module: items:

"" value search
"main.htm" value current-file

forth:: admin_itemcreate ( -- )
    "spawn" check-access
	"main.htm" show
;

forth:: admin_items_total ( -- )
    "spawn" check-access
	"" to search
	"total.htm" 
	dup to current-file
	show
;

forth:: admin_items_search ( -- )
    "spawn" check-access
	"search.htm" 
	dup to current-file
	show
;


forth:: admin_item_search ( -- )
	to search
	"search.htm" show
;

0 value count
"unknown" value item_name

forth:: admin_create_item  ( -- )
	2 args  ( item-id [count] )
	?dup unless 1 then
	dup to count
	swap 
	"SELECT name FROM prices WHERE item_id = [ dup ]" parse query ?dup unless
		0 list@ 'name' m@
	then
	to item_name
	
	items_add
	"created.htm" show
;

0 value page
false value item_grade
false value item_type

: (show_spawns_by_level)  ( str1 {list} -- str2 )
\ Добавляет к строке в стеке новую запись о предмете
	>r
	"<tr><td>[ r@ 'item_type' m@ ], [ r@ 'crystal_type' m@ ]</td>
	<td>[ r@ 'price' m@ ]</td>
	<td><a action=\"bypass -h forth admin: items: show_item [ r@ 'id' m@ ]\">[ r@ 'name' m@ ]</a></td>
	</tr>\n" parse
	s+
	rdrop
;

: where
	" WHERE 1 " s+

	item_grade if
		" AND crystal_type = '[ item_grade >slashes ]' " s+
	then

	item_type if
		" AND item_type = '[ item_type >slashes ]' " s+
	then

	search if
		" AND name like '%[ search >slashes ]%' " s+
	then
;

: make_items_list ( -- )
	"SELECT name, item_id as id, item_type, crystal_type, price
	FROM `prices` p"
	
	where

	"
	ORDER BY `name`
	LIMIT [ page 10 * ], 10" s+

	parse query	?dup if exit then

	"<table width=400><tr><td>Grade</td><td>Price</td><td>Name</td></tr>\n"
	swap & (show_spawns_by_level) do-list
	"</table>" s+
;

0 value item_id
null value item_data
0 value item_count
: show_item  ( -- )
	1 args int to item_id
	"SELECT * FROM prices WHERE item_id=[ item_id ]" parse query ?dup if show exit then
	0 list@ to item_data
	"SELECT COUNT(*) as `total` FROM items WHERE item_id=[ item_id ]" parse query ?dup if show exit then
	0 list@ 'total' m@ int to item_count
	"item.htm" show
;

1 value mult
: show_items_pages ( mult -- )
	to mult
	'Страницы:&nbsp;' 

	"SELECT COUNT(*) AS `count` FROM `prices` " where parse query ?dup if rexit then
	0 list@
	'count' m@ 
	int mult /
	1-  10 /  1+  0 max
	page mult / 5 + min
	0 page mult / 5 - max ?do
		'<a action="bypass -h forth admin: items: set_items_page [ i  mult * ]">' parse
		page i = if '<font color="LEVEL">' s+ then
		'[ i 1+ mult * ]' parse s+
		page i = if "</font>" s+ then
		'</a>&nbsp;' s+
		s+
	loop
;

: set_items_page  ( page -- )
	1 args int  
	0 max  
	to page 
	current-file show
;

: (add_items_type)  ( s1 %type -- s2 )
	'item_type' m@
	>r
	"<a action=\"bypass -h forth admin: items: '[ r@ ]' set_items_type\">" parse
	r@ item_type = if '<font color="LEVEL">' s+ then
	r@ ?dup unless 'all' then parse s+
	r@ item_type = if "</font>" s+ then
	rdrop
	'</a>&nbsp;' s+
	s+
;

: show_items_types ( -- )
	"SELECT DISTINCT item_type FROM `prices` ORDER BY item_type" parse query ?dup if rexit then
	new-hashmap '' over 'item_type' m! over list+
	'Типы:&nbsp;' swap & (add_items_type) do-list
;

: set_items_type  ( type -- )
	to item_type
	0 to page
	current-file show
;

: (add_items_grade)  ( s1 %grade -- s2 )
	'crystal_type' m@
	>r
	"<a action=\"bypass -h forth admin: items: '[ r@ ]' set_items_grade\">" parse
	r@ item_grade = if '<font color="LEVEL">' s+ then
	r@ ?dup unless 'all' then parse s+
	r@ item_grade = if "</font>" s+ then
	rdrop
	'</a>&nbsp;' s+
	s+
;

: show_items_grades ( -- )
	"SELECT DISTINCT crystal_type FROM `prices` ORDER BY crystal_type" parse query ?dup if rexit then
	new-hashmap '' over 'crystal_type' m! over list+
	'Типы:&nbsp;' swap & (add_items_grade) do-list
;

: set_items_grade  ( grade -- )
	to item_grade
	0 to page
	current-file show
;

;module
