"l2f.gameserver.model.MobGroup" class constant MG.class
"l2f.gameserver.model.MobGroup" constant MG
"l2f.gameserver.tables.MobGroupTable" class constant MGT.class
"l2f.gameserver.tables.NpcTable" class constant NpcTable.class
"l2f.gameserver.templates.L2NpcTemplate" class constant L2NpcTemplate.class

: instance ( object -- object.getInstance )
  "getInstance" 0 jget
;

0 uvalue mg_count
0 uvalue mg_tplid
0 uvalue mg_gid

: mg_create ( group_id tpl_id count -- )
  to mg_count to mg_tplid to mg_gid
  mg_tplid NpcTable.class instance "getTemplate" { int.class } jget \ get template
  mg_count MG { L2NpcTemplate.class int.class } jnew \ create mob group
  mg_gid swap MGT.class instance "addGroup" { int.class MG.class } jexec
  "Mobgroup was created" .
;

: mg_spawn ( group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . exit THEN
  player@ swap "spawnIt" { L2Player.class } jexec
  "Mobgroup was spawned" .
;

: mg_spawnat ( x y z group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . 2drop drop exit THEN
  "spawnIt" { int.class int.class int.class } jexec
  "Mobgroup was spawned" .
;

: mg_unspawn ( group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . exit THEN
  "unspawn" 0 jexec
  "Mobgroup was unspawned" .
;

: mg_kill ( group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . exit THEN
  player@ swap "kill" { L2Player.class } jexec
  "Mobgroup was killed" .
;

: mg_setcasting ( group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . exit THEN
  "setCastMode" 0 jexec
  "Mobgroup mode was set to casting" .
;

: mg_nomove ( flag group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . drop exit THEN
  "setNoMoveMode" { int.class } jexec
  "Mobgroup nomove mode was changed" .
;

: mg_follow ( target group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . drop exit THEN
  "follow" { L2Character.class } jexec
  "Mobgroup follow was changed" .
;

: mg_attack ( target group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . drop exit THEN
  "attackTarget" { L2Character.class } jexec
  "Mobgroup attack target was changed" .
;

: mg_attackgrp ( target_group_id group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . drop exit THEN
  swap MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong target group" . drop exit THEN
  swap "setAttackGroup" { MG.class } jexec
  "Mobgroup attack target group was changed" .
;

: mg_idle ( group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . exit THEN
  "idle" 0 jexec
  "Mobgroup mode was set to idle" .
;

: mg_return ( player group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . drop exit THEN
  "returnToCharacter" { L2Character.class } jexec
  "Mobgroup was returned" .
;

: mg_attackrnd ( group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . exit THEN
  "randomAttack" 0 jexec
  "Mobgroup attack target was changed to random" .
;

: mg_invul ( flag group_id -- )
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . drop exit THEN
  "setInvul" { boolean.class } jexec
  "Mobgroup invul mode was changed" .
;

: mg_setcheck ( seconds word player group_id -- ) \ remember that word is String!
  MGT.class instance "getGroup" { int.class } jget
  ?dup null? IF "Wrong group" . 2drop drop exit THEN
  "setCheck" { int.class String.class L2Player.class } jexec
  "Mobgroup check task started" .
;
