: admin_rename
  "rename" check-access
  ?dup "" = if
    "jbforth/admin/players/rename.htm" show
    exit
  then
  target-or-me@ player_rename
;

: smart-find  ( name/npc_id/empty -- object_id | null )
  depth 0= if target-or-me@ exit then
  ?dup "" = if target-or-me@ exit then

  dup find_player ?dup if nip exit then
  dup find-by-npc_id ?dup if nip exit then
  "Not found player or NPC [  ]" parse type
  null
;

: admin_to_char  ( name -- )
  "to-char" check-access
  smart-find ?dup null? if exit then
  "Teleport to [ dup ]" parse type
  coords@ 50 coords-randomize jump
;

: admin_character_list  ( name -- )
  "players-data-view" check-access
  smart-find ?dup null? if exit then
  to object
    object player@ c.target!
  "jbforth/admin/players/character_list.htm" show
;

: p.no-channel@  ( player -- )
  "NoChannel" p@
  dup int 0 < if drop -1 exit then
  dup 0 > if 
    60 / 
  else
    drop 0
  then
;

: admin_teleport_char ( name -- )
    "jbforth/admin/players/character_teleport.htm" show
;

module: players:

forth:: admin_player_change
	"default" check-access
	"change.htm" show
;

: p.reset  (( player -- ))
	0 player p.setHairColor
	0 player p.setHairStyle
	0 player p.setFace
;

forth:: p.class-id/sex! (( class-id sex player -- ))
	class-id   		player p.setBaseClass
	class-id >Short	player p.setActiveClass
	class-id   sex
	class-id/sex>template \ "classId" field@
	player c.setTemplate
	player "ClassId" p@
	sex boolean
	player p.setBaseTemplate
	class-id player p.setBaseClass
	player p.reset
	player p.broadcastUserInfo
	player coords@ jump
;

forth:: p.class-id!  ( class-id player -- )
	dup p.sex swap
	p.class-id/sex!
;

forth:: p.sex!  ( sex player -- )
	dup p.class-id -rot
	p.class-id/sex!
;

forth:: int>sex  ( sex -- "sex" )
	int
	if
		ru: женский
		en: female
	else
		ru: мужской
		en: male
	then
;

: class_list-by-race (( race sex -- {list} ))
	new-list
	118 0 do
		i sex class-id/sex>template
		?dup if
			dup "classId" field@ "Race" p@ "ordinal" 0 jget
			race = if
				over list+
			else
				drop
			then
		then
	loop
;

: (class-list-add)  ( str1 class -- str2 )
	"classId" field@ >r
	" &nbsp;<a action=\"bypass -h forth [ r@ 'Id' p@ ] target-player-or-me p.class-id! 'jbforth/admin/players/change.htm' show\">[ r> ]</a>" parse
	s+
;

forth:: p.race  ( player -- int )  "Race" p@ "ordinal" 0 jget ;

: make-classes-links  ( -- html )
	target-player-or-me dup p.race
	swap p.sex
	class_list-by-race
	"" swap & (class-list-add) do-list
;

forth:: admin_set_level  ( -- )
	"default" check-access
	target-player-or-me	>r
	0 r@ "setExp" { long.class } jexec
	int 1 max 127 min
	dup 1- r@ "setLevel" { int.class } jexec
	experience-levels swap >string m@ >Long
	1 >Long r> "addExpAndSp" { long.class long.class } jexec
	'jbforth/admin/players/change.htm' show
;

ban.f
banchat.f
kick.f
buffs.f

;module
