module: spawn:

\ Однократный спавн npc по "//spawn1 npc_id"

: spawn-around  ( npc-id randomize? -- npc-id randomize? )
	swap >r >r
	player@ coords@ 
	r@ ?dup if coords-randomize then
	player@ "Heading" p@
	r> r@ swap >r 0 0 spawn drop
	r> r> swap
;

0 value spawn_level

forth:: admin_spawns ( [level] -- )
    "spawn" check-access
	1 args ?dup unless
		"main.htm" show
		exit
	then
	
	int to spawn_level
	"level.htm" show
;

null value spawn_counts
0	 value max_level

forth:: max_mobs_level ( -- level )
	max_level if max_level exit then
	"SELECT MAX(`level`) as `level` FROM `npc`" query
	?dup if . exit then
	0 list@ "level" m@ int
	1 max
	dup to max_level
;

: (add_to_spawn_counts)  (( rec -- ))
	rec "count" m@
	spawn_counts
	rec "level" m@
	m!
;

forth:: mobs_count_by_level  (( level -- count ))
	spawn_counts null? if
		"SELECT level, COUNT(*) AS `count` 
			FROM `npc` 
			WHERE  `type` IN ('L2Monster', 'L2Boss', 'L2RaidBoss')
			GROUP BY `level`" parse query
		?dup if exit then
		new-map to spawn_counts
		& (add_to_spawn_counts) do-list
	then

	spawn_counts level m@ int
;

: show_levels ( -- string )
	true \ new line flag
	"<table width=290>"
	max_mobs_level 1+ 1 ?do
		over if "<tr>" s+ nip false swap then
		'<td><a action="bypass -h admin_spawns [ i ]">[ i ] ([ i mobs_count_by_level ])</a></td>' parse s+
		i 6 mod unless "</tr>\n" s+ nip true swap then
	loop
	swap unless "</tr>\n" s+ then
	"</table>\n" s+
;

: aggro-star  ( aggro -- '*' )  if '*' else '' then ;

: (show_spawns_by_level)  ( str1 {list} -- str2 )
\ Добавляет к строке в стеке новую запись о мобе
	>r
	"<tr><td>[ r@ 'hp' m@ ]</td>
	<td>[ r@ 'count' m@ ]</td>
	<td>[ r@ 'aggro' m@ int aggro-star ] <a action=\"bypass -h forth admin: spawn: show_spawn [ r@ 'id' m@ ]\">[ r@ 'name' m@ ]</a></td>
	</tr>\n" parse
	s+
	rdrop
;

0 value page

: show_spawns_by_level ( -- string )
	"SELECT name, n.id as id, type, hp, aggro, SUM(`count`) as `count`
	FROM `npc` n 
		LEFT JOIN spawnlist s ON n.id = s.npc_templateid
	WHERE `type` IN ('L2Monster', 'L2Boss', 'L2RaidBoss') AND `level` = [ spawn_level ] AND name != ''
	GROUP BY n.id
	ORDER BY `name`
	LIMIT [ page 10 * ], 10" parse query
	?dup if exit then
	"<table width=400><tr><td>HP</td><td>Spawns</td><td>Name</td></tr>\n"
	swap & (show_spawns_by_level) do-list
	"</table>" s+
;

0 value npc_id
null value npc_data
: show_spawn  ( -- )
	1 args int to npc_id
	"SELECT * FROM npc WHERE id=[ npc_id ]" parse query ?dup if show exit then
	0 list@ to npc_data
	"npc_spawn.htm" show
;

forth:: admin_spawn1  ( -- )
    "spawn" check-access
	2 args
	int swap int dup >r swap
	?dup if
		dup 10 * swap 1 max 500 min 0 ?do
			spawn-around
		loop
	else
		false spawn-around
	then
	2drop
	r> npc_id = if
		admin_spawns
	then
;

: show_spbl_pages ( -- )
	spawn_level mobs_count_by_level 10 <= if
		'' exit
	then
	
	'Страницы:&nbsp;' 
	spawn_level mobs_count_by_level 1- 10 / 1+ 0 max 0 ?do
		'<a action="bypass -h forth admin: spawn: set_spbl_page [ i ]">[ i 1+ ]</a>&nbsp;' parse s+
	loop
;

: set_spbl_page  ( page -- )
	1 args int  
	0 max  
	to page 
	"level.htm" show
;

;module
