module: bodyguard   

100  uvalue follow-distance	\ Дистанция следования.
null uvalue master			\ Кого охраняем
null uvalue attack? 		\ Объект атакуемого тут.
null uvalue bg-char			\ Наш охранник
null uvalue def-master


\ Также нужны два этих словаря.
evt also
intention also

: start-attack  (( _enemy -- ))
	"'[ self ] start attack' parse ." master do-player
	_enemy self c.target!
	_enemy true boolean EVT_ATTACKED notify! 
;

: exit-if-eq  ( obj1 obj2 -- ) obj= if rdrop exit then ;

: master-attacked  (( _enemy -- ))
	_enemy '[ ai bodyguard master ], master of [ self ] attacked by [  ]' parse .out

	_enemy 	self	exit-if-eq
	_enemy 	master 	exit-if-eq


\	attack? unless
		_enemy to attack?
		_enemy start-attack
		exit
\	then

\	_enemy self attack? obj= if \ already attacked this
\		drop
\		exit
\	then
\	drop \ TODO: условная смена атакующего
;

: check-master-attacked  (( _dummy _enemy _evt _guard -- ))
	"_enemy = [ local: _enemy ], _evt = [ local: _evt ], _guard = [ local: _guard ]" parse .out
	\ _evt == EVT_ATTACKED|AI_INTENTION_ATTACK
	\ _guard == guard_id

	_guard id>obj to _guard

	_guard 'exec in [  ] context' parse .out

	_enemy ['] master-attacked _guard arg-exec-for
	null
;

: stop-attack  ( -- )
	null self c.target!
	false to attack?
	null null AI_INTENTION_ACTIVE intention!
;

: follow-to-master  (( _pos -- ))
	master distance-to follow-distance > if
		_pos follow-distance position-randomize
		null AI_INTENTION_MOVE_TO intention!
	then
;

: check-follow  (( _new-pos -- ))
	set-running
	attack? if
		self "Target" p@ distance-to
		600 < if exit then
		stop-attack
	then

	_new-pos follow-to-master
	null
;

: master-check-follow  (( _dummy _new-pos _evt _guard -- ))
	\ evt == AI_INTENTION_MOVE_TO
	\ guard == guard_id
	_guard id>obj to _guard
	_evt "'Check follow [  ]' parse ." master p-do-player
	_guard "'Check follow guard = [  ]' parse ." master p-do-player
	'ai bodyguard caller to master' _guard exec-for
	_new-pos ['] check-follow _guard arg-exec-for
	null
;

: master-check-stop-attack  ( _dummy _new-pos _MESSAGE _guard -- )
	attack? unless null exit then
	stop-attack
	"Stop attack: self=[ self ], _enemy = [ local: _enemy ], _evt = [ local: _evt ]" parse .out
	_guard unless null exit then
	_guard id>obj to _guard
	"_guard = [ local: _guard ]" parse .out
	['] stop-attack _guard exec-for
	null
;


forth:: admin_def_master  ( -- )  
	"admin" check-access
	target-or-me@ to def-master
	"Setted default master [ ai bodyguard def-master ]" parse .
;

: make-handler  ( char "handler" -- 'handler )
    swap
	"also ai bodyguard :noname   [ 'ObjectId' p@ ] [  ] ; previous" parse eval
;

: show-message  ( dummy new-pos MESSAGE guard-oid -- )
	drop
	announce
	2drop
;

: i.master!  ( INTENTION "code" -- )
	bg-char swap   make-handler def-master intention.handler!
;

: i.bodyguard!  ( INTENTION "code" -- )
	bg-char swap   make-handler bg-char intention.handler!
;

: e.master!  ( EVT "code" -- )
	bg-char swap   make-handler def-master evt.handler!
;

: e.bodyguard!  ( EVT "code" -- )
	bg-char swap   make-handler bg-char evt.handler!
;

forth:: admin_tt  ( -- )
	"admin" check-access
	
	\ Наша цель - охранник
	self target@ dup null? if
		drop exit
	then
	
	to bg-char
	
	\ Мы - мастер
	self to def-master
	self "ai bodyguard to master" bg-char arg-exec-for
	
	\ ------------------------------------
	\ Наши режимы: командуют охранником. 
	
	\ Если куда-то бежим - то и он бежит в ту же точку.
	AI_INTENTION_MOVE_TO "master-check-follow" 		i.master!

	\ Если мы кого-то атакуем - то и он атакует того же.
	AI_INTENTION_ATTACK	 "check-master-attacked"	i.master!

	\ -------------------------------
	\ События, получаемые охранником:

	\ Если цель потеряна - прекратить атаку.
	EVT_FORGET_OBJECT    "master-check-stop-attack" e.bodyguard!

	\ Если охранника кто-то атакует - начать контратаку.
	EVT_ATTACKED  		 "check-master-attacked"	e.master!

	AI_INTENTION_ACTIVE	"master-check-stop-attack" i.bodyguard!

\	EVT_AGGRESSION	"master-check-stop-attack" e.bodyguard!
\	EVT_STUNNED	"master-check-stop-attack" e.bodyguard!
\	EVT_SLEEPING	"master-check-stop-attack" e.bodyguard!
\	EVT_ROOTED	"master-check-stop-attack" e.bodyguard!
\	EVT_USER_CMD	"master-check-stop-attack" e.bodyguard!
\	EVT_ARRIVED_REVALIDATE	"master-check-stop-attack" e.bodyguard!
\	EVT_ARRIVED_BLOCKED	"master-check-stop-attack" e.bodyguard!
\	EVT_FORGET_OBJECT	"master-check-stop-attack" e.bodyguard!
\	EVT_CANCEL	"master-check-stop-attack" e.bodyguard!
\	EVT_DEAD	"master-check-stop-attack" e.bodyguard!
\	EVT_FAKE_DEATH	"master-check-stop-attack" e.bodyguard!
\	EVT_CONFUSED	"master-check-stop-attack" e.bodyguard!
\	EVT_MUTED	"master-check-stop-attack" e.bodyguard!
\	EVT_AFFRAID	"master-check-stop-attack" e.bodyguard!
\	EVT_FINISH_CASTING	"master-check-stop-attack" e.bodyguard!

	"Setted " bg-char s+ " as bodyguard for " s+
	def-master s+ .
;

forth:: admin_st  ( -- )
	"ai bodyguard attack? .to-caller" bg-char exec-for
;

previous previous \ drop evt and intention

;module
