\ ai/main.f

\ "java.util.concurrent.ConcurrentHashMap"<java.lang.Integer,ArrayList<Word>>
\ "java.util.ArrayList<java.lang.Integer>" 0 jnew .

\ player@ "AI" p@ "eventsHandlersMap" field@ .

: attacked  ( dummy attacker evtAttecked -- )
	drop
	"[ self ]: attacked by [  ]!" parse announce
	drop
	null
;

: event  ( dummy dummy evtThink -- )
	"[ self ] got event [  ]([  ], [  ])" parse announce
	null
;

: set-intention  ( dummy dummy intention -- )
	"[ self ] set intention [  ]([  ], [  ])" parse announce
	null
;

"l2f.gameserver.ai.CtrlEvent" class constant  CtrlEvent.class
"l2f.gameserver.ai.CtrlIntention" class constant  CtrlIntention.class

: handler+!  ( evt 'handler character -- )
	"AI" p@ >r
	over r@ "resetEventHandlers" 1 jexec
	r@ "addEventHandler"  { CtrlEvent.class Word.class } jexec
	rdrop
;

: int.handler+!  ( intention 'handler character -- )
	"AI" p@ >r
	over r@ "resetIntentionHandlers" 1 jexec
	r@ "addIntentionHandler"  { CtrlIntention.class Word.class } jexec
	rdrop
;

: def-evt:        ( -- \ name )  CtrlEvent.class     NextWord tuck field@ "constant " over s+ eval ;
: def-intention:  ( -- \ name )  CtrlIntention.class NextWord tuck field@ "constant " over s+ eval ;

def-evt: EVT_ATTACKED
def-evt: EVT_THINK
def-evt: EVT_AGGRESSION
def-evt: EVT_STUNNED
def-evt: EVT_SLEEPING
def-evt: EVT_ROOTED
def-evt: EVT_READY_TO_ACT
def-evt: EVT_USER_CMD
def-evt: EVT_ARRIVED
def-evt: EVT_ARRIVED_REVALIDATE
def-evt: EVT_ARRIVED_BLOCKED
def-evt: EVT_FORGET_OBJECT
def-evt: EVT_CANCEL
def-evt: EVT_DEAD
def-evt: EVT_FAKE_DEATH
def-evt: EVT_CONFUSED
def-evt: EVT_MUTED
def-evt: EVT_AFFRAID
def-evt: EVT_FINISH_CASTING

def-intention: AI_INTENTION_IDLE
def-intention: AI_INTENTION_ACTIVE
def-intention: AI_INTENTION_REST
def-intention: AI_INTENTION_ATTACK
def-intention: AI_INTENTION_CAST
def-intention: AI_INTENTION_MOVE_TO
def-intention: AI_INTENTION_FOLLOW
def-intention: AI_INTENTION_PICK_UP
def-intention: AI_INTENTION_INTERACT

EVT_ATTACKED			['] attacked player@ handler+!
EVT_THINK				['] event    player@ handler+!
EVT_AGGRESSION          ['] event    player@ handler+!
EVT_STUNNED             ['] event    player@ handler+!
EVT_SLEEPING            ['] event    player@ handler+!
EVT_ROOTED              ['] event    player@ handler+!
EVT_READY_TO_ACT        ['] event    player@ handler+!
EVT_USER_CMD            ['] event    player@ handler+!
EVT_ARRIVED             ['] event    player@ handler+!
EVT_ARRIVED_REVALIDATE  ['] event    player@ handler+!
EVT_ARRIVED_BLOCKED     ['] event    player@ handler+!
EVT_FORGET_OBJECT       ['] event    player@ handler+!
EVT_CANCEL              ['] event    player@ handler+!
EVT_DEAD                ['] event    player@ handler+!
EVT_FAKE_DEATH          ['] event    player@ handler+!
EVT_CONFUSED            ['] event    player@ handler+!
EVT_MUTED               ['] event    player@ handler+!
EVT_AFFRAID             ['] event    player@ handler+!
EVT_FINISH_CASTING      ['] event    player@ handler+!

AI_INTENTION_IDLE     ['] set-intention player@ int.handler+!
AI_INTENTION_ACTIVE   ['] set-intention player@ int.handler+!
AI_INTENTION_REST     ['] set-intention player@ int.handler+!
AI_INTENTION_ATTACK   ['] set-intention player@ int.handler+!
AI_INTENTION_CAST     ['] set-intention player@ int.handler+!
AI_INTENTION_MOVE_TO  ['] set-intention player@ int.handler+!
AI_INTENTION_FOLLOW   ['] set-intention player@ int.handler+!
AI_INTENTION_PICK_UP  ['] set-intention player@ int.handler+!
AI_INTENTION_INTERACT ['] set-intention player@ int.handler+!
