50 ndrop
\ ai/main.f

\ "java.util.concurrent.ConcurrentHashMap"<java.lang.Integer,ArrayList<Word>>
\ "java.util.ArrayList<java.lang.Integer>" 0 jnew .

\ player@ "AI" p@ "eventsHandlersMap" field@ .

: attacked  ( dummy attacker evtAttecked -- )
	drop
	"[ self ]: attacked by [  ]!" parse announce
	drop
	null
;

: event  ( dummy dummy evtThink -- )
	"[ self ] got event [  ]([  ], [  ])" parse announce
	null
;

: set-intention  ( dummy dummy intention -- )
	"[ self ] set intention [  ]([  ], [  ])" parse announce
	null
;

"l2f.gameserver.ai.CtrlEvent" class constant  CtrlEvent.class
"l2f.gameserver.ai.CtrlIntention" class constant  CtrlIntention.class

: handler+!  ( evt 'handler character -- )
	"AI" p@ >r
	over r@ "resetEventHandlers" 1 jexec
	r@ "addEventHandler"  { CtrlEvent.class Word.class } jexec
	rdrop
;

: int.handler+!  ( intention 'handler character -- )
	"AI" p@ >r
	over r@ "resetIntentionHandlers" 1 jexec
	r@ "addIntentionHandler"  { CtrlIntention.class Word.class } jexec
	rdrop
;

: def-evt:        ( -- \ name )  CtrlEvent.class     NextWord tuck field@ "constant " rot s+ eval ;
: def-intention:  ( -- \ name )  CtrlIntention.class NextWord tuck field@ "constant " rot s+ eval ;

def-evt: EVT_ATTACKED
def-evt: EVT_THINK
def-evt: EVT_AGGRESSION
def-evt: EVT_STUNNED
def-evt: EVT_SLEEPING
def-evt: EVT_ROOTED
def-evt: EVT_READY_TO_ACT
def-evt: EVT_USER_CMD
def-evt: EVT_ARRIVED
def-evt: EVT_ARRIVED_REVALIDATE
def-evt: EVT_ARRIVED_BLOCKED
def-evt: EVT_FORGET_OBJECT
def-evt: EVT_CANCEL
def-evt: EVT_DEAD
def-evt: EVT_FAKE_DEATH
def-evt: EVT_CONFUSED
def-evt: EVT_MUTED
def-evt: EVT_AFFRAID
def-evt: EVT_FINISH_CASTING

def-intention: AI_INTENTION_IDLE
def-intention: AI_INTENTION_ACTIVE
def-intention: AI_INTENTION_REST
def-intention: AI_INTENTION_ATTACK
def-intention: AI_INTENTION_CAST
def-intention: AI_INTENTION_MOVE_TO
def-intention: AI_INTENTION_FOLLOW
def-intention: AI_INTENTION_PICK_UP
def-intention: AI_INTENTION_INTERACT

player@ target@ value x

EVT_ATTACKED			['] attacked x handler+!
EVT_THINK				['] event    x handler+!
EVT_AGGRESSION          ['] event    x handler+!
EVT_STUNNED             ['] event    x handler+!
EVT_SLEEPING            ['] event    x handler+!
EVT_ROOTED              ['] event    x handler+!
\ EVT_READY_TO_ACT        ['] event    x handler+!
EVT_USER_CMD            ['] event    x handler+!
EVT_ARRIVED             ['] event    x handler+!
EVT_ARRIVED_REVALIDATE  ['] event    x handler+!
EVT_ARRIVED_BLOCKED     ['] event    x handler+!
EVT_FORGET_OBJECT       ['] event    x handler+!
EVT_CANCEL              ['] event    x handler+!
EVT_DEAD                ['] event    x handler+!
EVT_FAKE_DEATH          ['] event    x handler+!
EVT_CONFUSED            ['] event    x handler+!
EVT_MUTED               ['] event    x handler+!
EVT_AFFRAID             ['] event    x handler+!
EVT_FINISH_CASTING      ['] event    x handler+!

AI_INTENTION_IDLE     ['] set-intention x int.handler+!
AI_INTENTION_ACTIVE   ['] set-intention x int.handler+!
AI_INTENTION_REST     ['] set-intention x int.handler+!
AI_INTENTION_ATTACK   ['] set-intention x int.handler+!
AI_INTENTION_CAST     ['] set-intention x int.handler+!
AI_INTENTION_MOVE_TO  ['] set-intention x int.handler+!
AI_INTENTION_FOLLOW   ['] set-intention x int.handler+!
AI_INTENTION_PICK_UP  ['] set-intention x int.handler+!
AI_INTENTION_INTERACT ['] set-intention x int.handler+!

: distance-to  ( char -- distance ) self "getDistance" { L2Object.class } jget int ;

null  uvalue master
false uvalue attack?

: c.intention!  ( arg0 arg1 intention char -- )  >r -rot r> "setIntention" { CtrlIntention.class Object.class dup } jexec ;
: intention!  ( arg0 arg1 intention -- )  self c.intention! ;

: c.notify!  ( arg0 arg1 event char -- )  >r -rot r> "notifyEvent" { CtrlEvent.class Object.class dup } jexec ;
: notify!  ( arg0 arg1 event -- )  self c.notify! ;

: obj=  ( obj1 obj2 -- obj1.objectId==obj2.objectId ) "ObjectId" p@ swap "ObjectId" p@ = ;

: start-attack  ( damage enemy -- )
	null EVT_ATTACKED notify! 
\	100 EVT_AGGRESSION notify! 
;

: master-attacked  ( enemy -- )
	dup self   obj= if drop exit then
	dup master obj= if drop exit then

\	attack? unless
        "Attack to " over s+ announce
		true to attack?
		start-attack
		exit
\	then

	dup self "ObjectId" p@ target@ "ObjectId" p@ = if \ already attacked this
		drop 
		exit
	then

	drop \ TODO: условная смена атакующего
;

: check-master-attacked  ( dummy enemy EVT_ATTACKED master -- )
	nip world@ "findObject" { Integer.class } jget 
	['] master-attacked swap arg-exec-for
	drop
	null
;

: xyzh>position  ( x y z heading -- L2CharPosition )
	"l2f.gameserver.model.L2CharPosition" { int.class dup 2dup } jnew
;

: char>position  ( char -- L2CharPosition )
	>r
	r@ "X" p@
	r@ "Y" p@
	r@ "Z" p@
	r> "Heading" p@

	xyzh>position
;

: position>xyzh  ( L2CharPosition -- x y z h )
	>r 
	r@ "x" field@
	r@ "y" field@
	r@ "z" field@
	r> "heading" field@
;

: position-randomize  ( pos1 random-radius -- pos2 )
	>r
	position>xyzh
	r> swap >r
	coords-randomize
	r>
	xyzh>position
;

: stop-attack  ( -- )
	null null AI_INTENTION_ACTIVE intention!
	false to attack?
;

: follow-to-master  ( pos -- )
	master distance-to 200 > if
		200 position-randomize
		null 
		AI_INTENTION_MOVE_TO 
		intention!
	else
		drop
	then
;

: check-follow  ( new-pos -- )
	attack? if
		self "Target" p@
		distance-to
		600 < if exit then
		stop-attack
	then

	follow-to-master
	null
;

: master-check-follow  ( dummy new-pos AI_INTENTION_MOVE_TO self-oid -- )
	nip world@ "findObject" { Integer.class } jget 
	['] check-follow swap arg-exec-for
	drop
	null
;

\ "caller to master follow-to-master" player@ target@  exec-for

AI_INTENTION_MOVE_TO  ":noname [ player@ target@ 'ObjectId' p@ ] master-check-follow ; 'caller to master' player@ target@ exec-for" parse eval player@ int.handler+!

EVT_ATTACKED  ":noname [ player@ target@ 'ObjectId' p@ ] check-master-attacked ; 'caller to master' player@ target@ exec-for" parse eval player@ handler+!

player@ target@ value def

: atk    player@ target@ "start-attack" def arg-exec-for ;
