\ Jail system by Balancer, (c) 2005-2007

module: jail:

\ ======================================
\ You may change it properties
{ -114500 -249000 -3000 } value jail-coords
~BlueGemstone	constant jail-item
\ ======================================

false 	suvalue jailed?
0 		suvalue jail-to-collect
0 		suvalue jail-total-collected
0		suvalue	jail-coords-back

{
	{ 20653 -113865 -250100 -3000 0 120 false } \ Lesser Giant
	{ 20653 -115245 -250100 -3000 0 120 false } \ Lesser Giant
	{ 20653 -115245 -248670 -3000 0 100 false } \ Lesser Giant
	{ 20653 -113865 -248670 -3000 0 90 false } \ Lesser Giant
	{ 20653 -114555 -248660 -3000 0 60 false } \ Lesser Giant
	{ 20255 -115228 -249300 -3000 0 90 false } \ Batur Orc
	{ 20255 -113835 -249270 -3000 0 80 false } \ Batur Orc
	{ 20255 -114207 -249067 -3000 0 60 false } \ Batur Orc
	{ 20255 -114714 -244060 -3000 0 30 false } \ Batur Orc
	{ 20172 -114852 -249689 -3000 0 60 false } \ Sylph
	{ 20172 -114353 -249703 -3000 0 60 false } \ Sylph
	{ 20172 -114337 -249461 -3000 0 65 false } \ Sylph
	{ 20172 -114467 -249073 -3000 0 40 false } \ Sylph
	{ 20172 -114709 -249307 -3000 0 30 false } \ Sylph
	
} value jail-mobs

null	value	jail-mobs-spawn

forth:: items:remove-all ( item-id -- )
	dup items# ?dup if
		swap items_remove
	else
		drop
	then
;

: jail-me ( items_count -- )
	int to jail-to-collect
	
	self player? unless
		jail-to-collect "jail-me"  self getPlayer p-do-player 
		exit
	then
	
	jail-to-collect jail-total-collected + to jail-total-collected
	
	true 	to jailed?
	false	to can-teleport?

	jail-coords-back unless
		loc@ coords>s to jail-coords-back
	then
	
	10000 karma+!
	-1 self "updateNoChannel" { int.class } jexec

	"You are jailed! To free you must collect [ jail-to-collect ] item(s) from killed mobs" parse 
	"Jail system" self .tell

	"help.htm" show

	jail-coords list-rev> drop jump
	suv-save-all
;

: jail-offline  ( "char_name" items -- )
	int swap >r

	"SELECT obj_Id AS object_id FROM characters WHERE char_name = '[ r@ >slashes ]'" parse
	query ?dup if .out "Error. See details in stdout." type rdrop exit then

	dup list# ?dup 0= if "Not found player " r> s+ . exit then
	1 > if "More then 1 character with name " r> s+ . exit then
	
	list-shift drop
	'object_id' m@ int >r
	"REPLACE character_quests SET char_id=[ r@ ], name='user-var', var='jail-to-collect', value=[ dup ]" parse 
	update ?dup if . else drop then
	"REPLACE character_quests SET char_id=[ r@ ], name='user-var', var='jailed?', value=-1" parse 
	update ?dup if . else drop then
	rdrop

	"Character [ r> ] was offline jailed by [ '' name@ s+ ] for [  ] items" parse dup . "jail" >log
;

: jail-stop ( -- )
	0 		to jail-to-collect
	false 	to jailed?
	true	to can-teleport?
	
	jail-item dup items# ?dup if 
		swap items_remove 
	else
		drop 
	then

	-10000 karma+!

	0 self "updateNoChannel" { int.class } jexec
	
	"You are freed!" "Jail system" self .tell

	1000 sleep

	suv-save-all

	\ Восстанавливаем запомненные координаты возврата.
	jail-coords-back s>coords 
	\ Если что-то сломалось - то тупо в Глудио
	unless 
		drop
		-14225 123540 3121
	then
	jump

	false to jail-coords-back
;

\ Вызывается в контексте убийцы (игрока)
: on-kill-jail-check ( -- )

	\ Если мы не посажены, то убийство это убийство игнорируем.
	jailed? unless exit then
	
	\ Вероятность выпадения предмета
	\ равна отношению уровней нашей жерты и нас
	my-level  target get-level  /

	\ Отношение не меньше единицы
	1 max 
	
	\ Если Rnd(my-level/target-level) > 0 - то ничего не выпало.
	choose 0 > if exit then

	jail-to-collect 1- to jail-to-collect

	1 jail-item items_add

	"Need to collect [ jail-to-collect ] more items" parse 
	"Jail system" self .tell

	"Itemsound.quest_itemget" so

	suv-save-all	

	jail-to-collect 0 > if exit then

	"Player [ name@ ] collect all jail items and freed"	parse
	"jail" >log

	jail-stop
;

: dist-to-jail  ( -- distance )  jail-coords list-rev> 2drop self distance ;

forth:: enter-jail-check
	jailed? int 0= if exit then
	jail-to-collect 0= if exit then
	jail-coords-back s>coords if 
		"help.htm" show
		jail-coords list-rev> drop jump
		exit 
	then
	3 ndrop
	jail-to-collect jail-me
;

{ 20653 20172 20255 } [[ & on-kill-jail-check swap add-killer-handler ]] do-list

on-server-start:: jail-mobs npc-list-spawn drop ;
   
forth:: admin_jail  ( items -- )
	"jail" check-access

	self target@ null? if "No target selected" . exit then

	int ?dup 0= if 100 then

	"Player [ self target@ p.name@ ] jailed by [ name@ ] for [ dup ] items" parse
	"jail" >log

	& jail-me self target@ p-do-player 
;

forth:: admin_jail:  ( "name [items]" -- )
	"jail" check-access

	2 args

	?dup unless 100 then

	int	>r

	dup find_player ?dup if
		"Player [ swap ] jailed by [ dup name@ ] for [ r@ ] items" parse dup . 
		"jail" >log
		r> & jail-me rot p-do-player
		drop
	else
		r> jail-offline
	then
;

"jail: name [num]  - jail player <name> (incl. offline) for <num> (100 default) items" telnet-help+

forth:: admin_unjail
	drop 

	"jail" check-access

	self target@ null? if "No target selected" . exit then

	"Player [ self target@ p.name@ ] unjailed by [ name@ ]" parse dup .
	"jail" >log
	
	& jail-stop self target@ do-player 
;

;module
