module: pirates:

false	value events-balancer-pirates-run

forth:: gm?  ( -- flag )  access-level 100 >= ;
forth:: c.target  ( char -- target ) target@ ;
forth:: s.target  ( -- my-target )  self c.target ;
( object>id | object -- objet_id ) L2Object.class "getObjectId" { } japi-func: object>id  

: ann
	parse
	gm? if "System" player@ .tell else announce then
;

: run?  ( -- flag ) 
	gm? if true exit then
	events-balancer-pirates-run 
;

: check-run  ( -- ) run? unless rdrop exit then ;

: step  ( -- step )  "events-balancer-pirates-npc-[ s.target npc.id@ ]-step" parse eval ;
: step!  ( step -- )  "to events-balancer-pirates-npc-[ s.target npc.id@ ]-step" parse eval ;

: n.step  ( npc -- step )  "events-balancer-pirates-npc-[  ]-step" parse eval ;
: n.step!  ( step npc -- )  "to events-balancer-pirates-npc-[  ]-step" parse eval ;

: show-link  ( -- string )
	run? unless "" exit then
	'<a action="bypass -h forth events: balancer: pirates: talk">"Сокровища пиратов"</a><br1>'
	parse
; 

: npc-init  ( npc -- )
	dup ['] show-link swap npc-dialog+
	"1 suvalue events-balancer-pirates-npc-[  ]-step" parse eval
;

{ 30737 30924 30879 30387 30047 31351 30110 31057 31454 31452 31056 } ['] npc-init do-list

: check-letter  ( -- )  3866 items# unless rdrop "nothing.htm" show exit then ;
: check-map     ( -- )  2805 items# unless rdrop "nothing.htm" show exit then ;
: check-amuleth ( -- )  6653 items# unless rdrop "nothing.htm" show exit then ;
: check-key 	( -- )  5204 items# unless rdrop "nothing.htm" show exit then ;

: (test-answer)  ( flag1 ответ отгадка -- flag2 ответ )
	over = unless exit then
	nip true swap
;

: answer-true?  ( { отгадки } -- \ ответ )
	false next-word rot ['] (test-answer) do-list
	drop
;

0 uvalue last-found-step
: talk  ( -- )
	check-run
	"talk-[ s.target npc.id@ dup ]-[ n.step ]" parse
	dup sfind if eval exit then
	"nothing.htm" show
;

: talk-30737-1  ( -- ) "1-30737-morgan/1.htm" show ;
: do-30737-1  ( -- ) 
	check-run
	{ { 10000 57 } } { { 1 3866 } } items-exchanged?
	unless "У вас нет достаточного количества денег!" show exit then
	2 step!
	"1-30737-morgan/2.htm" show
;

: talk-30737-2  ( -- )
	check-letter
	{
		{ 1 3866 }
		{ 1 2801 }
		{ 1 2801 }
		{ 1 5864 }
		{ 1 5915 }
		{ 1 7165 }
	} { { 1 2805 } } items-exchanged?
	unless "1-30737-morgan/3.htm" show exit then
	5 step!
	"Игрок [ name@ ] собрал пять кусков карты!" ann
	"1-30737-morgan/4.htm" show
;

: talk-30737-5  ( -- )  "1-30737-morgan/5.htm" show ;

\ -------------------------------------------------

: talk-30924-1  ( -- )
	check-letter
	"2-30924-nedy/1.htm" show 
;

: do-30924-1  ( { отгадки } -- \ ответ ) 
	check-run
	check-letter
	answer-true? unless 
		"2-30924-nedy/2.htm" show  
		random-jump  
		exit 
	then
	"Игрок [ name@ ] отгадал загадку управляющего пристанью Нэди" ann
	4 step!
	1 2801 items_add
	"2-30924-nedy/3.htm" show
;

\ -------------------------------------------------

: talk-30879-1  ( -- )
	check-letter
	"3-30879-felton/1.htm" show 
;

: do-30879-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-letter
	answer-true? unless 
		"3-30879-felton/2.htm" show  
		random-jump  
		exit 
	then
	"Игрок [ name@ ] отгадал загадку управляющего пристанью Фелтона" ann
	4 step!
	1 2802 items_add
	"3-30879-felton/3.htm" show
;

: talk-30879-4  ( -- )  check-letter  "3-30879-felton/4.htm" show ;

\ -------------------------------------------------

: talk-30387-1  ( -- )
	check-letter
	"4-30387-clancy/1.htm" show 
;

: do-30387-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-letter
	answer-true? unless 
		"4-30387-clancy/2.htm" show  
		random-jump  
		exit 
	then
	"Игрок [ name@ ] отгадал загадку управляющего пристанью Клэнси" ann
	4 step!
	1 5864 items_add
	"4-30387-clancy/3.htm" show
;

: talk-30387-4  ( -- )  check-letter  "4-30387-clancy/4.htm" show ;

\ -------------------------------------------------

: talk-30047-1  ( -- )
	check-letter
	"5-30047-firon/1.htm" show 
;

: do-30047-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-letter
	answer-true? unless 
		"5-30047-firon/2.htm" show  
		random-jump  
		exit 
	then
	"Игрок [ name@ ] отгадал загадку управляющего пристанью Фирона" ann
	4 step!
	1 5915 items_add
	"5-30047-firon/3.htm" show
;

: talk-30047-4  ( -- )  check-letter  "5-30047-firon/4.htm" show ;

\ -------------------------------------------------

: talk-31351-1  ( -- )
	check-letter
	"6-31351-volker/1.htm" show 
;

: do-31351-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-letter
	answer-true? unless 
		"6-31351-volker/2.htm" show  
		random-jump  
		exit 
	then
	"Игрок [ name@ ] отгадал загадку управляющего пристанью Волкера" ann
	1 7165 items_add
	4 step!
	"6-31351-volker/3.htm" show
;

: talk-31351-4  ( -- )  check-letter  "6-31351-volker/4.htm" show ;

\ -------------------------------------------------

: talk-30110-1  ( -- )
	check-map
	"7-30110-iker/1.htm" show 
;

: do-30110-2  ( -- ) 
	check-run
	check-map
	{ { 10000 57 } } { { 1 6653 } } items-exchanged?
	unless "У вас нет достаточного количества денег!" show exit then
	3 step!
	"7-30110-iker/2.htm" show
;

: talk-30110-3  ( -- )
	check-map
	{
		{ 1 6653 }
		{ 1 3888 }
		{ 1 3882 }
		{ 1 3885 }
	} { { 1 5204 } } items-exchanged?
	unless "7-30110-iker/3.htm" show exit then
	5 step!
	"7-30110-iker/4.htm" show
;

: talk-30110-5  ( -- )  check-map  "7-30110-iker/5.htm" show ;

\ -------------------------------------------------

: talk-31057-1  ( -- )
	check-amuleth
	"8-31057-loken-ghost/1.htm" show 
;

: do-31057-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-amuleth
	answer-true? unless 
		"8-31057-loken-ghost/2.htm" show  
		random-jump  
		exit 
	then
	
	"Игрок [ name@ ] отгадал загадку первого призрака" ann

	21240001 door-open
	"21240001 door-close" 2000 do-timer drop
	
	"8-31057-loken-ghost/3.htm" show
;

: kill-18281  ( -- )
	check-run  
	check-amuleth  
	3888 items# if exit then 
	1 3888 items_add  
	4 31057 n.step! 
	42018 208203 -3783 jump
	"Игрок [ name@ ] получил первую руну" ann
;

:noname  ['] kill-18281 killer do-player ; 18281 npc-die+!

: talk-31057-4  ( -- )  check-amuleth  "8-31057-loken-ghost/4.htm" show ;

\ -------------------------------------------------

: talk-31454-1  ( -- )
	check-amuleth
	"9-31454-wigoth/1.htm" show 
;

: do-31454-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-amuleth
	answer-true? unless 
		"9-31454-wigoth/2.htm" show  
		random-jump  
		exit 
	then
	
	"Игрок [ name@ ] отгадал загадку второго призрака" ann

	21240002 door-open
	"21240002 door-close" 2000 do-timer drop
	
	"9-31454-wigoth/3.htm" show
;

: kill-21819  ( -- )
	check-run  
	check-amuleth 
	3882 items# if exit then 
	1 3882 items_add  
	4 31454 n.step! 
	43482 212493 -3713 jump
	"Игрок [ name@ ] получил вторую руну" ann
;

:noname  ['] kill-21819 killer do-player ; 21819 npc-die+!

: talk-31454-4  ( -- )  check-amuleth  "9-31454-wigoth/4.htm" show ;

\ -------------------------------------------------

: talk-31452-1  ( -- )
	check-amuleth
	"a-31452-wigoth/1.htm" show 
;

: do-31452-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-amuleth
	answer-true? unless 
		"a-31452-wigoth/2.htm" show  
		random-jump  
		exit 
	then
	
	"Игрок [ name@ ] отгадал загадку третьего призрака" ann

	21240004 door-open
	"21240004 door-close" 2000 do-timer drop
	
	"a-31452-wigoth/3.htm" show
;

: kill-25330  ( -- )
	check-run  
	check-amuleth 
	3885 items# if exit then 
	1 3885 items_add  
	4 31452 n.step! 
	51110 206356 -4004 jump
	"Игрок [ name@ ] убил монстра и получил третью руну" ann
;

:noname  ['] kill-25330 killer do-player ; 25330 npc-die+!

: talk-31452-4  ( -- )  check-amuleth  "a-31452-wigoth/4.htm" show ;

\ -------------------------------------------------

: talk-31056-1  ( -- )
	check-key
	"b-31056-doorman/1.htm" show 
;

: do-31056-2  ( { отгадки } -- \ ответ ) 
	check-run
	check-key
	answer-true? unless 
		"b-31056-doorman/2.htm" show  
		random-jump  
		exit 
	then
	3 step!

	"Игрок [ name@ ] ввёл верный пароль и полчил доступ к сокровищам!" ann

	21240006 door-open
	"21240006 door-close" 2000 do-timer drop

	"b-31056-doorman/3.htm" show
;

: talk-31056-3 ( -- )
	21240006 door-open
	"21240006 door-close" 2000 do-timer drop

	"b-31056-doorman/3.htm" show
;



{ items.f } value items-list
new-list value spawned-items-list

{ spawn1.f } value npc-list1
{ spawn2.f } value npc-list2
{ spawn3.f } value npc-list3
new-list value spawned-list1
new-list value spawned-list2
new-list value spawned-list3

: start
	npc-list1 npc-list-spawn to spawned-list1
	npc-list2 npc-list-spawn to spawned-list2
	npc-list3 npc-list-spawn to spawned-list3
	items-list items-list-spawn to spawned-items-list
	true to events-balancer-pirates-run
;

: stop
	false to events-balancer-pirates-run
	spawned-list1 npc-list-unspawn
	spawned-list2 npc-list-unspawn
	spawned-list3 npc-list-unspawn
	spawned-items-list items-list-unspawn
;

;module
