module: poison:
stats: also

"java.util.LinkedList" class value LinkedList.class
"l2f.gameserver.tables.SkillTable" class value SkillTable.class

LinkedList.class "size" { } japi-func: LinkedList#
LinkedList.class "get" { int.class } japi-func: LinkedList@
L2Skill.class "getEffects" { L2Character.class L2Character.class bool.class } japi-func: Effects!

new-map value SkillsHash
null value TmpHash
null value TmpName
null value TmpTerr
"none" value SkillList
"pc" value TmpTarget

: targetAccept? ( type -- boolean)
	dup "npc" = monster? =
	swap
	"pc" = player? =
	or boolean
;

: Skill@ ( { SkillId SkillLv } -- L2Skill )
	list-rev> drop
	SkillTable.class "getInstance" { } jget
	"getInfo" { int.class int.class } jget
;

: addSkill ( L2Skill -- )
	>r
	r@ "Name" p@
	r@ "Level" p@
	s+ r> swap SkillsHash swap M!
;

: addEffect ( { SkillId SkillLv } -- )
	Skill@
	?dup null? if "not found area skill" .out null exit then
	>r
	player@ dup false boolean r>
	Effects!
	player@ "updateEffectIcons" 0 jexec drop
;

: addEffectList ( skilllist --)
	['] addEffect do-list
;

: removeEffect ( { SkillId SkillLv } -- )
	Skill@
	?dup null? if exit then
	player@ "getEffect" { L2Skill.class } jget
	?dup null? not if
	player@ "removeEffect" { "l2f.gameserver.model.L2Effect" class } jget drop
	then
;

: removeEffectList ( skilllist -- )
	['] removeEffect do-list
;

\ "data/jbforth/geodata/territories/poison/poison-area.xml" "java.io.File" 1 jnew
\ "l2f.gameserver.skills.SkillsEngine" class "getInstance" 0 jget 
\ "loadSkills" 1 jget "toArray" 0 jget []>list 
\  ['] addSkill do-list

: make-terr-poison ( hashfilename name -- )
	to TmpName
	new-map swap included to TmpHash
	{ } to SkillList

	TmpHash "skill_list" m@ ?dup null? not if to SkillList then 
	TmpHash "target" m@ ?dup null? not if to TmpTarget then

	{ TmpHash "range" m@ list> drop TmpName } points>territory to TmpTerr 

	" null uvalue [ TmpName ]-activated? " parse eval
	" { } value [ TmpName ]-SkillList " parse eval
	"SkillList to [ TmpName ]-SkillList " parse eval

	":  [ TmpName ]-enter  ( -- ) " parse
		'"' s+ "[ TmpTarget ]" parse s+ '"' s+ 
		" targetAccept? not if  exit then " s+
		" [ TmpName ]-activated? if exit then " parse s+
		"[ TmpName ]-SkillList" parse s+ 
		"  addEffectList " parse s+
		" true to [ TmpName ]-activated? " parse s+
		'"Enter the in poison zone"' s+ " type " s+
	";" s+  
	eval
 
	": [ TmpName ]-leave  ( -- ) " parse
		"[ TmpName ]-activated? unless exit then " parse s+
		"false to [ TmpName ]-activated? " parse s+
		"[ TmpName ]-SkillList removeEffectList " parse s+
		'"Exit the out poison zone"' s+ " type  " s+
	";" s+  
	eval
    
	"['] " " [ TmpName ]-enter TmpTerr " parse '"setEnterWord"' s+ " 1 jexec " s+
	s+
	eval

	"['] " " [ TmpName ]-leave TmpTerr " parse '"setLeaveWord"' s+ " 1 jexec " s+
	s+ 
	eval
;

 _fireswamp.f 		[']   make-terr-poison do-hashmap
 _godad_swamp_monster.f	[']   make-terr-poison do-hashmap
 _godad_swamp_pc.f	[']   make-terr-poison do-hashmap
 _list-lava.f		[']   make-terr-poison do-hashmap
 _list-over.f		[']   make-terr-poison do-hashmap

previous

;module
