\ Набор слов для работы с игроками

\ --------------------------------------------------------------
\ p.name  ( L2Player -- "name" )
\ Возврашает имя заданного игрока
L2Player.class "getName" { } japi-func: p.name
"p.name@" alias p.name \ алиас для старого кода

: name@  ( -- "current-player-name" )  player@ p.name@ ;
: p.oid@  ( -- current-player-object_id )  player@ oid@ ;

L2World.class "getPlayer" { String.class } japi-static-func: find_player
\ : find_player  ( "name" -- player )  world@ "Player" get(s) ; \ Find player by his name

L2Object.class "getPlayer" {  } japi-static-func: getPlayer

\ Return target object or player, if target not selected
: target-or-me@  ( -- target )
	player@ target@	?dup if exit then
	player@
;

\ Вернуть игрока, если он выбран целью, иначе - нас самих.
: target-player-or-me  ( -- player )
	target-or-me@
	dup c.player? if
		exit
	then

	drop
	self
;

"get-target" alias target@

: my-target   self get-target ;

: hcoords@  ( character -- x y z heading )
	>r
	r@ "X" p@
	r@ "Y" p@
	r@ "Z" p@
	r> "Heading" p@
;

: party@  ( player -- party | null )
	dup "InParty" p? if
		"Party" p@
	else
		drop null
	then
;

: db!  ( value "table field where_field" where-value -- false | errno )
	swap
	explode list> drop
	( value where-value where-field field table )
	"UPDATE `[ >slashes  ]` SET `[ >slashes ]`='[ rot >slashes  ]' WHERE `[ >slashes  ]`='[ >slashes ]';" parse dup .
	update ?dup if exit then
	drop false
;

: db@  ( "table field where_field" where-value -- value false | errno )
	swap
	explode list> drop
	( where-value where-field field table )
	"SELECT `[ swap dup >r >slashes ]` FROM `[ >slashes ]` WHERE `[ >slashes ]`='[ >slashes ]';" parse dup .
	query ?dup if rdrop exit then
	0 list@ r> m@
;	

\ : x1  "characters char_name obj_Id" p.oid@ db@ .s ;
\ : x2  ""  "characters char_name obj_Id" p.oid@ db! ;
\ : x2  "characters char_name level" 40 db@ .s ;

: broadcast-status  ( player -- )
	"broadcastStatusUpdate" 0 jexec
;

: f!  ( face -- )
	player@ "setFace" { int.class } jexec
	player@ broadcast-status
	player@ "HennaInfo" { L2Player.class } new-server-packet
	send-packet
	player@ "getFace" 0 jget .
;

: player-db!  ( value db-fields where-value set-method set.class -- errno )
	>r >r
	rdrop rdrop
	2drop
;

: p.karma@  ( player -- karma )			\ Get karma for player
	"Karma" p@ ;

: p.karma!  ( karma player -- )			\ Set karma for player
	swap 0 max swap "setKarma" { int.class } jexec ;

: p.karma+!  ( karma-change player -- )	\ Add karma for player
	dup >r p.karma@ + r> p.karma! ;

\ For current player
: karma@   player@ p.karma@ ;
: karma!   player@ p.karma! ;
: karma+!  player@ p.karma+! ;

: p.access-level  ( player -- access-level )  "AccessLevel" p@ ;
: p.access-level! ( access-level player -- )  "setAccessLevel" { int.class } jexec ;
: access-level  ( -- access-level )  player@ p.access-level ;
: access-level! ( access-level -- )  player@ p.access-level! ;
: p.clan-leader?  ( player -- flag )  "ClanLeader" p? ;
: clan-leader?  ( -- flag )  player@ p.clan-leader? ;

: id>clan  ( clan_id -- L2Clan | null )
	dup 0 > if
		ClanTable "getClan" { int.class } jget
	else
		drop null
	then
;

: name>clan_id  ( "clan_name" -- clan_id )  "clan_data clan_id clan_name" swap db@ ?dup if . 0 then ;
: p.clan!  ( clan_id player -- )  swap id>clan swap "setClan" { L2Clan.class } jexec ;
L2Player.class "getClan" { } japi-func: p.clan
: p.clan_name  ( player -- "clan_name" | "none" )  p.clan ?dup unless "none" then ;

: model:  ( -- )
	"l2f.gameserver.model." NextWord dup >r s+
	class
	"constant " r> ".class" s+
	eval
;

model: L2Clan

"l2f.gameserver.instancemanager.CastleManager" class    constant CastleManager.class
 CastleManager.class "getCastleByOwner" { L2Clan.class } japi-func: getCastleByOwner

: p.castle  ( player -- castle | null )
	p.clan
	?dup unless
		null
		exit
	then
	
	CastleManager getCastleByOwner
;

: p.castle-name  ( player -- castle-name  ) p.castle "Name" p@ ;

: p.castle-territory-name    p.castle-name >lower "_castle" s+ ;

L2Territory.class "getRandomBoundPoint" { } japi-func:  territory>point

: p.castle-owner-restart-point  ( player -- x y z )
	p.castle-territory-name
	"_owner_restart_point" s+
	name>territory
	territory>point 
	dup
	>r "x" field@
	r@ "y" field@
	r> "zmin" field@
;

: x.level  ( character -- level )  "Level" p@ ;

"get-level" alias x.level
: my-level   self get-level ;

L2Player.class "broadcastUserInfo" { } japi-proc: p.broadcastUserInfo
L2Player.class "setTeam" { int.class } japi-proc: p.setTeam
L2Player.class "getTeam" {  } japi-func: team@

: team! (( team player -- ))
	team player p.setTeam
	player p.broadcastUserInfo
;

: player_by_obj_id ( obj_id -- obj )
	"select char_name from characters where obj_id = [  ]" parse query drop 0 list@ "char_name" m@ find_player
;

: online@ ( player -- flag )
	dup null = not if
		oid@ player_by_obj_id null = not if 1 else 0 then
	else
		0
	then
;

L2Player.class "getSex" { } japi-func: p.getSex
: p.sex  ( player -- sex )  p.getSex int ;
L2Player.class "getClassId" { } japi-func: p.get-class-id-class
L2Player.class "setBaseClass" { int.class } japi-proc: p.setBaseClass
L2Player.class "setBaseTemplate" { ClassId.class bool.class } japi-proc: p.setBaseTemplate
 ClassId.class "getId" { } japi-func: ClassId.getId
 CharTemplateTable.class "getTemplate" { shrt.class bool.class } japi-func: chartable.getTemplate
L2Player.class "setActiveClass" { shrt.class } japi-proc: p.setActiveClass

\ --------------------------------------------------------------
\ p.kick ( player -- )
\ Выкидывает указанного игрока из игры
L2Player.class "kick" { } japi-proc: p.kick

L2Player.class "setHairColor" { bte.class } japi-proc: (p.setHairColor)
: p.setHairColor   swap >Byte swap (p.setHairColor) ;

L2Player.class "setHairStyle" { bte.class } japi-proc: (p.setHairStyle)
: p.setHairStyle   swap >Byte swap (p.setHairStyle) ;

L2Player.class "setFace" { bte.class } japi-proc: (p.setFace)
: p.setFace   swap >Byte swap (p.setFace) ;

: class-id/sex>template  ( class-id sex -- L2PcTemplate )
	boolean swap >Short swap
	CharTemplateTable chartable.getTemplate 
;

: p.class-id  ( player -- class-id )
	p.get-class-id-class
	ClassId.getId
;

: p.jump  ( x y z player -- )  >r coords>s " jump" s+ r> do-player ;

forth:: p.xyzh-list-jump  ( {x y z h} player -- )
	>r
	list-rev> drop
	r@ "setHeading" { int.class } jexec
	r> p.jump
;

\ { -18107 110211 -2514 48392 } value test
\ : ttt test self p.xyzh-list-jump ;
