: server-stat-instance  ( class-name -- instance )
  "l2f.gameserver." swap s+ class
  "getInstance" 0 jget
;

: skill-table@		( -- SkillTable )	"tables.SkillTable"	server-stat-instance ;
: skill-tree-table@	( -- SkillTreeTable )	"tables.SkillTreeTable"	server-stat-instance ;
: item-table@		( -- ItemTable )	"tables.ItemTable"	server-stat-instance ;
: teleport-location-table	( -- TeleportLocationTable )	"tables.TeleportLocationTable"	server-stat-instance ;
: doors@			( -- DoorTable )	"tables.DoorTable"	server-stat-instance ;
: world@			( -- L2World )		"model.L2World"		server-stat-instance ;
: Territory   ( -- Territory    ) "Territory"   server-stat-instance ;
: ClanTable     ( -- ClanTable    ) "tables.ClanTable"      server-stat-instance ;
: TownManager     ( -- TownManager    ) "instancemanager.TownManager"      server-stat-instance ;
: ClanHallManager     ( -- ClanHallManager    ) "instancemanager.ClanHallManager"      server-stat-instance ;
: Shutdown@     ( -- Shutdown   ) "Shutdown"      server-stat-instance ;
: GeoData	( -- Geodata ) "geodata.GeoData"   server-stat-instance ;
: GeoEngine ( -- Geodata ) "geodata.GeoEngine"   server-stat-instance ;
: CharTemplateTable ( -- CharTemplateTable )  "tables.CharTemplateTable" server-stat-instance ;

\ Упрощённый "импорт" соответствующих getInstance классов.
: instance:  ( class_name -- \ forth_name )  "l2f.gameserver." swap s+ class "getInstance" { } [compile] japi-static-func: ;

"instancemanager.CastleManager" instance: CastleManager
"instancemanager.DimensionalRiftManager" instance: DimensionalRiftManager
"instancemanager.RaidBossSpawnManager" instance: RaidBossSpawnManager
"model.entity.MonsterRace" instance: MonsterRace
"tables.NpcTable" instance: NpcTable
"tables.SpawnTable" instance: SpawnTable

"l2f.gameserver.tables.TerritoryTable" class   constant TerritoryTable.class
TerritoryTable.class "reload_data" { } japi-static-proc: TerritoryTable.reload
TerritoryTable.class "getInstance" { } japi-static-func: TerritoryTable
TerritoryTable.class "getLocations" { } japi-func: getLocations

"java.util.HashMap" class constant HashMap.class
HashMap.class "get" { Object.class } japi-func: hm@

: name>territory  >string TerritoryTable getLocations hm@ ;

"l2f.Config" class value Config.class

: config@  ( field_name -- value )  Config.class swap field@ ;
: config!  ( value field_name -- )  Config.class swap field! ;

: config-instance@  ( -- Config.getInstance )  Config.class "getInstance" 0 jget ;

: skills-reload  ( -- )   skill-table@ "reload" 0 jexec ;

false value server-file-include
false value player-online-notify
false value player-offline-notify
false value jbf-first-start

"config/server.f" INCLUDED

: server-addintional-load  ( -- )
  server-file-include if
    server-file-include INCLUDED
  then
;

: restart  ( seconds -- )
  "JBForth" swap 
  int true boolean
  Shutdown@ "startTelnetShutdown" { String.class int.class bool.class }
  jexec
;

: shutdown  ( seconds -- )
  "JBForth" swap 
  int false boolean
  Shutdown@ "startTelnetShutdown" { String.class int.class bool.class }
  jexec
;

\ Немедленно вырубить сервер при условии, что это у нас
\ первичная инициализация сервера
: shutdown-now-on-server-init  ( -- )
	server@ "Loading" p? if
		0 shutdown 
	then
;

\ В случае ошибки Форта при первичной загрузке сервера - вырубаем его.
on-abort: shutdown-now-on-server-init

: abort ( -- )
  "JBForth" Shutdown@ "Telnetabort" { String.class } jexec
;

: java.lang.Runtime  ( -- java.lang.Runtime )  "java.lang.Runtime" class "getRuntime" 0 jget ;
: gc  ( -- )  java.lang.Runtime "gc" 0 jexec ;

\ Раз в 10 минут запускаем принудительно сборщик мусора.
: periodical-garbage-collector  ( -- )  gc   "periodical-garbage-collector" 600000 do-timer drop ;
on-server-start: periodical-garbage-collector

\ : regions-clean  ( -- )
\	"Clean world begin" .out
\	now
\	world@ "REGIONS_Y" field@ 0 do
\		world@ "REGIONS_X" field@ 0 do
\			i j w.getRegion r.clean
\			?dup if 
\				"In region ([ i ], [ j ]) was cleaned [  ] objects" parse .out 
\			then
\		loop
\	loop
\	now swap D- 1000L D/ int
\	"Clean world end in [  ]sec." parse .out
\	"regions-clean" 1200000 do-timer drop
\ ;

\ on-server-start: regions-clean

new-hashmap server@ "setNpcOnDieMap"  { "java.util.concurrent.ConcurrentHashMap" class } jexec


\ Если конфиг настроен на отложенную загрузку сервера, то это слово
\ произведёт всю необходимую инициализацию.
: delayed-server-init  ( -- )
	"Delayed init begin..." .out
	NpcTable "Initialized" is? unless
		"Could not initialize the npc table" throw
	then

	SpawnTable drop
	RaidBossSpawnManager drop
	DimensionalRiftManager drop
	MonsterRace drop
	Quest.class "init" 0 jexec
;

\ Запускалка отложенной инициализации сервера, стартующего отдельным потоком
on-server-start:: "delayed-server-init" 1000 do-timer drop ;

: new-server-packet  ( ... name params -- )
	"l2f.gameserver.serverpackets." rot s+ swap
	jnew
;
