: get-available-skills  ( -- skills-list )
	player@
	dup "ClassId" p@

	skill-tree-table@ "getAvailableSkills" 2 jget

	[]>list
;

: new-AquireSkillList  ( standart_fishing_clan -- server-packet ) "AquireSkillList" { int.class } new-server-packet ;

: player&class-id@  ( -- player classId )
	player@ dup "ClassId" p@
;

: id&level>skill  ( int:skill int:level -- )
	skill-table@  "getInfo" { int.class int.class } jget
;

: calc-cost  ( skill -- cost|null )
	dup "id" field@
	swap "skillLevel" field@
	id&level>skill

	dup null? if exit then

	player@ "ClassId" p@  over  "getCanLearn" 1 jget 0= if drop null exit then

	player@ swap
	skill-tree-table@ "getSkillCost" { L2Player.class L2Skill.class } jget
;

: asl.addSkill  ( asl flag skill -- asl flag )
	>r \ r: skill

	r@ "id" field@
	r@ "skillLevel" field@
	dup
	r>
						\ ( asl flag skill-id skill-level skill-level skill )
	calc-cost

	dup null? if
		4 ndrop
		exit
	then

	0

	6 pick

	"addSkill" { int.class int.class int.class int.class int.class } jexec
	1+
;

: >acquire-skill-list  ( is_fishing_or_clan skill-list -- asl flag )
	new-AquireSkillList 0
	rot ['] asl.addSkill do-list
;

: sm607  ( min-level -- )
	607 new-SystemMessage
	swap sm.addNumber
	send-packet
;


: cannot-teache-notify  ( -- )
	player&class-id@
	skill-tree-table@  "getMinLevelForNewSkill" 2 jget

	dup 0> if
		sm607
		exit
	then

	drop
	"I cannot teach you any skills for your class." show
;

: skill-learn-list  ( classes-to-teach -- )
	dup null? if "WARRNING skill-learn-list list null" parse .out exit then \ здесь вместо списка иногда попадает null, основную причину пока ненашёл
	player@ "ClassId" p@ "Id" p@ int
	swap in-list? not if
		"I cannot teach you any skills for your class." show
		exit
	then

	get-available-skills 0 >acquire-skill-list
	0= if
		cannot-teache-notify
		exit
	then

	send-packet
	action-failed
;

: fishing-skill-learn-list ( -- )
  player@
  skill-tree-table@
  "getAvailableFishingSkills" { L2Player.class } jget
  []>list 1 >acquire-skill-list
  0= if
    cannot-teache-notify
    exit
  then

  send-packet
;

forth:: bypass_learnFishing  ( -- )
  fishing-skill-learn-list
;

: clan-skill-learn-list ( -- )
  player@ "getClanId" 0 jexec
  0 = if
    cannot-teache-notify
    exit
  then
  player@ dup "getClan" 0 jexec
  skill-tree-table@
  "getAvailableClanSkills" { L2Clan.class } jget
  []>list 2 >acquire-skill-list
  0= if
    cannot-teache-notify
    exit
  then

  send-packet
;

forth:: bypass_learnClanSkills  ( -- )
  clan-skill-learn-list
;
