package test.java._001_kill_handler;

import java.util.ArrayList;

import l2f.gameserver.GameServer;
import l2f.gameserver.model.L2Player;
import l2f.gameserver.model.instances.L2ItemInstance;
import l2f.gameserver.serverpackets.ItemList;
import l2f.gameserver.serverpackets.SystemMessage;
import l2f.gameserver.tables.ItemTable;
import ru.balancer.JBForth;
import ru.balancer.jbforth.Word;

public class KillHandler extends Word
{
	public KillHandler()
	{
		this.name = "KillHandlerTest1";
	}

	public void run(JBForth jbf)
	{
		Object killer = jbf.uvget("self");
		if(!(killer instanceof L2Player))
			return;

		L2Player player = (L2Player) killer;
		L2ItemInstance item = ItemTable.getInstance().createItem((short) 57, player.getObjectId(), 0, "TestKillHandler");
		item.setCount(1);

		player.getInventory().addItem(item);
		player.sendPacket(new ItemList(player, false));
		player.sendPacket((new SystemMessage(SystemMessage.EARNED_S2_S1_s)).addItemName(57).addNumber(1));
	}

	public void init()
	{
		Integer npc_id = 20001; // Гремлин
		ArrayList<Word> words = GameServer.getNpcOnKillMap().get(npc_id);
		if(words == null)
			words = new ArrayList<Word>();
		words.add(this);
		GameServer.getNpcOnKillMap().put(npc_id, words);
	}
}
