import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ROIENS_LETTER = 796
HOWTOGO_RUINS = 937
BROKEN_SWORD_HANDLE = 739
BROKEN_BLADE_BOTTOM = 740
BROKEN_BLADE_TOP = 741
ALLTRANS_NOTE = 742
SWORD_OF_SOLIDARITY = 738

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30008-04.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
        st.giveItems(ROIENS_LETTER,1)
    elif event == "30283-02.htm" :
        st.set("cond","2")
        st.takeItems(ROIENS_LETTER,-1)
        st.giveItems(HOWTOGO_RUINS,1)
    elif event == "30283-07.htm" :
        st.takeItems(BROKEN_SWORD_HANDLE,-1)
        st.giveItems(1060,100)
        for item in range(4412,4417) :
           st.giveItems(item,10)
        if st.getPlayer().getLevel() < 25 :
           if st.getPlayer().getClassId().isMage() :
              st.playTutorialVoice("tutorial_voice_027")
              st.giveItems(5790,3000)
           else :
              st.playTutorialVoice("tutorial_voice_026")
              st.giveItems(5789,6000)
        st.giveItems(SWORD_OF_SOLIDARITY,1)
        st.set("cond","0")
        st.setState(COMPLETED)
        st.playSound("ItemSound.quest_finish")
    return htmltext


 def onTalk (Self,npc,st) :
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30008 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() != 0 :
               htmltext = "30008-00.htm"
            elif st.getPlayer().getLevel() >= 9 :
               htmltext = "30008-02.htm"
               return htmltext
            else:
               htmltext = "30008-08.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and st.getQuestItemsCount(ROIENS_LETTER) == 1 :
         htmltext = "30008-05.htm"
      elif cond >= 2 and st.getQuestItemsCount(ROIENS_LETTER) == 0 and st.getQuestItemsCount(ALLTRANS_NOTE) == 0 :
         if st.getQuestItemsCount(BROKEN_BLADE_TOP) and st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) :
            htmltext = "30008-12.htm"
         if (st.getQuestItemsCount(BROKEN_BLADE_TOP) + st.getQuestItemsCount(BROKEN_BLADE_BOTTOM)) <= 1 :
            htmltext = "30008-11.htm"
         if st.getQuestItemsCount(BROKEN_SWORD_HANDLE) > 0 :
            htmltext = "30008-07.htm"
         if st.getQuestItemsCount(HOWTOGO_RUINS) == 1 :
            htmltext = "30008-10.htm"
      elif cond == 4 and st.getQuestItemsCount(ALLTRANS_NOTE) :
         htmltext = "30008-06.htm"
         st.set("cond","5")
         st.takeItems(ALLTRANS_NOTE,-1)
         st.giveItems(BROKEN_SWORD_HANDLE,1)
   elif npcId == 30283 :
      if cond == 1 and st.getQuestItemsCount(ROIENS_LETTER) > 0 :
         htmltext = "30283-01.htm"
      elif cond >= 2 and st.getQuestItemsCount(HOWTOGO_RUINS) == 1 :
         if (st.getQuestItemsCount(BROKEN_BLADE_TOP) + st.getQuestItemsCount(BROKEN_BLADE_BOTTOM)) == 1 :
            htmltext = "30283-08.htm"
         elif (st.getQuestItemsCount(BROKEN_BLADE_TOP) + st.getQuestItemsCount(BROKEN_BLADE_BOTTOM)) == 0 :
            htmltext = "30283-03.htm"
         elif st.getQuestItemsCount(BROKEN_BLADE_TOP) and st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) :
            htmltext = "30283-04.htm"
            st.set("cond","4")
            st.takeItems(HOWTOGO_RUINS,-1)
            st.takeItems(BROKEN_BLADE_TOP,-1)
            st.takeItems(BROKEN_BLADE_BOTTOM,-1)
            st.giveItems(ALLTRANS_NOTE,1)
      elif cond == 4 and st.getQuestItemsCount(ALLTRANS_NOTE) :
         htmltext = "30283-05.htm"
      elif cond == 5 and st.getQuestItemsCount(BROKEN_SWORD_HANDLE) :
         htmltext = "30283-06.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if npcId in [20361,20362] and st.getQuestItemsCount(HOWTOGO_RUINS) :
      if st.getQuestItemsCount(BROKEN_BLADE_TOP) == 0 :
         if st.getRandom(5) == 0 :
            st.giveItems(BROKEN_BLADE_TOP,1)
            st.playSound("ItemSound.quest_middle")
      elif st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) == 0 :
         if st.getRandom(5) == 0 :
            st.giveItems(BROKEN_BLADE_BOTTOM,1)
            st.playSound("ItemSound.quest_middle")
      if st.getQuestItemsCount(BROKEN_BLADE_TOP) and st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) :
         st.set("cond","3")
   return

QUEST       = Quest(101,"101_SwordOfSolidarity","Sword Of Solidarity")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30008)
CREATED.addTalkId(30008)
STARTED.addTalkId(30008)
COMPLETED.addTalkId(30008)
STARTED.addTalkId(30283)

STARTED.addKillId(20361)
STARTED.addKillId(20362)

STARTED.addQuestDrop(30283,ALLTRANS_NOTE,1)
STARTED.addQuestDrop(30283,HOWTOGO_RUINS,1)
STARTED.addQuestDrop(20362,BROKEN_BLADE_TOP,1)
STARTED.addQuestDrop(20361,BROKEN_BLADE_TOP,1)
STARTED.addQuestDrop(20362,BROKEN_BLADE_BOTTOM,1)
STARTED.addQuestDrop(20361,BROKEN_BLADE_BOTTOM,1)
STARTED.addQuestDrop(30008,ROIENS_LETTER,1)
STARTED.addQuestDrop(30008,BROKEN_SWORD_HANDLE,1)
for reward in range (4412,4417) + (5789, 5791) + [1060] :
  STARTED.addQuestDrop(30283,reward,1)

print "importing quests: 101: Sword Of Solidarity"
