import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

GALLINS_OAK_WAND = 748
WAND_SPIRITBOUND1 = 1135
WAND_SPIRITBOUND2 = 1136
WAND_SPIRITBOUND3 = 1137
WAND_OF_ADEPT = 747

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30017-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
      st.giveItems(GALLINS_OAK_WAND,3)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == 30017 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() != 0 :
               htmltext = "30017-00.htm"
               st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 10 :
               htmltext = "30017-02.htm"
               return htmltext
            else:
               htmltext = "30017-06.htm"
               st.exitCurrentQuest(True)
         else:
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif st.getInt("cond") == 1 and st.getQuestItemsCount(GALLINS_OAK_WAND) >= 1 and (st.getQuestItemsCount(WAND_SPIRITBOUND1) == 0 or st.getQuestItemsCount(WAND_SPIRITBOUND2) == 0 or st.getQuestItemsCount(WAND_SPIRITBOUND3) == 0) :
         htmltext = "30017-04.htm"
      elif st.getInt("cond") == 3 and st.getQuestItemsCount(WAND_SPIRITBOUND1) == 1 and st.getQuestItemsCount(WAND_SPIRITBOUND2) == 1 and st.getQuestItemsCount(WAND_SPIRITBOUND3) == 1 :
         st.giveItems(WAND_OF_ADEPT,1)
         st.takeItems(WAND_SPIRITBOUND1,1)
         st.takeItems(WAND_SPIRITBOUND2,1)
         st.takeItems(WAND_SPIRITBOUND3,1)
         st.giveItems(1060,100)
         for item in range(4412,4416) :
            st.giveItems(item,10)
         if st.getPlayer().getClassId().isMage() :
            st.giveItems(5790,3000)
            st.giveItems(2509,500)
         else :
            st.giveItems(5789,6000)
            st.giveItems(1835,1000)
         htmltext = "30017-05.htm"
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
         st.set("onlyone","1")
   elif npcId in [ 30041, 30043, 30045 ] and st.getInt("cond") == 1:
      htmltext = str(npcId) + "-01.htm"
      st.set("id",str(st.getInt("id")+1))
      if st.getInt("id") == 3 :
         st.set("cond","2")
   return htmltext

 def onKill (self,npc,st):
   cond = st.getInt("cond")
   npcId = npc.getNpcId()
   
   if cond == 2 and st.getQuestItemsCount(GALLINS_OAK_WAND) > 0 :
      if npcId == 27003 and st.getQuestItemsCount(WAND_SPIRITBOUND1) == 0 :
         st.takeItems(GALLINS_OAK_WAND,1)
         st.giveItems(WAND_SPIRITBOUND1,1)
         Collect = st.getQuestItemsCount(WAND_SPIRITBOUND1) + st.getQuestItemsCount(WAND_SPIRITBOUND2) + st.getQuestItemsCount(WAND_SPIRITBOUND3)
         if Collect == 3 :
            st.set("cond","3")
            st.playSound("ItemSound.quest_middle")
         else :
            st.playSound("ItemSound.quest_itemget")
      elif npcId == 27004 and st.getQuestItemsCount(WAND_SPIRITBOUND2) == 0 :
         st.takeItems(GALLINS_OAK_WAND,1)
         st.giveItems(WAND_SPIRITBOUND2,1)
         Collect = st.getQuestItemsCount(WAND_SPIRITBOUND1) + st.getQuestItemsCount(WAND_SPIRITBOUND2) + st.getQuestItemsCount(WAND_SPIRITBOUND3)
         if Collect == 3 :
            st.set("cond","3")
            st.playSound("ItemSound.quest_middle")
         else :
            st.playSound("ItemSound.quest_itemget")
      elif npcId == 27005 and st.getQuestItemsCount(WAND_SPIRITBOUND3) == 0 :
         st.takeItems(GALLINS_OAK_WAND,1)
         st.giveItems(WAND_SPIRITBOUND3,1)
         Collect = st.getQuestItemsCount(WAND_SPIRITBOUND1) + st.getQuestItemsCount(WAND_SPIRITBOUND2) + st.getQuestItemsCount(WAND_SPIRITBOUND3)
         if Collect == 3 :
            st.set("cond","3")
            st.playSound("ItemSound.quest_middle")
         else :
            st.playSound("ItemSound.quest_itemget")
   return

QUEST		= Quest(104,"104_SpiritOfMirror","Spirit Of Mirror")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30017)

CREATED.addTalkId(30017)

STARTED.addTalkId(30017)
STARTED.addTalkId(30041)
STARTED.addTalkId(30043)
STARTED.addTalkId(30045)

STARTED.addKillId(27003)
STARTED.addKillId(27004)
STARTED.addKillId(27005)

STARTED.addQuestDrop(27003,WAND_SPIRITBOUND1,1)
STARTED.addQuestDrop(27004,WAND_SPIRITBOUND2,1)
STARTED.addQuestDrop(27005,WAND_SPIRITBOUND3,1)
STARTED.addQuestDrop(30017,GALLINS_OAK_WAND,1)
for reward in [4412,4413,4414,4415,4416] + [5789, 5790, 5791] + [1060] + [WAND_OF_ADEPT] + [2509] :
  STARTED.addQuestDrop(30017,reward,1)

print "importing quests: 104: Spirit Of Mirror"