import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ONYX_TALISMAN1 = 984
ONYX_TALISMAN2 = 985
ANCIENT_SCROLL = 986
ANCIENT_CLAY_TABLET = 987
KARTAS_TRANSLATION = 988
ELDRITCH_DAGGER = 989

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30358-05.htm" :
        st.giveItems(ONYX_TALISMAN1,1)
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
    return htmltext


 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30358 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() != 2 :
               htmltext = "30358-00.htm"
               st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 10 :
               htmltext = "30358-03.htm"
            else:
               htmltext = "30358-02.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond > 0 and (st.getQuestItemsCount(ONYX_TALISMAN1) or st.getQuestItemsCount(ONYX_TALISMAN2)) and st.getQuestItemsCount(KARTAS_TRANSLATION) == 0 :
         htmltext = "30358-06.htm"
      elif cond == 4 and st.getQuestItemsCount(KARTAS_TRANSLATION) :
         htmltext = "30358-07.htm"
         st.takeItems(KARTAS_TRANSLATION,-1)
         st.giveItems(ELDRITCH_DAGGER,1)
         for item in range(4412,4417) :
            st.giveItems(item,10)
         st.giveItems(1060,100)
         if st.getPlayer().getClassId().isMage():
            st.playTutorialVoice("tutorial_voice_027")
            st.giveItems(5790,3000)
            st.giveItems(2509,500)
         else :
            st.playTutorialVoice("tutorial_voice_026")
            st.giveItems(1835,1000)
            st.giveItems(5789,6000)
         st.unset("cond")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == 30133 :
      if cond == 1 and st.getQuestItemsCount(ONYX_TALISMAN1) :
         htmltext = "30133-01.htm"
         st.takeItems(ONYX_TALISMAN1,-1)
         st.giveItems(ONYX_TALISMAN2,1)
         st.set("cond","2")
      elif cond == 2 and st.getQuestItemsCount(ONYX_TALISMAN2) and (st.getQuestItemsCount(ANCIENT_SCROLL) == 0 or st.getQuestItemsCount(ANCIENT_CLAY_TABLET) == 0) :
          htmltext = "30133-02.htm"
      elif cond == 3 and st.getQuestItemsCount(ANCIENT_SCROLL) and st.getQuestItemsCount(ANCIENT_CLAY_TABLET) :
         htmltext = "30133-03.htm"
         st.takeItems(ONYX_TALISMAN2,-1)
         st.takeItems(ANCIENT_SCROLL,-1)
         st.takeItems(ANCIENT_CLAY_TABLET,-1)
         st.giveItems(KARTAS_TRANSLATION,1)
         st.set("cond","4")
      elif cond == 4 and st.getQuestItemsCount(KARTAS_TRANSLATION) :
         htmltext = "30133-04.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   rand = st.getRandom(100)
   if npcId == 27070 :
      if st.getInt("cond") == 2 and st.getQuestItemsCount(ONYX_TALISMAN2) :
         if rand < 20 and st.getQuestItemsCount(ANCIENT_SCROLL) == 0 :
               st.giveItems(ANCIENT_SCROLL,1)
               st.playSound("ItemSound.quest_middle")
         elif rand < 10 and st.getQuestItemsCount(ANCIENT_CLAY_TABLET) == 0 :
               st.giveItems(ANCIENT_CLAY_TABLET,1)
               st.playSound("ItemSound.quest_middle")
   if st.getQuestItemsCount(ANCIENT_SCROLL) and st.getQuestItemsCount(ANCIENT_CLAY_TABLET) :
      st.set("cond","3")
   return

QUEST           = Quest(106,"106_ForgottenTruth","Forgotten Truth")
CREATED         = State('Start', QUEST)
STARTED         = State('Started', QUEST)
COMPLETED       = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30358)

CREATED.addTalkId(30358)

STARTED.addTalkId(30133)
STARTED.addTalkId(30358)

STARTED.addKillId(27070)

STARTED.addQuestDrop(30133,KARTAS_TRANSLATION,1)
STARTED.addQuestDrop(30358,ONYX_TALISMAN1,1)
STARTED.addQuestDrop(30133,ONYX_TALISMAN2,1)
STARTED.addQuestDrop(27070,ANCIENT_SCROLL,1)
STARTED.addQuestDrop(27070,ANCIENT_CLAY_TABLET,1)

print "importing quests: 106: Forgotten Truth"
