import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

HATOSS_ORDER1 = 1553
HATOSS_ORDER2 = 1554
HATOSS_ORDER3 = 1555
LETTER_TO_HUMAN = 1557
LETTER_TO_DARKELF = 1556
LETTER_TO_ELF = 1558
ADENA = 57
BUTCHER = 1510

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30568-03.htm" :
       st.giveItems(HATOSS_ORDER1,1)
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "30568-06.htm" :
       st.takeItems(HATOSS_ORDER2,1)
       st.takeItems(LETTER_TO_DARKELF,1)
       st.takeItems(LETTER_TO_HUMAN,1)
       st.takeItems(LETTER_TO_ELF,1)
       st.takeItems(HATOSS_ORDER1,1)
       st.takeItems(HATOSS_ORDER2,1)
       st.takeItems(HATOSS_ORDER3,1)
       st.giveItems(ADENA,200)
       st.unset("cond")
       st.playSound("ItemSound.quest_giveup")
       st.setState(ABORTED)
    elif event == "30568-07.htm" :
       st.takeItems(HATOSS_ORDER1,1)
       if st.getQuestItemsCount(HATOSS_ORDER2) == 0 :
          st.giveItems(HATOSS_ORDER2,1)
    elif event == "30568-09.htm" :
       st.takeItems(HATOSS_ORDER2,1)
       if st.getQuestItemsCount(HATOSS_ORDER3) == 0 :
          st.giveItems(HATOSS_ORDER3,1)
    return htmltext


 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   id2 = st.getStateId()
   cond = st.getInt("cond")
   if npcId == 30568 :
      if id == COMPLETED :
         htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif id == CREATED or id2 == "Aborted" :
         if st.getPlayer().getRace().ordinal() != 3 :
            htmltext = "30568-00.htm"
            st.exitCurrentQuest(True)
         elif st.getPlayer().getLevel() >= 12 :
            htmltext = "30568-02.htm"
            return htmltext
         else:
            htmltext = "30568-01.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getQuestItemsCount(HATOSS_ORDER1) :
          htmltext = "30568-04.htm"
      elif cond == 2 and st.getQuestItemsCount(HATOSS_ORDER1) and st.getQuestItemsCount(LETTER_TO_HUMAN) == 0 :
          htmltext = "30568-04.htm"
      elif cond == 3 and st.getQuestItemsCount(HATOSS_ORDER1) and st.getQuestItemsCount(LETTER_TO_HUMAN) >= 1 :
          htmltext = "30568-05.htm"
          st.set("cond","4")
      elif cond == 4 and st.getQuestItemsCount(HATOSS_ORDER2) and st.getQuestItemsCount(LETTER_TO_DARKELF) == 0 :
          htmltext = "30568-05.htm"
      elif cond == 5 and st.getQuestItemsCount(HATOSS_ORDER2) and st.getQuestItemsCount(LETTER_TO_DARKELF) >= 1 :
          htmltext = "30568-08.htm"
          st.set("cond","6")
      elif cond == 6 and st.getQuestItemsCount(HATOSS_ORDER3) and st.getQuestItemsCount(LETTER_TO_ELF) == 0 :
          htmltext = "30568-08.htm"
      elif cond == 7 and st.getQuestItemsCount(HATOSS_ORDER3) and (st.getQuestItemsCount(LETTER_TO_ELF)+st.getQuestItemsCount(LETTER_TO_HUMAN)+st.getQuestItemsCount(LETTER_TO_DARKELF)) == 3 :
            htmltext = "30568-10.htm"
            st.takeItems(LETTER_TO_DARKELF,-1)
            st.takeItems(LETTER_TO_HUMAN,-1)
            st.takeItems(LETTER_TO_ELF,-1)
            st.takeItems(HATOSS_ORDER3,-1)
            for item in range (4412,4417) :
               st.giveItems(item,10)
            st.giveItems(1060,100)
            if st.getPlayer().getClassId().isMage() :
               st.giveItems(5790,3000)
               st.playTutorialVoice("tutorial_voice_027")
            else :
               st.giveItems(5789,7000)
               st.playTutorialVoice("tutorial_voice_026")
            st.giveItems(BUTCHER,1)
            st.unset("cond")
            st.setState(COMPLETED)
            st.playSound("ItemSound.quest_finish")
   elif npcId == 30580 and cond >= 1 and (st.getQuestItemsCount(HATOSS_ORDER1) or st.getQuestItemsCount(HATOSS_ORDER2) or st.getQuestItemsCount(HATOSS_ORDER3)) :
      if cond == 1 :
         st.set("cond","2")
      htmltext = "30580-01.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == 27041 :
        if cond == 2 and st.getQuestItemsCount(HATOSS_ORDER1) and st.getQuestItemsCount(LETTER_TO_HUMAN) == 0 :
            st.giveItems(LETTER_TO_HUMAN,1)
            st.set("cond","3")
            st.playSound("ItemSound.quest_itemget")
        elif cond == 4 and st.getQuestItemsCount(HATOSS_ORDER2) and st.getQuestItemsCount(LETTER_TO_DARKELF) == 0 :
            st.giveItems(LETTER_TO_DARKELF,1)
            st.set("cond","5")
            st.playSound("ItemSound.quest_itemget")
        elif cond == 6 and st.getQuestItemsCount(HATOSS_ORDER3) and st.getQuestItemsCount(LETTER_TO_ELF) == 0 :
            st.giveItems(LETTER_TO_ELF,1)
            st.set("cond","7")
            st.playSound("ItemSound.quest_itemget")
   return

QUEST           = Quest(107,"107_MercilessPunishment","Merciless Punishment")
CREATED         = State('Start', QUEST)
STARTED         = State('Started', QUEST)
ABORTED         = State('Aborted', QUEST)
COMPLETED       = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30568)

CREATED.addTalkId(30568)
STARTED.addTalkId(30568)
STARTED.addTalkId(30580)

STARTED.addKillId(27041)

STARTED.addQuestDrop(27041,LETTER_TO_DARKELF,1)
STARTED.addQuestDrop(27041,LETTER_TO_HUMAN,1)
STARTED.addQuestDrop(27041,LETTER_TO_ELF,1)
STARTED.addQuestDrop(30568,HATOSS_ORDER1,1)
STARTED.addQuestDrop(30568,HATOSS_ORDER2,1)
STARTED.addQuestDrop(30568,HATOSS_ORDER3,1)

print "importing quests: 107: Merciless Punishment"