import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

VERY_EXPENSIVE_NECKLACE = 7574
SCROLL_OF_ESCAPE_GIRAN = 7126
MARK_OF_TRAVELER = 7570

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st) :
        htmltext = event
        if event == "30533-03.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        elif event == "30520-02.htm" :
            st.set("cond","2")
            st.giveItems(VERY_EXPENSIVE_NECKLACE,1)
        elif event == "30650-02.htm" :
            st.set("cond","3")
            st.takeItems(VERY_EXPENSIVE_NECKLACE,1)
        elif event == "30520-05.htm" :
            st.set("cond","4")
        elif event == "30533-06.htm" :
            st.giveItems(SCROLL_OF_ESCAPE_GIRAN,1)
            st.giveItems(MARK_OF_TRAVELER,1)
            st.unset("cond")
            st.setState(COMPLETED)
            st.playSound("ItemSound.quest_finish")
        return htmltext

    def onTalk (Self,npc,st):
        npcId = npc.getNpcId()
        htmltext = "<html><body>I have nothing to say you</body></html>"
        id = st.getState()
        cond = st.getInt("cond")
        if npcId == 30533 :
           if cond == 0 :
              if id != COMPLETED :
                 if st.getPlayer().getRace().ordinal() == 4 and st.getPlayer().getLevel() >= 3 :
                    htmltext = "30533-02.htm"
                 else :
                    htmltext = "30533-01.htm"
                    st.exitCurrentQuest(True)
              else :
                 htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>"
           elif cond == 1 :
              htmltext = "30533-04.htm"
           elif cond == 4 :
              htmltext = "30533-05.htm"
        elif npcId == 30520 :
           if cond == 1 :
              htmltext = "30520-01.htm"
           elif cond == 2 :
              htmltext = "30520-03.htm"
           elif cond == 3 :
              htmltext = "30520-04.htm"
           elif cond == 4 :
              htmltext = "30520-06.htm"
        elif npcId == 30650 :
           if cond == 2 and st.getQuestItemsCount(VERY_EXPENSIVE_NECKLACE) :
              htmltext = "30650-01.htm"
           elif cond == 3 :
              htmltext = "30650-03.htm"
           else :
              htmltext = "30650-04.htm"
        return htmltext

QUEST       = Quest(10,"10_IntoTheWorld","Into The World")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30533)

CREATED.addTalkId(30533)
COMPLETED.addTalkId(30533)

STARTED.addTalkId(30533)
STARTED.addTalkId(30520)
STARTED.addTalkId(30650)

STARTED.addQuestDrop(30520,VERY_EXPENSIVE_NECKLACE,1)
STARTED.addQuestDrop(30533,SCROLL_OF_ESCAPE_GIRAN,1)
STARTED.addQuestDrop(30533,MARK_OF_TRAVELER,1)

print "importing quests: 10: Into The World"