import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

HARRYS_RECEIPT1 = 1008
HARRYS_RECEIPT2 = 1009
GOLEM_SHARD = 1010
TOOL_BOX = 1011
WOODEN_BP = 23

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30035-04.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
       if st.getQuestItemsCount(HARRYS_RECEIPT1) == 0 :
          st.giveItems(HARRYS_RECEIPT1,1)
    elif event == "152_2" :
       st.takeItems(HARRYS_RECEIPT1,-1)
       if st.getQuestItemsCount(HARRYS_RECEIPT2) == 0 :
          st.giveItems(HARRYS_RECEIPT2,1)
          st.set("cond","2")
       htmltext = "30283-02.htm"
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30035 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 10 :
               htmltext = "30035-03.htm"
               return htmltext
            else:
               htmltext = "30035-02.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and st.getQuestItemsCount(HARRYS_RECEIPT1) != 0 :
         htmltext = "30035-05.htm"
      elif cond == 2 and st.getQuestItemsCount(HARRYS_RECEIPT2) != 0 :
         htmltext = "30035-05.htm"
      elif cond == 4 and st.getQuestItemsCount(TOOL_BOX)!=0 :
         st.takeItems(TOOL_BOX,-1)
         st.takeItems(HARRYS_RECEIPT2,-1)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
         st.giveItems(WOODEN_BP,1)
         st.addExpAndSp(5000,250)
         htmltext = "30035-06.htm"
   elif npcId == 30283 :
      if cond == 1 and st.getQuestItemsCount(HARRYS_RECEIPT1) != 0 :
         htmltext = "30283-01.htm"
      elif cond == 2 and st.getQuestItemsCount(HARRYS_RECEIPT2) != 0 and st.getQuestItemsCount(GOLEM_SHARD) < 5 :
         htmltext = "30283-03.htm"
      elif cond == 3 and st.getQuestItemsCount(HARRYS_RECEIPT2) != 0 and st.getQuestItemsCount(GOLEM_SHARD) == 5 :
        st.takeItems(GOLEM_SHARD,-1)
        if st.getQuestItemsCount(TOOL_BOX) == 0 :
           st.giveItems(TOOL_BOX,1)
           st.set("cond","4")
        htmltext = "30283-04.htm"
   elif cond == 4 and st.getQuestItemsCount(HARRYS_RECEIPT2) != 0 and st.getQuestItemsCount(TOOL_BOX) != 0 :
        htmltext = "30283-05.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if st.getInt("cond") == 2 and st.getRandom(100) < 30 and st.getQuestItemsCount(GOLEM_SHARD) < 5 :
      st.giveItems(GOLEM_SHARD,1)
      if st.getQuestItemsCount(GOLEM_SHARD) == 5 :
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")
      else:
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(152,"152_ShardsOfGolem","Shards Of Golem")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30035)

CREATED.addTalkId(30035)
STARTED.addTalkId(30035)
STARTED.addTalkId(30283)
COMPLETED.addTalkId(30035)

STARTED.addKillId(20016)

STARTED.addQuestDrop(30035,HARRYS_RECEIPT1,1)
STARTED.addQuestDrop(20016,GOLEM_SHARD,1)
STARTED.addQuestDrop(30283,TOOL_BOX,1)
STARTED.addQuestDrop(30283,HARRYS_RECEIPT2,1)

print "importing quests: 152: Shards Of Golem"