import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

DELIVERY_LIST = 1012
HEAVY_WOOD_BOX = 1013
CLOTH_BUNDLE = 1014
CLAY_POT = 1015
JACKSONS_RECEIPT = 1016
SILVIAS_RECEIPT = 1017
RANTS_RECEIPT = 1018
RING_OF_KNOWLEDGE = 875

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30041-04.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
        if st.getQuestItemsCount(DELIVERY_LIST) == 0 :
          st.giveItems(DELIVERY_LIST,1)
        if st.getQuestItemsCount(HEAVY_WOOD_BOX) == 0 :
          st.giveItems(HEAVY_WOOD_BOX,1)
        if st.getQuestItemsCount(CLOTH_BUNDLE) == 0 :
          st.giveItems(CLOTH_BUNDLE,1)
        if st.getQuestItemsCount(CLAY_POT) == 0 :
          st.giveItems(CLAY_POT,1)
        htmltext = "30041-04.htm"
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30041 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 2 :
               htmltext = "30041-03.htm"
               return htmltext
            else:
               htmltext = "30041-02.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and (st.getQuestItemsCount(JACKSONS_RECEIPT) + st.getQuestItemsCount(SILVIAS_RECEIPT) + st.getQuestItemsCount(RANTS_RECEIPT)) == 0 :
         htmltext = "30041-05.htm"
      elif cond == 1 and (st.getQuestItemsCount(JACKSONS_RECEIPT) + st.getQuestItemsCount(SILVIAS_RECEIPT) + st.getQuestItemsCount(RANTS_RECEIPT)) == 3 :
         st.giveItems(RING_OF_KNOWLEDGE,2)
         st.takeItems(DELIVERY_LIST,-1)
         st.takeItems(JACKSONS_RECEIPT,-1)
         st.takeItems(SILVIAS_RECEIPT,-1)
         st.takeItems(RANTS_RECEIPT,-1)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
         htmltext = "30041-06.htm"
   elif npcId == 30002 :
      if cond == 1 and st.getQuestItemsCount(HEAVY_WOOD_BOX) == 1 :
         st.takeItems(HEAVY_WOOD_BOX,-1)
         if st.getQuestItemsCount(JACKSONS_RECEIPT) == 0 :
            st.giveItems(JACKSONS_RECEIPT,1)
         htmltext = "30002-01.htm"
      elif cond == 1 and st.getQuestItemsCount(JACKSONS_RECEIPT) > 0 :
         htmltext = "30002-02.htm"
   elif npcId == 30003 :
      if cond == 1 and st.getQuestItemsCount(CLOTH_BUNDLE) == 1 :
         st.takeItems(CLOTH_BUNDLE,-1)
         if st.getQuestItemsCount(SILVIAS_RECEIPT) == 0 :
            st.giveItems(SILVIAS_RECEIPT,1)
            if st.getPlayer().getClassId().isMage() :
               st.giveItems(2509,3)
            else :
               st.giveItems(1835,6)
         htmltext = "30003-01.htm"
      elif cond == 1 and st.getQuestItemsCount(SILVIAS_RECEIPT) > 0 :
         htmltext = "30003-02.htm"
   elif npcId == 30054 :
      if cond == 1 and st.getQuestItemsCount(CLAY_POT) == 1 :
         st.takeItems(CLAY_POT,-1)
         if st.getQuestItemsCount(RANTS_RECEIPT) == 0 :
            st.giveItems(RANTS_RECEIPT,1)
         htmltext = "30054-01.htm"
      elif cond == 1 and st.getQuestItemsCount(RANTS_RECEIPT) > 0 :
         htmltext = "30054-02.htm"
   return htmltext

QUEST       = Quest(153,"153_DeliverGoods","Deliver Goods")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30041)

CREATED.addTalkId(30041)
STARTED.addTalkId(30041)
COMPLETED.addTalkId(30041)
STARTED.addTalkId(30002)
STARTED.addTalkId(30003)
STARTED.addTalkId(30054)

STARTED.addQuestDrop(30041,HEAVY_WOOD_BOX,1)
STARTED.addQuestDrop(30041,CLOTH_BUNDLE,1)
STARTED.addQuestDrop(30041,CLAY_POT,1)
STARTED.addQuestDrop(30041,DELIVERY_LIST,1)
STARTED.addQuestDrop(30002,JACKSONS_RECEIPT,1)
STARTED.addQuestDrop(30003,SILVIAS_RECEIPT,1)
STARTED.addQuestDrop(30054,RANTS_RECEIPT,1)
STARTED.addQuestDrop(30041,RING_OF_KNOWLEDGE,1)

print "importing quests: 153: Deliver Goods"