import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

VLADIMIR = 31302
TUNATUN = 31537

BEAST_MEAT = 7547

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "31302-1.htm" :
     st.giveItems(BEAST_MEAT,1)
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   if event == "31537-1.htm" :
     st.takeItems(BEAST_MEAT,-1)
     st.giveItems(57,30000)
     st.unset("cond")
     st.setState(COMPLETED)
     st.playSound("ItemSound.quest_finish")
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == VLADIMIR :
     if cond == 0 :
       if id == COMPLETED :
         htmltext = "<html><body>This quest has already been completed.</body></html>"
       elif st.getPlayer().getLevel() >= 63 :
         htmltext = "31302-0.htm"
       else:
         htmltext = "31302-00.htm"
         st.exitCurrentQuest(True)
     else :
       htmltext = "31302-2.htm"
   elif npcId == TUNATUN :
      if st.getQuestItemsCount(BEAST_MEAT) >= 1 :
         htmltext = "31537-0.htm"
      else :
         htmltext = "31302-havent.htm"
         st.exitCurrentQuest(True)
   return htmltext

QUEST       = Quest(19,"19_GoToThePastureland","Go To The Pastureland")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(VLADIMIR)

CREATED.addTalkId(VLADIMIR)
STARTED.addTalkId(VLADIMIR)
COMPLETED.addTalkId(VLADIMIR)
STARTED.addTalkId(TUNATUN)

STARTED.addQuestDrop(VLADIMIR,BEAST_MEAT,1)
STARTED.addQuestDrop(VLADIMIR,57,1)

print "importing quests: 19: Go To The Pastureland"