import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPCs 
DARIN  = 30048
ROXXY  = 30006
BAULRO = 30033

#ITEMS 
DARINGS_LETTER     = 687
RAPUNZELS_KERCHIEF = 688
DARINGS_RECEIPT    = 1079
BAULS_POTION       = 1080
 
#REWARD 
NECKLACE = 906
 
class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30048-06.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.giveItems(DARINGS_LETTER,1)
     st.playSound("ItemSound.quest_accept")
   return htmltext 

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == DARIN :
      if cond == 0 : 
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 2 :
               htmltext = "30048-02.htm"
            else: 
               htmltext = "30048-00.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "30048-07.htm"
      elif cond == 2 and st.getQuestItemsCount(RAPUNZELS_KERCHIEF) == 1 :
         htmltext = "30048-08.htm"
         st.takeItems(RAPUNZELS_KERCHIEF,-1)
         st.giveItems(DARINGS_RECEIPT,1)
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")
      elif cond == 3 :
         htmltext = "30048-09.htm"
      elif cond == 4 and st.getQuestItemsCount(BAULS_POTION) == 1 :
         htmltext = "30048-10.htm"
         st.takeItems(BAULS_POTION,-1)
         st.giveItems(NECKLACE,1)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == ROXXY :
      if cond == 1 :
         if st.getQuestItemsCount(RAPUNZELS_KERCHIEF) == 0 and st.getQuestItemsCount(DARINGS_LETTER) :
            htmltext = "30006-01.htm"
            st.takeItems(DARINGS_LETTER,-1)
            st.giveItems(RAPUNZELS_KERCHIEF,1)
            st.set("cond","2")
            st.playSound("ItemSound.quest_middle")
      elif cond == 2 and st.getQuestItemsCount(RAPUNZELS_KERCHIEF) :
            htmltext = "30006-02.htm"
      elif cond > 2 and (st.getQuestItemsCount(BAULS_POTION) or st.getQuestItemsCount(DARINGS_RECEIPT)) :
            htmltext = "30006-03.htm"
   elif npcId == BAULRO :
      if cond == 3 and st.getQuestItemsCount(DARINGS_RECEIPT) == 1 : 
         htmltext = "30033-01.htm" 
         st.takeItems(DARINGS_RECEIPT,-1) 
         st.giveItems(BAULS_POTION,1) 
         st.set("cond","4") 
         st.playSound("ItemSound.quest_middle") 
      elif cond == 4 : 
         htmltext = "30033-02.htm" 
   return htmltext

QUEST     = Quest(1,"1_LettersOfLove","Letters of Love")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(DARIN)

CREATED.addTalkId(DARIN)
STARTED.addTalkId(ROXXY)
STARTED.addTalkId(BAULRO)
STARTED.addTalkId(DARIN)
COMPLETED.addTalkId(DARIN)

STARTED.addQuestDrop(DARIN,DARINGS_LETTER,1)
STARTED.addQuestDrop(ROXXY,RAPUNZELS_KERCHIEF,1)
STARTED.addQuestDrop(DARIN,DARINGS_RECEIPT,1)
STARTED.addQuestDrop(BAULRO,BAULS_POTION,1)
STARTED.addQuestDrop(DARIN,NECKLACE,1)

print "importing quests: 1: Letters Of Love"