import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

MARK_OF_GUILDSMAN = 3119
VALKONS_RECOMMEND = 3120
MANDRAGORA_BERRY = 3121
ALLTRANS_INSTRUCTIONS = 3122
ALLTRANS_RECOMMEND1 = 3123
ALLTRANS_RECOMMEND2 = 3124
NORMANS_INSTRUCTIONS = 3125
NORMANS_RECEIPT = 3126
DUNINGS_INSTRUCTIONS = 3127
DUNINGS_KEY = 3128
NORMANS_LIST = 3129
GRAY_BONE_POWDER = 3130
GRANITE_WHETSTONE = 3131
RED_PIGMENT = 3132
BRAIDED_YARN = 3133
JOURNEYMAN_GEM = 3134
PINTERS_INSTRUCTIONS = 3135
AMBER_BEAD = 3136
AMBER_LUMP = 3137
JOURNEYMAN_DECO_BEADS = 3138
JOURNEYMAN_RING = 3139
RP_JOURNEYMAN_RING = 3024
DIMENSION_DIAMOND = 7562
ADENA = 57
RP_AMBER_BEAD = 3025

# ID : [ REQUIRED, ITEM, MAX_QUANTY, CHANCE]
DROPLIST_COND_3={
20223  :[VALKONS_RECOMMEND, MANDRAGORA_BERRY,   1,  20],   # Mandragora Sprout
20154  :[VALKONS_RECOMMEND, MANDRAGORA_BERRY,   1,  50],   # Mandragora Sprout
20155  :[VALKONS_RECOMMEND, MANDRAGORA_BERRY,   1,  50],   # Mandragora Sapling
20156  :[VALKONS_RECOMMEND, MANDRAGORA_BERRY,   1,  50]   # Mandragora Blossom
}

# ID : [ REQUIRED, ITEM, MAX_QUANTY, CHANCE, DROP]
DROPLIST_COND_5={
20267  :[NORMANS_INSTRUCTIONS, DUNINGS_KEY, 30,  30, 1],   # Breka Orc
20268  :[NORMANS_INSTRUCTIONS, DUNINGS_KEY, 30,  30, 1],   # Breka Orc Archer
20269  :[NORMANS_INSTRUCTIONS, DUNINGS_KEY, 30,  30, 1],   # Breka Orc Shaman
20270  :[NORMANS_INSTRUCTIONS, DUNINGS_KEY, 30,  30, 1],   # Breka Orc Overlord
20271  :[NORMANS_INSTRUCTIONS, DUNINGS_KEY, 30,  30, 1],   # Breka Orc Warrior
20200  :[NORMANS_LIST, GRAY_BONE_POWDER, 70,  100, 2],   # Strain
20201  :[NORMANS_LIST, GRAY_BONE_POWDER, 70,  100, 2],   # Ghoul
20202  :[NORMANS_LIST, RED_PIGMENT, 70,  100, 2],        # Dead Seeker
20083  :[NORMANS_LIST, GRANITE_WHETSTONE, 70,  100, 2],  # Granite Golem
20168  :[NORMANS_LIST, BRAIDED_YARN, 70,  100, 2]       # Silenos
}

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "1" :
       htmltext = "30103-06.htm"
#       if st.getStateId() != "Aborted" :
#          st.giveItems(DIMENSION_DIAMOND,85)
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
       st.giveItems(VALKONS_RECOMMEND,1)
       st.takeItems(ADENA,2000)
    elif event == "30103-07c.htm" :
       st.set("cond","3")
    elif event == "30103_1" :
       htmltext = "30103-04.htm"
    elif event == "30103_2" :
       if st.getQuestItemsCount(ADENA) >= 2000 :
          htmltext = "30103-05.htm"
       else:
          htmltext = "30103-05a.htm"
    elif event == "30103_3" :
       htmltext = "30103-09a.htm"
       st.addExpAndSp(80993,12250)
       st.takeItems(JOURNEYMAN_RING,-1)
       st.takeItems(ALLTRANS_INSTRUCTIONS,1)
       st.takeItems(RP_JOURNEYMAN_RING,1)
       st.giveItems(MARK_OF_GUILDSMAN,1)
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
    elif event == "30103_4" :
       st.addExpAndSp(80993,12250)
       htmltext = "30103-09b.htm"
       st.takeItems(JOURNEYMAN_RING,-1)
       st.takeItems(ALLTRANS_INSTRUCTIONS,1)
       st.takeItems(RP_JOURNEYMAN_RING,1)
       st.giveItems(MARK_OF_GUILDSMAN,1)
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
    elif event == "30283_1" :
       htmltext = "30283-03.htm"
       st.giveItems(ALLTRANS_INSTRUCTIONS,1)
       st.takeItems(VALKONS_RECOMMEND,-1)
       st.giveItems(RP_JOURNEYMAN_RING,1)
       st.takeItems(MANDRAGORA_BERRY,1)
       st.giveItems(ALLTRANS_RECOMMEND1,1)
       st.giveItems(ALLTRANS_RECOMMEND2,1)
       st.set("cond","5")
    elif event == "30210_1" :
       htmltext = "30210-02.htm"
    elif event == "30210_2" :
       htmltext = "30210-03.htm"
    elif event == "30210_3" :
       htmltext = "30210-04.htm"
       st.giveItems(NORMANS_INSTRUCTIONS,1)
       st.takeItems(ALLTRANS_RECOMMEND1,1)
       st.giveItems(NORMANS_RECEIPT,1)
    elif event == "30210_4" :
       htmltext = "30210-08.htm"
    elif event == "30210_5" :
       htmltext = "30210-09.htm"
    elif event == "30210_6" :
       htmltext = "30210-10.htm"
       st.takeItems(DUNINGS_KEY,-1)
       st.giveItems(NORMANS_LIST,1)
       st.takeItems(NORMANS_INSTRUCTIONS,1)
    elif event == "30688_1" :
       htmltext = "30688-02.htm"
       st.giveItems(DUNINGS_INSTRUCTIONS,1)
       st.takeItems(NORMANS_RECEIPT,1)
    elif event == "30298_1" :
       htmltext = "30298-03.htm"
    elif event == "30298_2" :
       if st.getPlayer().getClassId().getId() == 0x36 :
          htmltext = "30298-04.htm"
          st.giveItems(PINTERS_INSTRUCTIONS,1)
          st.takeItems(ALLTRANS_RECOMMEND2,1)
       else:
          htmltext = "30298-05.htm"
          st.giveItems(RP_AMBER_BEAD,1)
          st.takeItems(ALLTRANS_RECOMMEND2,1)
          st.giveItems(PINTERS_INSTRUCTIONS,1)
    return htmltext


 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30103 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getClassId().getId() in [0x36,0x38] :
               if st.getPlayer().getLevel() >= 35 :
                  htmltext = "30103-03.htm"
               else:
                  htmltext = "30103-02.htm"
                  st.exitCurrentQuest(True)
         
            else:
               htmltext = "30103-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 2 and st.getQuestItemsCount(VALKONS_RECOMMEND) :
         htmltext = "30103-07.htm"
      elif cond >= 1 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 :
         if st.getQuestItemsCount(JOURNEYMAN_RING) < 7 :
            htmltext = "30103-08.htm"
         else:
            htmltext = "30103-09.htm"
   elif npcId == 30283 :
      if cond == 1 and st.getQuestItemsCount(VALKONS_RECOMMEND) and st.getQuestItemsCount(MANDRAGORA_BERRY) == 0 :
         htmltext = "30283-01.htm"
         st.set("cond","2")
      elif cond == 4 and st.getQuestItemsCount(VALKONS_RECOMMEND) and st.getQuestItemsCount(MANDRAGORA_BERRY) == 1 :
         htmltext = "30283-02.htm"
      elif cond < 6 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 and st.getQuestItemsCount(JOURNEYMAN_RING) < 7 :
         htmltext = "30283-04.htm"
      elif cond == 6 and st.getQuestItemsCount(JOURNEYMAN_RING) == 7 :
         htmltext = "30283-05.htm"
   elif npcId == 30210 :
      if cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 and st.getQuestItemsCount(ALLTRANS_RECOMMEND1) == 1 :
          htmltext = "30210-01.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_RECEIPT) :
         htmltext = "30210-05.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) and st.getQuestItemsCount(DUNINGS_INSTRUCTIONS) :
         htmltext = "30210-06.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) and st.getQuestItemsCount(DUNINGS_KEY) >= 30 :
         htmltext = "30210-07.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_LIST) :
         if st.getQuestItemsCount(GRAY_BONE_POWDER) >= 70 and st.getQuestItemsCount(GRANITE_WHETSTONE) >= 70 and st.getQuestItemsCount(RED_PIGMENT) >= 70 and st.getQuestItemsCount(BRAIDED_YARN) >= 70 :
            htmltext = "30210-12.htm"
            st.takeItems(NORMANS_LIST,1)
            st.takeItems(GRAY_BONE_POWDER,-1)
            st.takeItems(GRANITE_WHETSTONE,-1)
            st.takeItems(RED_PIGMENT,-1)
            st.takeItems(BRAIDED_YARN,-1)
            st.giveItems(JOURNEYMAN_GEM,7)
            if st.getQuestItemsCount(JOURNEYMAN_DECO_BEADS) == 7 and st.getQuestItemsCount(JOURNEYMAN_GEM) == 7 :
               st.set("cond","6")
         else:
            htmltext = "30210-11.htm"
      elif cond >= 5 and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) == 0 and st.getQuestItemsCount(NORMANS_LIST) == 0 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 and (st.getQuestItemsCount(JOURNEYMAN_GEM) or st.getQuestItemsCount(JOURNEYMAN_RING)) :
         htmltext = "30210-13.htm"
   elif npcId == 30688 :
      if cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_RECEIPT) :
         htmltext = "30688-01.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) and st.getQuestItemsCount(DUNINGS_INSTRUCTIONS) :
         htmltext = "30688-03.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(NORMANS_INSTRUCTIONS) and st.getQuestItemsCount(DUNINGS_KEY) >= 30 :
         htmltext = "30688-04.htm"
      elif cond >= 5 and st.getQuestItemsCount(NORMANS_RECEIPT) == 0 and st.getQuestItemsCount(DUNINGS_INSTRUCTIONS) == 0 and st.getQuestItemsCount(DUNINGS_KEY) == 0 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 :
         htmltext = "30688-01.htm"
   elif npcId == 30298 :
      if cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(ALLTRANS_RECOMMEND2) :
         if st.getPlayer().getLevel() < 36 :
            htmltext = "30298-01.htm"
         else:
            htmltext = "30298-02.htm"
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) and st.getQuestItemsCount(PINTERS_INSTRUCTIONS) :
         if st.getQuestItemsCount(AMBER_BEAD) < 70 :
            htmltext = "30298-06.htm"
         else:
            htmltext = "30298-07.htm"
            st.takeItems(PINTERS_INSTRUCTIONS,1)
            st.takeItems(AMBER_BEAD,-1)
            st.takeItems(RP_AMBER_BEAD,-1)
            st.takeItems(AMBER_LUMP,-1)
            st.giveItems(JOURNEYMAN_DECO_BEADS,7)
            if st.getQuestItemsCount(JOURNEYMAN_DECO_BEADS) == 7 and st.getQuestItemsCount(JOURNEYMAN_GEM) == 7 :
               st.set("cond","6")
      elif cond >= 5 and st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 and st.getQuestItemsCount(PINTERS_INSTRUCTIONS) == 0 and (st.getQuestItemsCount(JOURNEYMAN_DECO_BEADS) or st.getQuestItemsCount(JOURNEYMAN_RING)) :
         htmltext = "30298-08.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 3 and npcId in DROPLIST_COND_3.keys() :
      required,item,maxquanty,chance = DROPLIST_COND_3[npcId]
      count = st.getQuestItemsCount(item)
      if st.getQuestItemsCount(required) and count < maxquanty :
         if st.getRandom(100) < chance :
            st.giveItems(item,1)
            st.set("cond","4")
            st.playSound("Itemsound.quest_middle")
   elif cond == 5 and npcId in DROPLIST_COND_5.keys():
      required,item,maxquanty,chance,drop = DROPLIST_COND_5[npcId]
      count = st.getQuestItemsCount(item)
      if st.getQuestItemsCount(required) and count < maxquanty and st.getRandom(100) < chance :
         st.giveItems(item,drop)
         if npcId in [20267, 20268, 20269, 20270, 20271] and st.getQuestItemsCount(DUNINGS_KEY) == 30 :
            st.takeItems(DUNINGS_INSTRUCTIONS,1)
         if count + drop == maxquanty :
            st.playSound("Itemsound.quest_middle")
         else :
            st.playSound("Itemsound.quest_itemget")
   elif cond == 5 and (npcId == 20079 or npcId == 20080 or npcId == 20081) :
      if st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 and st.getQuestItemsCount(PINTERS_INSTRUCTIONS) == 1 :
         if st.getQuestItemsCount(AMBER_BEAD) < 70 :
            if st.getRandom(100) < 50 and st.getPlayer().getClassId().getId() == 0x36: #and IsSpoiled() == 1 :
               st.giveItems(AMBER_BEAD,1)
            if st.getQuestItemsCount(AMBER_LUMP) == 70 and st.getQuestItemsCount(AMBER_BEAD) == 70 :
               st.playSound("Itemsound.quest_middle")
            else :
               st.playSound("Itemsound.quest_itemget")
         if st.getQuestItemsCount(AMBER_LUMP) < 70 :
            if st.getRandom(100) < 50 :
               st.giveItems(AMBER_LUMP,1)
            if st.getQuestItemsCount(AMBER_LUMP) == 70 and st.getQuestItemsCount(AMBER_BEAD) == 70 :
               st.playSound("Itemsound.quest_middle")
            else :
               st.playSound("Itemsound.quest_itemget")
   return

QUEST       = Quest(216,"216_TrialOfGuildsman","Trial Of Guildsman")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)
ABORTED     = State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30103)

CREATED.addTalkId(30103)
COMPLETED.addTalkId(30103)

STARTED.addTalkId(30103)
STARTED.addTalkId(30210)
STARTED.addTalkId(30283)
STARTED.addTalkId(30298)
STARTED.addTalkId(30688)

STARTED.addKillId(20154)
STARTED.addKillId(20155)
STARTED.addKillId(20156)
STARTED.addKillId(20168)
STARTED.addKillId(20200)
STARTED.addKillId(20201)
STARTED.addKillId(20202)
STARTED.addKillId(20223)
STARTED.addKillId(20267)
STARTED.addKillId(20268)
STARTED.addKillId(20269)
STARTED.addKillId(20270)
STARTED.addKillId(20271)
STARTED.addKillId(20079)
STARTED.addKillId(20080)
STARTED.addKillId(20081)
STARTED.addKillId(20083)

STARTED.addQuestDrop(30283,RP_JOURNEYMAN_RING,1)
STARTED.addQuestDrop(30283,ALLTRANS_INSTRUCTIONS,1)
STARTED.addQuestDrop(30283,RP_JOURNEYMAN_RING,1)
STARTED.addQuestDrop(30103,VALKONS_RECOMMEND,1)
STARTED.addQuestDrop(20223,MANDRAGORA_BERRY,1)
STARTED.addQuestDrop(20154,MANDRAGORA_BERRY,1)
STARTED.addQuestDrop(20155,MANDRAGORA_BERRY,1)
STARTED.addQuestDrop(20156,MANDRAGORA_BERRY,1)
STARTED.addQuestDrop(30283,ALLTRANS_RECOMMEND1,1)
STARTED.addQuestDrop(20267,DUNINGS_KEY,1)
STARTED.addQuestDrop(20268,DUNINGS_KEY,1)
STARTED.addQuestDrop(20271,DUNINGS_KEY,1)
STARTED.addQuestDrop(20269,DUNINGS_KEY,1)
STARTED.addQuestDrop(20270,DUNINGS_KEY,1)
STARTED.addQuestDrop(30210,NORMANS_INSTRUCTIONS,1)
STARTED.addQuestDrop(30210,NORMANS_LIST,1)
STARTED.addQuestDrop(30210,NORMANS_RECEIPT,1)
STARTED.addQuestDrop(30283,ALLTRANS_RECOMMEND2,1)
STARTED.addQuestDrop(30298,PINTERS_INSTRUCTIONS,1)
STARTED.addQuestDrop(30298,RP_AMBER_BEAD,1)
STARTED.addQuestDrop(20079,AMBER_BEAD,1)
STARTED.addQuestDrop(20080,AMBER_BEAD,1)
STARTED.addQuestDrop(20081,AMBER_BEAD,1)
STARTED.addQuestDrop(20083,GRANITE_WHETSTONE,1)
STARTED.addQuestDrop(30688,DUNINGS_INSTRUCTIONS,1)

print "importing quests: 216: Trial Of Guildsman"