# ~~~~~ Made by ValianT ~~~~~#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~#
# Need created moveTo for    #
# Ghost of von Hell mann's   #
# Page...                    #
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~#
import sys
from l2f.gameserver.model.quest        import State
from l2f.gameserver.model.quest        import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# ~~~~~~~~ npcId list: ~~~~~~~~
MysteriousWizard        = 31522
Tombstone               = 31523
GhostofvonHellmann      = 31524
GhostofvonHellmannsPage = 31525
BrokenBookshelf         = 31526
Agripel                 = 31348
Dominic                 = 31350
Benedict                = 31349
Innocentin              = 31328
# ~~~~~~~~~~~~ END ~~~~~~~~~~~~

# ~~~~~~~~ itemId list: ~~~~~~~~
CrossofEinhasad           = 7140
CrossofEinhasadNextQuest  = 7141
# ~~~~~~~~~~~~ END ~~~~~~~~~~~~~

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st):
        htmltext = event
        if event == "31522-02.htm":
            st.setState(STARTED)
            st.set("cond","1")
        elif event == "html" :
            htmltext = "31328-05.htm"
        elif event == "31328-05.htm":
            st.unset("cond")
            st.set("onlyone","1")
            st.setState(COMPLETED)
            st.takeItems(CrossofEinhasad,-1)
            if st.getQuestItemsCount(CrossofEinhasadNextQuest) == 0 :
                st.giveItems(CrossofEinhasadNextQuest,1)
            st.playSound("ItemSound.quest_finish")
            st.startQuestTimer("html",1)
            htmltext = "Congratulations! You are completed this quest!"     + \
                       " \n The Quest \"Tragedy In Von Hellmann Forest\""   + \
                       " become available.\n Show Cross of Einhasad to High"+ \
                       " Priest Tifaren."
        elif event == "31523-03.htm" :
            st.playSound("SkillSound5.horror_02")
            st.set("cond","2")
            st.getPcSpawn().addSpawn(GhostofvonHellmann,51432,-54570,-3136,120000)
        elif event == "31524-06.htm" :
            st.set("cond","3")
            st.getPcSpawn().addSpawn(GhostofvonHellmannsPage,51446,-54514,-3136,120000)
        elif event == "31526-03.htm" :
            st.playSound("ItemSound.item_drop_equip_armor_cloth")
        elif event == "31526-08.htm" :
            st.playSound("AmdSound.ed_chimes_05")
            st.set("cond","5")
        elif event == "31526-14.htm" :
            st.giveItems(CrossofEinhasad,1)
            st.set("cond","6")
        return htmltext

    def onTalk (Self,npc,st):
        htmltext = "This person inaccessible and does not want with you to talk!" + \
                   "\n Are they please returned later..."
        npcId = npc.getNpcId()
        cond = st.getInt("cond")
        onlyone = st.getInt("onlyone")
        id = st.getInt("id")

        if npcId == MysteriousWizard and onlyone == 0 :
            if cond == 0 and onlyone == 0 :
                if st.getPlayer().getLevel() >= 63 :
                    htmltext = "31522-01.htm"
                else :
                    htmltext = "31522-03.htm"
                    st.exitCurrentQuest(True)
            elif cond == 0 and onlyone == 1 :
                htmltext = "This quest have already been completed."
            elif cond == 1 :
                htmltext = "31522-05.htm"

        elif npcId == Tombstone and onlyone == 0 :
            if cond == 1 :
                htmltext = "31523-01.htm"
            elif cond == 2 :
                htmltext = "31523-04.htm"
                st.playSound("SkillSound5.horror_02")
                if st.getPcSpawn().getSpawn(GhostofvonHellmann) == None :
                    st.getPcSpawn().addSpawn(GhostofvonHellmann,51432,-54570,-3136,120000)

        elif npcId == GhostofvonHellmann and onlyone == 0 :
            if cond == 2 :
                htmltext = "31524-01.htm"
            elif cond == 3 :
                htmltext = "31524-07b.htm"
                st.set("cond","4")
                st.player.teleToLocation(52143,-51418,-3085)
            elif cond == 4 :
                htmltext = "31524-07c.htm"
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
# Here need create moveTo for Ghost of von                           #
# Hellmann's Page from # 51392,-54529,-3140 > > > 52143,-51418,-3085 #
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#

        elif npcId == GhostofvonHellmannsPage and onlyone == 0 :
            if cond == 3 :
                htmltext = "31525-01.htm"
            elif cond == 4 and id == 1 :
                htmltext = "31525-02.htm"

        elif npcId == BrokenBookshelf and onlyone == 0 :
            if cond == 4 :
                st.set("cond","5")
                htmltext = "31526-01.htm"
            elif cond == 5 :
                if id == 0 :
                    htmltext = "31526-10.htm"
                    st.playSound("AmdSound.ed_chimes_05")
                elif id == 1 :
                    htmltext = "31526-11.htm"
            elif cond == 6 :
                htmltext = "31526-15.htm"

        elif npcId == Agripel and onlyone == 0 and st.getQuestItemsCount(CrossofEinhasad) >= 1 :
            if cond == 6 :
                n = st.getRandom(3)
                htmltext = "31348-0" + str(n) + ".htm"
                if id > 1 and id < 4 :
                    id = id + 1
                elif id >= 5 :
                    htmltext = "31348-02.htm"
                    st.unset("id")
                    st.set("cond","7")
            elif cond == 7 :
                htmltext = "31348-03.htm"

        elif npcId == Dominic and st.getQuestItemsCount(CrossofEinhasad) >= 1 :
            if cond == 6 :
                n = st.getRandom(3)
                htmltext = "31350-0" + str(n) + ".htm"
                if id != 2 and id not in (3,4) and id < 4 :
                    id = id + 2
                elif id >= 4 :
                    htmltext = "31350-02.htm"
                    st.unset("id")
                    st.set("cond","7")
            elif cond == 7 :
                htmltext = "31350-03.htm"

        elif npcId == Benedict and st.getQuestItemsCount(CrossofEinhasad) >= 1 :
            if cond == 6 :
                n = st.getRandom(3)
                htmltext = "31349-0" + str(n) + ".htm"
                st.set("cond","7")
                if id != 3 and id < 5 :
                    id = id + 3
                elif id > 3 :
                    htmltext = "31349-02.htm"
                    st.unset("id")
                    st.set("cond","7")
            elif cond == 7 :
                htmltext = "31349-03.htm"

        elif npcId == Innocentin:
            if cond == 7 and onlyone == 0:
                if st.getQuestItemsCount(CrossofEinhasad) != 0:
                    htmltext = "31328-01.htm"
            elif cond == 0 and onlyone == 1:
                htmltext = "31328-06.htm"
        return htmltext

QUEST     = Quest(21,"21_HiddenTruth","Hidden Truth")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(MysteriousWizard)

CREATED.addTalkId(MysteriousWizard)
STARTED.addTalkId(MysteriousWizard)
STARTED.addTalkId(Tombstone)
STARTED.addTalkId(GhostofvonHellmann)
STARTED.addTalkId(GhostofvonHellmannsPage)
STARTED.addTalkId(BrokenBookshelf)
STARTED.addTalkId(Agripel)
STARTED.addTalkId(Dominic)
STARTED.addTalkId(Benedict)
STARTED.addTalkId(Innocentin)

COMPLETED.addTalkId(Innocentin)
COMPLETED.addTalkId(MysteriousWizard)

print "importing quests: 21: Hidden Truth"
