# Made by Drac (L2j Fortress team)

import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

CARADINES_LETTER_2_PART = 7678
RING_OF_GODDESS_WATERBINDER = 7591
NECKLACE_OF_GODDESS_EVERGREEN = 7592
STAFF_OF_GODDESS_RAIN_SONG = 7593
CARADINES_LETTER = 7679
RELIC_BOX = 7594

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31740-2.htm" :
       st.set("cond","1")
       st.takeItems(CARADINES_LETTER_2_PART,1)
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "31741-2.htm" :
       st.set("cond","2")
       st.playSound("ItemSound.quest_middle")
    elif event == "31741-4.htm" :
       st.set("cond","4")
       st.playSound("ItemSound.quest_middle")
    elif event == "31741-6.htm" :
       st.takeItems(RING_OF_GODDESS_WATERBINDER,1)
       st.takeItems(NECKLACE_OF_GODDESS_EVERGREEN,1)
       st.takeItems(STAFF_OF_GODDESS_RAIN_SONG,1)
       st.set("cond","6")
       st.giveItems(RELIC_BOX,1)
       st.playSound("ItemSound.quest_middle")
    elif event == "30721-2.htm" :
       st.takeItems(RELIC_BOX,1)
       st.giveItems(CARADINES_LETTER,1)
       st.addExpAndSp(719843,0)
       st.unset("cond")
       st.setState(COMPLETED)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == 31740 :
      if cond == 0 :
         if st.getQuestItemsCount(CARADINES_LETTER_2_PART) >= 1 and st.getPlayer().isSubClassActive() and st.getPlayer().getLevel() >= 65 :
            if id == COMPLETED :
               htmltext = "<html><head><body>You have already complete this quest.</body></html>"
            else :
               htmltext = "31740-1.htm"
         else :
            htmltext = "31740-0.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31740-2r.htm"
   elif npcId == 31741 and st.getPlayer().isSubClassActive() :
      if cond == 1 :
         htmltext = "31741-1.htm"
      elif (cond == 2 or cond == 3) and (st.getQuestItemsCount(RING_OF_GODDESS_WATERBINDER) < 1 or st.getQuestItemsCount(NECKLACE_OF_GODDESS_EVERGREEN) < 1) :
         htmltext = "8743-2r.htm"
      elif cond == 3 and st.getQuestItemsCount(RING_OF_GODDESS_WATERBINDER) == 1 and st.getQuestItemsCount(NECKLACE_OF_GODDESS_EVERGREEN) == 1 :
         htmltext = "31741-3.htm"
      elif cond == 4 :
         htmltext = "31741-4.htm"
      elif (cond == 4 or cond == 5) and st.getQuestItemsCount(STAFF_OF_GODDESS_RAIN_SONG) < 1 :
         htmltext = "31741-4r.htm"
      elif cond == 5 and st.getQuestItemsCount(RING_OF_GODDESS_WATERBINDER) == 1 and st.getQuestItemsCount(NECKLACE_OF_GODDESS_EVERGREEN) == 1 and st.getQuestItemsCount(STAFF_OF_GODDESS_RAIN_SONG) == 1 :
         htmltext = "31741-5.htm"
      elif cond == 6 :
         htmltext = "31741-6r.htm"
   elif npcId == 30721 and st.getPlayer().isSubClassActive() :
      if cond == 6 and st.getQuestItemsCount(RELIC_BOX) == 1 :
         htmltext = "30721-1.htm"

   return htmltext

 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    cond = int(st.get("cond"))
    if cond == 2 and st.getPlayer().isSubClassActive() :
       if st.getRandom(100) < 15 :
          if npcId == 21541 and st.getQuestItemsCount(RING_OF_GODDESS_WATERBINDER) == 0 :
             st.giveItems(RING_OF_GODDESS_WATERBINDER,1)
             if st.getQuestItemsCount(RING_OF_GODDESS_WATERBINDER) == 1 and st.getQuestItemsCount(NECKLACE_OF_GODDESS_EVERGREEN) == 1 :
                st.set("cond","3")
             st.playSound("ItemSound.quest_itemget")
          elif npcId == 21544 and st.getQuestItemsCount(NECKLACE_OF_GODDESS_EVERGREEN) == 0 :
             st.giveItems(NECKLACE_OF_GODDESS_EVERGREEN,1)
             if st.getQuestItemsCount(RING_OF_GODDESS_WATERBINDER) == 1 and st.getQuestItemsCount(NECKLACE_OF_GODDESS_EVERGREEN) == 1 :
                st.set("cond","3")
             st.playSound("ItemSound.quest_itemget")
    elif cond == 4 and st.getPlayer().isSubClassActive() :
       if npcId == 25325 and st.getQuestItemsCount(STAFF_OF_GODDESS_RAIN_SONG) == 0 :
          st.giveItems(STAFF_OF_GODDESS_RAIN_SONG,1)
          st.set("cond","5")
          st.playSound("ItemSound.quest_itemget")

    return

QUEST       = Quest(246,"246_PossessorOfaPreciousSoul3","Possessor of a Precious Soul - 3",True)
CREATED     = State('Start', QUEST)
STARTING    = State('Starting', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31740)

CREATED.addTalkId(31740)
STARTING.addTalkId(31740)
STARTED.addTalkId(31740)

STARTED.addTalkId(31741)
STARTED.addTalkId(30721)

STARTED.addKillId(21541)
STARTED.addKillId(21544)
STARTED.addKillId(25325)

STARTED.addQuestDrop(21541,RING_OF_GODDESS_WATERBINDER,1)
STARTED.addQuestDrop(21544,NECKLACE_OF_GODDESS_EVERGREEN,1)
STARTED.addQuestDrop(25325,STAFF_OF_GODDESS_RAIN_SONG,1)
STARTED.addQuestDrop(30721,CARADINES_LETTER,1)

print "importing quests: 246: Possessor of a Precious Soul - 3"