import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
CARADINE = 31740
LADY_OF_LAKE = 31745

#QUEST ITEM
CARADINE_LETTER_LAST = 7679
NOBLESS_TIARA = 7694

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
   htmltext = event
   cond = st.getInt("cond") 
   if cond == 0 :
     if event == "31740-3.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
   elif cond == 1 :
     if event == "31740-4.htm" :
       return htmltext
     elif event == "31740-5.htm" :
       st.set("cond","2")
       st.takeItems(CARADINE_LETTER_LAST,1)
       st.getPlayer().teleToLocation(143230,44030,-3030)
       return htmltext
   elif cond == 2 :
     if event == "31740-6.htm" :
       return htmltext
     elif event == "31740-5.htm" :
       st.getPlayer().teleToLocation(143230,44030,-3030)
       return htmltext
     elif event == "31745-2.htm" :
       return htmltext
     elif event == "31745-3.htm" :
       return htmltext
     elif event == "31745-4.htm" :
       return htmltext
     elif event == "31745-5.htm" :
       if st.getPlayer().getLevel() >= 75 :
         st.getPlayer().setNoble(True)
         st.giveItems(NOBLESS_TIARA,1)
         st.playSound("ItemSound.quest_finish")
         st.setState(COMPLETED)
         st.unset("cond")
       else:
         htmltext = "31745-6.htm"
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == CARADINE and st.getPlayer().isSubClassActive() :
     if id == COMPLETED :
       htmltext = "<html><head><body>This quest have already been completed.</body></html>"
     elif id == CREATED and st.getQuestItemsCount(CARADINE_LETTER_LAST) == 1 :
       st.set("cond","0")
       if st.getPlayer().getLevel() < 75 : 
         htmltext = "31740-2.htm"
         st.exitCurrentQuest(True)
       elif st.getPlayer().getLevel() >= 75 :
         htmltext = "31740-1.htm"
     elif cond == 1 : htmltext = "31740-3.htm"
     elif cond == 2 : htmltext = "31740-6.htm"
   elif npcId == LADY_OF_LAKE and cond == 2 and st.getPlayer().isSubClassActive() :
     if st.getPlayer().getLevel() >= 75 :
       htmltext = "31745-1.htm"
     else :
       htmltext = "31745-6.htm"
   return htmltext

QUEST       = Quest(247,"247_PossessorOfaPreciousSoul4","Possessor of a Precious Soul - 4",True)
CREATED     = State('Start', QUEST)
STARTING    = State('Starting', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(CARADINE)

CREATED.addTalkId(CARADINE)
STARTING.addTalkId(CARADINE)
STARTED.addTalkId(CARADINE)

STARTED.addTalkId(LADY_OF_LAKE)

print "importing quests: 246: Possessor of a Precious Soul - 4"