import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

GLUDIO_LORDS_MARK = 1084
ORC_AMULET = 752
ORC_NECKLACE = 1085
WEREWOLF_FANG = 1086
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30039-03.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
       st.takeItems(GLUDIO_LORDS_MARK,-1)
       st.giveItems(GLUDIO_LORDS_MARK,1)
    elif event == "257_2" :
       htmltext = "30039-05.htm"
       st.takeItems(GLUDIO_LORDS_MARK,-1)
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
    elif event == "257_3" :
       htmltext = "30039-06.htm"
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30039 :
      if cond == 0 :
         if st.getPlayer().getLevel() >= 6 :
            htmltext = "30039-02.htm"
            return htmltext
         else:
            htmltext = "30039-01.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and (st.getQuestItemsCount(ORC_AMULET)<1) and (st.getQuestItemsCount(ORC_NECKLACE)<1) and (st.getQuestItemsCount(WEREWOLF_FANG)<1) :
         htmltext = "30039-04.htm"
      elif cond == 1 and ((st.getQuestItemsCount(ORC_AMULET)>0) or (st.getQuestItemsCount(ORC_NECKLACE)>0) or (st.getQuestItemsCount(WEREWOLF_FANG)>0)) :
         st.giveItems(ADENA,12*st.getQuestItemsCount(ORC_AMULET)+20*st.getQuestItemsCount(ORC_NECKLACE)+25*st.getQuestItemsCount(WEREWOLF_FANG))
         qs = st.getPlayer().getQuestState("255_C4Tutorial")
         if qs != None :
             Ex = qs.getInt("Ex")
             if Ex != 10 :
               st.showQuestionMark(26)
               qs.set("Ex","10")
               if st.getPlayer().getClassId().isMage() :
                  st.playTutorialVoice("tutorial_voice_027")
                  st.giveItems(5790,3000)
               else :
                  st.playTutorialVoice("tutorial_voice_026")
                  st.giveItems(5789,6000)
         st.takeItems(ORC_AMULET,-1)
         st.takeItems(ORC_NECKLACE,-1)
         st.takeItems(WEREWOLF_FANG,-1)
         htmltext = "30039-07.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if st.getQuestItemsCount(GLUDIO_LORDS_MARK) and st.getInt("cond") > 0 :
      if st.getRandom(10) < 5 :
         if npcId in [20130,20131,20006] :
             st.giveItems(ORC_AMULET,1)
         elif npcId in [20093,20096,20098] :
            st.giveItems(ORC_NECKLACE,1)
         elif npcId == 20132 :
            st.giveItems(WEREWOLF_FANG,1)
         st.playSound("ItemSound.quest_itemget")
      elif npcId == 20343 and st.getRandom(10) < 4 :
         st.giveItems(WEREWOLF_FANG,1)
         st.playSound("ItemSound.quest_itemget")
      elif npcId == 20342 and st.getRandom(10) < 2 :
         st.giveItems(WEREWOLF_FANG,1)
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(257,"257_GuardIsBusy","Guard Is Busy")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30039)

CREATED.addTalkId(30039)
STARTED.addTalkId(30039)
COMPLETED.addTalkId(30039)

STARTED.addKillId(20130)
STARTED.addKillId(20131)
STARTED.addKillId(20132)
STARTED.addKillId(20342)
STARTED.addKillId(20343)
STARTED.addKillId(20006)
STARTED.addKillId(20093)
STARTED.addKillId(20096)
STARTED.addKillId(20098)

STARTED.addQuestDrop(20130,ORC_AMULET,1)
STARTED.addQuestDrop(20131,ORC_AMULET,1)
STARTED.addQuestDrop(20006,ORC_AMULET,1)
STARTED.addQuestDrop(20093,ORC_NECKLACE,1)
STARTED.addQuestDrop(20096,ORC_NECKLACE,1)
STARTED.addQuestDrop(20098,ORC_NECKLACE,1)
STARTED.addQuestDrop(20132,WEREWOLF_FANG,1)
STARTED.addQuestDrop(20343,WEREWOLF_FANG,1)
STARTED.addQuestDrop(20342,WEREWOLF_FANG,1)
STARTED.addQuestDrop(30039,GLUDIO_LORDS_MARK,1)

print "importing quests: 257: Guard Is Busy"
