import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ORC_AMULET = 1114
ORC_NECKLACE = 1115
ADENA_ID = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30221-03.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "30221-06.htm" :
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
    return htmltext


 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30221 :
      if cond == 0 :
         if st.getPlayer().getLevel() >= 6 and st.getPlayer().getRace().ordinal() == 1 :
            htmltext = "30221-02.htm"
            return htmltext
         elif st.getPlayer().getRace().ordinal() != 1 :
            htmltext = "30221-00.htm"
            st.exitCurrentQuest(True)
         elif st.getPlayer().getLevel() < 6 :
            htmltext = "30221-01.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getQuestItemsCount(ORC_AMULET) == 0 and st.getQuestItemsCount(ORC_NECKLACE) == 0 :
         htmltext = "30221-04.htm"
      elif cond == 1 and (st.getQuestItemsCount(ORC_AMULET) > 0 or st.getQuestItemsCount(ORC_NECKLACE) > 0) :
         htmltext = "30221-05.htm"
         adenaPay = 0
         if st.getQuestItemsCount(ORC_AMULET) >= 40 :
            adenaPay += st.getQuestItemsCount(ORC_AMULET)*14
         else :
            adenaPay += st.getQuestItemsCount(ORC_AMULET)*12
         if st.getQuestItemsCount(ORC_NECKLACE) >= 40 :
            adenaPay += st.getQuestItemsCount(ORC_NECKLACE)*40
         else :
            adenaPay += st.getQuestItemsCount(ORC_NECKLACE)*30
         st.giveItems(ADENA_ID,adenaPay)
         st.takeItems(ORC_AMULET,-1)
         st.takeItems(ORC_NECKLACE,-1)
         qs = st.getPlayer().getQuestState("255_C4Tutorial")
         if qs != None :
            if Ex != 10 :
               qs.set("Ex","10")
               st.showQuestionMark(26)
               if st.getPlayer().getClassId().isMage() :
                  st.playTutorialVoice("tutorial_voice_027")
                  st.giveItems(5790,3000)
               else :
                  st.playTutorialVoice("tutorial_voice_026")
                  st.giveItems(5789,6000)
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if st.getInt("cond") == 1 and st.getRandom(10) > 4 :
      if npcId == 20468 or npcId == 20469 or npcId == 20470 :
         st.giveItems(ORC_AMULET,1)
         st.playSound("ItemSound.quest_itemget")
      elif npcId == 20471 or npcId == 20472 or npcId == 20473 :
         st.giveItems(ORC_NECKLACE,1)
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(260,"260_HuntTheOrcs","Hunt the Orcs")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30221)

CREATED.addTalkId(30221)
STARTED.addTalkId(30221)
COMPLETED.addTalkId(30221)

STARTED.addKillId(20468)
STARTED.addKillId(20469)
STARTED.addKillId(20470)
STARTED.addKillId(20471)
STARTED.addKillId(20472)
STARTED.addKillId(20473)

STARTED.addQuestDrop(20468,ORC_AMULET,1)
STARTED.addQuestDrop(20469,ORC_AMULET,1)
STARTED.addQuestDrop(20470,ORC_AMULET,1)
STARTED.addQuestDrop(20472,ORC_NECKLACE,1)
STARTED.addQuestDrop(20473,ORC_NECKLACE,1)
STARTED.addQuestDrop(20471,ORC_NECKLACE,1)

print "importing quests: 260: Hunt the Orcs"
