import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

GIANT_SPIDER_LEG = 1087
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30222-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() >= 15 :
         htmltext = "30222-02.htm"
         return htmltext
      else:
         htmltext = "30222-01.htm"
         st.exitCurrentQuest(True)
   elif cond == 1 or st.getQuestItemsCount(GIANT_SPIDER_LEG) < 8 :
      htmltext = "30222-04.htm"
   elif cond == 2 and st.getQuestItemsCount(GIANT_SPIDER_LEG) >= 8 :
      st.giveItems(ADENA,1000)
      st.addExpAndSp(2000,0)
      st.takeItems(GIANT_SPIDER_LEG,-1)
      htmltext = "30222-05.htm"
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if (npcId == 20460 or npcId == 20308 or npcId == 20466) and st.getInt("cond") == 1 and st.getQuestItemsCount(GIANT_SPIDER_LEG) < 8 :
      st.giveItems(GIANT_SPIDER_LEG,1)
      if st.getQuestItemsCount(GIANT_SPIDER_LEG) == 8 :
         st.playSound("ItemSound.quest_middle")
         st.set("cond","2")
      else:
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(261,"261_CollectorsDream","Collector's Dream")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30222)

CREATED.addTalkId(30222)
STARTED.addTalkId(30222)
COMPLETED.addTalkId(30222)

STARTED.addKillId(20308)
STARTED.addKillId(20460)
STARTED.addKillId(20466)

STARTED.addQuestDrop(20460,GIANT_SPIDER_LEG,1)
STARTED.addQuestDrop(20308,GIANT_SPIDER_LEG,1)
STARTED.addQuestDrop(20466,GIANT_SPIDER_LEG,1)
STARTED.addQuestDrop(30222,ADENA,1)

print "importing quests: 261: Collector's Dream"