import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
VOLODOS = 30137

#MOB
GREEN_FUNGUS = 20007
BLOOD_FUNGUS = 20400

FUNGUS_SAC = 707
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30137-03.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() >= 8 :
         htmltext = "30137-02.htm"
         return htmltext
      else:
         htmltext = "30137-01.htm"
         st.exitCurrentQuest(True)
   elif cond == 1 and st.getQuestItemsCount(FUNGUS_SAC) < 10 :
      htmltext = "30137-04.htm"
   elif cond == 2 and st.getQuestItemsCount(FUNGUS_SAC) >= 10 :
      st.giveItems(ADENA,3000)
      st.takeItems(FUNGUS_SAC,-1)
      st.set("cond","0")
      st.playSound("ItemSound.quest_finish")
      htmltext = "30137-05.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   random = st.getRandom(10)
   if st.getInt("cond") == 1 and st.getQuestItemsCount(FUNGUS_SAC) < 10 :
      if (npcId == GREEN_FUNGUS and random < 3) or (npcId == BLOOD_FUNGUS and random < 4) :
         st.giveItems(FUNGUS_SAC,1)
         if st.getQuestItemsCount(FUNGUS_SAC) == 10 :
            st.set("cond","2")
            st.playSound("ItemSound.quest_middle")
         else:
            st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(262,"262_TradewiththeIvoryTower","Trade with the Ivory Tower",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(VOLODOS)

CREATED.addTalkId(VOLODOS)
STARTED.addTalkId(VOLODOS)

STARTED.addKillId(BLOOD_FUNGUS)
STARTED.addKillId(GREEN_FUNGUS)

STARTED.addQuestDrop(GREEN_FUNGUS,FUNGUS_SAC,1)
STARTED.addQuestDrop(BLOOD_FUNGUS,FUNGUS_SAC,1)

print "importing quests: 262: Trade with the Ivory Tower"
