import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
KAYLEEN = 30346

# MOBS
BALOR_ORC_ARCHER = 20385
BALOR_ORC_FIGHTER = 20386
BALOR_ORC_FIGHTER_LEADER = 20387
BALOR_ORC_LIEUTENANT = 20388

ORC_AMULET = 1116
ORC_NECKLACE = 1117
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30346-03.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "30346-06.htm" :
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() >= 8 and st.getPlayer().getRace().ordinal() == 2 :
         htmltext = "30346-02.htm"
         return htmltext
      elif st.getPlayer().getRace().ordinal() != 2 :
         htmltext = "30346-00.htm"
         st.exitCurrentQuest(True)
      elif st.getPlayer().getLevel() < 8 :
         htmltext = "30346-01.htm"
         st.exitCurrentQuest(True)
   elif cond == 1 :
      if st.getQuestItemsCount(ORC_AMULET) == 0 and st.getQuestItemsCount(ORC_NECKLACE) == 0 :
         htmltext = "30346-04.htm"
      elif (st.getQuestItemsCount(ORC_AMULET) + st.getQuestItemsCount(ORC_NECKLACE)) >= 10 :
         htmltext = "30346-05.htm"
         st.giveItems(ADENA,st.getQuestItemsCount(ORC_AMULET)*20+st.getQuestItemsCount(ORC_NECKLACE)*30+1100)
         st.takeItems(ORC_AMULET,-1)
         st.takeItems(ORC_NECKLACE,-1)
      else :
         htmltext = "30346-05.htm"
         st.giveItems(ADENA,st.getQuestItemsCount(ORC_AMULET)*20+st.getQuestItemsCount(ORC_NECKLACE)*30)
         st.takeItems(ORC_AMULET,-1)
         st.takeItems(ORC_NECKLACE,-1)
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if st.getInt("cond") == 1 and st.getRandom(10) > 4 :
      if npcId == BALOR_ORC_ARCHER :
         st.giveItems(ORC_AMULET,1)
      elif npcId == BALOR_ORC_FIGHTER or npcId == BALOR_ORC_FIGHTER_LEADER or npcId == BALOR_ORC_LIEUTENANT :
         st.giveItems(ORC_NECKLACE,1)
      st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(263,"263_OrcSubjugation","Orc Subjugation")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(KAYLEEN)

CREATED.addTalkId(KAYLEEN)
STARTED.addTalkId(KAYLEEN)
COMPLETED.addTalkId(KAYLEEN)

STARTED.addKillId(BALOR_ORC_ARCHER)
STARTED.addKillId(BALOR_ORC_FIGHTER)
STARTED.addKillId(BALOR_ORC_FIGHTER_LEADER)
STARTED.addKillId(BALOR_ORC_LIEUTENANT)

STARTED.addQuestDrop(BALOR_ORC_ARCHER,ORC_AMULET,1)
STARTED.addQuestDrop(BALOR_ORC_FIGHTER_LEADER,ORC_NECKLACE,1)
STARTED.addQuestDrop(BALOR_ORC_LIEUTENANT,ORC_NECKLACE,1)
STARTED.addQuestDrop(BALOR_ORC_FIGHTER,ORC_NECKLACE,1)

print "importing quests: 263: Orc Subjugation"