import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
KRISTIN = 30357

# MOBS
IMP = 20004
IMP_ELDER = 20005

IMP_SHACKLES = 1368
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30357-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "30357-06.htm" :
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   if st.getInt("cond") == 0 :
     if st.getPlayer().getRace().ordinal() != 2 :
       htmltext = "30357-00.htm"
       st.exitCurrentQuest(True)
     else :
       if st.getPlayer().getLevel() < 6 :
          htmltext = "30357-01.htm"
          st.exitCurrentQuest(True)
       else:
          htmltext = "30357-02.htm"
   else :
     count = st.getQuestItemsCount(IMP_SHACKLES)
     if count :
       if count >= 10:
          st.giveItems(ADENA,13*count+500)
       else :
          st.giveItems(ADENA,13*count)
       st.takeItems(IMP_SHACKLES,-1)
       htmltext = "30357-05.htm"
       qs = st.getPlayer().getQuestState("255_C4Tutorial")
       if qs != None :
          Ex = qs.getInt("Ex")
          if Ex != 10 :
             st.showQuestionMark(26)
             qs.set("Ex","10")
             if st.getPlayer().getClassId().isMage() :
                st.playTutorialVoice("tutorial_voice_027")
                st.giveItems(5790,3000)
             else :
                st.giveItems(5789,6000)
                st.playTutorialVoice("tutorial_voice_026")
     else:
       htmltext = "30357-04.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if st.getInt("cond") == 1 and st.getRandom(10) < (5+(npc.getNpcId()-20003)) :
      if npcId == IMP or npcId == IMP_ELDER :
         st.giveItems(IMP_SHACKLES,1)
      st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(265,"265_ChainsOfSlavery","Chains Of Slavery")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(KRISTIN)

CREATED.addTalkId(KRISTIN)
STARTED.addTalkId(KRISTIN)
COMPLETED.addTalkId(KRISTIN)

STARTED.addKillId(IMP)
STARTED.addKillId(IMP_ELDER)

STARTED.addQuestDrop(IMP,IMP_SHACKLES,1)
STARTED.addQuestDrop(IMP_ELDER,IMP_SHACKLES,1)

print "importing quests: 265: Chains Of Slavery"
