# Last fix 16/04/07 by ValianT
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

StartNpc = 30534

BatFang = 1491
RingOfRaccoon = 1508
Adena = 57

Monster = [20370,20480]

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st) :
        htmltext = event
        if event == "30534-03.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        return htmltext

    def onTalk (Self,npc,st):
        npcId = npc.getNpcId()
        htmltext = "<html><head><body>I have nothing to say you</body></html>"
        id = st.getState()
        id2 = st.getStateId()
        if id in [CREATED,COMPLETED] or id2 == "Aborted" :
            if st.getPlayer().getRace().ordinal() != 4 :
                htmltext = "30534-00.htm"
                st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 10 :
                htmltext = "30534-02.htm"
                return htmltext
            else:
                htmltext = "30534-01.htm"
                st.exitCurrentQuest(True)
        else :
            if st.getQuestItemsCount(BatFang) < 100 :
                htmltext = "30534-04.htm"
            else :
                if st.getQuestItemsCount(RingOfRaccoon) < 1 :
                    htmltext = "30534-05.htm"
                    st.giveItems(RingOfRaccoon,1)
                else :
                    htmltext = "30534-06.htm"
                    st.giveItems(Adena,2400)
                st.takeItems(BatFang,-1)
                st.unset("cond")
                st.addExpAndSp(0,60)
                st.setState(COMPLETED)
                st.playSound("ItemSound.quest_finish")
        return htmltext

    def onKill (self,npc,st):
        npcId = npc.getNpcId()
        if npcId == Monster[1] :
            BatFangCount = st.getQuestItemsCount(BatFang)
            if st.getInt("cond") and BatFangCount < 100 :
                n = st.getRandom(10)
                if n > 5 :
                    if BatFangCount == 99 :
                        st.giveItems(BatFang,1)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,1)
                        st.playSound("ItemSound.quest_itemget")
                elif n > 2 :
                    if BatFangCount >= 98 :
                        st.giveItems(BatFang,100-BatFangCount)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,2)
                        st.playSound("ItemSound.quest_itemget")
                else:
                    if BatFangCount >= 97 :
                        st.giveItems(BatFang,100-BatFangCount)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,3)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == Monster[0] :
            BatFangCount = st.getQuestItemsCount(BatFang)
            if st.getInt("cond") and BatFangCount < 100 :
                n = st.getRandom(10)
                if n > 6 :
                    if BatFangCount == 99 :
                        st.giveItems(BatFang,1)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,1)
                        st.playSound("ItemSound.quest_itemget")
                elif n > 3 :
                    if BatFangCount >= 98 :
                        st.giveItems(BatFang,100-BatFangCount)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,2)
                        st.playSound("ItemSound.quest_itemget")
                elif n > 1 :
                    if BatFangCount >= 97 :
                        st.giveItems(BatFang,100-BatFangCount)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,3)
                        st.playSound("ItemSound.quest_itemget")
                else:
                    if BatFangCount >= 96 :
                        st.giveItems(BatFang,100-BatFangCount)
                        st.playSound("ItemSound.quest_middle")
                    else:
                        st.giveItems(BatFang,4)
                        st.playSound("ItemSound.quest_itemget")
        return

QUEST = Quest(294,"294_CovertBusiness","Covert Business")
CREATED = State('Start', QUEST)
STARTED = State('Started', QUEST)
ABORTED = State('Aborted', QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(StartNpc)

CREATED.addTalkId(StartNpc)
STARTED.addTalkId(StartNpc)
ABORTED.addTalkId(StartNpc)
COMPLETED.addTalkId(StartNpc)

for npcId in Monster :
    STARTED.addKillId(npcId)
    STARTED.addQuestDrop(npcId,BatFang,1)

print "importing quests: 294: Covert Business"
