import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

FLOATING_STONE = 1492
RING_OF_FIREFLY = 1509
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30536-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   if id == CREATED :
      st.set("cond","0")
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() >= 11 :
         htmltext = "30536-02.htm"
         return htmltext
      else:
         htmltext = "30536-01.htm"
         st.exitCurrentQuest(True)
   elif cond == 1 or st.getQuestItemsCount(FLOATING_STONE) < 50 :
      htmltext = "30536-04.htm"
   elif cond == 2 and st.getQuestItemsCount(FLOATING_STONE) == 50 :
      if st.getQuestItemsCount(RING_OF_FIREFLY) < 1 :
         htmltext = "30536-05.htm"
         st.giveItems(RING_OF_FIREFLY,1)
      elif st.getQuestItemsCount(RING_OF_FIREFLY) >= 1 :
         htmltext = "30536-06.htm"
         st.giveItems(ADENA,2400)
      st.addExpAndSp(0,500)
      st.takeItems(FLOATING_STONE,-1)
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if st.getInt("cond") == 1 and st.getQuestItemsCount(FLOATING_STONE) < 50 :
      if st.getRandom(100) > 25 :
         st.giveItems(FLOATING_STONE,1)
         if st.getQuestItemsCount(FLOATING_STONE) == 50 :
            st.playSound("ItemSound.quest_middle")
            st.set("cond","2")
         else:
            st.playSound("ItemSound.quest_itemget")
      else:
         if st.getQuestItemsCount(FLOATING_STONE) >= 48 :
            st.giveItems(FLOATING_STONE,50-st.getQuestItemsCount(FLOATING_STONE))
            st.playSound("ItemSound.quest_middle")
            st.set("cond","2")
         else:
            st.giveItems(FLOATING_STONE,2)
            st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(295,"295_DreamsoftheSkies","Dreams of the Skies")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30536)

CREATED.addTalkId(30536)
STARTED.addTalkId(30536)
COMPLETED.addTalkId(30536)

STARTED.addKillId(20153)

STARTED.addQuestDrop(20153,FLOATING_STONE,1)
STARTED.addQuestDrop(30536,RING_OF_FIREFLY,1)
STARTED.addQuestDrop(30536,ADENA,1)

print "importing quests: 295: Dreams of the Skies"