import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

TARANTULA_SPIDER_SILK = 1493
TARANTULA_SPINNERETTE = 1494
RING_OF_RACCOON = 1508
RING_OF_FIREFLY = 1509
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30519-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "quit" :
       htmltext = "30519-06.htm"
       st.takeItems(TARANTULA_SPINNERETTE,-1)
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
    elif event == "exchange" :
       if st.getQuestItemsCount(TARANTULA_SPINNERETTE) >= 1 :
          htmltext = "30548-03.htm"
          st.giveItems(TARANTULA_SPIDER_SILK,15+st.getRandom(9))
          st.takeItems(TARANTULA_SPINNERETTE,-1)
       else:
          htmltext = "30548-02.htm"
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   if id == CREATED :
      st.set("cond","0")
   cond = st.getInt("cond")
   if npcId == 30519 :
      if cond == 0 :
         if st.getPlayer().getLevel() >= 15 :
            if st.getQuestItemsCount(RING_OF_RACCOON) > 1 or st.getQuestItemsCount(RING_OF_FIREFLY) > 1 :
               htmltext = "30519-02.htm"
            else:
               htmltext = "30519-08.htm"
               return htmltext
         else:
            htmltext = "30519-01.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getQuestItemsCount(TARANTULA_SPIDER_SILK) < 1 :
         htmltext = "30519-04.htm"
      elif cond == 1 and st.getQuestItemsCount(TARANTULA_SPIDER_SILK) >= 1 :
         htmltext = "30519-05.htm"
         st.giveItems(ADENA,st.getQuestItemsCount(TARANTULA_SPIDER_SILK)*23)
         st.takeItems(TARANTULA_SPIDER_SILK,-1)
   elif npcId == 30548 and cond == 1 :
      htmltext = "30548-01.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if (npcId == 20394 or npcId == 20403 or npcId == 20508) and st.getInt("cond") == 1 :
      n = st.getRandom(100)
      if n > 95 :
         st.giveItems(TARANTULA_SPINNERETTE,1)
         st.playSound("ItemSound.quest_itemget")
      elif n > 45 :
         st.giveItems(TARANTULA_SPIDER_SILK,1)
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(296,"296_SilkOfTarantula","Silk Of Tarantula")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30519)

CREATED.addTalkId(30519)
STARTED.addTalkId(30519)
COMPLETED.addTalkId(30519)
STARTED.addTalkId(30548)

STARTED.addKillId(20394)
STARTED.addKillId(20403)
STARTED.addKillId(20508)

STARTED.addQuestDrop(20394,TARANTULA_SPIDER_SILK,1)
STARTED.addQuestDrop(20403,TARANTULA_SPIDER_SILK,1)
STARTED.addQuestDrop(20508,TARANTULA_SPIDER_SILK,1)
STARTED.addQuestDrop(20394,TARANTULA_SPINNERETTE,1)
STARTED.addQuestDrop(20403,TARANTULA_SPINNERETTE,1)
STARTED.addQuestDrop(20508,TARANTULA_SPINNERETTE,1)

STARTED.addQuestDrop(30548,TARANTULA_SPIDER_SILK,1)
STARTED.addQuestDrop(30519,ADENA,1)

print "importing quests: 296: Silk Of Tarantula"