import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

REPORT = 7182
GEM = [7183,7184]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30333-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.giveItems(REPORT,1)
      st.playSound("ItemSound.quest_accept")
    elif event == "30344-02.htm" :
      st.takeItems(REPORT,-1)
      st.set("cond","2")
      st.playSound("ItemSound.quest_middle")
    elif event == "30344-04.htm" :
      st.takeItems(GEM[0],-1)
      st.takeItems(GEM[1],-1)
      st.addExpAndSp(0,42000)
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
    return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   if id == CREATED :
      st.set("cond","0")
   cond = st.getInt("cond")
   if npcId == 30333 :
      if cond == 0 :
         if st.getPlayer().getLevel() < 25 :
            htmltext = "30333-00.htm"
            st.exitCurrentQuest(True)
         else :
            htmltext = "30333-01.htm"
      elif cond == 1 :
         htmltext = "30333-02r.htm"
   elif npcId == 30344 :
      if cond == 0 :
         htmltext = "30344-0.htm"
      elif cond == 1 :
         htmltext = "30344-01.htm"
      elif cond == 2 and st.getQuestItemsCount(GEM[0]) <= 49 or st.getQuestItemsCount(GEM[1]) <= 49 :
         htmltext = "30344-02r.htm"
      elif cond == 3 and st.getQuestItemsCount(GEM[0]) == 50 and st.getQuestItemsCount(GEM[1]) == 50 :
         htmltext = "30344-03.htm"

   return htmltext

 def onKill (self,npc,st):
 
   npcId = npc.getNpcId()
   rand = st.getRandom(10)
   if st.getInt("cond") == 2 :
      if npcId in [ 20922 , 20923 , 20924 ] and st.getQuestItemsCount(GEM[0]) < 50 :
        if rand < 6 :
          if rand < 2 and st.getQuestItemsCount(GEM[0]) < 49 :
            st.giveItems(GEM[0],2)
          else :
            st.giveItems(GEM[0],1)
          if (st.getQuestItemsCount(GEM[0]) + st.getQuestItemsCount(GEM[1])) == 100 :
            st.set("cond","3")
            st.playSound("ItemSound.quest_middle")
          else :
            st.playSound("ItemSound.quest_itemget")
      elif npcId in [ 20925 , 20926 ] and st.getQuestItemsCount(GEM[1]) < 50 :
        if rand < 6 :
          st.giveItems(GEM[1],1)
          if (st.getQuestItemsCount(GEM[0]) + st.getQuestItemsCount(GEM[1])) == 100 :
            st.set("cond","3")
            st.playSound("ItemSound.quest_middle")
          else :
            st.playSound("ItemSound.quest_itemget")

   return

QUEST       = Quest(298,"298_LizardmensConspiracy","Lizardmen�s Conspiracy")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30333)

CREATED.addTalkId(30333)
STARTED.addTalkId(30333)
STARTED.addTalkId(30344)
COMPLETED.addTalkId(30333)

for i in range(20922,20927) :
   STARTED.addKillId(i)

STARTED.addQuestDrop(30333,REPORT,1)
STARTED.addQuestDrop(20922,GEM[0],1)
STARTED.addQuestDrop(20923,GEM[0],1)
STARTED.addQuestDrop(20924,GEM[0],1)
STARTED.addQuestDrop(20925,GEM[1],1)
STARTED.addQuestDrop(20926,GEM[1],1)

print "importing quests: 298: Lizardmen�s Conspiracy"