import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

HONEY = 7138
SPICE = 7137
FRUIT = 7136

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30620-02.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")

    elif event == "30620-04.htm" :
       if st.getQuestItemsCount(HONEY) == 100 :
          st.set("cond","3")
          st.takeItems(HONEY,-1)
       else :
          htmltext = "bug1.htm"

    elif event == "30063-02.htm" :
      st.set("cond","4")
      st.giveItems(SPICE,1)

    elif event == "30620-06.htm" :
       if st.getQuestItemsCount(SPICE) == 1 :
          st.set("cond","5")
          st.takeItems(SPICE,-1)
       else :
          htmltext = "bug2.htm"

    elif event == "30466-02.htm" :
       st.set("cond","6")
       st.giveItems(FRUIT,1)

    elif event == "30620-08.htm" :
       if st.getQuestItemsCount(FRUIT) == 1 :
          st.takeItems(FRUIT,-1)
          if st.getRandom(100) < 50 :
             st.giveItems(57,25000)
          else :
             st.giveItems(1865,50)
          st.set("cond","0")
          st.setState(COMPLETED)
       else :
          htmltext = "bug3.htm"

    return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30620 :
      if cond == 0 :
         if st.getPlayer().getLevel() < 34 :
            htmltext = "30620-00.htm"
            st.exitCurrentQuest(True)
         elif st.getPlayer().getLevel() >= 34 :
            htmltext = "30620-01.htm"
      elif cond == 1 and st.getQuestItemsCount(HONEY) <= 99 :
         htmltext = "30620-02r.htm"
      elif cond == 2 and st.getQuestItemsCount(HONEY) == 100 :
         htmltext = "30620-03.htm"
      elif cond == 3 and st.getQuestItemsCount(SPICE) == 0 :
         htmltext = "30620-04r.htm"
      elif cond == 4 and st.getQuestItemsCount(SPICE) == 1 :
         htmltext = "30620-05.htm"
      elif cond == 5 and st.getQuestItemsCount(FRUIT) == 0 :
         htmltext = "30620-06r.htm"
      elif cond == 6 and st.getQuestItemsCount(FRUIT) == 1 :
         htmltext = "30620-07.htm"

   elif npcId == 30063 :
      if cond == 3 :
         htmltext = "30063-01.htm"
      elif cond == 4 :
         htmltext = "30063-02r.htm"

   elif npcId == 30466 :
      if cond == 5 :
         htmltext = "30466-01.htm"
      elif cond == 6 :
         htmltext = "30466-02r.htm"

   return htmltext


 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    if st.getInt("cond") == 1 and st.getQuestItemsCount(HONEY) < 100 and st.getRandom(10) < 6 :
       st.giveItems(HONEY,1)
       if st.getQuestItemsCount(HONEY) == 100 :
          st.set("cond","2")
          st.playSound("ItemSound.quest_middle")
       else :
          st.playSound("ItemSound.quest_itemget")

    return

QUEST       = Quest(299,"299_GatherIngredientsforPie","Gather Ingredients for Pie")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30620)

CREATED.addTalkId(30620)
STARTED.addTalkId(30620)
STARTED.addTalkId(30063)
STARTED.addTalkId(30466)

STARTED.addKillId(20934)
STARTED.addKillId(20935)

STARTED.addQuestDrop(20934,HONEY,1)
STARTED.addQuestDrop(20935,HONEY,1)
STARTED.addQuestDrop(30063,SPICE,1)
STARTED.addQuestDrop(30466,FRUIT,1)
STARTED.addQuestDrop(30620,57,1)
STARTED.addQuestDrop(30620,1865,1)

print "importing quests: 299: Gather Ingredients for Pie"