import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ARUJIEN = 30223
MIRABEL = 30146
HERBIEL = 30150
GREENIS = 30157

ARUJIENS_LETTER1 = 1092
ARUJIENS_LETTER2 = 1093
ARUJIENS_LETTER3 = 1094
POETRY_BOOK      = 689
GREENIS_LETTER   = 693
 
ADENA            = 57
BEGINNERS_POTION = 1073
 
class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30223-04.htm" :
      st.giveItems(ARUJIENS_LETTER1,1)
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
   elif event == "30223-08.htm" :
      st.takeItems(ARUJIENS_LETTER3,-1)
      st.giveItems(POETRY_BOOK,1)
      st.set("cond","4")
      st.playSound("ItemSound.quest_middle")
   elif event == "30223-10.htm" :
      st.takeItems(ARUJIENS_LETTER3,-1)
      st.giveItems(ADENA,450)
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == ARUJIEN :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() != 1 and st.getPlayer().getRace().ordinal() != 0 :
               htmltext = "30223-00.htm"
            elif st.getPlayer().getLevel() >= 2 :
               htmltext = "30223-02.htm"
            else:
               htmltext = "30223-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and st.getQuestItemsCount(ARUJIENS_LETTER1) :
         htmltext = "30223-05.htm"
      elif cond == 2 and st.getQuestItemsCount(ARUJIENS_LETTER2) :
         htmltext = "30223-06.htm"
      elif cond == 3 and st.getQuestItemsCount(ARUJIENS_LETTER3) :
         htmltext = "30223-07.htm"
      elif cond == 4 and st.getQuestItemsCount(POETRY_BOOK) :
         htmltext = "30223-11.htm"
      elif cond == 5 and st.getQuestItemsCount(GREENIS_LETTER) :
         htmltext = "30223-10.htm"
         st.takeItems(GREENIS_LETTER,-1)
         st.giveItems(BEGINNERS_POTION,5)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == MIRABEL :
      if cond == 1 and st.getQuestItemsCount(ARUJIENS_LETTER1) :
         htmltext = "30146-01.htm"
         st.takeItems(ARUJIENS_LETTER1,-1)
         st.giveItems(ARUJIENS_LETTER2,1)
         st.set("cond","2")
         st.playSound("ItemSound.quest_middle")
      elif cond == 2  :
         htmltext = "30146-02.htm"
   elif npcId == HERBIEL :
      if cond == 2 and st.getQuestItemsCount(ARUJIENS_LETTER2) :
         htmltext = "30150-01.htm"
         st.takeItems(ARUJIENS_LETTER2,-1)
         st.giveItems(ARUJIENS_LETTER3,1)
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")
      elif cond == 3 :
         htmltext = "30150-02.htm"
   elif npcId == GREENIS :
      if cond == 4 and st.getQuestItemsCount(POETRY_BOOK) :
         htmltext = "30157-02.htm"
         st.takeItems(POETRY_BOOK,-1)
         st.giveItems(GREENIS_LETTER,1)
         st.set("cond","5")
         st.playSound("ItemSound.quest_middle")
      elif cond == 5 and st.getQuestItemsCount(GREENIS_LETTER) :
         htmltext = "30157-03.htm"
      else :
         htmltext = "30157-01.htm"
   return htmltext

QUEST     = Quest(2,"2_WhatWomenWant","What Women Want")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(ARUJIEN)

CREATED.addTalkId(ARUJIEN)
COMPLETED.addTalkId(ARUJIEN)

STARTED.addTalkId(MIRABEL)
STARTED.addTalkId(HERBIEL)
STARTED.addTalkId(GREENIS)
STARTED.addTalkId(ARUJIEN)

STARTED.addQuestDrop(GREENIS,GREENIS_LETTER,1)
STARTED.addQuestDrop(HERBIEL,ARUJIENS_LETTER3,1)
STARTED.addQuestDrop(ARUJIEN,ARUJIENS_LETTER1,1)
STARTED.addQuestDrop(MIRABEL,ARUJIENS_LETTER2,1)
STARTED.addQuestDrop(ARUJIEN,POETRY_BOOK,1)
STARTED.addQuestDrop(ARUJIEN,BEGINNERS_POTION,1)

print "importing quests: 2: What Women Want"