import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

BRACELET_OF_LIZARDMAN = 7139
REW = [1872,57]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30126-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")

   elif event == "30126-04.htm" :
      if st.getQuestItemsCount(BRACELET_OF_LIZARDMAN) < 60 :
         htmltext = "bug.htm"
         st.set("cond","1")
      else :
         st.takeItems(BRACELET_OF_LIZARDMAN,-1)
         if st.getRandom(14) < 7 :
            st.giveItems(REW[0],50)
         else :
            st.giveItems(REW[1],30000)
         st.exitCurrentQuest(True)
   return htmltext

 def onTalk (Self,npc,st) :
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if id != STARTED :
      if st.getPlayer().getLevel() < 34 :
         htmltext = "30126-00.htm"
         st.exitCurrentQuest(True)
      else : htmltext = "30126-01.htm"
   elif cond > 0 and st.getQuestItemsCount(BRACELET_OF_LIZARDMAN) < 60 :
      htmltext = "30126-02r.htm"
      st.set("cond","1")
   else : htmltext = "30126-03.htm"
   return htmltext


 def onKill (self,npc,st):
   if st.getInt("cond") == 1 and st.getQuestItemsCount(BRACELET_OF_LIZARDMAN) < 60 and st.getRandom(10) < 7 :
      st.giveItems(BRACELET_OF_LIZARDMAN,1)
      if st.getQuestItemsCount(BRACELET_OF_LIZARDMAN) == 60 :
         st.set("cond","2")
         st.playSound("ItemSound.quest_middle")
      else :
         st.playSound("ItemSound.quest_itemget")

   return

QUEST       = Quest(300,"300_HuntingLetoLizardman","Hunting Leto Lizardman")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30126)

CREATED.addTalkId(30126)
STARTED.addTalkId(30126)

for i in range (20577,20583) :
   STARTED.addKillId(i)
   STARTED.addQuestDrop(i,BRACELET_OF_LIZARDMAN,1)

print "importing quests: 300: Hunting Leto Lizardmans"