# Last fix 16/04/07  by ValianT
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

StartNpc = 30138

ZombieSkin = 1045
Adena = 57
HealingPotion = 1061

Monster = [20015,20020]

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st) :
        htmltext = event
        if event == "30138-04.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        return htmltext

    def onTalk (Self,npc,st):
        npcId = npc.getNpcId()
        htmltext = "<html><head><body>I have nothing to say you</body></html>"
        id = st.getState()
        id2 = st.getStateId()
        if id in [CREATED,COMPLETED] or id2 == "Aborted" :
            if st.getPlayer().getLevel() >= 11 :
                htmltext = "30138-03.htm"
            else:
                htmltext = "30138-02.htm"
                st.exitCurrentQuest(True)
        else :
            if st.getQuestItemsCount(ZombieSkin) < 5 :
                htmltext = "30138-05.htm"
            else :
                htmltext = "30138-06.htm"
                st.takeItems(ZombieSkin,-1)
                st.giveItems(Adena,2000)
                st.giveItems(HealingPotion,1)
                st.unset("cond")
                st.playSound("ItemSound.quest_finish")
                st.setState(COMPLETED)
        return htmltext

    def onKill (self,npc,st):
        ZombieSkinCount = st.getQuestItemsCount(ZombieSkin)
        if ZombieSkinCount < 5 :
            if st.getRandom(10) > 7 :
                st.giveItems(ZombieSkin,1)
                if ZombieSkinCount == 4 :
                    st.playSound("ItemSound.quest_middle")
                    st.set("cond","2")
                else :
                    st.playSound("ItemSound.quest_itemget")
        return

QUEST = Quest(319,"319_ScentOfDeath","Scent Of Death")
CREATED = State('Start', QUEST)
STARTED = State('Started', QUEST)
ABORTED = State('Aborted', QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(StartNpc)

ABORTED.addTalkId(StartNpc)
CREATED.addTalkId(StartNpc)
STARTED.addTalkId(StartNpc)
COMPLETED.addTalkId(StartNpc)

for npcId in Monster :
   STARTED.addKillId(npcId)
   STARTED.addQuestDrop(npcId,ZombieSkin,1)

print "importing quests: 319: Scent Of Death"
