# Made by Mr. - Version 0.3 by DrLecter
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

StartNpc = 30351
VenomSac = 1077
Adena = 57
Mobs = [20034,20038,20043]

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st) :
        htmltext = event
        if event == "30351-04.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        return htmltext

    def onTalk (Self,npc,st):
        htmltext = "<html><head><body>I have nothing to say you</body></html>"
        id = st.getState()
        if id in [CREATED,ABORTED,COMPLETED] :
            if st.getPlayer().getLevel() >= 18 :
                htmltext = "30351-03.htm"
            else:
                htmltext = "30351-02.htm"
                st.exitCurrentQuest(True)
        elif id == STARTED :
            VenomSacCount = st.getQuestItemsCount(VenomSac)
            if VenomSacCount == 10 :
                st.takeItems(VenomSac,-1)
                st.giveItems(Adena,5810)
                st.playSound("ItemSound.quest_finish")
                htmltext = "30351-06.htm"
                st.unset("cond")
                st.setState(COMPLETED)
            else :
                htmltext = "30351-05.htm"
        return htmltext

    def onKill (self,npc,st):
        npcId = npc.getNpcId()
        VenomSacCount = st.getQuestItemsCount(VenomSac)
        if VenomSacCount <= 9 :
            Rate = 100 - (12 * (1 + (npcId - 20034)/4))
            if st.getRandom(100) > Rate :
                st.giveItems(VenomSac,1)
                if VenomSacCount == 9 :
                    st.playSound("ItemSound.quest_middle")
                    st.set("cond","2")
                else :
                    st.playSound("ItemSound.quest_itemget")
        return

QUEST = Quest(324,"324_SweetestVenom","Sweetest Venom")
CREATED = State('Start', QUEST)
STARTED = State('Started', QUEST)
ABORTED = State('Aborted', QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(StartNpc)

ABORTED.addTalkId(StartNpc)
CREATED.addTalkId(StartNpc)
STARTED.addTalkId(StartNpc)
COMPLETED.addTalkId(StartNpc)

for Monster in Mobs :
    STARTED.addKillId(Monster)
    STARTED.addQuestDrop(Monster,VenomSac,1)

print "importing quests: 324: Sweetest Venom"
