import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

STALKER_HORN_ID = 3853
DRAKE_TALON_ID = 3854
REMAINS_OF_SACRIFICED_ID = 3857
TOTEM_OF_LAND_DRAGON_ID = 3858
HAMRUT_LEG_ID = 3856
KRANROT_SKIN_ID = 3855
MARA_FANG_ID = 3862
MUSFEL_FANG_ID = 3863
FIRST_ABYSS_FRAGMENT_ID = 3859
SECOND_ABYSS_FRAGMENT_ID = 3860
THIRD_ABYSS_FRAGMENT_ID = 3861
PORTAL_STONE_ID = 3865
MARK_OF_WATCHMAN_ID = 3864


class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "1" :
      st.set("id","0")
      st.set("cond","1")
      st.setState(STARTED)
      htmltext = "30753-02.htm"
      st.playSound("ItemSound.quest_accept")

    elif event == "2" :
      st.set("cond","2")

    elif event == "4" :
      st.set("cond","4")

    elif event == "7" :
      st.set("cond","6")

    elif event == "8" :
      st.set("cond","8")

    elif event == "12" :
      st.set("cond","10")

    elif event == "14" :
      st.set("cond","12")

    return htmltext


 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   if id == CREATED :
     st.setState(STARTING)
     st.set("cond","0")
     st.set("onlyone","0")
     st.set("id","0")
   if npcId == 30753 :
        if int(st.get("cond")) == 0 and int(st.get("id")) == 0 :
          if st.getPlayer().getLevel() < 50 :
            htmltext = "30753-00.htm"
            st.exitCurrentQuest(True)
          elif st.getPlayer().getLevel() >= 50 :
            htmltext = "30753-01.htm"
          else:
            htmltext = "30753-00.htm"
            st.exitCurrentQuest(True)

        elif st.getPlayer().getLevel() >= 50 and int(st.get("cond")) == 9 :
            st.takeItems(MARK_OF_WATCHMAN_ID,4)
            htmltext = "30753-03.htm"
        elif st.getPlayer().getLevel() >= 50 and int(st.get("cond")) < 9 :
            htmltext = "30753-02.htm"
        elif st.getPlayer().getLevel() >= 50 and int(st.get("cond")) == 13 :
            htmltext = "30753-04.htm"
            st.takeItems(MARK_OF_WATCHMAN_ID,2)
            st.set("cond","14")
        elif st.getPlayer().getLevel() >= 50 and int(st.get("cond")) < 13 :
            htmltext = "30753-05.htm"
        elif st.getPlayer().getLevel() >= 50 and int(st.get("cond")) > 13 :
            htmltext = "30753-06.htm"

        else:
            htmltext = "30753-00.htm"
            st.exitCurrentQuest(True)

   elif npcId == 30720 and int(st.get("cond")) < 3 :
        if st.getQuestItemsCount(STALKER_HORN_ID) == 0 and st.getQuestItemsCount(DRAKE_TALON_ID) == 0 and int(st.get("cond")) == 1 :
          htmltext = "30720-01.htm"
        elif st.getQuestItemsCount(STALKER_HORN_ID) == 1 and st.getQuestItemsCount(DRAKE_TALON_ID) == 1 and int(st.get("cond")) == 2 :
          htmltext = "30720-03.htm"
          st.takeItems(STALKER_HORN_ID,1)
          st.takeItems(DRAKE_TALON_ID,1)
          st.giveItems(MARK_OF_WATCHMAN_ID,1)
          st.set("cond","3")
        else :
          htmltext = "30720-02.htm"

   elif npcId == 30857 and int(st.get("cond")) < 5 :
        if st.getQuestItemsCount(REMAINS_OF_SACRIFICED_ID) == 0 and int(st.get("cond")) == 3 :
          htmltext = "30857-01.htm"
        elif st.getQuestItemsCount(REMAINS_OF_SACRIFICED_ID) == 1 and int(st.get("cond")) == 4:
          htmltext = "30857-03.htm"
          st.takeItems(REMAINS_OF_SACRIFICED_ID,1)
          st.giveItems(MARK_OF_WATCHMAN_ID,1)
          st.set("cond","5")
        else :
          htmltext = "30857-02.htm"

   elif npcId == 30851 and int(st.get("cond")) < 7 :
        if st.getQuestItemsCount(TOTEM_OF_LAND_DRAGON_ID) == 0 and int(st.get("cond")) == 5 :
          htmltext = "30851-01.htm"
        elif st.getQuestItemsCount(TOTEM_OF_LAND_DRAGON_ID) == 1 and int(st.get("cond")) == 6 :
          htmltext = "30851-03.htm"
          st.takeItems(TOTEM_OF_LAND_DRAGON_ID,1)
          st.giveItems(MARK_OF_WATCHMAN_ID,1)
          st.set("cond","7")
        else :
          htmltext = "30851-02.htm"

   elif npcId == 30705 and int(st.get("cond")) < 9 :
        if st.getQuestItemsCount(HAMRUT_LEG_ID) == 0 and st.getQuestItemsCount(KRANROT_SKIN_ID) == 0 and int(st.get("cond")) == 7 :
          htmltext = "30705-01.htm"
        elif st.getQuestItemsCount(HAMRUT_LEG_ID) == 1 and st.getQuestItemsCount(KRANROT_SKIN_ID) == 1 and int(st.get("cond")) == 8 :
          htmltext = "30705-03.htm"
          st.takeItems(HAMRUT_LEG_ID,1)
          st.takeItems(KRANROT_SKIN_ID,1)
          st.giveItems(MARK_OF_WATCHMAN_ID,1)
          st.set("cond","9")
        else :
          htmltext = "30705-02.htm"

   elif npcId == 30498 and int(st.get("cond")) < 11 :
        if st.getQuestItemsCount(MARA_FANG_ID) == 0 and st.getQuestItemsCount(FIRST_ABYSS_FRAGMENT_ID) == 0 and int(st.get("cond")) == 9 :
          htmltext = "30498-01.htm"
        elif st.getQuestItemsCount(MARA_FANG_ID) == 1 and st.getQuestItemsCount(FIRST_ABYSS_FRAGMENT_ID) == 1 and int(st.get("cond")) == 10 :
          htmltext = "30498-03.htm"
          st.takeItems(MARA_FANG_ID,1)
          st.takeItems(FIRST_ABYSS_FRAGMENT_ID,1)
          st.giveItems(MARK_OF_WATCHMAN_ID,1)
          st.set("cond","11")
        else :
          htmltext = "30498-02.htm"

   elif npcId == 30678 and int(st.get("cond")) < 13 :
        if st.getQuestItemsCount(MUSFEL_FANG_ID) == 0 and st.getQuestItemsCount(SECOND_ABYSS_FRAGMENT_ID) == 0 and int(st.get("cond")) == 11 :
          htmltext = "30678-01.htm"
        elif st.getQuestItemsCount(MUSFEL_FANG_ID) == 1 and st.getQuestItemsCount(SECOND_ABYSS_FRAGMENT_ID) == 1 and int(st.get("cond")) == 12 :
          htmltext = "30678-03.htm"
          st.takeItems(MUSFEL_FANG_ID,1)
          st.takeItems(SECOND_ABYSS_FRAGMENT_ID,1)
          st.giveItems(MARK_OF_WATCHMAN_ID,1)
          st.set("cond","13")
        else :
          htmltext = "30678-02.htm"

   elif npcId == 30754 and int(st.get("cond")) == 14 :
        if st.getQuestItemsCount(THIRD_ABYSS_FRAGMENT_ID) == 0 :
          htmltext = "30754-01.htm"
        else :
          htmltext = "30754-02.htm"

   elif npcId == 30755 and int(st.get("cond")) == 15 :
        if st.getQuestItemsCount(THIRD_ABYSS_FRAGMENT_ID) == 0 :
          htmltext = "30755-02.htm"
        elif st.getQuestItemsCount(THIRD_ABYSS_FRAGMENT_ID) == 1 :
          htmltext = "30755-01.htm"
          st.takeItems(THIRD_ABYSS_FRAGMENT_ID,1)
          st.giveItems(PORTAL_STONE_ID,1)
          st.set("cond","0")
          st.set("id","0")
          st.setState(COMPLETED)
          st.getPcSpawn().removeAllSpawn()
          st.playSound("ItemSound.quest_finish")
        else :
          htmltext = "30755-02.htm"

   elif npcId == 13001 and int(st.get("cond")) == 16 :
    st.takeItems(PORTAL_STONE_ID,1)
    st.getPlayer().teleToLocation(173826,115333,-7708);

   return htmltext

 def onAttack (self,npc,st):

        npcId = npc.getNpcId()
        if npcId == 27165 and int(st.get("cond")) == 10 and int(st.get("id")) == 0 :
          if (npc.getMaxHp()/2) > npc.getCurrentHp() :
                st.set("id","100")
                for i in range(4):
                        st.getPcSpawn().addSpawn(27168)

        elif npcId == 27166 and int(st.get("cond")) == 12 and int(st.get("id")) == 50 :
          if (npc.getMaxHp()/2) > npc.getCurrentHp() :
                st.set("id","120")
                for i in range(4):
                        st.getPcSpawn().addSpawn(27169)

        elif npcId == 27167 and int(st.get("cond")) == 14 and int(st.get("id")) == 140 :
          if (npc.getMaxHp()/2) > npc.getCurrentHp() :
#		st.set("onlyone","1")
                st.set("id","70")
                for i in range(4):
                        st.getPcSpawn().addSpawn(5170)

#	  elif int(st.get("id")) == 140 and int(st.get("onlyone")) == 1 :
#		timer = st.getQuestTimer("Kill_timer")
#		if timer != None :
#			st.getPcSpawn().removeAllSpawn()
#			timer.cancel()
#			st.set("id","70")

        return



 def onKill (self,npc,st):

        npcId = npc.getNpcId()
        if npcId == 20679 :
          if st.getQuestItemsCount(STALKER_HORN_ID) == 0 :
                if st.getRandom(10) < 5 :
                        st.giveItems(STALKER_HORN_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 20680 :
          if st.getQuestItemsCount(DRAKE_TALON_ID) == 0 :
                if st.getRandom(10) < 5 :
                        st.giveItems(DRAKE_TALON_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 18002 :
          if int(st.get("cond")) == 4 :
                if st.getRandom(10) < 5 :
                        st.getPcSpawn().addSpawn(27171)
                        st.playSound("Itemsound.quest_before_battle")
        elif npcId == 27171 :
          if int(st.get("cond")) == 4 and st.getQuestItemsCount(REMAINS_OF_SACRIFICED_ID) == 0 :
                if st.getRandom(10) < 5 :
                        st.giveItems(REMAINS_OF_SACRIFICED_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 20644 or npcId == 20645 :
          if int(st.get("cond")) == 6 :
                if st.getRandom(10) < 5 :
                        st.getPcSpawn().addSpawn(27172)
                        st.playSound("Itemsound.quest_before_battle")
        elif npcId == 27172 :
          if int(st.get("cond")) == 6 and st.getQuestItemsCount(TOTEM_OF_LAND_DRAGON_ID) == 0 :
                if st.getRandom(10) < 5 :
                        st.giveItems(TOTEM_OF_LAND_DRAGON_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 20649 :
          if st.getQuestItemsCount(HAMRUT_LEG_ID) == 0 and int(st.get("cond")) == 8 :
                if st.getRandom(10) < 5 :
                        st.giveItems(HAMRUT_LEG_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 20650 :
          if st.getQuestItemsCount(KRANROT_SKIN_ID) == 0 and int(st.get("cond")) == 8 :
                if st.getRandom(10) < 5 :
                        st.giveItems(KRANROT_SKIN_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 27168 :
          if st.getQuestItemsCount(MARA_FANG_ID) == 0 and int(st.get("cond")) == 10 :
                if st.getRandom(10) < 5 :
                        st.giveItems(MARA_FANG_ID,1)
                        st.playSound("ItemSound.quest_itemget")
                        st.set("id","50")
        elif npcId == 27169 :
          if st.getQuestItemsCount(MUSFEL_FANG_ID) == 0 and int(st.get("cond")) == 12 :
                if st.getRandom(10) < 5 :
                        st.giveItems(MUSFEL_FANG_ID,1)
                        st.playSound("ItemSound.quest_itemget")
                        st.set("id","60")
        elif npcId == 20246 or npcId == 20134 :
          if int(st.get("cond")) == 14 :
                if st.getRandom(10) < 5 :
                        st.getPcSpawn().addSpawn(27167)
                        st.set("id","140")
                        st.playSound("Itemsound.quest_before_battle")
        elif npcId == 20134 and int(st.get("cond")) == 14 :
          if st.getRandom(10) < 5 :
                st.getPcSpawn().addSpawn(27167)
                st.set("id","140")
                st.playSound("Itemsound.quest_before_battle")
        elif npcId == 27165 :
          if st.getQuestItemsCount(FIRST_ABYSS_FRAGMENT_ID) == 0 and int(st.get("cond")) == 10 :
                if st.getRandom(10) < 5 :
                        st.set("id","50")
                        st.giveItems(FIRST_ABYSS_FRAGMENT_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 27166 :
          if st.getQuestItemsCount(SECOND_ABYSS_FRAGMENT_ID) == 0 and int(st.get("cond")) == 12 :
                if st.getRandom(10) < 5 :
                        st.set("id","60")
                        st.giveItems(SECOND_ABYSS_FRAGMENT_ID,1)
                        st.playSound("ItemSound.quest_itemget")
        elif npcId == 27167 :
          if st.getQuestItemsCount(THIRD_ABYSS_FRAGMENT_ID) == 0 and int(st.get("cond")) == 14 :
                if st.getRandom(10) < 5 :
                        st.set("id","70")
                        st.giveItems(THIRD_ABYSS_FRAGMENT_ID,1)
                        st.playSound("ItemSound.quest_itemget")
                        st.set("cond","15")
                        st.getPcSpawn().removeAllSpawn()

        return


QUEST       = Quest(337,"337_AudienceWithLandDragon","Audience with Land Dragon")
CREATED     = State('Start', QUEST)
STARTING    = State('Starting', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30753)

STARTING.addTalkId(30753)

STARTED.addTalkId(30720)
STARTED.addTalkId(30857)
STARTED.addTalkId(30851)
STARTED.addTalkId(30705)
STARTED.addTalkId(30498)
STARTED.addTalkId(30678)
STARTED.addTalkId(30753)
STARTED.addTalkId(30754)
STARTED.addTalkId(30755)
COMPLETED.addTalkId(13001)

STARTED.addKillId(18002)
STARTED.addKillId(20679)
STARTED.addKillId(20680)
STARTED.addKillId(27171)
STARTED.addKillId(20644)
STARTED.addKillId(20645)
STARTED.addKillId(27172)
STARTED.addKillId(20649)
STARTED.addKillId(20650)
STARTED.addKillId(27165)
STARTED.addKillId(27166)
STARTED.addKillId(20246)
STARTED.addKillId(20134)
STARTED.addKillId(27167)
STARTED.addKillId(27168)
STARTED.addKillId(27169)
STARTED.addKillId(27170)

STARTED.addAttackId(27165)
STARTED.addAttackId(27166)
STARTED.addAttackId(27167)

STARTED.addQuestDrop(20679,STALKER_HORN_ID,1)
STARTED.addQuestDrop(20680,DRAKE_TALON_ID,1)
STARTED.addQuestDrop(27171,REMAINS_OF_SACRIFICED_ID,1)
STARTED.addQuestDrop(27172,TOTEM_OF_LAND_DRAGON_ID,1)
STARTED.addQuestDrop(20649,HAMRUT_LEG_ID,1)
STARTED.addQuestDrop(20650,KRANROT_SKIN_ID,1)
STARTED.addQuestDrop(27168,MARA_FANG_ID,1)
STARTED.addQuestDrop(27165,FIRST_ABYSS_FRAGMENT_ID,1)
STARTED.addQuestDrop(27169,MUSFEL_FANG_ID,1)
STARTED.addQuestDrop(27166,SECOND_ABYSS_FRAGMENT_ID,1)
STARTED.addQuestDrop(27167,THIRD_ABYSS_FRAGMENT_ID,1)
STARTED.addQuestDrop(30720,MARK_OF_WATCHMAN_ID,1)
STARTED.addQuestDrop(30857,MARK_OF_WATCHMAN_ID,1)
STARTED.addQuestDrop(30851,MARK_OF_WATCHMAN_ID,1)
STARTED.addQuestDrop(30705,MARK_OF_WATCHMAN_ID,1)
STARTED.addQuestDrop(30498,MARK_OF_WATCHMAN_ID,1)
STARTED.addQuestDrop(30678,MARK_OF_WATCHMAN_ID,1)
STARTED.addQuestDrop(30755,PORTAL_STONE_ID,1)



print "importing quests: 337: Audience with Land Dragon"
