import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

PELT = 4337

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30892-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")

    elif event == "30892-02-afmenu.htm" :
      st.giveItems(57,st.getQuestItemsCount(PELT)*40)
      st.takeItems(PELT,st.getQuestItemsCount(PELT))

    elif event == "quit" :
      if st.getQuestItemsCount(PELT) >= 1 :
        st.giveItems(57,st.getQuestItemsCount(PELT)*40)
        st.takeItems(PELT,st.getQuestItemsCount(PELT))
        htmltext = "30892-havequit.htm"
      else :
        htmltext = "30892-havent.htm"

    return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() < 40 :
         htmltext = "30892-00.htm"
         st.exitCurrentQuest(True)
      elif st.getPlayer().getLevel() >= 40 :
         htmltext = "30892-01.htm"
   elif cond == 1 and st.getQuestItemsCount(PELT) == 0 :
      htmltext = "30892-02-rep.htm"
   elif cond == 1 and st.getQuestItemsCount(PELT) >= 1 :
      htmltext = "30892-menu.htm"

   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if npcId in [20804,20805,20806,20807,20808,20991] and st.getInt("cond") == 1 and st.getRandom(10) < 6 :
      st.giveItems(PELT,1)
      st.playSound("ItemSound.quest_itemget")

   return

QUEST       = Quest(338,"338_AlligatorHunter","Alligator Hunter")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)
ABORTED     = State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30892)

CREATED.addTalkId(30892)
STARTED.addTalkId(30892)
COMPLETED.addTalkId(30892)

for i in range(20804,20809)+[20991]:
  STARTED.addKillId(i)
for j in range(20804,20809)+[20991]:
  STARTED.addQuestDrop(j,TEETH,1)

print "importing quests: 338: Alligator Hunter"