#don by fatall
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
WEITSZ = 30385
LEVIAN = 30037
ADONIUS = 30375
CHEST_OF_BIFRONS = 30989

#QUEST ITEM
ROSARY = 4257
HOLY_SYMBOL = 4256
TRADE_CARGO = 4255
EVIL_SPIRIT_OF_DARKNESS = 7190

#MOBS
LANGK_LIZARDMAN = 20008
LANGK_LIZARDMAN_SCOUT = 20010
SERPENT_DEMON_BIFRONS = 25146
LANGK_LIZARDMAN_SHAMAN = 21101
LANGK_LIZARDMAN_LEADER = 20356
LANGK_LIZARDMAN_WARRIOR = 20014
LANGK_LIZARDMAN_SENTINEL = 21100
LANGK_LIZARDMAN_LIEUTENANT = 20357

#REWARD
ADENA = 57


class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   cond = st.getInt("cond")
   if event == "30385-4.htm" :
     if cond == 0 :
       st.setState(STARTED)
       st.set("cond","1")
       st.playSound("ItemSound.quest_accept")
   if event == "30385-6.htm" :
     if cond == 1 :
       st.set("cond","2")
       st.takeItems(TRADE_CARGO,30)
       st.playSound("ItemSound.quest_middle")
   if event == "30375-2.htm" :
     if cond == 2 :
       st.set("cond","3")       
       st.playSound("ItemSound.quest_middle")
   if event == "30989-2.htm" :
     if cond == 5 :
       st.set("cond","6")
       st.giveItems(EVIL_SPIRIT_OF_DARKNESS,1)
       st.playSound("ItemSound.quest_middle")
   if event == "30037-4.htm" :
     if cond == 6 :
       st.set("cond","7")
       st.takeItems(EVIL_SPIRIT_OF_DARKNESS,1)
       st.playSound("ItemSound.quest_middle")
   if event == "30385-10.htm" :
     if cond == 7 :
       st.set("cond","0")
       st.giveItems(ADENA,14700)
       st.getPcSpawn().removeAllSpawn()
       st.playSound("ItemSound.quest_finish")
       st.setState(COMPLETED)
   if event == "30385-7.htm" :
     if cond == 1 :
       st.set("cond","0")
       st.takeItems(TRADE_CARGO,30)
       st.giveItems(ADENA,4090)
       st.playSound("ItemSound.quest_finish")
       st.setState(COMPLETED)
   return htmltext

 def onTalk (Self,npc,st) :
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == WEITSZ and cond == 0 :
      if st.getPlayer().getLevel() >= 17 :
         htmltext = "30385-2.htm"
      else :
         htmltext = "30385-1.htm"
         st.exitCurrentQuest(True)

   if npcId == WEITSZ and cond == 1 :
     if st.getQuestItemsCount(TRADE_CARGO) == 30 :
       htmltext = "30385-5.htm"
     else :
       htmltext = "30385-8.htm"
   if npcId == WEITSZ and cond == 2 :
      htmltext = "30385-11.htm"
   if npcId == WEITSZ and cond == 7 :
      htmltext = "30385-9.htm"
   if npcId == ADONIUS and cond == 2 : 
      htmltext = "30375-1.htm"
   if npcId == ADONIUS and cond == 3 :
     if st.getQuestItemsCount(ROSARY) == 1 and st.getQuestItemsCount(HOLY_SYMBOL) == 1 :  
       htmltext = "30375-3.htm"
       st.takeItems(ROSARY,1)
       st.takeItems(HOLY_SYMBOL,1)
       st.playSound("ItemSound.quest_middle")
       st.set("cond","4")
     else :
       htmltext = "30375-4.htm"
   if npcId == ADONIUS and cond == 4 :
      htmltext = "30375-5.htm"
   if npcId == LEVIAN and cond == 4 :
      htmltext = "30037-1.htm"
      st.playSound("ItemSound.quest_middle")
      st.set("cond","5")
   if npcId == LEVIAN and cond == 5 :
      htmltext = "30037-2.htm"
   if npcId == LEVIAN and cond == 7 :
      htmltext = "30037-5.htm"
   if npcId == LEVIAN and cond == 6 :
     if st.getQuestItemsCount(EVIL_SPIRIT_OF_DARKNESS) == 1 :
       htmltext = "30037-3.htm"
   if npcId == CHEST_OF_BIFRONS and cond == 5 :
      htmltext = "30989-1.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == SERPENT_DEMON_BIFRONS :
      st.getPcSpawn().addSpawn(CHEST_OF_BIFRONS)
   if npcId in [20008,20010,20014] :
     if cond == 1 and st.getQuestItemsCount(TRADE_CARGO) < 30 :
       if st.getRandom(100) < 35 :
         st.giveItems(TRADE_CARGO,1)
         if st.getQuestItemsCount(TRADE_CARGO) == 30 :        
           st.playSound("ItemSound.quest_middle")
         else:
           st.playSound("ItemSound.quest_itemget")
   if npcId in [20357,21100,20014,20356,21101,20010] :
     if cond == 3 and st.getQuestItemsCount(ROSARY) < 1 :
       if st.getRandom(100) < 5 :
         st.giveItems(ROSARY,1)
         if st.getQuestItemsCount(HOLY_SYMBOL) < 1 :
           st.playSound("ItemSound.quest_itemget")
         else:
           st.playSound("ItemSound.quest_middle")
     elif cond == 3 and st.getQuestItemsCount(HOLY_SYMBOL) < 1 :
       if st.getRandom(100) > 95 :
         st.giveItems(HOLY_SYMBOL,1)
         if st.getQuestItemsCount(ROSARY) < 1 :
           st.playSound("ItemSound.quest_itemget")
         else:
           st.playSound("ItemSound.quest_middle")
   return 

QUEST       = Quest(340,"340_SubjugationofLizardmen","Subjugation of Lizardmen")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(WEITSZ)
CREATED.addTalkId(WEITSZ)
STARTED.addTalkId(WEITSZ)
STARTED.addTalkId(LEVIAN)
STARTED.addTalkId(ADONIUS)
STARTED.addTalkId(CHEST_OF_BIFRONS)

STARTED.addKillId(LANGK_LIZARDMAN)
STARTED.addKillId(LANGK_LIZARDMAN_SCOUT)
STARTED.addKillId(SERPENT_DEMON_BIFRONS)
STARTED.addKillId(LANGK_LIZARDMAN_LEADER)
STARTED.addKillId(LANGK_LIZARDMAN_SHAMAN)
STARTED.addKillId(LANGK_LIZARDMAN_WARRIOR)
STARTED.addKillId(LANGK_LIZARDMAN_SENTINEL)
STARTED.addKillId(LANGK_LIZARDMAN_LIEUTENANT)

STARTED.addQuestDrop(WEITSZ,ROSARY,1)
STARTED.addQuestDrop(WEITSZ,HOLY_SYMBOL,1)
STARTED.addQuestDrop(WEITSZ,TRADE_CARGO,1)
STARTED.addQuestDrop(WEITSZ,EVIL_SPIRIT_OF_DARKNESS,1)

print "importing quests: 340: Subjugation of Lizardmen"