import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
CEMA = 30834
ICARUS = 30835
MARSHA = 30934
TRUMPIN = 30935

ORB = 4364
ECTOPLASM = 4365
ADENA = 57
CHANCE = 50

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
     htmltext = event
     random1 = st.getRandom(3)
     random2 = st.getRandom(2)
     orbs = st.getQuestItemsCount(ORB)
     if event == "30834-03.htm" :
         st.setState(STARTED)
         st.set("cond","1")
         st.playSound("ItemSound.quest_accept")
     elif event == "30834-08.htm" :
         if orbs :
             st.giveItems(ADENA,orbs*120)
             st.takeItems(ORB,-1)
         else :
             htmltext = "30834-08.htm"
     elif event == "30834-09.htm" :
         st.playSound("ItemSound.quest_finish")
         st.exitCurrentQuest(True)

     elif event == "30934-02.htm" :
         if orbs < 10 :
             htmltext = "noorbs.htm"
     elif event == "30934-03.htm" :
         if orbs >= 10 :
             st.takeItems(ORB,10)
             st.set("playing","1")
         else :
             htmltext = "noorbs.htm"
     elif event == "30934-04.htm" :
         if st.getInt("playing") :
             if random1 == 0 :
                 htmltext = "30934-05.htm"
                 st.giveItems(ORB,10)
             elif random1 == 1 :
                 htmltext = "30934-06.htm"
             elif random1 == 2 :
                 st.giveItems(ORB,20)
             st.unset("playing")
         else :
             htmltext = "Player is cheating"
             st.takeItems(ORB,-1)
     elif event == "30934-05.htm" :
         if st.getInt("playing") :
             if random1 == 0 :
                 htmltext = "30934-04.htm"
                 st.giveItems(ORB,20)
             elif random1 == 1 :
                 st.giveItems(ORB,10)
             elif random1 == 2 :
                 htmltext = "30934-06.htm"
             st.unset("playing")
         else :
             htmltext="Player is cheating"
             st.takeItems(ORB,-1)
     elif event == "30934-06.htm" :
         if st.getInt("playing") :
             if random1 == 1 :
                 htmltext = "30934-04.htm"
                 st.giveItems(ORB,20)
             elif random1 == 2 :
                 htmltext = "30934-05.htm"
                 st.giveItems(ORB,10)
             st.unset("playing")
         else :
             htmltext="Player is cheating"
             st.takeItems(ORB,-1)

     elif event == "30935-02.htm" :
         st.unset("toss")
         if orbs < 10 :
             htmltext = "noorbs.htm"
     elif event == "30935-03.htm" :
         if orbs < 10 :
             st.unset("toss")
             htmltext = "noorbs.htm"         
     elif event == "30935-05.htm" :
         if orbs >= 10 :
             if random2 == 0 :
                 toss = st.getInt("toss")
                 if toss == 4 :
                     st.unset("toss")
                     st.giveItems(ORB,310)
                     htmltext = "30935-07.htm"
                 else :
                     st.set("toss", str(toss+1))
                     htmltext = "30935-04.htm"
             else :
                 st.unset("toss")
                 st.takeItems(ORB,10)
         else :
             htmltext = "noorbs.htm"
     elif event == "30935-06.htm" :
         if orbs >= 10 :
             toss = st.getInt("toss")
             st.unset("toss")
             if toss == 1 :
                 st.giveItems(ORB,10)
             elif toss == 2 :
                 st.giveItems(ORB,30)
             elif toss == 3 :
                 st.giveItems(ORB,70)
             elif toss == 4 :
                 st.giveItems(ORB,150)
         else :
             htmltext = "noorbs.htm"

     elif event == "30835-02.htm" :
         if st.getQuestItemsCount(ECTOPLASM) :
             st.takeItems(ECTOPLASM,1)
             random = st.getRandom(1000)
             if random <= 119 :
                 st.giveItems(955,1)
             elif random <= 169 :
                 st.giveItems(951,1)
             elif random <= 329 :
                 st.giveItems(2511, st.getRandom(200) + 401)
             elif random <= 559 :
                 st.giveItems(2510, st.getRandom(200) + 401)
             elif random <= 561 :
                 st.giveItems(316,1)
             elif random <= 578 :
                 st.giveItems(630,1)
             elif random <= 579 :
                 st.giveItems(188,1)
             elif random <= 581 :
                 st.giveItems(885,1)
             elif random <= 582 :
                 st.giveItems(103,1)
             elif random <= 584 :
                 st.giveItems(917,1)
             else :
                 st.giveItems(736,1)
         else :
             htmltext = "30835-03.htm"
     return htmltext

 def onTalk (self,npc,st):
     npcId = npc.getNpcId()
     htmltext = "default.htm"
     player = st.getPlayer()
     if npcId == CEMA :
         if st.getState() != STARTED :
             if player.getClassId().getId() in [0xb,0xc,0xd,0xe,0x1a,0x1b,0x1c,0x27,0x28,0x29] and player.getLevel() >=40 :
                 htmltext = "30834-01.htm"
             else :
                 htmltext = "30834-07.htm"
         elif st.getQuestItemsCount(ORB) :
             htmltext = "30834-06.htm"
         else :
             htmltext = "30834-05.htm"
     elif npcId == ICARUS :
         htmltext = "30835-01.htm"
     elif npcId == MARSHA :
         htmltext = "30934-01.htm"
     elif npcId == TRUMPIN :
         htmltext = "30935-01.htm"
     return htmltext

 def onKill (self,npc,st):
     if st.getRandom(100) < CHANCE :
         st.giveItems(ORB,1)
         st.playSound("ItemSound.quest_itemget")
     return

QUEST   = Quest(343,"343_UnderTheShadowOfTheIvoryTower","Under The Shadow Of The Ivory Tower")
CREATED = State('Start', QUEST)
STARTED = State('Started', QUEST)
ABORTED = State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(CEMA)

CREATED.addTalkId(CEMA)
STARTED.addTalkId(CEMA)
STARTED.addTalkId(ICARUS)
STARTED.addTalkId(MARSHA)
STARTED.addTalkId(TRUMPIN)

for i in range(20563,20566) :
    STARTED.addKillId(i)

STARTED.addQuestDrop(30834,ORB,1)

print "importing quests: 343: Under The Shadow Of The Ivory Tower"
