import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

SPINNERET = 7528
SUEDE = 1866
THREAD = 1868
SPIDERSILK = 1493
MYSTERIOUS_CLOTH = 7076

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
   htmltext = event
   cond = st.getInt("cond")
   if event == "30088-1.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "30294-1.htm" and cond == 1 :
     st.set("cond","2")
   elif event == "30088-3.htm" and cond == 2 :
     st.set("cond","3")
   elif event == "30165-1.htm" and cond == 3 :
     st.set("cond","4")
   elif event == "30165-3.htm" and cond == 5 :
     if st.getQuestItemsCount(SPINNERET) == 10 :
       st.takeItems(SPINNERET,10)
       st.giveItems(SPIDERSILK,1)
       st.set("cond","6")
     else :
       htmltext = "30165-1r.htm"
   elif event == "30088-5.htm" and cond == 6 :
     if st.getQuestItemsCount(SUEDE) >= 3000 and st.getQuestItemsCount(THREAD) >= 5000 and st.getQuestItemsCount(SPIDERSILK) == 1 :
       st.takeItems(SUEDE,3000)
       st.takeItems(THREAD,5000)
       st.takeItems(SPIDERSILK,1)
       st.giveItems(MYSTERIOUS_CLOTH,1)
       st.playSound("ItemSound.quest_finish")
       st.exitCurrentQuest(True)
     else :
       htmltext = "30088-havent.htm"
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30088 :
      if cond == 0 and st.getQuestItemsCount(MYSTERIOUS_CLOTH) == 0 :
         if st.getPlayer().getLevel() >= 60 :
            fwear = st.getPlayer().getQuestState("37_PleaseMakeMeFormalWear")
            if fwear :
               if fwear.get("cond") == "6" :
                  htmltext = "30088-0.htm"
               else :
                  st.exitCurrentQuest(True)
            else :
               st.exitCurrentQuest(True)
         else :
            htmltext = "30088-6.htm"
      elif cond == 1 :
         htmltext = "30088-1r.htm"
      elif cond == 2 :
         htmltext = "30088-2.htm"
      elif cond == 3 :
         htmltext = "30088-3r.htm"
      elif cond == 6 and (st.getQuestItemsCount(SUEDE) < 3000 or st.getQuestItemsCount(THREAD) < 5000 or st.getQuestItemsCount(SPIDERSILK) < 1) :
         htmltext = "30088-havent.htm"
      elif cond == 6 :
         htmltext = "30088-4.htm"
   elif npcId == 30294 :
      if cond == 1 :
         htmltext = "30294-0.htm"
      elif cond == 2 :
         htmltext = "30294-1r.htm"
   elif npcId == 30165 :
      if cond == 3 :
         htmltext = "30165-0.htm"
      elif cond == 4 and st.getQuestItemsCount(SPINNERET) < 10 :
         htmltext = "30165-1r.htm"
      elif cond == 5 :
         htmltext = "30165-2.htm"
      elif cond == 6 and (st.getQuestItemsCount(SUEDE) < 3000 or st.getQuestItemsCount(THREAD) < 5000 or st.getQuestItemsCount(SPIDERSILK) < 1) :
         htmltext = "30165-3r.htm"
   return htmltext

 def onKill (self,npc,st):
   if st.getQuestItemsCount(SPINNERET) < 10 :
      st.giveItems(SPINNERET,1)
      if st.getQuestItemsCount(SPINNERET) == 10 :
         st.playSound("ItemSound.quest_middle")
         st.set("cond","5")
      else :
         st.playSound("ItemSound.quest_itemget")	
   return

QUEST       = Quest(34,"34_InSearchOfClothes","In Search of Clothes",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30088)
CREATED.addTalkId(30088)
STARTED.addTalkId(30088)
STARTED.addTalkId(30165)
STARTED.addTalkId(30294)

STARTED.addKillId(20560)

STARTED.addQuestDrop(20560,SPINNERET,1)

print "importing quests: 34: In Search of Clothes"
