import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ROUGH_JEWEL = 7162
ORIHARUKON = 1893
SILVER_NUGGET = 1873
THONS = 4044
JEWEL_BOX = 7077

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
   htmltext = event
   cond = st.getInt("cond")
   if event == "30091-1.htm" and cond == 0 :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "30879-1.htm" and cond == 1 :
     st.set("cond","2")
   elif event == "30091-3.htm" and cond == 3 :
      if st.getQuestItemsCount(ROUGH_JEWEL) == 10 :
         st.takeItems(ROUGH_JEWEL,-1)
         st.set("cond","4")
      else :
         htmltext = "30091-hvnore.htm"
   elif event == "30091-5.htm" and cond == 4 :
      if st.getQuestItemsCount(ORIHARUKON) >= 5 and st.getQuestItemsCount(SILVER_NUGGET) >= 500 and st.getQuestItemsCount(THONS) >= 150 :
         st.takeItems(ORIHARUKON,5)
         st.takeItems(SILVER_NUGGET,500)
         st.takeItems(THONS,150)
         st.giveItems(JEWEL_BOX,1)
         st.playSound("ItemSound.quest_finish")
         st.exitCurrentQuest(True)
      else :
         htmltext = "30091-hvnmat-bug.htm"
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30091 :
      if cond == 0 and st.getQuestItemsCount(JEWEL_BOX) == 0 :
         if st.getPlayer().getLevel() >= 60 :
            fwear=st.getPlayer().getQuestState("37_PleaseMakeMeFormalWear")
            if fwear :
               if fwear.get("cond") == "6" :
                  htmltext = "30091-0.htm"
               else :
                  st.exitCurrentQuest(True)
         else:
            htmltext = "30091-6.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 :
         htmltext = "30879-1r.htm"
      elif cond == 2 :
         htmltext = "30879-1r2.htm"
      elif cond == 3 and st.getQuestItemsCount(ROUGH_JEWEL) == 10 :
         htmltext = "30091-2.htm"
      elif cond == 4 and (st.getQuestItemsCount(ORIHARUKON) < 5 or st.getQuestItemsCount(SILVER_NUGGET) < 500 or st.getQuestItemsCount(THONS) < 150) :
         htmltext = "30091-hvnmat.htm"
      elif cond == 4 and st.getQuestItemsCount(ORIHARUKON) >= 5 and st.getQuestItemsCount(SILVER_NUGGET) >= 500 and st.getQuestItemsCount(THONS) >= 150 :
         htmltext = "30091-4.htm"
   elif npcId == 30879 :
      if cond == 1 :
         htmltext = "30879-0.htm"
      elif cond == 2 :
         htmltext = "30879-1r.htm"
   return htmltext


 def onKill (self,npc,st):
   count = st.getQuestItemsCount(ROUGH_JEWEL)
   if count < 10 :
      st.giveItems(ROUGH_JEWEL,1)
      if st.getQuestItemsCount(ROUGH_JEWEL) == 10 :
         st.playSound("ItemSound.quest_middle")
         st.set("cond","3")
      else:
         st.playSound("ItemSound.quest_itemget")	
   return

QUEST       = Quest(35,"35_FindGlitteringJewelry","Find Glittering Jewelry",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30091)
CREATED.addTalkId(30091)
STARTED.addTalkId(30091)
STARTED.addTalkId(30879)

STARTED.addKillId(20135)

STARTED.addQuestDrop(20135,ROUGH_JEWEL,1)

print "importing quests: 35: Find Glittering Jewelry"
