import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

LEAF_OF_EUCALYPTUS = 5893
STONE_OF_CHILL = 5894
REWARD = [5956,5957,5958]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30074-04.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "reward" :
      st.takeItems(LEAF_OF_EUCALYPTUS,-1)
      st.takeItems(STONE_OF_CHILL,-1)
      rand = st.getRandom(50)
      if rand < 25 :
         st.giveItems(REWARD[0],1)
         htmltext = "30074-rew1.htm"
      elif rand >= 25 and rand < 40 :
         st.giveItems(REWARD[1],1)
         htmltext = "30074-rew2.htm"
      elif rand >= 40 :
         st.giveItems(REWARD[2],1)
         htmltext = "30074-rew3.htm"
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
    elif event == "quit.htm" :
      st.set("cond","0")
      st.setState(COMPLETED)

    return htmltext

 def onTalk (Self,npc,st) :
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() < 20 :
         htmltext = "30074-00.htm"
         st.exitCurrentQuest(True)
      elif st.getPlayer().getLevel() >= 20 :
         htmltext = "30074-01.htm"
   elif cond == 1 and st.getQuestItemsCount(LEAF_OF_EUCALYPTUS) < 80 and st.getQuestItemsCount(STONE_OF_CHILL) < 100 :
         htmltext = "30074-04r.htm"
   elif cond == 1 and st.getQuestItemsCount(LEAF_OF_EUCALYPTUS) == 80 and st.getQuestItemsCount(STONE_OF_CHILL) < 100 :
         htmltext = "30074-chill.htm"
   elif cond == 1 and st.getQuestItemsCount(LEAF_OF_EUCALYPTUS) < 80 and st.getQuestItemsCount(STONE_OF_CHILL) == 100 :
         htmltext = "30074-leaf.htm"
   elif cond == 2 and st.getQuestItemsCount(LEAF_OF_EUCALYPTUS) == 80 and st.getQuestItemsCount(STONE_OF_CHILL) == 100 :
         htmltext = "30074-05.htm"

   return htmltext

 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    if st.getRandom(10) < 8 :
       if npcId == 20292 and st.getQuestItemsCount(STONE_OF_CHILL) < 100:
          st.giveItems(STONE_OF_CHILL,1)
       else :
          if npcId == 20291 and st.getQuestItemsCount(LEAF_OF_EUCALYPTUS) < 80:
             st.giveItems(LEAF_OF_EUCALYPTUS,1)
       if st.getQuestItemsCount(LEAF_OF_EUCALYPTUS) == 80 and st.getQuestItemsCount(STONE_OF_CHILL) == 100 :
          st.playSound("ItemSound.quest_middle")
          st.set("cond","2")
       else :
          st.playSound("ItemSound.quest_itemget")
    return

QUEST       = Quest(379,"379_FantasyWine","Fantasy Wine")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30074)

CREATED.addTalkId(30074)
STARTED.addTalkId(30074)

STARTED.addKillId(20291)
STARTED.addKillId(20292)

for item in REWARD :
   STARTED.addQuestDrop(30074,item,1)
STARTED.addQuestDrop(20291,LEAF_OF_EUCALYPTUS,1)
STARTED.addQuestDrop(20292,STONE_OF_CHILL,1)

print "importing quests: 379: Fantasy Wine"