import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

TREASURE_MAP = 5915
REWARD = [1338,3452,3453,3455,4412,4413,4416,4417,952,956,2450,2451] + (4445,4457) + (4517,4529)
THIEF_KEY = 1661

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "selled" :
       htmltext = "30890-selled.htm"
       st.giveItems(57,1000)
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_accept")

    elif event == "showmap" :
       if st.getQuestItemsCount(TREASURE_MAP) < 1 :
          htmltext = "30890-havenot.htm"
          return htmltext
       else :
          htmltext = "30890-01-1.htm"

    elif event == "30890-04.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.takeItems(MAP,1)

    elif event == "30890-07.htm" :
       st.set("cond","2")

    elif event == "openchest" :
       if st.getQuestItemsCount(THIEF_KEY) < 1 :
          htmltext = "31148-02.htm"
       else :
          htmltext = "31148-03.htm"
          luck_adena = st.getRandom(100)
          if luck_adena in range(0,21) :
             st.giveItems(57,500)
          elif luck_adena in range(21,41) :
             st.giveItems(57,800)
          elif luck_adena in range(41,61) :
             st.giveItems(57,1000)
          elif luck_adena in range(61,81) :
             st.giveItems(57,1300)
          else :
             st.giveItems(57,1600)
          luck_item = st.getRandom(3)
          for luck_item in range(i) :
             st.giveItems(REWARD[st.getRandom(36)],1)
          st.set("cond","0")
          st.setState(COMPLETED)
          st.playSound("ItemSound.quest_finish")

    return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30890 :
      if cond == 0 :
         if st.getPlayer().getLevel() < 42 :
            htmltext = "30890-00.htm"
            st.exitCurrentQuest(True)
         elif st.getQuestItemsCount(TREASURE_MAP) < 1 :
            htmltext = "30890-00-1.htm"
         else :
            htmltext = "30890-01.htm"
      elif cond == 1 :
         htmltext = "30890-03.htm"
      elif cond == 2 :
         htmltext = "30890-03.htm"

   elif npcId == 31148 :
      if cond == 2 :
         htmltext = "31148-03.htm"

   return htmltext

QUEST       = Quest(383,"383_SearchingForTreasure","Searching for Treasure")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30890)

CREATED.addTalkId(30890)
STARTED.addTalkId(30890)
COMPLETED.addTalkId(30890)

STARTED.addQuestDrop(30890,57,1)
STARTED.addQuestDrop(31148,57,1)

print "importing quests: 383: Searching For Treasure"