import sys
from l2f import Config
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ANCIENT_SCROLL = 5902
RATE = int(Config.RATE_QUESTS_REWARD)

def checkNPC(st):
        if npcId in range(31095,31126) and not (npcId in [31100,31111,31112,31113]):
                valid = 1
                return valid

class Quest (JQuest) :
        
        def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)
        
        def onEvent (self,event,st) :
                htmltext = event
                if event == "14.htm" :
                        st.setState(STARTED)
                        st.playSound("ItemSound.quest_accept")
                        st.set("cond","1")
                elif event == "16.htm" :
                        htmltext = "quit.htm"
                        st.playSound("ItemSound.quest_finish")
                        st.exitCurrentQuest(True)
                return htmltext
        
        def onTalk (Self,npc,st):
                npcId = npc.getNpcId()
                htmltext = "<html><body>I have nothing to say you</body></html>"
                id = st.getState()
                if checkNPC(st) == 1 and st.getInt("cond") == 0 :
                        if st.getPlayer().getLevel() < 20 :
                                htmltext = "00.htm"
                                st.exitCurrentQuest(True)
                        else :
                                htmltext = "10.htm"
                elif st.getInt("cond") == 1 and st.getQuestItemsCount(ANCIENT_SCROLL) == 0 :
                        htmltext = "17.htm"
                elif st.getInt("cond") == 1 and st.getQuestItemsCount(ANCIENT_SCROLL) :
                        htmltext = "16.htm"
                        NumberScrolls = st.getQuestItemsCount(ANCIENT_SCROLL)
                        st.giveItems(5965,NumberScrolls)
                        st.takeItems(ANCIENT_SCROLL,-1)
                else:
                        st.exitCurrentQuest(True)
                return htmltext
        
        def onKill (self,npc,st):
                npcId = npc.getNpcId()
                mobLvl = npc.getLevel()
                charLvl = st.getPlayer().getLevel()
                n = charLvl - mobLvl
                if n in range(3,5) :
                        rand = 3
                elif n in range(5,9) :
                        rand = 2
                elif n in range(9,12) :
                        rand = 1
                elif n > 11 :
                        rand = 0
                else :
                        rand = 5
                if rand != 0 and st.getRandom(10) < rand :
                        st.giveItems(ANCIENT_SCROLL,RATE)
                        st.playSound("ItemSound.quest_itemget")
                return

QUEST       = Quest(385,"385_YokeofthePast","Yoke of the Past",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)

for npcId in range(31095,31126):
        if npcId in [31100,31111,31112,31113]:
                continue
        STARTED.addTalkId(npcId)
        CREATED.addTalkId(npcId)
        QUEST.addStartNpc(npcId)

for mobs in range(21208,21256):
        STARTED.addKillId(mobs)
        STARTED.addQuestDrop(mobs,ANCIENT_SCROLL,1)

print "importing quests: 385: Yoke of the Past"