#don by fatall
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
ROHMER = 30344
LUIS = 30386
IRIS = 30034

#QUEST ITEM
FEATHER_ORNAMENT = 7173
TOOTH_OF_TOTEM = 7174
LETTER_OF_IRIS = 7176
LETTER_OF_ROHMER = 7177
TOOTH_OF_DRAGON = 7175

#MOBS
LANGK_LIZARDMAN_LIEUTENANT = 20357
LANGK_LIZARDMAN_SENTINEL = 21100
LANGK_LIZARDMAN_LEADER = 20356
LANGK_LIZARDMAN_SHAMAN = 21101

#CHANCE FOR DROP
CHANCE_FOR_QUEST_ITEMS = 100

#REWARD
ADENA = 57
BONE_HELMET = 45
ASSAULT_BOOTS = 1125
BLUE_BUCKSKIN_BOOTS = 1123

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   cond = st.getInt("cond")
   if event == "30386-3.htm" :
     if cond == 0 :
       st.setState(STARTED)
       st.set("cond","1")
       st.playSound("ItemSound.quest_accept")
   if event == "30386-5.htm" :
     if cond == 2 :
       st.set("cond","3")
       st.takeItems(FEATHER_ORNAMENT,100)
       st.giveItems(TOOTH_OF_TOTEM,1)
       st.playSound("ItemSound.quest_middle")
   if event == "30034-2.htm" :
     if cond == 3 :
       st.set("cond","4") 
       st.takeItems(TOOTH_OF_TOTEM,1)      
       st.giveItems(LETTER_OF_IRIS,1)
       st.playSound("ItemSound.quest_middle")
   if event == "30344-2.htm" :
     if cond == 4 :
       st.set("cond","5")
       st.takeItems(LETTER_OF_IRIS,1)
       st.giveItems(LETTER_OF_ROHMER,1)
       st.playSound("ItemSound.quest_middle")
   if event == "30034-6.htm" :
     if cond == 5 :
       st.set("cond","6")
       st.takeItems(LETTER_OF_ROHMER,1)
       st.playSound("ItemSound.quest_middle")   
   if event == "30034-9.htm" :
     if cond == 7 :
       st.set("cond","0")
       st.takeItems(TOOTH_OF_DRAGON,50)
       luck = st.getRandom(3)
       if luck == 0 :
          st.giveItems(BLUE_BUCKSKIN_BOOTS,1)
          st.giveItems(ADENA,1500)
       if luck == 1 :
          st.giveItems(BONE_HELMET,1)
          st.giveItems(ADENA,5200)
       if luck == 2 :
          st.giveItems(ASSAULT_BOOTS,1)
          st.giveItems(ADENA,1500)
       st.playSound("ItemSound.quest_finish")
       st.setState(COMPLETED)
   return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == LUIS and cond == 0 :
      if id == COMPLETED :
         htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif st.getPlayer().getLevel() < 19 :
         htmltext = "30386-2.htm"
         st.exitCurrentQuest(True)
      elif st.getPlayer().getLevel() >= 19 :
         htmltext = "30386-1.htm"

   if npcId == LUIS and cond == 1 :
         htmltext = "30386-6.htm"
   if npcId == LUIS and cond == 2 and st.getQuestItemsCount(FEATHER_ORNAMENT) == 100 : 
         htmltext = "30386-4.htm"
   if npcId == LUIS and cond == 3 : 
         htmltext = "30386-7.htm"
   if npcId == IRIS and cond == 3 and st.getQuestItemsCount(TOOTH_OF_TOTEM) == 1 :
         htmltext = "30034-1.htm"
   if npcId == IRIS and cond == 4 :
         htmltext = "30034-3.htm"
   if npcId == IRIS and cond == 5 and st.getQuestItemsCount(LETTER_OF_ROHMER) == 1 :
         htmltext = "30034-5.htm"
   if npcId == IRIS and cond == 6 :
         htmltext = "30034-7.htm"
   if npcId == IRIS and cond == 7 and st.getQuestItemsCount(TOOTH_OF_DRAGON) == 50 :
         htmltext = "30034-8.htm"
   if npcId == ROHMER and cond == 4 and st.getQuestItemsCount(LETTER_OF_IRIS) == 1 :
         htmltext = "30344-1.htm"
   if npcId == ROHMER and cond == 5 :
         htmltext = "30344-3.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   chance = st.getRandom(100)
   cond = st.getInt("cond")
   if npcId in [20357,21100] :
     if cond == 1 and CHANCE_FOR_QUEST_ITEMS > chance and st.getQuestItemsCount(FEATHER_ORNAMENT) < 100 :
       st.giveItems(FEATHER_ORNAMENT,1)
       if st.getQuestItemsCount(FEATHER_ORNAMENT) == 100 :        
         st.playSound("ItemSound.quest_middle")
         st.set("cond","2")
       else:
        st.playSound("ItemSound.quest_itemget")
   if npcId in [20356,21101] :
     if cond == 6 and CHANCE_FOR_QUEST_ITEMS > chance and st.getQuestItemsCount(TOOTH_OF_DRAGON) < 50 :
       st.giveItems(TOOTH_OF_DRAGON,1)
       if st.getQuestItemsCount(TOOTH_OF_DRAGON) == 50 :
         st.playSound("ItemSound.quest_middle")
         st.set("cond","7")
       else:
        st.playSound("ItemSound.quest_itemget")
   return 

QUEST       = Quest(38,"38_DragonFangs","Dradon Fangs")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(LUIS)
CREATED.addTalkId(LUIS)
STARTED.addTalkId(LUIS)
STARTED.addTalkId(IRIS)
STARTED.addTalkId(ROHMER)

STARTED.addKillId(LANGK_LIZARDMAN_LEADER)
STARTED.addKillId(LANGK_LIZARDMAN_SHAMAN)
STARTED.addKillId(LANGK_LIZARDMAN_SENTINEL)
STARTED.addKillId(LANGK_LIZARDMAN_LIEUTENANT)

STARTED.addQuestDrop(LUIS,TOOTH_OF_TOTEM,1)
STARTED.addQuestDrop(IRIS,LETTER_OF_IRIS,1)
STARTED.addQuestDrop(ROHMER,LETTER_OF_ROHMER,1)
STARTED.addQuestDrop(LANGK_LIZARDMAN_SHAMAN,TOOTH_OF_DRAGON,1)
STARTED.addQuestDrop(LANGK_LIZARDMAN_LEADER,TOOTH_OF_DRAGON,1)
STARTED.addQuestDrop(LANGK_LIZARDMAN_SENTINEL,FEATHER_ORNAMENT,1)
STARTED.addQuestDrop(LANGK_LIZARDMAN_LIEUTENANT,FEATHER_ORNAMENT,1)

print "importing quests: 38: Dragon Fangs"