# Last fix 16/04/07 by ValianT
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

StartNpc = 30141
Monster = [20031,20041,20046,20048,20052,20057]

OnyxBeastEye,TaintStone,SuccubusBlood = 1081,1082,1083

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st) :
        htmltext = event
        if event == "30141-03.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        return htmltext

    def onTalk (Self,npc,st):
        htmltext = "<html><body>I have nothing to say you</body></html>"
        npcId = npc.getNpcId()
        id = st.getState()
        if id in [CREATED,ABORTED] :
            if st.getPlayer().getRace().ordinal() != 2 :
                htmltext = "30141-00.htm"
                st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 16 :
                htmltext = "30141-02.htm"
                return htmltext
            else:
                htmltext = "30141-01.htm"
                st.exitCurrentQuest(True)
        elif id == STARTED :
            if st.getQuestItemsCount(OnyxBeastEye) and st.getQuestItemsCount(TaintStone) and st.getQuestItemsCount(SuccubusBlood) :
                htmltext = "30141-06.htm"
                st.takeItems(OnyxBeastEye,-1)
                st.takeItems(TaintStone,-1)
                st.takeItems(SuccubusBlood,-1)
                st.giveItems(57,4900)
                st.addExpAndSp(5000,0)
                st.unset("cond")
                st.setState(COMPLETED)
                st.playSound("ItemSound.quest_finish")
            else :
                htmltext = "30141-04.htm"
        elif id == COMPLETED :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
        return htmltext

    def onKill (self,npc,st):
        npcId = npc.getNpcId()
        id = st.getState()
        if id == STARTED :
            if npcId == Monster[0] and st.getQuestItemsCount(OnyxBeastEye) == 0 :
                st.giveItems(OnyxBeastEye,1)
                st.playSound("ItemSound.quest_itemget")
            elif (npcId in [Monster[1],Monster[2]]) and st.getQuestItemsCount(TaintStone) == 0 :
                st.giveItems(TaintStone,1)
                st.playSound("ItemSound.quest_itemget")
            elif (npcId in [Monster[3],Monster[4],Monster[5]]) and st.getQuestItemsCount(SuccubusBlood) == 0 :
                st.giveItems(SuccubusBlood,1)
                st.playSound("ItemSound.quest_itemget")

            if st.getQuestItemsCount(OnyxBeastEye) and st.getQuestItemsCount(TaintStone) and st.getQuestItemsCount(SuccubusBlood) :
                st.set("cond","2")
                st.playSound("ItemSound.quest_middle")
        return

QUEST = Quest(3,"3_WilltheSealbeBroken","Will the Seal be Broken?")
CREATED = State('Start', QUEST)
STARTED = State('Started', QUEST)
ABORTED = State('Aborted', QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(StartNpc)

CREATED.addTalkId(StartNpc)
STARTED.addTalkId(StartNpc)
COMPLETED.addTalkId(StartNpc)

for npcId in Monster :
    STARTED.addKillId(npcId)

STARTED.addQuestDrop(Monster[0],OnyxBeastEye, 1)
STARTED.addQuestDrop(Monster[1],TaintStone,   1)
STARTED.addQuestDrop(Monster[2],TaintStone,   1)
STARTED.addQuestDrop(Monster[3],SuccubusBlood,1)
STARTED.addQuestDrop(Monster[4],SuccubusBlood,1)
STARTED.addQuestDrop(Monster[5],SuccubusBlood,1)

print "importing quests: 3: Will the Seal be Broken?"
