import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

LETTER_OF_ORDER1 = 1191
LETTER_OF_ORDER2 = 1192
BOOK_OF_LEMONIELL = 1193
BOOK_OF_VIVI = 1194
BOOK_OF_SIMLON = 1195
BOOK_OF_PRAGA = 1196
CERTIFICATE_OF_GALLINT = 1197
PENDANT_OF_MOTHER = 1198
NECKLACE_OF_MOTHER = 1199
LEMONIELLS_COVENANT = 1200
MARK_OF_FAITH = 1201

def checkBooks(st):
   if st.getQuestItemsCount(BOOK_OF_PRAGA) + st.getQuestItemsCount(BOOK_OF_VIVI) + st.getQuestItemsCount(BOOK_OF_SIMLON) >= 5 :
      st.set("cond","2")

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "1" :
        if st.getPlayer().getLevel() >= 19 and st.getPlayer().getClassId().getId() == 0x0a and st.getQuestItemsCount(MARK_OF_FAITH) == 0 :
          st.set("cond","1")
          st.setState(STARTED)
          st.playSound("ItemSound.quest_accept")
          st.giveItems(LETTER_OF_ORDER1,1)
          htmltext = "30022-05.htm"
        elif st.getPlayer().getClassId().getId() != 0x0a :
            if st.getPlayer().getClassId().getId() == 0x0f :
              htmltext = "30022-02a.htm"
            else:
              htmltext = "30022-02.htm"
        elif st.getPlayer().getLevel()<19 and st.getPlayer().getClassId().getId() == 0x0a :
            htmltext = "30022-03.htm"
        elif st.getPlayer().getLevel() >= 19 and st.getPlayer().getClassId().getId() == 0x0a and st.getQuestItemsCount(MARK_OF_FAITH) == 1 :
            htmltext = "30022-04.htm"
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30022 :
      if cond == 0 and id == COMPLETED :
         htmltext = "30022-04.htm"
         return htmltext
      if cond == 0 :
         if st.getQuestItemsCount(MARK_OF_FAITH) == 0 :
            htmltext = "30022-01.htm"
            return htmltext
         else:
            htmltext = "30022-04.htm"
      elif cond in [1,2] and st.getQuestItemsCount(LETTER_OF_ORDER1) == 1 :
         if st.getQuestItemsCount(BOOK_OF_VIVI) == 1 and st.getQuestItemsCount(BOOK_OF_SIMLON) == 3 and st.getQuestItemsCount(BOOK_OF_PRAGA) == 1 :
            htmltext = "30022-08.htm"
            st.takeItems(BOOK_OF_PRAGA,1)
            st.takeItems(BOOK_OF_VIVI,1)
            st.takeItems(BOOK_OF_SIMLON,3)
            st.takeItems(LETTER_OF_ORDER1,1)
            st.giveItems(LETTER_OF_ORDER2,1)
            st.set("cond","3")
         else:
            htmltext = "30022-06.htm"
      elif cond < 6 and st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 :
         htmltext = "30022-07.htm"
      elif cond == 6 and st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 and st.getQuestItemsCount(LEMONIELLS_COVENANT) == 1 :
         htmltext = "30022-09.htm"
         st.takeItems(LEMONIELLS_COVENANT,1)
         st.takeItems(LETTER_OF_ORDER2,1)
         st.giveItems(MARK_OF_FAITH,1)
         st.addExpAndSp(3200,5610)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == 30253 and cond == 1 and st.getQuestItemsCount(LETTER_OF_ORDER1) == 1 :
      if st.getQuestItemsCount(BOOK_OF_SIMLON) == 0 :
         htmltext = "30253-01.htm"
         st.giveItems(BOOK_OF_SIMLON,3)
         checkBooks(st)
      elif st.getQuestItemsCount(BOOK_OF_SIMLON) > 0 :
         htmltext = "30253-02.htm"
   elif npcId == 30030 and cond == 1 and st.getQuestItemsCount(LETTER_OF_ORDER1) == 1 :
      if st.getQuestItemsCount(BOOK_OF_VIVI) == 0 :
         htmltext = "30030-01.htm"
         st.giveItems(BOOK_OF_VIVI,1)
         checkBooks(st)
      elif st.getQuestItemsCount(BOOK_OF_VIVI) == 1 :
         htmltext = "30030-02.htm"
   elif npcId == 30333 and cond == 1 and st.getQuestItemsCount(LETTER_OF_ORDER1) == 1 :
      if st.getQuestItemsCount(BOOK_OF_PRAGA) == 0 and st.getQuestItemsCount(NECKLACE_OF_MOTHER) == 0 :
         htmltext = "30333-01.htm"
         st.giveItems(NECKLACE_OF_MOTHER,1)
      elif st.getQuestItemsCount(BOOK_OF_PRAGA) == 0 and st.getQuestItemsCount(NECKLACE_OF_MOTHER) == 1 and st.getQuestItemsCount(PENDANT_OF_MOTHER) == 0 :
         htmltext = "30333-02.htm"
      elif st.getQuestItemsCount(BOOK_OF_PRAGA) == 0 and st.getQuestItemsCount(NECKLACE_OF_MOTHER) == 1 and st.getQuestItemsCount(PENDANT_OF_MOTHER) == 1 :
         htmltext = "30333-03.htm"
         st.takeItems(NECKLACE_OF_MOTHER,1)
         st.takeItems(PENDANT_OF_MOTHER,1)
         st.giveItems(BOOK_OF_PRAGA,1)
         checkBooks(st)
      elif st.getQuestItemsCount(BOOK_OF_PRAGA) > 0 :
         htmltext = "30333-04.htm"
   elif npcId == 30408 :
      if st.getQuestItemsCount(LETTER_OF_ORDER2) == 0 :
         htmltext = "30408-02.htm"
      elif cond == 3 and st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 and st.getQuestItemsCount(BOOK_OF_LEMONIELL) == 0 and st.getQuestItemsCount(LEMONIELLS_COVENANT) == 0 and st.getQuestItemsCount(CERTIFICATE_OF_GALLINT) == 0 :
         htmltext = "30408-01.htm"
         st.giveItems(BOOK_OF_LEMONIELL,1)
         st.set("cond","4")
      elif cond == 4 and st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 and st.getQuestItemsCount(BOOK_OF_LEMONIELL) == 1 and st.getQuestItemsCount(LEMONIELLS_COVENANT) == 0 and st.getQuestItemsCount(CERTIFICATE_OF_GALLINT) == 0 :
         htmltext = "30408-03.htm"
      elif st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 and st.getQuestItemsCount(BOOK_OF_LEMONIELL) == 0 and st.getQuestItemsCount(LEMONIELLS_COVENANT) == 0 and st.getQuestItemsCount(CERTIFICATE_OF_GALLINT) == 1 :
         htmltext = "30408-04.htm"
         st.takeItems(CERTIFICATE_OF_GALLINT,1)
         st.giveItems(LEMONIELLS_COVENANT,1)
         st.set("cond","6")
      elif st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 and st.getQuestItemsCount(BOOK_OF_LEMONIELL) == 0 and st.getQuestItemsCount(LEMONIELLS_COVENANT) == 1 and st.getQuestItemsCount(CERTIFICATE_OF_GALLINT) == 0 :
         htmltext = "30408-05.htm"
   elif npcId == 30017 and st.getQuestItemsCount(LETTER_OF_ORDER2) == 1 :
      if cond == 4 and st.getQuestItemsCount(BOOK_OF_LEMONIELL) == 1 and st.getQuestItemsCount(CERTIFICATE_OF_GALLINT) == 0 :
         htmltext = "30017-01.htm"
         st.takeItems(BOOK_OF_LEMONIELL,1)
         st.giveItems(CERTIFICATE_OF_GALLINT,1)
         st.set("cond","5")
      elif cond == 5 and st.getQuestItemsCount(BOOK_OF_LEMONIELL) == 0 and st.getQuestItemsCount(CERTIFICATE_OF_GALLINT) == 1 :
         htmltext = "30017-02.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if npcId == 20026 or npcId == 20029 :
      if st.getInt("cond") == 1 and st.getQuestItemsCount(PENDANT_OF_MOTHER) == 0 :
         st.giveItems(PENDANT_OF_MOTHER,1)
         st.playSound("ItemSound.quest_middle")
   return

QUEST       = Quest(405,"405_PathToCleric","Path To Cleric")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30022)

CREATED.addTalkId(30022)
COMPLETED.addTalkId(30022)
STARTED.addTalkId(30017)
STARTED.addTalkId(30022)
STARTED.addTalkId(30030)
STARTED.addTalkId(30253)
STARTED.addTalkId(30333)
STARTED.addTalkId(30408)

STARTED.addKillId(20026)
STARTED.addKillId(20029)

STARTED.addQuestDrop(30408,LEMONIELLS_COVENANT,1)
STARTED.addQuestDrop(30022,LETTER_OF_ORDER2,1)
STARTED.addQuestDrop(30333,BOOK_OF_PRAGA,1)
STARTED.addQuestDrop(30030,BOOK_OF_VIVI,1)
STARTED.addQuestDrop(30253,BOOK_OF_SIMLON,1)
STARTED.addQuestDrop(30022,LETTER_OF_ORDER1,1)
STARTED.addQuestDrop(30333,NECKLACE_OF_MOTHER,1)
STARTED.addQuestDrop(20026,PENDANT_OF_MOTHER,1)
STARTED.addQuestDrop(20029,PENDANT_OF_MOTHER,1)
STARTED.addQuestDrop(30017,CERTIFICATE_OF_GALLINT,1)
STARTED.addQuestDrop(30408,BOOK_OF_LEMONIELL,1)

print "importing quests: 405: Path To Cleric"