# ~~~ Make by ValianT ~~~ #
# ~~~~~~~~~~~~~~~~~~~~~~~ #
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

npcTable = {
    30668 : [[1,"katari_q0422_01.htm"],       [5,4326,10,"katari_q0422_02.htm","katari_q0422_03.htm"],             [9,"katari_q0422_04.htm"]],
    30597 : [[2,"piotur_q0422_01.htm"],       [6,4327,10,"piotur_q0422_02.htm","piotur_q0422_03.htm"],             [10,"piotur_q0422_04.htm"]],
    30612 : [[3,"sage_kasian_q0422_01.htm"],  [7,4328,1,"sage_kasian_q0422_02.htm","sage_kasian_q0422_03.htm"],    [11,"sage_kasian_q0422_04.htm"]],
    30718 : [[4,"magister_joan_q0422_01.htm"],[8,4329,3,"magister_joan_q0422_02.htm","magister_joan_q0422_03.htm"],[12,"magister_joan_q0422_04.htm"]]
    }
mobsTable = {
    20039 : [5,4326,10],
    20494 : [6,4327,10],
    20193 : [7,4328,1],
    20561 : [8,4329,3]
    }

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st):
        htmltext = event
        if event == "StartQuest" :
            if st.getInt("count") < 16 :
                if st.getPlayer().getLevel() > 20 and st.getPlayer().getLevel() < 31 :
                    SoundEffect(talker,"ItemSound.quest_accept")
                    htmltext = "black_judge_q0422_04.htm"
                    st.set("id","2")
                    st.set("cond","3")
                    st.setState(STARTED)
                elif st.getPlayer().getLevel() < 21 :
                    htmltext = "black_judge_q0422_03.htm"
                    st.set("id","1")
                    st.set("cond","1")
                    st.set("cond","2")
                    st.setState(STARTED)
                elif st.getPlayer().getLevel() > 30 and st.getPlayer().getLevel() < 41 :
                    htmltext = "black_judge_q0422_05.htm"
                    st.set("Ex","3")
                    st.set("cond","4")
                    st.setState(STARTED)
                else :
                    htmltext = "black_judge_q0422_06.htm"
                    st.set("Ex","4")
                    st.set("cond","5")
                    st.setState(STARTED)
            return htmltext
        elif event == "black_judge_q0422_11.htm" :
            st.takeItems(4330,-1)
            st.takeItems(4426,-1)
            PetLevel = str(st.getPlayer().getLevel())
            st.giveItems(4425,1,int(PetLevel))
            st.set("Ex",str(PetLevel))
            st.set("cond","16")
        elif event == "black_judge_q0422_14.htm" :
            if st.getInt("id") >= 9 and st.getInt("id") <= 12 :
                return htmltext
            else : return " "
        elif event == "black_judge_q0422_15t.htm" :
            if st.getQuestItemsCount(4425) :
                if st.getPlayer().getLevel() > st.getInt("Ex") :
                    i1 = st.getEnchantLevel(4425) - st.getInt("Ex") - ( st.getPlayer().getLevel() - st.getInt("Ex"))
                else :
                    i1 = st.getEnchantLevel(4425) - st.getInt("Ex")
                if i1 < 0 :
                    i1 = 0
                i0 = int(st.getRandom(10) * i1) + 1
                if st.getPlayer().getPkKills() <= i0 :
                    st.takeItems(4425,-1)
                    st.giveItems(4426,1)
                    htmltext = "black_judge_q0422_15.htm"
                    if st.getPlayer().getPkKills() - i0 < 0 :
                        st.getPlayer().setPkKills(0)
                        st.getPlayer().broadcastUserInfo()
                    else :
                        st.getPlayer().setPkKills(st.getPlayer().getPkKills() - i0);
                        st.getPlayer().broadcastUserInfo()
                    st.setState(COMPLETED)
                    st.playSound("ItemSound.quest_finish")
                else :
                    st.giveItems(4426,1)
                    st.takeItems(4425,1)
                    htmltext = "black_judge_q0422_16.htm"
                    st.getPlayer().setPkKills(st.getPlayer().getPkKills() - i0)
                    st.getPlayer().broadcastUserInfo()
                    st.unset("Ex")
            return htmltext
        elif event == "black_judge_q0422_17.htm" :
            if st.getInt("id") >= 9 and st.getInt("id") <= 12 :
                return htmltext
            else :
                return " "
        elif event == "black_judge_q0422_18.htm" :
            if st.getInt("id") >= 9 and st.getInt("id") <= 12 :
                st.unset("Ex")
                st.takeItems(4326,-1)
                st.takeItems(4327,-1)
                st.takeItems(4328,-1)
                st.takeItems(4329,-1)
                st.takeItems(4330,-1)
                st.takeItems(4331,-1)
                st.takeItems(4425,-1)
                st.setState(COMPLETED)
                st.playSound("ItemSound.quest_finish")
        elif event == "changeSubClass" :
            st.takeItems(4326,-1)
            st.takeItems(4327,-1)
            st.takeItems(4328,-1)
            st.takeItems(4329,-1)
            st.takeItems(4330,-1)
            st.takeItems(4331,-1)
            st.takeItems(4425,-1)
            st.exitCurrentQuest(True)
            return
        return htmltext

    def onTalk (Self,npc,st):
        npcId = npc.getNpcId()
        htmltext = "<html><head><body>I have nothing to say you</body></html>"
        cond = st.getInt("cond")
        id = st.getState()
        PlayerLevel = st.getPlayer().getLevel()
        if npcId == 30981 :
            if id == CREATED or id == COMPLETED :
                if st.getPlayer().getPkKills() == 0 :
                    htmltext = "black_judge_q0422_01.htm"
                else :
                    htmltext = "black_judge_q0422_02.htm"
            if id == STARTED or id == COMPLETED :
                if st.getInt("id") == 1000 :
                    st.takeItems(4425,1)
                if st.getInt("id") < 9 :
                    htmltext = "black_judge_q0422_07.htm"
                    if st.getQuestItemsCount(4426) >= 1 :
                        htmltext = "black_judge_q0422_16t.htm"
                    st.set("id","9")
                elif st.getInt("id") >= 9 and st.getInt("id") <= 12 :
                    if st.getQuestItemsCount(4426) == 0 and st.getQuestItemsCount(4425) == 0 :
                        if st.getQuestItemsCount(4330) == 0 :
                            if st.getQuestItemsCount(4331) == 0 :
                                st.giveItems(4331,1)
                                htmltext = "black_judge_q0422_08.htm"
                                st.set("cond","14")
                            else :
                                htmltext = "black_judge_q0422_09.htm"
                        else :
                            htmltext = "black_judge_q0422_10.htm"
                    elif st.getQuestItemsCount(4425) >= 1 :
                        item = st.getEnchantLevel(4425)
                        Ex = st.getInt("Ex") + 1
                        if item < Ex :
                            htmltext = "black_judge_q0422_12.htm"
                        else :
                            htmltext = "black_judge_q0422_13.htm"
                    elif st.getQuestItemsCount(4426) >= 1 :
                        htmltext = "black_judge_q0422_16t.htm"
                return htmltext
        elif npcId == 30300 :
            if id == STARTED and st.getInt("id") >= 9 and st.getInt("id") <= 12 and \
               st.getQuestItemsCount(4331) >= 1 and st.getQuestItemsCount(1892) > 0 and \
               st.getQuestItemsCount(1880) >= 5 and st.getQuestItemsCount(1877) >= 2 and \
               st.getQuestItemsCount(1873) >= 10 and st.getQuestItemsCount(1879) >= 10 and \
               st.getQuestItemsCount(4330) == 0 and st.getQuestItemsCount(4425) == 0 and \
               st.getQuestItemsCount(4426) == 0 :
                st.giveItems(4330,1)
                st.takeItems(4331,1)
                st.takeItems(1892,1)
                st.takeItems(1880,5)
                st.takeItems(1877,2)
                st.takeItems(1873,10)
                st.takeItems(1879,10)
                htmltext = "blacksmith_pushkin_q0422_01.htm"
                st.set("cond","15")
            elif ( ( ( id == STARTED and st.getInt("id") >= 9 and st.getInt("id") <= 12 and \
                       st.getQuestItemsCount(4331) >= 1 and st.getQuestItemsCount(1873) < 10 or \
                       st.getQuestItemsCount(1879) < 10 ) and st.getQuestItemsCount(4330) == 0 ) and \
                       st.getQuestItemsCount(4425) == 0 ) and st.getQuestItemsCount(4426) == 0 :
                htmltext = "blacksmith_pushkin_q0422_02.htm"
            elif id == STARTED and st.getInt("id") >= 9 and st.getInt("id") <= 12 and \
                 ( st.getQuestItemsCount(4330) == 1 or st.getQuestItemsCount(4425) == 1 or st.getQuestItemsCount(4426) == 1 ):
                htmltext = "blacksmith_pushkin_q0422_03.htm"
        elif npcId in [30668,30597,30612,30718]:
            cond1, cond2, cond3 = npcTable[npcId]
            if st.getInt("id") in [1,2,3,4] :
                getId, html = cond1
                if st.getInt("id") == getId :
                    st.set("id",str(getId + 4))
                    st.set("cond",str(getId + 5))
                    htmltext = html
            elif st.getInt("id") in [5,6,7,8] :
                getId, itemId, count, html1, html2 = cond2
                if st.getInt("id") == getId :
                    if st.getQuestItemsCount(itemId) < count :
                        htmltext = html1
                    else :
                        st.set("id",str(getId + 4))
                        st.set("cond",str(getId + 5))
                        htmltext = html2
                        st.takeItems(itemId, -1)
            elif st.getInt("id") in [9,10,11,12] :
                getId, html = cond3
                if st.getInt("id") == getId :
                    htmltext = html
        return htmltext

    def onKill (self,npc,st):
        npcId = npc.getNpcId()
        if npcId in [20039,20494,20193,20561] :
            getId, itemId, count = mobsTable[npcId]
            if st.getInt("id") == getId :
                if st.getQuestItemsCount(itemId) < count :
                    n = count - 1
                    if st.getQuestItemsCount(itemId) == n :
                        st.playSound("ItemSound.quest_middle")
                    else :
                        st.playSound("ItemSound.quest_itemget")
                    st.giveItems(itemId,1)
        return

QUEST     = Quest(422,"422_RepentYourSins","Repent Your Sins")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30981)

CREATED.addTalkId(30981)
STARTED.addTalkId(30981)
STARTED.addTalkId(30668)
STARTED.addTalkId(30597)
STARTED.addTalkId(30612)
STARTED.addTalkId(30718)
STARTED.addTalkId(30300)
COMPLETED.addTalkId(30981)

STARTED.addKillId(20039)
STARTED.addKillId(20561)
STARTED.addKillId(20494)
STARTED.addKillId(20193)

print "importing quests: 422: Repent Your Sins"
