import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

MELODY_MAESTRO_KANTABILON = 31042
SILVER_CRYSTAL = 7540
WEDDING_ECHO_CRYSTAL = 7062

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)
 
 def onEvent (self,event,st) :
     htmltext = event
     if event == "31042-02.htm" :
         st.set("cond","1")
         st.setState(STARTED)
         st.playSound("ItemSound.quest_accept")
     elif event == "31042-05.htm" :
         st.takeItems(SILVER_CRYSTAL,50)
         st.giveItems(WEDDING_ECHO_CRYSTAL,25)
         st.playSound("ItemSound.quest_finish")
         st.unset("cond")
         st.setState(COMPLETED)
     return htmltext
 
 def onTalk (Self,npc,st):
     npcId = npc.getNpcId()
     htmltext = "<html><body>I have nothing to say you</body></html>"
     id = st.getState()
     cond = st.getInt("cond")
     if npcId == 31042 :
        if id != STARTED :
           if st.getPlayer().getLevel() < 38 :
              htmltext = "31042-00.htm"
              st.exitCurrentQuest(True)
           else :
              htmltext = "31042-01.htm"
        elif cond == 1 :
           htmltext = "31042-03.htm"
        elif cond == 2 and st.getQuestItemsCount(SILVER_CRYSTAL) == 50 :
           htmltext = "31042-04.htm"
     
     return htmltext
 
 def onKill(self,npc,st):
     npcId = npc.getNpcId()     
     if npcId == 20786 or npcId == 20787 :
         if st.getInt("cond") == 1 and st.getQuestItemsCount(SILVER_CRYSTAL) < 50 :
             st.giveItems(SILVER_CRYSTAL,1)
             if st.getQuestItemsCount(SILVER_CRYSTAL) == 50 :
                 st.playSound("ItemSound.quest_middle")
                 st.set("cond","2")
             else :
                 st.playSound("ItemSound.quest_itemget")
     return
 
QUEST       = Quest(431,"431_WeddingMarch","Wedding March")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31042)

CREATED.addTalkId(31042)
STARTED.addTalkId(31042)
COMPLETED.addTalkId(31042)

STARTED.addKillId(20786)
STARTED.addKillId(20787)

STARTED.addQuestDrop(20786,SILVER_CRYSTAL,1)
STARTED.addQuestDrop(20787,SILVER_CRYSTAL,1)
STARTED.addQuestDrop(31042,WEDDING_ECHO_CRYSTAL,1)

print "importing quests: 431: Wedding March"