#quest by zerghase

from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

LUNDY = 30827
DRIKUS = 30505

WORK_HAMMER = 168
GEMSTONE_FRAGMENT = 7552
GEMSTONE = 7553
PET_TICKET = 7585

MAILLE_GUARD = 20921
MAILLE_SCOUT = 20920
MAILLE_LIZARDMAN = 20919

class Quest (JQuest) :
 def onEvent(self, event, st):
    htmltext=event
    if event == "1" :
       htmltext="30827-01.htm"
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "3" and st.getQuestItemsCount(WORK_HAMMER) :
       htmltext = "30827-03.htm"
       st.takeItems(WORK_HAMMER,1)
       st.set("cond","2")
    elif event == "4" and st.getQuestItemsCount(GEMSTONE_FRAGMENT) >= 30 :
       htmltext = "30827-05.htm"
       st.takeItems(GEMSTONE_FRAGMENT,-1)
       st.giveItems(GEMSTONE,1)
       st.set("cond", "4")
    elif event == "5" and st.getQuestItemsCount(GEMSTONE) :
       htmltext = "30505-06.htm"
       st.takeItems(GEMSTONE,1)
       st.set("cond","5")
    elif event == "7" :
       htmltext = "30827-07.htm"
       st.giveItems(PET_TICKET,1)
       st.setState(COMPLETED)
    return htmltext

 def onTalk(self, npc, st):
    npcId=npc.getNpcId()
    htmltext="<html><head><body>I have nothing to say you</body></html>"
    id = st.getState()
    if id == CREATED:
       if st.getPlayer().getLevel() >= 24 :
          htmltext="30827-00.htm"
       else :
          st.exitCurrentQuest(True)
          htmltext = "30827-000.htm"
    elif id == STARTED:
       cond = st.getInt("cond")
       if npcId == LUNDY:
          if cond == 1 :
             if not st.getQuestItemsCount(WORK_HAMMER) :
                htmltext="30827-01a.htm"
             else:
                htmltext="30827-02.htm"
          elif cond == 2 :
             htmltext = "30827-03a.htm"
          elif cond == 3 :
             htmltext = "30827-04.htm"
          elif cond == 4 :
             htmltext = "30827-05a.htm"
          elif cond == 5 :
             htmltext = "30827-06.htm"
       elif npcId == DRIKUS:
          if cond == 4 and st.getQuestItemsCount(GEMSTONE) :
             htmltext = "30505-05.htm"
          elif cond == 5 :
             htmltext = "30505-06a.htm"
    elif id == COMPLETED :
       htmltext = "<html><head><body>This quest have already been completed.</body></html>"
    return htmltext

 def onKill(self, npc, st):
    npcId = npc.getNpcId()
    cond = st.getInt("cond")
    if cond == 2 and st.getQuestItemsCount(GEMSTONE_FRAGMENT) < 30 :
       st.giveItems(GEMSTONE_FRAGMENT,1)
       if st.getQuestItemsCount(GEMSTONE_FRAGMENT) == 30 :
          st.playSound("ItemSound.quest_middle")
          st.set("cond", "3")
          st.playSound("ItemSound.quest_itemget")
       else :
          st.playSound("ItemSound.quest_itemget")
    return

QUEST		= Quest(44,"44_HelpTheSon","Help The Son!")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(LUNDY)

CREATED.addTalkId(LUNDY)

STARTED.addTalkId(LUNDY)
STARTED.addTalkId(DRIKUS)

STARTED.addKillId(MAILLE_GUARD)
STARTED.addKillId(MAILLE_SCOUT)
STARTED.addKillId(MAILLE_LIZARDMAN)

STARTED.addQuestDrop(MAILLE_GUARD,GEMSTONE_FRAGMENT,1)
STARTED.addQuestDrop(MAILLE_SCOUT,GEMSTONE_FRAGMENT,1)
STARTED.addQuestDrop(MAILLE_LIZARDMAN,GEMSTONE_FRAGMENT,1)

print "importing quests: 44: Help The Son!"