import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

BOLTER = 30554
SHARI  = 30517
GARITA = 30518
REED   = 30520
BRUNON = 30526

BOLTERS_LIST         = 1547
MINING_BOOTS         = 1548
MINERS_PICK          = 1549
BOOMBOOM_POWDER      = 1550
REDSTONE_BEER        = 1551
BOLTERS_SMELLY_SOCKS = 1552
 
NECKLACE = 906
 
class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30554-03.htm" :
     st.giveItems(BOLTERS_LIST,1)
     st.giveItems(BOLTERS_SMELLY_SOCKS,1)
     st.setState(STARTED)
     st.set("cond","1")
     st.playSound("ItemSound.quest_accept")
   elif event == "30526-02.htm" :
     st.takeItems(BOLTERS_SMELLY_SOCKS,-1)
     st.giveItems(MINERS_PICK,1)
     if st.getQuestItemsCount(BOLTERS_LIST) and (st.getQuestItemsCount(MINING_BOOTS) + st.getQuestItemsCount(MINERS_PICK) + st.getQuestItemsCount(BOOMBOOM_POWDER) + st.getQuestItemsCount(REDSTONE_BEER) >= 4) :
       st.set("cond","2")
       st.playSound("ItemSound.quest_middle")
     else:
       st.playSound("ItemSound.quest_itemget")
   return htmltext

 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond") 
   if npcId == BOLTER :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 2 :
               htmltext = "30554-02.htm"
            else:
               htmltext = "30554-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "30554-04.htm"
      elif cond == 2 :
         htmltext = "30554-06.htm"
         st.takeItems(MINING_BOOTS,-1)
         st.takeItems(MINERS_PICK,-1)
         st.takeItems(BOOMBOOM_POWDER,-1)
         st.takeItems(REDSTONE_BEER,-1)
         st.takeItems(BOLTERS_LIST,-1)
         st.giveItems(NECKLACE,1)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == SHARI and cond == 1 and st.getQuestItemsCount(BOLTERS_LIST) :
      if st.getQuestItemsCount(BOOMBOOM_POWDER) == 0 :
         htmltext = "30517-01.htm"
         st.giveItems(BOOMBOOM_POWDER,1)
         st.playSound("ItemSound.quest_itemget")
      else:
         htmltext = "30517-02.htm"
   elif npcId == GARITA and cond == 1 and st.getQuestItemsCount(BOLTERS_LIST) :
      if st.getQuestItemsCount(MINING_BOOTS) == 0 :
         htmltext = "30518-01.htm"
         st.giveItems(MINING_BOOTS,1)
         st.playSound("ItemSound.quest_itemget")
      else:
         htmltext = "30518-02.htm"
   elif npcId == REED and cond == 1 and st.getQuestItemsCount(BOLTERS_LIST) :
      if st.getQuestItemsCount(REDSTONE_BEER) == 0 :
         htmltext = "30520-01.htm"
         st.giveItems(REDSTONE_BEER,1)
         st.playSound("ItemSound.quest_itemget")
      else:
         htmltext = "30520-02.htm"
   elif npcId == BRUNON and cond == 1 and st.getQuestItemsCount(BOLTERS_LIST) :
      if st.getQuestItemsCount(MINERS_PICK) == 0 :
         htmltext = "30526-01.htm"
      else:
         htmltext = "30526-03.htm"
   if st.getQuestItemsCount(BOLTERS_LIST) and (st.getQuestItemsCount(MINING_BOOTS) + st.getQuestItemsCount(MINERS_PICK) + st.getQuestItemsCount(BOOMBOOM_POWDER) + st.getQuestItemsCount(REDSTONE_BEER) == 4) :
      st.set("cond","2")
      st.playSound("ItemSound.quest_middle")
   return htmltext

QUEST     = Quest(5,"5_MinersFavor","Miner's Favor")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(BOLTER)

CREATED.addTalkId(BOLTER)

STARTED.addTalkId(SHARI)
STARTED.addTalkId(GARITA)
STARTED.addTalkId(REED)
STARTED.addTalkId(BRUNON)
STARTED.addTalkId(BOLTER)

STARTED.addQuestDrop(BOLTER,BOLTERS_LIST,1)
STARTED.addQuestDrop(BOLTER,BOLTERS_SMELLY_SOCKS,1)
STARTED.addQuestDrop(GARITA,MINING_BOOTS,1)
STARTED.addQuestDrop(BRUNON,MINERS_PICK,1)
STARTED.addQuestDrop(SHARI,BOOMBOOM_POWDER,1)
STARTED.addQuestDrop(REED,REDSTONE_BEER,1)
STARTED.addQuestDrop(BOLTER,NECKLACE,1)

print "importing quests: 5: Miner's Favor"