# by disKret
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
EYE_OF_ARGOS = 31683
#ITEMS
PROOF_OF_AVENGER = 7188
#CHANCE
DROP_CHANCE = 50
#MOBS
MOBS = [ 21306,21308,21309,21310,21311 ]
REWARDS = [[6699,90000,0,19],[6698,80000,20,39],[6700,40000,40,49],[0,230000,50,100]]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   cond = st.getInt("cond")
   htmltext = event
   if event == "31683-1.htm" :
      if st.getPlayer().getLevel() < 71 : 
         htmltext = "31683-0a.htm"
         st.exitCurrentQuest(True)
      else :
         st.set("cond","1")
         st.setState(STARTED)
         st.playSound("ItemSound.quest_accept")
   elif event == "31683-4.htm" :
     random = st.getRandom(100)
     i = 0
     while i < len(REWARDS) :
       item,adena,chance,chance2=REWARDS[i]
       if chance<=random<= chance2 :
         break
       i = i+1
     st.giveItems(57,adena)
     if item :
       st.giveItems(item,5)
       st.addExpAndSp(120000,10000)
     st.takeItems(PROOF_OF_AVENGER,-1)
     st.playSound("ItemSound.quest_finish")
     st.exitCurrentQuest(True)
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      htmltext = "31683-0.htm"
   elif cond == 1 :
      htmltext = "31683-2.htm"
   elif cond == 2 and st.getQuestItemsCount(PROOF_OF_AVENGER) == 100 :
      htmltext = "31683-3.htm"
   else :
      htmltext="31683-4a.htm"
      st.set("cond","1")
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if (npcId in MOBS) and st.getInt("cond") == 1 :
     count = st.getQuestItemsCount(PROOF_OF_AVENGER)
     if count < 100 :
       if st.getRandom(100) < DROP_CHANCE : 
         st.giveItems(PROOF_OF_AVENGER,1)
         if count == 99 :
            st.playSound("ItemSound.quest_middle")
            st.set("cond","2")
         else:
            st.playSound("ItemSound.quest_itemget")	
   return

QUEST       = Quest(601,"601_WatchingEyes","Watching Eyes")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(EYE_OF_ARGOS)
CREATED.addTalkId(EYE_OF_ARGOS)
STARTED.addTalkId(EYE_OF_ARGOS)

for i in MOBS :
  STARTED.addKillId(i)

STARTED.addQuestDrop(EYE_OF_ARGOS,PROOF_OF_AVENGER,1)

print "importing quests: 601: Watching Eyes"