# Made by DJ_WEST! Version 1.0
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

EYE_OF_DARKNESS = 7189
ADENA_ID = 57
CHANCE = {
    21304:50,
    21299:45
}
REWARDS = [[6699,40000,120000,20000,0,19],[6698,60000,110000,15000,20,39],[6700,40000,150000,10000,40,49],[0,100000,140000,11250,50,100]]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "31683-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
   elif event == "31683-04.htm" :
      st.takeItems(EYE_OF_DARKNESS,-1)
      random = st.getRandom(100)
      i = 0
      while i < len(REWARDS) :
        item,adena,exp,sp,chance,chance2=REWARDS[i]
        if chance<=random<= chance2 :
          break
        i = i+1
      st.giveItems(ADENA_ID,adena)
      if item :
        st.giveItems(item,3)
      st.addExpAndSp(exp,sp)
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 31683 :
      if cond == 0 :
         if st.getPlayer().getLevel() >= 68 :
            htmltext = "31683-01.htm"
         else :
            htmltext = "31683-00.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getQuestItemsCount(EYE_OF_DARKNESS) < 100 :
         htmltext = "31683-02r.htm"
      elif cond == 2 and st.getQuestItemsCount(EYE_OF_DARKNESS) == 100 :
         htmltext = "31683-03.htm"
   return htmltext

 def onKill(self,npc,st):
   npcId = npc.getNpcId()
   cond=st.getInt("cond")
   if (npcId in [21299,21304]) and cond == 1 :
      chance = CHANCE[npc.getNpcId()]
      if st.getRandom(100) < chance :
        if st.getQuestItemsCount(EYE_OF_DARKNESS) < 100 :
          st.giveItems(EYE_OF_DARKNESS,1)
          if st.getQuestItemsCount(EYE_OF_DARKNESS) == 100 :
            st.set("cond","2")
            st.playSound("ItemSound.quest_middle")
          else :
            st.playSound("ItemSound.quest_itemget")
   return
   
QUEST       = Quest(602,"602_ShadowofLight","Shadow of Light")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31683)

STARTED.addTalkId(31683)
COMPLETED.addTalkId(31683)

STARTED.addKillId(21299)
STARTED.addKillId(21304)

STARTED.addQuestDrop(21299,EYE_OF_DARKNESS,1)
STARTED.addQuestDrop(21304,EYE_OF_DARKNESS,1)
STARTED.addQuestDrop(31683,ADENA_ID,1)

print "importing quests: 602: Shadow of Light"