import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#Items
MARK_OF_KETRA_ALLIANCE1 = 7211
MARK_OF_KETRA_ALLIANCE2 = 7212
MARK_OF_KETRA_ALLIANCE3 = 7213
MARK_OF_KETRA_ALLIANCE4 = 7214
MARK_OF_KETRA_ALLIANCE5 = 7215
VB_SOLDIER = 7216
VB_CAPTAIN = 7217
VB_GENERAL = 7218
TOTEM_OF_VALOR = 7219
TOTEM_OF_WISDOM = 7220

#hunt for soldier
RECRUIT = 21350
FOOTMAN = 21351
SCOUT = 21353
HUNTER = 21354
SHAMAN = 21355

#hunt for captain
PRIEST = 21357
WARRIOR = 21358
MEDIUM = 21360
MAGUS = 21361
OFFICIER = 21362
COMMANDER = 21369
ELITE_GUARD = 21370

#hunt for general
GREAT_MAGUS = 21365
GENERAL = 21366
GREAT_SEER = 21368
VARKA_PROPHET = 21373
DISCIPLE_OF_PROPHET = 21375
PROPHET_GUARDS = 21374
HEAD_MAGUS = 21371
HEAD_GUARDS = 21372

def checkMarks(st) :
   if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) < 0 and st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) < 0 and st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) < 0 and st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) < 0 and st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) < 0 :
      return
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) > 0 :
      st.set("cond","1")
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) > 0 :
      st.set("cond","3")
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) > 0 :
      st.set("cond","4")
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) > 0 :
      st.set("cond","5")
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0 :
      st.set("cond","6")

class Quest (JQuest) :

     def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)
	
     def onEvent(self,event,st) :
        htmltext = event
        if event == "first-2.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        elif event == "first-have-2.htm" :
            st.takeItems(VB_SOLDIER, 100)
            st.giveItems(MARK_OF_KETRA_ALLIANCE1, 1)
            st.set("cond","2")
            st.getPlayer().setKetra(1)
            st.playSound("ItemSound.quest_middle")
        elif event == "second-have-2.htm" :
            st.takeItems(VB_SOLDIER, 200)
            st.takeItems(VB_CAPTAIN, 100)
            st.takeItems(MARK_OF_KETRA_ALLIANCE1, 1)
            st.giveItems(MARK_OF_KETRA_ALLIANCE2, 1)
            st.set("cond","3")
            st.getPlayer().setKetra(2)
            st.playSound("ItemSound.quest_middle")
        elif event == "third-have-2.htm" :
            st.takeItems(VB_SOLDIER, 300)
            st.takeItems(VB_CAPTAIN, 200)
            st.takeItems(VB_GENERAL, 100)
            st.takeItems(MARK_OF_KETRA_ALLIANCE2, 1)
            st.giveItems(MARK_OF_KETRA_ALLIANCE3, 1)
            st.set("cond","4")
            st.getPlayer().setKetra(3)
            st.playSound("ItemSound.quest_middle")
        elif event == "fourth-have-2.htm" :
            st.takeItems(VB_SOLDIER, 300)
            st.takeItems(VB_CAPTAIN, 300)
            st.takeItems(VB_GENERAL, 200)
            st.takeItems(TOTEM_OF_VALOR, 1)
            st.takeItems(MARK_OF_KETRA_ALLIANCE3, 1)
            st.giveItems(MARK_OF_KETRA_ALLIANCE4, 1)
            st.set("cond","5")
            st.getPlayer().setKetra(4)
            st.playSound("ItemSound.quest_middle")
        elif event == "fifth-have-2.htm" :
            st.takeItems(VB_SOLDIER, 400)
            st.takeItems(VB_CAPTAIN, 400)
            st.takeItems(VB_GENERAL, 200)
            st.takeItems(TOTEM_OF_WISDOM, 1)
            st.takeItems(MARK_OF_KETRA_ALLIANCE4, 1)
            st.giveItems(MARK_OF_KETRA_ALLIANCE5, 1)
            st.set("cond","6")
            st.getPlayer().setKetra(5)
            st.playSound("ItemSound.quest_middle")
        elif event == "quit-2.htm" :
            st.takeItems(MARK_OF_KETRA_ALLIANCE1, -1)
            st.takeItems(MARK_OF_KETRA_ALLIANCE2, -1)
            st.takeItems(MARK_OF_KETRA_ALLIANCE3, -1)
            st.takeItems(MARK_OF_KETRA_ALLIANCE4, -1)
            st.takeItems(MARK_OF_KETRA_ALLIANCE5, -1)
            st.set("cond","0")
            st.setState(COMPLETED)
            st.getPlayer().setKetra(0)
            st.playSound("ItemSound.quest_middle")
        return htmltext


     def onTalk (Self,npc,st):
       htmltext = "<html><head><body>I have nothing to say you</body></html>"
       if st.getPlayer().getVarka() > 0 :
          htmltext = "isvarka.htm"
          st.exitCurrentQuest(True)
          return htmltext
       id = st.getState()
       if id == CREATED :
          st.set("cond","0")
       npcId = npc.getNpcId()
       cond = st.getInt("cond")
       checkMarks(st)
       if npcId == 31371 :
           if cond == 0 :
              if st.getPlayer().getLevel() >= 74 :
                 if id == COMPLETED :
                    htmltext = "<html><head>body>You have already complete this quest.</body></html>"
                 else :
                    htmltext = "first.htm"
              else :
                 htmltext = "no-level.htm"
                 st.exitCurrentQuest(True)
           elif cond == 1 :
              if st.getQuestItemsCount(VB_SOLDIER) >= 100 :
                 htmltext = "first-have.htm"
              else :
                 htmltext = "first-havenot.htm"
           elif cond == 2 :
              if st.getQuestItemsCount(VB_SOLDIER) >= 200 and st.getQuestItemsCount(VB_CAPTAIN) >= 100 :
                 htmltext = "second-have.htm"
              else :
                 htmltext = "second.htm"
           elif cond == 3 :
              if st.getQuestItemsCount(VB_SOLDIER) >= 300 and st.getQuestItemsCount(VB_CAPTAIN) >= 200 and st.getQuestItemsCount(VB_GENERAL) >= 100 :
                 htmltext = "third-have.htm"
              else :
                 htmltext = "third.htm"
           elif cond == 4 :
              if st.getQuestItemsCount(VB_SOLDIER) >= 300 and st.getQuestItemsCount(VB_CAPTAIN) >= 300 and st.getQuestItemsCount(VB_GENERAL) >= 200 and st.getQuestItemsCount(TOTEM_OF_VALOR) == 1 :
                 htmltext = "fourth-have.htm"
              else :
                 htmltext = "fourth.htm"
           elif cond == 5 :
              if st.getQuestItemsCount(VB_SOLDIER) >= 400 and st.getQuestItemsCount(VB_CAPTAIN) >= 400 and st.getQuestItemsCount(VB_GENERAL) >= 200 and st.getQuestItemsCount(TOTEM_OF_WISDOM) == 1 :
                 htmltext = "fifth-have.htm"
              else :
                 htmltext = "fifth.htm"
           elif cond == 6 :
              htmltext = "high.htm"
           return htmltext
       else :
           st.exitCurrentQuest(True)
           return htmltext

     def onKill (Self,npc,st):

       npcId = npc.getNpcId()
       if npcId == PRIEST or npcId == WARRIOR or npcId == MEDIUM or npcId == MAGUS or npcId == OFFICIER or npcId == COMMANDER or npcId == ELITE_GUARD :
        if st.getInt("cond") > 1 :
          if st.getRandom(100) < 40 :
            st.giveItems(VB_CAPTAIN,1)
            st.playSound("ItemSound.quest_middle")
       elif npcId == RECRUIT or npcId == FOOTMAN or npcId == SCOUT or npcId == HUNTER or npcId == SHAMAN :
        if st.getInt("cond") > 0 :
          if st.getRandom(100) < 40 :
            st.giveItems(VB_SOLDIER,1)
            st.playSound("ItemSound.quest_middle")
       elif npcId == GREAT_MAGUS or npcId == GENERAL or npcId == GREAT_SEER or npcId == VARKA_PROPHET or npcId == DISCIPLE_OF_PROPHET or npcId == PROPHET_GUARDS or npcId == HEAD_MAGUS or npcId == HEAD_GUARDS :
        if st.getInt("cond") > 2 :
          if st.getRandom(100) < 40 :
            st.giveItems(VB_GENERAL,1)
            st.playSound("ItemSound.quest_middle")
       return 

QUEST           = Quest(605,"605_AllianceWithKetraOrcs","Alliance With The Ketra Orcs",True)
CREATED         = State('Start', QUEST)
STARTED         = State('Started', QUEST)
COMPLETED       = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31371)
CREATED.addTalkId(31371)
STARTED.addTalkId(31371)

#hunt for soldier
STARTED.addKillId(RECRUIT) 
STARTED.addKillId(FOOTMAN)
STARTED.addKillId(SCOUT)
STARTED.addKillId(HUNTER)
STARTED.addKillId(SHAMAN)

#hunt for captain
STARTED.addKillId(PRIEST)
STARTED.addKillId(WARRIOR)
STARTED.addKillId(MEDIUM)
STARTED.addKillId(MAGUS)
STARTED.addKillId(OFFICIER)
STARTED.addKillId(COMMANDER)
STARTED.addKillId(ELITE_GUARD)

#hunt for general
STARTED.addKillId(GREAT_MAGUS)
STARTED.addKillId(GENERAL)
STARTED.addKillId(GREAT_SEER)
STARTED.addKillId(VARKA_PROPHET)
STARTED.addKillId(DISCIPLE_OF_PROPHET)
STARTED.addKillId(PROPHET_GUARDS)
STARTED.addKillId(HEAD_MAGUS)
STARTED.addKillId(HEAD_GUARDS)


#hunt for soldier
STARTED.addQuestDrop(RECRUIT,VB_SOLDIER,1) 
STARTED.addQuestDrop(FOOTMAN,VB_SOLDIER,1)
STARTED.addQuestDrop(SCOUT,VB_SOLDIER,1)
STARTED.addQuestDrop(HUNTER,VB_SOLDIER,1)
STARTED.addQuestDrop(SHAMAN,VB_SOLDIER,1)

#hunt for captain
STARTED.addQuestDrop(PRIEST,VB_CAPTAIN,1)
STARTED.addQuestDrop(WARRIOR,VB_CAPTAIN,1)
STARTED.addQuestDrop(MEDIUM,VB_CAPTAIN,1)
STARTED.addQuestDrop(MAGUS,VB_CAPTAIN,1)
STARTED.addQuestDrop(OFFICIER,VB_CAPTAIN,1)
STARTED.addQuestDrop(COMMANDER,VB_CAPTAIN,1)
STARTED.addQuestDrop(ELITE_GUARD,VB_CAPTAIN,1)

#hunt for general
STARTED.addQuestDrop(GREAT_MAGUS,VB_GENERAL,1)
STARTED.addQuestDrop(GENERAL,VB_GENERAL,1)
STARTED.addQuestDrop(GREAT_SEER,VB_GENERAL,1)
STARTED.addQuestDrop(VARKA_PROPHET,VB_GENERAL,1)
STARTED.addQuestDrop(DISCIPLE_OF_PROPHET,VB_GENERAL,1)
STARTED.addQuestDrop(PROPHET_GUARDS,VB_GENERAL,1)
STARTED.addQuestDrop(HEAD_MAGUS,VB_GENERAL,1)
STARTED.addQuestDrop(HEAD_GUARDS,VB_GENERAL,1)

print "importing quests: 605: Alliance with Ketra Orcs"
