import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
KADUN_ZU_KETRA = 31370
KETRA_FIRST_NPC = 21324
KETRA_LAST_NPC = 21350

# Quest items
VARKAS_MANE = 7233
HORN_OF_BUFFALO = 7186

# etc
MARK_OF_KETRA_ALLIANCE1 = 7211
MARK_OF_KETRA_ALLIANCE2 = 7212
MARK_OF_KETRA_ALLIANCE3 = 7213
MARK_OF_KETRA_ALLIANCE4 = 7214
MARK_OF_KETRA_ALLIANCE5 = 7215

# mob , chance
DROPLIST = {
21350: [500],
21353: [510],
21354: [522],
21355: [519],
21357: [529],
21358: [529],
21360: [539],
21362: [548],
21364: [558],
21365: [568],
21366: [568],
21368: [568],
21369: [664],
21371: [713]
}

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31370-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "31370-4.htm" :
       if st.getQuestItemsCount(VARKAS_MANE) >= 100 :
          st.takeItems(VARKAS_MANE,100)
          st.giveItems(HORN_OF_BUFFALO,20)
       else :
          htmltext = "31370-havenot.htm"
    elif event == "31370-quit.htm" :
       st.takeItems(VARKAS_MANE,-1)
       st.playSound("ItemSound.quest_finish")
       st.exitCurrentQuest(True)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() >= 74 :
         htmltext = "31370-1.htm"
      else :
         htmltext = "31370-0.htm"
         st.exitCurrentQuest(True)
   elif cond == 1 and st.getQuestItemsCount(VARKAS_MANE) == 0 :
      htmltext = "31370-2r.htm"
   elif cond == 1 and st.getQuestItemsCount(VARKAS_MANE) > 0 :
      htmltext = "31370-3.htm"
   return htmltext

# "However, if you ever harm a Ketra Orc while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if npcId in DROPLIST.keys() and st.getInt("cond") > 1 and st.getRandom(1000) < DROPLIST[npcId][0] :
      st.giveItems(VARKAS_MANE,1)
      st.playSound("ItemSound.quest_itemget")
   elif npcId in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
      if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE5,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE4,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE4,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE3,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE3,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE2,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE2,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE1,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE1,-1)
      st.getPlayer().setKetra(st.getPlayer().getKetra()-1)
      st.exitQuest(int(605))
      st.exitQuest(int(606))
      st.exitQuest(int(607))
      st.exitQuest(int(608))
      st.exitQuest(int(609))
      st.exitQuest(int(610))
   return 

QUEST		= Quest(606,"606_WarwithVarkaSilenos","War with Varka Silenos")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(KADUN_ZU_KETRA)
CREATED.addTalkId(KADUN_ZU_KETRA)
STARTED.addTalkId(KADUN_ZU_KETRA)
COMPLETED.addTalkId(KADUN_ZU_KETRA)

for mobs in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
   STARTED.addKillId(mobs)

for mob in DROPLIST.keys() :
   STARTED.addKillId(mob)
   STARTED.addQuestDrop(mob,VARKAS_MANE,1)

print "importing quests: 606: War with Varka Silenos"