import sys
from l2f.gameserver.tables import SkillTable
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
WAHKAN = 31371
ASEFA = 31372
UDANS_MARDUI_BOX = 31561

KETRA_FIRST_NPC = 21324
KETRA_LAST_NPC = 21350
VARKA_FIRST_NPC = 21350
VARKA_LAST_NPC = 21376

# Quest items
STOLEN_GREEN_TOTEM = 7237
DIVINE_STONE_OF_WISDOM = 7081
GREEN_TOTEM = 7238

# etc
MARK_OF_KETRA_ALLIANCE1 = 7211
MARK_OF_KETRA_ALLIANCE2 = 7212
MARK_OF_KETRA_ALLIANCE3 = 7213
MARK_OF_KETRA_ALLIANCE4 = 7214
MARK_OF_KETRA_ALLIANCE5 = 7215
THIEF_KEY = 1661

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31371-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "open" :
       if st.getInt("cond") == 2 :
          if st.getQuestItemsCount(THIEF_KEY) < 1 :
             htmltext = "31561-2.htm"
          else :
             if st.getInt("proval") == 1 :
                htmltext = "31561-4.htm"
                st.takeItems(THIEF_KEY,1)
             else :
                st.takeItems(THIEF_KEY,1)
                st.giveItems(STOLEN_GREEN_TOTEM,1)
                htmltext = "31561-3.htm"
                st.set("cond","3")
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   proval = st.getInt("proval")
   if npcId == WAHKAN :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 74 :
               if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) == 1 or st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) == 1 or st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) == 1 or st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) == 1 :
                  htmltext = "31371-1.htm"
               else :
                  htmltext = "31371-00.htm"
                  st.exitCurrentQuest(True)
            else :
               htmltext = "31371-0.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "31371-2r.htm"
   elif npcId == ASEFA :
      if cond == 1 :
         htmltext = "31372-1.htm"
         st.set("cond","2")
      elif cond == 2 and proval == 1 :
         htmltext = "31371-3.htm"
         npc.doCast(SkillTable.getInstance().getInfo(4548,1),st.getPlayer())
         st.set("proval","0")
      elif cond == 3 and st.getQuestItemsCount(STOLEN_GREEN_TOTEM) == 1 :
         htmltext = "31371-4.htm"
         st.takeItems(STOLEN_GREEN_TOTEM,-1)
         st.giveItems(GREEN_TOTEM,1)
         st.giveItems(DIVINE_STONE_OF_WISDOM,1)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == UDANS_MARDUI_BOX :
      if cond == 2 :
         htmltext = "31561-1.htm"
   return htmltext

 def onAttack (self, npc, st):
    npcId = npc.getNpcId()
    cond = st.getInt("cond")
    proval = st.getInt("proval")
    if cond == 2 and proval == 0 :
       npc.doCast(SkillTable.getInstance().getInfo(4547,1),st.getPlayer())
       st.set("proval","1")
    return

# "However, if you ever harm a Ketra Orc while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) :
      st.takeItems(MARK_OF_KETRA_ALLIANCE5,-1)
      st.giveItems(MARK_OF_KETRA_ALLIANCE4,1)
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) :
      st.takeItems(MARK_OF_KETRA_ALLIANCE4,-1)
      st.giveItems(MARK_OF_KETRA_ALLIANCE3,1)
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) :
      st.takeItems(MARK_OF_KETRA_ALLIANCE3,-1)
      st.giveItems(MARK_OF_KETRA_ALLIANCE2,1)
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) :
      st.takeItems(MARK_OF_KETRA_ALLIANCE2,-1)
      st.giveItems(MARK_OF_KETRA_ALLIANCE1,1)
   elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) :
      st.takeItems(MARK_OF_KETRA_ALLIANCE1,-1)
   st.getPlayer().setKetra(st.getPlayer().getKetra()-1)
   st.exitQuest(int(605))
   st.exitQuest(int(606))
   st.exitQuest(int(607))
   st.exitQuest(int(608))
   st.exitQuest(int(609))
   st.exitQuest(int(610))
   return 

QUEST		= Quest(609,"609_MagicalPowerofWater1","Magical Power of Water - Part 1")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(WAHKAN)
CREATED.addTalkId(WAHKAN)
STARTED.addTalkId(WAHKAN)
COMPLETED.addTalkId(WAHKAN)

STARTED.addTalkId(ASEFA)
STARTED.addTalkId(UDANS_MARDUI_BOX)

for enemies in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
   STARTED.addAttackId(enemies)

for mobs in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
   STARTED.addKillId(mobs)

print "importing quests: 609: Magical Power of Water - Part 1"
