import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#Items
MARK_OF_VARKA_ALLIANCE1 = 7221
MARK_OF_VARKA_ALLIANCE2 = 7222
MARK_OF_VARKA_ALLIANCE3 = 7223
MARK_OF_VARKA_ALLIANCE4 = 7224
MARK_OF_VARKA_ALLIANCE5 = 7225
KB_SOLDIER = 7226
KB_CAPTAIN = 7227
KB_GENERAL = 7228
TOTEM_OF_VALOR = 7219
TOTEM_OF_WISDOM = 7220

#hunt for soldier
RAIDER = 21327
FOOTMAN = 21324
SCOUT = 21328
WAR_HOUND = 21325
SHAMAN = 2132

#hunt for captain
SEER = 21338
WARRIOR = 21331
LIEUTENANT = 21332
ELITE_SOLDIER = 21335
MEDIUM = 21334
COMMAND = 21343
ELITE_GUARD = 21344
WHITE_CAPTAIN = 21336

#hunt for general
BATTALION_COMMANDER_SOLDIER = 21340
GENERAL = 21339
GREAT_SEER = 21342
KETRA_PROPHET = 21347
DISCIPLE_OF_PROPHET = 21375
PROPHET_GUARDS = 21348
PROPHET_AIDE = 21349
HEAD_SHAMAN = 21345
HEAD_GUARDS = 21346    

def checkMarks(st) :
   if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) < 0 and st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) < 0 and st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) < 0 and st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) < 0 and st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) < 0 :
      return
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0 :
      st.set("cond","1")
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0 :
      st.set("cond","3")
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0 :
      st.set("cond","4")
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0 :
      st.set("cond","5")
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0 :
      st.set("cond","6")

class Quest (JQuest) :

     def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)
     
     def onEvent(self,event,st) :
        htmltext = event
        if event == "first-2.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        elif event == "first-have-2.htm" :
            st.takeItems(KB_SOLDIER, 100)
            st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1)
            st.set("cond","2")
            st.getPlayer().setVarka(1)
            st.playSound("ItemSound.quest_middle")
        elif event == "second-have-2.htm" :
            st.takeItems(KB_SOLDIER, 200)
            st.takeItems(KB_CAPTAIN, 100)
            st.takeItems(MARK_OF_VARKA_ALLIANCE1, 1)
            st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1)
            st.set("cond","3")
            st.getPlayer().setVarka(2)
            st.playSound("ItemSound.quest_middle")
        elif event == "third-have-2.htm" :
            st.takeItems(KB_SOLDIER, 300)
            st.takeItems(KB_CAPTAIN, 200)
            st.takeItems(KB_GENERAL, 100)
            st.takeItems(MARK_OF_VARKA_ALLIANCE2, 1)
            st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1)
            st.set("cond","4")
            st.getPlayer().setVarka(3)
            st.playSound("ItemSound.quest_middle")
        elif event == "fourth-have-2.htm" :
            st.takeItems(KB_SOLDIER, 300)
            st.takeItems(KB_CAPTAIN, 300)
            st.takeItems(KB_GENERAL, 200)
            st.takeItems(TOTEM_OF_VALOR, 1)
            st.takeItems(MARK_OF_VARKA_ALLIANCE3, 1)
            st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1)
            st.set("cond","5")
            st.getPlayer().setVarka(4)
            st.playSound("ItemSound.quest_middle")
        elif event == "fifth-have-2.htm" :
            st.takeItems(KB_SOLDIER, 400)
            st.takeItems(KB_CAPTAIN, 400)
            st.takeItems(KB_GENERAL, 200)
            st.takeItems(TOTEM_OF_WISDOM, 1)
            st.takeItems(MARK_OF_VARKA_ALLIANCE4, 1)
            st.giveItems(MARK_OF_VARKA_ALLIANCE5, 1)
            st.set("cond","6")
            st.getPlayer().setVarka(5)
            st.playSound("ItemSound.quest_middle")
        elif event == "quit-2.htm" :
            st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1)
            st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1)
            st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1)
            st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1)
            st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1)
            st.set("cond","0")
            st.setState(COMPLETED)
            st.getPlayer().setVarka(0)
            st.playSound("ItemSound.quest_finish")
        return htmltext


     def onTalk (Self,npc,st):
       htmltext = "<html><body>I have nothing to say you</body></html>"
       if st.getPlayer().getKetra() > 0 :
          htmltext = "isketra.htm"
          st.exitCurrentQuest(True)
          return htmltext
       id = st.getState()
       npcId = npc.getNpcId()
       cond = st.getInt("cond")
       checkMarks(st)
       if npcId == 31378 :
           if cond == 0 :
              if st.getPlayer().getLevel() >= 74 :
                 if id == COMPLETED :
                    htmltext = "<html><body>You have already complete this quest.</body></html>"
                 else :
                    htmltext = "first.htm"
              else :
                 htmltext = "no-level.htm"
                 st.exitCurrentQuest(True)
           elif cond == 1 :
              if st.getQuestItemsCount(KB_SOLDIER) >= 100 :
                 htmltext = "first-have.htm"
              else :
                 htmltext = "first-havenot.htm"
           elif cond == 2 :
              if st.getQuestItemsCount(KB_SOLDIER) >= 200 and st.getQuestItemsCount(KB_CAPTAIN) >= 100 :
                 htmltext = "second-have.htm"
              else :
                 htmltext = "second.htm"
           elif cond == 3 :
              if st.getQuestItemsCount(KB_SOLDIER) >= 300 and st.getQuestItemsCount(KB_CAPTAIN) >= 200 and st.getQuestItemsCount(KB_GENERAL) >= 100 :
                 htmltext = "third-have.htm"
              else :
                 htmltext = "third.htm"
           elif cond == 4 :
              if st.getQuestItemsCount(KB_SOLDIER) >= 300 and st.getQuestItemsCount(KB_CAPTAIN) >= 300 and st.getQuestItemsCount(KB_GENERAL) >= 200 and st.getQuestItemsCount(TOTEM_OF_VALOR) == 1 :
                 htmltext = "fourth-have.htm"
              else :
                 htmltext = "fourth.htm"
           elif cond == 5 :
              if st.getQuestItemsCount(KB_SOLDIER) >= 400 and st.getQuestItemsCount(KB_CAPTAIN) >= 400 and st.getQuestItemsCount(KB_GENERAL) >= 200 and st.getQuestItemsCount(TOTEM_OF_WISDOM) == 1 :
                 htmltext = "fifth-have.htm"
              else :
                 htmltext = "fifth.htm"
           elif cond == 6 :
              htmltext = "high.htm"
           return htmltext
       else :
           st.exitCurrentQuest(True)
           return htmltext

     def onKill (Self,npc,st):

       npcId = npc.getNpcId()
       if npcId == SEER or npcId == WARRIOR or npcId == LIEUTENANT or npcId == ELITE_SOLDIER or npcId == MEDIUM or npcId == COMMAND or npcId == ELITE_GUARD or npcId == WHITE_CAPTAIN :
        if st.getInt("cond") > 1 :
          if st.getRandom(100) < 40 :
            st.giveItems(KB_CAPTAIN,1)
            st.playSound("ItemSound.quest_middle")
       elif npcId == RAIDER or npcId == FOOTMAN or npcId == SCOUT or npcId == WAR_HOUND or npcId == SHAMAN :
        if st.getInt("cond") > 0 :
          if st.getRandom(100) < 40 :
            st.giveItems(KB_SOLDIER,1)
            st.playSound("ItemSound.quest_middle")
       elif npcId == BATTALION_COMMANDER_SOLDIER or npcId == GENERAL or npcId == GREAT_SEER or npcId == KETRA_PROPHET or npcId == DISCIPLE_OF_PROPHET or npcId == PROPHET_GUARDS or npcId == HEAD_SHAMAN or npcId == HEAD_GUARDS :
        if st.getInt("cond") > 2 :
          if st.getRandom(100) < 40 :
            st.giveItems(KB_GENERAL,1)
            st.playSound("ItemSound.quest_middle")
       return 

QUEST		= Quest(611,"611_AllianceWithVarkaSillenos","Alliance with Varka Silenos",True)
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31378)
CREATED.addTalkId(31378)
STARTED.addTalkId(31378)

#hunt for soldier
STARTED.addKillId(RAIDER) 
STARTED.addKillId(FOOTMAN)
STARTED.addKillId(SCOUT)
STARTED.addKillId(WAR_HOUND)
STARTED.addKillId(SHAMAN)

#hunt for captain
STARTED.addKillId(SEER)
STARTED.addKillId(WARRIOR)
STARTED.addKillId(LIEUTENANT)
STARTED.addKillId(ELITE_SOLDIER)
STARTED.addKillId(MEDIUM)
STARTED.addKillId(COMMAND)
STARTED.addKillId(ELITE_GUARD)
STARTED.addKillId(WHITE_CAPTAIN)

#hunt for general
STARTED.addKillId(BATTALION_COMMANDER_SOLDIER)
STARTED.addKillId(GENERAL)
STARTED.addKillId(GREAT_SEER)
STARTED.addKillId(KETRA_PROPHET)
STARTED.addKillId(PROPHET_AIDE)
STARTED.addKillId(PROPHET_GUARDS)
STARTED.addKillId(HEAD_SHAMAN)
STARTED.addKillId(HEAD_GUARDS)

#hunt for soldier
STARTED.addQuestDrop(RAIDER,KB_SOLDIER,1) 
STARTED.addQuestDrop(FOOTMAN,KB_SOLDIER,1)
STARTED.addQuestDrop(SCOUT,KB_SOLDIER,1)
STARTED.addQuestDrop(WAR_HOUND,KB_SOLDIER,1)
STARTED.addQuestDrop(SHAMAN,KB_SOLDIER,1)

#hunt for captain
STARTED.addQuestDrop(SEER,KB_CAPTAIN,1)
STARTED.addQuestDrop(WARRIOR,KB_CAPTAIN,1)
STARTED.addQuestDrop(LIEUTENANT,KB_CAPTAIN,1)
STARTED.addQuestDrop(ELITE_SOLDIER,KB_CAPTAIN,1)
STARTED.addQuestDrop(MEDIUM,KB_CAPTAIN,1)
STARTED.addQuestDrop(COMMAND,KB_CAPTAIN,1)
STARTED.addQuestDrop(ELITE_GUARD,KB_CAPTAIN,1)
STARTED.addQuestDrop(WHITE_CAPTAIN,KB_CAPTAIN,1)

#hunt for general
STARTED.addQuestDrop(BATTALION_COMMANDER_SOLDIER,KB_GENERAL,1)
STARTED.addQuestDrop(GENERAL,KB_GENERAL,1)
STARTED.addQuestDrop(GREAT_SEER,KB_GENERAL,1)
STARTED.addQuestDrop(KETRA_PROPHET,KB_GENERAL,1)
STARTED.addQuestDrop(PROPHET_AIDE,KB_GENERAL,1)
STARTED.addQuestDrop(PROPHET_GUARDS,KB_GENERAL,1)
STARTED.addQuestDrop(HEAD_SHAMAN,KB_GENERAL,1)
STARTED.addQuestDrop(HEAD_GUARDS,KB_GENERAL,1)

print "importing quests: 611: Alliance with Varka Silenos"
