import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
DURAI = 31377
VARKA_FIRST_NPC = 21350
VARKA_LAST_NPC = 21376

# Quest items
MOLAR_OF_KETRA_ORC = 7234
NEPENTHES_SEED = 7187

# etc
MARK_OF_VARKA_ALLIANCE1 = 7221
MARK_OF_VARKA_ALLIANCE2 = 7222
MARK_OF_VARKA_ALLIANCE3 = 7223
MARK_OF_VARKA_ALLIANCE4 = 7224
MARK_OF_VARKA_ALLIANCE5 = 7225

# mob , chance
DROPLIST = {
21324: [500],
21327: [510],
21328: [522],
21329: [519],
21331: [529],
21332: [529],
21334: [539],
21343: [664],
21339: [568],
21340: [568],
21342: [578],
21345: [713],
21347: [738]
}

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31377-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "31377-4.htm" :
       if st.getQuestItemsCount(MOLAR_OF_KETRA_ORC) >= 100 :
          st.takeItems(MOLAR_OF_KETRA_ORC,100)
          st.giveItems(NEPENTHES_SEED,20)
       else :
          htmltext = "31377-havenot.htm"
    elif event == "31377-quit.htm" :
       st.takeItems(MOLAR_OF_KETRA_ORC,-1)
       st.playSound("ItemSound.quest_finish")
       st.exitCurrentQuest(True)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 0 :
      if st.getPlayer().getLevel() >= 74 :
         htmltext = "31377-1.htm"
      else :
         htmltext = "31377-0.htm"
         st.exitCurrentQuest(True)
   elif cond == 1 and st.getQuestItemsCount(MOLAR_OF_KETRA_ORC) == 0 :
      htmltext = "31377-2r.htm"
   elif cond == 1 and st.getQuestItemsCount(MOLAR_OF_KETRA_ORC) > 0 :
      htmltext = "31377-3.htm"
   return htmltext

# "However, if you ever harm a Varka Silenos while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if npcId in DROPLIST.keys() and st.getInt("cond") > 1 and st.getRandom(1000) < DROPLIST[npcId][0] :
      st.giveItems(MOLAR_OF_KETRA_ORC,1)
      st.playSound("ItemSound.quest_itemget")
   elif npcId in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
      if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE5,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE4,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE4,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE3,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE3,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE2,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE2,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE1,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE1,-1)
      st.getPlayer().setVarka(st.getPlayer().getVarka()-1)
      st.exitQuest(int(611))
      st.exitQuest(int(612))
      st.exitQuest(int(613))
      st.exitQuest(int(614))
      st.exitQuest(int(615))
      st.exitQuest(int(616))
   return 

QUEST		= Quest(612,"612_WarwithKetraOrcs","War with Ketra Orcs")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)
ABORTED		= State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(DURAI)
CREATED.addTalkId(DURAI)
STARTED.addTalkId(DURAI)
COMPLETED.addTalkId(DURAI)

for mobs in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
   STARTED.addKillId(mobs)

for mob in DROPLIST.keys() :
   STARTED.addKillId(mob)
   STARTED.addQuestDrop(mob,MOLAR_OF_KETRA_ORC,1)

print "importing quests: 612: War with Ketra Orcs"