import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
DURAI = 31377
KETRAS_COMMANDER_TAYR = 25299

# Quest Items
HEAD_OF_TAYR = 7241
FEATHER_OF_WISDOM = 7230

# etc
VARKA_FIRST_NPC = 21350
VARKA_LAST_NPC = 21376
MARK_OF_VARKA_ALLIANCE1 = 7221
MARK_OF_VARKA_ALLIANCE2 = 7222
MARK_OF_VARKA_ALLIANCE3 = 7223
MARK_OF_VARKA_ALLIANCE4 = 7224
MARK_OF_VARKA_ALLIANCE5 = 7225

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31377-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "31377-4.htm" :
       if st.getQuestItemsCount(HEAD_OF_TAYR) >= 1 :
          st.takeItems(HEAD_OF_TAYR,-1)
          st.giveItems(FEATHER_OF_WISDOM,1)
          st.addExpAndSp(0,10000)
          st.unset("cond")
          st.setState(COMPLETED)
          st.playSound("ItemSound.quest_finish")
       else :
          htmltext = "31377-2r.htm"
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 0 :
      if id != COMPLETED :
         if st.getPlayer().getLevel() >= 75 :
            if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) == 1 or st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) == 1 :
               htmltext = "31377-1.htm"
            else :
               htmltext = "31377-00.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "31377-0.htm"
            st.exitCurrentQuest(True)
      else :
         htmltext = "<html><head><body>This quest have already been completed.</body></html>"
   elif cond == 1 and st.getQuestItemsCount(HEAD_OF_TAYR) == 0 :
      htmltext = "31377-2r.htm"
   elif cond == 2 and st.getQuestItemsCount(HEAD_OF_TAYR) >= 1 :
      htmltext = "31377-3.htm"
   return htmltext

# "However, if you ever harm a Varka Silenos while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if npcId == KETRAS_COMMANDER_TAYR and st.getInt("cond") == 1 :
      st.giveItems(HEAD_OF_TAYR,1)
      st.set("cond","2")
      st.playSound("ItemSound.quest_itemget")
   elif npcId in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
      if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE5,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE4,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE4,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE3,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE3,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE2,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE2,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE1,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE1,-1)
      st.getPlayer().setVarka(st.getPlayer().getVarka()-1)
      st.exitQuest(int(611))
      st.exitQuest(int(612))
      st.exitQuest(int(613))
      st.exitQuest(int(614))
      st.exitQuest(int(615))
      st.exitQuest(int(616))
   return 

QUEST		= Quest(614,"614_SlayTheEnemyCommander","Slay the enemy commander!")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(DURAI)
CREATED.addTalkId(DURAI)
STARTED.addTalkId(DURAI)
COMPLETED.addTalkId(DURAI)

for mobs in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
   STARTED.addKillId(mobs)

STARTED.addKillId(KETRAS_COMMANDER_TAYR)

STARTED.addQuestDrop(KETRAS_COMMANDER_TAYR,HEAD_OF_TAYR,1)

print "importing quests: 614: Slay the enemy commander!"