import sys
from l2f.gameserver.tables import SkillTable
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
NARAN = 31378
UDAN = 31379
BOX_OF_ASEFA = 31559

KETRA_FIRST_NPC = 21324
KETRA_LAST_NPC = 21350
VARKA_FIRST_NPC = 21350
VARKA_LAST_NPC = 21376

# Quest items
STOLEN_RED_TOTEM = 7242
DIVINE_STONE_OF_WISDOM = 7081
RED_TOTEM = 7243

# etc
MARK_OF_VARKA_ALLIANCE1 = 7221
MARK_OF_VARKA_ALLIANCE2 = 7222
MARK_OF_VARKA_ALLIANCE3 = 7223
MARK_OF_VARKA_ALLIANCE4 = 7224
MARK_OF_VARKA_ALLIANCE5 = 7225
THIEF_KEY = 1661

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31378-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "open" :
       if st.getInt("cond") == 2 :
          if st.getQuestItemsCount(THIEF_KEY) < 1 :
             htmltext = "31559-2.htm"
          else :
             if st.getInt("proval") == 1 :
                htmltext = "31559-4.htm"
                st.takeItems(THIEF_KEY,1)
             else :
                st.takeItems(THIEF_KEY,1)
                st.giveItems(STOLEN_RED_TOTEM,1)
                htmltext = "31559-3.htm"
                st.set("cond","3")
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   proval = st.getInt("proval")
   if npcId == NARAN :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 74 :
               if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) == 1 or st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) == 1 or st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) == 1 or st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) == 1 :
                  htmltext = "31378-1.htm"
               else :
                  htmltext = "31378-00.htm"
                  st.exitCurrentQuest(True)
            else :
               htmltext = "31378-0.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "31378-2r.htm"
   elif npcId == UDAN :
      if cond == 1 :
         htmltext = "31379-1.htm"
         st.set("cond","2")
      elif cond == 2 and proval == 1 :
         htmltext = "31379-3.htm"
         npc.doCast(SkillTable.getInstance().getInfo(4548,1),st.getPlayer())
         st.set("proval","0")
      elif cond == 3 and st.getQuestItemsCount(STOLEN_RED_TOTEM) == 1 :
         htmltext = "31379-4.htm"
         st.takeItems(STOLEN_RED_TOTEM,-1)
         st.giveItems(RED_TOTEM,1)
         st.giveItems(DIVINE_STONE_OF_WISDOM,1)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == BOX_OF_ASEFA :
      if cond == 2 :
         htmltext = "31559-1.htm"
   return htmltext

 def onAttack (self, npc, st):
    npcId = npc.getNpcId()
    if cond == 2 and proval == 0 :
       npc.doCast(SkillTable.getInstance().getInfo(4547,1),st.getPlayer())
       st.set("proval","1")
    return

# "However, if you ever harm a Ketra Orc while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) :
      st.takeItems(MARK_OF_VARKA_ALLIANCE5,-1)
      st.giveItems(MARK_OF_VARKA_ALLIANCE4,1)
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) :
      st.takeItems(MARK_OF_VARKA_ALLIANCE4,-1)
      st.giveItems(MARK_OF_VARKA_ALLIANCE3,1)
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) :
      st.takeItems(MARK_OF_VARKA_ALLIANCE3,-1)
      st.giveItems(MARK_OF_VARKA_ALLIANCE2,1)
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) :
      st.takeItems(MARK_OF_VARKA_ALLIANCE2,-1)
      st.giveItems(MARK_OF_VARKA_ALLIANCE1,1)
   elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) :
      st.takeItems(MARK_OF_VARKA_ALLIANCE1,-1)
   st.getPlayer().setVarka(st.getPlayer().getVarka()-1)
   st.exitQuest(int(611))
   st.exitQuest(int(612))
   st.exitQuest(int(613))
   st.exitQuest(int(614))
   st.exitQuest(int(615))
   st.exitQuest(int(616))
   return 

QUEST		= Quest(615,"615_MagicalPowerofFire1","Magical Power of Fire - Part 1")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(NARAN)
CREATED.addTalkId(NARAN)
STARTED.addTalkId(NARAN)
COMPLETED.addTalkId(NARAN)

STARTED.addTalkId(UDAN)
STARTED.addTalkId(BOX_OF_ASEFA)

for enemies in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
   STARTED.addAttackId(enemies)

for mobs in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
   STARTED.addKillId(mobs)

print "importing quests: 615: Magical Power of Fire - Part 1"