import sys
from l2f.gameserver.tables import SkillTable
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
UDAN = 31379
KETRAS_HOLY_ALTAR = 31558
SOUL_OF_FIRE_NASTRON = 25306

KETRA_FIRST_NPC = 21324
KETRA_LAST_NPC = 21350
VARKA_FIRST_NPC = 21350
VARKA_LAST_NPC = 21376

# Quest items
RED_TOTEM = 7243
FIRE_HEART_OF_NASTRON = 7244

# etc
MARK_OF_VARKA_ALLIANCE1 = 7221
MARK_OF_VARKA_ALLIANCE2 = 7222
MARK_OF_VARKA_ALLIANCE3 = 7223
MARK_OF_VARKA_ALLIANCE4 = 7224
MARK_OF_VARKA_ALLIANCE5 = 7225

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31379-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "use_totem" :
       if st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) >= 1 and not st.isSpawnExists(25306) :
          st.takeItems(RED_TOTEM,-1)
          st.getPcSpawn().addSpawn(25306,142528,-82528,-6496)
          st.getPcSpawn().addSpawn(25307,142628,-82528,-6490)
          st.getPcSpawn().addSpawn(25308,142428,-82528,-6490)
          st.playSound("ItemSound.quest_middle")
       else :
          htmltext = "31558-havenot.htm"
    elif event == "31379-4.htm" :
       if st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) >= 1 :
          st.takeItems(FIRE_HEART_OF_NASTRON,-1)
          st.set("cond","0")
          st.setState(COMPLETED)
          st.playSound("ItemSound.quest_finish")
          htmltext = "31379-2.htm"
       else :
          htmltext = "31379-havenot.htm"
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == UDAN :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 75 :
               if st.getQuestItemsCount(RED_TOTEM) == 1 :
                  htmltext = "31379-1.htm"
               else :
                  htmltext = "31379-00.htm"
                  st.exitCurrentQuest(True)
            else :
               htmltext = "31379-0.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "31379-2r.htm"
      elif cond == 2 :
         htmltext = "31379-2rr.htm"
      elif cond == 3 and st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) == 1 :
         htmltext = "31379-3.htm"
   elif npcId == KETRAS_HOLY_ALTAR :
      if not npc.isBusy():
         if cond == 1 :
            htmltext = "31558-1.htm"
         elif cond == 2 and not st.isSpawnExists(25306) :
            st.getPcSpawn().addSpawn(25306,142528,-82528,-6496)
            st.getPcSpawn().addSpawn(25307,142628,-82528,-6490)
            st.getPcSpawn().addSpawn(25308,142428,-82528,-6490)
            htmltext = "31558-3.htm"
      else :
         htmltext = "31558-busy.htm"
   return htmltext

# "However, if you ever harm a Ketra Orc while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if npcId in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
      if st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE5,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE4,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE4,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE3,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE3,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE2,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE2,-1)
         st.giveItems(MARK_OF_VARKA_ALLIANCE1,1)
      elif st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) :
         st.takeItems(MARK_OF_VARKA_ALLIANCE1,-1)
      st.getPlayer().setKetra(st.getPlayer().getVarka()-1)
      st.exitQuest(int(611))
      st.exitQuest(int(612))
      st.exitQuest(int(613))
      st.exitQuest(int(614))
      st.exitQuest(int(615))
      st.exitQuest(int(616))
   else :
      if st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) == 0 :
         st.giveItems(FIRE_HEART_OF_NASTRON,1)
         st.set("cond","3")
         st.getPcSpawn().removeAllSpawn()
   return 

QUEST		= Quest(616,"616_MagicalPowerofFire2","Magical Power of Fire - Part 2")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(UDAN)
CREATED.addTalkId(UDAN)
STARTED.addTalkId(UDAN)
COMPLETED.addTalkId(UDAN)

STARTED.addTalkId(KETRAS_HOLY_ALTAR)

for mobs in range(VARKA_FIRST_NPC,VARKA_LAST_NPC) :
   STARTED.addKillId(mobs)

STARTED.addKillId(SOUL_OF_FIRE_NASTRON)

STARTED.addQuestDrop(SOUL_OF_FIRE_NASTRON,FIRE_HEART_OF_NASTRON,1)

print "importing quests: 616: Magical Power of Fire - Part 2"