# Gather The Flames version 0.1
# by Mortius
import sys
from l2f import Config
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#Quest info
QUEST_NUMBER,QUEST_NAME,QUEST_DESCRIPTION = 617,"GatherTheFlames","Gather The Flames"

#Variables
RATE = int(Config.RATE_QUESTS_REWARD+1)

#Quest items
TORCH = 7264

#Messages
default   = "<html><head><body>I have nothing to say to you.</body></html>"

#NPCs
VULCAN = 31539

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31539-03.htm" :
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
      st.set("cond","1")
    elif event == "31539-08.htm" :
      st.playSound("ItemSound.quest_finish")
      st.takeItems(TORCH,-1)
      st.set("cond","0")
      st.exitCurrentQuest(True)
    elif event == "31539-07.htm" :
      item=st.getRandom(10)
      if item == 0 :
        st.giveItems(6881,1)
      elif item == 1 :
        st.giveItems(6883,1)
      elif item == 2 :
        st.giveItems(6885,1)
      elif item == 3 :
        st.giveItems(6887,1)
      elif item == 4 :
        st.giveItems(7580,1)
      elif item == 5 :
        st.giveItems(6891,1)
      elif item == 6 :
        st.giveItems(6893,1)
      elif item == 7 :
        st.giveItems(6895,1)
      elif item == 8 :
        st.giveItems(6897,1)
      elif item == 9 :
        st.giveItems(6899,1)
      st.playSound("ItemSound.quest_middle")
      st.takeItems(TORCH,1000)
    return htmltext

 def onTalk (self,npc,st):
    htmltext = default
    id = st.getState()
    npcid=npc.getNpcId()
    if npcid == VULCAN :
       if id == CREATED :
          if st.getPlayer().getLevel() >=74 :
             htmltext="31539-01.htm"
          else :
             htmltext="31539-02.htm"
       else :
          if st.getQuestItemsCount(TORCH) < 1000 :
             htmltext="31539-05.htm"
          else :
             htmltext="31539-04.htm"
    return htmltext


 def onKill (self,npc,st) :
    npcid = npc.getNpcId()
    if npcid == 21376 or npcid == 21377 or npcid == 21378 or npcid == 21652 or npcid == 21380 :
      if st.getRandom(100) < 48 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    elif npcid == 21381 or npcid == 21653 or npcid == 21383 or npcid == 21394 or npcid == 21385 or npcid == 21386 :
      if st.getRandom(100) < 51 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    elif npcid == 21388 or npcid == 21655 or npcid == 21387:
      if st.getRandom(100) < 53 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    elif npcid == 21390 or npcid == 21656 or npcid == 21395 or npcid == 21389 or npcid == 21391 or npcid == 21392 :
      if st.getRandom(100) < 56 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    elif npcid == 21393 or npcid == 21657 :
      if st.getRandom(100) < 58 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    elif npcid == 21382 or npcid == 21379 :
      if st.getRandom(100) < 60 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    elif npcid == 21654 or npcid == 21384 :
      if st.getRandom(100) < 64 :
        st.giveItems(TORCH,max(1,st.getRandom(RATE)))
        st.playSound("ItemSound.quest_itemget")
    return

# Quest class and state definition
QUEST       = Quest(QUEST_NUMBER, str(QUEST_NUMBER)+"_"+QUEST_NAME, QUEST_DESCRIPTION, True)

CREATED     = State('Start',     QUEST)
STARTED     = State('Started',   QUEST)

QUEST.setInitialState(CREATED)

# Quest NPC starter initialization
QUEST.addStartNpc(VULCAN)
# Quest initialization
CREATED.addTalkId(VULCAN)
STARTED.addTalkId(VULCAN)

STARTED.addKillId(21376)
STARTED.addKillId(21377)
STARTED.addKillId(21378)
STARTED.addKillId(21652)
STARTED.addKillId(21380)
STARTED.addKillId(21381)
STARTED.addKillId(21653)
STARTED.addKillId(21383)
STARTED.addKillId(21394)
STARTED.addKillId(21385)
STARTED.addKillId(21392)
STARTED.addKillId(21386)
STARTED.addKillId(21388)
STARTED.addKillId(21390)
STARTED.addKillId(21656)
STARTED.addKillId(21359)
STARTED.addKillId(21393)
STARTED.addKillId(21657)
STARTED.addKillId(21382)
STARTED.addKillId(21379)
STARTED.addKillId(21389)
STARTED.addKillId(21391)
STARTED.addKillId(21655)
STARTED.addKillId(21654)
STARTED.addKillId(21384)
STARTED.addKillId(21387)

print "importing quests: "+str(QUEST_NUMBER)+": "+QUEST_DESCRIPTION
