import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
JEREMY = 31521

# MOBS
HOT_SPRINGS_ATROX = 21321
HOT_SPRINGS_NEPENTHES = 21319
HOT_SPRINGS_ATROXSPAWN = 21317
HOT_SPRINGS_BANDERSNATCH = 21322

#QUEST ITEMS
SECRET_SPICE = 7204
TRUNK_OF_NEPENTHES = 7202
FOOT_OF_BANDERSNATCHLING = 7203
CRYOLITE = 7080
SAUCE = 7205

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   cond = st.getInt("cond")
   htmltext = event
   trunk = st.getQuestItemsCount(TRUNK_OF_NEPENTHES)
   foot = st.getQuestItemsCount(FOOT_OF_BANDERSNATCHLING)
   spice = st.getQuestItemsCount(SECRET_SPICE)
   if event == "31521-1.htm" :
     if st.getPlayer().getLevel() >= 73 : 
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")       
     else:
        htmltext = "31521-0a.htm"
        st.exitCurrentQuest(True)
   elif event == "31521-4.htm" :
     if trunk==foot==spice==50 :
       st.takeItems(TRUNK_OF_NEPENTHES,-1)
       st.takeItems(FOOT_OF_BANDERSNATCHLING,-1)
       st.takeItems(SECRET_SPICE,-1)
       st.playSound("ItemSound.quest_finish")
       st.giveItems(SAUCE,1)
       st.giveItems(CRYOLITE,1)
       htmltext = "31521-4.htm"
       st.exitCurrentQuest(True)
     else:
       htmltext="31521-5.htm"
       st.set("cond","1")
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 0 :
      htmltext = "31521-0.htm"
   elif cond <> 3 :
      htmltext = "31521-2.htm"
   else :
      htmltext = "31521-3.htm"
   return htmltext

 def onKill (self,npc,st):
   count_trunk = st.getQuestItemsCount(TRUNK_OF_NEPENTHES)
   count_foot = st.getQuestItemsCount(FOOT_OF_BANDERSNATCHLING)
   count_spice = st.getQuestItemsCount(SECRET_SPICE)
   npcId = npc.getNpcId()
   if st.getInt("cond") == 1:
     if npcId == HOT_SPRINGS_NEPENTHES and count_trunk < 50 :
       st.giveItems(TRUNK_OF_NEPENTHES,1)
       if count_trunk == 49 and count_foot == count_spice == 50 :
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")
       else:
         st.playSound("ItemSound.quest_itemget")	
     elif npcId == HOT_SPRINGS_BANDERSNATCH and count_foot < 50 :
       st.giveItems(FOOT_OF_BANDERSNATCHLING,1)
       if count_foot == 49 and count_trunk == count_spice == 50 :
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")
       else:
         st.playSound("ItemSound.quest_itemget")	
     elif npcId in [ HOT_SPRINGS_ATROX,HOT_SPRINGS_ATROXSPAWN ] and count_spice < 50 :
       st.giveItems(SECRET_SPICE,1)
       if count_trunk == count_foot == 50 and count_spice == 49 :
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")
       else:
         st.playSound("ItemSound.quest_itemget")	
   return

QUEST       = Quest(624,"624_TheFinestIngredientsPart1","The Finest Ingredients - Part 1")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(JEREMY)

CREATED.addTalkId(JEREMY)
STARTED.addTalkId(JEREMY)
COMPLETED.addTalkId(JEREMY)

STARTED.addKillId(HOT_SPRINGS_ATROX)
STARTED.addKillId(HOT_SPRINGS_NEPENTHES)
STARTED.addKillId(HOT_SPRINGS_ATROXSPAWN)
STARTED.addKillId(HOT_SPRINGS_BANDERSNATCH)

STARTED.addQuestDrop(HOT_SPRINGS_ATROX,SECRET_SPICE,1)
STARTED.addQuestDrop(HOT_SPRINGS_NEPENTHES,TRUNK_OF_NEPENTHES,1)
STARTED.addQuestDrop(HOT_SPRINGS_ATROXSPAWN,SECRET_SPICE,1)
STARTED.addQuestDrop(HOT_SPRINGS_BANDERSNATCH,FOOT_OF_BANDERSNATCHLING,1)

print "importing quests: 624: The Finest Ingredients - Part 1"