import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

BLOOD_OF_SAINT = 7169

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31517-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")

    elif event == "31517-03-choose.htm" :
      if st.getQuestItemsCount(BLOOD_OF_SAINT) < 300 :
         htmltext = "31517-bug.htm"

    elif event == "rew_exp" :
      st.takeItems(BLOOD_OF_SAINT,-1)
      st.addExpAndSp(162773,12500)
      htmltext = "31517-reward.htm"
      st.set("cond","0")
      st.setState(COMPLETED)

    elif event == "rew_adena" :
      st.takeItems(BLOOD_OF_SAINT,-1)
      st.giveItems(57,100000)
      htmltext = "31517-reward.htm"
      st.set("cond","0")
      st.setState(COMPLETED)

    return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 31517 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() < 62 :
               htmltext = "31517-00.htm"
               st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 62 :
               htmltext = "31517-01.htm"
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and st.getQuestItemsCount(BLOOD_OF_SAINT) < 300 :
            htmltext = "31517-02-rep.htm"
      elif cond == 2 and st.getQuestItemsCount(BLOOD_OF_SAINT) == 300 :
            htmltext = "31517-03.htm"

   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if st.getInt("cond") == 1 and st.getRandom(10) < 7 and st.getQuestItemsCount(BLOOD_OF_SAINT) == 299 :
      st.giveItems(BLOOD_OF_SAINT,1)
      if st.getQuestItemsCount(BLOOD_OF_SAINT) < 300 :
         st.playSound("ItemSound.quest_itemget")
      else :
        st.set("cond","2")
        st.playSound("ItemSound.quest_middle")
   return

QUEST       = Quest(626,"626_ADarkTwilight","A Dark Twilight")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31517)

CREATED.addTalkId(31517)
STARTED.addTalkId(31517)
COMPLETED.addTalkId(31517)

for mob in range(21520,21542) :
  STARTED.addKillId(mob)
  STARTED.addQuestDrop(mob,BLOOD_OF_SAINT,1)
STARTED.addQuestDrop(31517,57,1)

print "importing quests: 626: A Dark Twilight"