import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

TALON_OF_STAKATO = 7250
GOLDEN_RAM_COIN = 7251

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31554-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "31554-04.htm" :
      if st.getQuestItemsCount(TALON_OF_STAKATO) >= 100 :
         st.takeItems(TALON_OF_STAKATO,100)
         st.giveItems(GOLDEN_RAM_COIN,20)
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
      else :
         htmltext = "31554-bug.htm"
    elif event == "31554-quit.htm" :
      st.takeItems(TALON_OF_STAKATO,-1)
      st.playSound("ItemSound.quest_finish")
      st.exitCurrentQuest(True)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 31554 :
      if cond == 0 :
         if st.getPlayer().getLevel() >= 66 :
            htmltext = "31554-01.htm"
         else :
            htmltext = "31554-00.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getQuestItemsCount(TALON_OF_STAKATO) < 100 :
         htmltext = "31554-02r.htm"
      elif cond == 1 and st.getQuestItemsCount(TALON_OF_STAKATO) >= 100 :
         htmltext = "31554-03.htm"

   return htmltext

 def onKill(self,npc,st):
   cond = st.getInt("cond")
   if cond == 1 and st.getRandom(10) < 5 :
      st.giveItems(TALON_OF_STAKATO,1)
      if st.getQuestItemsCount(TALON_OF_STAKATO) == 100 :
         st.playSound("ItemSound.quest_middle")
      else :
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(629,"629_CleanuptheSwampofScreams","Clean up the Swamp of Screams")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31554)

STARTED.addTalkId(31554)
COMPLETED.addTalkId(31554)

for mob in range(21508,21520):
   STARTED.addKillId(mob)

for mob in range(21508,21520):
   STARTED.addQuestDrop(mob,TALON_OF_STAKATO,1)
STARTED.addQuestDrop(31554,GOLDEN_RAM_COIN,1)

print "importing quests: 629: Clean up the Swamp of Screams"