import sys
from l2f import Config
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

#NPC
TUNATUN = 31537

#MOBS
ALPEN_COUGAR = 21489
ALPEN_BUFFALO = 21470
ALPEN_KOOKABURRA = 21451

#ITEMS
TOP_QUALITY_MEAT = 7546

#REWARDS
MOLD_GLUE,MOLD_LUBRICANT,MOLD_HARDENER,ENRIA,ASOFE,THONS = 4039,4040,4041,4042,4043,4044
REWARDS={"1":[MOLD_GLUE,15],"2":[ASOFE,15],"3":[THONS,15],"4":[MOLD_LUBRICANT,10],"5":[ENRIA,10],"6":[MOLD_HARDENER,5]}


class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "31537-03.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "31537-05.htm" and st.getQuestItemsCount(TOP_QUALITY_MEAT) == 120 :
     st.set("cond","3")
   elif event in REWARDS.keys() :
     htmltext = "31537-07.htm"
     item,qty=REWARDS[event]
     if st.getQuestItemsCount(TOP_QUALITY_MEAT) == 120 and st.getInt("cond") == 3:
       htmltext = "31537-06.htm"
       st.takeItems(TOP_QUALITY_MEAT,120)
       st.giveItems(item,int(qty*Config.RATE_QUESTS_REWARD))
       st.playSound("ItemSound.quest_finish")
       st.set("cond","0")
       st.setState(COMPLETED)
   return htmltext

 def onTalk (self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
     if st.getPlayer().getLevel() >= 65 :
       htmltext = "31537-01.htm"
     else:
       htmltext = "31537-02.htm"
       st.exitCurrentQuest(True)
   elif cond == 1 :
     htmltext = "31537-01a.htm"
   elif cond == 2 and st.getQuestItemsCount(TOP_QUALITY_MEAT) == 120 :
     htmltext = "31537-04.htm"
   elif cond == 3 :
     htmltext = "31537-05.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   chance = st.getRandom(100)
   count = st.getQuestItemsCount(TOP_QUALITY_MEAT)
   if st.getInt("cond") == 1 : 
     if npcId in [21489,21470,21451] :
       if count < 120 and chance < 80 :
         st.giveItems(TOP_QUALITY_MEAT,1)
         if count == 119 :
           st.playSound("ItemSound.quest_middle")
           st.set("cond","2")
         else:
           st.playSound("ItemSound.quest_itemget")	
   return

QUEST       = Quest(631,"631_DeliciousTopChoiceMeat","Delicious Top Choice Meat",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(TUNATUN)

CREATED.addTalkId(TUNATUN)
STARTED.addTalkId(TUNATUN)
COMPLETED.addTalkId(TUNATUN)

STARTED.addKillId(ALPEN_COUGAR)
STARTED.addKillId(ALPEN_BUFFALO)
STARTED.addKillId(ALPEN_KOOKABURRA)

STARTED.addQuestDrop(ALPEN_COUGAR,TOP_QUALITY_MEAT,1)
STARTED.addQuestDrop(ALPEN_BUFFALO,TOP_QUALITY_MEAT,1)
STARTED.addQuestDrop(ALPEN_KOOKABURRA,TOP_QUALITY_MEAT,1)

print "importing quests: 631: Delicious Top Choice Meat"