#Create by Artful
import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

# NPC
GALATEA = 30634

# MOBS
MOBS=[20078,21026,21025,21024,21023]

#QUEST ITEMS
FAIRY_BREATH = 8286

#REWARDS
ADENA = 57

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30634-03.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "30634-06.htm" :
       count = st.getQuestItemsCount(FAIRY_BREATH)
       if count > 0 :
          if count<10 :
             reward = count*50
          else :
             reward = count*50+5365
          st.takeItems(FAIRY_BREATH,-1)
          st.giveItems(ADENA,reward)
    elif event == "30634-08.htm" :
       st.exitCurrentQuest(True)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   if id == CREATED :
      st.set("cond","0")
   cond = st.getInt("cond") 
   if st.getPlayer().getLevel() < 26 :
      htmltext = "30634-01.htm"
      st.exitCurrentQuest(True)
   elif cond == 0 :
      htmltext = "30634-02.htm"
   elif cond == 1 :
      if st.getQuestItemsCount(FAIRY_BREATH) == 0 :
        htmltext = "30634-04.htm"
      else :
        htmltext = "30634-05.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if st.getInt("cond") == 1 :
      chance = st.getRandom(100)
      if npcId in MOBS and chance < 30 :
         st.giveItems(FAIRY_BREATH,1)
         st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(659,"659_IdRatherBeCollectingFairyBreath","I'd Rather Be Collecting Fairy Breath")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(GALATEA)
CREATED.addTalkId(GALATEA)
STARTED.addTalkId(GALATEA)
COMPLETED.addTalkId(GALATEA)

for mob in MOBS:
   STARTED.addKillId(mob)

print "importing quests: 659: I'd Rather Be Collecting Fairy Breath"
