import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

ROXXY      = 30006
BAULRO     = 30033
SIR_COLLIN = 30311
 
BAULRO_LETTER = 7571
 
SCROLL_OF_ESCAPE_GIRAN = 7126
MARK_OF_TRAVELER       = 7570

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30006-03.htm" :
     st.set("cond","1")
     st.setState(STARTED) 
     st.playSound("ItemSound.quest_accept")
   elif event == "30033-02.htm" :
     st.giveItems(BAULRO_LETTER,1)
     st.set("cond","2")
     st.playSound("ItemSound.quest_middle")
   elif event == "30311-03.htm" :
     st.takeItems(BAULRO_LETTER,-1)
     st.set("cond","3")
     st.playSound("ItemSound.quest_middle")
   elif event == "30006-06.htm" :
     st.giveItems(SCROLL_OF_ESCAPE_GIRAN,1)
     st.giveItems(MARK_OF_TRAVELER, 1)
     st.unset("cond")
     st.setState(COMPLETED)
     st.playSound("ItemSound.quest_finish")
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   cond  = st.getInt("cond")
   id    = st.getState()
   if npcId == ROXXY :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() == 0 and st.getPlayer().getLevel() >= 3 :
               htmltext = "30006-02.htm"
            else :
               htmltext = "30006-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>"
      elif cond == 1 :
         htmltext = "30006-04.htm"
      elif cond == 3 :
         htmltext = "30006-05.htm" 
   elif npcId == BAULRO :
      if cond == 1:
         htmltext = "30033-01.htm"
      elif cond == 2 and st.getQuestItemsCount(BAULRO_LETTER):
         htmltext = "30033-03.htm"
   elif npcId == SIR_COLLIN :
      if cond == 2 and st.getQuestItemsCount(BAULRO_LETTER) :
         htmltext = "30311-02.htm"
      elif cond == 2 and st.getQuestItemsCount(BAULRO_LETTER) == 0 :
         htmltext = "30311-havent.htm"
      elif cond == 3 :
         htmltext = "30311-03r.htm"
   return htmltext

QUEST     = Quest(6,"6_StepIntoTheFuture","Step into the Future")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(ROXXY)

CREATED.addTalkId(ROXXY)
COMPLETED.addTalkId(ROXXY)

STARTED.addTalkId(ROXXY) 
STARTED.addTalkId(BAULRO)
STARTED.addTalkId(SIR_COLLIN)

STARTED.addQuestDrop(ROXXY,BAULRO_LETTER,1)
STARTED.addQuestDrop(ROXXY,SCROLL_OF_ESCAPE_GIRAN,1)
STARTED.addQuestDrop(ROXXY,MARK_OF_TRAVELER,1) 

print "importing quests: 6: Step into the Future"