import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

MIRABEL  = 30146
ARIEL    = 30148
ASTERIOS = 30154

ARIELS_RECOMMENDATION = 7572
 
SCROLL_OF_ESCAPE_GIRAN = 7126
MARK_OF_TRAVELER       = 7570
 
class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30146-03.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept") 
   elif event == "30148-02.htm" : 
     st.giveItems(ARIELS_RECOMMENDATION,1)
     st.set("cond","2")
     st.playSound("ItemSound.quest_middle")
   elif event == "30154-02.htm" :
     st.takeItems(ARIELS_RECOMMENDATION,-1)
     st.set("cond","3")
     st.playSound("ItemSound.quest_middle")
   elif event == "30146-06.htm" :
     st.giveItems(SCROLL_OF_ESCAPE_GIRAN,1)
     st.giveItems(MARK_OF_TRAVELER, 1)
     st.set("cond","0")
     st.setState(COMPLETED)
     st.playSound("ItemSound.quest_finish")
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   cond  = st.getInt("cond")
   id    = st.getState()
   if npcId == MIRABEL :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() == 1 and st.getPlayer().getLevel() >= 3 :
                 htmltext = "30146-02.htm"
            else :
                 htmltext = "30146-01.htm"
                 st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>"
      elif cond == 1 :
         htmltext = "30146-04.htm"
      elif cond == 3 :
         htmltext = "30146-05.htm"
   elif npcId == ARIEL :
      if cond == 1 and st.getQuestItemsCount(ARIELS_RECOMMENDATION) == 0 :
         htmltext = "30148-01.htm"
      elif cond == 2 :
         htmltext = "30148-03.htm"
   elif npcId == ASTERIOS :
      if cond == 2 and st.getQuestItemsCount(ARIELS_RECOMMENDATION) > 0 :
         htmltext = "30154-01.htm"
      elif cond == 2 and st.getQuestItemsCount(ARIELS_RECOMMENDATION) == 0 :
         htmltext = "30154-havent.htm"
      elif cond == 3 :
         htmltext = "30154-02r.htm"
   return htmltext

QUEST     = Quest(7,"7_ATripBegins","A Trip Begins")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)
 
QUEST.setInitialState(CREATED)
QUEST.addStartNpc(MIRABEL)

CREATED.addTalkId(MIRABEL)
COMPLETED.addTalkId(MIRABEL)

STARTED.addTalkId(MIRABEL)
STARTED.addTalkId(ARIEL)
STARTED.addTalkId(ASTERIOS)

STARTED.addQuestDrop(ARIEL,ARIELS_RECOMMENDATION,1)
STARTED.addQuestDrop(MIRABEL,SCROLL_OF_ESCAPE_GIRAN,1)
STARTED.addQuestDrop(MIRABEL,MARK_OF_TRAVELER,1)

print "importing quests: 7: A Trip Begins"