import sys
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

JASMINE = 30134
ROSELYN = 30355
HARNE   = 30144

ROSELYNS_NOTE = 7573

SCROLL_OF_ESCAPE_GIRAN = 7126
MARK_OF_TRAVELER       = 7570
 
class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr) 

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30134-03.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "30355-02.htm" :
     st.giveItems(ROSELYNS_NOTE,1)
     st.set("cond","2")
     st.playSound("ItemSound.quest_middle")
   elif event == "30144-02.htm" :
     st.takeItems(ROSELYNS_NOTE,-1)
     st.set("cond","3")
     st.playSound("ItemSound.quest_middle")
   elif event == "30134-06.htm" :
     st.giveItems(SCROLL_OF_ESCAPE_GIRAN,1)
     st.giveItems(MARK_OF_TRAVELER, 1)
     st.set("cond","0")
     st.setState(COMPLETED)
     st.playSound("ItemSound.quest_finish")
   return htmltext 

 def onTalk (Self,npc,st): 
   htmltext = "<html><body>I have nothing to say you</body></html>" 
   npcId = npc.getNpcId() 
   cond  = st.getInt("cond") 
   id    = st.getState() 
   if npcId == JASMINE :
      if cond == 0 and st.getPlayer().getRace().ordinal() == 2 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 3 :
               htmltext = "30134-02.htm"
            else :
               htmltext = "30134-01.htm"
               st.exitCurrentQuest(True)
         else:
            htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>"
      elif cond == 1 :
         htmltext = "30134-04.htm"
      elif cond == 3 :
         htmltext = "30134-05.htm"
   elif npcId == ROSELYN :
      if st.getQuestItemsCount(ROSELYNS_NOTE) == 0 :
         htmltext = "30355-01.htm"
      else :
         htmltext = "30355-03.htm"
   elif npcId == HARNE :
      if cond == 2 and st.getQuestItemsCount(ROSELYNS_NOTE) > 0 :
         htmltext = "30144-01.htm"
      elif cond == 2 and st.getQuestItemsCount(ROSELYNS_NOTE) == 0 : 
         htmltext = "30144-havent.htm"
      elif cond == 3 : 
         htmltext = "30144-02r.htm"
   return htmltext

QUEST     = Quest(8,"8_AnAdventureBegins","An Adventure Begins")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)
 
QUEST.setInitialState(CREATED)
QUEST.addStartNpc(JASMINE)

CREATED.addTalkId(JASMINE)
COMPLETED.addTalkId(JASMINE)

STARTED.addTalkId(JASMINE)
STARTED.addTalkId(ROSELYN)
STARTED.addTalkId(HARNE)

STARTED.addQuestDrop(ROSELYN,ROSELYNS_NOTE,1)
STARTED.addQuestDrop(JASMINE,SCROLL_OF_ESCAPE_GIRAN,1)
STARTED.addQuestDrop(JASMINE,MARK_OF_TRAVELER,1)

print "importing quests: 8: An Adventure Begins"