import sys
from l2f.gameserver.serverpackets import SystemMessage
from l2f.gameserver.tables import SkillTable
from l2f.gameserver.model.quest import State
from l2f.gameserver.model.quest import QuestState
from l2f.gameserver.model.quest import QuestJython as JQuest

SPAWNED = 0
HITED = 0
HITS = 0

ICE_CRYSTAL_ID = 7080
REPORT_ID = 7532
RESONANCE_AMULET_1_ID = 7293
RESONANCE_AMULET_2_ID = 7324
RESONANCE_AMULET_3_ID = 7355
RESONANCE_AMULET_4_ID = 7386
RESONANCE_AMULET_5_ID = 7417
RESONANCE_AMULET_6_ID = 7448
DIVINE_STONE_OF_WISDOM_ID = 7081
HALISHA_MARK_ID = 7510
ADEN_ID = 57
BOOK_ID = 6622

#Mobs kill
KILL_TABL3 = 27258





class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
#Mordred
   if event == "31582-03.htm" :
      if st.getPlayer().getClassId().getId() == 6 and st.getPlayer().getLevel() >=76 :
         st.giveItams(7086,1)
         st.set("id","1")
         st.set("cond","1")
         st.set("count","0")
         st.playSound("ItemSound.quest_accept")
         st.setState(STARTED)
   elif event == "31582-07.htm" :
      if st.getPlayer().getLevel() >=76 :
         st.takeItems(7086,-1)
         st.addExpAndSp(2299404,0)
         st.giveItems(ADEN_ID,5000000)
         st.giveItems(BOOK_ID,1)
         st.getPlayer().setClassId(91)
         st.getPlayer().setBaseClass(91)
         st.player.broadcastUserInfo()
         st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339,1),st.getPlayer())
         st.playSound("ItemSound.quest_fanfare_2")
         st.exitCurrentQuest(True)
         st.setState(COMPLETED)
      else :
         htmltext = "31582-08.htm"
         st.takeItems(7086,-1)
         st.set("id","16")
         st.set("cond","20")
         st.playSound("ItemSound.quest_middle")
#Bavarin
   elif event =="31623-15.htm" :
      st.set("id","3")
      st.set("cond","3")
      st.playSound("ItemSound.quest_middle")
   elif event == "31623-16.htm" :
      st.giveItems(REPORT_ID,1)
      st.takeItems(ICE_CRYSTAL_ID,-1)
      st.set("id","4")
      st.set("cond","4")
      st.playSound("ItemSound.quest_middle")
#Bayard
   elif event == "31297-05.htm" :
      st.set("id","2")
      st.set("cond","2")
      st.playSound("ItemSound.quest_middle")
   elif event == "31297-06.htm" :
      st.giveItems(RESONANCE_AMULET_1_ID,)
      st.takeItems(REPORT_ID,-1)
      st.set("id","5")
      st.set("cond","5")
      st.playSound("ItemSound.quest_middle")
   elif event == "31297-22.htm" :
      st.set("id","9")
      st.set("cond","11")
      st.playSound("ItemSound.quest_middle")     
   elif event == "31297-23.htm" :      
      st.set("id","9")
      st.set("cond","12")
      st.playSound("ItemSound.quest_middle")           
   elif event == "31297-28.htm" :         
      st.giveItems(RESONANCE_AMULET_4_ID,1)
      st.takeItems(DIVINE_STONE_OF_WISDOM_ID,-1)
      st.set("id","10")
      st.set("cond","13")
      st.playSound("ItemSound.quest_middle")                 
   elif event == "31297-33.htm" :
      st.set("id","12")
      st.set("cond","15")
      st.playSound("ItemSound.quest_middle")                        
#Tablet1      
   elif event == "31646-02.htm" :
      st.takeItems(RESONANCE_AMULET_1_ID,1)
      st.set("cond","6")
      st.set("id","6")
      st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546,1),st.getPlayer())
      st.playSound("ItemSound.quest_middle")       
#Tablet2        
   elif event == "31647-03.htm" :
      st.takeItems(RESONANCE_AMULET_2_ID,-1)
      st.set("id","7")
      st.set("cond","8")
      st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546,1),st.getPlayer())
      st.playSound("ItemSound.quest_middle")    
#tablet3
   elif event == "31653-02.htm" :
      if SPAWNED > 0 :
         if HITED > 0 :
            htmltext="31653-04.htm"
         else :
            htmltext="31653-03.htm"
      else:
         st.playSound("Itemsound.quest_before_battle")
         st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(KILL_TABL3, 160987,-70194,-2655)).getLastSpawn().addDamageHate(st.getPlayer(),1,100)
         SPAWNED = 1
         st.startQuestTimer("chat_timer",500)
         st.startQuestTimer("despawn_timer",300000)
   elif event == "31653-06.htm" :
      st.takeItems(RESONANCE_AMULET_3_ID,-1)
      st.set("id","8")
      st.set("cond","10")
      st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546,1),st.getPlayer())
      st.playSound("ItemSound.quest_middle")
#Timers
   elif event=="chat_timer" :
      st.getPlayer().sendPacket(SystemMessage.sendString("Archangel Iconoclasis: Your this fellow... " + st.getPlayer().getName() + "? Cannot become Hunt always collaborate rests the tower sound!"))
   elif event=="despawn_timer" :
      if SPAWNED > 0 :
         st.getPlayer().sendPacket(SystemMessage.sendString("Archangel Iconoclasis: Cuts Compared to imagines has the endurance oh This stops"))
         st.getPcSpawn().removeAllSpawn()
         SPAWNED = 0
   elif event=="halette_chat" :
      st.getPlayer().sendPacket(SystemMessage.sendString("Death Lord Hallate: any, is betrays Always thought somewhat strangely... cuts, this secondary retreated."))
   elif event=="halette_unspawn" :
      if SPAWNED > 0 :
         st.getPlayer().sendPacket(SystemMessage.sendString("Death Lord Hallate: shouts, then I first walk step..."))
         st.getPcSpawn().removeSpawn(27263)
         st.set("i_quest","2")
   elif event=="waldstein_chat" :
      st.getPlayer().sendPacket(SystemMessage.sendString("Disgraced Knight Waldstein: you cannot and the mystical flagstone cross coupling! Hands over the cross coupling stone!"))
      st.startQuestTimer("waldstein_chat1",1500)
   elif event=="waldstein_chat1" :
      st.getPlayer().sendPacket(SystemMessage.sendString("Disgraced Knight Waldstein: this, a person still somewhat impolite... "+st.getPlayer().getName()+"! Helps me!"))    
      st.startQuestTimer("waldstein_chat2",10000)
   elif event=="waldstein_chat2" :
      if HITS <= 15 :
         if st.getRandom(2) == 0 :
            st.getPlayer().sendPacket(SystemMessage.sendString("Disgraced Knight Waldstein: "+st.getPlayer().getName()+"! Grasps Otherwise had to slip away."))
         else :
            st.getPlayer().sendPacket(SystemMessage.sendString("Disgraced Knight Waldstein: "+st.getPlayer().getName()+"! A bit faster grasps."))
         st.startQuestTimer("waldstein_chat2",13000)
   elif event=="waldstein_unspawn" :
      if int(st.get("i_quest")) == 2 :
         st.getPlayer().sendPacket(SystemMessage.sendString("Disgraced Knight Waldstein: cuts Wants to escape Does not halt!"))
         st.getPcSpawn().removeSpawn(31599)
   elif event=="halisha_unspawn" :
      st.getPlayer().sendPacket(SystemMessage.sendString("Archon of Halisha: stops, please return."))
      st.getPcSpawn().removeSpawn(27244)
#Tablet4
   elif event == "31654-02.htm" : 
      st.takeItems(RESONANCE_AMULET_4_ID,1) 
      st.set("id","11")
      st.set("cond","14")
      st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546,1),st.getPlayer())
      st.playSound("ItemSound.quest_middle") 
#Tablet5
   elif event == "31655-03.htm" : 
      st.takeItems(RESONANCE_AMULET_5_ID,-1)
      st.set("cond","17")
      st.set("id","13")
      st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546,1),st.getPlayer())
      st.playSound("ItemSound.quest_middle")
#6 Tablet         
   elif event == "31656-02.htm" : 
      if SPAWNED > 0 :
         if HITED > 0 :
            htmltext="31656-04.htm"
         else :
            htmltext="31656-03.htm"
      else:
         st.getPcSpawn().removeAllSpawn()          
         st.getPcSpawn().addSpawn(31599, 47429,-56923,-2383)
         st.getPcSpawn().addSpawn(27263, 47391,-56929,-2370)
         SPAWNED=1
         st.startQuestTimer("halette_chat",500)
         st.startQuestTimer("halette_unspawn",59000)
         st.startQuestTimer("waldstein_chat",500)
         st.startQuestTimer("waldstein_unspawn",60000)
         st.set("i_quest","0")
         st.playSound("Itemsound.quest_before_battle")
   elif event == "31656-06.htm" :
      st.getPcSpawn().removeAllSpawn()
      st.set("id","15")
      st.set("cond","19")
      st.takeItems(RESONANCE_AMULET_6_ID,-1)
      st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546,1),st.getPlayer())
      st.playSound("ItemSound.quest_middle") 
#Disgraced Knight Waldstein
   elif event == "final" :
      st.giveItems(RESONANCE_AMULET_6_ID,1)
      st.set("cond","18")
      st.playSound("ItemSound.quest_middle")
      st.getPlayer().sendPacket(SystemMessage.sendString("Disgraced Knight Waldstein: that next time goodbye."))
      st.getPcSpawn().removeSpawn(31599)
      st.set("i_quest","0")
   return htmltext


 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
#Mordred
   if id == COMPLETED :
      htmltext = "You have been allready copleted this quest!"
   if npcId == 31582 and id == CREATED :
      if st.getPlayer().getClassId().getId() == 6 and st.getPlayer().getLevel() >=76 :
         htmltext = "31582-01.htm"
      else :
         htmltext = "31582-02.htm"
   elif npcId == 31582 and int(st.get("id"))==1 :
      htmltext = "31582-04.htm"
   elif npcId == 31582 and int(st.get("id"))==15 :
      htmltext = "31582-06.htm"
   elif npcId == 31582 and int(st.get("id"))==16 :
      if st.getPlayer().getLevel() >=76 :
         st.addExpAndSp(2299404,0)
         st.giveItems(ADEN_ID,5000000)
         st.giveItems(BOOK_ID,1)
         st.getPlayer().setClassId(91)
         st.getPlayer().setBaseClass(91)
         st.player.broadcastUserInfo()
         st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339,1),st.getPlayer())
         st.playSound("ItemSound.quest_fanfare_2")
         st.exitCurrentQuest(True)
         st.setState(COMPLETED)
         htmltext = "31582-09.htm"
      else :
         htmltext = "31582-10.htm"
#Bavarin   
   elif npcId == 31623 and int(st.get("id"))==2 :
      htmltext = "31623-11.htm"
   elif (npcId == 31623 and int(st.get("id"))==3) : 
      if st.getQuestItemsCount(ICE_CRYSTAL_ID)>=1 :
         htmltext = "31623-13.htm"
      else:
         htmltext = "31623-12.htm" 
   elif npcId == 31623 and int(st.get("id"))==4 :
      htmltext = "31623-14.htm"
#Bayard
   elif npcId == 31297 and int(st.get("id"))==1 :
      htmltext = "31297-01.htm"
   elif npcId == 31297 and int(st.get("id"))>=2 and int(st.get("id"))<=4 and st.getQuestItemsCount(REPORT_ID)==0 :
      htmltext = "31297-02.htm"      
   elif npcId == 31297 and int(st.get("id"))>=2 and int(st.get("id"))<=4 and st.getQuestItemsCount(REPORT_ID)>=1 :
      htmltext = "31297-03.htm"
   elif npcId == 31297 and int(st.get("id"))==5 :
      htmltext = "31297-04.htm"
   elif npcId == 31297 and int(st.get("id"))==8 :
      htmltext = "31297-21.htm"
   elif npcId == 31297 and int(st.get("id"))==9 and st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM_ID) == 0 :
      htmltext = "31297-24.htm"
   elif npcId == 31297 and int(st.get("id"))==9 and st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM_ID) >= 1 :
      htmltext = "31297-25.htm"
   elif npcId == 31297 and int(st.get("id"))==10 :
      htmltext = "31297-26.htm"
   elif npcId == 31297 and int(st.get("id"))==11 :
      htmltext = "31297-31.htm"
   elif npcId == 31297 and int(st.get("id"))==12 :
      htmltext = "31297-32.htm"
#Tablet1       
   elif npcId == 31646 and int(st.get("id"))==5 and st.getQuestItemsCount(RESONANCE_AMULET_1_ID)>=1 :
      htmltext = "31646-01.htm"
   elif npcId == 31646 and int(st.get("id"))==6 :
      htmltext = "31646-03.htm"   
#Tablet2 
   elif npcId == 31647 and int(st.get("id"))==6 and st.getQuestItemsCount(RESONANCE_AMULET_2_ID)==0 :
      htmltext = "31647-01.htm"
   elif npcId == 31647 and int(st.get("id"))==6 and st.getQuestItemsCount(RESONANCE_AMULET_2_ID)>=1 :
      htmltext = "31647-02.htm"
   elif npcId == 31647 and int(st.get("id"))==7 :
      htmltext = "31647-04.htm"
#Tablet3
   elif npcId == 31653 and int(st.get("cond"))==7 and st.getQuestItemsCount(RESONANCE_AMULET_3_ID)==0 :
      htmltext = "31653-01.htm"
   elif npcId == 31653 and int(st.get("cond"))==7 and st.getQuestItemsCount(RESONANCE_AMULET_3_ID)>=0 :
      htmltext = "31653-05.htm"
   elif npcId == 31653 and int(st.get("cond"))==8 :
      htmltext = "31653-07.htm"
#Tablet 4
   elif npcId == 31654 and int(st.get("id"))==10 and st.getQuestItemsCount(RESONANCE_AMULET_4_ID)>=1 :
      htmltext = "31654-01.htm"
   elif npcId == 31654 and int(st.get("id"))==11 :
      htmltext = "31654-03.htm"
#Tablet 5
   elif npcId == 31655 and int(st.get("id"))==12 and st.getQuestItemsCount(RESONANCE_AMULET_5_ID)==0 :
      htmltext = "31655-01.htm"
   elif npcId == 31655 and int(st.get("id"))==12 and st.getQuestItemsCount(RESONANCE_AMULET_5_ID)>=1 :
      htmltext = "31655-02.htm"
   elif npcId == 31655 and int(st.get("id"))==13 :
      htmltext = "31655-04.htm"
#Tablet 6
   elif npcId == 31656 and (int(st.get("id"))==13 or int(st.get("id"))==14) and st.getQuestItemsCount(RESONANCE_AMULET_6_ID)==0 :
      htmltext = "31656-01.htm"
   elif npcId == 31656 and int(st.get("id"))==14 and st.getQuestItemsCount(RESONANCE_AMULET_6_ID)>=1 :
      htmltext = "31656-05.htm"
   elif npcId == 31656 and int(st.get("id"))==15 :
      htmltext = "31656-07.htm"
#Disgraced Knight Waldstein
   elif npcId == 31599 and int(st.get("id"))==13 :
      if int(st.get("i_quest"))==0 :
         htmltext = "31599-01.htm"
      elif int(st.get("i_quest"))==1 :
         htmltext = "31599-03.htm"
   elif npcId == 31599 and st.getQuestItemsCount(RESONANCE_AMULET_6_ID)==0 and int(st.get("id"))==14 :
      if int(st.get("i_quest"))==0 :
         htmltext = "31599-04.htm"
      elif int(st.get("i_quest"))==1 :
         htmltext = "31599-06.htm"
   elif npcId == 31599 and st.getQuestItemsCount(RESONANCE_AMULET_6_ID)>=1 and int(st.get("id"))==14 :
      if int(st.get("i_quest"))==0 :
         htmltext = "31599-08.htm"
      elif int(st.get("i_quest"))==1 :
         htmltext = "31599-09.htm"
   return htmltext

 def onAttack (self, npc, st):                   
   npcId = npc.getNpcId()
   if npcId == KILL_TABL3 :
      HITED = 1
   elif npcId == 27263 :
      HITED = 1
      HITS = HITS+1
      if HITS <= 15 :
         if HITS == 1 :
            st.getPlayer().sendPacket(SystemMessage.sendString("Death Lord Hallate: your this fellow... "+st.getPlayer().getName()+"? Became two people, thought could block my escape route?"))
      else :
         st.set("id","14")
         st.set("i_quest","1")
         st.getPlayer().sendPacket(SystemMessage.sendString("Death Lord Hallate: this! My cross coupling stone... "+st.getPlayer().getName()+", I can remember always."))
         st.getPcSpawn().removeSpawn(27263)
   return

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if npcId == 27214 and int(st.get("id"))==6 :
      if int(st.get("count")) > 9 :
         st.giveItems(RESONANCE_AMULET_2_ID,1)
         st.set("cond","7")   
         st.playSound("ItemSound.quest_middle")
      else :
         st.set("count",str(int(st.get("count"))+1))
   elif npcId == KILL_TABL3 :
      if int(st.get("id")) == 7 and st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 0 :
         st.getPlayer().sendPacket(SystemMessage.sendString("Archangel Iconoclasis: I unexpectedly can lose..."))
         st.giveItems(RESONANCE_AMULET_3_ID,1)
         st.set("cond","9")
         st.playSound("ItemSound.quest_middle")
   if npcId in [21646, 21647, 21648, 21649, 21650, 21651]  :
      if int(st.get("id")) == 12  and st.getQuestItemsCount(HALISHA_MARK_ID)<701 :
         st.giveItems(HALISHA_MARK_ID,1)
         if st.getQuestItemsCount(HALISHA_MARK_ID) == 701 :
            st.playSound("Itemsound.quest_before_battle")
            st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(27244, npc.getX(),npc.getY(),npc.getZ())).getLastSpawn().addDamageHate(st.getPlayer(),1,100)
            st.takeItems(HALISHA_MARK_ID,20)
            st.getPlayer().sendPacket(SystemMessage.sendString("Archon of Halisha: "+st.getPlayer().getName()+", recently suffered under our unit the person was your this fellow?"))
            st.startQuestTimer("halisha_unspawn",600000)
         else:
            st.playSound("ItemSound.quest_itemget")
   elif npcId == 27244 :
      if int(st.get("id")) == 12 and st.getQuestItemsCount(RESONANCE_AMULET_5_ID) == 0 :
         st.playSound("ItemSound.quest_middle")
         st.giveItems(RESONANCE_AMULET_5_ID,1)
         st.takeItems(HALISHA_MARK_ID,-1)
         st.getPlayer().sendPacket(SystemMessage.sendString("Archon of Halisha: Strives to excel Arab League..."))
         st.set("cond","16") 
   return

QUEST       = Quest(95,"95_SagaOfTheHellKnight","Saga of the Hell Knight")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)


QUEST.setInitialState(CREATED)
#Fist NPC
QUEST.addStartNpc(31582)
CREATED.addTalkId(31582)
STARTED.addTalkId(31582)
COMPLETED.addTalkId(31582)
#Bavarin
STARTED.addTalkId(31623)
#Bayard
STARTED.addTalkId(31297)
#Tablet 1
STARTED.addTalkId(31646) 
#Tablet 2
STARTED.addTalkId(31647)
#Tablet 3
STARTED.addTalkId(31653)
#Tablet 4
STARTED.addTalkId(31654)
#Tablet 5
STARTED.addTalkId(31655)
#Tablet 6
STARTED.addTalkId(31656)
#NPC TABLET 6
STARTED.addTalkId(31599)

STARTED.addAttackId(KILL_TABL3)
STARTED.addAttackId(27263)

STARTED.addKillId(27214)
STARTED.addKillId(KILL_TABL3)
STARTED.addKillId(27244)
STARTED.addKillId(21646)
STARTED.addKillId(21647)
STARTED.addKillId(21648)
STARTED.addKillId(21649)
STARTED.addKillId(21650)
STARTED.addKillId(21651)

STARTED.addQuestDrop(27214,RESONANCE_AMULET_2_ID,1)
STARTED.addQuestDrop(KILL_TABL3,RESONANCE_AMULET_3_ID,1)
STARTED.addQuestDrop(27244,RESONANCE_AMULET_5_ID,1)
STARTED.addQuestDrop(21646,HALISHA_MARK_ID,1)
STARTED.addQuestDrop(21647,HALISHA_MARK_ID,1)
STARTED.addQuestDrop(21648,HALISHA_MARK_ID,1)
STARTED.addQuestDrop(21649,HALISHA_MARK_ID,1)
STARTED.addQuestDrop(21650,HALISHA_MARK_ID,1)
STARTED.addQuestDrop(21651,HALISHA_MARK_ID,1)

print "importing quests: 95: Saga of the Hell Knight"