import sys
from l2f.gameserver.model.quest        import State
from l2f.gameserver.model.quest        import QuestState
from l2f.gameserver.model.quest        import QuestJython as JQuest

qnTutorial = "255_C4Tutorial"

NewbieHelper = {
    30009 : [ 0, 0, 1067],
    30019 : [10, 0, 1068],
    30400 : [-1, 1, 1069],
    30131 : [-1, 2, 1070],
    30575 : [-1, 3, 1496],
    30530 : [-1, 4, 1498]
    }

GrandMaster = {
    30008 : [1067,-84081, 243277,-3723],
    30017 : [1068,-84081, 243277,-3723],
    30370 : [1069, 45475,  48359,-3060],
    30129 : [1070, 17024,  13296,-3744],
    30573 : [1496,-45032,-113598, -192],
    30528 : [1498,115632,-177996, -905]
    }

NewbieGuide = [30598,30599,30600,30602,30601]
BEGINER_TRAVEL_TOKEN=8542

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st):
        htmltext = event
        qs = st.getPlayer().getQuestState(qnTutorial)
        if qs != None :
            Ex = int(qs.get("Ex"))
            classId = int(st.getPlayer().getClassId().getId())
            if event == "TimerEx_NewbieHelper" :
                if Ex == 0 :
                    st.playTutorialVoice("tutorial_voice_009a")
                    qs.set("Ex","1")
                elif Ex == 3 :
                    st.playTutorialVoice("tutorial_voice_010a")
                    qs.set("Ex","4")
                return
            elif event == "TimerEx_GrandMaster" :
                if Ex >= 4 :
                    st.showQuestionMark(7)
                    st.playSound("ItemSound.quest_tutorial")
                    st.playTutorialVoice("tutorial_voice_025")
                return
            elif int(event) in GrandMaster.keys() :
                itemId, radarX, radarY, radarZ = GrandMaster[int(event)]
                if st.getQuestItemsCount(itemId) > 0 :
                    if st.getPlayer().getClassId().isMage() :
                        if st.getQuestItemsCount(5789) <= 200 and st.getQuestItemsCount(5790) <= 100 :
                            if classId == 49 :
                                st.giveItems(5789,200)
                                st.playTutorialVoice("tutorial_voice_026")
                            else :
                                st.giveItems(5790,100)
                                st.playTutorialVoice("tutorial_voice_027")
                            
                    else :
                        if st.getQuestItemsCount(5789) <= 200 :
                            st.giveItems(5789,200)
                            st.playTutorialVoice("tutorial_voice_026")
                    st.addExpAndSp(0,50)
                    htmltext = event + ".htm"
                    st.takeItems(itemId,1)
                    st.startQuestTimer("TimerEx_GrandMaster",60000)
                    st.addRadar(radarX,radarY,radarZ)
                    if Ex <= 3 :
                        qs.set("Ex","4")
            elif int(event) in NewbieGuide :
                if Ex < 5 :
                    qs.set("Ex","5")
                    if st.getPlayer().getClassId().isMage() :
                        if st.getQuestItemsCount(5789) <= 400 and st.getQuestItemsCount(5790) <= 200 :
                            if classId == 49 :
                                st.playTutorialVoice("tutorial_voice_026")
                                st.giveItems(5789,200)
                            else :
                                st.playTutorialVoice("tutorial_voice_027")
                                st.giveItems(5790,100)
                    else :
                        if st.getQuestItemsCount(5789) <= 400 :
                            st.playTutorialVoice("tutorial_voice_026")
                            st.giveItems(5789,200)
                return
        return htmltext

    def onTalk (Self,npc,st):
        htmltext = "<html><head><body>I have nothing to say you...</body></html>"
        npcId = npc.getNpcId()
        qs = st.getPlayer().getQuestState(qnTutorial)
        if qs != None :
            Ex      = qs.getInt("Ex")
            classId = int(st.getPlayer().getClassId().getId())
            raceId  = st.getPlayer().getRace().ordinal()
            if npcId in NewbieHelper.keys() :
                occupation, race, itemId = NewbieHelper[npcId]
                if Ex < 0 :
                    if raceId == race :
                        if occupation < 0 :
                            st.startQuestTimer("TimerEx_NewbieHelper",30000)
                            qs.set("Ex","0")
                            st.onTutorialClientEvent(1048576)
                            if st.getPlayer().getClassId().isMage() :
                                htmltext = str(npcId) + "-01m.htm"
                            else :
                                htmltext = str(npcId) + "-01f.htm"
                        elif classId == occupation :
                            st.startQuestTimer("TimerEx_NewbieHelper",30000)
                            htmltext = str(npcId) + "-01.htm"
                            qs.set("Ex","0")
                            st.onTutorialClientEvent(1048576)
                        else :
                            htmltext = str(npcId) + "-06.htm"
                    else :
                        htmltext = str(npcId) + "-06.htm"
                elif Ex in [0,1,2] :
                    if st.getQuestItemsCount(6353) :
                        st.takeItems(6353,-1)
                        qs.set("Ex","3")
                        st.giveItems(itemId,1)
                        st.startQuestTimer("TimerEx_NewbieHelper",30000)
                        qs.set("ucMemo","3")
                        if st.getPlayer().getClassId().isMage() :
                            if st.getQuestItemsCount(5789) <= 0 and st.getQuestItemsCount(5790) <= 0 :
                                if classId == 49 :
                                    st.playTutorialVoice("tutorial_voice_026")
                                    st.giveItems(5789,200)
                                else :
                                    st.playTutorialVoice("tutorial_voice_027")
                                    st.giveItems(5790,100)
                        else :
                            if st.getQuestItemsCount(5789) <= 0 :
                                st.giveItems(5789,200)
                                st.playTutorialVoice("tutorial_voice_026")
                        if occupation < 0 :
                            if st.getPlayer().getClassId().isMage() :
                                htmltext = str(npcId) + "-03m.htm"
                            else :
                                htmltext = str(npcId) + "-03f.htm"
                        else :
                            htmltext = str(npcId) + "-03.htm"
                    else :
                        if occupation < 0 :
                            if st.getPlayer().getClassId().isMage() :
                                htmltext = str(npcId) + "-02m.htm"
                            else :
                                htmltext = str(npcId) + "-02f.htm"
                        else :
                            htmltext = str(npcId) + "-02.htm"
                elif Ex == 3 :
                    htmltext = str(npcId) + "-04.htm"
                elif Ex > 3 :
                    htmltext = str(npcId) + "-05.htm"
            elif npcId in GrandMaster.keys() :
                itemId, radarX, radarY, radarZ = GrandMaster[npcId]
                if st.getQuestItemsCount(itemId) > 0 :
                    if st.getPlayer().getClassId().isMage() :
                        if st.getQuestItemsCount(5789) <= 200 and st.getQuestItemsCount(5790) <= 100 :
                            if classId == 49 :
                                st.giveItems(BEGINER_TRAVEL_TOKEN,8)  
                                st.giveItems(5789,200)
                                st.playTutorialVoice("tutorial_voice_026")
                            else :
                                st.giveItems(BEGINER_TRAVEL_TOKEN,8)  
                                st.giveItems(5790,100)
                                st.playTutorialVoice("tutorial_voice_027")
                            
                    else :
                        if st.getQuestItemsCount(5789) <= 200 :
                            st.giveItems(BEGINER_TRAVEL_TOKEN,8)
                            st.giveItems(5789,200)
                            st.playTutorialVoice("tutorial_voice_026")
                    st.addExpAndSp(0,50)
                    htmltext = str(npcId) + ".htm"
                    st.takeItems(itemId,1)
                    st.startQuestTimer("TimerEx_GrandMaster",60000)
                    st.addRadar(radarX,radarY,radarZ)
                    if Ex <= 3 :
                        qs.set("Ex","4")
        return htmltext

    def onKill (self,npc,st):
        qs = st.getPlayer().getQuestState(qnTutorial)
        Ex = int(qs.get("Ex"))
        if qs != None :
            if Ex in [0,1] :
                st.playTutorialVoice("tutorial_voice_011")
                st.showQuestionMark(3)
                qs.set("Ex","2")
            if Ex in [0,1,2] and st.getQuestItemsCount(6353) < 1 :
                if st.getRandom(100) < 50 :
                    player = st.getPlayer()
                    st.dropItem(npc,player,6353,1)
                    st.playSound("ItemSound.quest_tutorial")
        return

QUEST = Quest(999,"999_C4Tutorial","C4 Tutorial Quest")
CREATED = State('Start', QUEST)
COMPLETED = State('Completed', QUEST)

for npcId in NewbieHelper.keys() :
    QUEST.setInitialState(CREATED)
    QUEST.addStartNpc(npcId)
    CREATED.addTalkId(npcId)

for npcId in GrandMaster.keys() :
    CREATED.addTalkId(npcId)

for npcId in NewbieGuide :
    CREATED.addTalkId(npcId)

CREATED.addKillId(18342)

print "importing quests: 999: C4 Tutorial Quest"
