@echo off
TITLE L2J Fortress Setup
REM ######################################## Automatic updater for L2J Fortress - Do not edit !!!
goto answer%ERRORLEVEL%
:answerTrue
set fastend=yes
goto upgrade_db
:answer0
set fastend=no
REM ######################################## Automatic updater for L2J Fortress - Do not edit !!!
REM ######################################## DB path

REM ### MYSQL 4.1 ###
REM set mysqlBinPath=C:\Program Files\MySQL\MySQL Server 4.1\bin

REM ### MYSQL 5.0 ###
set mysqlBinPath=C:\Program Files\MySQL\MySQL Server 5.0\bin

REM ######################################## DB

set user=root
set pass=
set DBname=l2jdb
set DBHost=localhost

set Generaltables=accounts gameservers banned_ips loginserv_log character_blocklist character_friends character_hennas character_macroses character_quests character_recipebook character_shortcuts character_skills character_effects_save character_skills_save character_subclasses characters character_variables clanhall_bids clanhall_data clan_data clanhall_decorations_bids ally_data clan_wars items pets server_variables seven_signs seven_signs_festival siege_clans killcount dropcount craftcount game_log petitions seven_signs_status global_tasks raidboss_status manor_crop manor_seeds
set Ignore=--ignore-table=%DBname%.game_log --ignore-table=%DBname%.loginserv_log --ignore-table=%DBname%.petitions

REM ########################################
set mysqldumpPath="%mysqlBinPath%\mysqldump"
set mysqlPath="%mysqlBinPath%\mysql"
%mysqlPath% -h %DBHost% -u %user% --password=%pass% --execute="CREATE DATABASE IF NOT EXISTS %DBname%"
if not exist backup (
mkdir backup
)

REM ######################################## :main_menu
:main_menu
cls
echo.L2J Fortress Setup
echo.
echo.### Main Menu ###
echo.
echo.(1) Install Login Server
echo.(2) Install Game Server
echo.(3) Upgrade DB
echo.(4) Backup DB
echo.(5) Restore DB
echo.(6) Lost data in DB
echo.(q) Quit
echo.
set button=x
set /p button=What do you want ?:
if /i %button%==1 goto Install_Login_Server_menu
if /i %button%==2 goto Install_Game_Server_menu
if /i %button%==3 goto upgrade_menu
if /i %button%==4 goto backup_menu
if /i %button%==5 goto restore_menu
if /i %button%==6 goto lost_data_menu
if /i %button%==q goto end
goto main_menu

REM ######################################## :Install_Login_Server_menu
:Install_Login_Server_menu
cls
echo.L2J Fortress Setup
echo.
echo.### Install Login Server ###
echo.
echo.(i) Install Login Server. Warning !!! accounts, gameservers, banned_ips will be deleted !!!
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==i goto Install_Login_Server
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto Install_Login_Server_menu

REM ######################################## :Install_Game_Server_menu
:Install_Game_Server_menu
cls
echo.L2J Fortress Setup
echo.
echo.### Install Game Server ###
echo.
echo.(i) Install Game Server. Warning !!! All Game Server Database will be deleted !!!
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==i goto Install_Game_Server
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto Install_Game_Server_menu

REM ######################################## :upgrade_menu
:upgrade_menu
cls
echo.L2J Fortress Setup
echo.
echo.### Upgrade Menu ###
echo.
echo.(u) Upgrade Database
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==u goto upgrade_db
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto upgrade_menu

REM ######################################## :backup_menu
:backup_menu
cls
echo.L2J Fortress Setup
echo.
echo.### Backup Menu ###
echo.
echo.(1) Full backup
echo.(2) General tables backup only
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Select backup type ?:
if /i %button%==1 goto full_backup
if /i %button%==2 goto general_backup
if /i %button%==m goto setup
if /i %button%==q goto end
goto backup_menu

REM ######################################## :restore_menu
:restore_menu
cls
echo.List all files in dir "/backup" !
echo.
dir backup /B /P
echo.
echo.L2J Fortress Setup
echo.
echo.### Restore Menu ###
echo.
echo.Enter a full filename do you want to restore to the database !
echo.(m) Main menu
echo.(q) Quit
echo.
set filename=x
set /p filename=Enter filename ?:
if /i %filename%==m goto main_menu
if /i %filename%==q goto end
if /i %filename%==%filename% goto restore_DB
goto restore_menu

REM ######################################## :lost_data_menu
:lost_data_menu
cls
echo.L2J Fortress Setup
echo.
echo.### Lost Data Menu ###
echo.
echo.(1) Show lost data
echo.(2) Delete lost data
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Select backup type ?:
if /i %button%==1 goto show_lost_data
if /i %button%==2 goto delete_lost_data
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto lost_data_menu

:show_lost_data
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < maintenance/lost_data_show.sql
pause
goto lost_data_menu

:delete_lost_data
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < maintenance/lost_data_del.sql
echo.
echo.All lost data deleted !!!
echo.
pause
goto lost_data_menu

REM ######################################## :Install_Login_Server
:Install_Login_Server
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a full backup into %DATE%-%ctime%_backup_full.sql
echo.
%mysqldumpPath% %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% > backup/%DATE%-%ctime%_backup_full.sql
echo.
echo.Installing Login Server !!!
echo.
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/accounts.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/gameservers.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/banned_ips.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/loginserv_log.sql
echo.
echo.Login Server Installed !!!
echo.
pause
goto main_menu

REM ######################################## :Install_Game_Server
:Install_Game_Server
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a full backup into %DATE%-%ctime%_backup_full.sql
echo.
%mysqldumpPath% %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% > backup/%DATE%-%ctime%_backup_full.sql
echo.
echo.Installing general tables !!!
echo.
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_blocklist.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_friends.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_hennas.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_macroses.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_quests.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_recipebook.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_shortcuts.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_skills.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_effects_save.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_skills_save.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_subclasses.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/characters.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_variables.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_data.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/cursed_weapons.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/ally_data.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_wars.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_privs.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_skills.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_subpledges.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/item_creation.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/items.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/items_delayed.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/pets.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/server_variables.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/seven_signs.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/seven_signs_festival.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/siege_clans.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/killcount.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/dropcount.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/craftcount.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/game_log.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/petitions.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/seven_signs_status.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/global_tasks.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/global_tasks.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/raidboss_points.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/raidboss_status.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/forums.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/posts.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/topic.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/manor_crop.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/manor_seeds.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/bans.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/bonus.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/auction.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/auction_bid.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clanhall.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clanhall_functions.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/couples.sql

goto upgrade_db

REM ######################################## :upgrade_db
:upgrade_db
echo.
echo.Installing tables !!!
echo.
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/armor.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/armorsets.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/auto_chat.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/auto_chat_text.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/boxaccess.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/boxes.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/castle.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/castle_door.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/castle_doorupgrade.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/castle_siege_guards.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/char_templates.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/class_list.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/dimensional_rift.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/droplist.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/etcitem.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/fish.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/fishreward.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/henna.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/henna_trees.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/heroes.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/weapon.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/locations.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zone_locations.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zone_points.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zone.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zones/clanhalls.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zones/town.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/lvlupgain.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/mapregion.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/merchant_areas_list.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/merchants.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/minions.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/npc.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/npcskills.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/olympiad_nobles.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/pet_data.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/prices.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/random_spawn.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/random_spawn_loc.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/recipes.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/recitems.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/skill_spellbooks.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/skill_trees.sql
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/spawnlist.sql
echo.
echo.Complete !!!
echo.
if /I %fastend%==yes goto :EOF
pause
goto main_menu

REM ######################################## :full_backup
:full_backup
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a full backup into %DATE%-%ctime%_backup_full.sql
echo.
%mysqldumpPath% %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% > backup/%DATE%-%ctime%_backup_full.sql
goto end

REM ######################################## :general_backup
:general_backup
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a general tables backup into %DATE%-%ctime%_backup_general.sql
echo.
%mysqldumpPath% %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% %Generaltables% > backup/%DATE%-%ctime%_backup_general.sql
goto end

REM ######################################## :restore_DB
:restore_DB
if not exist backup/%filename% (
echo.
echo.File not found !
echo.
pause
goto restore_menu
)
cls
echo.
echo.Restore from file %filename% !
echo.
pause
%mysqlPath% -h %DBHost% -u %user% --password=%pass% -D %DBname% < backup/%filename%
goto end

REM ######################################## :not_working_now
:not_working_now
echo.
echo Not working NOW !!!
echo.
pause
goto main_menu

REM ######################################## :end
:end
echo.
echo Setup complete.
pause
