DROP TABLE `character_subclasses`;

CREATE TABLE `character_subclasses` (
	`char_obj_id` DECIMAL(11,0) NOT NULL,
	`class_id` TINYINT(2) NOT NULL,
	`level` TINYINT(2) NOT NULL DEFAULT '1',
	`exp` DECIMAL(11,0) NOT NULL DEFAULT '1',
	`sp` DECIMAL(11,0) NOT NULL DEFAULT '0',
  `curHp`   DECIMAL(8,4)  UNSIGNED NOT NULL DEFAULT '0',
  `curMp`   DECIMAL(8,4)  UNSIGNED NOT NULL DEFAULT '0',
  `curCp`   DECIMAL(8,4)  UNSIGNED NOT NULL DEFAULT '0',
  `maxHp`   MEDIUMINT(8)  UNSIGNED NOT NULL DEFAULT '0',
  `maxMp`   MEDIUMINT(8)  UNSIGNED NOT NULL DEFAULT '0',
  `maxCp`   MEDIUMINT(8)  UNSIGNED NOT NULL DEFAULT '0',
	`active` BOOLEAN NOT NULL DEFAULT '0',
	`isBase` BOOLEAN NOT NULL DEFAULT '0',
	PRIMARY KEY  (`char_obj_id`,`class_id`)
);

INSERT INTO `character_subclasses` SELECT `obj_Id`, `classid`, `level`, `exp`, `sp`, `curHp`, `curMp`, `curCp`, `maxHp`, `maxMp`, `maxCp`, '1', '1' FROM `characters`;

ALTER TABLE `character_hennas` CHANGE `class_index` `class_index` TINYINT( 2 ) NOT NULL DEFAULT '0';
DELETE FROM `character_hennas` WHERE `class_index` > '0';
UPDATE `character_hennas` `h` LEFT JOIN `characters` `c` ON (`c`.`obj_Id` = `h`.`char_obj_id`) SET `h`.`class_index` = `c`.`classid`;

ALTER TABLE `character_quests` CHANGE `class_index` `class_index` TINYINT( 2 ) NOT NULL DEFAULT '0';
DELETE FROM `character_quests` WHERE `class_index` > '0';
UPDATE `character_quests` `q` LEFT JOIN `characters` `c` ON (`c`.`obj_Id` = `q`.`char_id`) SET `q`.`class_index` = `c`.`classid`;

ALTER TABLE `character_shortcuts` CHANGE `class_index` `class_index` TINYINT( 2 ) NOT NULL DEFAULT '0';
DELETE FROM `character_shortcuts` WHERE `class_index` > '0';
UPDATE `character_shortcuts` `s` LEFT JOIN `characters` `c` ON (`c`.`obj_Id` = `s`.`char_obj_id`) SET `s`.`class_index` = `c`.`classid`;

ALTER TABLE `character_skills` CHANGE `class_index` `class_index` TINYINT( 2 ) NOT NULL DEFAULT '0';
DELETE FROM `character_skills` WHERE `class_index` > '0';
UPDATE `character_skills` `s` LEFT JOIN `characters` `c` ON (`c`.`obj_Id` = `s`.`char_obj_id`) SET `s`.`class_index` = `c`.`classid`;

ALTER TABLE `character_skills_save` CHANGE `class_index` `class_index` TINYINT( 2 ) NOT NULL DEFAULT '0';
DELETE FROM `character_skills_save` WHERE `class_index` > '0';
UPDATE `character_skills_save` `s` LEFT JOIN `characters` `c` ON (`c`.`obj_Id` = `s`.`char_obj_id`) SET `s`.`class_index` = `c`.`classid`;

ALTER TABLE `characters`
  DROP `acc`,
  DROP `crit`,
  DROP `evasion`,
  DROP `mAtk`,
  DROP `mDef`,
  DROP `mSpd`,
  DROP `pAtk`,
  DROP `pDef`,
  DROP `pSpd`,
  DROP `runSpd`,
  DROP `walkSpd`,
  DROP `str`,
  DROP `con`,
  DROP `dex`,
  DROP `_int`,
  DROP `men`,
  DROP `wit`,
  DROP `movement_multiplier`,
  DROP `attack_speed_multiplier`,
  DROP `colRad`,
  DROP `colHeight`,
  DROP `race`,
  DROP `classid`;