#!/bin/sh

if [ -f mysql_pass.sh ]; then
        . mysql_pass.sh
else
        . mysql_pass.sh.default
fi

mysqldump --ignore-table=${DBNAME}.game_log --ignore-table=${DBNAME}.loginserv_log --ignore-table=${DBNAME}.petitions --add-drop-table -h $DBHOST -u $USER --password=$PASS $DBNAME > ${DBNAME}_upgrade_`date +%Y-%m-%d_%H:%M:%S`.sql

for tab in \
        upgrade/armor.sql \
	upgrade/armorsets.sql \
        upgrade/boxaccess.sql \
        upgrade/boxes.sql \
        upgrade/castle.sql \
        upgrade/castle_door.sql \
        upgrade/castle_doorupgrade.sql \
        upgrade/castle_siege_guards.sql \
        upgrade/char_templates.sql \
        upgrade/class_list.sql \
        upgrade/droplist.sql \
        upgrade/etcitem.sql \
        upgrade/henna.sql \
        upgrade/henna_trees.sql \
        upgrade/locations.sql \
        upgrade/zone_locations.sql \
        upgrade/zone_points.sql \
        upgrade/zone.sql \
        upgrade/zones/clanhalls.sql \
        upgrade/zones/town.sql \
        upgrade/lvlupgain.sql \
        upgrade/mapregion.sql \
        upgrade/merchant_areas_list.sql \
        upgrade/merchants.sql \
        upgrade/minions.sql \
        upgrade/npc.sql \
        upgrade/npcskills.sql \
        upgrade/pet_data.sql \
        upgrade/skill_spellbooks.sql \
        upgrade/skill_trees.sql \
        upgrade/spawnlist.sql \
        upgrade/weapon.sql \
        upgrade/prices.sql \
        upgrade/random_spawn.sql \
        upgrade/random_spawn_loc.sql \
        upgrade/recipes.sql \
        upgrade/recitems.sql \
        upgrade/fish.sql \
        upgrade/fishreward.sql \
        upgrade/auto_chat.sql \
        upgrade/auto_chat_text.sql \
        upgrade/heroes.sql \
        upgrade/olympiad_nobles.sql \
	upgrade/dimensional_rift.sql \
        ; do
                echo Loading $tab ...
                mysql -h $DBHOST -u $USER --password=$PASS -D $DBNAME < $tab
done

