DROP TABLE IF EXISTS prices;
CREATE TABLE prices SELECT item_id, name, price, weight, crystal_type, item_type, consume_type, icon  FROM etcitem;
ALTER TABLE `prices` ADD PRIMARY KEY (`item_id`), ADD KEY (`name`), ADD KEY(`price`), ADD KEY(`crystal_type`), ADD KEY(`item_type`);
INSERT INTO prices SELECT item_id, name, price, weight, crystal_type, 'weapon', 'normal', icon FROM weapon;
INSERT INTO prices SELECT item_id, name, price, weight, crystal_type, 'armor', 'normal', icon FROM armor;

DROP TABLE IF EXISTS total;
CREATE TABLE total SELECT 
	c.obj_Id as object_id,
	SUM(p.price*i.count) as total_adena,
	a.access_level
FROM characters c 
	LEFT JOIN accounts a ON c.account_name = a.login
	LEFT JOIN items i ON i.owner_id = c.obj_Id
	LEFT JOIN prices p ON i.item_id = p.item_id
GROUP BY i.owner_id
ORDER BY total_adena DESC;

ALTER TABLE `total` ADD PRIMARY KEY ( `object_id` );
