DROP TABLE IF EXISTS `npc`;

CREATE TABLE `npc` (
  `ordinal` smallint(4) unsigned NOT NULL default '0',
  `c4id` int(11) NOT NULL default '0',
  `id` int(11) unsigned NOT NULL default '0',
  `name` varchar(45) default NULL,
  `title` varchar(25) NOT NULL default '',
  `class` varchar(40) default NULL,
  `collision_radius` decimal(5,2) default NULL,
  `collision_height` decimal(5,2) default NULL,
  `level` int(11) default NULL,
  `sex` varchar(6) default NULL,
  `type` varchar(20) default NULL,
  `ai_type` varchar(20) default NULL,
  `attackrange` int(11) default NULL,
  `hp` int(11) default NULL,
  `base_hp_regen` double(11,3) NOT NULL default '0.000',
  `mp` int(11) default NULL,
  `base_mp_regen` double(11,3) NOT NULL default '0.000',
  `str` int(11) default NULL,
  `con` int(11) default NULL,
  `dex` int(11) default NULL,
  `int` int(11) default NULL,
  `wit` int(11) default NULL,
  `men` int(11) default NULL,
  `exp` int(11) default NULL,
  `sp` int(11) default NULL,
  `patk` int(11) default NULL,
  `pdef` int(11) default NULL,
  `matk` int(11) default NULL,
  `mdef` int(11) default NULL,
  `atkspd` int(11) default NULL,
  `aggro` int(11) default NULL,
  `matkspd` int(11) default NULL,
  `rhand` int(11) default NULL,
  `lhand` int(11) default NULL,
  `armor` int(11) default NULL,
  `walkspd` int(11) default NULL,
  `runspd` int(11) default NULL,
  `faction_id` varchar(40) default NULL,
  `faction_range` int(11) default NULL,
  `isUndead` int(11) default '0',
  `last_editor` varchar(50) default 'Local',
  `last_changed` varchar(20) default NULL,
  `displayId` int(11) NOT NULL default '0',
  `shield_defense_rate` int(11) default NULL,
  `shield_defense` int(11) default NULL,
  `corpse_time` int(11) default NULL,
  `base_rand_dam` int(11) default NULL,
  `base_critical` int(11) default NULL,
  `physical_hit_modify` int(11) default NULL,
  `base_reuse_delay` int(11) default NULL,
  `physical_avoid_modify` int(11) default NULL,
  `hit_time_factor` double(11,2) default '0.00',
  PRIMARY KEY  (`id`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1,1,20001,'Gremlin','','gremlin','10.00','15.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(2,2,20002,'Rabbit','','rabbit','5.00','4.50',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3,3,20003,'Goblin','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(4,4,20004,'Imp','','imp','10.00','24.00',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5,5,20005,'Imp Elder','','imp','10.00','24.00',7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,18,48,6,43,278,0,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(6,6,20006,'Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(7,7,20007,'Green Fungus','','walking_fungus','15.00','22.50',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(8,8,20008,'Felim Lizardman','','virud_lizardman','10.00','23.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,1,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(9,9,20009,'Vuku Orc','','orc','10.00','21.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,33,73,12,59,278,0,253,156,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(10,10,20010,'Felim Lizardman Scout','','virud_lizardman','10.00','23.00',15,'male','L2Monster','Ranger',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,16,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(11,11,20011,'Vuku Orc Archer','','orc_archer','14.00','25.00',15,'male','L2Monster','Ranger',500,390,2.500,165,1.200,40,43,30,21,20,10,550,22,82,76,14,62,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(12,12,20012,'Gora Werewolf','','werewolf','10.00','26.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,582,23,44,72,15,64,278,500,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(13,13,20013,'Dryad','','dryad','9.00','20.00',13,'female','L2Monster','Fighter',40,339,2.500,147,1.200,40,43,30,21,20,10,462,18,27,77,11,56,278,0,253,0,0,0,40,110,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(14,14,20014,'Felim Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,16,0,0,52,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(15,15,20015,'Marsh Zombie','','zombie','13.00','21.00',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,33,63,11,56,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(16,16,20016,'Stone Golem','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,30,70,11,56,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(17,17,20017,'Vuku Orc Fighter','','orc_fighter','12.00','22.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(18,18,20018,'Carnivorous Fungus','','walking_fungus','15.00','22.50',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,37,66,12,59,278,500,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(19,19,20019,'Dryad Elder','','dryad','9.00','20.00',14,'female','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,0,0,0,40,110,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(20,20,20020,'Marsh Zombie Lord','','zombie','13.00','21.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(21,21,20021,'Red Bear','','grizzly','21.00','40.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,37,66,12,59,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(22,22,20022,'Misery Skeleton','','skeleton','11.00','25.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,35,7,10,8,0,0,-6,0.30),
(23,23,20023,'Shadow Beast','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(24,24,20024,'Langk Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,16,0,0,52,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(25,25,20025,'Lesser Dark Horror','','dark_horror','20.00','35.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,36,76,14,62,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(26,26,20026,'Ruin Zombie','','zombie','13.00','21.00',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,755,31,40,69,14,62,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(27,27,20027,'Langk Lizardman Scout','','virud_lizardman','10.00','23.00',16,'male','L2Monster','Ranger',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,16,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(28,28,20028,'Pincher','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(29,29,20029,'Ruin Zombie Leader','','zombie','13.00','21.00',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,807,33,36,87,15,64,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(30,30,20030,'Langk Lizardman','','virud_lizardman','10.00','23.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,36,76,14,62,278,0,253,1,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(31,31,20031,'Omen Beast','','onyx_beast','14.00','14.50',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,48,75,17,67,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(32,32,20032,'Pinrul','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(33,33,20033,'Shade Horror','','dark_horror','20.00','35.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,48,75,17,67,278,0,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(34,34,20034,'Prowler','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(35,35,20035,'Tracker Skeleton','','skeleton','11.00','25.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,42,75,17,67,317,0,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,39,7,10,8,0,0,-6,0.30),
(36,36,20036,'Lirein','','sylph','11.00','35.00',18,'female','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,652,28,53,79,19,70,278,500,253,0,0,0,60,60,'elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(37,37,20037,'Mana Seeker','','mana_vampire','11.00','20.00',18,'male','L2Monster','Mystic',40,476,5.000,193,1.200,40,43,30,21,20,10,496,21,44,95,19,70,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(38,38,20038,'Poison Spider','','poison_spider','27.00','25.50',18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,704,31,53,79,19,70,278,0,253,0,0,0,60,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(39,39,20039,'Scavenger Wererat','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,46,79,19,70,317,0,289,12,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(40,40,20040,'Sukar Wererat','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,533,23,46,79,19,70,317,0,289,216,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(41,41,20041,'Tainted Zombie','','zombie','13.00','21.00',18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,754,33,44,95,19,70,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(42,42,20042,'Tracker Skeleton Leader','','skeleton','11.00','25.00',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,652,28,46,79,19,70,317,500,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,40,7,10,8,0,0,-6,0.30),
(43,43,20043,'Arachnid Tracker','','poison_spider','27.00','25.50',19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,760,34,48,99,21,73,278,500,253,0,0,0,60,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(44,44,20044,'Lirein Elder','','sylph','11.00','35.00',19,'female','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,691,31,58,82,21,73,278,500,253,0,0,0,60,60,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(45,45,20045,'Skeleton Scout','','skeleton_archer','11.00','27.00',19,'male','L2Monster','Ranger',500,508,2.500,203,1.200,40,43,30,21,20,10,698,31,107,99,21,73,249,0,227,275,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(46,46,20046,'Stink Zombie','','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(47,47,20047,'Sukar Wererat Leader','','wererat','14.00','25.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,576,26,42,99,21,73,317,500,289,216,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(48,48,20048,'Lesser Succubus','','succubus','10.00','36.00',20,'female','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,57,94,23,76,278,500,253,0,0,0,60,100,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(49,49,20049,'Lycanthrope','','werewolf','10.00','26.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,726,32,63,86,23,76,278,500,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(50,50,20050,'Arachnid Predator','','poison_spider','27.00','25.50',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,799,35,63,86,23,76,278,500,253,0,0,0,60,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(51,51,20051,'Skeleton Bowman','','skeleton_archer','11.00','27.00',20,'male','L2Monster','Ranger',500,541,2.500,213,1.200,40,43,30,21,20,10,734,32,117,104,23,76,249,0,227,275,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(52,52,20052,'Lesser Succubus Turen','','succubus','10.00','36.00',21,'female','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,60,100,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(53,53,20053,'Ol Mahum Patrol','','ol_mahum_archer','14.00','25.00',21,'male','L2Monster','Ranger',500,575,3.500,227,1.500,40,43,30,21,20,10,787,36,140,98,25,80,249,0,227,14,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(54,54,20054,'Ruin Spartoi','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,73,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(55,55,20055,'Wandering Eye','','monster_eye','21.00','43.00',21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(56,56,20056,'Dre Vanul Disposer','','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,767,36,75,93,28,83,278,500,253,0,0,0,80,80,'demonic_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.35),
(57,57,20057,'Lesser Succubus Tilfo','','succubus','10.00','36.00',22,'female','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,0,0,0,60,100,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(58,58,20058,'Ol Mahum Guard','','ol_mahum','13.50','25.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,75,93,28,83,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(59,59,20059,'Hungry Eye','','monster_eye','21.00','43.00',22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,75,93,28,83,278,0,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(60,60,20060,'Raging Spartoi','','spartoi','11.00','27.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,837,40,54,113,28,83,317,500,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,46,7,10,8,0,0,-6,0.30),
(61,61,20061,'Ol Mahum Straggler','','ol_mahum','13.50','25.00',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,75,107,31,87,278,500,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(62,62,20062,'Tumran Bugbear','','bugbear','17.00','35.00',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,156,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(63,63,20063,'Ol Mahum Shooter','','ol_mahum_archer','14.00','25.00',24,'male','L2Monster','Ranger',500,687,3.500,272,1.500,40,43,30,21,20,10,963,47,181,111,34,90,249,0,227,14,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(64,64,20064,'Tumran Bugbear Warrior','','bugbear','17.00','35.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,88,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(65,65,20065,'Ol Mahum Patrolman','','ol_mahum','13.50','25.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(66,66,20066,'Ol Mahum Captain','','ol_mahum_champion','14.00','27.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1052,53,97,105,37,94,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(67,67,20067,'Monster Eye Watcher','','monster_eye','21.00','43.00',25,'male','L2Monster','Mystic',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,80,127,37,94,278,0,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(68,68,20068,'Monster Eye Destroyer','','monster_eye','21.00','43.00',26,'male','L2Monster','Mystic',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,87,132,41,98,278,500,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(69,69,20069,'Selu Lizardman Scout','','virud_lizardman','10.00','23.00',26,'male','L2Monster','Ranger',40,770,3.500,303,1.500,40,43,30,21,20,10,880,44,87,132,41,98,278,0,253,16,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(70,70,20070,'Lesser Basilisk','','lesser_basilisk','34.00','25.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,35,131,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(71,71,20071,'Selu Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,946,48,114,114,45,102,278,500,253,16,0,0,52,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(72,72,20072,'Basilisk','','lesser_basilisk','34.00','25.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1189,62,102,143,49,106,278,500,253,0,0,0,35,131,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(73,73,20073,'Ol Mahum Legionnaire','','ol_mahum','13.50','25.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,981,52,113,130,49,106,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(74,74,20074,'Androscorpio','','onyx_beast','14.00','14.50',29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1243,67,122,135,53,110,278,0,253,0,0,0,30,120,'scropio_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(75,75,20075,'Ant Larva','','ant_larva','12.00','8.00',29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1139,61,111,149,53,110,278,0,253,0,0,0,40,60,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(76,76,20076,'Ol Mahum Commander','','ol_mahum_champion','14.00','27.00',29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1319,71,134,123,53,110,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(77,77,20077,'Androscorpio Hunter','','onyx_beast','14.00','14.50',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,30,120,'scropio_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(78,78,20078,'Whispering Wind','','sylph_100_bi','20.00','70.00',30,'female','L2Monster','Mystic',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,120,155,58,114,278,0,253,0,0,0,60,60,'elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(79,79,20079,'Ant','','ant','26.00','15.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,40,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(80,80,20080,'Ant Captain','','ant','26.00','15.00',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1425,79,157,133,64,118,278,500,253,0,0,0,40,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(81,81,20081,'Ant Overseer','','ant','26.00','15.00',32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1200,67,169,138,69,123,278,0,253,0,0,0,40,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(82,82,20082,'Ant Recruit','','ant_soldier','35.00','17.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(83,83,20083,'Granite Golem','','stone_golem','20.00','31.00',33,'male','L2Monster','Mystic',40,1109,4.500,413,1.800,40,43,30,21,20,10,2239,129,151,173,75,128,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(84,84,20084,'Ant Patrol','','ant_soldier','35.00','17.00',34,'male','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1667,97,196,148,82,132,278,0,253,0,0,0,80,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(85,85,20085,'Puncher','','stone_golem','20.00','31.00',34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,2424,142,196,148,82,132,278,500,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(86,86,20086,'Ant Guard','','ant_soldier','35.00','17.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1484,88,192,169,89,137,278,0,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(87,87,20087,'Ant Soldier','','ant_soldier','35.00','17.00',35,'male','L2Monster','Fighter',40,1220,9.000,446,1.800,40,43,30,21,20,10,1780,105,192,169,89,137,278,500,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(88,88,20088,'Ant Warrior Captain','','ant_soldier','35.00','17.00',36,'male','L2Monster','Fighter',40,1279,9.000,463,1.800,40,43,30,21,20,10,1984,120,227,159,96,142,278,500,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(89,89,20089,'Noble Ant','','noble_ant','20.00','48.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,1659,102,222,182,104,147,278,0,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(90,90,20090,'Noble Ant Leader','','noble_ant','20.00','48.00',38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,1829,114,261,171,112,153,278,500,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(91,91,20091,'Young Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(92,92,20092,'Monster Eye','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,294,10,22,61,8,49,278,0,253,0,0,0,90,134,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(93,93,20093,'Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,22,61,8,49,278,500,253,1,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(94,94,20094,'Orc Marksman','','orc_archer','14.00','25.00',10,'male','L2Monster','Ranger',500,257,2.000,120,0.900,40,43,30,21,20,10,305,10,56,55,8,49,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(95,95,20095,'Vampire Bat','','vampire_bat','10.00','33.50',10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,22,61,8,49,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(96,96,20096,'Orc Lieutenant','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(97,97,20097,'Drill Bat','','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(98,98,20098,'Orc Fighter Leader','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,447,17,30,60,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(99,99,20099,'Skeleton','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,33,7,10,8,0,0,-6,0.30),
(100,100,20100,'Skeleton Archer','','skeleton_archer','11.00','27.00',13,'male','L2Monster','Ranger',500,339,2.500,147,1.200,40,43,30,21,20,10,405,16,74,63,11,56,249,500,227,14,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(101,101,20101,'Crasher','','stone_golem','20.00','31.00',14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(102,102,20102,'Skeleton Marksman','','skeleton_archer','11.00','27.00',14,'male','L2Monster','Ranger',500,364,2.500,156,1.200,40,43,30,21,20,10,428,17,82,66,12,59,249,0,227,14,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(103,103,20103,'Giant Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(104,104,20104,'Skeleton Lord','','skeleton','11.00','25.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,445,18,29,84,14,62,317,0,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,36,7,10,8,0,0,-6,0.30),
(105,105,20105,'Dark Horror','','dark_horror','20.00','35.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,576,23,44,72,15,64,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(106,106,20106,'Talon Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(107,107,20107,'Wererat','','wererat','14.00','25.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,475,19,40,79,15,64,278,0,253,0,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(108,108,20108,'Blade Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(109,109,20109,'Salamander','','salamander','16.00','6.80',17,'male','L2Monster','Fighter',40,446,5.000,184,1.200,40,43,30,21,20,10,494,21,44,83,17,67,278,0,253,0,0,0,64,96,'elemental3_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.20),
(110,110,20110,'Undine','','undine','12.00','27.00',17,'female','L2Monster','Mystic',40,446,5.000,184,1.200,40,43,30,21,20,10,479,20,44,83,17,67,278,500,253,0,0,0,60,60,'elemental4_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.35),
(111,111,20111,'Wererat Leader','','wererat','14.00','25.00',17,'male','L2Monster','Fighter',40,446,5.000,184,1.200,40,43,30,21,20,10,479,20,40,91,17,67,278,500,253,1,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(112,112,20112,'Salamander Elder','','salamander','16.00','6.80',18,'male','L2Monster','Fighter',40,476,5.000,193,1.200,40,43,30,21,20,10,496,21,53,79,19,70,278,0,253,0,0,0,64,96,'elemental3_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.20),
(113,113,20113,'Undine Elder','','undine','12.00','27.00',18,'female','L2Monster','Mystic',40,476,5.000,193,1.200,40,43,30,21,20,10,505,22,44,95,19,70,278,500,253,0,0,0,60,60,'elemental4_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.35),
(114,114,20114,'Salamander Noble','','salamander','16.00','6.80',19,'male','L2Monster','Fighter',40,508,5.000,203,1.200,40,43,30,21,20,10,525,23,58,82,21,73,278,0,253,0,0,0,64,96,'elemental3_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.20),
(115,115,20115,'Undine Noble','','undine','12.00','27.00',19,'female','L2Monster','Mystic',40,508,5.000,203,1.200,40,43,30,21,20,10,536,24,58,82,21,73,278,500,253,0,0,0,60,60,'elemental4_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.35),
(116,116,20116,'Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(117,117,20117,'Dre Vanul','','dre_vanul','14.00','36.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,666,29,63,86,23,76,278,500,253,0,0,0,80,80,'demonic_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.35),
(118,118,20118,'Dre Vanul Scout','','dre_vanul','14.00','36.00',21,'male','L2Monster','Ranger',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,80,80,'demonic_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.35),
(119,119,20119,'Elder Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(120,120,20120,'Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(121,121,20121,'Giant Toad','','poison_toad','20.00','10.00',5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,0,0,0,50,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(122,130,20130,'Orc','','orc','10.00','21.00',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(123,131,20131,'Orc Grunt','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,4,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(124,132,20132,'Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,20,58,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(125,133,20133,'Bugbear','','bugbear','17.00','35.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,63,98,25,80,278,500,253,4,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(126,134,20134,'Cave Maiden','','cave_maiden','25.00','65.00',59,'female','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5112,437,902,326,453,291,278,500,253,68,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(127,135,20135,'Alligator','','crocodile','28.00','11.50',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2373,153,300,183,131,164,278,500,253,0,0,0,70,174,'croc_clan2',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.41),
(128,136,20136,'Death Knight','','death_knight','12.00','30.00',50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,4651,350,616,230,264,226,278,500,253,75,0,0,27,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(129,137,20137,'Drake','','drake','30.00','100.00',57,'male','L2Monster','Mystic',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4819,401,817,309,405,276,278,500,253,0,0,0,70,174,'dragon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(130,138,20138,'Gargoyle','','gargoyle','16.00','50.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,946,48,104,125,45,102,278,500,253,0,0,0,140,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(131,139,20139,'Giant Bee','','giant_bee','8.00','24.50',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,471,19,40,79,15,64,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(132,140,20140,'Giant Leech','','giant_leech','70.00','29.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,795,39,81,111,34,90,278,500,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(133,141,20141,'Giant Wild Hog','','giant_wild_hog','25.00','27.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,2730,196,427,253,216,206,278,500,253,0,0,0,35,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(134,142,20142,'Griffon','','griffin','20.00','44.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,593,26,57,94,23,76,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(135,143,20143,'Grizzly','','grizzly','21.00','40.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,27,66,10,54,278,500,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(136,144,20144,'Hangman Tree','','hanged_man_ripper','35.00','80.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1817,108,192,169,89,137,278,500,253,0,0,0,55,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(137,145,20145,'Harpy','','harpy','10.00','42.00',32,'female','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1504,84,154,151,69,123,278,500,253,0,0,0,60,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(138,146,20146,'Headless Knight','','headless_knight','21.00','31.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3708,279,463,306,264,226,278,500,253,124,0,0,70,174,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(139,147,20147,'Hobgoblin','','hobgoblin','12.00','24.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,4,0,0,45,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(140,148,20148,'Hungry Spirit','','hungry_spirit','13.00','40.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1958,126,300,183,131,164,278,500,253,0,0,0,15,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(141,149,20149,'Iron Golem','','iron_golem','18.00','34.00',38,'male','L2Monster','Mystic',40,1400,4.500,497,1.800,40,43,30,21,20,10,2524,157,216,207,112,153,278,500,253,0,0,0,20,20,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(142,150,20150,'King Bugbear','','king_bugbear','15.00','40.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,169,138,69,123,278,500,253,88,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(143,151,20151,'Kobold','','kobold','10.00','15.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,118,3,12,46,4,37,278,0,253,4,0,0,47,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.54),
(144,152,20152,'Lizardman','','virud_lizardman','10.00','23.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(145,153,20153,'Magical Weaver','','magical_weaver','11.00','20.00',11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(146,154,20154,'Mandragora Sprout','','manadragora','14.00','17.80',21,'female','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,0,0,0,80,80,'mandragora_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(147,155,20155,'Mandragora Sapling','','mandragora_a','15.00','26.00',23,'female','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,82,97,31,87,278,500,253,0,0,0,80,120,'mandragora_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(148,156,20156,'Mandragora Blossom','','mandragora_b','12.00','25.50',25,'female','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1012,51,97,105,37,94,278,500,253,0,0,0,80,120,'mandragora_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.13),
(149,157,20157,'Marsh Stakato','','marsh_stakato','10.00','20.00',29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1509,81,117,123,53,110,317,500,289,223,0,0,21,120,'stakato_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.74),
(150,158,20158,'Medusa','','medusa','10.00','25.00',34,'female','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1714,100,178,163,82,132,278,500,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(151,159,20159,'Minotaur','','minotaur','21.00','45.50',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2263,153,365,202,163,181,278,500,253,300,0,0,40,120,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.59),
(152,160,20160,'Neer Crawler','','neer_crawler','14.00','22.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1201,63,124,118,49,106,278,500,253,0,0,0,50,90,'neer_crawler_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(153,161,20161,'Oel Mahum','','oel_mahum','20.00','37.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'oel_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(154,162,20162,'Ogre','','ogre','21.00','44.00',41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,2057,135,446,189,141,169,200,500,182,98,0,0,22,80,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(155,163,20163,'Ol Mahum','','ol_mahum','13.50','25.00',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,82,97,31,87,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(156,164,20164,'Ol Mahum Archer','','ol_mahum_archer','14.00','25.00',25,'male','L2Monster','Ranger',500,728,3.500,287,1.500,40,43,30,21,20,10,868,44,216,105,37,94,249,500,227,14,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(157,165,20165,'Ol Mahum Champion','','ol_mahum_champion','14.00','27.00',29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1257,67,134,123,53,110,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(158,166,20166,'Succubus','','succubus','10.00','36.00',32,'female','L2Monster','Mystic',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,154,151,69,123,278,500,253,0,0,0,60,100,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(159,167,20167,'Serpent Slave','','serpent_slave','17.00','46.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1977,128,273,201,131,164,278,500,253,73,0,0,70,110,'serpent_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(160,168,20168,'Silenos','','silenos','14.00','32.50',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,88,0,0,70,110,'silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(161,169,20169,'Skeleton Royal Guard','','skeleton_royal_guard','11.00','28.50',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,898,45,92,109,41,98,317,500,289,946,945,0,80,120,'skeleton_clan',300,1,'Local','',0,20,52,7,10,8,0,0,-6,0.52),
(162,170,20170,'Spartoi','','spartoi','11.00','27.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,35,69,14,62,317,500,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,36,7,10,8,0,0,-6,0.30),
(163,171,20171,'Specter','','dark_horror','20.00','35.00',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,96,120,41,98,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(164,172,20172,'Sylph','','sylph','11.00','35.00',10,'female','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,25,55,8,49,278,0,253,0,0,0,60,60,'elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(165,173,20173,'Troll','','troll','21.00','35.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1332,76,182,143,75,128,278,500,253,0,0,0,55,110,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(166,174,20174,'Two-Headed Giant','','twin_headed_giant','17.00','39.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1499,89,174,186,89,137,278,500,253,4,0,0,45,100,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(167,175,20175,'Walking Fungus','','walking_fungus','15.00','22.50',8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,237,8,18,55,6,45,278,0,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(168,176,20176,'Wyrm','','wyrm','29.00','72.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1817,108,211,154,89,137,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(169,177,20177,'Zombie','','zombie','13.00','21.00',6,'male','L2Monster','Mystic',40,147,2.000,85,0.900,40,43,30,21,20,10,178,5,15,50,5,41,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(170,189,20189,'Puma','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,441,18,40,69,14,62,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(171,190,20190,'Skeleton Marauder','','skeleton_archer','11.00','27.00',29,'male','L2Monster','Ranger',500,906,3.500,349,1.500,40,43,30,21,20,10,1306,70,299,123,53,110,249,500,227,14,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(172,191,20191,'Skeleton Raider','','skeleton','11.00','25.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1335,73,127,128,58,114,317,500,289,946,945,0,60,140,'skeleton_clan',300,1,'Local','',0,20,59,7,10,8,0,0,-6,0.30),
(173,192,20192,'Tyrant','','grave','15.00','29.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1781,105,211,154,89,137,278,0,253,0,0,0,70,174,'tyrant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(174,193,20193,'Tyrant Kingpin','','grave','15.00','29.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1922,116,227,159,96,142,278,500,253,0,0,0,70,174,'tyrant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(175,194,20194,'Queen Undine','','undine','12.00','27.00',50,'female','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,560,253,264,226,278,500,253,0,0,0,60,60,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(176,197,20197,'Sorrow Maiden','','sylph','11.00','35.00',27,'female','L2Monster','Mystic',40,813,3.500,318,1.500,40,43,30,21,20,10,1102,56,104,125,45,102,278,0,253,0,0,0,60,60,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(177,198,20198,'Neer Ghoul Berserker','','neer_crawler','14.00','22.00',29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1268,68,134,123,53,110,278,500,253,0,0,0,50,90,'neer_crawler_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(178,199,20199,'Amber Basilisk','','lesser_basilisk','34.00','25.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1557,85,120,155,58,114,278,0,253,0,0,0,35,131,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(179,200,20200,'Strain','','hungry_spirit','13.00','40.00',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1383,77,157,133,64,118,278,0,253,0,0,0,15,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(180,201,20201,'Ghoul','','zombie','13.00','21.00',32,'male','L2Monster','Mystic',40,1056,4.500,397,1.800,40,43,30,21,20,10,2085,117,169,138,69,123,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(181,202,20202,'Dead Seeker','','vampire_bat','10.00','33.50',34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1664,97,178,163,82,132,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(182,203,20203,'Dion Grizzly','','grizzly','21.00','40.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,705,31,52,104,23,76,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(183,204,20204,'Bloody Bee','','giant_bee','8.00','24.50',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,956,46,82,97,31,87,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(184,205,20205,'Dire Wolf','','dire_wolf','13.00','11.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,0,0,0,24,110,'wolf_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(185,206,20206,'Kadif Werewolf','','werewolf','10.00','26.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,982,49,97,105,37,94,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(186,207,20207,'Ol Mahum Guerilla','','ol_mahum','13.50','25.00',26,'male','L2Monster','Fighter',40,770,7.000,303,1.500,40,43,30,21,20,10,982,49,87,132,41,98,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,52,7,30,4,4,0,-6,0.46),
(187,208,20208,'Ol Mahum Raider','','ol_mahum','13.50','25.00',27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,1035,53,83,138,45,102,317,0,289,10,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(188,209,20209,'Ol Mahum Marksman','','ol_mahum_archer','14.00','25.00',28,'male','L2Monster','Ranger',500,859,7.000,334,1.500,40,43,30,21,20,10,1128,59,276,118,49,106,249,0,227,275,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(189,210,20210,'Ol Mahum Sergeant','','ol_mahum','13.50','25.00',29,'male','L2Monster','Fighter',40,906,7.000,349,1.500,40,43,30,21,20,10,1156,62,111,149,53,110,278,0,253,68,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,57,7,30,4,4,0,-6,0.46),
(190,211,20211,'Ol Mahum Captain','','ol_mahum_champion','14.00','27.00',30,'male','L2Monster','Fighter',40,954,7.000,365,1.500,40,43,30,21,20,10,1241,68,145,128,58,114,278,500,253,123,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,59,7,30,4,4,0,-6,0.63),
(191,212,20212,'Bloody Axe Turmak','Ol Mahum Lord','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,1164,9.000,430,1.800,40,43,30,21,20,10,1469,86,196,148,82,132,278,500,253,69,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,66,7,30,4,4,0,-6,0.63),
(192,213,20213,'Porta','','stone_golem','20.00','31.00',40,'male','L2Monster','Mystic',40,1527,9.000,531,1.800,40,43,30,21,20,10,2364,152,248,222,131,164,278,0,253,0,0,0,23,23,'porta_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(193,214,20214,'Excuro','','mana_vampire','11.00','20.00',41,'male','L2Monster','Mystic',40,1593,11.000,560,2.100,40,43,30,21,20,10,2028,132,265,229,141,169,278,0,253,0,0,0,90,174,'porta_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(194,215,20215,'Mordeo','','onyx_beast','14.00','14.50',42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,2625,175,342,196,152,175,278,500,253,0,0,0,30,174,'beast_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(195,216,20216,'Ricenseo','','monster_eye','21.00','43.00',43,'male','L2Monster','Mystic',40,1728,11.000,618,2.100,40,43,30,21,20,10,2104,142,332,223,163,181,278,0,253,0,0,0,90,174,'porta_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(196,217,20217,'Krator','','stone_golem','20.00','31.00',44,'male','L2Monster','Mystic',40,1799,11.000,648,2.100,40,43,30,21,20,10,2688,184,322,253,176,187,278,500,253,0,0,0,23,23,'porta_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(197,218,20218,'Premo','','troll','21.00','35.00',45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,2812,195,415,216,188,193,278,0,253,0,0,0,55,174,'porta_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(198,219,20219,'Validus','','grave','15.00','29.00',46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'torfe_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(199,220,20220,'Dicor','','mandragora_b','12.00','25.50',47,'female','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,2867,205,469,230,216,206,278,500,253,0,0,0,80,174,'torfe_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.13),
(200,221,20221,'Perum','','iron_golem','18.00','34.00',48,'male','L2Monster','Mystic',40,2091,11.000,768,2.100,40,43,30,21,20,10,3438,251,412,288,231,212,278,500,253,0,0,0,20,20,'torfe_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(201,222,20222,'Torfe','','grave','15.00','29.00',49,'male','L2Monster','Fighter',40,2168,11.000,799,2.100,40,43,30,21,20,10,3025,223,529,245,247,219,278,0,253,0,0,0,70,174,'torfe_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(202,223,20223,'Mandragora Sprout','','manadragora','14.00','17.80',20,'female','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,783,35,63,86,23,76,278,0,253,0,0,0,80,80,'mandragora_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(203,224,20224,'Ol Mahum Ranger','','ol_mahum_archer','14.00','25.00',22,'male','L2Monster','Ranger',500,611,3.500,242,1.500,40,43,30,21,20,10,1059,50,139,113,28,83,249,0,227,13,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(204,225,20225,'Giant Mist Leech','','giant_leech','70.00','29.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,88,116,37,94,278,0,253,0,0,0,50,110,'giant_leech_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(205,226,20226,'Gray Ant','','ant','26.00','15.00',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,40,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(206,227,20227,'Horror Mist Ripper','','dark_horror','20.00','35.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(207,228,20228,'Giant Crimson Ant','','ant_soldier','35.00','17.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1296,68,124,118,49,106,278,0,253,0,0,0,80,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(208,229,20229,'Stinger Wasp','','giant_bee','8.00','24.50',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1454,79,120,155,58,114,278,500,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(209,230,20230,'Marsh Stakato Worker','','marsh_stakato_worker','9.00','21.00',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1663,92,142,146,64,118,278,0,253,153,0,0,20,140,'stakato_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.59),
(210,231,20231,'Toad Lord','','poison_toad','20.00','10.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1622,91,140,167,69,123,278,0,253,0,0,0,50,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(211,232,20232,'Marsh Stakato Soldier','','marsh_stakato_soldier','10.00','25.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1583,91,132,173,75,128,317,0,289,217,0,0,30,155,'stakato_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.74),
(212,233,20233,'Marsh Spider','','poison_spider','27.00','25.50',34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1867,109,178,163,82,132,278,500,253,0,0,0,60,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(213,234,20234,'Marsh Stakato Drone','','marsh_stakato_drone','9.00','24.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1889,112,185,154,89,137,317,500,289,219,0,0,80,174,'stakato_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.39),
(214,235,20235,'Shackle','','hungry_spirit','13.00','40.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2974,207,343,262,188,193,278,500,253,0,0,0,15,174,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(215,236,20236,'Cave Servant','','skeleton','11.00','25.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3077,218,365,270,202,199,278,0,253,79,945,0,60,174,'cave_servant_clan',300,1,'Local','',0,20,91,7,30,4,4,0,-6,0.30),
(216,237,20237,'Cave Servant Archer','','skeleton_archer','11.00','27.00',47,'male','L2Monster','Ranger',500,2016,5.500,738,2.100,40,43,30,21,20,10,4143,297,1043,230,216,206,249,0,227,14,0,0,40,174,'cave_servant_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(217,238,20238,'Cave Servant Warrior','','skeleton','11.00','25.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3987,291,498,238,231,212,278,0,253,77,2495,0,60,174,'cave_servant_clan',300,1,'Local','',0,20,95,7,30,4,4,0,-6,0.30),
(218,239,20239,'Cave Servant Captain','','spartoi','11.00','27.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,4238,313,437,297,247,219,278,500,253,73,2495,0,60,174,'cave_servant_clan',300,1,'Local','',0,20,97,7,30,4,4,0,-6,0.30),
(219,240,20240,'Royal Cave Servant','','skeleton_royal_guard','11.00','28.50',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,4546,347,429,315,281,232,317,0,289,946,945,0,80,174,'cave_servant_clan',400,1,'Local','',0,20,102,7,10,8,0,0,-6,0.52),
(220,241,20241,'Hunter Gargoyle','','hunter_gargoyle','25.00','65.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4633,358,627,268,300,239,278,0,253,0,0,0,100,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(221,242,20242,'Dustwind Gargoyle','','hunter_gargoyle','25.00','65.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4813,378,547,334,319,247,278,0,253,0,0,0,100,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(222,243,20243,'Thunder Wyrm','','wyrm','29.00','72.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4283,341,699,284,339,254,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(223,244,20244,'Malruk Succubus','','succubus','10.00','36.00',55,'female','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4399,355,737,292,360,261,278,0,253,0,0,0,60,174,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(224,245,20245,'Malruk Succubus Turen','','succubus','10.00','36.00',56,'female','L2Monster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4560,375,777,301,382,269,278,0,253,0,0,0,60,174,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(225,246,20246,'Cave Keeper','','serpent_slave','17.00','46.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'cave_servant_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(226,248,20248,'Turak Bugbear','','bugbear','17.00','35.00',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1397,78,129,161,64,118,278,0,253,88,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(227,249,20249,'Turak Bugbear Warrior','','bugbear','17.00','35.00',33,'male','L2Monster','Fighter',40,1109,9.000,413,1.800,40,43,30,21,20,10,1502,86,151,173,75,128,278,500,253,73,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(228,250,20250,'Glass Jaguar','','onyx_beast','14.00','14.50',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1102,56,114,114,45,102,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(229,251,20251,'Delu Lizardman','','virud_lizardman','10.00','23.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1166,61,102,143,49,106,278,0,253,1,19,0,43,130,'',0,0,'Local','',0,20,55,7,30,4,4,0,-6,0.48),
(230,252,20252,'Delu Lizardman Scout','','virud_lizardman','10.00','23.00',29,'male','L2Monster','Ranger',40,906,3.500,349,1.500,40,43,30,21,20,10,1231,66,134,123,53,110,278,0,253,123,0,0,43,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(231,253,20253,'Delu Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1321,72,120,155,58,114,278,500,253,16,0,0,52,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(232,254,20254,'Skeleton Axeman','','skeleton','11.00','25.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1201,63,113,130,49,106,278,500,253,86,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(233,255,20255,'Batur Orc','','batur_orc','9.00','21.50',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1164,65,129,161,64,118,278,0,253,123,0,0,80,130,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(234,256,20256,'Batur Orc Archer','','batur_orc_archer','11.00','21.50',32,'male','L2Monster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1600,90,311,167,69,123,249,0,227,13,0,0,45,130,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.96),
(235,257,20257,'Batur Orc Warrior','','batur_orc_warrior','10.00','20.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1602,92,182,143,75,128,278,500,253,123,19,0,80,120,'orc_clan',300,0,'Local','',0,20,64,7,30,4,4,0,-6,0.30),
(236,258,20258,'Batur Orc Shaman','','batur_orc_shaman','11.00','16.00',34,'male','L2Monster','Priest',40,1164,4.500,430,1.800,40,43,30,21,20,10,1401,82,196,148,82,132,278,0,253,7,0,0,50,120,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(237,259,20259,'Batur Orc Overlord','','batur_orc_overlord','12.00','24.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1802,107,211,154,89,137,278,500,253,79,0,0,80,140,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(238,260,20260,'Orc Champion','','orc_champion','10.00','23.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,435,17,30,80,12,59,278,500,253,2,0,0,45,130,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(239,261,20261,'Orc Shaman','','orc_shaman','9.00','22.00',17,'male','L2Monster','Priest',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,40,91,17,67,278,0,253,7,0,0,45,120,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(240,265,20265,'Monster Eye Searcher','','monster_eye','21.00','43.00',22,'male','L2Monster','Mystic',40,611,7.000,242,1.500,40,43,30,21,20,10,763,36,75,93,28,83,278,0,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(241,266,20266,'Monster Eye Gazer','','monster_eye','21.00','43.00',25,'male','L2Monster','Mystic',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,80,127,37,94,278,0,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(242,267,20267,'Breka Orc','','batur_orc','9.00','21.50',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1397,78,113,161,64,118,317,0,289,215,0,0,80,130,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(243,268,20268,'Breka Orc Archer','','batur_orc_archer','11.00','21.50',32,'male','L2Monster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1920,108,311,167,69,123,249,0,227,275,0,0,45,130,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.96),
(244,269,20269,'Breka Orc Shaman','','batur_orc_shaman','11.00','16.00',34,'male','L2Monster','Priest',40,1164,4.500,430,1.800,40,43,30,21,20,10,1681,98,162,179,82,132,278,0,253,7,0,0,50,120,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(245,270,20270,'Breka Orc Overlord','','batur_orc_overlord','12.00','24.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2380,141,211,154,89,137,278,500,253,79,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(246,271,20271,'Breka Orc Warrior','','batur_orc_warrior','10.00','20.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1922,110,182,143,75,128,278,500,253,123,20,0,80,120,'orc_clan',300,0,'Local','',0,20,64,7,30,4,4,0,-6,0.30),
(247,272,20272,'Cave Servant','','skeleton','11.00','25.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,2564,182,365,270,202,199,278,0,253,79,945,0,60,140,'cave_servant_clan',300,1,'Local','',0,20,91,7,30,4,4,0,-6,0.30),
(248,273,20273,'Cave Servant Archer','','skeleton_archer','11.00','27.00',47,'male','L2Monster','Ranger',500,2016,5.500,738,2.100,40,43,30,21,20,10,2757,198,1043,230,216,206,249,0,227,275,0,0,40,140,'cave_servant_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(249,274,20274,'Cave Servant Warrior','','skeleton','11.00','25.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,2792,204,498,238,231,212,278,0,253,77,0,0,60,140,'cave_servant_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(250,275,20275,'Cave Servant Captain','','spartoi','11.00','27.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2968,219,437,297,247,219,278,500,253,73,0,0,60,140,'cave_servant_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(251,276,20276,'Royal Cave Servant','','skeleton_royal_guard','11.00','28.50',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3152,240,429,315,281,232,317,0,289,946,945,0,80,120,'cave_servant_clan',300,1,'Local','',0,20,102,7,10,8,0,0,-6,0.52),
(252,277,20277,'Cave Keeper','','serpent_slave','17.00','46.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,4077,344,751,318,428,284,317,0,289,223,0,0,70,110,'cave_servant_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(253,279,20279,'Shackle','','hungry_spirit','13.00','40.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2478,172,343,262,188,193,278,500,253,0,0,0,15,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(254,280,20280,'Headless Knight','','headless_knight','21.00','31.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,463,306,264,226,278,500,253,124,0,0,70,110,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(255,281,20281,'Dustwind Gargoyle','','hunter_gargoyle','25.00','65.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,3370,265,547,334,319,247,278,0,253,0,0,0,100,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(256,282,20282,'Thunder Wyrm','','wyrm','29.00','72.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3569,285,699,284,339,254,278,500,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(257,283,20283,'Malruk Succubus','','succubus','10.00','36.00',55,'female','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,3666,296,737,292,360,261,278,0,253,0,0,0,60,100,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(258,284,20284,'Malruk Succubus Turen','','succubus','10.00','36.00',56,'female','L2Monster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,3800,312,777,301,382,269,278,0,253,0,0,0,60,100,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(259,285,20285,'Drake','','drake','30.00','100.00',57,'male','L2Monster','Mystic',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4016,334,817,309,405,276,278,500,253,0,0,0,70,70,'dragon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(260,286,20286,'Hunter Gargoyle','','hunter_gargoyle','25.00','65.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,3244,251,627,268,300,239,278,0,253,0,0,0,100,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(261,287,20287,'Cave Maiden','','cave_maiden','25.00','65.00',59,'female','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,4260,364,902,326,453,291,278,500,253,68,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(262,291,20291,'Enku Orc Champion','','orc_champion','10.00','23.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,927,43,57,108,25,80,278,500,253,2,0,0,45,130,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(263,292,20292,'Enku Orc Shaman','','orc_shaman','9.00','22.00',20,'male','L2Monster','Priest',40,541,2.500,213,1.200,40,43,30,21,20,10,813,36,52,104,23,76,278,0,253,7,0,0,45,120,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(264,293,20293,'Virud Lizardman','','virud_lizardman','10.00','23.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,593,26,52,104,23,76,278,0,253,291,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(265,294,20294,'Virud Lizardman Matriarch','','virud_lizardman_matriarch','13.00','37.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,951,47,89,101,34,90,278,500,253,2,19,0,56,130,'lizardman_clan',300,0,'Local','',0,20,49,7,30,4,4,0,-6,0.65),
(266,295,20295,'Virud Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,16,0,0,52,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(267,296,20296,'Virud Lizardman Scout','','virud_lizardman_scout','10.00','22.00',21,'male','L2Monster','Ranger',500,575,3.500,227,1.500,40,43,30,21,20,10,656,30,127,108,25,80,249,0,227,2507,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.72),
(268,297,20297,'Virud Lizardman Shaman ','','virud_lizardman_shaman','10.00','29.00',23,'male','L2Monster','Priest',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,68,117,31,87,278,0,253,7,0,0,43,120,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(269,298,20298,'Virud Lizardman Shaman ','','virud_lizardman_shaman','10.00','29.00',23,'male','L2Monster','Priest',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,68,117,31,87,278,0,253,7,0,0,43,120,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(270,299,20299,'Zenta Lizardman','','zenta_lizardman','11.00','32.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1939,125,248,222,131,164,278,0,253,68,0,0,37,140,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(271,300,20300,'Zenta Lizardman Matriarch','','zenta_lizardman_matriarch','20.00','40.00',44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,2848,195,341,209,176,187,317,500,289,221,0,0,53,140,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(272,301,20301,'Zenta Lizardman Scout','','zenta_lizardman_scout','11.00','30.00',41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,2098,137,589,229,141,169,249,0,227,14,0,0,37,150,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(273,302,20302,'Zenta Lizardman Warrior','','zenta_lizardman_warrior','13.00','35.00',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2180,145,342,196,152,175,278,500,253,16,0,0,40,140,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(274,303,20303,'Zenta Lizardman Shaman','','zenta_lizardman_shaman','13.00','35.00',43,'male','L2Monster','Priest',40,1728,5.500,618,2.100,40,43,30,21,20,10,2240,152,302,245,163,181,278,0,253,7,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.63),
(275,304,20304,'Marsh Stakato Queen','','marsh_stakato_queen','15.00','37.00',36,'female','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1906,115,227,159,96,142,278,500,253,74,0,0,130,130,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(276,305,20305,'Grave','','grave','15.00','29.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1958,126,300,183,131,164,278,500,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(277,307,20307,'Garum Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,5,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(278,308,20308,'Hook Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(279,309,20309,'Brown Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(280,310,20310,'Brown Bear','','grizzly_bi','21.00','50.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,576,23,36,87,15,64,278,500,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(281,311,20311,'Rakeclaw Imp','','imp','10.00','24.00',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,16,46,5,41,278,0,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(282,312,20312,'Rakeclaw Imp Hunter','','imp','10.00','24.00',7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,18,48,6,43,278,0,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(283,313,20313,'Rakeclaw Imp Chieftain','','imp_bi','10.00','30.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(284,314,20314,'Great White Shark','','great_white_shark','20.00','7.00',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2180,145,342,196,152,175,278,500,253,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(285,316,20316,'Darkwing Bat','','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(286,317,20317,'Black Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(287,318,20318,'Black Timber Wolf','','wolf_bi','13.00','10.80',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,211,6,15,50,5,41,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(288,319,20319,'Goblin Grave Robber','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(289,320,20320,'Goblin Tomb Raider Leader','','goblin_bi','10.00','21.40',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,24,66,10,54,317,0,289,12,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.32),
(290,321,20321,'Goblin Thief','','goblin_bi','10.00','21.40',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,356,12,20,61,8,49,317,0,289,217,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.32),
(291,322,20322,'Goblin Brigand','','goblin','10.00','16.50',8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(292,323,20323,'Goblin Brigand Leader','','goblin_bi','10.00','21.40',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,508,20,29,73,12,59,317,500,289,217,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.32),
(293,324,20324,'Goblin Brigand Lieutenant','','goblin','10.00','16.50',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,20,61,8,49,317,500,289,10,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.32),
(294,325,20325,'Goblin Raider','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(295,326,20326,'Goblin Scout','','goblin','10.00','16.50',8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(296,327,20327,'Goblin Snooper','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(297,328,20328,'Goblin Lookout','','goblin','10.00','16.50',8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,16,55,6,45,317,0,289,12,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.32),
(298,329,20329,'Ghost Guardian','','human_ghost','8.00','22.00',21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,643,30,63,98,25,80,278,500,253,0,0,0,80,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(299,330,20330,'Mineshaft Bat','','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(300,331,20331,'Monster Eye Tracker','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,20,67,8,49,278,0,253,0,0,0,90,134,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(301,333,20333,'Greystone Golem','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,27,77,11,56,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(302,334,20334,'Gremlin Scavenger','','gremlin','10.00','15.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(303,335,20335,'Grizzly Bear','','grizzly_bi','21.00','50.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,599,25,40,91,17,67,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(304,336,20336,'Green Dryad','','dryad_sm','6.00','15.00',8,'female','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(305,337,20337,'Longtail Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(306,338,20338,'Nightmare Weaver','','magical_weaver','11.00','20.00',21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,707,33,69,89,25,80,278,500,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(307,340,20340,'Slave Skeleton','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(308,341,20341,'Undead Slave','','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,58,82,21,73,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(309,342,20342,'Werewolf Chieftain','','werewolf_bi','11.00','29.70',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,30,60,10,54,278,500,253,5,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(310,343,20343,'Werewolf Hunter','','werewolf','10.00','26.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,5,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(311,345,20345,'Dark Terror','','dark_horror','20.00','35.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,533,22,44,72,15,64,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(312,346,20346,'Darkstone Golem','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(313,347,20347,'Death Wraith','','death_blader','15.00','45.00',55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,3739,302,737,292,360,261,278,500,253,1472,0,0,100,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(314,348,20348,'Cave Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,445,18,40,69,14,62,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(315,349,20349,'Cave Bat','','vampire_bat','10.00','33.50',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,385,15,33,63,11,56,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(316,350,20350,'Cave Fang Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,485,20,44,72,15,64,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(317,351,20351,'Dre Vanul Tracker','','dre_vanul','14.00','36.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,80,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(318,352,20352,'Dre Vanul Slayer','','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,767,36,75,93,28,83,278,500,253,0,0,0,80,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(319,353,20353,'Dre Vanul Beholder','','dre_vanul','14.00','36.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,80,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(320,354,20354,'Dwarf Ghost','','dwarf_ghost','9.00','16.50',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,80,140,'ghost_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(321,356,20356,'Langk Lizardman Leader','','virud_lizardman_warrior_bi','12.00','34.50',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1012,51,80,127,37,94,278,500,253,16,0,0,52,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(322,357,20357,'Langk Lizardman Lieutenant','','virud_lizardman_warrior','12.00','30.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,62,113,28,83,278,0,253,16,0,0,52,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(323,358,20358,'Ratman Hunter','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,38,95,19,70,317,0,289,11,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(324,359,20359,'Ratman Warrior','','wererat','14.00','25.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,678,30,58,82,21,73,278,0,253,2,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(325,360,20360,'Ratman Spy','','wererat_sm','14.00','18.70',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,39,72,15,64,317,0,289,12,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(326,361,20361,'Tunath Orc Marksman','','orc_archer','14.00','25.00',10,'male','L2Monster','Ranger',500,257,2.000,120,0.900,40,43,30,21,20,10,305,10,51,61,8,49,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(327,362,20362,'Tunath Orc Warrior','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,25,73,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(328,363,20363,'Maraku Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(329,364,20364,'Maraku Werewolf Chieftain','','werewolf_bi','11.00','29.70',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,508,20,32,66,12,59,317,500,289,217,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.43),
(330,365,20365,'Mountain Fungus','','walking_fungus','15.00','22.50',8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,20,50,6,45,278,0,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(331,367,20367,'Merkenis Escort','','spartoi','11.00','27.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,68,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(332,368,20368,'Grave Keeper','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(333,369,20369,'Moonstone Beast','','onyx_beast','14.00','14.50',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,599,25,48,75,17,67,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(334,370,20370,'Barbed Bat','','vampire_bat','10.00','33.50',12,'male','L2Monster','Mystic',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(335,371,20371,'Mist Terror','','dark_horror','20.00','35.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(336,372,20372,'Baraq Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,302,10,25,55,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(337,373,20373,'Baraq Orc Warrior Leader','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(338,374,20374,'Baranka''s Guard','','spartoi','11.00','27.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,910,43,62,113,28,83,278,500,253,68,0,0,60,140,'skeleton_clan',300,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.30),
(339,375,20375,'Baranka''s Escort','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,50,108,25,80,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local',NULL,0,0,0,7,10,8,0,0,0,0.30),
(340,376,20376,'Varikan Brigand Leader','','goblin_bi','10.00','21.40',10,'male','L2Monster','Fighter',40,257,4.000,120,0.900,40,43,30,21,20,10,503,17,22,61,8,49,278,500,253,12,0,0,40,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.32),
(341,377,20377,'Varika''s Bandit','','goblin','10.00','16.50',7,'male','L2Monster','Fighter',40,171,1.000,94,0.900,40,43,30,21,20,10,334,12,20,44,6,43,278,0,253,0,0,0,40,110,'goblin_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.32),
(342,378,20378,'Stone Giant','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(343,379,20379,'Stone Soldier','','stone_golem','20.00','31.00',14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(344,380,20380,'Stone Guardian','','stone_golem','20.00','31.00',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,807,33,36,87,15,64,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(345,381,20381,'Vaiss Orc','','orc','10.00','21.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,22,61,8,49,278,0,253,156,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(346,382,20382,'Vaiss Orc Warrior Leader','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(347,383,20383,'Arachnid Hunter','','binding','12.00','21.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1223,67,120,155,58,114,278,500,253,0,0,0,10,140,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.54);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(348,385,20385,'Balor Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(349,386,20386,'Balor Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(350,387,20387,'Balor Orc Fighter Leader','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,30,60,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(351,388,20388,'Balor Orc Lieutenant','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(352,389,20389,'Boogle Ratman','','wererat','14.00','25.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,475,19,39,72,15,64,317,0,289,12,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(353,390,20390,'Boogle Ratman Leader','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,533,23,46,79,19,70,317,0,289,12,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(354,391,20391,'Red Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(355,392,20392,'Redeye Bat','','vampire_bat_bi','10.00','42.00',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(356,393,20393,'Red Scavenger Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(357,394,20394,'Crimson Tarantula','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(358,398,20398,'Vrykolakas','','werewolf_bi','11.00','29.70',15,'male','L2Monster','Fighter',40,390,5.000,165,1.200,40,43,30,21,20,10,692,28,40,69,14,62,278,500,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(359,399,20399,'Vrykolakas Wolfkin','','wolf_bi','13.00','10.80',9,'male','L2Monster','Fighter',40,226,1.000,111,0.900,40,43,30,21,20,10,354,12,25,48,7,47,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(360,400,20400,'Blood Fungus','','walking_fungus','15.00','22.50',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(361,401,20401,'Veelan Bugbear','','bugbear','17.00','35.00',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,156,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(362,402,20402,'Veelan Bugbear Warrior','','bugbear','17.00','35.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,88,0,0,55,130,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(363,403,20403,'Hunter Tarantula','','giant_spider','26.00','26.50',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(364,404,20404,'Silent Horror','','dark_horror','20.00','35.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,485,20,44,72,15,64,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,50,1,9,0,0,0.37),
(365,405,20405,'Young Brown Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(366,406,20406,'Young Red Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(367,407,20407,'Young Crimson Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(368,410,20410,'Scavenger Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(369,411,20411,'Scavenger Bat','','vampire_bat','10.00','33.50',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,53,79,19,70,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(370,412,20412,'Susceptor','','susceptor','20.00','35.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2910,215,437,297,247,219,278,500,253,0,0,0,27,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(371,415,20415,'Scarlet Salamander','','salamander','16.00','6.80',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,555,23,48,75,17,67,278,0,253,0,0,0,64,96,'elemental3_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(372,416,20416,'Scarlet Salamander Elder','','salamander','16.00','6.80',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,586,26,53,79,19,70,278,0,253,0,0,0,64,96,'elemental3_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(373,418,20418,'Crystalline Beast','','onyx_beast','14.00','14.50',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,633,28,53,79,19,70,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(374,419,20419,'Akaste Succubus','','succubus','10.00','36.00',20,'female','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,60,100,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(375,420,20420,'Akaste Succubus Turen','','succubus','10.00','36.00',21,'female','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,60,100,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(376,421,20421,'Akaste Succubus Tilfo','','succubus_bi','10.00','43.20',22,'female','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,0,0,0,60,100,'succubus_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(377,422,20422,'Akaste Bone Warlord','','skeleton','11.00','25.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,612,26,48,75,17,67,278,500,253,2,18,0,60,140,'skeleton_clan',300,1,'Local','',0,20,39,7,30,4,4,0,-6,0.30),
(378,423,20423,'Akaste Bone Archer','','skeleton_archer','11.00','27.00',14,'male','L2Monster','Ranger',500,364,2.500,156,1.200,40,43,30,21,20,10,428,17,68,80,12,59,249,0,227,275,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(379,424,20424,'Akaste Bone Lord','','skeleton','11.00','25.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,592,26,58,82,21,73,278,500,253,68,19,0,60,140,'skeleton_clan',300,1,'Local','',0,20,42,7,30,4,4,0,-6,0.30),
(380,425,20425,'Akaste Bone Soldier','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(381,426,20426,'Evil Eye','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,356,12,20,67,8,49,278,0,253,0,0,0,90,134,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(382,427,20427,'Evil Eye Watcher','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,20,67,8,49,278,0,253,0,0,0,90,134,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(383,428,20428,'Evil Eye Patroller','','monster_eye','21.00','43.00',14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,0,0,0,90,134,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(384,429,20429,'Evil Eye Lookout','','monster_eye','21.00','43.00',14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,415,16,30,80,12,59,278,0,253,0,0,0,90,134,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(385,431,20431,'Elf Ghost','','elf_ghost','7.00','21.00',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,0,0,0,80,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(386,432,20432,'Elpy','','elpy','5.00','4.50',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(387,433,20433,'Festering Bat','','vampire_bat','10.00','33.50',13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,462,18,33,63,11,56,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(388,435,20435,'Opal Beast','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(389,436,20436,'Ol Mahum Supplier','','ol_mahum_bi','13.50','29.20',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,47,7,30,4,4,0,-6,0.46),
(390,437,20437,'Ol Mahum Recruit','','ol_mahum','13.50','25.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,68,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,44,7,30,4,4,0,-6,0.46),
(391,438,20438,'Ol Mahum General','','ol_mahum_champion','14.00','27.00',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,105,109,41,98,278,500,253,67,102,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,52,7,30,4,4,0,-6,0.63),
(392,439,20439,'Ol Mahum Officer','','ol_mahum','13.50','25.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,74,122,34,90,278,0,253,66,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(393,440,20440,'Elder Brown Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(394,441,20441,'Elder Longtail Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(395,442,20442,'Elder Wolf','','wolf','13.00','9.00',5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,176,5,13,48,4,39,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(396,443,20443,'Elder Red Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(397,444,20444,'Elder Prairie Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(398,445,20445,'Uthanka Pirate','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,1.000,94,0.900,40,43,30,21,20,10,307,10,20,44,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(399,446,20446,'Utuku Orc','','orc','10.00','21.00',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(400,447,20447,'Utuku Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(401,448,20448,'Utuku Orc Grunt','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(402,449,20449,'Will-O-Wisp','','will_o_wisp','13.00','22.00',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,533,22,40,69,14,62,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.10),
(403,450,20450,'Relic Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,267,9,22,53,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(404,451,20451,'Relic Spartoi','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,7.000,227,1.500,40,43,30,21,20,10,592,27,57,108,25,80,278,0,253,68,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(405,453,20453,'Human Ghost','','human_ghost','8.00','22.00',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,0,0,0,80,140,'ghost_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(406,454,20454,'Oblivion Watcher','','monster_eye','21.00','43.00',17,'male','L2Monster','Mystic',40,446,1.250,184,1.200,40,43,30,21,20,10,454,20,53,68,17,67,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(407,455,20455,'Doom Soldier','','skeleton','11.00','25.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(408,456,20456,'Ashen Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(409,457,20457,'Zombie Soldier','','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,958,43,58,82,21,73,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(410,458,20458,'Zombie Warrior','','zombie_bi','13.00','27.50',22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,1184,56,75,93,28,83,278,500,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(411,460,20460,'Crimson Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(412,461,20461,'Dungeon Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(413,462,20462,'Cave Blade Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,515,22,48,75,17,67,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(414,463,20463,'Dungeon Skeleton Archer','','skeleton_archer','11.00','27.00',13,'male','L2Monster','Ranger',500,339,2.500,147,1.200,40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,275,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(415,464,20464,'Dungeon Skeleton','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(416,465,20465,'Prairie Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,11,38,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(417,466,20466,'Pincer Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(418,468,20468,'Kaboo Orc','','orc','10.00','21.00',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(419,469,20469,'Kaboo Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(420,470,20470,'Kaboo Orc Grunt','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(421,471,20471,'Kaboo Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,20,67,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(422,472,20472,'Kaboo Orc Fighter Leader','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,25,73,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(423,473,20473,'Kaboo Orc Fighter Lieutenant','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(424,474,20474,'Kasha Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(425,475,20475,'Kasha Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(426,476,20476,'Kasha Fang Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(427,477,20477,'Kasha Timber Wolf','','wolf_bi','13.00','10.80',6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,211,6,15,50,5,41,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(428,478,20478,'Kasha Blade Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,666,28,48,75,17,67,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(429,479,20479,'Kasha Bear','','grizzly_bi','21.00','50.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,539,22,33,84,14,62,278,500,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(430,480,20480,'Blade Bat','','vampire_bat','10.00','33.50',10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,356,12,25,55,8,49,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(431,481,20481,'Bearded Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(432,483,20483,'Corpse Candle','','will_o_wisp','13.00','22.00',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,604,25,40,91,17,67,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.10),
(433,487,20487,'Kuruka Ratman','','wererat','14.00','25.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,475,19,32,87,15,64,317,0,289,216,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(434,488,20488,'Kuruka Ratman Hunter','','wererat','14.00','25.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,40,91,17,67,278,0,253,3,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(435,489,20489,'Quicksilver Beast','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(436,490,20490,'Death Doll','','crimson_doll','15.00','38.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2175,141,300,183,131,164,278,500,253,0,0,0,60,150,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.67),
(437,491,20491,'Crypt Horror','','dark_horror','20.00','35.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,100,100,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(438,492,20492,'Kirunak''s Guards','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,636,29,57,108,25,80,278,0,253,68,0,0,60,140,'kirunak_clan',300,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.30),
(439,494,20494,'Turek War Hound','','dire_wolf','13.00','11.00',24,'male','L2Monster','Fighter',40,687,7.000,272,1.500,40,43,30,21,20,10,869,43,89,101,34,90,278,0,253,0,0,0,24,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(440,495,20495,'Turek Orc Warlord','','orc_champion','10.00','23.00',30,'male','L2Monster','Fighter',40,954,7.000,365,1.500,40,43,30,21,20,10,1390,76,120,155,58,114,278,500,253,127,0,0,45,130,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(441,496,20496,'Turek Orc Archer','','orc_archer','14.00','25.00',27,'male','L2Monster','Ranger',500,813,7.000,318,1.500,40,43,30,21,20,10,1076,55,231,125,45,102,249,0,227,14,0,0,45,110,'orc_clan',400,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(442,497,20497,'Turek Orc Skirmisher','','orc_fighter','12.00','22.00',28,'male','L2Monster','Fighter',40,859,7.000,334,1.500,40,43,30,21,20,10,1117,58,102,143,49,106,278,500,253,121,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(443,498,20498,'Turek Orc Supplier','','orc_fighter','12.00','22.00',27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,1035,53,83,138,45,102,317,0,289,11,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(444,499,20499,'Turek Orc Footman','','orc','10.00','21.00',26,'male','L2Monster','Fighter',40,770,7.000,303,1.500,40,43,30,21,20,10,982,49,96,120,41,98,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(445,500,20500,'Turek Orc Sentinel','','orc','10.00','21.00',25,'male','L2Monster','Fighter',40,728,7.000,287,1.500,40,43,30,21,20,10,922,46,88,116,37,94,278,0,253,3,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(446,501,20501,'Turek Orc Shaman','','orc_shaman','9.00','22.00',29,'male','L2Monster','Priest',40,906,7.000,349,1.500,40,43,30,21,20,10,1156,62,111,149,53,110,278,0,253,7,0,0,45,120,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(447,502,20502,'Twink Puma','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,539,22,40,69,14,62,278,500,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(448,504,20504,'Dread Soldier','','skeleton','11.00','25.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(449,505,20505,'Ruin Bat','','vampire_bat_bi','10.00','42.00',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,712,32,63,86,23,76,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(450,506,20506,'Ruin Imp','','imp_bi','10.00','30.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(451,507,20507,'Ruin Imp Elder','','imp_bi','10.00','30.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,779,36,69,89,25,80,278,500,253,0,0,0,60,80,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(452,508,20508,'Plunder Tarantula','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(453,509,20509,'Spore Fungus','','walking_fungus','15.00','22.50',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(454,510,20510,'Puma','','onyx_beast','14.00','14.50',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,423,16,30,60,10,54,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(455,511,20511,'Pitchstone Golem','','stone_golem','20.00','31.00',19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(456,512,20512,'Field Stalker','','field_stalker','15.00','30.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1812,107,211,154,89,137,278,500,253,0,0,0,70,110,'monster_eye_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(457,513,20513,'Skeleton Knight','','skeleton_knight','10.00','25.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,140,167,69,123,278,500,253,150,0,0,40,160,'skeleton_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(458,514,20514,'Shield Skeleton','','skeleton','11.00','25.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,157,103,0,60,140,'skeleton_clan',300,1,'Local','',0,20,36,7,50,1,9,0,-6,0.30),
(459,515,20515,'Skeleton Infantryman','','skeleton','11.00','25.00',16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,157,18,0,60,140,'skeleton_clan',300,1,'Local','',0,20,38,7,50,1,9,0,-6,0.30),
(460,516,20516,'Skeleton Sentinel','','skeleton_bi','11.00','31.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(461,517,20517,'Skeleton Hunter','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(462,518,20518,'Skeleton Hunter Archer','','skeleton_archer','11.00','27.00',13,'male','L2Monster','Fighter',500,339,2.500,147,1.200,40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,275,0,0,40,140,'skeleton_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(463,519,20519,'Skeleton Pikeman','','skeleton_pikeman','10.00','28.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,946,48,114,114,45,102,278,500,253,299,0,0,50,155,'skeleton_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(464,520,20520,'Pirate Captain Uthanka','','orc_fighter_bi','12.00','26.40',10,'male','L2Monster','Fighter',40,257,4.000,120,0.900,40,43,30,21,20,10,463,16,20,67,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(465,521,20521,'Whinstone Golem','','stone_golem','20.00','31.00',14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(466,522,20522,'White Fang','','wolf_bi','13.00','10.80',10,'male','L2Monster','Fighter',40,257,4.000,120,0.900,40,43,30,21,20,10,458,15,22,61,8,49,278,500,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(467,524,20524,'Grey Wolf Elder','','wolf','13.00','9.00',7,'male','L2Monster','Fighter',40,171,1.000,94,0.900,40,43,30,21,20,10,304,10,20,44,6,43,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(468,525,20525,'Gray Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(469,526,20526,'Obsidian Golem','','stone_golem','20.00','31.00',15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,755,31,33,84,14,62,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(470,527,20527,'White Wolf','','dire_wolf','13.00','11.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,121,3,13,42,4,37,278,500,253,0,0,0,24,110,'wolf_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(471,528,20528,'Goblin Lord','','goblin','10.00','16.50',13,'male','L2Monster','Fighter',40,339,2.500,147,1.200,40,43,30,21,20,10,458,18,29,63,11,56,317,0,289,217,0,0,40,110,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.32),
(472,529,20529,'Young Brown Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(473,530,20530,'Young Red Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(474,531,20531,'Young Prairie Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(475,532,20532,'Brown Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(476,533,20533,'Longtail Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(477,534,20534,'Red Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(478,535,20535,'Prairie Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(479,536,20536,'Elder Brown Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(480,537,20537,'Elder Red Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(481,538,20538,'Elder Prairie Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(482,539,20539,'Elder Longtail Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(483,540,20540,'Gemstone Beast','','onyx_beast','14.00','14.50',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,352,13,25,73,10,54,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(484,541,20541,'Ore Bat','','vampire_bat','10.00','33.50',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,499,21,48,75,17,67,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(485,542,20542,'Skeleton Longbowman','','skeleton_archer','11.00','27.00',19,'male','L2Monster','Ranger',500,508,2.500,203,1.200,40,43,30,21,20,10,587,26,129,82,21,73,249,500,227,275,0,0,40,140,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(486,543,20543,'Ghost','','human_ghost','8.00','22.00',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,599,27,63,86,23,76,278,500,253,0,0,0,80,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(487,544,20544,'Elder Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(488,545,20545,'Young Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(489,546,20546,'Turek Orc Elder','','orc_shaman','9.00','22.00',34,'male','L2Monster','Priest',40,1164,4.500,430,1.800,40,43,30,21,20,10,1714,100,162,179,82,132,278,500,253,7,0,0,45,120,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(490,547,20547,'Ol Mahum Reserve','','ol_mahum_bi','13.50','29.20',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,47,7,30,4,4,0,-6,0.46),
(491,548,20548,'Ol Mahum Deserter','','ol_mahum','13.50','25.00',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,75,107,31,87,278,500,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(492,549,20549,'Ol Mahum Lord','','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,1164,9.000,430,1.800,40,43,30,21,20,10,1763,103,196,148,82,132,278,500,253,69,19,0,50,110,'ol_mahum_clan',300,0,'Local','',0,20,66,7,30,4,4,0,-6,0.63),
(493,550,20550,'Guardian Basilisk','','lesser_basilisk','34.00','25.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1960,118,206,175,96,142,278,0,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(494,551,20551,'Road Scavenger','','wererat','14.00','25.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,1991,122,194,154,104,147,317,0,289,221,0,0,80,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,10,0.61),
(495,552,20552,'Fettered Soul','','binding','12.00','21.00',38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,2146,134,238,188,112,153,278,0,253,0,0,0,10,174,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(496,553,20553,'Windsus','','giant_wild_hog','25.00','27.00',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2212,141,255,195,121,158,278,0,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(497,554,20554,'Grandis','','twin_headed_giant','17.00','39.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(498,555,20555,'Giant Fungus','','walking_fungus_bi','15.00','31.30',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(499,556,20556,'Giant Monstereye','','monster_eye_bi','29.00','60.00',41,'male','L2Monster','Mystic',40,1593,5.500,560,2.100,40,43,30,21,20,10,2444,160,321,189,141,169,278,0,253,0,0,0,90,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(500,557,20557,'Dire Wyrm','','wyrm','29.00','72.00',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2590,173,283,237,152,175,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(501,558,20558,'Rotting tree','','hanged_man_ripper','35.00','80.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2662,180,302,245,163,181,278,0,253,0,0,0,55,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(502,559,20559,'Rotting Golem','','stone_golem_bi_one','22.00','43.40',44,'male','L2Monster','Mystic',40,1799,5.500,648,2.100,40,43,30,21,20,10,3942,270,322,253,176,187,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(503,560,20560,'Trisalim Spider','','giant_spider','26.00','26.50',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2916,203,415,216,188,193,278,0,253,0,0,0,72,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(504,561,20561,'Trisalim Tarantula','','poison_spider','27.00','25.50',46,'male','L2Monster','Mystic',40,1943,5.500,707,2.100,40,43,30,21,20,10,3452,245,365,270,202,199,278,500,253,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(505,562,20562,'Spore Zombie','','zombie_bi','13.00','27.50',47,'male','L2Monster','Mystic',40,2016,5.500,738,2.100,40,43,30,21,20,10,3591,257,469,230,216,206,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(506,563,20563,'Manashen Gargoyle','','gargoyle','16.00','50.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2769,179,300,183,131,164,278,0,253,0,0,0,140,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(507,564,20564,'Enchanted Monstereye','','monster_eye','21.00','43.00',41,'male','L2Monster','Mystic',40,1593,5.500,560,2.100,40,43,30,21,20,10,2493,163,321,189,141,169,278,500,253,0,0,0,90,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(508,565,20565,'Enchanted Stone Golem','','stone_golem_bi','20.00','40.30',42,'male','L2Monster','Mystic',40,1660,5.500,589,2.100,40,43,30,21,20,10,3627,242,342,196,152,175,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(509,566,20566,'Enchanted Iron Golem','','iron_golem','18.00','34.00',43,'male','L2Monster','Mystic',40,1728,5.500,618,2.100,40,43,30,21,20,10,3802,257,302,245,163,181,278,0,253,0,0,0,20,20,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(510,567,20567,'Enchanted Gargoyle','','gargoyle','16.00','50.00',44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3350,229,390,209,176,187,278,0,253,0,0,0,140,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(511,568,20568,'Formor','','troll','21.00','35.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2945,205,377,238,188,193,278,0,253,0,0,0,55,174,'beast_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(512,569,20569,'Formor Elder','','troll','21.00','35.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3200,227,401,245,202,199,278,0,253,0,0,0,55,174,'beast_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(513,570,20570,'Tarlk Bugbear','','bugbear','17.00','35.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,88,0,0,55,174,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(514,571,20571,'Tarlk Bugbear Warrior','','bugbear','17.00','35.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3793,277,453,261,231,212,278,500,253,169,0,0,55,174,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(515,572,20572,'Tarlk Bugbear High Warrior','','king_bugbear','15.00','40.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,4155,307,529,245,247,219,278,0,253,160,0,0,55,174,'bugbear_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(516,573,20573,'Tarlk Basilisk','','lesser_basilisk','34.00','25.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3600,271,463,306,264,226,278,0,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(517,574,20574,'Elder Tarlk Basilisk','','lesser_basilisk','34.00','25.00',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(518,575,20575,'Oel Mahum Warrior','','oel_mahum_warrior','20.00','38.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4241,338,699,284,339,254,278,0,253,72,0,0,70,174,'oel_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(519,576,20576,'Oel Mahum Witch Doctor','','oel_mahum_witch_doctor','15.00','34.00',55,'male','L2Monster','Mystic',40,2643,13.000,987,2.400,40,43,30,21,20,10,4401,355,609,354,360,261,278,0,253,201,0,0,70,174,'oel_mahum_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(520,577,20577,'Leto Lizardman','','zenta_lizardman','11.00','32.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1781,105,192,169,89,137,278,0,253,66,0,0,37,174,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(521,578,20578,'Leto Lizardman Archer','','zenta_lizardman_scout','11.00','30.00',36,'male','L2Monster','Ranger',500,1279,4.500,463,1.800,40,43,30,21,20,10,1941,117,417,193,96,142,249,0,227,14,0,0,37,174,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(522,579,20579,'Leto Lizardman Soldier','','zenta_lizardman','11.00','32.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2030,125,222,182,104,147,278,500,253,68,0,0,37,174,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(523,580,20580,'Leto Lizardman Warrior','','zenta_lizardman_warrior','13.00','35.00',38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,1953,121,261,171,112,153,278,0,253,93,0,0,40,174,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(524,581,20581,'Leto Lizardman Shaman','','zenta_lizardman_shaman','13.00','35.00',39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,2212,141,280,177,121,158,278,0,253,159,0,0,43,174,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.63),
(525,582,20582,'Leto Lizardman Overlord','','zenta_lizardman_matriarch','20.00','40.00',40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,2207,142,217,222,131,164,317,500,289,221,0,0,53,174,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(526,583,20583,'Timak Orc','','batur_orc','9.00','21.50',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,300,183,131,164,278,0,253,2,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(527,584,20584,'Timak Orc Archer','','batur_orc_archer','11.00','21.50',41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,3152,206,589,229,141,169,249,0,227,14,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.96),
(528,585,20585,'Timak Orc Soldier','','batur_orc','9.00','21.50',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,3114,207,311,215,152,175,278,500,253,66,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(529,586,20586,'Timak Orc Warrior','','batur_orc_warrior','10.00','20.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2984,202,332,223,163,181,278,0,253,68,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(530,587,20587,'Timak Orc Shaman','','batur_orc_shaman','11.00','16.00',44,'male','L2Monster','Priest',40,1799,5.500,648,2.100,40,43,30,21,20,10,2815,193,390,209,176,187,278,0,253,179,0,0,50,174,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(531,588,20588,'Timak Orc Overlord','','batur_orc_overlord','12.00','24.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3701,257,415,216,188,193,278,500,253,127,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(532,589,20589,'Fline','','sylph','11.00','35.00',45,'female','L2Monster','Mystic',40,1870,11.000,677,2.100,40,43,30,21,20,10,2766,192,343,262,188,193,278,0,253,0,0,0,60,174,'elemental_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(533,590,20590,'Liele','','undine','12.00','27.00',46,'female','L2Monster','Mystic',40,1943,11.000,707,2.100,40,43,30,21,20,10,2862,203,365,270,202,199,278,0,253,0,0,0,60,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(534,591,20591,'Valley Treant','','ti_mi_tran','23.00','90.00',47,'male','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,4224,303,388,279,216,206,278,0,253,0,0,0,12,12,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(535,592,20592,'Satyr','','pan','14.00','35.00',48,'male','L2Monster','Fighter',40,2091,16.500,768,2.100,40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,291,0,0,45,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(536,593,20593,'Unicorn','','unicorn','14.00','30.00',49,'male','L2Monster','Mystic',40,2168,16.500,799,2.100,40,43,30,21,20,10,3299,244,437,297,247,219,278,0,253,0,0,0,46,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(537,594,20594,'Forest Runner','','mandragora_b','12.00','25.50',50,'female','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,3381,254,463,306,264,226,278,0,253,0,0,0,80,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.13),
(538,595,20595,'Fline Elder','','sylph','11.00','35.00',51,'female','L2Monster','Mystic',40,2323,13.000,861,2.400,40,43,30,21,20,10,3518,268,593,260,281,232,278,0,253,0,0,0,60,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(539,596,20596,'Liele Elder','','undine','12.00','27.00',52,'female','L2Monster','Mystic',40,2402,13.000,892,2.400,40,43,30,21,20,10,3730,288,627,268,300,239,278,500,253,0,0,0,60,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(540,597,20597,'Valley treant Elder','','ti_mi_tran','23.00','90.00',53,'male','L2Monster','Fighter',40,2481,19.500,923,2.400,40,43,30,21,20,10,5199,408,662,276,319,247,278,0,253,0,0,0,12,12,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(541,598,20598,'Satyr Elder','','pan','14.00','35.00',54,'male','L2Monster','Fighter',40,2562,19.500,955,2.400,40,43,30,21,20,10,3816,304,699,284,339,254,278,0,253,297,0,0,45,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(542,599,20599,'Unicorn Elder','','unicorn','14.00','30.00',55,'male','L2Monster','Mystic',40,2643,19.500,987,2.400,40,43,30,21,20,10,3959,319,737,292,360,261,278,0,253,0,0,0,46,174,'elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(543,600,20600,'Karul Bugbear','','bugbear','17.00','35.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2741,177,300,183,131,164,278,0,253,88,0,0,55,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(544,601,20601,'Tamlin Orc','','batur_orc','9.00','21.50',41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,2444,160,291,208,141,169,278,0,253,2,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(545,602,20602,'Tamlin Orc Archer','','batur_orc_archer','11.00','21.50',42,'male','L2Monster','Ranger',500,1660,5.500,589,2.100,40,43,30,21,20,10,3308,220,692,215,152,175,249,0,227,14,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.96),
(546,603,20603,'Kronbe Spider','','giant_spider','26.00','26.50',43,'male','L2Monster','Mystic',40,1728,5.500,618,2.100,40,43,30,21,20,10,2715,184,302,245,163,181,278,500,253,0,0,0,72,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(547,604,20604,'Lakin','','twin_headed_giant','17.00','39.00',44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3317,227,390,209,176,187,278,0,253,89,0,0,45,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(548,605,20605,'Weird Drake','','drake','30.00','100.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(549,606,20606,'Kuran Kobold','','kobold','10.00','15.00',27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,950,48,94,138,45,102,278,0,253,0,0,0,47,110,'kobold_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(550,607,20607,'Kuran Kobold Warrior','','kobold','10.00','15.00',28,'male','L2Monster','Fighter',40,859,7.000,334,1.500,40,43,30,21,20,10,1006,53,124,118,49,106,278,0,253,0,0,0,47,110,'kobold_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(551,608,20608,'Patin Archer','','skeleton_archer','11.00','27.00',29,'male','L2Monster','Ranger',500,906,7.000,349,1.500,40,43,30,21,20,10,1022,55,271,135,53,110,249,500,227,14,0,0,40,140,'',0,1,'DRIVER','',0,0,0,7,10,8,0,1500,0,0.80),
(552,609,20609,'Lakin Salamander','','salamander','16.00','6.80',30,'male','L2Monster','Fighter',40,954,7.000,365,1.500,40,43,30,21,20,10,1068,58,120,155,58,114,278,0,253,0,0,0,64,96,'elemental_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.20),
(553,610,20610,'Sentinel Of Water','','monster_eye','21.00','43.00',31,'male','L2Monster','Mystic',40,1004,9.000,381,1.800,40,43,30,21,20,10,1083,60,157,133,64,118,278,0,253,0,0,0,90,90,'elemental_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.30),
(554,611,20611,'Dre Vanul Warrior','','dre_vanul','14.00','36.00',32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1154,65,169,138,69,123,278,0,253,0,0,0,80,80,'demonic_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.35),
(555,612,20612,'Salamander Rowin','','salamander','16.00','6.80',33,'male','L2Monster','Fighter',40,1109,9.000,413,1.800,40,43,30,21,20,10,1319,75,151,173,75,128,278,500,253,0,0,0,64,96,'elemental_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.20),
(556,613,20613,'Lafi Lizardman','','virud_lizardman','10.00','23.00',27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,950,48,104,125,45,102,278,0,253,291,0,0,43,130,'lizardman_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.48),
(557,614,20614,'Lafi Lizardman Scout','','virud_lizardman_scout','10.00','22.00',28,'male','L2Monster','Ranger',500,859,7.000,334,1.500,40,43,30,21,20,10,940,49,228,143,49,106,249,0,227,2507,0,0,43,130,'lizardman_clan',300,0,'DRIVER','',0,0,0,7,10,8,0,1500,0,0.72),
(558,615,20615,'Ritmal Swordsman','','spartoi','11.00','27.00',29,'male','L2Monster','Fighter',40,906,7.000,349,1.500,40,43,30,21,20,10,1094,58,122,135,53,110,278,500,253,73,0,0,60,140,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.30),
(559,616,20616,'Lakin Undine','','undine','12.00','27.00',30,'female','L2Monster','Mystic',40,954,7.000,365,1.500,40,43,30,21,20,10,1434,78,145,128,58,114,278,0,253,0,0,0,60,60,'elemental_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.35),
(560,617,20617,'Sentinel Of Water','','magical_weaver','11.00','20.00',31,'male','L2Monster','Mystic',40,1004,9.000,381,1.800,40,43,30,21,20,10,1093,60,129,161,64,118,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(561,618,20618,'Kanil Succubus','','succubus','10.00','36.00',32,'female','L2Monster','Mystic',40,1056,9.000,397,1.800,40,43,30,21,20,10,1216,68,169,138,69,123,278,0,253,0,0,0,60,100,'demonic_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.84),
(562,619,20619,'Rowin Undine','','undine','12.00','27.00',33,'female','L2Monster','Mystic',40,1109,9.000,413,1.800,40,43,30,21,20,10,1252,72,151,173,75,128,278,500,253,0,0,0,60,60,'elemental_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.35),
(563,620,20620,'Cave Beast','','troll','21.00','35.00',61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4304,378,992,344,505,307,278,500,253,0,0,0,55,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(564,621,20621,'Death Wave','','will_o_wisp','13.00','22.00',62,'male','L2Monster','Mystic',40,3219,22.500,1217,2.700,40,43,30,21,20,10,4639,413,1038,353,532,315,278,500,253,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.10),
(565,622,20622,'Malruk Soldier','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,4953,447,950,362,560,323,317,500,289,221,0,0,80,174,'malruk_clan',500,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(566,623,20623,'Plando','','virud_lizardman_scout','10.00','22.00',64,'male','L2Monster','Ranger',500,3384,30.000,1285,2.700,40,43,30,21,20,10,4953,453,2084,449,589,331,249,500,227,2507,0,0,43,174,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.72),
(567,624,20624,'Cave Howler','','twin_headed_giant','17.00','39.00',65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,5037,468,979,460,619,340,278,500,253,0,0,0,45,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(568,625,20625,'Malruk Knight','','skeleton_knight','10.00','25.00',66,'male','L2Monster','Fighter',40,3546,30.000,1353,2.700,40,43,30,21,20,10,5030,473,1020,471,649,348,278,500,253,78,0,0,40,174,'malruk_clan',500,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(569,626,20626,'Malruk Berserker','','death_knight','12.00','30.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,7220,687,1415,362,681,356,278,500,253,77,0,0,27,174,'malruk_clan',500,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(570,627,20627,'Malruk Lord','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3706,37.500,1423,2.700,40,43,30,21,20,10,4964,479,1217,449,713,365,278,500,253,1472,0,0,100,174,'malruk_clan',500,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(571,628,20628,'Limal Karinness','','bloody_queen','14.00','40.00',69,'female','L2Monster','Mystic',40,3784,37.500,1458,2.700,40,43,30,21,20,10,5349,523,1392,418,746,373,278,500,253,0,0,0,80,174,'malruk_clan',500,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(572,629,20629,'Karik','','karik','25.00','90.00',70,'male','L2Monster','Fighter',40,3862,37.500,1493,2.700,40,43,30,21,20,10,6584,652,1445,427,780,382,278,500,253,0,0,0,37,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(573,630,20630,'Taik Orc','','ketra_orc','12.00','29.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,127,0,0,45,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(574,631,20631,'Taik Orc Archer','','ketra_orc_archer','12.00','27.00',41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,3152,206,589,195,141,169,249,0,227,14,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.91),
(575,632,20632,'Taik Orc Warrior','','ketra_orc_warrior','12.00','24.00',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,3144,209,342,196,152,175,278,500,253,75,0,0,36,174,'orc_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(576,633,20633,'Taik Orc Shaman','','ketra_orc_shaman','10.00','23.00',43,'male','L2Monster','Priest',40,1728,5.500,618,2.100,40,43,30,21,20,10,3068,207,302,245,163,181,278,0,253,9,0,0,10,174,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.34),
(577,634,20634,'Taik Orc Captain','','ketra_orc_warrior','12.00','24.00',44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,2943,201,322,253,176,187,278,500,253,75,104,0,36,174,'orc_clan',300,0,'Local','',0,20,86,7,30,4,4,0,-6,0.54),
(578,635,20635,'Carinkain','','mana_vampire','11.00','20.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2974,207,415,216,188,193,278,500,253,0,0,0,90,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(579,636,20636,'Forest of Mirrors Ghost','','dwarf_ghost','9.00','16.50',46,'male','L2Monster','Mystic',40,1943,5.500,707,2.100,40,43,30,21,20,10,3310,235,442,223,202,199,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(580,637,20637,'Forest of Mirrors Ghost','','elf_ghost','7.00','21.00',47,'male','L2Monster','Mystic',40,2016,5.500,738,2.100,40,43,30,21,20,10,3456,248,469,230,216,206,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,1,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(581,638,20638,'Forest of Mirrors Ghost','','human_ghost','8.00','22.00',48,'male','L2Monster','Mystic',40,2091,5.500,768,2.100,40,43,30,21,20,10,3605,263,498,238,231,212,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(582,639,20639,'Mirror','','mirror','26.00','52.00',49,'male','L2Monster','Mystic',40,2168,11.000,799,2.100,40,43,30,21,20,10,4254,314,437,297,247,219,278,0,253,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(583,640,20640,'Harit Lizardman','','zenta_lizardman','11.00','32.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3636,274,509,278,264,226,278,0,253,88,945,0,37,174,'lizardman_clan',300,0,'Local','',0,20,100,7,50,1,9,0,-6,0.28),
(584,641,20641,'Harit Lizardman Grunt','','zenta_lizardman','11.00','32.00',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,4501,343,539,286,281,232,278,0,253,70,0,0,37,174,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(585,642,20642,'Harit Lizardman Archer','','zenta_lizardman_scout','11.00','30.00',52,'male','L2Monster','Ranger',500,2402,6.500,892,2.400,40,43,30,21,20,10,4214,326,1152,324,300,239,249,500,227,14,0,0,37,174,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(586,643,20643,'Harit Lizardman Warrior','','zenta_lizardman_warrior','13.00','35.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4332,341,662,276,319,247,278,0,253,291,0,0,40,174,'lizardman_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(587,644,20644,'Harit Lizardman Shaman','','zenta_lizardman_shaman','13.00','35.00',54,'male','L2Monster','Priest',40,2562,6.500,955,2.400,40,43,30,21,20,10,4241,338,699,284,339,254,278,0,253,9,0,0,43,174,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.63),
(588,645,20645,'Harit Lizardman Matriarch','','zenta_lizardman_matriarch','20.00','40.00',55,'male','L2Monster','Fighter',40,2643,13.000,987,2.400,40,43,30,21,20,10,4768,385,609,354,360,261,278,500,253,221,0,0,53,174,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(589,646,20646,'Halingka','','saber_toothed_tiger','34.00','28.00',55,'male','L2Monster','Fighter',40,2643,13.000,987,2.400,40,43,30,21,20,10,3592,290,737,292,360,261,278,0,253,0,0,0,60,170,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(590,647,20647,'Yintzu','','field_stalker','15.00','30.00',56,'male','L2Monster','Fighter',40,2724,13.000,1019,2.400,40,43,30,21,20,10,3605,296,777,301,382,269,278,500,253,0,0,0,70,110,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(591,648,20648,'Paliote','','will_o_wisp','13.00','22.00',57,'male','L2Monster','Mystic',40,2806,13.000,1052,2.400,40,43,30,21,20,10,4094,340,817,309,405,276,278,0,253,0,0,0,80,140,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.10),
(592,649,20649,'Hamrut','','poison_spider','27.00','25.50',58,'male','L2Monster','Mystic',40,2889,13.000,1084,2.400,40,43,30,21,20,10,4075,344,859,318,428,284,278,500,253,0,0,0,60,140,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.65),
(593,650,20650,'Kranrot','','crimson_bear','19.00','36.00',59,'male','L2Monster','Fighter',40,2971,13.000,1117,2.400,40,43,30,21,20,10,4410,377,902,326,453,291,278,500,253,0,0,0,37,170,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(594,651,20651,'Gamlin','','gamlin','11.00','32.00',60,'male','L2Monster','Fighter',40,3054,13.000,1150,2.400,40,43,30,21,20,10,4097,355,782,405,478,299,278,0,253,0,0,0,80,170,'giant_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(595,652,20652,'Leogul','','leogul','15.00','35.00',61,'male','L2Monster','Fighter',40,3137,15.000,1184,2.700,40,43,30,21,20,10,4320,380,819,416,505,307,278,500,253,0,0,0,80,170,'giant_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.72),
(596,653,20653,'Lesser Giant','','lesser_giant','21.00','44.00',61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4058,357,901,378,505,307,278,0,253,3937,0,0,15,180,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.58),
(597,654,20654,'Lesser Giant Soldier','','lesser_giant','21.00','44.00',62,'male','L2Monster','Fighter',40,3219,22.500,1217,2.700,40,43,30,21,20,10,6224,554,1142,321,532,315,278,0,253,3937,0,0,15,180,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.58),
(598,655,20655,'Lesser Giant Shooter','','lesser_giant_shooter','21.00','44.00',63,'male','L2Monster','Fighter',500,3302,22.500,1251,2.700,40,43,30,21,20,10,5085,459,2194,398,560,323,249,500,227,4028,0,0,80,180,'giant_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.63),
(599,656,20656,'Lesser Giant Scout','','lesser_giant_shooter','21.00','44.00',63,'male','L2Monster','Ranger',500,3302,22.500,1251,2.700,40,43,30,21,20,10,4639,419,2194,338,560,323,249,500,227,4028,0,0,80,180,'giant_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.63),
(600,657,20657,'Lesser Giant Mage','','lesser_giant_mage','21.00','44.00',64,'male','L2Monster','Mystic',40,3384,15.000,1285,2.700,40,43,30,21,20,10,5511,504,1135,371,589,331,278,0,253,3938,0,0,15,180,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(601,658,20658,'Lesser Giant Elder','','lesser_giant_mage','21.00','44.00',65,'male','L2Monster','Mystic',40,3465,15.000,1319,2.700,40,43,30,21,20,10,5324,494,1184,380,619,340,278,0,253,3938,0,0,15,180,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(602,659,20659,'Grave Wanderer','','zombie','13.00','21.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,4123,287,377,238,188,193,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(603,660,20660,'Archer of Greed','','skeleton_archer','11.00','27.00',46,'male','L2Monster','Ranger',500,1943,5.500,707,2.100,40,43,30,21,20,10,4048,287,982,190,202,199,249,500,227,14,0,0,40,174,'',0,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(604,661,20661,'Hatar Ratman Thief','','wererat','14.00','25.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3823,274,373,253,216,206,317,0,289,946,0,0,80,174,'hatar_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(605,662,20662,'Hatar Ratman Boss','','wererat','14.00','25.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3987,291,396,261,231,212,317,0,289,221,0,0,80,174,'hatar_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(606,663,20663,'Hatar Hanishee','','medusa','10.00','25.00',49,'female','L2Monster','Mystic',40,2168,5.500,799,2.100,40,43,30,21,20,10,3492,258,529,245,247,219,278,0,253,0,0,0,50,174,'hatar_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(607,664,20664,'Deprive','','field_stalker','15.00','30.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3672,277,560,253,264,226,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(608,665,20665,'Taik Orc Supply','','ketra_orc','12.00','29.00',51,'male','L2Monster','Priest',40,2323,6.500,861,2.400,40,43,30,21,20,10,4501,343,490,315,281,232,278,0,253,69,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(609,666,20666,'Taik Orc Seeker','','ketra_orc','12.00','29.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(610,667,20667,'Farcran','','crimson_bear','19.00','36.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4813,378,602,304,319,247,278,0,253,0,0,0,37,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(611,668,20668,'Grave Guard','','gargoyle','16.00','50.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4283,341,578,344,339,254,278,500,253,0,0,0,140,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(612,669,20669,'Taik Orc Supply Leader','','ketra_orc_warrior','12.00','24.00',55,'male','L2Monster','Priest',40,2643,6.500,987,2.400,40,43,30,21,20,10,5340,431,737,292,360,261,278,500,253,75,0,0,36,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(613,670,20670,'Crimson Drake','','drake','30.00','100.00',61,'male','L2Monster','Mystic',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5465,481,992,344,505,307,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(614,671,20671,'Kadios','','devastator','35.00','35.00',62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,5702,508,1038,353,532,315,278,500,253,0,0,0,25,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(615,672,20672,'Trives','','serpent_slave','17.00','46.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,5772,521,897,438,560,323,278,0,253,127,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(616,673,20673,'Falibati','','cave_maiden','25.00','65.00',64,'female','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,6016,551,938,449,589,331,278,500,253,73,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(617,674,20674,'Doom Knight','','death_blader','15.00','45.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,8649,804,1184,380,619,340,278,500,253,1472,0,0,100,174,'doom_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,0,0.45),
(618,675,20675,'Tairim','','will_o_wisp','13.00','22.00',50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,3817,288,463,306,264,226,278,0,253,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.10),
(619,676,20676,'Judge of Marsh','','hanged_man_ripper','35.00','80.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6205,577,1184,380,619,340,278,500,253,0,0,0,55,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(620,677,20677,'Tulben','','vampire_bat','10.00','33.50',66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,6968,656,1123,428,649,348,278,0,253,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(621,678,20678,'Tortured Undead','','hungry_spirit','13.00','40.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4085,321,662,276,319,247,278,0,253,0,0,0,15,174,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(622,679,20679,'Marsh Stalker','','gargoyle','16.00','50.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4199,335,636,313,339,254,278,0,253,0,0,0,140,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(623,680,20680,'Marsh Drake','','drake','30.00','100.00',55,'male','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4443,359,737,292,360,261,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(624,681,20681,'Vanor Silenos','','heltor_silenos','13.00','29.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3092,215,377,238,188,193,278,0,253,88,0,0,34,174,'silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(625,682,20682,'Vanor Silenos Grunt','','heltor_silenos','13.00','29.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3077,218,401,245,202,199,278,0,253,158,18,0,34,174,'silenos_clan',300,0,'Local','',0,20,91,7,50,1,9,0,-6,0.46),
(626,683,20683,'Vanor Silenos Scout','','heltor_silenos','13.00','29.00',47,'male','L2Monster','Ranger',40,2016,5.500,738,2.100,40,43,30,21,20,10,4004,287,388,279,216,206,278,500,253,5,0,0,34,174,'silenos_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(627,684,20684,'Vanor Silenos Warrior','','heltor_silenos_warrior','13.00','31.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,4188,306,498,238,231,212,278,0,253,160,0,0,36,174,'silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(628,685,20685,'Vanor Silenos Shaman','','heltor_silenos_shaman','13.00','32.00',49,'male','L2Monster','Priest',40,2168,5.500,799,2.100,40,43,30,21,20,10,3492,258,529,245,247,219,278,0,253,9,0,0,29,174,'silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.22),
(629,686,20686,'Vanor Silenos Chieftain','','heltor_silenos_chieftain','13.00','31.50',50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,3637,274,463,306,264,226,278,0,253,75,0,0,27,174,'silenos_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(630,738,20738,'Kobold Looter Bepook','','kobold_bi','15.00','24.00',13,'male','L2Monster','Fighter',40,339,5.000,147,1.200,40,43,30,21,20,10,663,26,33,63,11,56,278,500,253,4,0,0,47,110,'partisan_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.54),
(631,739,20739,'Bepook''s Pet','','wolf','13.00','9.00',10,'male','L2Monster','Fighter',40,257,1.000,120,0.900,40,43,30,21,20,10,439,14,27,50,8,49,278,0,253,0,0,0,24,110,'partisan_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.39),
(632,742,20742,'Mystical Weaver','','magical_weaver','11.00','20.00',22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,684,32,62,113,28,83,278,0,253,0,0,0,90,90,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(633,743,20743,'Howler','','werewolf','10.00','26.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,843,42,80,127,37,94,278,500,253,0,0,0,50,120,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(634,744,20744,'Red Eye Vampire Bat','','vampire_bat','10.00','33.50',22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,684,32,75,93,28,83,278,0,253,0,0,0,60,80,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(635,745,20745,'Gigantiops','','ant_soldier','35.00','17.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2681,159,174,186,89,137,278,500,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(636,746,20746,'Young Gigantiops','','ant','26.00','15.00',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,2062,114,157,133,64,118,278,0,253,0,0,0,40,139,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(637,747,20747,'Roxide','','succubus','10.00','36.00',32,'female','L2Monster','Mystic',40,1056,9.000,397,1.800,40,43,30,21,20,10,1459,82,169,138,69,123,278,500,253,0,0,0,60,159,'demonic_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.84),
(638,748,20748,'Roxide Cohort','','spartoi','11.00','27.00',29,'male','L2Monster','Fighter',40,906,7.000,349,1.500,40,43,30,21,20,10,1349,72,111,149,53,110,278,0,253,73,0,0,60,159,'demonic_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(639,749,20749,'Death Fire','','dre_vanul','14.00','36.00',32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1459,82,169,138,69,123,278,500,253,0,0,0,80,159,'demonic_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.35),
(640,750,20750,'Fire Archer','','skeleton_archer','11.00','27.00',29,'male','L2Monster','Ranger',500,906,7.000,349,1.500,40,43,30,21,20,10,1397,75,247,149,53,110,249,0,227,14,0,0,40,159,'demonic_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(641,751,20751,'Snipe','','onyx_beast','14.00','14.50',44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,3387,232,390,209,176,187,278,500,253,0,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(642,752,20752,'Snipe Cohort','','onyx_beast','14.00','14.50',42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,3290,219,283,237,152,175,278,0,253,0,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(643,753,20753,'Dark Lord','','death_blader','15.00','45.00',50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,4282,322,463,306,264,226,278,500,253,1472,0,0,100,174,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(644,754,20754,'Dark Knight','','death_knight','12.00','30.00',48,'male','L2Monster','Fighter',40,2091,11.000,768,2.100,40,43,30,21,20,10,4960,362,498,238,231,212,278,0,253,127,0,0,27,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(645,755,20755,'Talakin','','ol_mahum_champion','14.00','27.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1970,108,120,155,58,114,278,500,253,2,0,0,50,133,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(646,756,20756,'Talakin Archer','','ol_mahum_archer','14.00','25.00',28,'male','L2Monster','Ranger',500,859,3.500,334,1.500,40,43,30,21,20,10,1884,99,228,143,49,106,249,0,227,14,0,0,50,133,'ol_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(647,757,20757,'Talakin Raider','','ol_mahum','13.50','25.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1380,71,114,114,45,102,278,0,253,3,0,0,50,133,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(648,758,20758,'Dragon Bearer Chief','','spartoi','11.00','27.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,5255,389,437,297,247,219,278,500,253,123,945,0,60,174,'cave_servant_clan',300,1,'Local','',0,20,97,7,30,4,4,0,-6,0.30),
(649,759,20759,'Dragon Bearer Warrior','','skeleton','11.00','25.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,4944,361,498,238,231,212,278,0,253,2,945,0,60,174,'cave_servant_clan',300,1,'Local','',0,20,95,7,30,4,4,0,-6,0.30),
(650,760,20760,'Dragon Bearer Archer','','skeleton_archer','11.00','27.00',47,'male','L2Monster','Ranger',500,2016,5.500,738,2.100,40,43,30,21,20,10,5137,368,862,279,216,206,249,0,227,14,0,0,40,174,'cave_servant_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(651,761,20761,'Pytan','','bloody_queen','14.00','40.00',69,'female','L2Monster','Mystic',40,3784,22.500,1458,2.700,40,43,30,21,20,10,6633,649,1392,418,746,373,278,500,253,0,0,0,80,174,'malruk_clan',500,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(652,762,20762,'Pytan Knight','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3706,15.000,1423,2.700,40,43,30,21,20,10,7021,678,1106,494,713,365,278,0,253,1472,0,0,100,174,'malruk_clan',500,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(653,763,20763,'Lord of the Plains','','zenta_lizardman_matriarch','20.00','40.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,3869,250,217,222,131,164,317,500,289,221,0,0,53,174,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(654,764,20764,'Shaman of the Plains','','zenta_lizardman_shaman','13.00','35.00',39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,3457,220,231,214,121,158,278,0,253,179,0,0,43,174,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.63),
(655,765,20765,'Warrior of the Plains','','zenta_lizardman_warrior','13.00','35.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,2992,187,261,171,112,153,278,0,253,16,0,0,40,174,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(656,766,20766,'Scout of the Plains','','zenta_lizardman_scout','11.00','30.00',36,'male','L2Monster','Ranger',500,1279,4.500,463,1.800,40,43,30,21,20,10,2659,161,417,193,96,142,249,0,227,14,0,0,37,174,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(657,767,20767,'Timak Orc Troop Leader','','batur_orc_overlord','12.00','24.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,4801,334,415,216,188,193,278,0,253,79,0,0,80,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(658,768,20768,'Timak Orc Troop Shaman','','batur_orc_shaman','11.00','16.00',44,'male','L2Monster','Priest',40,1799,5.500,648,2.100,40,43,30,21,20,10,4632,317,390,209,176,187,278,0,253,7,0,0,50,174,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(659,769,20769,'Timak Orc Troop Warrior','','batur_orc_warrior','10.00','20.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,3684,249,365,202,163,181,278,0,253,123,19,0,80,174,'orc_clan',300,0,'Local','',0,20,84,7,30,4,4,0,-6,0.30),
(660,770,20770,'Timak Orc Troop Archer','','batur_orc_archer','11.00','21.50',41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,4319,283,713,189,141,169,249,0,227,13,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.96),
(661,771,20771,'Barif','','lesser_giant_mage','21.00','44.00',64,'male','L2Monster','Mystic',40,3384,15.000,1285,2.700,40,43,30,21,20,10,6515,596,938,449,589,331,278,500,253,3938,0,0,15,180,'giant_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(662,772,20772,'Barif''s Pet','','leogul','15.00','35.00',61,'male','L2Monster','Fighter',40,3137,15.000,1184,2.700,40,43,30,21,20,10,6332,557,992,344,505,307,278,0,253,0,0,0,80,170,'giant_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.72),
(663,773,20773,'Conjurer Bat Lord','','vampire_bat','10.00','33.50',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10535,1070,1284,540,849,399,278,500,253,0,0,0,60,174,'giant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(664,774,20774,'Conjurer Bat ','','vampire_bat','10.00','33.50',70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,11140,1105,1194,517,780,382,278,0,253,0,0,0,60,174,'giant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(665,775,20775,'Bugbear Raider','','bugbear','17.00','35.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,599,25,48,75,17,67,278,0,253,0,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(666,776,20776,'Dark Succubus','','succubus','10.00','36.00',20,'female','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,783,35,57,94,23,76,278,0,253,0,0,0,60,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(667,777,20777,'Hunter Bear','','grizzly','21.00','40.00',14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,37,66,12,59,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(668,778,20778,'Ragna Orc Overlord','','orc_champion','10.00','23.00',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2477,157,231,214,121,158,278,0,253,2,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(669,779,20779,'Ragna Orc Seer','','orc_shaman','9.00','22.00',39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,2212,141,231,214,121,158,278,0,253,7,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.26),
(670,780,20780,'Bloody Axe Elite','','ol_mahum_champion','14.00','27.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1799,106,174,186,89,137,278,500,253,2,0,0,50,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(671,781,20781,'Delu Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',35,'male','L2Monster','Priest',40,1220,4.500,446,1.800,40,43,30,21,20,10,1781,105,211,154,89,137,278,0,253,7,0,0,43,174,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(672,782,20782,'Ol Mahum Novice','','ol_mahum','13.50','25.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,44,83,17,67,278,500,253,1,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(673,783,20783,'Dread Wolf','','dire_wolf','13.00','11.00',35,'male','L2Monster','Fighter',40,1220,2.250,446,1.800,40,43,30,21,20,10,1635,96,256,127,89,137,278,500,253,0,0,0,24,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(674,784,20784,'Tasaba Lizardman','','virud_lizardman_scout','10.00','22.00',36,'male','L2Monster','Ranger',500,1279,2.250,463,1.800,40,43,30,21,20,10,1852,112,505,159,96,142,249,0,227,2507,0,0,43,140,'lizardman_clan1',300,0,'Magister','',0,0,0,7,10,8,0,1500,0,0.72),
(675,785,20785,'Tasaba Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',37,'male','L2Monster','Priest',40,1338,2.250,480,1.800,40,43,30,21,20,10,1791,110,244,140,104,147,278,0,253,7,0,0,43,140,'lizardman_clan1',300,0,'Magister','',0,0,0,7,50,1,9,0,10,0.48),
(676,786,20786,'Lienrik','','lienrik','12.00','50.00',39,'male','L2Monster','Fighter',40,1462,2.250,514,1.800,40,43,30,21,20,10,1990,126,297,146,121,158,317,0,289,0,0,0,100,150,'lienrik_clan',300,0,'Magister','',0,0,0,7,10,8,0,0,0,0.46),
(677,787,20787,'Lienrik Lad','','lienrik','12.00','50.00',40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,2421,156,317,151,131,164,317,500,289,0,0,0,100,174,'lienrik_clan',300,0,'Magister','',0,0,0,7,10,8,0,0,0,0.46),
(678,788,20788,'Rakul','','rakul','30.00','39.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2120,125,192,169,89,137,278,0,253,3,0,0,60,174,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.59),
(679,789,20789,'Crokian','','crokian','18.00','29.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1999,121,187,193,96,142,278,500,253,5128,0,0,18,174,'croc_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(680,790,20790,'Dailaon','','dailaon','20.00','28.00',37,'male','L2Monster','Fighter',500,1338,4.500,480,1.800,40,43,30,21,20,10,2567,158,448,200,104,147,249,0,227,5127,0,0,18,174,'croc_clan',300,0,'Magister','',0,0,0,7,10,8,0,1500,0,0.91),
(681,791,20791,'Crokian Warrior','','crokian','18.00','29.00',38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,2211,138,261,171,112,153,278,500,253,5128,0,0,18,174,'croc_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(682,792,20792,'Farhite','','farhite','16.00','31.00',39,'male','L2Monster','Fighter',40,1462,9.000,514,1.800,40,43,30,21,20,10,2057,131,280,150,121,158,278,0,253,5131,0,0,15,174,'croc_clan',300,0,'Magister','',0,0,0,7,50,1,9,0,10,0.74),
(683,793,20793,'Nos','','nos','26.00','42.00',40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,2251,145,300,183,131,164,278,500,253,5130,0,0,18,174,'croc_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(684,794,20794,'Blade Stakato','','blade_stakato','15.00','36.00',41,'male','L2Monster','Fighter',40,1593,11.000,560,2.100,40,43,30,21,20,10,2103,137,265,229,141,169,278,0,253,223,0,0,25,174,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(685,795,20795,'Blade Stakato Worker','','blade_stakato_worker','13.00','40.00',42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,1988,132,272,215,152,175,317,0,289,226,0,0,25,174,'stakato_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.76),
(686,796,20796,'Blade Stakato Warrior','','blade_stakato_soldier','15.00','38.00',43,'male','L2Monster','Fighter',40,1728,11.000,618,2.100,40,43,30,21,20,10,2125,143,365,202,163,181,278,500,253,232,0,0,25,174,'stakato_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.74),
(687,797,20797,'Blade Stakato Drone','','blade_stakato_drone','15.00','39.00',44,'male','L2Monster','Fighter',40,1799,16.500,648,2.100,40,43,30,21,20,10,2154,147,390,178,176,187,278,0,253,74,0,0,25,174,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.58),
(688,798,20798,'Water Giant','','water_giant','13.00','44.00',45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,2612,181,343,262,188,193,278,500,253,5132,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(689,799,20799,'Queen Undine Lad','','undine','12.00','27.00',46,'female','L2Monster','Mystic',40,1943,11.000,707,2.100,40,43,30,21,20,10,2630,186,442,190,202,199,278,0,253,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.35),
(690,800,20800,'Eva''s Seeker','','field_stalker','15.00','30.00',47,'male','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,2465,176,388,279,216,206,278,0,253,0,0,0,70,174,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.41),
(691,801,20801,'Theeder Piker','','theeder','9.00','32.00',48,'male','L2Monster','Fighter',80,2091,11.000,768,2.100,40,43,30,21,20,10,2972,217,481,288,231,212,237,500,216,302,0,0,80,174,'theeder_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(692,802,20802,'Theeder Mage','','theeder','9.00','32.00',49,'male','L2Monster','Mystic',40,2168,11.000,799,2.100,40,43,30,21,20,10,3025,223,529,208,247,219,278,0,253,192,0,0,80,174,'theeder_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.45),
(693,803,20803,'Doll Master','','doll_master','20.00','42.00',50,'male','L2Monster','Fighter',40,2245,16.500,830,2.100,40,43,30,21,20,10,3949,297,616,230,264,226,278,500,253,0,0,0,80,174,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.56),
(694,804,20804,'Crokian Lad','','crokian_100_bi','36.00','61.00',41,'male','L2Monster','Fighter',40,1593,11.000,560,2.100,40,43,30,21,20,10,2574,168,291,208,141,169,278,500,253,5128,0,0,18,174,'croc_clan2',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(695,805,20805,'Dailaon Lad','','dailaon_100_bi','40.00','58.00',42,'male','L2Monster','Fighter',500,1660,11.000,589,2.100,40,43,30,21,20,10,2790,186,762,196,152,175,249,0,227,5127,0,0,18,174,'croc_clan2',300,0,'Magister','',0,0,0,7,10,8,0,1500,0,0.91),
(696,806,20806,'Crokian Lad Warrior','','crokian_100_bi','36.00','61.00',43,'male','L2Monster','Fighter',40,1728,11.000,618,2.100,40,43,30,21,20,10,2678,181,365,202,163,181,278,500,253,5128,0,0,18,174,'croc_clan2',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(697,807,20807,'Farhite Lad','','farhite_50_bi','24.00','48.00',44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,2817,193,390,178,176,187,278,0,253,5131,0,0,15,174,'croc_clan2',300,0,'Magister','',0,0,0,7,50,1,9,0,10,0.74),
(698,808,20808,'Nos Lad','','nos_100_bi','52.00','86.00',45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,3487,242,343,262,188,193,278,500,253,128,0,0,18,174,'croc_clan2',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(699,809,20809,'Ghost of the Tower','','human_ghost','8.00','22.00',60,'male','L2Monster','Mystic',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4045,351,860,368,478,299,278,500,253,0,0,0,80,143,'tower_ghost_clan',400,1,'Magister','',0,0,0,7,50,1,9,0,0,0.39),
(700,810,20810,'Seer of Hallate','','field_stalker','15.00','30.00',60,'male','L2Monster','Fighter',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4045,351,946,335,478,299,278,500,253,0,0,0,70,170,'hallate_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.41),
(701,811,20811,'Ghastly Warrior','','unpleasant_humming','12.00','26.00',61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4769,419,717,416,505,307,317,500,289,0,0,0,21,150,'tower_ghost_clan',400,1,'Magister','',0,0,0,7,10,8,0,0,0,0.59),
(702,812,20812,'Archer of Despair','','skeleton_archer','11.00','27.00',61,'male','L2Monster','Ranger',500,3137,22.500,1184,2.700,40,43,30,21,20,10,4708,414,2204,292,505,307,249,500,227,284,0,0,40,160,'tower_ghost_clan',400,1,'Magister','',0,0,0,7,10,8,0,1500,10,0.80),
(703,813,20813,'Crendion','','liviona','15.00','28.00',62,'male','L2Monster','Fighter',40,3219,22.500,1217,2.700,40,43,30,21,20,10,4276,381,944,388,532,315,278,500,253,0,0,0,80,160,'tower_ghost_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(704,814,20814,'Blader of Despair','','spartoi','11.00','27.00',62,'male','L2Monster','Fighter',80,3219,22.500,1217,2.700,40,43,30,21,20,10,4938,440,1212,353,532,315,237,500,216,79,0,0,60,143,'tower_ghost_clan',400,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(705,815,20815,'Hound Dog of Hallate','','dire_wolf','13.00','11.00',63,'male','L2Monster','Fighter',40,3302,30.000,1251,2.700,40,43,30,21,20,10,4583,413,897,438,560,323,278,500,253,0,0,0,24,165,'hallate_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.39),
(706,816,20816,'Hallate''s Royal Guard','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,5098,460,785,438,560,323,317,500,289,946,945,0,80,164,'hallate_clan',400,1,'Magister',NULL,0,20,131,7,10,8,0,0,-6,0.52),
(707,817,20817,'Corrupt Sage','','vale_master','12.00','40.00',64,'male','L2Monster','Mystic',40,3384,22.500,1285,2.700,40,43,30,21,20,10,5315,486,1135,315,589,331,278,500,253,210,0,0,70,160,'tower_ghost_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,10,0.74),
(708,818,20818,'Hallate''s Warrior','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,22.500,1285,2.700,40,43,30,21,20,10,4926,451,1135,371,589,331,278,500,253,78,0,0,40,160,'hallate_clan',400,1,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.17),
(709,819,20819,'Archer of Abyss','','fiend_archer','17.00','55.00',65,'male','L2Monster','Ranger',500,3465,22.500,1319,2.700,40,43,30,21,20,10,4889,454,2632,380,619,340,249,500,227,0,0,0,70,165,'tower_ghost_clan',400,0,'Magister','',0,0,0,7,10,8,0,1500,0,0.76),
(710,820,20820,'Hallate''s Knight','','death_knight','12.00','30.00',65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,7310,679,979,460,619,340,278,500,253,80,0,0,27,160,'hallate_clan',400,1,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.71),
(711,821,20821,'Erin Ediunce','','banshee','9.00','23.00',66,'female','L2Monster','Mystic',40,3546,30.000,1353,2.700,40,43,30,21,20,10,5335,502,1020,401,649,348,278,500,253,3939,0,0,80,165,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,10,0.56),
(712,822,20822,'Hallate''s Maid','','bloody_queen','14.00','40.00',66,'female','L2Monster','Mystic',40,3546,30.000,1353,2.700,40,43,30,21,20,10,4964,467,893,471,649,348,317,500,289,0,0,0,80,160,'hallate_clan',400,0,'Magister',NULL,0,0,0,7,10,8,0,0,0,0.50),
(713,823,20823,'Platinum Tribe Soldier','','kel_mahum','13.00','26.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5764,549,1126,399,681,356,317,500,289,242,0,0,50,160,'tower_guard_clan',400,0,'Magister','',0,0,0,7,10,8,0,0,0,0.52),
(714,824,20824,'Hallate''s Commander','','death_blader','15.00','45.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5184,493,1286,399,681,356,278,500,253,1472,0,0,100,170,'hallate_clan',400,1,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45),
(715,825,20825,'Hallate''s Inspector','','karik_25_bi','31.00','110.00',68,'male','L2Monster','Fighter',40,3706,30.000,1423,2.700,40,43,30,21,20,10,5414,523,1339,408,713,365,278,500,253,0,0,0,37,170,'hallate_clan',400,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45),
(716,826,20826,'Platinum Tribe Archer','','kel_mahum_archer','13.00','27.00',68,'male','L2Monster','Ranger',500,3706,22.500,1423,2.700,40,43,30,21,20,10,7650,739,2975,347,713,365,249,500,227,288,0,0,50,160,'tower_guard_clan',400,0,'Magister','',0,0,0,7,10,8,0,1500,10,0.91),
(717,827,20827,'Platinum Tribe Warrior','','kel_mahum_warrior','13.00','28.00',69,'male','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,5991,586,1150,506,746,373,278,500,253,148,0,0,50,160,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(718,828,20828,'Platinum Tribe Shaman','','kel_mahum_witch_doctor','13.00','25.00',70,'male','L2Monster','Priest',40,3862,37.500,1493,2.700,40,43,30,21,20,10,5881,583,1445,427,780,382,278,500,253,202,0,0,50,160,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.28),
(719,829,20829,'Platinum Tribe Overlord','','kel_mahum_champion','13.00','32.00',71,'male','L2Monster','Fighter',40,3938,42.500,1529,3.000,40,43,30,21,20,10,8449,847,1239,529,814,390,278,500,253,147,0,0,50,170,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.56),
(720,830,20830,'Guardian Angel','','angel','13.50','36.50',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,0,0,1710,406,849,399,278,500,253,148,0,0,30,170,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(721,831,20831,'Seal Angel','','angel','13.50','36.50',73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,0,0,1770,415,885,407,278,500,253,148,0,0,30,170,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(722,832,20832,'Zaken''s Pikeman','','skeleton_pikeman','10.00','28.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2720,184,249,252,163,181,278,500,253,292,0,0,50,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,30,4,4,0,10,0.21),
(723,833,20833,'Zaken''s Archer','','skeleton_archer','11.00','27.00',44,'male','L2Monster','Ranger',500,1799,5.500,648,2.100,40,43,30,21,20,10,3025,207,592,260,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,10,8,0,1500,10,0.80),
(724,834,20834,'Mardian','','giant_spider','26.00','26.50',42,'male','L2Monster','Mystic',40,1660,11.000,589,2.100,40,43,30,21,20,10,2251,150,342,196,152,175,278,500,253,0,0,0,72,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(725,835,20835,'Zaken''s Seer','','liviona','15.00','28.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2478,172,283,269,188,193,278,500,253,0,0,0,80,174,NULL,0,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34),
(726,836,20836,'Pirate Zombie','','pirates_zombie','10.00','23.00',44,'male','L2Monster','Mystic',40,1799,11.000,648,2.100,40,43,30,21,20,10,2832,194,341,209,176,187,317,0,289,225,0,0,11,174,'undead_clan1',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.74),
(727,837,20837,'Tainted Ogre','','ogre','21.00','44.00',45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,2565,178,577,216,188,193,200,500,182,194,0,0,22,174,'undead_clan1',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.69),
(728,838,20838,'Bloody Bat','','vampire_bat','10.00','33.50',45,'male','L2Monster','Mystic',40,1870,11.000,677,2.100,40,43,30,21,20,10,2405,167,300,262,188,193,317,0,289,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.50),
(729,839,20839,'Unpleasant Humming','','unpleasant_humming','12.00','26.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,2877,204,301,327,202,199,278,500,253,0,0,0,21,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(730,840,20840,'Death Flyer','','dark_horror','20.00','35.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,2971,213,320,287,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,10,0.37),
(731,841,20841,'Fiend Archer','','fiend_archer','17.00','55.00',48,'male','L2Monster','Ranger',500,2091,5.500,768,2.100,40,43,30,21,20,10,3052,223,757,296,231,212,249,500,227,0,0,0,70,174,'demonic_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(732,842,20842,'Musveren','','field_stalker','15.00','30.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'undead_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(733,843,20843,'Zaken''s Royal Guard','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3677,277,335,370,264,226,317,500,289,225,945,0,80,174,'undead_clan',300,1,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52),
(734,844,20844,'Kaim Vanul','','kaim_vanul','24.00','40.00',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3279,250,405,381,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(735,845,20845,'Pirate''s Zombie Captain','','pirates_zombie_captain','17.00','28.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4954,383,375,393,300,239,317,500,289,232,0,0,14,174,'zaken_clan',300,1,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(736,846,20846,'Doll Blader','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,3931,309,396,344,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,0,'Local','',0,0,93,7,10,8,0,0,10,0.50),
(737,847,20847,'Vale Master','','vale_master','12.00','40.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3750,299,477,354,339,254,278,500,253,0,0,0,70,174,'zaken_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(738,848,20848,'Light Bringer','','light_bringer','10.00','23.00',46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2432,172,401,245,202,199,278,500,253,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(739,849,20849,'Light Worm','','light_worm','5.00','16.00',41,'male','L2Monster','Fighter',40,1593,11.000,560,2.100,40,43,30,21,20,10,1932,126,265,229,141,169,278,500,253,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.06),
(740,850,20850,'Golden Stag Lord','','golden_stag_lord','25.00','30.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3152,237,509,278,264,226,278,0,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(741,851,20851,'Theeder','','theeder','9.00','32.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,2841,204,498,253,216,206,237,500,216,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(742,852,20852,'Banshee','','banshee','9.00','23.00',60,'female','L2Monster','Mystic',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4450,386,828,335,478,299,317,500,289,3939,0,0,80,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.56),
(743,853,20853,'Kel Mahum','','kel_mahum','13.00','26.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7824,727,942,418,619,340,317,500,289,242,0,0,50,174,'kel_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(744,854,20854,'Kel Mahum Warrior','','kel_mahum_warrior','13.00','28.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7686,723,1235,389,649,348,278,500,253,148,0,0,50,174,'kel_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(745,855,20855,'Kel Mahum Archer','','kel_mahum_archer','13.00','27.00',67,'male','L2Monster','Ranger',500,3626,7.500,1388,2.700,40,43,30,21,20,10,8900,848,2859,339,681,356,249,0,227,288,0,0,50,174,'kel_mahum_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.91),
(746,856,20856,'Kel Mahum Shaman','','kel_mahum_witch_doctor','13.00','25.00',68,'male','L2Monster','Priest',40,3706,7.500,1423,2.700,40,43,30,21,20,10,6390,617,1339,347,713,365,278,500,253,202,0,0,50,174,'kel_mahum_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.28),
(747,857,20857,'Kel Mahum Champion','','kel_mahum_champion','13.00','32.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8149,808,1445,427,780,382,278,500,253,147,0,0,50,174,'kel_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(748,858,20858,'Angel','','angel','13.50','36.50',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,9102,925,1554,446,849,399,278,500,253,148,0,0,30,174,'tower_guard_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(749,859,20859,'Guardian Angel','','angel','13.50','36.50',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,12443,1264,1554,446,849,399,278,500,253,148,0,0,30,170,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(750,860,20860,'Seal Angel','','angel','13.50','36.50',73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,13949,1435,1330,552,885,407,278,500,253,148,0,0,30,170,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(751,861,20861,'Oel Mahum Champion','','oel_mahum_champion','23.00','61.00',56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,5533,454,777,301,382,269,278,500,253,127,0,0,67,174,'oel_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(752,862,20862,'Death Lord','','death_lord','21.00','40.00',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'demonic_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(753,919,20919,'Maille Lizardman','','virud_lizardman','10.00','23.00',20,'male','L2Monster','Fighter',40,541,1.250,213,1.200,40,43,30,21,20,10,641,28,57,94,23,76,278,0,253,291,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(754,920,20920,'Maille Lizardman Scout','','virud_lizardman_scout','10.00','22.00',22,'male','L2Monster','Ranger',500,611,1.750,242,1.500,40,43,30,21,20,10,1187,56,153,102,28,83,249,0,227,2507,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.72),
(755,921,20921,'Maille Lizardman Guard','','virud_lizardman','10.00','23.00',24,'male','L2Monster','Fighter',40,687,1.750,272,1.500,40,43,30,21,20,10,858,42,81,111,34,90,278,500,253,291,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(756,922,20922,'Maille Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',26,'male','L2Monster','Fighter',40,770,1.750,303,1.500,40,43,30,21,20,10,951,48,96,120,41,98,278,0,253,16,0,0,52,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.59),
(757,923,20923,'Maille Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',28,'male','L2Monster','Priest',40,859,1.750,334,1.500,40,43,30,21,20,10,1392,74,113,130,49,106,278,0,253,7,0,0,43,120,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(758,924,20924,'Maille Lizardman Matriarch','','virud_lizardman_matriarch','13.00','37.00',30,'male','L2Monster','Fighter',40,954,1.750,365,1.500,40,43,30,21,20,10,1708,94,132,140,58,114,278,500,253,69,627,0,56,130,'lizardman_clan',300,0,'Local','',0,20,59,7,50,1,9,0,-6,0.65),
(759,925,20925,'Giant Araneid','','giant_spider','26.00','26.50',24,'male','L2Monster','Mystic',40,687,1.750,272,1.500,40,43,30,21,20,10,875,44,81,94,34,90,278,0,253,0,0,0,72,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.26),
(760,926,20926,'Poison Araneid','','poison_spider','27.00','25.50',25,'male','L2Monster','Mystic',40,728,1.750,287,1.500,40,43,30,21,20,10,1012,50,88,98,37,94,278,0,253,0,0,0,60,140,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.65),
(761,927,20927,'King of the Araneid','','giant_spider_50_bi','39.00','38.00',27,'male','L2Monster','Mystic',40,813,1.750,318,1.500,40,43,30,21,20,10,1453,74,104,106,45,102,278,500,253,0,0,0,72,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.26),
(762,928,20928,'Hatu Weird Bee','','giant_bee','8.00','24.50',30,'male','L2Monster','Fighter',40,954,1.750,365,1.500,40,43,30,21,20,10,1468,80,132,140,58,114,278,500,253,0,0,0,90,120,'hatu_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(763,929,20929,'Hatu Dire Wolf','','dire_wolf','13.00','11.00',32,'male','L2Monster','Fighter',40,1056,2.250,397,1.800,40,43,30,21,20,10,1393,78,154,151,69,123,278,0,253,0,0,0,24,110,'hatu_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(764,930,20930,'Hatu Brown Bear','','grizzly','21.00','40.00',34,'male','L2Monster','Fighter',40,1164,2.250,430,1.800,40,43,30,21,20,10,2195,128,178,163,82,132,278,500,253,0,0,0,40,143,'hatu_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.34),
(765,931,20931,'Hatu Onyx Beast','','onyx_beast','14.00','14.50',36,'male','L2Monster','Fighter',40,1279,2.250,463,1.800,40,43,30,21,20,10,2035,124,206,175,96,142,278,0,253,0,0,0,30,174,'hatu_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(766,932,20932,'Hatu Crimson Bear','','crimson_bear','19.00','36.00',38,'male','L2Monster','Fighter',40,1400,2.250,497,1.800,40,43,30,21,20,10,2688,168,238,188,112,153,278,0,253,0,0,0,37,174,'hatu_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(767,933,20933,'Hatu Windsus','','giant_wild_hog','25.00','27.00',40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,3080,198,273,201,131,164,278,500,253,0,0,0,35,174,'hatu_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.54),
(768,934,20934,'Wasp Worker','','giant_bee_bi','8.00','32.00',35,'male','L2Monster','Fighter',40,1220,2.250,446,1.800,40,43,30,21,20,10,1651,98,192,144,89,137,278,0,253,0,0,0,90,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.50),
(769,935,20935,'Wasp Leader','','giant_bee_100_bi','16.00','49.00',37,'male','L2Monster','Fighter',40,1338,2.250,480,1.800,40,43,30,21,20,10,1809,112,222,154,104,147,278,500,253,0,0,0,90,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.50),
(770,936,20936,'Tanor Silenos','','heltor_silenos','13.00','29.00',40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,3443,222,273,201,131,164,278,0,253,88,0,0,34,174,'silenos_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.46),
(771,937,20937,'Tanor Silenos Grunt','','heltor_silenos','13.00','29.00',42,'male','L2Monster','Fighter',40,1660,2.750,589,2.100,40,43,30,21,20,10,4498,300,311,215,152,175,278,0,253,158,18,0,34,174,'silenos_clan',300,0,'Local','',0,20,82,7,50,1,9,0,-6,0.46),
(772,938,20938,'Tanor Silenos Scout','','heltor_silenos','13.00','29.00',44,'male','L2Minion','Ranger',40,1799,2.750,648,2.100,40,43,30,21,20,10,4937,338,354,230,176,187,278,0,253,5,0,0,34,174,'silenos_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.46),
(773,939,20939,'Tanor Silenos Warrior','','heltor_silenos_warrior','13.00','31.00',46,'male','L2Monster','Fighter',40,1943,2.750,707,2.100,40,43,30,21,20,10,5504,390,401,245,202,199,278,500,253,160,0,0,36,174,'silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.39),
(774,940,20940,'Tanor Silenos Shaman','','heltor_silenos_shaman','13.00','32.00',48,'male','L2Monster','Priest',40,2091,2.750,768,2.100,40,43,30,21,20,10,6707,490,453,261,231,212,278,0,253,9,0,0,29,174,'silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.22),
(775,941,20941,'Tanor Silenos Chieftain','','heltor_silenos_chieftain','13.00','31.50',50,'male','L2Monster','Fighter',40,2245,2.750,830,2.100,40,43,30,21,20,10,6503,490,509,278,264,226,278,500,253,75,0,0,27,174,'silenos_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.39),
(776,942,20942,'Nightmare Guide','','harpy','10.00','42.00',43,'female','L2Monster','Fighter',40,1728,2.750,618,2.100,40,43,30,21,20,10,3282,222,332,189,163,181,278,0,253,0,0,0,60,174,'',0,0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.65),
(777,943,20943,'Nightmare Keeper','','harpy','10.00','42.00',45,'female','L2Monster','Fighter',40,1870,2.750,677,2.100,40,43,30,21,20,10,4721,328,377,202,188,193,278,0,253,0,0,0,60,174,'',0,0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.65),
(778,944,20944,'Nightmare Lord','','succubus_100_bi','20.00','75.00',47,'female','L2Monster','Fighter',40,2016,2.750,738,2.100,40,43,30,21,20,10,4000,286,427,215,216,206,278,500,253,0,0,0,60,174,'',0,0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.84),
(779,945,20945,'Cadeine','','hobgoblin','12.00','24.00',50,'male','L2Monster','Fighter',40,2245,2.750,830,2.100,40,43,30,21,20,10,4483,338,509,278,264,226,278,0,253,127,625,0,45,174,'green_clan',300,0,'Local','',0,20,100,7,50,1,9,0,-6,0.41),
(780,946,20946,'Sanhidro','','troll','21.00','35.00',52,'male','L2Monster','Fighter',40,2402,3.250,892,2.400,40,43,30,21,20,10,6896,534,570,295,300,239,278,0,253,0,0,0,55,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(781,947,20947,'Connabi','','bugbear','17.00','35.00',54,'male','L2Monster','Fighter',40,2562,3.250,955,2.400,40,43,30,21,20,10,7437,592,636,313,339,254,278,0,253,88,0,0,55,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(782,948,20948,'Bartal','','liviona','15.00','28.00',56,'male','L2Monster','Fighter',40,2724,3.250,1019,2.400,40,43,30,21,20,10,7385,606,706,331,382,269,278,0,253,0,0,0,80,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.34),
(783,949,20949,'Luminun','','twin_headed_giant','17.00','39.00',58,'male','L2Monster','Fighter',40,2889,3.250,1084,2.400,40,43,30,21,20,10,8700,734,781,349,428,284,278,0,253,157,0,0,45,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(784,950,20950,'Innersen','','king_bugbear','15.00','40.00',60,'male','L2Monster','Fighter',40,3054,3.250,1150,2.400,40,43,30,21,20,10,9365,812,860,368,478,299,278,500,253,160,0,0,55,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(785,951,20951,'Pobby''s Maid','','manadragora','14.00','17.80',53,'female','L2Monster','Fighter',40,2481,3.250,923,2.400,40,43,30,21,20,10,5037,396,602,258,319,247,278,0,253,0,0,0,80,174,'green_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.28),
(786,952,20952,'Pobby Escort','','mandragora_b','12.00','25.50',55,'female','L2Monster','Fighter',40,2643,3.250,987,2.400,40,43,30,21,20,10,9101,734,670,273,360,261,278,0,253,0,0,0,80,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.13),
(787,953,20953,'Pobby','','mandragora_a','15.00','26.00',57,'female','L2Monster','Fighter',40,2806,3.250,1052,2.400,40,43,30,21,20,10,8452,702,743,289,405,276,278,500,253,0,0,0,80,174,'green_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.20),
(788,954,20954,'Hungered Corpse','','skeleton','11.00','25.00',60,'male','L2Monster','Fighter',40,3054,3.250,1150,2.400,40,43,30,21,20,10,9985,866,860,368,478,299,278,0,253,123,945,0,60,180,'bloody_clan',300,1,'Local','',0,20,123,7,50,1,9,0,-6,0.30),
(789,955,20955,'Ghostly Warrior','','skeleton_pikeman','10.00','28.00',62,'male','L2Monster','Fighter',40,3219,3.750,1217,2.700,40,43,30,21,20,10,10662,950,944,388,532,315,278,0,253,299,0,0,50,180,'bloody_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.21),
(790,956,20956,'Past Knight','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,3.750,1285,2.700,40,43,30,21,20,10,11588,1060,1031,408,589,331,278,500,253,150,103,0,40,174,'bloody_clan',300,1,'Local','',0,20,133,7,50,1,9,0,-6,0.17),
(791,957,20957,'Nihil Invader','','skeleton_royal_guard','11.00','28.50',66,'male','L2Monster','Fighter',40,3546,3.750,1353,2.700,40,43,30,21,20,10,12082,1138,1123,428,649,348,278,0,253,946,945,0,80,185,'bloody_clan',300,1,'Local','',0,20,138,7,50,1,9,0,-6,0.52),
(792,958,20958,'Death Agent','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,9018,872,1217,449,713,365,278,0,253,1472,0,0,100,195,'bloody_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(793,959,20959,'Dark Guard','','headless_knight','21.00','31.00',70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,13863,1374,1314,470,780,382,278,500,253,124,0,0,70,170,'bloody_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(794,960,20960,'Bloody Ghost','','succubus','10.00','36.00',64,'female','L2Monster','Mystic',40,3384,3.750,1285,2.700,40,43,30,21,20,10,7988,732,1031,347,589,331,278,0,253,0,0,0,60,175,'bloody_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.84),
(795,961,20961,'Bloody Knight','','doll_blader','6.00','12.00',65,'male','L2Monster','Fighter',40,3465,3.750,1319,2.700,40,43,30,21,20,10,11719,1088,1077,355,619,340,278,0,253,5129,5129,0,22,175,'bloody_clan',300,0,'Local','',0,0,119,7,50,1,9,0,10,0.50),
(796,962,20962,'Bloody Priest','','bloody_queen','14.00','40.00',66,'female','L2Monster','Priest',40,3546,3.750,1353,2.700,40,43,30,21,20,10,13045,1228,1123,364,649,348,278,0,253,0,0,0,80,185,'bloody_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.50),
(797,963,20963,'Bloody Lord','','banshee','9.00','23.00',68,'female','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,9382,906,1217,382,713,365,278,500,253,3939,0,0,80,180,'bloody_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(798,964,20964,'Huge Footmark','','stone_golem','20.00','31.00',70,'male','L2Monster','Mystic',40,3862,3.750,1493,2.700,40,43,30,21,20,10,13513,1340,1314,470,780,382,278,0,253,0,0,0,23,23,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(799,965,20965,'Chimera Piece','','saber_toothed_tiger','34.00','28.00',72,'male','L2Monster','Fighter',40,4013,4.250,1565,3.000,40,43,30,21,20,10,14379,1460,1413,491,849,399,278,0,253,0,0,0,60,174,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(800,966,20966,'Black Shadow','','drake','30.00','100.00',74,'male','L2Monster','Mystic',40,4158,4.250,1637,3.000,40,43,30,21,20,10,15493,1616,1513,512,921,416,278,500,253,0,0,0,70,185,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.84),
(801,967,20967,'Past Creature','','gamlin','11.00','32.00',76,'male','L2Monster','Fighter',40,4297,4.250,1710,3.000,40,43,30,21,20,10,16021,1712,1614,534,994,433,278,0,253,0,0,0,80,170,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(802,968,20968,'Nonexistent Man','','susceptor','20.00','35.00',78,'male','L2Monster','Fighter',40,4428,4.250,1784,3.000,40,43,30,21,20,10,15583,1706,1715,555,1069,451,278,0,253,0,0,0,27,150,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(803,969,20969,'Giant''s Shadow','','lesser_giant_shooter','21.00','44.00',79,'male','L2Monster','Fighter',500,4490,4.250,1821,3.000,40,43,30,21,20,10,13043,1446,3921,566,1107,459,249,500,227,4028,0,0,80,190,'giant_clan',300,0,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.63),
(804,970,20970,'Soldier of Ancient Times','','lesser_giant','21.00','44.00',73,'male','L2Monster','Fighter',40,4086,4.250,1601,3.000,40,43,30,21,20,10,10913,1122,1463,426,885,407,278,0,253,3937,0,0,15,190,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.58),
(805,971,20971,'Warrior of Ancient Times','','lesser_giant','21.00','44.00',75,'male','L2Monster','Fighter',40,4229,4.250,1673,3.000,40,43,30,21,20,10,15602,1646,1563,445,957,425,278,0,253,3937,0,0,15,185,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.58),
(806,972,20972,'Shaman of Ancient Times','','lesser_giant_mage','21.00','44.00',75,'male','L2Monster','Mystic',40,4229,4.250,1673,3.000,40,43,30,21,20,10,10970,1158,1563,445,957,425,278,0,253,3938,0,0,15,195,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(807,973,20973,'Forgotten Ancient People','','lesser_giant_mage','21.00','44.00',77,'male','L2Monster','Mystic',40,4364,4.250,1747,3.000,40,43,30,21,20,10,16958,1836,1664,463,1031,442,278,500,253,3938,0,0,15,185,'giant_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(808,974,20974,'Spiteful Soul Leader','','skeleton_royal_guard_bi','16.00','44.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,11772,1094,1077,418,619,340,278,0,253,946,945,0,80,174,'undead_clan',300,1,'Magister','',0,20,135,7,30,4,4,0,-6,0.52),
(809,975,20975,'Spiteful Soul Wizard','','elf_ghost_50_bi','10.00','32.00',63,'male','L2Monster','Mystic',40,3302,7.500,1251,2.700,40,43,30,21,20,10,10499,948,987,398,560,323,278,0,253,0,0,0,80,174,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.41),
(810,976,20976,'Spiteful Soul Fighter','','human_ghost_50_bi','12.00','33.00',62,'male','L2Monster','Mystic',40,3219,7.500,1217,2.700,40,43,30,21,20,10,8911,794,944,388,532,315,278,0,253,0,0,0,80,174,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.39),
(811,977,20977,'Elmo-Aden''s Lady','','banshee_50_bi','13.50','38.00',65,'female','L2Monster','Mystic',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7513,698,979,460,619,340,278,500,253,3939,0,0,80,160,'tower_ghost_clan',400,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.56),
(812,978,20978,'Elmo-Aden''s Archer Escort','','skeleton_archer','11.00','27.00',64,'male','L2Monster','Ranger',500,3384,15.000,1285,2.700,40,43,30,21,20,10,7470,684,2522,315,589,331,249,0,227,284,0,0,40,140,'tower_ghost_clan',400,1,'Magister',NULL,0,0,0,7,10,8,0,1500,10,0.80),
(813,979,20979,'Elmo-Aden''s Maid','','doll_blader','6.00','12.00',64,'male','L2Monster','Fighter',40,3384,15.000,1285,2.700,40,43,30,21,20,10,7141,654,1135,371,589,331,278,0,253,5129,5129,0,22,170,'tower_ghost_clan',400,0,'Magister',NULL,0,0,137,7,30,4,4,0,0,0.50),
(814,980,20980,'Hallate''s Follower Mul','','vale_master','12.00','40.00',68,'male','L2Monster','Fighter',40,3706,15.000,1423,2.700,40,43,30,21,20,10,7606,735,1339,408,713,365,278,500,253,210,0,0,70,170,'hallate_clan',400,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.74),
(815,981,20981,'Mul''s Wizard','','kaim_vanul_50_bi','36.00','60.00',67,'male','L2Monster','Mystic',40,3626,15.000,1388,2.700,40,43,30,21,20,10,7564,720,1063,483,681,356,278,0,253,0,0,0,37,160,'hallate_clan',400,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45),
(816,982,20982,'Mul''s Knight','','dre_vanul_100_bi','28.00','75.00',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,6676,636,1126,399,681,356,317,0,289,0,0,0,80,143,'hallate_clan',400,0,'Magister',NULL,0,0,0,7,10,8,0,0,0,0.35),
(817,983,20983,'Binder','','kel_mahum_champion_50_bi','19.00','48.00',73,'male','L2Monster','Fighter',40,4086,17.000,1601,3.000,40,43,30,21,20,10,10342,1064,1609,456,885,407,278,500,253,147,0,0,50,170,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.56),
(818,984,20984,'Bound Warrior','','kel_mahum_warrior','13.00','28.00',72,'male','L2Monster','Fighter',40,4013,17.000,1565,3.000,40,43,30,21,20,10,9719,987,1554,446,849,399,278,0,253,148,0,0,50,160,'tower_guard_clan',50,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(819,985,20985,'Bound Archer','','kel_mahum_archer','13.00','27.00',72,'male','L2Monster','Ranger',500,4013,17.000,1565,3.000,40,43,30,21,20,10,9647,980,3454,379,849,399,249,0,227,288,0,0,50,170,'tower_guard_clan',50,0,'Magister','',0,0,0,7,10,8,0,1500,10,0.91),
(820,986,20986,'Sairon','','doll_blader_50_bi','9.00','20.50',54,'male','L2Monster','Fighter',40,2562,13.000,955,2.400,40,43,30,21,20,10,5524,440,636,313,339,254,278,500,253,5129,5129,0,22,174,'demonic_clan',300,0,'Local','',0,0,112,7,30,4,4,0,0,0.50),
(821,987,20987,'Sairon''s Doll','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,13.000,923,2.400,40,43,30,21,20,10,5025,395,602,304,319,247,278,0,253,5129,5129,0,22,174,NULL,0,0,'Local',NULL,0,0,110,7,30,4,4,0,0,0.50),
(822,988,20988,'Sairon''s Puppet','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,13.000,923,2.400,40,43,30,21,20,10,5527,434,602,304,319,247,278,0,253,5129,5129,0,22,174,NULL,0,0,'Local',NULL,0,0,110,7,30,4,4,0,0,0.50),
(823,989,20989,'Lageos','','marsh_stakato_drone_50_bi','13.00','37.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,2749,171,238,188,112,153,278,0,253,182,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(824,990,20990,'Pageos','','marsh_stakato_soldier','10.00','25.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,2609,163,238,188,112,153,278,0,253,128,0,0,30,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(825,991,20991,'Swamp Tribe','','farhite_50_bi','24.00','48.00',45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,5139,357,377,238,188,193,278,500,253,5131,0,0,15,174,'croc_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.74),
(826,992,20992,'Swamp Alligator','','crokian','18.00','29.00',44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,4600,315,354,230,176,187,278,0,253,5128,0,0,18,174,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.78),
(827,993,20993,'Swamp Warrior','','dailaon','20.00','28.00',44,'male','L2Monster','Fighter',500,1799,11.000,648,2.100,40,43,30,21,20,10,4881,334,788,230,176,187,249,0,227,5127,0,0,18,174,'',0,0,'Magister','',0,0,0,7,10,8,0,1500,0,0.91),
(828,994,20994,'Garden Guard Leader','','doll_master_50_bi','30.00','63.00',50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,6194,466,560,253,264,226,278,500,253,0,0,0,80,174,'theeder_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(829,995,20995,'Garden Guard','','theeder','9.00','32.00',48,'male','L2Monster','Fighter',40,2091,11.000,768,2.100,40,43,30,21,20,10,4222,308,453,261,231,212,278,0,253,94,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(830,996,20996,'Spiteful Ghost of Ruins','','zombie','13.00','21.00',50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(831,997,20997,'Soldier of Grief','','unpleasant_humming','12.00','26.00',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3782,288,593,260,281,232,278,0,253,0,0,0,21,150,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.59),
(832,998,20998,'Cruel Punisher','','hungry_spirit','13.00','40.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4168,322,518,324,300,239,278,0,253,0,0,0,15,120,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(833,999,20999,'Roving Soul','','skeleton','11.00','25.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'undead_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(834,1000,21000,'Soul of Ruins','','human_ghost','8.00','22.00',54,'male','L2Monster','Mystic',40,2562,6.500,955,2.400,40,43,30,21,20,10,4325,345,578,344,339,254,278,500,253,0,0,0,80,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(835,1001,21001,'Wretched Archer','','skeleton_archer','11.00','27.00',55,'male','L2Monster','Ranger',500,2643,6.500,987,2.400,40,43,30,21,20,10,5856,473,1639,292,360,261,249,0,227,282,0,0,40,174,'undead_clan',300,1,'Magister','',0,0,0,7,10,8,0,1500,0,0.80),
(836,1002,21002,'Doom Scout','','skeleton_royal_guard','11.00','28.50',56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,5163,424,679,301,382,269,317,500,289,242,2496,0,80,174,'doom_clan',300,1,'Magister','',0,20,114,7,10,8,0,0,-6,0.52),
(837,1003,21003,'Grave Lich','','liviona','15.00','28.00',57,'male','L2Monster','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'undead_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(838,1004,21004,'Dismal Pole','','hanged_man_ripper','35.00','80.00',58,'male','L2Monster','Fighter',80,2889,6.500,1084,2.400,40,43,30,21,20,10,5239,443,828,384,428,284,237,500,216,0,0,0,55,174,'undead_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.48),
(839,1005,21005,'Grave Predator','','devastator','35.00','35.00',59,'male','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5732,490,902,326,453,291,278,500,253,0,0,0,25,174,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(840,1006,21006,'Doom Servant','','hungry_spirit','13.00','40.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,5447,473,946,335,478,299,278,500,253,0,0,0,15,174,'doom_clan',300,1,'Magister','',0,0,0,7,50,1,9,0,0,0.45),
(841,1007,21007,'Doom Guard','','hungry_spirit','13.00','40.00',61,'male','L2Monster','Fighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5844,514,992,344,505,307,278,0,253,0,0,0,15,174,'doom_clan',300,1,'Magister','',0,0,0,7,50,1,9,0,0,0.45),
(842,1008,21008,'Doom Archer','','skeleton_archer','11.00','27.00',62,'male','L2Monster','Ranger',500,3219,7.500,1217,2.700,40,43,30,21,20,10,7471,666,2308,353,532,315,249,500,227,286,0,0,40,174,'doom_clan',300,1,'Magister','',0,0,0,7,10,8,0,1500,0,0.80),
(843,1009,21009,'Doom Trooper','','skeleton_pikeman','10.00','28.00',63,'male','L2Monster','Fighter',80,3302,7.500,1251,2.700,40,43,30,21,20,10,7966,719,1267,362,560,323,237,0,216,301,0,0,50,174,'doom_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,0,0.21),
(844,1010,21010,'Doom Warrior','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,6380,584,993,371,589,331,317,0,289,71,0,0,40,174,'doom_clan',300,1,'Magister','',0,0,0,7,10,8,0,0,0,0.17),
(845,1011,21011,'Ol Mahum Van Grunt','','ol_mahum','13.50','25.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,5,0,0,50,150,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(846,1012,21012,'Magical Eye','','magical_weaver','11.00','20.00',31,'male','L2Monster','Mystic',40,1004,4.500,381,1.800,40,43,30,21,20,10,1736,96,129,161,64,118,278,500,253,0,0,0,90,150,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(847,1013,21013,'Ol Mahum Van Archer','','ol_mahum_archer','14.00','25.00',32,'male','L2Monster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1920,108,376,138,69,123,249,0,227,273,0,0,50,150,'wererat_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(848,1014,21014,'Lesser Warlike Tyrant','','grave','15.00','29.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1987,114,151,173,75,128,278,500,253,0,0,0,70,150,'kinpin_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(849,1015,21015,'Ol Mahum Van Leader','','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,2040,119,196,148,82,132,278,500,253,67,0,0,50,150,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(850,1016,21016,'Warlike Tyrant','','grave','15.00','29.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2192,130,211,154,89,137,278,0,253,0,0,0,70,174,'kinpin_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(851,1017,21017,'Fallen Orc','','ketra_orc','12.00','29.00',55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,4399,355,737,292,360,261,278,0,253,127,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(852,1018,21018,'Ancient Gargoyle','','hunter_gargoyle','25.00','65.00',56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,5536,455,642,364,382,269,278,500,253,0,0,0,100,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(853,1019,21019,'Fallen Orc Archer','','ketra_orc_archer','12.00','27.00',57,'male','L2Monster','Ranger',500,2806,6.500,1052,2.400,40,43,30,21,20,10,6093,506,1501,374,405,276,249,0,227,279,0,0,45,174,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.91),
(854,1020,21020,'Fallen Orc Shaman','','ketra_orc_shaman','10.00','23.00',58,'male','L2Monster','Priest',40,2889,6.500,1084,2.400,40,43,30,21,20,10,6898,583,710,384,428,284,278,0,253,9,0,0,10,174,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.34),
(855,1021,21021,'Sharp Talon Tiger','','saber_toothed_tiger','34.00','28.00',59,'male','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,6353,543,902,277,453,291,278,500,253,0,0,0,60,174,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.45);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(856,1022,21022,'Fallen Orc Captain','','ketra_orc_warrior','12.00','24.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,6462,561,946,285,478,299,278,500,253,160,0,0,36,174,'orc_clan',300,0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.54),
(857,1023,21023,'Sobbing Wind','','sylph','11.00','35.00',26,'female','L2Monster','Mystic',40,770,3.500,303,1.500,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,60,150,'elemental2_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(858,1024,21024,'Babbling Wind','','sylph','11.00','35.00',27,'female','L2Monster','Mystic',40,813,3.500,318,1.500,40,43,30,21,20,10,1113,57,94,138,45,102,278,0,253,0,0,0,60,150,'elemental2_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(859,1025,21025,'Giggling Wind','','sylph','11.00','35.00',28,'female','L2Monster','Mystic',40,859,3.500,334,1.500,40,43,30,21,20,10,1178,62,102,143,49,106,278,0,253,0,0,0,60,150,'elemental2_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(860,1026,21026,'Singing Wind','','sylph','11.00','35.00',29,'female','L2Monster','Mystic',40,906,3.500,349,1.500,40,43,30,21,20,10,1268,68,111,149,53,110,278,500,253,0,0,0,60,150,'elemental2_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(861,1034,21034,'Ogre','','ogre','21.00','44.00',38,'male','L2Monster','Fighter',40,1400,2.250,497,1.800,40,43,30,21,20,10,3594,224,440,141,112,153,200,500,182,98,0,0,22,174,'lizardman_clan1',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.69),
(862,1035,21035,'Catherok','','marsh_stakato_soldier','10.00','25.00',42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,2275,151,342,196,152,175,278,500,253,127,0,0,30,174,'beast_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.74),
(863,1036,21036,'Shindebarn','','magical_weaver','11.00','20.00',44,'male','L2Monster','Mystic',40,1799,11.000,648,2.100,40,43,30,21,20,10,2869,196,390,209,176,187,278,500,253,0,0,0,90,174,'porta_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.39),
(864,1037,21037,'Ossiud','','field_stalker','15.00','30.00',47,'male','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,3326,238,469,230,216,206,278,500,253,0,0,0,70,174,'torfe_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.41),
(865,1038,21038,'Liangma','','will_o_wisp','13.00','22.00',49,'male','L2Monster','Mystic',40,2168,11.000,799,2.100,40,43,30,21,20,10,2926,216,529,245,247,219,278,500,253,0,0,0,80,174,'undead_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.10),
(866,1039,21039,'Snipe Cohort','','onyx_beast','14.00','14.50',43,'male','L2Monster','Fighter',40,1728,11.000,618,2.100,40,43,30,21,20,10,3041,205,302,245,163,181,278,0,253,0,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(867,1040,21040,'Soldier of Darkness','','death_knight','12.00','30.00',49,'male','L2Minion','Fighter',40,2168,11.000,799,2.100,40,43,30,21,20,10,5077,375,581,223,247,219,278,0,253,127,0,0,27,174,'',0,1,'DRIVER','',0,0,0,7,50,1,9,0,0,0.71),
(868,1058,21058,'Beast Lord','','saber_toothed_tiger','34.00','28.00',60,'male','L2Monster','Fighter',40,3054,13.000,1150,2.400,40,43,30,21,20,10,7880,684,946,335,478,299,278,500,253,0,0,0,60,174,'beast_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(869,1059,21059,'Beast Guardian','','onyx_beast','14.00','14.50',59,'male','L2Monster','Fighter',40,2971,13.000,1117,2.400,40,43,30,21,20,10,6289,537,902,326,453,291,278,0,253,0,0,0,30,174,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(870,1060,21060,'Beast Seer','','field_stalker','15.00','30.00',59,'male','L2Monster','Fighter',40,2971,13.000,1117,2.400,40,43,30,21,20,10,6289,537,745,395,453,291,278,0,253,0,0,0,70,174,'beast_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(871,1061,21061,'Hallate''s Guardian','','kaim_vanul','24.00','40.00',69,'male','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,6396,625,1392,418,746,373,278,500,253,0,0,0,37,174,'hallate_clan',400,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45),
(872,1062,21062,'Messenger Angel','','angel','13.50','36.50',70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,0,0,1590,388,780,382,278,500,253,148,0,0,30,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(873,1063,21063,'Messenger Angel','','angel','13.50','36.50',70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,13079,1297,1194,517,780,382,278,500,253,148,0,0,30,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(874,1064,21064,'Platinum Guardian Archer','','kel_mahum_archer','13.00','27.00',71,'male','L2Monster','Ranger',500,3938,34.000,1529,3.000,40,43,30,21,20,10,8009,803,3332,371,814,390,249,500,227,288,0,0,50,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,10,8,0,1500,10,0.91),
(875,1065,21065,'Platinum Guardian Warrior','','kel_mahum_warrior','13.00','28.00',72,'male','L2Monster','Fighter',40,4013,42.500,1565,3.000,40,43,30,21,20,10,6036,613,1284,540,849,399,278,500,253,148,0,0,50,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.34),
(876,1066,21066,'Platinum Guardian Shaman','','kel_mahum_witch_doctor','13.00','25.00',73,'male','L2Monster','Priest',40,4086,42.500,1601,3.000,40,43,30,21,20,10,6529,672,1609,456,885,407,278,500,253,202,0,0,50,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.28),
(877,1067,21067,'Guardian Archangel','','angel','13.50','36.50',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(878,1068,21068,'Guardian Archangel','','angel','13.50','36.50',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,14206,1481,1664,466,921,416,278,500,253,148,0,0,30,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(879,1069,21069,'Platinum Guardian Prefect','','kel_mahum_champion','13.00','32.00',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,8909,928,1831,423,921,416,278,500,253,147,0,0,50,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.56),
(880,1070,21070,'Seal Archangel','','angel','13.50','36.50',75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,0,0,1892,432,957,425,278,500,253,148,0,0,30,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(881,1071,21071,'Seal Archangel','','angel','13.50','36.50',75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,14733,1554,1421,575,957,425,278,500,253,148,0,0,30,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(882,1072,21072,'Platinum Guardian Chief','','kel_mahum_witch_doctor','13.00','25.00',75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,6752,712,1720,475,957,425,278,500,253,202,0,0,50,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.28),
(883,1073,21073,'Guardian Warrior of Elmoreden','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,15.000,1285,2.700,40,43,30,21,20,10,7040,644,1135,371,589,331,278,0,253,84,0,0,40,174,'tower_ghost_clan',400,1,'Magister','',0,0,0,7,30,4,4,0,0,0.17),
(884,1074,21074,'Bound Shaman','','kel_mahum_witch_doctor','13.00','25.00',72,'male','L2Monster','Priest',40,4013,17.000,1565,3.000,40,43,30,21,20,10,9651,980,1284,540,849,399,278,0,253,202,0,0,50,174,'tower_guard_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.28),
(885,1075,21075,'Slaughter Bathin','','death_knight','12.00','30.00',63,'male','L2Monster','Fighter',40,3302,15.000,1251,2.700,40,43,30,21,20,10,6995,631,1086,362,560,323,278,500,253,84,0,0,27,174,'hallate_clan',200,1,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(886,1076,21076,'Bathin''s Knight','','skeleton_knight','10.00','25.00',62,'male','L2Monster','Fighter',40,3219,15.000,1217,2.700,40,43,30,21,20,10,6881,613,1038,353,532,315,278,0,253,78,0,0,40,174,'hallate_clan',200,1,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.17),
(887,1077,21077,'Bathin''s Wizard','','banshee','9.00','23.00',62,'female','L2Monster','Mystic',40,3219,15.000,1217,2.700,40,43,30,21,20,10,6669,594,1038,353,532,315,278,0,253,3939,0,0,80,174,'hallate_clan',200,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.56),
(888,1078,21078,'Magus Valac','','vale_master','12.00','40.00',70,'male','L2Monster','Mystic',40,3862,15.000,1493,2.700,40,43,30,21,20,10,8481,841,1445,427,780,382,278,500,253,198,0,0,70,174,'hallate_clan',200,0,'Magister','',0,0,0,7,50,1,9,0,0,0.74),
(889,1079,21079,'Valac''s Creature','','serpent_slave','17.00','46.00',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,7707,754,1392,418,746,373,278,0,253,150,0,0,70,174,'hallate_clan',200,0,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.46),
(890,1080,21080,'Valac''s Guardian Spirit','','shadow','10.00','30.00',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,7123,697,1006,506,746,373,317,0,289,0,0,0,80,174,'hallate_clan',200,0,'Magister',NULL,0,0,0,7,10,8,0,0,0,0.54),
(891,1081,21081,'Power Angel Amon','','angel','13.50','36.50',75,'male','L2Monster','Fighter',40,4229,17.000,1673,3.000,40,43,30,21,20,10,8887,937,1720,475,957,425,278,500,253,4700,0,0,30,174,'tower_guard_clan',200,0,'Magister','',0,0,0,7,50,1,9,0,0,0.52),
(892,1082,21082,'Amon''s Captain of the Guards','','kel_mahum_champion','13.00','32.00',74,'male','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8546,891,1664,466,921,416,278,0,253,150,0,0,50,174,'tower_guard_clan',200,0,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.56),
(893,1083,21083,'Amon''s Spirits','','pixy','5.00','25.00',74,'female','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,10096,1052,1664,466,921,416,278,0,253,0,0,0,80,174,'tower_guard_clan',200,0,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.72),
(894,1084,21084,'Bloody Lady','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4112,357,946,335,478,299,278,500,253,0,0,0,80,174,'bloody_clan',400,0,'stiff_l2wh','',0,0,0,7,30,4,4,0,0,0.50),
(895,1085,21085,'Bloody Sniper','','fiend_archer','17.00','55.00',71,'male','L2Monster','Ranger',500,3938,42.500,1529,3.000,40,43,30,21,20,10,5574,559,3332,437,814,390,249,500,227,0,0,0,70,174,'bloody_clan',400,0,'Local','',0,0,0,7,10,8,0,1500,0,0.76),
(896,1086,21086,'Bloody Liviona','','liviona','15.00','28.00',72,'male','L2Monster','Fighter',40,4013,42.500,1565,3.000,40,43,30,21,20,10,5566,565,1413,491,849,399,278,500,253,0,0,0,80,174,'bloody_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(897,1087,21087,'Bloody Knight','','death_knight','12.00','30.00',73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,8932,919,1770,415,885,407,278,500,253,137,0,0,27,174,'bloody_clan',400,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(898,1088,21088,'Bloody Banshee','','banshee','9.00','23.00',74,'female','L2Monster','Mystic',40,4158,42.500,1637,3.000,40,43,30,21,20,10,5879,612,1513,512,921,416,278,500,253,3939,0,0,80,174,'bloody_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(899,1089,21089,'Bloody Lord','','karik','25.00','90.00',75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,6817,719,1720,475,957,425,278,500,253,0,0,0,37,174,'bloody_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(900,1090,21090,'Bloody Guardian','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,8734,921,1720,475,957,425,278,500,253,1472,0,0,100,174,'bloody_clan',400,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(901,1091,21091,'Bloody Keeper','','kaim_vanul','24.00','40.00',74,'male','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8831,920,1513,512,921,416,278,0,253,0,0,0,37,174,'bloody_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(902,1092,21092,'Bloody Mystic','','banshee','9.00','23.00',74,'female','L2Monster','Mystic',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8627,899,1513,512,921,416,278,0,253,3939,0,0,80,174,'bloody_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(903,1093,21093,'Ratman Sub Chieftain','','wererat','14.00','25.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,691,31,58,70,21,73,278,400,253,216,0,0,80,150,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.61),
(904,1094,21094,'Ratman Chieftain','','wererat','14.00','25.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,712,32,52,104,23,76,278,0,253,3,0,0,80,155,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(905,1095,21095,'Giant Poison Bee','','giant_bee','8.00','24.50',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,840,39,55,83,25,80,317,0,289,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,10,8,0,0,10,0.50),
(906,1096,21096,'Cloudy Beast','','onyx_beast','14.00','14.50',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,837,40,68,87,28,83,278,400,253,0,0,0,30,140,'beast_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.24),
(907,1097,21097,'Young Araneid','','poison_spider','27.00','25.50',23,'male','L2Monster','Mystic',40,648,3.500,257,1.500,40,43,30,21,20,10,985,48,75,107,31,87,278,400,253,0,0,0,60,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(908,1098,21098,'Plain Grizzly','','grizzly','21.00','40.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,81,111,34,90,278,0,253,0,0,0,40,115,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(909,1099,21099,'Cloudy Beast Turen','','onyx_beast','14.00','14.50',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1012,51,88,98,37,94,278,400,253,0,0,0,30,145,'beast_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.24),
(910,1100,21100,'Langk Lizardman Sentinel','','virud_lizardman','10.00','23.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,691,31,53,90,21,73,278,500,253,2,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(911,1101,21101,'Langk Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',24,'male','L2Monster','Priest',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,81,94,34,90,278,0,253,6,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(912,1102,21102,'Watchman of the Plains','','magical_weaver','11.00','20.00',30,'male','L2Monster','Mystic',40,954,3.500,365,1.500,40,43,30,21,20,10,1335,73,132,119,58,114,278,500,253,0,0,0,90,160,'monster_eye_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.39),
(913,1103,21103,'Roughly Hewn Rock Golem','','stone_golem_bi','20.00','40.30',31,'male','L2Monster','Mystic',40,1004,4.500,381,1.800,40,43,30,21,20,10,1397,78,142,146,64,118,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(914,1104,21104,'Delu Lizardman Supplier','','virud_lizardman','10.00','23.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1754,99,134,151,69,123,317,0,289,223,0,0,43,135,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.48),
(915,1105,21105,'Delu Lizardman Special Agent','','virud_lizardman_scout','10.00','22.00',33,'male','L2Monster','Ranger',500,1109,4.500,413,1.800,40,43,30,21,20,10,2022,116,406,143,75,128,249,0,227,2507,0,0,43,135,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.72),
(916,1106,21106,'Cursed Seer','','magical_weaver','11.00','20.00',34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1714,100,178,138,82,132,278,500,253,0,0,0,90,160,'monster_eye_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.39),
(917,1107,21107,'Delu Lizardman Commander','','virud_lizardman_warrior','12.00','30.00',35,'male','L2Monster','Fighter',40,1220,9.000,446,1.800,40,43,30,21,20,10,1814,107,192,169,89,137,278,0,253,93,0,0,52,135,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(918,1108,21108,'Glow Wisp','','will_o_wisp','13.00','22.00',67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,1169,439,681,356,278,0,253,0,0,0,80,160,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.10),
(919,1109,21109,'Hames Orc Scout','','ketra_orc','12.00','29.00',68,'male','L2Monster','Ranger',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8082,781,1065,382,713,365,317,0,289,229,0,0,45,185,'orc_clan',400,0,'Local','',0,0,0,7,10,8,0,0,10,0.46),
(920,1110,21110,'Marsh Predator','','devastator','35.00','35.00',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6890,674,1265,460,746,373,278,0,253,0,0,0,25,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(921,1111,21111,'Lava Wyrm','','wyrm','29.00','72.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,7197,714,1314,470,780,382,278,500,253,0,0,0,70,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(922,1112,21112,'Hames Orc Footman','','ketra_orc','12.00','29.00',71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,8724,875,1363,481,814,390,278,0,253,233,110,0,45,180,'orc_clan',300,0,'Local','',0,20,150,7,30,4,4,0,-6,0.46),
(923,1113,21113,'Hames Orc Sniper','','ketra_orc_archer','12.00','27.00',72,'male','L2Monster','Ranger',500,4013,8.500,1565,3.000,40,43,30,21,20,10,9722,988,3140,417,849,399,249,0,227,287,0,0,45,160,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.91),
(924,1114,21114,'Cursed Guardian','','death_blader','15.00','45.00',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9231,950,1463,426,885,407,278,0,253,1472,0,0,100,175,'',0,1,'Local','',0,0,0,7,30,4,4,0,10,0.45),
(925,1115,21115,'Hames Orc Shaman','','ketra_orc_shaman','10.00','23.00',74,'male','L2Monster','Priest',40,4158,8.500,1637,3.000,40,43,30,21,20,10,8043,838,1513,435,921,416,278,0,253,186,0,0,10,145,'orc_clan',400,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(926,1116,21116,'Hames Orc Overlord','','ketra_orc_warrior','12.00','24.00',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,12699,1340,1720,475,957,425,278,500,253,75,103,0,36,175,'orc_clan',500,0,'Local','',0,20,159,7,30,4,4,0,-6,0.54),
(927,1117,21117,'Kasha Imp','','imp_bi','10.00','30.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,678,30,53,77,21,73,278,0,253,0,0,0,60,85,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.34),
(928,1118,21118,'Baar Dre Vanul','','dre_vanul','14.00','36.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,726,32,57,94,23,76,278,400,253,0,0,0,80,85,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(929,1119,21119,'Hobgoblin','','hobgoblin','12.00','24.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,4,0,0,45,110,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(930,1120,21120,'Kasha Imp Turen','','imp_bi','10.00','30.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,996,47,75,79,28,83,278,400,253,0,0,0,60,85,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.34),
(931,1121,21121,'Kasha Dire Wolf','','dire_wolf','13.00','11.00',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,75,91,31,87,278,400,253,0,0,0,24,135,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.39),
(932,1122,21122,'Kasha Bugbear','','bugbear','17.00','35.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,81,111,34,90,278,400,253,169,0,0,55,130,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(933,1123,21123,'Baar Dre Vanul Destroyer','','dre_vanul','14.00','36.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1267,63,97,105,37,94,278,400,253,0,0,0,80,85,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(934,1124,21124,'Red Eye Barbed Bat','','vampire_bat','10.00','33.50',18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,48,73,19,70,278,0,253,0,0,0,60,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(935,1125,21125,'Northern Trimden','','poison_spider','27.00','25.50',19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,684,31,53,90,21,73,278,400,253,0,0,0,60,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(936,1126,21126,'Kerope Werewolf','','werewolf_bi','11.00','29.70',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,712,32,57,80,23,76,278,0,253,0,0,0,50,125,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.43),
(937,1127,21127,'Northern Goblin','','northern_goblin','21.00','20.00',21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,152,0,0,30,120,'goblin_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(938,1128,21128,'Spine Golem','','stone_golem_bi','20.00','40.30',22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,68,102,28,83,278,0,253,0,0,0,23,23,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(939,1129,21129,'Kerope Werewolf Chief','','werewolf_bi','11.00','29.70',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,82,82,31,87,278,400,253,0,0,0,50,140,'werewolf_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.43),
(940,1130,21130,'Northern Goblin Leader','','northern_goblin','21.00','20.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,81,111,34,90,278,400,253,66,102,0,30,125,'goblin_clan',300,0,'Local','',0,20,49,7,50,1,9,0,-6,0.45),
(941,1131,21131,'Enchanted Spine Golem','','stone_golem_bi','20.00','40.30',25,'male','L2Monster','Mystic',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,97,105,37,94,278,0,253,0,0,0,23,29,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(942,1132,21132,'Underground Kobold','','kobold','10.00','15.00',24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,779,38,81,94,34,90,278,0,253,0,0,0,47,110,'kobold_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(943,1133,21133,'Dead Pit Skeleton Archer','','skeleton_archer','11.00','27.00',25,'male','L2Monster','Ranger',500,728,3.500,287,1.500,40,43,30,21,20,10,851,43,197,98,37,94,249,0,227,274,0,0,40,130,'undead_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(944,1134,21134,'Dead Pit Spartoi','','spartoi','11.00','27.00',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,898,45,96,102,41,98,278,400,253,219,0,0,60,145,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.30),
(945,1135,21135,'Underground Kobold Warrior','','kobold','10.00','15.00',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1103,56,114,114,45,102,278,0,253,0,0,0,47,115,'kobold_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(946,1136,21136,'Dead Pit Horror','','dark_horror','20.00','35.00',28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,981,52,113,110,49,106,278,0,253,0,0,0,100,100,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(947,1137,21137,'Iron Ore Golem','','iron_golem','18.00','34.00',29,'male','L2Monster','Mystic',40,906,3.500,349,1.500,40,43,30,21,20,10,1057,57,111,149,53,110,278,400,253,0,0,0,20,21,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(948,1138,21138,'Greedy Geist','','hungry_spirit','13.00','40.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1134,62,132,119,58,114,278,0,253,0,0,0,15,150,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,10,0.45),
(949,1139,21139,'Catacomb Barbed Bat','','vampire_bat','10.00','33.50',23,'male','L2Monster','Mystic',40,648,14.000,257,1.500,40,43,30,21,20,10,655,31,75,91,31,87,278,500,253,0,0,0,60,130,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(950,1140,21140,'Catacomb Wisp','','monster_eye','21.00','43.00',26,'male','L2Monster','Mystic',40,770,14.000,303,1.500,40,43,30,21,20,10,788,39,96,102,41,98,278,500,253,0,0,0,80,120,'c_dungeon_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.10),
(951,1141,21141,'Catacomb Serpent','','onyx_beast','14.00','14.50',28,'male','L2Monster','Fighter',40,859,14.000,334,1.500,40,43,30,21,20,10,926,48,113,110,49,106,278,500,253,73,0,0,70,130,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.46),
(952,1142,21142,'Grave Keeper Spartoi','','spartoi','11.00','27.00',29,'male','L2Monster','Fighter',40,906,14.000,349,1.500,40,43,30,21,20,10,927,49,111,149,53,110,278,500,253,221,0,0,60,140,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(953,1143,21143,'Catacomb Scavenger Bat','','vampire_bat','10.00','33.50',31,'male','L2Monster','Fighter',40,1004,18.000,381,1.800,40,43,30,21,20,10,1042,57,142,124,64,118,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(954,1144,21144,'Catacomb Shadow','','field_stalker','15.00','30.00',34,'male','L2Monster','Mystic',40,1164,18.000,430,1.800,40,43,30,21,20,10,1254,73,178,138,82,132,278,500,253,0,0,0,80,130,'c_dungeon_clan',300,0,'Magister','',0,0,0,7,50,1,9,0,10,0.54),
(955,1145,21145,'Catacomb Stakato Soldier','','blade_stakato_soldier','15.00','38.00',38,'male','L2Monster','Fighter',40,1400,18.000,497,1.800,40,43,30,21,20,10,1611,100,238,160,112,153,278,500,253,232,0,0,25,150,'c_dungeon_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,10,0.74),
(956,1146,21146,'Grave Keeper Dark Horror','','dark_horror','20.00','35.00',40,'male','L2Monster','Fighter',40,1527,18.000,531,1.800,40,43,30,21,20,10,1735,112,248,222,131,164,278,500,253,0,0,0,100,160,'c_dungeon_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,0,0.37),
(957,1147,21147,'Catacomb Gargoyle','','gargoyle','16.00','50.00',43,'male','L2Monster','Fighter',40,1728,22.000,618,2.100,40,43,30,21,20,10,2114,143,332,223,163,181,278,500,253,0,0,0,140,170,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(958,1148,21148,'Catacomb Liviona','','liviona','15.00','28.00',44,'male','L2Monster','Fighter',40,1799,22.000,648,2.100,40,43,30,21,20,10,2100,143,354,196,176,187,278,500,253,0,0,0,80,140,'c_dungeon_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(959,1149,21149,'Decayed Ancient Pikeman','','skeleton_pikeman','10.00','28.00',46,'male','L2Monster','Fighter',40,1943,22.000,707,2.100,40,43,30,21,20,10,2419,171,401,245,202,199,278,500,253,96,0,0,50,170,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(960,1150,21150,'Decayed Ancient Soldier','','skeleton_knight','10.00','25.00',49,'male','L2Monster','Fighter',40,2168,22.000,799,2.100,40,43,30,21,20,10,2745,203,480,270,247,219,278,500,253,125,0,0,40,160,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(961,1151,21151,'Decayed Ancient Knight','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,22.000,830,2.100,40,43,30,21,20,10,2858,215,509,278,264,226,278,500,253,227,0,0,80,170,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(962,1152,21152,'Purgatory Wisp','','monster_eye','21.00','43.00',53,'male','L2Monster','Mystic',40,2481,26.000,923,2.400,40,43,30,21,20,10,3047,239,602,258,319,247,278,500,253,0,0,0,80,150,'c_dungeon_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.10),
(963,1153,21153,'Purgatory Serpent','','onyx_beast','14.00','14.50',56,'male','L2Monster','Fighter',40,2724,26.000,1019,2.400,40,43,30,21,20,10,3586,294,706,281,382,269,278,500,253,73,0,0,70,175,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.46),
(964,1154,21154,'Hell Keeper Medusa','','spartoi','11.00','27.00',58,'female','L2Monster','Mystic',40,2889,26.000,1084,2.400,40,43,30,21,20,10,3753,317,710,384,428,284,278,500,253,0,0,0,50,165,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(965,1155,21155,'Purgatory Conjurer','','vampire_bat','10.00','33.50',59,'male','L2Monster','Mystic',40,2971,26.000,1117,2.400,40,43,30,21,20,10,3776,322,820,305,453,291,278,500,253,0,0,0,60,175,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(966,1156,21156,'Purgatory Shadow','','field_stalker','15.00','30.00',61,'male','L2Monster','Mystic',40,3137,30.000,1184,2.700,40,43,30,21,20,10,4036,355,901,321,505,307,278,500,253,0,0,0,80,155,'c_dungeon_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.54),
(967,1157,21157,'Purgatory Tarantula','','poison_spider','27.00','25.50',64,'male','L2Monster','Mystic',40,3384,30.000,1285,2.700,40,43,30,21,20,10,4569,418,1031,347,589,331,278,500,253,0,0,0,60,175,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.65),
(968,1158,21158,'Hell Keeper Crimson Doll','','dark_horror','20.00','35.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5133,488,1063,483,681,356,278,500,253,0,0,0,60,180,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.67),
(969,1159,21159,'Purgatory Gargoyle','','gargoyle','16.00','50.00',68,'male','L2Monster','Fighter',40,3706,30.000,1423,2.700,40,43,30,21,20,10,5287,510,1217,449,713,365,278,500,253,0,0,0,140,175,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(970,1160,21160,'Purgatory Liviona','','liviona','15.00','28.00',71,'male','L2Monster','Fighter',40,3938,34.000,1529,3.000,40,43,30,21,20,10,5468,548,1363,408,814,390,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(971,1161,21161,'Lesser Ancient Soldier','','lesser_giant','21.00','44.00',73,'female','L2Monster','Fighter',40,4086,34.000,1601,3.000,40,43,30,21,20,10,5945,611,1463,502,885,407,278,500,253,0,0,0,50,180,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(972,1162,21162,'Lesser Ancient Scout','','lesser_giant_shooter','21.00','44.00',74,'male','L2Monster','Ranger',40,4158,34.000,1637,3.000,40,43,30,21,20,10,5940,619,1513,512,921,416,278,500,253,135,0,0,25,160,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(973,1163,21163,'Lesser Ancient Shaman','','silhouette','8.00','23.00',76,'female','L2Monster','Priest',40,4297,34.000,1710,3.000,40,43,30,21,20,10,6265,669,1614,454,994,433,278,500,253,0,0,0,80,200,'c_dungeon_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,10,0.54),
(974,1164,21164,'Guardian Spirit of Ancient Holy Ground','','death_lord','21.00','40.00',79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7136,791,1765,566,1107,459,278,500,253,78,0,0,40,190,'c_dungeon_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,0,0.50),
(975,1165,21165,'Lesser Ancient Warrior','','shadeless','7.00','28.00',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'c_dungeon_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(976,1166,21166,'Lith Scout','','temple_guard_a_20_sm','12.00','33.60',21,'male','L2Monster','Fighter',40,575,14.000,227,1.500,40,43,30,21,20,10,594,27,66,69,25,80,317,0,289,5795,0,0,53,130,'c_dungeon_clan',400,0,'Local','',0,0,0,7,10,8,0,0,10,0.48),
(977,1167,21167,'Lith Witch','','temple_savant_a_20_sm','8.00','32.00',24,'male','L2Monster','Mystic',40,687,14.000,272,1.500,40,43,30,21,20,10,690,34,98,92,34,90,278,0,253,5797,0,0,25,110,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(978,1168,21168,'Lith Warrior','','temple_guard_b_20_sm','12.00','33.60',27,'male','L2Monster','Fighter',40,813,14.000,318,1.500,40,43,30,21,20,10,855,43,126,103,45,102,278,0,253,5796,0,0,53,130,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(979,1169,21169,'Lith Guard','','temple_guard_a','15.00','42.00',30,'male','L2Monster','Fighter',40,954,14.000,365,1.500,40,43,30,21,20,10,1133,62,140,99,58,114,317,0,289,5795,0,0,53,140,'c_dungeon_clan',400,0,'Local','',0,0,0,7,10,8,0,0,10,0.48),
(980,1170,21170,'Lith Medium','','temple_savant_a','10.00','40.00',33,'male','L2Monster','Fighter',40,1109,18.000,413,1.800,40,43,30,21,20,10,1307,75,201,130,75,128,278,0,253,5797,0,0,25,120,'c_dungeon_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.48),
(981,1171,21171,'Lith Overlord','','temple_guard_b','15.00','42.00',36,'male','L2Monster','Fighter',40,1279,18.000,463,1.800,40,43,30,21,20,10,1669,101,250,145,96,142,278,0,253,5796,0,0,53,140,'c_dungeon_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.48),
(982,1172,21172,'Lith Patrolman','','temple_guard_a','15.00','42.00',39,'male','L2Monster','Fighter',40,1462,18.000,514,1.800,40,43,30,21,20,10,1972,125,270,137,121,158,317,0,289,5795,0,0,53,150,'c_dungeon_clan',400,0,'Magister','',0,0,0,7,10,8,0,0,10,0.48),
(983,1173,21173,'Lith Shaman','','temple_savant_a','10.00','40.00',42,'male','L2Monster','Priest',40,1660,22.000,589,2.100,40,43,30,21,20,10,2118,141,377,178,152,175,278,0,253,5798,0,0,25,130,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(984,1174,21174,'Lith Commander','','temple_guard_b','15.00','42.00',45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2731,190,457,196,188,193,278,0,253,5796,0,0,53,150,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(985,1175,21175,'Lilim Butcher','','lilim_assassin_10_sm','11.00','36.00',48,'male','L2Monster','Ranger',40,2091,22.000,768,2.100,40,43,30,21,20,10,3093,226,480,183,231,212,317,0,289,232,232,0,36,170,'c_dungeon_clan',400,0,'Local','',0,0,83,7,10,8,0,0,10,0.46),
(986,1176,21176,'Lilim Magus','','lilim_wizard_10_sm','8.00','30.60',51,'female','L2Monster','Mystic',40,2323,26.000,861,2.400,40,43,30,21,20,10,3123,238,652,237,281,232,278,0,253,0,0,0,50,140,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(987,1177,21177,'Lilim Knight Errant','','lilim_knight_10_sm','11.00','45.00',54,'male','L2Monster','Fighter',40,2562,26.000,955,2.400,40,43,30,21,20,10,4385,349,769,258,339,254,278,0,253,5800,5799,0,56,170,'c_dungeon_clan',400,0,'Local','',0,20,109,7,30,4,4,0,-6,0.46),
(988,1178,21178,'Lilim Marauder','','lilim_assassin_10_sm','11.00','36.00',57,'male','L2Monster','Ranger',40,2806,26.000,1052,2.400,40,43,30,21,20,10,4697,390,786,239,405,276,317,0,289,229,229,0,36,180,'c_dungeon_clan',400,0,'Local','',0,0,102,7,10,8,0,0,10,0.46),
(989,1179,21179,'Lilim Priest','','lilim_wizard_10_sm','8.00','30.60',60,'female','L2Monster','Priest',40,3054,26.000,1150,2.400,40,43,30,21,20,10,4322,375,1041,304,478,299,278,0,253,0,0,0,50,160,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(990,1180,21180,'Lilim Knight','','lilim_knight_10_sm','11.00','45.00',63,'male','L2Monster','Fighter',40,3302,30.000,1251,2.700,40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,253,5800,5799,0,56,180,'c_dungeon_clan',400,0,'Local','',0,20,131,7,30,4,4,0,-6,0.46),
(991,1181,21181,'Lilim Assassin','','lilim_assassin_10_bi','13.00','44.00',66,'male','L2Monster','Fighter',40,3546,30.000,1353,2.700,40,43,30,21,20,10,6868,646,1189,301,649,348,317,0,289,234,234,0,36,190,'c_dungeon_clan',400,0,'Local','',0,0,121,7,10,8,0,0,10,0.46),
(992,1182,21182,'Lilim Soldier','','lilim_wizard_10_bi','10.00','37.50',69,'female','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,5717,559,1531,380,746,373,278,0,253,0,0,0,50,170,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(993,1183,21183,'Lilim Knight Banneret','','lilim_knight_10_bi','13.00','55.00',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,253,5800,5799,0,56,190,'c_dungeon_clan',400,0,'Local','',0,20,152,7,30,4,4,0,-6,0.46),
(994,1184,21184,'Lilim Slayer','','lilim_assassin_10_bi','13.00','44.00',75,'male','L2Monster','Ranger',40,4229,34.000,1673,3.000,40,43,30,21,20,10,8869,935,1655,367,957,425,317,0,289,236,236,0,36,200,'c_dungeon_clan',400,0,'Local','',0,0,140,7,10,8,0,0,10,0.46),
(995,1185,21185,'Lilim Great Mystic','','lilim_wizard_10_bi','10.00','37.50',78,'female','L2Monster','Mystic',40,4428,34.000,1784,3.000,40,43,30,21,20,10,7305,799,2075,459,1069,451,278,0,253,0,0,0,50,180,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.50),
(996,1186,21186,'Lilim Court Knight','','lilim_knight_10_bi','13.00','55.00',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,253,5800,5799,0,56,200,'c_dungeon_clan',400,0,'Local','',0,20,170,7,30,4,4,0,-6,0.46),
(997,1187,21187,'Gigant Slave','','tomb_guard_a_20_sm','8.00','32.00',21,'male','L2Monster','Fighter',40,575,14.000,227,1.500,40,43,30,21,20,10,594,27,76,69,25,80,278,0,253,5791,0,0,49,130,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(998,1188,21188,'Gigant Acolyte','','tomb_savant_a_20_sm','8.00','32.00',24,'male','L2Monster','Fighter',40,687,14.000,272,1.500,40,43,30,21,20,10,690,34,98,92,34,90,278,0,253,5793,0,0,49,110,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(999,1189,21189,'Gigant Overseer','','tomb_guard_b_20_sm','12.00','34.00',27,'male','L2Monster','Fighter',40,813,14.000,318,1.500,40,43,30,21,20,10,855,43,126,103,45,102,278,0,253,5792,0,0,49,130,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1000,1190,21190,'Gigant Footman','','tomb_guard_a','10.00','40.00',30,'male','L2Monster','Fighter',40,954,14.000,365,1.500,40,43,30,21,20,10,1133,62,160,99,58,114,278,0,253,5791,0,0,49,140,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1001,1191,21191,'Gigant Cleric','','tomb_savant_a','10.00','40.00',33,'male','L2Monster','Priest',40,1109,18.000,413,1.800,40,43,30,21,20,10,1307,75,201,130,75,128,278,0,253,5793,0,0,49,120,'c_dungeon_clan',400,0,'Magister','',0,0,0,7,50,1,9,0,0,0.48),
(1002,1192,21192,'Gigant Officer','','tomb_guard_b','15.00','42.50',36,'male','L2Monster','Fighter',40,1279,18.000,463,1.800,40,43,30,21,20,10,1669,101,250,145,96,142,278,0,253,5792,0,0,49,140,'c_dungeon_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,0,0.50),
(1003,1193,21193,'Gigant Raider','','tomb_guard_a','10.00','40.00',39,'male','L2Monster','Fighter',40,1462,18.000,514,1.800,40,43,30,21,20,10,1972,125,308,137,121,158,278,0,253,5791,0,0,49,150,'c_dungeon_clan',400,0,'Magister','',0,0,0,7,30,4,4,0,10,0.50),
(1004,1194,21194,'Gigant Confessor','','tomb_savant_a','10.00','40.00',42,'male','L2Monster','Fighter',40,1660,22.000,589,2.100,40,43,30,21,20,10,2118,141,377,178,152,175,278,0,253,5794,0,0,49,130,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1005,1195,21195,'Gigant Commander','','tomb_guard_b','15.00','42.50',45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2731,190,457,196,188,193,278,0,253,5792,0,0,49,150,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1006,1196,21196,'Nephilim Sentinel','','nephilim_slayer_10_sm','11.00','32.40',48,'male','L2Monster','Fighter',40,2091,22.000,768,2.100,40,43,30,21,20,10,3093,226,548,183,231,212,278,0,253,0,0,0,65,170,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.63),
(1007,1197,21197,'Nephilim Priest','','nephilim_priest_10_sm','21.00','36.50',51,'male','L2Monster','Priest',40,2323,26.000,861,2.400,40,43,30,21,20,10,3391,258,652,237,281,232,278,0,253,0,0,0,50,140,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1008,1198,21198,'Nephilim Swordsman','','nephilim_lord_10_sm','9.00','37.40',54,'male','L2Monster','Fighter',40,2562,26.000,955,2.400,40,43,30,21,20,10,4385,349,769,258,339,254,278,0,253,0,0,0,65,170,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(1009,1199,21199,'Nephilim Guard','','nephilim_slayer_10_sm','11.00','32.40',57,'male','L2Monster','Fighter',40,2806,26.000,1052,2.400,40,43,30,21,20,10,4697,390,899,239,405,276,278,0,253,0,0,0,65,180,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.63),
(1010,1200,21200,'Nephilim Bishop','','nephilim_priest_10_sm','21.00','36.50',60,'male','L2Monster','Priest',40,3054,26.000,1150,2.400,40,43,30,21,20,10,4694,407,1041,304,478,299,278,0,253,0,0,0,50,160,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1011,1201,21201,'Nephilim Centurion','','nephilim_lord_10_sm','9.00','37.40',63,'male','L2Monster','Fighter',40,3302,30.000,1251,2.700,40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,253,0,0,0,65,180,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(1012,1202,21202,'Nephilim Scout','','nephilim_slayer_10_bi','13.00','39.60',66,'male','L2Monster','Ranger',40,3546,30.000,1353,2.700,40,43,30,21,20,10,6868,646,1358,301,649,348,278,0,253,0,0,0,65,190,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.63),
(1013,1203,21203,'Nephilim Archbishop','','nephilim_priest_10_bi','21.00','44.00',69,'male','L2Monster','Priest',40,3784,30.000,1458,2.700,40,43,30,21,20,10,6208,607,1531,380,746,373,278,0,253,0,0,0,50,170,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1014,1204,21204,'Nephilim Praetorian','','nephilim_lord_10_bi','11.00','45.30',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,253,0,0,0,65,190,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(1015,1205,21205,'Nephilim Royal Guard','','nephilim_slayer_10_bi','13.00','39.60',75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,8869,935,1892,367,957,425,278,0,253,0,0,0,65,200,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.63),
(1016,1206,21206,'Nephilim Cardinal','','nephilim_priest_10_bi','21.00','44.00',78,'male','L2Monster','Priest',40,4428,34.000,1784,3.000,40,43,30,21,20,10,7933,868,2075,459,1069,451,278,0,253,0,0,0,50,180,'c_dungeon_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1017,1207,21207,'Nephilim Commander','','nephilim_lord_10_bi','11.00','45.30',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,253,0,0,0,65,200,'c_dungeon_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(1018,1208,21208,'Hallowed Watchman','','skeleton','11.00','25.00',20,'male','L2Monster','Fighter',40,541,10.000,213,1.200,40,43,30,21,20,10,521,23,57,94,23,76,278,0,253,216,111,0,60,130,'c_dungeon_clan',300,1,'Local','',0,20,43,7,30,4,4,0,-6,0.30);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1019,1209,21209,'Hallowed Seer','','binding','12.00','21.00',22,'male','L2Monster','Fighter',40,611,14.000,242,1.500,40,43,30,21,20,10,612,29,68,87,28,83,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,1,'Local','',0,0,0,7,50,1,9,0,10,0.54),
(1020,1210,21210,'Vault Guardian','','dre_vanul','14.00','36.00',25,'male','L2Monster','Fighter',40,728,14.000,287,1.500,40,43,30,21,20,10,780,39,88,116,37,94,278,500,253,0,0,0,60,130,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1021,1211,21211,'Vault Seer','','succubus','10.00','36.00',27,'female','L2Monster','Mystic',40,813,14.000,318,1.500,40,43,30,21,20,10,830,42,104,106,45,102,278,500,253,0,0,0,60,110,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.84),
(1022,1212,21212,'Hallowed Sentinel','','skeleton_bi','11.00','31.00',30,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1023,1213,21213,'Hallowed Monk','','binding_20_bi','14.00','25.30',32,'male','L2Monster','Fighter',40,1056,18.000,397,1.800,40,43,30,21,20,10,1110,62,154,129,69,123,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,1,'Magister','',0,0,0,7,50,1,9,0,10,0.54),
(1024,1214,21214,'Vault Sentinel','','dre_vanul_bi','14.00','43.20',35,'male','L2Monster','Fighter',40,1220,18.000,446,1.800,40,43,30,21,20,10,1400,83,192,169,89,137,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(1025,1215,21215,'Vault Monk','','succubus_bi','10.00','43.20',37,'female','L2Monster','Mystic',40,1338,18.000,480,1.800,40,43,30,21,20,10,1485,91,222,154,104,147,278,500,253,0,0,0,60,120,'c_dungeon_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,10,0.84),
(1026,1216,21216,'Overlord of the Holy Lands','','skeleton_knight_20_bi','12.00','30.50',40,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1027,1217,21217,'Hallowed Priest','','banshee_20_bi','10.00','27.50',42,'female','L2Monster','Priest',40,1660,22.000,589,2.100,40,43,30,21,20,10,1913,127,311,183,152,175,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1028,1218,21218,'Vault Overlord','','death_blader_10_sm','14.00','40.50',45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2315,161,415,216,188,193,278,500,253,297,0,0,100,160,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1029,1219,21219,'Vault Priest','','bloody_queen_10_sm','13.00','38.00',47,'female','L2Monster','Priest',40,2016,22.000,738,2.100,40,43,30,21,20,10,2396,171,427,215,216,206,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1030,1220,21220,'Sepulcher Archon','','skeleton_knight_30_bi','13.00','33.00',50,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1031,1221,21221,'Sepulcher Inquisitor','','banshee_30_bi','11.00','30.00',52,'female','L2Monster','Mystic',40,2402,26.000,892,2.400,40,43,30,21,20,10,2933,227,570,251,300,239,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1032,1222,21222,'Sepulcher Archon','','death_blader_10_bi','16.00','49.50',55,'male','L2Monster','Fighter',40,2643,26.000,987,2.400,40,43,30,21,20,10,3459,279,737,292,360,261,278,500,253,298,0,0,100,170,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1033,1223,21223,'Sepulcher Inquisitor','','bloody_queen_10_bi','15.00','46.00',57,'female','L2Monster','Mystic',40,2806,26.000,1052,2.400,40,43,30,21,20,10,3524,293,743,289,405,276,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1034,1224,21224,'Sepulcher Guardian','','skeleton_royal_guard_20_bi','13.00','34.50',60,'male','L2Monster','Fighter',40,3054,26.000,1150,2.400,40,43,30,21,20,10,3828,332,828,335,478,299,317,0,289,233,0,0,80,190,'c_dungeon_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1035,1225,21225,'Sepulcher Sage','','vale_master_10_bi','13.00','44.00',62,'male','L2Monster','Fighter',40,3219,30.000,1217,2.700,40,43,30,21,20,10,4169,371,944,330,532,315,278,500,253,311,0,0,70,160,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1036,1226,21226,'Sepulcher Guardian','','death_knight','12.00','30.00',65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,253,0,0,0,27,190,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(1037,1227,21227,'Sepulcher Sage','','doll_master','20.00','42.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1038,1228,21228,'Sepulcher Guard ','','skeleton_royal_guard_30_bi','14.00','37.50',70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,289,236,0,0,80,200,'c_dungeon_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1039,1229,21229,'Sepulcher Preacher','','vale_master_30_bi','15.00','52.00',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,253,326,0,0,70,165,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1040,1230,21230,'Sepulcher Guard','','death_knight','12.00','30.00',75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,253,0,0,0,27,200,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(1041,1231,21231,'Sepulcher Preacher','','doll_master_20_bi','24.00','50.40',77,'male','L2Monster','Fighter',40,4364,34.000,1747,3.000,40,43,30,21,20,10,6431,696,1664,463,1031,442,278,500,253,0,0,0,80,165,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1042,1232,21232,'Barrow Guardian','','skeleton','11.00','25.00',20,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1043,1233,21233,'Barrow Seer','','binding','12.00','21.00',22,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1044,1234,21234,'Grave Guardian','','imp','10.00','24.00',25,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1045,1235,21235,'Grave Seer','','succubus','10.00','36.00',27,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1046,1236,21236,'Barrow Sentinel','','skeleton_bi','11.00','31.00',30,'male','L2Monster','Fighter',40,954,14.000,365,1.500,40,43,30,21,20,10,957,52,132,140,58,114,278,0,253,69,0,0,60,140,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(1047,1237,21237,'Barrow Monk','','binding_20_bi','14.00','25.30',32,'male','L2Monster','Fighter',40,1056,18.000,397,1.800,40,43,30,21,20,10,1110,62,154,129,69,123,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,1,'Local','',0,0,0,7,50,1,9,0,10,0.54),
(1048,1238,21238,'Grave Sentinel','','imp_bi','10.00','30.00',35,'male','L2Monster','Fighter',40,1220,18.000,446,1.800,40,43,30,21,20,10,1400,83,192,169,89,137,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1049,1239,21239,'Grave Monk','','succubus_bi','10.00','43.20',37,'female','L2Monster','Mystic',40,1338,18.000,480,1.800,40,43,30,21,20,10,1485,91,222,154,104,147,278,500,253,0,0,0,60,120,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.84),
(1050,1240,21240,'Barrow Overlord','','skeleton_knight_20_bi','12.00','30.50',40,'male','L2Monster','Fighter',40,1527,18.000,531,1.800,40,43,30,21,20,10,1701,110,300,183,131,164,278,0,253,129,0,0,40,160,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(1051,1241,21241,'Barrow Priest','','banshee_20_bi','10.00','27.50',42,'female','L2Monster','Priest',40,1660,22.000,589,2.100,40,43,30,21,20,10,1913,127,311,183,152,175,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1052,1242,21242,'Grave Overlord','','death_blader_10_sm','14.00','40.50',45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2315,161,415,216,188,193,278,500,253,297,0,0,100,160,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1053,1243,21243,'Grave Priest','','bloody_queen_10_sm','13.00','38.00',47,'female','L2Monster','Priest',40,2016,22.000,738,2.100,40,43,30,21,20,10,2396,171,427,215,216,206,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1054,1244,21244,'Crypt Archon','','skeleton_knight_30_bi','13.00','33.00',50,'male','L2Monster','Fighter',40,2245,22.000,830,2.100,40,43,30,21,20,10,2658,200,560,253,264,226,278,0,253,131,0,0,40,170,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(1055,1245,21245,'Crypt Inquisitor','','banshee_30_bi','11.00','30.00',52,'female','L2Monster','Mystic',40,2402,26.000,892,2.400,40,43,30,21,20,10,2933,227,570,251,300,239,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1056,1246,21246,'Tomb Archon','','death_blader_10_bi','16.00','49.50',55,'male','L2Monster','Fighter',40,2643,26.000,987,2.400,40,43,30,21,20,10,3459,279,737,292,360,261,278,500,253,298,0,0,100,170,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1057,1247,21247,'Tomb Inquisitor','','bloody_queen_10_bi','15.00','46.00',57,'female','L2Monster','Mystic',40,2806,26.000,1052,2.400,40,43,30,21,20,10,3524,293,743,289,405,276,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1058,1248,21248,'Crypt Guardian','','skeleton_royal_guard_20_bi','13.00','34.50',60,'male','L2Monster','Fighter',40,3054,26.000,1150,2.400,40,43,30,21,20,10,3828,332,828,335,478,299,317,0,289,233,0,0,80,190,'c_dungeon_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1059,1249,21249,'Crypt Sage','','vale_master_10_bi','13.00','44.00',62,'male','L2Monster','Fighter',40,3219,30.000,1217,2.700,40,43,30,21,20,10,4169,371,944,330,532,315,278,500,253,311,0,0,70,160,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1060,1250,21250,'Tomb Guardian','','death_knight','12.00','30.00',65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,253,0,0,0,27,190,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(1061,1251,21251,'Tomb Sage','','doll_master','20.00','42.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1062,1252,21252,'Crypt Guard ','','skeleton_royal_guard_30_bi','14.00','37.50',70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,289,236,0,0,80,200,'c_dungeon_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1063,1253,21253,'Crypt Preacher','','vale_master_30_bi','15.00','52.00',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,253,326,0,0,70,165,'c_dungeon_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1064,1254,21254,'Tomb Guard','','death_knight','12.00','30.00',75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,253,78,0,0,27,200,'c_dungeon_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(1065,1255,21255,'Tomb Preacher','','doll_master_20_bi','24.00','50.40',77,'male','L2Monster','Fighter',40,4364,34.000,1747,3.000,40,43,30,21,20,10,7190,778,1664,463,1031,442,278,500,253,0,0,0,80,165,'c_dungeon_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,10,0.56),
(1066,1256,21256,'Underground Werewolf','','werewolf_bi','11.00','29.70',23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,754,36,75,91,31,87,278,400,253,0,0,0,50,135,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.43),
(1067,1257,21257,'Evil Eye Seer','','monster_eye','21.00','43.00',18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,646,28,48,73,19,70,278,0,253,0,0,0,90,155,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.30),
(1068,1258,21258,'Fallen Orc Shaman','','ketra_orc_shaman','10.00','23.00',58,'male','L2Monster','Priest',40,2889,6.500,1084,2.400,40,43,30,21,20,10,0,0,781,297,428,284,278,0,253,9,0,0,10,130,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(1069,1259,21259,'Fallen Orc Shaman','','Saber_toothed_Tiger','10.00','28.00',59,'male','L2Monster','Priest',40,2971,6.500,1117,2.400,40,43,30,21,20,10,12983,1110,820,305,453,291,278,500,253,0,0,0,60,180,'beast_clan',1000,0,'Local','',0,0,0,7,30,4,4,0,10,0.45),
(1070,1260,21260,'Betrayer Orc Hero','','Ketra_Orc_Warrior','12.00','24.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3691,278,509,278,264,226,278,0,253,74,0,0,36,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1071,1261,21261,'Ol Mahum Transcender','','ol_mahum','13.50','25.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,4284,323,509,236,264,226,278,0,253,127,0,0,50,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.46),
(1072,1262,21262,'Ol Mahum Transcender','','ol_mahum_champion','14.00','27.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,7732,608,602,304,319,247,278,500,253,127,0,0,50,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(1073,1263,21263,'Ol Mahum Transcender','','oel_mahum','20.00','37.00',55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,11790,952,670,322,360,261,278,500,253,127,0,0,70,150,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1074,1264,21264,'Ol Mahum Transcender','','kel_mahum','13.00','26.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,19082,1612,781,349,428,284,278,500,253,127,0,0,50,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1075,1265,21265,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1586,96,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(1076,1266,21266,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(1077,1267,21267,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(1078,1268,21268,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,9.000,463,1.800,40,43,30,21,20,10,1475,89,187,193,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(1079,1269,21269,'Cave Ant','','ant','26.00','15.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,3368,207,222,154,104,147,278,500,253,0,0,0,40,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.26),
(1080,1270,21270,'Cave Ant Soldier','','ant_soldier','35.00','17.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,3891,243,238,188,112,153,278,500,253,0,0,0,80,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1081,1271,21271,'Cave Ant','','ant','26.00','15.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2298,141,222,154,104,147,278,500,253,0,0,0,40,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.26),
(1082,1272,21272,'Cave Ant Soldier','','ant_soldier','35.00','17.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,4085,255,238,188,112,153,278,500,253,0,0,0,80,130,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1083,1273,21273,'Cave Noble Ant','','noble_ant','20.00','48.00',39,'male','L2Monster','Fighter',40,1462,9.000,514,1.800,40,43,30,21,20,10,5918,376,280,177,121,158,278,500,253,0,0,0,80,174,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(1084,1274,21274,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,8356,796,1169,373,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(1085,1275,21275,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,8356,796,1415,308,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(1086,1276,21276,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,8356,796,1063,410,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(1087,1277,21277,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,5875,560,1169,373,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(1088,1278,21278,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,8608,832,1217,449,713,365,278,0,253,0,0,0,45,185,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1089,1279,21279,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,8608,832,1106,494,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1090,1280,21280,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,8608,832,1473,371,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1091,1281,21281,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,6052,584,1217,449,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1092,1282,21282,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,9040,884,1757,460,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1093,1283,21283,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,9040,884,2127,380,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1094,1284,21284,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,9040,884,1598,506,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1095,1285,21285,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,6356,622,1757,460,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1096,1286,21286,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,9121,904,1825,470,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1097,1287,21287,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,9121,904,1659,517,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1098,1288,21288,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,9121,904,2209,388,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1099,1289,21289,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,6413,636,1825,470,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1100,1290,21290,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,9572,960,1894,481,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1101,1291,21291,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,9572,960,1721,529,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1102,1292,21292,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,9572,960,2291,397,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1103,1293,21293,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,6730,676,1894,481,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1104,1294,21294,'Canyon Antelope ','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,15.000,1423,2.700,40,43,30,21,20,10,6893,666,1217,449,713,365,278,0,253,0,0,0,45,185,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1105,1295,21295,'Canyon Antelope Slave','','antelope','17.00','34.00',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,7311,715,1265,460,746,373,278,150,253,0,0,0,45,165,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1106,1296,21296,'Canyon Bandersnatch ','','bandersnatch','18.00','25.00',70,'male','L2Monster','Fighter',40,3862,22.500,1493,2.700,40,43,30,21,20,10,7244,718,2429,353,780,382,200,150,182,0,0,0,30,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1107,1297,21297,'Canyon Bandersnatch Slave','','bandersnatch','18.00','25.00',71,'male','L2Monster','Fighter',40,3938,25.500,1529,3.000,40,43,30,21,20,10,7275,730,1721,529,814,390,200,150,182,0,0,0,30,170,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1108,1298,21298,'Eye of Restrainer ','','monster_eye','21.00','43.00',71,'male','L2Monster','Mystic',40,3938,17.000,1529,3.000,40,43,30,21,20,10,7023,705,1239,449,814,390,278,150,253,0,0,0,90,140,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.30),
(1109,1299,21299,'Buffalo Slave','','buffalo_ec','22.00','31.00',72,'male','L2Monster','Fighter',40,4013,25.500,1565,3.000,40,43,30,21,20,10,7481,760,2159,446,849,399,200,150,182,0,0,0,20,160,'eye_clan',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1110,1300,21300,'Eye of Guide','','parasitic_eye_20_sm','20.00','50.50',72,'male','L2Monster','Mystic',40,4013,25.500,1565,3.000,40,43,30,21,20,10,7360,747,1168,505,849,399,278,0,253,0,0,0,30,155,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1111,1301,21301,'Gaze of Nightmare','','field_stalker','15.00','30.00',72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,6624,673,1061,654,849,399,278,0,253,0,0,0,70,195,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1112,1302,21302,'Eye of Watchman','','parasitic_eye','25.00','63.00',73,'male','L2Monster','Mystic',40,4086,25.500,1601,3.000,40,43,30,21,20,10,7105,731,1770,352,885,407,278,150,253,0,0,0,30,160,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1113,1303,21303,'Homunculus','','homunculus_20_sm','10.00','26.00',73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,7185,739,1947,320,885,407,278,150,253,0,0,0,30,185,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1114,1304,21304,'Grendel Slave','','bionic_bear','15.00','39.00',74,'male','L2Monster','Fighter',40,4158,34.000,1637,3.000,40,43,30,21,20,10,7918,825,2312,466,921,416,200,150,182,0,0,0,36,140,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1115,1305,21305,'Eye of Pilgrim','','parasitic_eye_20_sm','20.00','50.50',74,'male','L2Monster','Mystic',40,4158,25.500,1637,3.000,40,43,30,21,20,10,7775,810,1375,479,921,416,278,0,253,0,0,0,30,165,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1116,1306,21306,'Disciples of Protection','','apostle_warrior','8.00','30.00',74,'female','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,8441,880,1579,682,921,416,200,150,182,6717,0,0,50,160,'divine_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1117,1307,21307,'Elder Homunculus','','homunculus','12.00','32.50',75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,7394,780,1892,367,957,425,278,150,253,0,0,0,30,200,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1118,1308,21308,'Disciples of Punishment','','apostle_warrior','8.00','30.00',75,'female','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,7860,829,2389,475,957,425,200,150,182,6717,0,0,50,190,'divine_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1119,1309,21309,'Disciples of Punishment','','apostle_warrior','8.00','30.00',75,'female','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,8192,864,1795,633,957,425,200,150,182,6717,0,0,50,190,'divine_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1120,1310,21310,'Disciples of Authority','','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,42.500,1710,3.000,40,43,30,21,20,10,8071,863,1775,412,994,433,278,150,253,6718,0,0,50,155,'divine_clan',600,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(1121,1311,21311,'Disciples of Authority','','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,42.500,1710,3.000,40,43,30,21,20,10,7441,795,1334,549,994,433,278,150,253,6718,0,0,50,155,'divine_clan',600,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(1122,1312,21312,'Eye of Ruler','','parasitic_eye','25.00','63.00',74,'male','L2Monster','Mystic',40,4158,25.500,1637,3.000,40,43,30,21,20,10,10752,1121,1375,479,921,416,278,150,253,0,0,0,30,160,'eye_clan',400,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1123,1313,21313,'Sly Hound Dog','','bandersnatch','18.00','25.00',72,'male','L2Monster','Fighter',40,4013,25.500,1565,3.000,40,43,30,21,20,10,10294,1046,2375,406,849,399,200,0,182,0,0,0,30,185,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1124,1314,21314,'Hot Springs Bandersnatchling','','bandersnatch','18.00','25.00',73,'male','L2Monster','Fighter',40,4086,17.000,1601,3.000,40,43,30,21,20,10,8609,886,2032,502,885,407,200,150,182,0,0,0,30,170,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.49),
(1125,1315,21315,'Hot Springs Buffalo','','buffalo','22.00','31.00',73,'male','L2Monster','Fighter',40,4086,17.000,1601,3.000,40,43,30,21,20,10,8971,923,2032,502,885,407,200,0,182,0,0,0,20,170,'',0,0,'Magister','',0,0,0,7,50,1,9,0,0,0.46),
(1126,1316,21316,'Hot Springs Flava','','flava','18.00','34.00',74,'male','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,10556,1100,1513,512,921,416,278,150,253,0,0,0,30,165,'',0,0,'Magister','',0,0,0,7,50,1,9,0,0,0.45),
(1127,1317,21317,'Hot Springs Atroxspawn','','kailiharim','57.00','39.00',74,'male','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8846,922,2102,512,921,416,200,150,182,0,0,0,105,175,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.48),
(1128,1318,21318,'Hot Springs Antelope','','antelope','17.00','34.00',74,'male','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,9247,964,1513,512,921,416,278,0,253,0,0,0,45,185,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.46),
(1129,1319,21319,'Hot Springs Nepenthes','','nephenthes','28.00','43.50',75,'male','L2Monster','Fighter',40,4229,17.000,1673,3.000,40,43,30,21,20,10,11636,1227,2172,523,957,425,200,150,182,0,0,0,48,170,'',0,0,'Magister','',0,0,0,7,50,1,9,0,0,0.47),
(1130,1320,21320,'Hot Springs Yeti','','yeti_20_bi','18.00','32.00',75,'male','L2Monster','Fighter',40,4229,17.000,1673,3.000,40,43,30,21,20,10,9470,999,1563,523,957,425,278,0,253,0,0,0,16,170,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.48),
(1131,1321,21321,'Hot Springs Atrox','','kailiharim','57.00','39.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,182,0,0,0,105,175,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.48),
(1132,1322,21322,'Hot Springs Bandersnatch','','bandersnatch','18.00','25.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,182,0,0,0,30,170,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.49),
(1133,1323,21323,'Hot Springs Grendel','','bionic_bear','15.00','39.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,9753,1042,2242,534,994,433,200,0,182,0,0,0,36,165,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.46),
(1134,1324,21324,'Ketra Orc Footman','','ketra_orc','12.00','29.00',77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9323,1009,1664,544,1031,442,278,150,253,79,0,0,45,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1135,1325,21325,'Ketra''s War Hound','','bandersnatch','18.00','25.00',77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9015,975,2543,495,1031,442,200,150,182,0,0,0,30,185,'ketra_orc_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.49),
(1136,1326,21326,'Grazing Kookaburra','','youth_ostrich','8.00','26.40',77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,253,0,0,0,23,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(1137,1327,21327,'Ketra Orc Raider','','ketra_orc_warrior','12.00','24.00',78,'male','L2Monster','Fighter',40,4428,17.000,1784,3.000,40,43,30,21,20,10,10240,1120,2075,459,1069,451,278,150,253,79,6919,0,36,175,'ketra_orc_clan',300,0,'Local','',0,20,166,7,30,4,4,0,-6,0.54),
(1138,1328,21328,'Ketra Orc Scout','','ketra_orc_archer','12.00','27.00',78,'male','L2Monster','Ranger',500,4428,17.000,1784,3.000,40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,227,288,0,0,45,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.91),
(1139,1329,21329,'Ketra Orc Shaman','','ketra_orc_shaman','10.00','23.00',79,'male','L2Monster','Priest',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9955,1103,1765,481,1107,459,278,150,253,92,0,0,10,150,'ketra_orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(1140,1330,21330,'Grazing Buffalo','','buffalo','22.00','31.00',79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1141,1331,21331,'Ketra Orc Warrior','','ketra_orc_warrior','12.00','24.00',80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,9304,1044,1996,524,1144,468,278,150,253,79,6919,0,36,175,'ketra_orc_clan',300,0,'Local','',0,20,170,7,30,4,4,0,-6,0.54),
(1142,1332,21332,'Ketra Orc Lieutenant','','ketra_orc_chieftain','11.00','38.50',80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10420,1169,2291,634,1144,468,200,150,182,6719,0,0,24,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.51),
(1143,1333,21333,'Grazing Windsus','','giant_wild_hog','25.00','27.00',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.54),
(1144,1334,21334,'Ketra Orc Medium','','ketra_orc_shaman','10.00','23.00',81,'male','L2Monster','Priest',40,4608,17.000,1896,3.000,40,43,30,21,20,10,14933,1695,1863,499,1182,477,278,150,253,92,0,0,10,150,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.34),
(1145,1335,21335,'Ketra Orc Elite Soldier','','ketra_orc','12.00','29.00',82,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,79,0,0,45,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1146,1336,21336,'Ketra Orc White Captain','','ketra_orc_overload_20_bi','14.00','28.80',82,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,11317,1300,1738,657,1220,485,278,150,253,80,0,0,33,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1147,1337,21337,'Grazing Elder Buffalo','','buffalo','22.00','31.00',83,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,150,182,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1148,1338,21338,'Ketra Orc Seer','','ketra_orc_shaman','10.00','23.00',83,'male','L2Monster','Priest',40,4716,17.000,1972,3.000,40,43,30,21,20,10,13783,1602,2155,470,1258,494,278,150,253,213,0,0,10,160,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.34),
(1149,1339,21339,'Ketra Orc General','','ketra_orc_chieftain_20_bi','17.00','46.20',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,10494,1234,3372,511,1296,502,200,150,182,6719,0,0,24,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.51),
(1150,1340,21340,'Ketra Orc Battalion Commander','','ketra_orc_warlord','12.00','30.00',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,10494,1234,2006,619,1296,502,278,150,253,80,6919,0,27,175,'ketra_orc_clan',300,0,'Local','',0,20,178,7,30,4,4,0,-6,0.48),
(1151,1341,21341,'Grazing Elder Kookaburra','','youth_ostrich','8.00','26.40',85,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,23,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(1152,1342,21342,'Ketra Orc Grand Seer','','ketra_orc_shaman','10.00','23.00',85,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,14456,1720,2052,629,1333,511,278,150,253,213,0,0,10,160,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1153,1343,21343,'Ketra Commander','','ketra_orc_warlord_20_bi','14.00','36.00',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,16400,1862,1630,587,1182,477,317,150,289,80,6919,0,27,175,'ketra_orc_clan',300,0,'Local','',0,20,172,7,10,8,0,0,-6,0.48),
(1154,1344,21344,'Ketra Elite Guard','','ketra_orc_overload','12.00','24.00',80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,11138,1250,2195,476,1144,468,278,0,253,80,0,0,33,180,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1155,1345,21345,'Ketra''s Head Shaman','','ketra_orc_shaman','10.00','23.00',85,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,12360,1471,2257,572,1333,511,278,150,253,210,0,0,10,175,'ketra_orc_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.34),
(1156,1346,21346,'Ketra''s Head Guard','','ketra_orc_chieftain','11.00','38.50',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,12279,1444,2303,749,1296,502,200,0,182,6719,0,0,24,175,'ketra_orc_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51),
(1157,1347,21347,'Ketra Prophet','','ketra_orc_shaman','10.00','23.00',87,'male','L2Monster','Priest',40,4899,17.000,2127,3.000,40,43,30,21,20,10,18779,2289,2141,650,1406,528,278,150,253,213,0,0,10,175,'ketra_orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1158,1348,21348,'Prophet''s Guard','','ketra_orc_chieftain','11.00','38.50',86,'male','L2Monster','Fighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,6719,0,0,24,180,'ketra_orc_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51),
(1159,1349,21349,'Prophet''s Aide','','ketra_orc_shaman','10.00','23.00',86,'male','L2Monster','Priest',40,4858,17.000,2088,3.000,40,43,30,21,20,10,13071,1574,2097,639,1370,519,278,0,253,210,0,0,10,180,'ketra_orc_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.34),
(1160,1350,21350,'Varka Silenos Recruit','','barka_silenos_hunter','16.00','38.00',77,'male','L2Monster','Ranger',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9851,1066,1664,544,1031,442,278,150,253,2504,0,0,44,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1161,1351,21351,'Varka Silenos Footman','','barka_silenos_warrior','16.00','41.00',77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,8487,918,1831,495,1031,442,278,150,253,2504,0,0,34,185,'varka_silenos_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1162,1352,21352,'Grazing Antelope','','antelope','17.00','34.00',77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,253,0,0,0,45,185,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.46),
(1163,1353,21353,'Varka Silenos Scout','','barka_silenos_hunter','16.00','38.00',78,'male','L2Monster','Ranger',40,4428,17.000,1784,3.000,40,43,30,21,20,10,9906,1084,2075,459,1069,451,278,150,253,142,6918,0,44,175,'varka_silenos_clan',300,0,'Local','',0,20,166,7,30,4,4,0,-6,0.48),
(1164,1354,21354,'Varka Silenos Hunter','','barka_silenos_archer','8.00','37.50',78,'male','L2Monster','Fighter',500,4428,17.000,1784,3.000,40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,227,6917,0,0,30,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.59),
(1165,1355,21355,'Varka Silenos Shaman','','barka_silenos_shaman','14.00','39.50',79,'male','L2Monster','Priest',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9492,1052,2451,481,1107,459,200,150,182,6716,0,0,36,150,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.49),
(1166,1356,21356,'Grazing Nepenthes','','nephenthes','28.00','43.50',79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,48,170,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1167,1357,21357,'Varka Silenos Priest','','barka_silenos_priest','9.00','41.50',80,'male','L2Monster','Priest',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10277,1153,1996,524,1144,468,278,150,253,6716,0,0,36,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.47),
(1168,1358,21358,'Varka Silenos Warrior','','barka_silenos_warrior','16.00','41.00',80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10771,1209,1649,634,1144,468,278,150,253,142,6918,0,34,175,'varka_silenos_clan',300,0,'Local','',0,20,170,7,30,4,4,0,-6,0.48),
(1169,1359,21359,'Grazing Bandersnatch','','bandersnatch','18.00','25.00',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1170,1360,21360,'Varka Silenos Medium','','barka_silenos_shaman','14.00','39.50',81,'male','L2Monster','Priest',40,4608,17.000,1896,3.000,40,43,30,21,20,10,15892,1804,2588,499,1182,477,200,150,182,6716,0,0,36,150,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.49),
(1171,1361,21361,'Varka Silenos Magus','','barka_silenos_mage_20_bi','11.00','55.20',82,'male','L2Monster','Mystic',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(1172,1362,21362,'Varka Silenos Officer','','barka_silenos_chieftain','18.00','42.50',82,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,11317,1300,2414,657,1220,485,200,150,182,2504,0,0,25,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1173,1363,21363,'Grazing Flava','','flava','18.00','34.00',83,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1174,1364,21364,'Varka Silenos Seer','','barka_silenos_shaman','14.00','39.50',83,'male','L2Monster','Priest',40,4716,17.000,1972,3.000,40,43,30,21,20,10,13272,1543,2994,470,1258,494,200,150,182,6716,0,0,36,160,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.49),
(1175,1365,21365,'Varka Silenos Great Magus','','barka_silenos_warrior_20_bi','20.00','49.20',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,253,2500,0,0,34,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1176,1366,21366,'Varka Silenos General','','barka_silenos_chieftain','18.00','42.50',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,12718,1496,2787,619,1296,502,200,150,182,2500,0,0,25,175,'varka_silenos_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1177,1367,21367,'Grazing Elder Antelope','','antelope','17.00','34.00',85,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,45,185,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.46),
(1178,1368,21368,'Varka Silenos Great Seer','','barka_silenos_shaman','14.00','39.50',85,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,16964,2019,2851,629,1333,511,200,150,182,6716,0,0,36,160,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.49),
(1179,1369,21369,'Varka''s Commander','','barka_silenos_chieftain_20_bi','22.00','51.00',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,15953,1811,2588,587,1182,477,200,150,182,2500,0,0,25,175,'varka_silenos_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1180,1370,21370,'Varka''s Elite Guard','','barka_silenos_warrior','16.00','41.00',80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,11565,1298,2195,476,1144,468,278,0,253,2500,0,0,34,180,'varka_silenos_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(1181,1371,21371,'Varka''s Head Magus','','barka_silenos_shaman','14.00','39.50',85,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,12360,1471,3136,572,1333,511,200,150,182,6716,0,0,36,175,'varka_silenos_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.49),
(1182,1372,21372,'Varka''s Head Guard','','barka_silenos_hunter','16.00','38.00',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,12279,1444,1658,749,1296,502,278,0,253,2500,6918,0,44,175,'varka_silenos_clan',300,0,'Local',NULL,0,20,178,7,30,4,4,0,-6,0.48),
(1183,1373,21373,'Varka''s Prophet','','barka_silenos_shaman_20_bi','17.00','47.50',87,'male','L2Monster','Priest',40,4899,17.000,2127,3.000,40,43,30,21,20,10,18082,2204,2973,650,1406,528,200,150,182,6716,0,0,36,175,'varka_silenos_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.54),
(1184,1374,21374,'Prophet Guard','','barka_silenos_warrior','16.00','41.00',86,'male','L2Monster','Fighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2097,639,1370,519,278,0,253,2500,6918,0,34,180,'varka_silenos_clan',300,0,'Local','',0,20,182,7,30,4,4,0,-6,0.48),
(1185,1375,21375,'Disciple of Prophet','','barka_silenos_priest','9.00','41.50',86,'male','L2Monster','Priest',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12404,1494,2097,639,1370,519,278,0,253,6716,0,0,36,180,'varka_silenos_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1186,1376,21376,'Scarlet Stakato Walker','','blade_stakato_worker','13.00','40.00',78,'male','L2Monster','Fighter',40,4428,42.500,1784,3.000,40,43,30,21,20,10,7054,772,1886,505,1069,451,278,150,253,235,0,0,25,130,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(1187,1377,21377,'Scarlet Stakato Soldier','','blade_stakato_soldier','15.00','38.00',78,'male','L2Monster','Fighter',40,4428,42.500,1784,3.000,40,43,30,21,20,10,6904,755,1886,429,1069,451,278,150,253,148,0,0,25,180,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1188,1378,21378,'Scarlet Stakato Noble','','blade_stakato_drone','15.00','39.00',79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,9829,1089,1941,514,1107,459,278,150,253,235,0,0,25,180,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1189,1379,21379,'Tepra Scorpion','','scorpion_20_sm','24.00','52.80',79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,7098,786,1698,514,1107,459,317,150,289,0,0,0,37,125,'fire_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(1190,1380,21380,'Tepra Scarab','','scarab','14.00','22.00',79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,7237,802,1941,514,1107,459,278,150,253,0,0,0,45,175,'fire_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(1191,1381,21381,'Assassin Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,8414,944,1996,524,1144,468,278,150,253,0,0,0,45,145,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1192,1382,21382,'Mercenary of Destruction','','skeleton_knight','10.00','25.00',80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,10380,1165,1996,524,1144,468,278,150,253,150,103,0,40,165,'fire_clan',300,1,'Local','',0,20,170,7,30,4,4,0,-6,0.17),
(1193,1383,21383,'Knight of Destruction','','skeleton_royal_guard','11.00','28.50',80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,10396,1167,1996,524,1144,468,278,150,253,946,945,0,80,185,'fire_clan',300,1,'Local','',0,20,170,7,30,4,4,0,-6,0.52),
(1194,1384,21384,'Necromancer of Destruction','','vale_master_20_bi','14.50','48.00',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8915,1012,2050,454,1182,477,278,150,253,0,0,0,70,145,'fire_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.74),
(1195,1385,21385,'Lavastone Golem','','stone_golem','20.00','31.00',81,'male','L2Monster','Mystic',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8585,975,2050,534,1182,477,278,150,253,0,0,0,23,40,'fire_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(1196,1386,21386,'Magma Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,9174,1041,2847,534,1182,477,200,150,182,0,0,0,13,60,'fire_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1197,1387,21387,'Arimanes of Destruction','','ahrimanes','14.00','57.75',82,'male','L2Monster','Mystic',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7314,840,2921,543,1220,485,200,150,182,6722,0,0,35,185,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1198,1388,21388,'Iblis of Destruction','','fiend_archer','17.00','55.00',82,'male','L2Monster','Ranger',40,4663,51.000,1934,3.000,40,43,30,21,20,10,9221,1059,2103,543,1220,485,278,150,253,0,0,0,70,150,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(1199,1389,21389,'Balrog of Destruction','','kaim_vanul','24.00','40.00',83,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,9888,1149,2155,553,1258,494,278,150,253,0,0,0,37,155,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1200,1390,21390,'Ashuras of Destruction','','ashuras_30_bi','17.00','49.00',84,'male','L2Monster','Fighter',40,4766,51.000,2011,3.000,40,43,30,21,20,10,11408,1342,2207,562,1296,502,278,150,253,0,0,0,41,190,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1201,1391,21391,'Lavasillisk','','lesser_basilisk','12.00','22.00',83,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,7886,916,2155,553,1258,494,278,150,253,0,0,0,35,140,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(1202,1392,21392,'Blazing Ifrit','','ifrit_30_bi','13.00','55.00',84,'male','L2Monster','Mystic',40,4766,51.000,2011,3.000,40,43,30,21,20,10,11251,1323,2207,562,1296,502,278,150,253,0,0,0,38,150,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1203,1393,21393,'Magma Drake','','inferno_drake_20_bi','29.00','42.00',85,'male','L2Monster','Mystic',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9494,1130,2257,572,1333,511,278,150,253,0,0,0,57,195,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1204,1394,21394,'Lavasaurus','','magmagoil','15.00','75.00',79,'male','L2Monster','Fighter',500,4490,42.500,1821,3.000,40,43,30,21,20,10,8988,996,5991,437,1107,459,179,150,163,0,0,0,1,1,'fire_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.48),
(1205,1395,21395,'Elder Lavasaurus','','magmagoil_lad','15.00','75.00',83,'male','L2Monster','Fighter',500,4716,51.000,1972,3.000,40,43,30,21,20,10,9760,1134,6652,470,1258,494,179,150,163,0,0,0,1,1,'fire_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.48),
(1206,1396,21396,'Carrion Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,25.500,1784,3.000,40,43,30,21,20,10,8182,895,1417,672,1069,451,278,0,253,0,0,0,45,130,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(1207,1397,21397,'Carrion Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,25.500,1784,3.000,40,43,30,21,20,10,7103,777,2282,417,1069,451,278,0,253,0,0,0,45,130,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1208,1398,21398,'Soldier Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,51.000,1784,3.000,40,43,30,21,20,10,6744,738,1715,555,1069,451,278,150,253,0,0,0,45,180,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(1209,1399,21399,'Soldier Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,42.500,1784,3.000,40,43,30,21,20,10,7736,846,1715,555,1069,451,278,150,253,0,0,0,45,180,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1210,1400,21400,'Hexa Beetle','','tera_beetle','19.00','54.50',79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,6611,732,1765,566,1107,459,278,0,253,0,0,0,45,145,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.59),
(1211,1401,21401,'Hexa Beetle','','tera_beetle','19.00','54.50',79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7271,806,1941,514,1107,459,278,150,253,0,0,0,45,145,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1212,1402,21402,'Katraxis','','scorpion_20_sm','24.00','52.80',79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7503,831,1544,566,1107,459,317,150,289,0,0,0,37,165,'tomb_clan',300,0,'Magister','',0,0,0,7,10,8,0,0,0,0.54),
(1213,1403,21403,'Katraxis','','scorpion_20_sm','24.00','52.80',79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,6928,767,1544,566,1107,459,317,150,289,0,0,0,37,165,'tomb_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(1214,1404,21404,'Tera Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,14906,1673,1649,634,1144,468,278,0,253,0,0,0,45,185,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.59),
(1215,1405,21405,'Tera Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7146,802,1814,576,1144,468,278,0,253,0,0,0,45,185,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1216,1406,21406,'Knight of Empire','','skeleton_knight','10.00','25.00',80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,8454,949,1814,576,1144,468,278,150,253,150,103,0,40,145,'tomb_clan',300,1,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.17),
(1217,1407,21407,'Knight of Empire','','skeleton_knight','10.00','25.00',80,'male','L2Monster','Fighter',40,4550,25.500,1859,3.000,40,43,30,21,20,10,9017,1012,1814,576,1144,468,278,150,253,150,103,0,40,145,'tomb_clan',300,1,'Local','',0,20,170,7,30,4,4,0,-6,0.17),
(1218,1408,21408,'Royal Guard of Empire','','skeleton_pikeman','10.00','28.00',80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,7358,825,1996,524,1144,468,278,150,253,304,0,0,50,190,'tomb_clan',300,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.21),
(1219,1409,21409,'Royal Guard of Empire','','skeleton_pikeman','10.00','28.00',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,6857,769,1499,698,1144,468,278,150,253,304,0,0,50,190,'tomb_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1220,1410,21410,'Guardian Scarab','','scarab_20_bi','17.00','26.50',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7602,863,1863,587,1182,477,278,0,253,0,0,0,45,195,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(1221,1411,21411,'Guardian Scarab','','scarab_20_bi','17.00','26.50',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7584,861,1863,587,1182,477,278,0,253,0,0,0,45,195,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1222,1412,21412,'Ustralith','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,9682,1099,1347,710,1182,477,317,150,289,0,0,0,37,130,'tomb_clan',300,0,'Magister','',0,0,0,7,10,8,0,0,0,0.54),
(1223,1413,21413,'Ustralith','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7445,845,1793,534,1182,477,317,150,289,0,0,0,37,130,'tomb_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(1224,1414,21414,'Assassin of Empire','','skeleton_royal_guard','11.00','28.50',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7236,821,1973,485,1182,477,317,0,289,946,945,0,80,175,'tomb_clan',300,1,'DRIVER','',0,20,172,7,10,8,0,0,-6,0.52),
(1225,1415,21415,'Assassin of Empire','','skeleton_royal_guard','11.00','28.50',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7299,828,1482,646,1182,477,317,0,289,946,945,0,80,175,'tomb_clan',300,1,'Local','',0,20,172,7,10,8,0,0,-6,0.52),
(1226,1416,21416,'Imperial Commander','','imperial_warlord_zombie','7.00','30.00',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8637,980,1863,587,1182,477,278,150,253,134,6721,0,39,140,'tomb_clan',300,1,'DRIVER','',0,20,172,7,30,4,4,0,-6,0.48),
(1227,1417,21417,'Imperial Commander','','imperial_warlord_zombie','7.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,12557,1425,2255,485,1182,477,278,150,253,134,6721,0,39,140,'tomb_clan',300,1,'Local','',0,20,172,7,30,4,4,0,-6,0.48),
(1228,1418,21418,'Imperial Royal Guard','','death_knight','12.00','30.00',82,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8030,922,1912,598,1220,485,278,0,253,142,0,0,27,160,'tomb_clan',300,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.71),
(1229,1419,21419,'Imperial Royal Guard','','death_knight','12.00','30.00',82,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,142,0,0,27,160,'tomb_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(1230,1420,21420,'Ashuras','','ashuras','13.00','37.50',82,'male','L2Monster','Fighter',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7704,885,1912,598,1220,485,278,150,253,0,0,0,41,200,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.50),
(1231,1421,21421,'Ashuras','','ashuras','13.00','37.50',82,'male','L2Monster','Fighter',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7231,830,1912,598,1220,485,278,150,253,0,0,0,41,200,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1232,1422,21422,'Dancer of Empire','','banshee','9.00','23.00',82,'female','L2Monster','Mystic',40,4663,51.000,1934,3.000,40,43,30,21,20,10,6913,794,2103,543,1220,485,278,0,253,0,0,0,80,120,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.56),
(1233,1423,21423,'Dancer of Empire','','banshee','9.00','23.00',82,'female','L2Monster','Mystic',40,4663,51.000,1934,3.000,40,43,30,21,20,10,7328,842,2103,543,1220,485,278,150,253,0,0,0,80,120,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1234,1424,21424,'Ashkenas','','ashuras','13.00','37.50',82,'male','L2Monster','Fighter',40,4663,51.000,1934,3.000,40,43,30,21,20,10,9288,1067,2544,449,1220,485,278,0,253,0,0,0,41,190,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.50),
(1235,1425,21425,'Ashkenas','','ashuras','13.00','37.50',82,'male','L2Monster','Fighter',40,4663,51.000,1934,3.000,40,43,30,21,20,10,9444,1085,2544,449,1220,485,278,150,253,0,0,0,41,190,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1236,1426,21426,'Abraxion','','erinyes','21.00','50.00',83,'male','L2Monster','Fighter',40,4716,34.000,1972,3.000,40,43,30,21,20,10,16312,1896,2722,608,1258,494,200,150,182,0,0,0,31,130,'tomb_clan',300,0,'Magister','',0,0,0,7,50,1,9,0,0,0.48),
(1237,1427,21427,'Abraxion','','erinyes','21.00','50.00',83,'male','L2Monster','Fighter',40,4716,34.000,1972,3.000,40,43,30,21,20,10,9587,1114,2722,608,1258,494,200,150,182,0,0,0,31,130,'tomb_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1238,1428,21428,'Hasturan','','erinyes','21.00','50.00',83,'male','L2Monster','Fighter',40,4716,42.500,1972,3.000,40,43,30,21,20,10,7324,851,2994,553,1258,494,200,150,182,0,0,0,31,150,'tomb_clan',300,0,'Magister','',0,0,0,7,50,1,9,0,0,0.48),
(1239,1429,21429,'Hasturan','','erinyes','21.00','50.00',83,'male','L2Monster','Fighter',40,4716,42.500,1972,3.000,40,43,30,21,20,10,7647,889,2474,669,1258,494,200,150,182,0,0,0,31,150,'tomb_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1240,1430,21430,'Arimanes','','ahrimanes','14.00','57.75',83,'male','L2Monster','Mystic',40,4716,51.000,1972,3.000,40,43,30,21,20,10,8801,1023,3293,503,1258,494,200,0,182,6722,0,0,35,210,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.48),
(1241,1431,21431,'Arimanes','','ahrimanes','14.00','57.75',83,'male','L2Monster','Mystic',40,4716,51.000,1972,3.000,40,43,30,21,20,10,7507,872,2249,736,1258,494,200,0,182,6722,0,0,35,210,'tomb_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1242,1432,21432,'Chakram Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,12155,1364,1814,576,1144,468,278,0,253,0,0,0,45,170,'tomb_clan',300,0,'Magister','',0,0,0,7,30,4,4,0,0,0.59),
(1243,1433,21433,'Jamadar Beetle','','tera_beetle_20_sm','15.00','43.60',79,'male','L2Monster','Fighter',40,4490,51.000,1821,3.000,40,43,30,21,20,10,11788,1306,1765,566,1107,459,278,0,253,0,0,0,45,175,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.59),
(1244,1434,21434,'Seer of Blood','','erinyes','21.00','50.00',82,'male','L2Monster','Fighter',40,4663,51.000,1934,3.000,40,43,30,21,20,10,23561,2707,2655,598,1220,485,200,0,182,0,0,0,31,150,'tomb_clan',300,0,'Magister','',0,0,0,7,50,1,9,0,0,0.48),
(1245,1435,21435,'Guide of Offering','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,11922,1338,1814,576,1144,468,278,0,253,134,6721,0,39,150,'',0,1,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.48),
(1246,1436,21436,'Leader of Offering','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,12367,1388,1814,576,1144,468,278,0,253,134,6721,0,39,150,'',0,1,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.48),
(1247,1437,21437,'Offering Bug','','scarab','14.00','22.00',79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7489,830,1765,566,1107,459,278,0,253,0,0,0,45,180,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.52),
(1248,1438,21438,'Heathen Warrior','','skeleton_royal_guard','11.00','28.50',65,'male','L2Monster','Fighter',40,3465,1.880,1319,2.700,40,43,30,21,20,10,5966,556,1140,346,619,340,317,150,289,946,945,0,80,175,'undead_clan',300,1,'Magister','',0,20,135,7,10,8,0,0,-6,0.52),
(1249,1439,21439,'Heathen Executed ','','hungry_spirit','13.00','40.00',66,'male','L2Monster','Fighter',40,3546,1.880,1353,2.700,40,43,30,21,20,10,6151,580,1358,301,649,348,278,150,253,0,0,0,15,175,'undead_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,10,0.45),
(1250,1440,21440,'Heathen Archer','','skeleton_archer','11.00','27.00',67,'male','L2Monster','Ranger',500,3626,1.880,1388,2.700,40,43,30,21,20,10,6735,640,3145,308,681,356,249,0,227,284,0,0,40,155,'undead_clan',300,1,'Magister','',0,0,0,7,10,8,0,1500,10,0.80),
(1251,1441,21441,'Heathen Grunt','','skeleton_pikeman','10.00','28.00',68,'male','L2Monster','Fighter',40,3706,1.880,1423,2.700,40,43,30,21,20,10,6530,632,1473,371,713,365,278,150,253,96,0,0,50,170,'undead_clan',300,1,'Magister','',0,0,0,7,30,4,4,0,0,0.21),
(1252,1442,21442,'Heathen Knight','','skeleton_knight','10.00','25.00',69,'male','L2Monster','Fighter',40,3784,1.880,1458,2.700,40,43,30,21,20,10,6723,656,1531,380,746,373,278,150,253,150,103,0,40,165,'undead_clan',300,1,'Magister','',0,20,145,7,30,4,4,0,-6,0.17),
(1253,1443,21443,'Raider of Pastureland','','dark_mahum','13.00','26.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,7006,633,649,530,560,323,317,150,289,153,0,0,50,165,'nonpet_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1254,1444,21444,'Raider of Pastureland','','dark_mahum','13.00','26.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,5887,532,741,530,560,323,278,150,253,153,0,0,50,165,'nonpet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1255,1445,21445,'Alpen Bandersnatch','','bandersnatch','18.00','25.00',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,6076,556,1302,449,589,331,200,150,182,0,0,0,30,170,'nonpet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1256,1446,21446,'Raider of Pastureland','','dark_mahum','13.00','26.00',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,7476,684,678,543,589,331,317,150,289,160,0,0,50,165,'nonpet_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1257,1447,21447,'Raider of Pastureland','','dark_mahum','13.00','26.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7689,724,738,570,649,348,317,150,289,229,0,0,50,165,'nonpet_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1258,1448,21448,'Raider of Pastureland','','dark_mahum','13.00','26.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,6462,608,843,570,649,348,278,150,253,229,0,0,50,165,'nonpet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1259,1449,21449,'Raider of Pastureland','','dark_mahum','13.00','26.00',68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8440,815,800,598,713,365,317,150,289,234,0,0,50,165,'nonpet_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1260,1450,21450,'Alpen Grendel','','bionic_bear','15.00','39.00',68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8162,789,1690,449,713,365,200,150,182,0,0,0,36,155,'nonpet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1261,1451,21451,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,3.750,1319,2.700,40,43,30,21,20,10,5530,514,1077,418,619,340,278,0,253,0,0,0,13,110,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1262,1452,21452,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1263,1453,21453,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1264,1454,21454,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1265,1455,21455,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1266,1456,21456,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1267,1457,21457,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1268,1458,21458,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1269,1459,21459,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1270,1460,21460,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1271,1461,21461,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1272,1462,21462,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1273,1463,21463,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1274,1464,21464,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1275,1465,21465,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1276,1466,21466,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1277,1467,21467,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1278,1468,21468,'Alpen Kookaburra','','rough_ostrich','10.00','33.00',65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,6457,600,1433,314,619,340,278,150,253,0,0,0,23,210,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1279,1469,21469,'Alpen Kookaburra','','rough_ostrich','10.00','33.00',65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,6159,572,1433,314,619,340,278,150,253,0,0,0,23,210,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1280,1470,21470,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,5875,560,1169,439,681,356,278,0,253,0,0,0,30,110,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1281,1471,21471,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1282,1472,21472,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1283,1473,21473,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1284,1474,21474,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1285,1475,21475,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1286,1476,21476,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1287,1477,21477,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1288,1478,21478,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.48),
(1289,1479,21479,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1290,1480,21480,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1291,1481,21481,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1292,1482,21482,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1293,1483,21483,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1294,1484,21484,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1295,1485,21485,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1296,1486,21486,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.47),
(1297,1487,21487,'Alpen Buffalo','','buffalo','22.00','31.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,6861,653,2162,329,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1298,1488,21488,'Alpen Buffalo','','buffalo','22.00','31.00',67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,6544,623,2162,329,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1299,1489,21489,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,6231,610,1265,460,746,373,278,0,253,0,0,0,28,110,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1300,1490,21490,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1301,1491,21491,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1302,1492,21492,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1303,1493,21493,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1304,1494,21494,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1305,1495,21495,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1306,1496,21496,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1307,1497,21497,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1308,1498,21498,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1309,1499,21499,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1310,1500,21500,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1311,1501,21501,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1312,1502,21502,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1313,1503,21503,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1314,1504,21504,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1315,1505,21505,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1316,1506,21506,'Alpen Cougar','','saber_toothed_tiger','13.00','28.00',69,'male','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,7276,712,1684,345,746,373,278,150,253,0,0,0,60,200,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1317,1507,21507,'Alpen Cougar','','saber_toothed_tiger','12.00','22.00',69,'male','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,6941,679,1684,345,746,373,278,150,253,0,0,0,60,200,'pet_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1318,1508,21508,'Splinter Stakato','','blade_stakato','15.00','36.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8452,796,1123,364,649,348,278,150,253,235,0,0,25,175,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.46),
(1319,1509,21509,'Splinter Stakato Walker','','blade_stakato_worker','13.00','40.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7445,709,1286,339,681,356,278,150,253,0,0,0,25,180,'stakato_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.76),
(1320,1510,21510,'Splinter Stakato Soldier','','blade_stakato_soldier','15.00','38.00',68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8972,867,1473,371,713,365,278,150,253,148,0,0,25,180,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(1321,1511,21511,'Splinter Stakato Drone','','blade_stakato_drone','15.00','39.00',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,9944,973,1265,460,746,373,278,150,253,132,0,0,25,185,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1322,1512,21512,'Splinter Stakato Drone','','blade_stakato_drone','15.00','39.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,12636,1253,1086,569,780,382,278,0,253,132,0,0,25,185,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1323,1513,21513,'Needle Stakato','','blade_stakato','15.00','36.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,9507,943,1314,399,780,382,278,150,253,235,0,0,25,185,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.46),
(1324,1514,21514,'Needle Stakato Walker','','blade_stakato_worker','13.00','40.00',71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,8360,839,1499,371,814,390,278,150,253,0,0,0,25,190,'stakato_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.76),
(1325,1515,21515,'Needle Stakato Soldier','','blade_stakato_soldier','15.00','38.00',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10059,1022,1710,406,849,399,278,150,253,148,0,0,25,190,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(1326,1516,21516,'Needle Stakato Drone','','blade_stakato_drone','15.00','39.00',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,10340,1064,1463,502,885,407,278,150,253,132,0,0,25,195,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1327,1517,21517,'Needle Stakato Drone','','blade_stakato_drone','15.00','39.00',74,'male','L2Monster','Fighter',40,4158,8.500,1637,3.000,40,43,30,21,20,10,14121,1472,1250,620,921,416,278,0,253,132,0,0,25,195,'stakato_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1328,1518,21518,'Frenzy Stakato Soldier','','blade_stakato_soldier','15.00','38.00',68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8002,773,1417,337,713,365,317,0,289,235,0,0,25,185,'stakato_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.74),
(1329,1519,21519,'Frenzy Stakato Drone','','blade_stakato_drone','15.00','39.00',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,8972,912,1645,369,849,399,317,0,289,235,0,0,25,195,'stakato_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.58),
(1330,1520,21520,'Eye of Splendor','','kel_mahum','13.00','26.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,7466,648,860,368,478,299,278,0,253,326,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1331,1521,21521,'Claws of Splendor','','kel_mahum_warrior','13.00','28.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,7340,637,711,446,478,299,278,0,253,326,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1332,1522,21522,'Claws of Splendor','','dark_fencer','7.00','13.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,8748,759,1041,259,478,299,278,0,253,0,0,0,25,155,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.20),
(1333,1523,21523,'Flash of Splendor','','kel_mahum_witch_doctor','13.00','25.00',61,'male','L2Monster','Fighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,7529,663,901,378,505,307,278,150,253,326,0,0,50,150,'saint_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(1334,1524,21524,'Blade of Splendor','','kel_mahum','13.00','26.00',61,'male','L2Monster','Fighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,8028,707,1200,284,505,307,278,0,253,242,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1335,1525,21525,'Blade of Splendor','','kel_mahum','13.00','26.00',61,'male','L2Monster','Fighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,8028,707,901,378,505,307,278,0,253,242,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1336,1526,21526,'Wisdom of Splendor','','kel_mahum_warrior','13.00','28.00',62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,9220,822,944,388,532,315,278,150,253,193,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1337,1527,21527,'Anger of Splendor','','kel_mahum_champion','13.00','32.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,8132,734,987,398,560,323,278,0,253,193,0,0,50,150,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1338,1528,21528,'Anger of Splendor','','dark_fencer','7.00','13.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,9645,871,987,398,560,323,278,0,253,0,0,0,25,155,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(1339,1529,21529,'Soul of Splendor','','kel_mahum_witch_doctor','13.00','25.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,7377,666,987,398,560,323,278,150,253,193,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(1340,1530,21530,'Victory of Splendor','','kel_mahum','13.00','26.00',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8006,733,1031,408,589,331,278,0,253,196,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1341,1531,21531,'Punishment of Splendor','','kel_mahum_warrior','13.00','28.00',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8837,809,1373,306,589,331,278,0,253,242,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1342,1532,21532,'Shout of Splendor','','kel_mahum_champion','13.00','32.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,9456,879,1077,418,619,340,278,150,253,196,0,0,50,150,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1343,1533,21533,'Alliance of Splendor','','kel_mahum_witch_doctor','13.00','25.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7767,722,890,430,619,340,278,0,253,196,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.28),
(1344,1534,21534,'Alliance of Splendor','','dark_fencer','7.00','13.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,10267,954,1303,346,619,340,278,0,253,0,0,0,25,155,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(1345,1535,21535,'Signet of Splendor','','kel_mahum_warrior','13.00','28.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9331,878,1123,428,649,348,278,150,253,189,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1346,1536,21536,'Crown of Splendor','','kel_mahum_champion','13.00','32.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9487,893,1123,428,649,348,278,0,253,189,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1347,1537,21537,'Fang of Splendor','','kel_mahum_witch_doctor','13.00','25.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8905,848,966,451,681,356,278,0,253,189,0,0,50,155,'saint_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.28),
(1348,1538,21538,'Fang of Splendor','','dark_fencer','7.00','13.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,10908,1039,1415,362,681,356,278,0,253,0,0,0,25,155,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(1349,1539,21539,'Wailing of Splendor','','kel_mahum','13.00','26.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9685,922,1557,329,681,356,278,0,253,242,0,0,50,170,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1350,1540,21540,'Wailing of Splendor','','kel_mahum','13.00','26.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9685,922,1169,439,681,356,278,0,253,242,0,0,50,170,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1351,1541,21541,'Pilgrim of Splendor','','kel_mahum_witch_doctor','13.00','25.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,9944,898,987,338,560,323,278,150,253,315,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.28),
(1352,1542,21542,'Disciple of Pilgrim','','kel_mahum_warrior','13.00','28.00',62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,6932,618,1038,353,532,315,278,0,253,193,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1353,1543,21543,'Page of Pilgrim','','kel_mahum','13.00','26.00',62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,7909,705,858,427,532,315,278,0,253,326,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1354,1544,21544,'Judge of Splendor','','kel_mahum_champion','13.00','32.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,11331,1079,1169,439,681,356,278,150,253,150,0,0,50,160,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1355,1545,21545,'Judge of Fire','','kel_mahum_witch_doctor','13.00','25.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7855,739,1235,331,649,348,278,0,253,189,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.28),
(1356,1546,21546,'Judge of Light','','kel_mahum','13.00','26.00',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8963,844,1020,471,649,348,278,0,253,196,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1357,1547,21547,'Corrupted Knight','','skeleton_knight','10.00','25.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,8116,733,987,398,560,323,278,0,253,150,103,0,40,165,'necro_clan',300,1,'Local','',0,20,131,30,30,4,4,0,-6,0.17),
(1358,1548,21548,'Resurrected Knight','','skeleton_knight','10.00','25.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,7019,634,987,398,560,323,278,0,253,150,103,0,40,165,'necro_clan',300,1,'Local','',0,20,131,30,30,4,4,0,-6,0.17),
(1359,1549,21549,'Corrupted Guard','','skeleton_royal_guard','11.00','28.50',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8375,767,902,408,589,331,317,0,289,946,0,0,80,175,'necro_clan',300,1,'Local','',0,0,0,30,10,8,0,0,0,0.52),
(1360,1550,21550,'Corrupted Guard','','skeleton_royal_guard','11.00','28.50',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8543,782,1201,306,589,331,317,150,289,946,945,0,80,175,'necro_clan',300,1,'Local','',0,20,133,30,10,8,0,0,-6,0.52),
(1361,1551,21551,'Resurrected Guard','','skeleton_royal_guard','11.00','28.50',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9541,898,982,428,649,348,317,0,289,221,0,0,80,175,'necro_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(1362,1552,21552,'Resurrected Guard','','skeleton_royal_guard','11.00','28.50',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9085,855,1307,322,649,348,317,150,289,221,945,0,80,175,'necro_clan',300,1,'Local','',0,20,138,7,10,8,0,0,-6,0.52),
(1363,1553,21553,'Trampled Man','','zombie','13.00','21.00',65,'male','L2Monster','Mystic',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6267,582,1077,355,619,340,278,0,253,0,0,0,15,40,'necro_clan',300,1,'Local','',0,0,0,30,30,4,4,0,10,0.43),
(1364,1554,21554,'Trampled Man','','zombie','13.00','21.00',65,'male','L2Monster','Mystic',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6267,582,1303,294,619,340,278,0,253,0,0,0,15,40,'necro_clan',300,1,'Local','',0,0,0,30,30,4,4,0,10,0.43),
(1365,1555,21555,'Slaughter Executioner','','dark_horror','20.00','35.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7619,708,979,391,619,340,278,0,253,0,0,0,100,160,'necro_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1366,1556,21556,'Slaughter Executioner','','dark_horror','20.00','35.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7435,691,1077,355,619,340,278,0,253,0,0,0,100,160,'necro_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1367,1557,21557,'Bone Snatcher','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1368,1558,21558,'Bone Snatcher','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1369,1559,21559,'Bone Maker','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1370,1560,21560,'Bone Shaper','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1371,1561,21561,'Sacrificed Man','','zombie','13.00','21.00',67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8057,767,1063,410,681,356,278,150,253,0,0,0,15,40,'necro_clan',300,1,'Local','',0,0,0,30,30,4,4,0,10,0.43),
(1372,1562,21562,'Guillotine''s Ghost','','liviona','15.00','28.00',67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8344,795,1169,373,681,356,278,150,253,0,0,0,80,150,'necro_clan',300,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34),
(1373,1563,21563,'Bone Collector','','black_magician','8.00','30.00',67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9695,923,1286,399,681,356,278,0,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1374,1564,21564,'Skull Collector','','black_magician','8.00','30.00',67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9223,878,1286,399,681,356,278,150,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1375,1565,21565,'Bone Animator','','black_magician','8.00','30.00',68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,9314,900,1339,408,713,365,278,0,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1376,1566,21566,'Skull Animator','','black_magician','8.00','30.00',68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,10186,984,1339,408,713,365,278,150,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1377,1567,21567,'Bone Slayer','','black_magician','8.00','30.00',68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,12175,1176,1106,494,713,365,278,150,253,178,0,0,19,180,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1378,1568,21568,'Devil Bat','','vampire_bat','10.00','33.50',68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,10440,1009,1473,315,713,365,278,150,253,0,0,0,60,170,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1379,1569,21569,'Devil Bat','','vampire_bat','10.00','33.50',68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8108,783,1217,382,713,365,278,150,253,0,0,0,60,170,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(1380,1570,21570,'Ghost of Betrayer','','binding','12.00','21.00',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,7557,739,1150,506,746,373,278,150,253,0,0,0,10,174,'necro_clan',300,1,'Local','',0,0,0,30,30,4,4,0,0,0.54),
(1381,1571,21571,'Ghost of Rebellion Soldier','','skeleton_knight','10.00','25.00',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,10718,1049,1265,460,746,373,278,150,253,150,103,0,40,165,'necro_clan',300,1,'Local','',0,20,145,7,30,4,4,0,-6,0.17),
(1382,1572,21572,'Bone Sweeper','','black_magician','8.00','30.00',69,'male','L2Monster','Mystic',40,3784,7.500,1458,2.700,40,43,30,21,20,10,10282,1006,1392,418,746,373,278,0,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1383,1573,21573,'Atrox','','kailiharim','57.00','39.00',69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,11456,1121,2127,380,746,373,200,150,182,0,0,0,105,185,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1384,1574,21574,'Bone Grinder','','black_magician','8.00','30.00',70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,12902,1279,1194,517,780,382,278,150,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1385,1575,21575,'Bone Grinder','','black_magician','8.00','30.00',70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,7269,721,1314,470,780,382,278,150,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1386,1576,21576,'Ghost of Guillotine ','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,9350,927,1590,330,780,382,278,0,253,0,0,0,80,150,'vampire_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(1387,1577,21577,'Ghost of Guillotine ','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8195,813,1314,399,780,382,278,0,253,0,0,0,80,150,'vampire_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.34),
(1388,1578,21578,'Behemoth Zombie','','giant_zombie','13.00','40.50',71,'male','L2Monster','Mystic',40,3938,8.500,1529,3.000,40,43,30,21,20,10,10308,1034,1239,529,814,390,278,0,253,0,0,0,20,90,'necro_clan',300,1,'Local','',0,0,0,30,30,4,4,0,0,0.48),
(1389,1579,21579,'Ghost of Rebellion Leader','','skeleton_royal_guard','11.00','28.50',71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,10843,1088,1193,481,814,390,317,0,289,221,945,0,80,175,'necro_clan',300,1,'Local','',0,20,150,7,10,8,0,0,-6,0.52),
(1390,1580,21580,'Bone Caster','','black_magician','8.00','30.00',71,'male','L2Monster','Mystic',40,3938,8.500,1529,3.000,40,43,30,21,20,10,10154,1019,1499,437,814,390,278,0,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1391,1581,21581,'Bone Puppeteer','','black_magician','8.00','30.00',71,'male','L2Monster','Mystic',40,3938,8.500,1529,3.000,40,43,30,21,20,10,11105,1114,1499,437,814,390,278,150,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1392,1582,21582,'Vampire Soldier','','vampire_soldier','8.00','23.50',71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,11891,1193,1649,397,814,390,278,0,253,234,0,0,60,190,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1393,1583,21583,'Bone Scavenger','','black_magician','8.00','30.00',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,11196,1137,1554,446,849,399,278,0,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1394,1584,21584,'Bone Scavenger','','black_magician','8.00','30.00',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10442,1061,1284,540,849,399,278,0,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1395,1585,21585,'Vampire Magician','','vampire_witch','6.00','21.50',72,'female','L2Monster','Mystic',40,4013,8.500,1565,3.000,40,43,30,21,20,10,9628,978,1710,406,849,399,278,150,253,946,0,0,64,180,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1396,1586,21586,'Vampire Adept','','vampire_wizard','5.50','28.00',72,'female','L2Monster','Mystic',40,4013,8.500,1565,3.000,40,43,30,21,20,10,11374,1156,1710,406,849,399,278,150,253,99,0,0,46,180,'vampire_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.46),
(1397,1587,21587,'Vampire Warrior','','vampire_soldier_20_bi','10.00','29.00',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,11852,1204,1710,406,849,399,278,0,253,234,0,0,60,190,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1398,1588,21588,'Vampire Wizard','','vampire_witch','6.00','21.50',73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9936,1022,1947,377,885,407,278,0,253,946,0,0,64,180,'vampire_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.50),
(1399,1589,21589,'Vampire Wizard','','vampire_witch','6.00','21.50',73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,10168,1046,1099,668,885,407,278,0,253,946,0,0,64,180,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1400,1590,21590,'Vampire Magister','','vampire_wizard','5.50','28.00',73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9936,1022,1770,415,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1401,1591,21591,'Vampire Magister','','vampire_wizard','5.50','28.00',73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,11462,1179,1770,415,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1402,1592,21592,'Vampire Magister','','vampire_wizard','5.50','28.00',73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,7750,797,1330,552,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1403,1593,21593,'Vampire Warlord','','vampire_warrior','9.00','31.50',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,13346,1373,2459,415,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1404,1594,21594,'Vampire Warlord','','vampire_warrior','9.00','31.50',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,12571,1294,2459,415,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(1405,1595,21595,'Vampire Warlord','','vampire_warrior','9.00','31.50',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9161,943,1847,552,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1406,1596,21596,'Requiem Lord','','black_magician','8.00','30.00',68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,12038,1163,1106,494,713,365,278,150,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1407,1597,21597,'Requiem Behemoth','','giant_zombie','13.00','40.50',67,'male','L2Minion','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8265,787,1286,399,681,356,278,0,253,0,0,0,20,100,'necro_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1408,1598,21598,'Requiem Behemoth','','giant_zombie','13.00','40.50',67,'male','L2Minion','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9179,874,1286,399,681,356,278,0,253,0,0,0,20,100,'necro_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1409,1599,21599,'Requiem Priest','','black_magician','8.00','30.00',71,'male','L2Monster','Priest',40,3938,8.500,1529,3.000,40,43,30,21,20,10,12750,1279,1239,529,814,390,278,150,253,178,0,0,19,185,'necro_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1410,1600,21600,'Requiem Behemoth','','giant_zombie','13.00','40.50',70,'male','L2Minion','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,9022,895,1445,427,780,382,278,0,253,0,0,0,20,100,'necro_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1411,1601,21601,'Requiem Behemoth','','giant_zombie','13.00','40.50',70,'male','L2Minion','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,10732,1064,1445,427,780,382,278,0,253,0,0,0,20,100,'necro_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1412,1602,21602,'Zaken''s Pikeman','','skeleton_pikeman','10.00','28.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,3693,250,332,223,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.21),
(1413,1603,21603,'Zaken''s Pikeman','','skeleton_pikeman','10.00','28.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,5230,354,442,167,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.21),
(1414,1604,21604,'Zaken''s Elite Pikeman','','skeleton_pikeman_20_bi','12.00','33.60',43,'male','L2Monster','Fighter',40,1728,22.000,618,2.100,40,43,30,21,20,10,2114,143,332,223,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.21),
(1415,1605,21605,'Zaken''s Archer','','skeleton_archer','11.00','27.00',44,'male','L2Monster','Ranger',500,1799,5.500,648,2.100,40,43,30,21,20,10,4109,281,788,230,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.80),
(1416,1606,21606,'Zaken''s Archer','','skeleton_archer','11.00','27.00',44,'male','L2Monster','Ranger',500,1799,5.500,648,2.100,40,43,30,21,20,10,5818,398,1048,173,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.80),
(1417,1607,21607,'Zaken''s Elite Archer','','skeleton_archer_20_bi','13.00','32.50',44,'male','L2Monster','Ranger',500,1799,22.000,648,2.100,40,43,30,21,20,10,2273,155,788,230,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,1,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.80),
(1418,1608,21608,'Zaken''s Watchman','','liviona','15.00','28.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3365,234,377,202,188,193,278,150,253,0,0,0,80,174,NULL,0,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34),
(1419,1609,21609,'Zaken''s Watchman','','liviona','15.00','28.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,4766,331,502,152,188,193,278,150,253,0,0,0,80,174,NULL,0,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34),
(1420,1610,21610,'Zaken''s High Grade Watchman','','liviona_20_bi','18.00','33.60',45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2174,151,377,202,188,193,278,150,253,0,0,0,80,174,NULL,0,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34),
(1421,1611,21611,'Unpleasant Humming','','unpleasant_humming','12.00','26.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3907,277,401,245,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1422,1612,21612,'Unpleasant Humming','','unpleasant_humming','12.00','26.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,5533,392,534,184,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1423,1613,21613,'Unpleasant Shout','','unpleasant_humming_20_bi','13.50','31.20',46,'male','L2Monster','Fighter',40,1943,22.000,707,2.100,40,43,30,21,20,10,2360,167,401,245,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1424,1614,21614,'Death Flyer','','dark_horror','20.00','35.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,4035,289,427,253,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.37),
(1425,1615,21615,'Death Flyer','','dark_horror','20.00','35.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,5714,410,568,190,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.37),
(1426,1616,21616,'Gigantic Flyer','','dark_horror_bi','20.00','42.00',47,'male','L2Monster','Fighter',40,2016,22.000,738,2.100,40,43,30,21,20,10,2607,187,427,253,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.37),
(1427,1617,21617,'Fiend Archer','','fiend_archer','17.00','55.00',48,'male','L2Monster','Ranger',500,2091,5.500,768,2.100,40,43,30,21,20,10,4103,300,1007,222,231,212,249,150,227,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(1428,1618,21618,'Fiend Archer','','fiend_archer','17.00','55.00',48,'male','L2Monster','Ranger',500,2091,5.500,768,2.100,40,43,30,21,20,10,5811,425,1341,167,231,212,249,150,227,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(1429,1619,21619,'Pit Archer','','fiend_archer_20_bi','20.00','66.00',48,'male','L2Monster','Ranger',500,2091,22.000,768,2.100,40,43,30,21,20,10,2651,193,1007,222,231,212,249,150,227,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(1430,1620,21620,'Musveren','','field_stalker','15.00','30.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,3951,292,480,270,247,219,278,0,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1431,1621,21621,'Musveren','','field_stalker','15.00','30.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,5595,414,640,202,247,219,278,0,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1432,1622,21622,'Greater Musveren','','field_stalker_20_bi','18.00','36.00',49,'male','L2Monster','Fighter',40,2168,22.000,799,2.100,40,43,30,21,20,10,2553,188,480,270,247,219,278,0,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1433,1623,21623,'Zaken''s Guard','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,4994,376,445,278,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,1,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52),
(1434,1624,21624,'Zaken''s Guard','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,7072,533,593,209,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,1,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52),
(1435,1625,21625,'Zaken''s Elite Guard','','skeleton_royal_guard_20_bi','13.00','34.50',50,'male','L2Monster','Fighter',40,2245,22.000,830,2.100,40,43,30,21,20,10,2858,215,445,278,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,1,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52),
(1436,1626,21626,'Kaim Vanul','','kaim_vanul','24.00','40.00',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,4453,340,539,286,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1437,1627,21627,'Kaim Vanul','','kaim_vanul','24.00','40.00',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,6306,481,718,215,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1438,1628,21628,'Kaim Vanul Lad','','kaim_vanul_20_bi','28.00','48.00',51,'male','L2Monster','Fighter',40,2323,26.000,861,2.400,40,43,30,21,20,10,2877,219,539,286,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1439,1629,21629,'Pirate Zombie Captain','','pirates_zombie_captain','17.00','28.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,6727,520,499,295,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.76),
(1440,1630,21630,'Pirate Zombie Captain','','pirates_zombie_captain','17.00','28.00',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,9526,737,664,221,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.76),
(1441,1631,21631,'Zombie Captain''s Spiritual Body','','pirates_zombie_captain_20_bi','20.00','33.60',52,'male','L2Monster','Fighter',40,2402,26.000,892,2.400,40,43,30,21,20,10,3948,305,499,295,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,1,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1442,1632,21632,'Doll Blader','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,5339,420,527,258,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,0,'Local','',0,0,93,7,10,8,0,0,10,0.50),
(1443,1633,21633,'Doll Blader','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,7560,594,701,194,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,0,'Local','',0,0,93,7,10,8,0,0,10,0.50),
(1444,1634,21634,'Crimson Doll Blader','','doll_blader_20_bi','7.00','15.00',53,'male','L2Monster','Fighter',40,2481,26.000,923,2.400,40,43,30,21,20,10,3450,271,527,258,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,0,'Local','',0,0,93,7,10,8,0,0,10,0.50),
(1445,1635,21635,'Vale Master','','vale_master','12.00','40.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1446,1636,21636,'Vale Master','','vale_master','12.00','40.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,7212,575,846,199,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1447,1637,21637,'Crimson Vale Master','','vale_master_20_bi','14.50','48.00',54,'male','L2Monster','Fighter',40,2562,26.000,955,2.400,40,43,30,21,20,10,3291,262,636,266,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1448,1638,21638,'Dread Wolf','','dire_wolf','13.00','11.00',35,'male','L2Monster','Fighter',40,1220,2.250,446,1.800,40,43,30,21,20,10,2303,136,211,154,89,137,278,150,253,0,0,0,24,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(1449,1639,21639,'Tasaba Lizardman','','virud_lizardman_scout','10.00','22.00',36,'male','L2Monster','Ranger',500,1279,2.250,463,1.800,40,43,30,21,20,10,2725,164,417,193,96,142,249,0,227,2507,0,0,43,140,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.72),
(1450,1640,21640,'Tasaba Lizardman Shaman ','','virud_lizardman_shaman','10.00','29.00',37,'male','L2Monster','Priest',40,1338,2.250,480,1.800,40,43,30,21,20,10,2003,124,295,116,104,147,278,0,253,7,0,0,43,140,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(1451,1641,21641,'Ogre','','ogre','21.00','44.00',38,'male','L2Monster','Fighter',40,1400,2.250,497,1.800,40,43,30,21,20,10,3555,222,300,207,112,153,200,150,182,98,0,0,22,174,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.69),
(1452,1642,21642,'Tasaba Lizardman Sniper','','virud_lizardman_scout','10.00','22.00',39,'male','L2Monster','Ranger',500,1462,2.250,514,1.800,40,43,30,21,20,10,3263,208,566,165,121,158,249,150,227,2507,0,0,43,140,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.72),
(1453,1643,21643,'Tasaba Lizardman Sniper','','virud_lizardman_scout','10.00','22.00',39,'male','L2Monster','Ranger',500,1462,2.250,514,1.800,40,43,30,21,20,10,4146,264,685,137,121,158,249,150,227,2507,0,0,43,140,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,10,0.72),
(1454,1644,21644,'Lienrik','','lienrik','12.00','50.00',39,'male','L2Monster','Fighter',40,1462,2.250,514,1.800,40,43,30,21,20,10,1990,126,297,146,121,158,317,0,289,0,0,0,100,150,'lienrik_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1455,1645,21645,'Lienrik Lad','','lienrik','12.00','50.00',40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,3836,248,317,151,131,164,317,150,289,0,0,0,100,174,'lienrik_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1456,1646,21646,'Grave Scarab','','scarab','14.00','22.00',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,10206,1050,1463,502,885,407,278,0,253,0,0,0,45,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1457,1647,21647,'Scavenger Scarab','','scarab','14.00','22.00',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,8609,886,1463,502,885,407,278,150,253,0,0,0,45,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1458,1648,21648,'Grave Ant','','ant_soldier','35.00','17.00',74,'male','L2Monster','Fighter',40,4158,8.500,1637,3.000,40,43,30,21,20,10,9383,978,1513,512,921,416,278,0,253,0,0,0,80,150,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1459,1649,21649,'Scavenger Ant','','ant_soldier','35.00','17.00',74,'male','L2Monster','Fighter',40,4158,8.500,1637,3.000,40,43,30,21,20,10,11099,1157,1513,512,921,416,278,150,253,0,0,0,80,150,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1460,1650,21650,'Shrine Knight','','skeleton_knight','10.00','25.00',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,10149,1071,1563,523,957,425,278,0,253,150,103,0,40,165,'',0,1,'Local','',0,20,159,7,30,4,4,0,-6,0.17),
(1461,1651,21651,'Shrine Guard','','skeleton_pikeman','10.00','28.00',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,9695,1023,1563,523,957,425,278,0,253,98,0,0,50,170,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1462,1652,21652,'Scarlet Stakato Noble','','blade_stakato_drone','15.00','39.00',79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,9382,1039,1544,566,1107,459,317,150,289,235,0,0,25,165,'fire_clan',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.58),
(1463,1653,21653,'Assassin Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,6804,763,1814,576,1144,468,278,150,253,0,0,0,45,165,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(1464,1654,21654,'Necromancer of Destruction','','vale_master_20_bi','14.50','48.00',81,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8042,913,1863,587,1182,477,278,150,253,0,0,0,70,140,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(1465,1655,21655,'Arimanes of Destruction','','ahrimanes','14.00','57.75',82,'male','L2Monster','Mystic',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7148,821,2655,598,1220,485,200,150,182,6722,0,0,35,185,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1466,1656,21656,'Ashuras of Destruction','','ashuras_30_bi','17.00','49.00',84,'male','L2Monster','Fighter',40,4766,51.000,2011,3.000,40,43,30,21,20,10,10463,1230,2006,619,1296,502,278,150,253,0,0,0,41,190,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1467,1657,21657,'Magma Drake','','inferno_drake_20_bi','29.00','42.00',85,'male','L2Monster','Mystic',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9062,1078,2052,629,1333,511,278,150,253,0,0,0,57,185,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1468,1658,21658,'Punishment of Splendor','','kel_mahum_warrior','13.00','28.00',64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8837,809,1031,408,589,331,278,0,253,242,0,0,50,165,'saint_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1469,1659,21659,'Otherworldly Invader Soldier','','neer_crawler','14.00','22.00',30,'male','L2Monster','Fighter',40,954,10.500,365,1.500,40,43,30,21,20,10,1457,79,115,119,58,114,317,0,289,0,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(1470,1660,21660,'Otherworldly Invader Soldier','','neer_crawler','14.00','22.00',35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,2073,122,126,191,89,137,317,150,289,0,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(1471,1661,21661,'Otherworldly Invader Archer','','skeleton_archer','11.00','27.00',33,'male','L2Monster','Ranger',500,1109,13.500,413,1.800,40,43,30,21,20,10,1492,85,491,100,75,128,249,150,227,275,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(1472,1662,21662,'Otherworldly Invader Elite Soldier','','dark_horror','20.00','35.00',35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1726,102,192,144,89,137,278,150,253,0,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1473,1663,21663,'Otherworldly Invader Shaman','','dark_horror','20.00','35.00',33,'male','L2Monster','Fighter',40,1109,13.500,413,1.800,40,43,30,21,20,10,1884,108,166,134,75,128,278,150,253,0,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1474,1664,21664,'Otherworldly Invader Priest','','dark_horror','20.00','35.00',30,'male','L2Monster','Priest',40,954,7.000,365,1.500,40,43,30,21,20,10,1511,82,132,119,58,114,278,0,253,0,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1475,1665,21665,'Otherworldly Invader Magus','','dark_horror','20.00','35.00',35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1362,80,256,108,89,137,278,150,253,0,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1476,1666,21666,'Otherworldly Invader Martyrs','','dark_horror','20.00','35.00',30,'male','L2Monster','Fighter',40,954,10.500,365,1.500,40,43,30,21,20,10,1018,55,132,119,58,114,278,0,253,0,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(1477,1667,21667,'Otherworldly Invader Warrior','','skeleton','11.00','25.00',33,'male','L2Monster','Fighter',40,1109,13.500,413,1.800,40,43,30,21,20,10,1211,69,145,157,75,128,317,150,289,220,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1478,1668,21668,'Otherworldly Invader Soldier','','neer_crawler','14.00','22.00',30,'male','L2Monster','Fighter',40,954,10.500,365,1.500,40,43,30,21,20,10,1071,58,115,119,58,114,317,150,289,0,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(1479,1669,21669,'Otherworldly Invader Discipline','','skeleton','11.00','25.00',33,'male','L2Monster','Fighter',40,1109,13.500,413,1.800,40,43,30,21,20,10,1275,73,145,157,75,128,317,0,289,220,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1480,1670,21670,'Otherworldly Invader Berserker','','skeleton','11.00','25.00',35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1785,105,139,205,89,137,317,150,289,220,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1481,1671,21671,'Otherworldly Invader Food','','mimic','8.50','8.50',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1482,1672,21672,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,27.000,446,1.800,40,43,30,21,20,10,1599,94,192,169,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1483,1673,21673,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,27.000,446,1.800,40,43,30,21,20,10,1629,96,192,169,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1484,1674,21674,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,1.130,446,1.800,40,43,30,21,20,10,1525,92,192,169,89,137,278,0,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1485,1675,21675,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',30,'male','L2Monster','Fighter',40,954,1.750,365,1.500,40,43,30,21,20,10,1555,84,132,140,58,114,278,0,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1486,1676,21676,'Otherworldly Invader Warrior','','skeleton','11.00','25.00',33,'male','L2Monster','Fighter',40,1109,27.000,413,1.800,40,43,30,21,20,10,1452,83,145,157,75,128,317,150,289,220,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1487,1677,21677,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',30,'male','L2Monster','Fighter',40,954,21.000,365,1.500,40,43,30,21,20,10,1164,63,109,170,58,114,278,150,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1488,1678,21678,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',33,'male','L2Monster','Fighter',40,1109,27.000,413,1.800,40,43,30,21,20,10,1409,80,201,130,75,128,278,150,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1489,1679,21679,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',30,'male','L2Monster','Fighter',40,954,21.000,365,1.500,40,43,30,21,20,10,1148,62,109,170,58,114,278,150,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1490,1680,21680,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,27.000,446,1.800,40,43,30,21,20,10,1562,92,232,140,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.21),
(1491,1681,21681,'Otherworldly Invader Magus','','dark_horror','20.00','35.00',33,'male','L2Monster','Fighter',40,1109,27.000,413,1.800,40,43,30,21,20,10,1343,77,166,157,75,128,278,0,253,0,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(1492,1682,21682,'Dimension Invader Soldier','','neer_crawler','14.00','22.00',40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,2590,167,238,171,131,164,317,0,289,0,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(1493,1683,21683,'Dimension Invader Soldier','','neer_crawler','14.00','22.00',45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,3427,238,248,269,188,193,317,150,289,0,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(1494,1684,21684,'Dimension Invader Archer','','skeleton_archer','11.00','27.00',43,'male','L2Monster','Ranger',500,1728,16.500,618,2.100,40,43,30,21,20,10,2534,171,984,142,163,181,249,150,227,279,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(1495,1685,21685,'Dimension Invader Elite Soldier','','crimson_doll','15.00','38.00',45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,2853,198,377,202,188,193,278,150,253,0,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.67),
(1496,1686,21686,'Dimension Invader Shaman','','crimson_doll','15.00','38.00',43,'male','L2Monster','Fighter',40,1728,16.500,618,2.100,40,43,30,21,20,10,3199,216,332,189,163,181,278,150,253,0,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.67),
(1497,1687,21687,'Dimension Invader Priest','','crimson_doll','15.00','38.00',40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,2686,173,273,171,131,164,278,0,253,0,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.67),
(1498,1688,21688,'Dimension Invader Magus','','crimson_doll','15.00','38.00',45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,2253,156,502,152,188,193,278,150,253,0,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.67),
(1499,1689,21689,'Dimension Invader Martyrs','','crimson_doll','15.00','38.00',40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,1809,117,273,171,131,164,278,0,253,0,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,10,0.67),
(1500,1690,21690,'Dimension Invader Warrior','','skeleton_knight','10.00','25.00',43,'male','L2Monster','Fighter',40,1728,16.500,618,2.100,40,43,30,21,20,10,2057,139,332,223,163,181,278,150,253,70,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(1501,1691,21691,'Dimension Invader Soldier','','neer_crawler','14.00','22.00',40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,1905,123,238,171,131,164,317,150,289,0,0,0,50,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(1502,1692,21692,'Dimension Invader Discipline','','skeleton_knight','10.00','25.00',43,'male','L2Monster','Fighter',40,1728,16.500,618,2.100,40,43,30,21,20,10,2166,146,332,223,163,181,278,0,253,70,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(1503,1693,21693,'Dimension Invader Berserker ','','skeleton_knight','10.00','25.00',45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,2951,205,312,288,188,193,278,150,253,70,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(1504,1694,21694,'Dimension Invader Food','','mimic','8.50','8.50',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1505,1695,21695,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,33.000,677,2.100,40,43,30,21,20,10,2643,183,377,238,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1506,1696,21696,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,33.000,677,2.100,40,43,30,21,20,10,2693,187,377,238,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1507,1697,21697,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,1.380,677,2.100,40,43,30,21,20,10,2521,176,377,238,188,193,278,0,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1508,1698,21698,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,2764,178,273,201,131,164,278,0,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1509,1699,21699,'Dimension Invader Warrior','','skeleton_knight','10.00','25.00',43,'male','L2Monster','Fighter',40,1728,33.000,618,2.100,40,43,30,21,20,10,2466,166,332,223,163,181,278,150,253,70,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(1510,1700,21700,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',40,'male','L2Monster','Fighter',40,1527,27.000,531,1.800,40,43,30,21,20,10,2070,133,225,244,131,164,278,150,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1511,1701,21701,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',43,'male','L2Monster','Fighter',40,1728,33.000,618,2.100,40,43,30,21,20,10,2392,161,402,184,163,181,278,150,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1512,1702,21702,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',40,'male','L2Monster','Fighter',40,1527,27.000,531,1.800,40,43,30,21,20,10,2041,131,225,244,131,164,278,150,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1513,1703,21703,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,33.000,677,2.100,40,43,30,21,20,10,2583,179,457,196,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1514,1704,21704,'Dimension Invader Magus','','crimson_doll','15.00','38.00',43,'male','L2Monster','Fighter',40,1728,33.000,618,2.100,40,43,30,21,20,10,2281,154,332,223,163,181,278,0,253,0,0,0,60,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.67),
(1515,1705,21705,'Purgatory Invader Soldier','','doll_blader','6.00','12.00',50,'male','L2Monster','Fighter',40,2245,16.500,830,2.100,40,43,30,21,20,10,4047,305,445,236,264,226,317,0,289,5129,5129,0,22,165,'ssq_clan',300,0,'Local','',0,0,87,7,10,8,0,0,10,0.50),
(1516,1706,21706,'Purgatory Invader Soldier','','doll_blader','6.00','12.00',55,'male','L2Monster','Fighter',40,2643,19.500,987,2.400,40,43,30,21,20,10,5120,413,440,364,360,261,317,150,289,5129,5129,0,22,165,'ssq_clan',300,0,'Local','',0,0,98,7,10,8,0,0,10,0.50),
(1517,1707,21707,'Purgatory Invader Archer','','skeleton_archer','11.00','27.00',53,'male','L2Monster','Ranger',500,2481,19.500,923,2.400,40,43,30,21,20,10,3850,302,1782,194,319,247,249,150,227,282,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(1518,1708,21708,'Purgatory Invader Elite Soldier','','banshee','9.00','23.00',55,'female','L2Monster','Mystic',40,2643,19.500,987,2.400,40,43,30,21,20,10,4262,344,670,273,360,261,278,150,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1519,1709,21709,'Purgatory Invader Shaman','','banshee','9.00','23.00',53,'female','L2Monster','Mystic',40,2481,19.500,923,2.400,40,43,30,21,20,10,4861,382,602,258,319,247,278,150,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1520,1710,21710,'Purgatory Invader Priest','','banshee','9.00','23.00',50,'female','L2Monster','Priest',40,2245,11.000,830,2.100,40,43,30,21,20,10,4198,316,509,236,264,226,278,0,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1521,1711,21711,'Purgatory Invader Magus','','banshee','9.00','23.00',55,'female','L2Monster','Mystic',40,2643,19.500,987,2.400,40,43,30,21,20,10,3365,271,892,205,360,261,278,150,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1522,1712,21712,'Purgatory Invader Martyrs','','banshee','9.00','23.00',50,'female','L2Monster','Mystic',40,2245,16.500,830,2.100,40,43,30,21,20,10,2828,213,509,236,264,226,278,0,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1523,1713,21713,'Purgatory Invader Warrior','','skeleton_royal_guard','11.00','28.50',53,'male','L2Monster','Fighter',40,2481,19.500,923,2.400,40,43,30,21,20,10,3125,245,527,304,319,247,317,150,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,107,7,10,8,0,0,-6,0.52),
(1524,1714,21714,'Purgatory Invader Soldier','','doll_blader','6.00','12.00',50,'male','L2Monster','Fighter',40,2245,16.500,830,2.100,40,43,30,21,20,10,2977,224,445,236,264,226,317,150,289,5129,5129,0,22,165,'ssq_clan',300,0,'Local','',0,0,87,7,10,8,0,0,10,0.50),
(1525,1715,21715,'Purgatory Invader Disciples','','skeleton_royal_guard','11.00','28.50',53,'male','L2Monster','Fighter',40,2481,19.500,923,2.400,40,43,30,21,20,10,3291,258,527,304,319,247,317,0,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,107,7,10,8,0,0,-6,0.52),
(1526,1716,21716,'Purgatory Invader Berserker','','skeleton_royal_guard','11.00','28.50',55,'male','L2Monster','Fighter',40,2643,19.500,987,2.400,40,43,30,21,20,10,4409,356,484,389,360,261,317,150,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,111,7,10,8,0,0,-6,0.52),
(1527,1717,21717,'Purgatory Invader Food','','mimic','8.50','8.50',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3636,274,509,278,264,226,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1528,1718,21718,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,39.000,987,2.400,40,43,30,21,20,10,3949,318,670,322,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1529,1719,21719,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,39.000,987,2.400,40,43,30,21,20,10,4023,324,670,322,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1530,1720,21720,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,1.630,987,2.400,40,43,30,21,20,10,3766,304,670,322,360,261,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1531,1721,21721,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',50,'female','L2Monster','Mystic',40,2245,2.750,830,2.100,40,43,30,21,20,10,4319,326,509,278,264,226,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1532,1722,21722,'Purgatory Invader Warrior','','skeleton_royal_guard','11.00','28.50',53,'male','L2Monster','Fighter',40,2481,39.000,923,2.400,40,43,30,21,20,10,3746,294,527,304,319,247,317,150,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,107,7,10,8,0,0,-6,0.52),
(1533,1723,21723,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',50,'female','L2Monster','Mystic',40,2245,33.000,830,2.100,40,43,30,21,20,10,3235,243,421,336,264,226,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1534,1724,21724,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',53,'female','L2Monster','Mystic',40,2481,39.000,923,2.400,40,43,30,21,20,10,3635,285,729,251,319,247,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1535,1725,21725,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',50,'female','L2Monster','Mystic',40,2245,33.000,830,2.100,40,43,30,21,20,10,3189,240,421,336,264,226,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1536,1726,21726,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,39.000,987,2.400,40,43,30,21,20,10,3859,311,811,266,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1537,1727,21727,'Purgatory Invader Magus','','banshee','9.00','23.00',53,'female','L2Monster','Mystic',40,2481,39.000,923,2.400,40,43,30,21,20,10,3465,272,602,258,319,247,278,0,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1538,1728,21728,'Forbidden Path Invader Elite Soldier','','doll_blader','6.00','12.00',60,'male','L2Monster','Fighter',40,3054,19.500,1150,2.400,40,43,30,21,20,10,5828,506,753,313,478,299,317,0,289,5129,5129,0,22,165,'ssq_clan',300,0,'Local','',0,0,108,7,10,8,0,0,10,0.50),
(1539,1729,21729,'Forbidden Path Invader Elite Soldier','','doll_blader','6.00','12.00',65,'male','L2Monster','Fighter',40,3465,22.500,1319,2.700,40,43,30,21,20,10,7151,664,708,473,619,340,317,150,289,5129,5129,0,22,165,'ssq_clan',300,0,'Local','',0,0,119,7,10,8,0,0,10,0.50),
(1540,1730,21730,'Forbidden Path Invader Archer','','skeleton_archer','11.00','27.00',63,'male','L2Monster','Ranger',500,3302,22.500,1251,2.700,40,43,30,21,20,10,5439,491,2920,254,560,323,249,150,227,284,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(1541,1731,21731,'Forbidden Path Invader Elite Soldier','','banshee','9.00','23.00',65,'female','L2Monster','Mystic',40,3465,22.500,1319,2.700,40,43,30,21,20,10,5952,553,1077,355,619,340,278,150,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1542,1732,21732,'Forbidden Path Invader Shaman','','banshee','9.00','23.00',63,'female','L2Monster','Mystic',40,3302,22.500,1251,2.700,40,43,30,21,20,10,6868,620,987,338,560,323,278,150,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1543,1733,21733,'Forbidden Path Invader Priest','','banshee','9.00','23.00',60,'female','L2Monster','Priest',40,3054,13.000,1150,2.400,40,43,30,21,20,10,6045,525,860,313,478,299,278,0,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1544,1734,21734,'Forbidden Path Invader Magus','','banshee','9.00','23.00',65,'female','L2Monster','Mystic',40,3465,22.500,1319,2.700,40,43,30,21,20,10,4700,436,1433,267,619,340,278,150,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1545,1735,21735,'Forbidden Path Invader Martyrs','','banshee','9.00','23.00',60,'female','L2Monster','Mystic',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4072,353,860,313,478,299,278,0,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1546,1736,21736,'Forbidden Path Invader Warrior','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,4415,398,864,398,560,323,317,150,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,131,7,10,8,0,0,-6,0.52),
(1547,1737,21737,'Forbidden Path Invader Soldier','','doll_blader','6.00','12.00',60,'male','L2Monster','Fighter',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4287,372,753,313,478,299,317,150,289,5129,5129,0,22,165,'ssq_clan',300,0,'Local','',0,0,108,7,10,8,0,0,10,0.50),
(1548,1738,21738,'Forbidden Path Invader Disciple','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,4650,419,864,398,560,323,317,0,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,131,7,10,8,0,0,-6,0.52),
(1549,1739,21739,'Forbidden Path Invader Berserker','','skeleton_royal_guard','11.00','28.50',65,'male','L2Monster','Fighter',40,3465,22.500,1319,2.700,40,43,30,21,20,10,6158,572,778,506,619,340,317,150,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,135,7,10,8,0,0,-6,0.52),
(1550,1740,21740,'Forbidden Path Invader Food','','mimic','8.50','8.50',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,5235,454,860,368,478,299,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1551,1741,21741,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,45.000,1319,2.700,40,43,30,21,20,10,5515,512,1077,418,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1552,1742,21742,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,45.000,1319,2.700,40,43,30,21,20,10,5620,522,1077,418,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1553,1743,21743,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,1.880,1319,2.700,40,43,30,21,20,10,5259,488,1077,418,619,340,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1554,1744,21744,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,3.250,1150,2.400,40,43,30,21,20,10,6220,540,860,368,478,299,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1555,1745,21745,'Forbidden Path Invader Warrior','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,45.000,1251,2.700,40,43,30,21,20,10,5294,478,864,398,560,323,317,150,289,946,946,0,80,165,'ssq_clan',300,1,'Local','',0,20,131,7,10,8,0,0,-6,0.52),
(1556,1746,21746,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,39.000,1150,2.400,40,43,30,21,20,10,4658,404,711,446,478,299,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1557,1747,21747,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',63,'female','L2Monster','Mystic',40,3302,45.000,1251,2.700,40,43,30,21,20,10,5136,463,1194,329,560,323,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1558,1748,21748,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,39.000,1150,2.400,40,43,30,21,20,10,4592,398,711,446,478,299,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1559,1749,21749,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,45.000,1319,2.700,40,43,30,21,20,10,5390,500,1303,346,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1560,1750,21750,'Forbidden Path Invader Magus','','banshee','9.00','23.00',63,'female','L2Monster','Mystic',40,3302,45.000,1251,2.700,40,43,30,21,20,10,4897,442,987,338,560,323,278,0,253,3939,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(1561,1751,21751,'Dark Omen Invader Soldier','','giant_zombie','13.00','40.00',70,'male','L2Monster','Mystic',40,3862,22.500,1493,2.700,40,43,30,21,20,10,7933,786,1314,470,780,382,278,0,253,0,0,0,20,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1562,1752,21752,'Dark Omen Invader Soldier','','giant_zombie','13.00','40.00',75,'male','L2Monster','Mystic',40,4229,25.500,1673,3.000,40,43,30,21,20,10,9521,1004,1175,696,957,425,278,150,253,0,0,0,20,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1563,1753,21753,'Dark Omen Invader Archer','','skeleton_archer','11.00','27.00',73,'male','L2Monster','Ranger',500,4086,25.500,1601,3.000,40,43,30,21,20,10,7303,751,4327,320,885,407,249,150,227,288,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(1564,1754,21754,'Dark Omen Invader Elite Soldier','','doll_master','20.00','42.00',75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,7925,836,1368,445,957,425,317,150,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1565,1755,21755,'Dark Omen Invader Shaman','','doll_master','20.00','42.00',73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,9222,949,1280,426,885,407,317,150,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1566,1756,21756,'Dark Omen Invader Priest','','doll_master','20.00','42.00',70,'male','L2Monster','Priest',40,3862,15.000,1493,2.700,40,43,30,21,20,10,8228,816,1150,399,780,382,317,0,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1567,1757,21757,'Dark Omen Invader Magus','','doll_master','20.00','42.00',75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,6258,660,1821,334,957,425,317,150,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1568,1758,21758,'Dark Omen Invader Martyrs','','doll_master','20.00','42.00',70,'male','L2Monster','Fighter',40,3862,22.500,1493,2.700,40,43,30,21,20,10,5542,549,1150,399,780,382,317,0,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1569,1759,21759,'Dark Omen Invader Warrior','','imperial_warlord_zombie','7.00','30.00',73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,5929,610,1463,502,885,407,278,150,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,155,7,30,4,4,0,-6,0.48),
(1570,1760,21760,'Dark Omen Invader Soldier','','giant_zombie','13.00','40.00',70,'male','L2Monster','Mystic',40,3862,22.500,1493,2.700,40,43,30,21,20,10,5835,578,1314,470,780,382,278,150,253,0,0,0,20,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1571,1761,21761,'Dark Omen Invader Disciple','','imperial_warlord_zombie','7.00','30.00',73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,6243,642,1463,502,885,407,278,0,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,155,7,30,4,4,0,-6,0.48),
(1572,1762,21762,'Dark Omen Invader Berserker','','imperial_warlord_zombie','7.00','30.00',75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,8198,864,1292,633,957,425,278,150,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,159,7,30,4,4,0,-6,0.48),
(1573,1763,21763,'Dark Omen Invader Food','','mimic','8.50','8.50',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,7126,707,1314,470,780,382,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1574,1764,21764,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,51.000,1673,3.000,40,43,30,21,20,10,7343,774,1563,523,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1575,1765,21765,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,51.000,1673,3.000,40,43,30,21,20,10,7482,789,1563,523,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1576,1766,21766,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,2.130,1673,3.000,40,43,30,21,20,10,7002,740,1563,523,957,425,278,0,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1577,1767,21767,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,8466,840,1314,470,780,382,278,0,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1578,1768,21768,'Dark Omen Invader Warrior','','imperial_warlord_zombie','7.00','30.00',73,'male','L2Monster','Fighter',40,4086,51.000,1601,3.000,40,43,30,21,20,10,7108,731,1463,502,885,407,278,150,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,155,7,30,4,4,0,-6,0.48),
(1579,1769,21769,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,3862,45.000,1493,2.700,40,43,30,21,20,10,6341,628,1086,569,780,382,278,150,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1580,1770,21770,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',73,'male','L2Monster','Fighter',40,4086,51.000,1601,3.000,40,43,30,21,20,10,6896,709,1770,415,885,407,278,150,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1581,1771,21771,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,3862,45.000,1493,2.700,40,43,30,21,20,10,6251,619,1086,569,780,382,278,150,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1582,1772,21772,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,51.000,1673,3.000,40,43,30,21,20,10,7176,757,1892,432,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1583,1773,21773,'Dark Omen Invader Magus','','doll_master','20.00','42.00',73,'male','L2Monster','Fighter',40,4086,51.000,1601,3.000,40,43,30,21,20,10,6575,676,1280,426,885,407,317,0,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1584,1774,21774,'Messenger Invader Soldier','','giant_zombie','13.00','40.00',80,'male','L2Monster','Mystic',40,4550,25.500,1859,3.000,40,43,30,21,20,10,10362,1163,1814,576,1144,468,278,0,253,0,0,0,20,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1585,1775,21775,'Messenger Invader Soldier','','giant_zombie','13.00','40.00',85,'male','L2Monster','Mystic',40,4813,25.500,2049,3.000,40,43,30,21,20,10,12230,1455,1542,837,1333,511,278,150,253,0,0,0,20,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1586,1776,21776,'Messenger Invader Archer','','skeleton_archer','11.00','27.00',83,'male','L2Monster','Ranger',500,4716,25.500,1972,3.000,40,43,30,21,20,10,9442,1097,5796,388,1258,494,249,150,227,289,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,1500,10,0.80),
(1587,1777,21777,'Messenger Invader Elite Soldier','','doll_master','20.00','42.00',85,'male','L2Monster','Fighter',40,4813,25.500,2049,3.000,40,43,30,21,20,10,10179,1211,1796,535,1333,511,317,150,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1588,1778,21778,'Messenger Invader Shaman','','doll_master','20.00','42.00',83,'male','L2Monster','Fighter',40,4716,25.500,1972,3.000,40,43,30,21,20,10,11921,1386,1714,517,1258,494,317,150,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1589,1779,21779,'Messenger Invader Priest','','doll_master','20.00','42.00',80,'male','L2Monster','Priest',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10747,1206,1587,490,1144,468,317,0,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1590,1780,21780,'Messenger Invader Magus','','doll_master','20.00','42.00',85,'male','L2Monster','Fighter',40,4813,25.500,2049,3.000,40,43,30,21,20,10,8038,957,2390,402,1333,511,317,150,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1591,1781,21781,'Messenger Invader Martyrs','','doll_master','20.00','42.00',80,'male','L2Monster','Fighter',40,4550,25.500,1859,3.000,40,43,30,21,20,10,7239,812,1587,490,1144,468,317,0,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1592,1782,21782,'Messenger Invader Warrior','','imperial_warlord_zombie','7.00','30.00',83,'male','L2Monster','Fighter',40,4716,25.500,1972,3.000,40,43,30,21,20,10,7664,891,1959,608,1258,494,278,150,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,176,7,30,4,4,0,-6,0.48),
(1593,1783,21783,'Messenger Invader Soldier','','giant_zombie','13.00','40.00',80,'male','L2Monster','Mystic',40,4550,25.500,1859,3.000,40,43,30,21,20,10,7621,855,1814,576,1144,468,278,150,253,0,0,0,20,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1594,1784,21784,'Messenger Invader Disciple','','imperial_warlord_zombie','7.00','30.00',83,'male','L2Monster','Fighter',40,4716,25.500,1972,3.000,40,43,30,21,20,10,8071,938,1959,608,1258,494,278,0,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,176,7,30,4,4,0,-6,0.48),
(1595,1785,21785,'Messenger Invader Berserker','','imperial_warlord_zombie','7.00','30.00',85,'male','L2Monster','Fighter',40,4813,25.500,2049,3.000,40,43,30,21,20,10,10530,1253,1696,761,1333,511,278,150,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,180,7,30,4,4,0,-6,0.48),
(1596,1786,21786,'Messenger Invader Food','','mimic','8.50','8.50',80,'male','L2Monster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,9308,1045,1814,576,1144,468,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1597,1787,21787,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',85,'male','L2Monster','Fighter',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9432,1122,2052,629,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1598,1788,21788,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',85,'male','L2Monster','Fighter',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9610,1144,2052,629,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1599,1789,21789,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',85,'male','L2Monster','Fighter',40,4813,2.130,2049,3.000,40,43,30,21,20,10,8994,1072,2052,629,1333,511,278,0,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1600,1790,21790,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4550,4.250,1859,3.000,40,43,30,21,20,10,11058,1242,1814,576,1144,468,278,0,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1601,1791,21791,'Messenger Invader Warrior','','imperial_warlord_zombie','7.00','30.00',83,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,9189,1068,1959,608,1258,494,278,150,253,134,6721,0,39,165,'ssq_clan',300,1,'Local','',0,20,176,7,30,4,4,0,-6,0.48),
(1602,1792,21792,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,8282,929,1499,698,1144,468,278,150,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1603,1793,21793,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',83,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,8915,1036,2371,503,1258,494,278,150,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1604,1794,21794,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,8165,916,1499,698,1144,468,278,150,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1605,1795,21795,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',85,'male','L2Monster','Fighter',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9217,1097,2483,520,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1606,1796,21796,'Messenger Invader Magus','','doll_master','20.00','42.00',83,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,8499,988,1714,517,1258,494,317,0,289,0,0,0,80,165,'ssq_clan',300,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(1607,1797,21797,'Spirit of Timiniel','','pixy','5.00','25.00',55,'female','L2Monster','Fighter',40,2643,3.250,987,2.400,40,43,30,21,20,10,3959,320,554,331,360,261,278,0,253,0,0,0,80,165,'timiniel_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.72),
(1608,1798,21798,'Ghost of a Gatekeeper','','skeleton_knight','10.00','25.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,7104,759,1614,534,994,433,278,0,253,150,103,0,40,165,'',0,1,'DRIVER','',0,20,161,7,30,4,4,0,-6,0.17),
(1609,1799,21799,'Ghost of a Gatekeeper','','skeleton_knight','10.00','25.00',76,'male','L2Monster','Fighter',40,4297,25.500,1710,3.000,40,43,30,21,20,10,8710,931,1614,534,994,433,278,0,253,150,103,0,40,165,'',0,1,'DRIVER','',0,20,161,7,30,4,4,0,-6,0.17),
(1610,1800,21800,'Vassal Ghost','','zombie','13.00','21.00',77,'male','L2Monster','Mystic',40,4364,17.000,1747,3.000,40,43,30,21,20,10,6616,716,1664,544,1031,442,278,0,253,0,0,0,15,165,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.43),
(1611,1801,21801,'Treasure Chest','','mimic','8.50','8.50',21,'male','L2Chest','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,630,29,63,98,25,80,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1612,1802,21802,'Treasure Chest','','mimic','8.50','8.50',24,'male','L2Chest','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,771,38,81,111,34,90,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1613,1803,21803,'Treasure Chest','','mimic','8.50','8.50',27,'male','L2Chest','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,918,47,104,125,45,102,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1614,1804,21804,'Treasure Chest','','mimic','8.50','8.50',30,'male','L2Chest','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1080,59,132,140,58,114,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1615,1805,21805,'Treasure Chest','','mimic','8.50','8.50',33,'male','L2Chest','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1306,75,166,157,75,128,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1616,1806,21806,'Treasure Chest','','mimic','8.50','8.50',36,'male','L2Chest','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1555,94,206,175,96,142,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1617,1807,21807,'Treasure Chest','','mimic','8.50','8.50',39,'male','L2Chest','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,1825,116,255,195,121,158,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1618,1808,21808,'Treasure Chest','','mimic','8.50','8.50',42,'male','L2Chest','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2116,141,311,215,152,175,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1619,1809,21809,'Treasure Chest','','mimic','8.50','8.50',45,'male','L2Chest','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2430,169,377,238,188,193,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1620,1810,21810,'Treasure Chest','','mimic','8.50','8.50',48,'male','L2Chest','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,2764,202,453,261,231,212,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1621,1811,21811,'Treasure Chest','','mimic','8.50','8.50',51,'male','L2Chest','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3121,238,539,286,281,232,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1622,1812,21812,'Treasure Chest','','mimic','8.50','8.50',54,'male','L2Chest','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3499,279,636,313,339,254,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1623,1813,21813,'Treasure Chest','','mimic','8.50','8.50',57,'male','L2Chest','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,3898,324,743,340,405,276,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1624,1814,21814,'Treasure Chest','','mimic','8.50','8.50',60,'male','L2Chest','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4320,375,860,368,478,299,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1625,1815,21815,'Treasure Chest','','mimic','8.50','8.50',63,'male','L2Chest','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,4762,430,987,398,560,323,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1626,1816,21816,'Treasure Chest','','mimic','8.50','8.50',66,'male','L2Chest','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,5227,492,1123,428,649,348,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1627,1817,21817,'Treasure Chest','','mimic','8.50','8.50',69,'male','L2Chest','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,5713,559,1265,460,746,373,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1628,1818,21818,'Treasure Chest','','mimic','8.50','8.50',72,'male','L2Chest','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,6220,632,1413,491,849,399,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1629,1819,21819,'Treasure Chest','','mimic','8.50','8.50',75,'male','L2Chest','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,6750,712,1563,523,957,425,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1630,1820,21820,'Treasure Chest','','mimic','8.50','8.50',78,'male','L2Chest','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,7300,799,1715,555,1069,451,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1631,1821,21821,'Treasure Chest','','mimic','8.50','8.50',81,'male','L2Chest','Fighter',40,4608,8.500,1896,3.000,40,43,30,21,20,10,7873,894,1863,587,1182,477,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1632,1822,21822,'Treasure Chest','','mimic','8.50','8.50',84,'male','L2Chest','Fighter',40,4766,8.500,2011,3.000,40,43,30,21,20,10,8467,996,2006,619,1296,502,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.56),
(1633,1823,21823,'Executor of Sacrificial Offerings','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,12042,1351,1814,576,1144,468,278,0,253,134,6721,0,39,190,'tomb_clan',300,1,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.48),
(1634,0,21824,'Alpen Kookaburra','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1635,0,21825,'Alpen Kookaburra','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1636,0,21826,'Alpen Buffalo','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1637,0,21827,'Alpen Buffalo','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1638,0,21828,'Alpen Cougar','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1639,0,21829,'Alpen Cougar','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1640,1824,22001,'Grim Wolf','','dire_wolf','13.00','11.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1641,1825,22002,'Grim Grizzly','','grizzly','21.00','40.00',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,87,132,41,98,278,500,253,0,0,0,90,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(1642,1826,22003,'Grave Robber Scout','','e_traderB_Fdwarf_mon','6.00','18.00',27,'female','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1643,1827,22004,'Grave Robber Lookout','','dwarf_ghost','10.00','18.70',27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,35,131,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(1644,1828,22005,'Grave Robber Ranger','','e_collector_teacher_Fdwarf_mon','8.00','17.50',28,'female','L2Monster','Ranger',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1645,1829,22006,'Grave Robber Guard','','e_collector_teacher_Mdwarf_mon','8.00','17.50',29,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1646,1830,22007,'Ghost of a Soldier','','orc','10.00','21.00',29,'male','L2Monster','Fighter',40,906,14.000,349,1.500,40,43,30,21,20,10,927,49,111,149,53,110,278,500,253,221,0,0,60,140,'',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(1647,1831,22008,'Grave Robber Fighter','','e_collector_teacher_Mdwarf_mon','8.00','17.50',30,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1648,1832,22009,'Ghost of a Loyal Vassal','','orc_shaman','9.00','22.00',31,'male','L2Monster','Mystic',40,1004,9.000,381,1.800,40,43,30,21,20,10,1083,60,157,133,64,118,278,0,253,0,0,0,90,90,'',300,0,'','',0,0,0,7,30,4,4,0,0,0.30),
(1649,1833,22010,'Ghost of a General','','orc_fighter','12.00','22.00',32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1200,67,169,138,69,123,278,0,253,0,0,0,40,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(1650,1834,22011,'Ghost of a Batur Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1651,1835,22012,'Ghost of a Batur Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1652,1836,22013,'Ghost of a Morek Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1653,1837,22014,'Ghost of a Morek Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1654,1838,22015,'Ghost of a Turka Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1655,1839,22016,'Ghost of a Turka Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1656,1840,22017,'Bandit Sweeper','','northern_goblin','4.00','15.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,30,120,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(1657,1841,22018,'Bandit Hound','','dire_wolf','13.00','11.00',31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1425,79,157,133,64,118,278,500,253,0,0,0,40,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(1658,1842,22019,'Bandit Watchman','','ol_mahum_archer_04te','15.00','32.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,169,138,69,123,278,500,253,88,0,0,55,130,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(1659,1843,22020,'Snow Lynx','','onyx_beast','14.00','14.50',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1332,76,182,143,75,128,278,500,253,0,0,0,55,110,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(1660,1844,22021,'Bandit Undertaker','','northern_goblin_110p','6.00','16.60',34,'male','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1667,97,196,148,82,132,278,0,253,0,0,0,80,130,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1661,1845,22022,'Bandit Assassin','','wererat_01te','14.00','25.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1484,88,192,169,89,137,278,0,253,0,0,0,80,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1662,1846,22023,'Bandit Warrior','','ol_mahum_04te','20.00','37.00',36,'male','L2Monster','Fighter',40,1279,9.000,463,1.800,40,43,30,21,20,10,1984,120,227,159,96,142,278,500,253,0,0,0,80,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(1663,1847,22024,'Bandit Inspector','','northern_goblin_120p','7.00','18.50',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,1991,122,194,154,104,147,317,0,289,221,0,0,80,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,10,0.61),
(1664,1848,22025,'Frozen Wasteland Werewolf','','werewolf','10.00','26.00',38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,2146,134,238,188,112,153,278,0,253,0,0,0,10,174,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(1665,1849,22026,'Bandit Captain','','ol_mahum_champion_04te','23.00','61.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1666,1850,22027,'Forgotten Crewman','','dwarf_ghost','10.00','18.70',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,1880,120,231,214,121,158,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1667,1851,22028,'Vagabond of the Ruins','','a_mageguild_teacher_Mhuman_mon','8.00','23.00',40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,2421,156,317,151,131,164,317,500,289,0,0,0,100,174,'',300,0,'','',0,0,0,7,10,8,0,0,0,0.46),
(1668,1852,22029,'Ragna Orc','','batur_orc_03te','9.00','21.50',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1669,1853,22030,'Ragna Orc Shaman','','batur_orc_shaman_a_03te','11.00','16.00',42,'male','L2Monster','Mystic',40,1660,11.000,589,2.100,40,43,30,21,20,10,2251,150,342,196,152,175,278,500,253,0,0,0,72,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(1670,1854,22031,'Ragna Orc Archer','','batur_orc_archer_03te','11.00','21.50',43,'male','L2Monster','Ranger',40,1728,5.500,618,2.100,40,43,30,21,20,10,2263,153,365,202,163,181,278,500,253,300,0,0,40,120,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.59),
(1671,1855,22032,'Ragna Orc Warrior','','batur_orc_warrior_03te','10.00','20.00',44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3350,229,390,209,176,187,278,0,253,0,0,0,140,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(1672,1856,22033,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(1673,1857,22034,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(1674,1858,22035,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(1675,1859,22036,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(1676,1860,22037,'Ragna Orc Healer','','batur_orc_shaman_a_03te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(1677,1861,22038,'Ragna Orc Hero','','batur_orc_overlord_03te','12.00','24.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3987,291,396,261,231,212,317,0,289,221,0,0,80,174,'',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.61),
(1678,1862,22039,'Ragna Orc Commander','','batur_orc_overlord_01te','12.00','24.00',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,3951,292,480,270,247,219,278,0,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1679,1863,22040,'Ragna Orc Sniper','','batur_orc_archer_01te','11.00','21.50',47,'male','L2Monster','Ranger',40,2016,5.500,738,2.100,40,43,30,21,20,10,4004,287,388,279,216,206,278,500,253,5,0,0,34,174,'',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1680,1864,22041,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(1681,1865,22042,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(1682,1866,22043,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(1683,1867,22044,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,1,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(1684,1868,22045,'Dark Corpse','','zombie_02te','13.00','21.00',40,'male','L2Monster','Fighter',40,381,4.500,531,1.800,40,43,30,21,20,10,2175,141,300,183,131,164,278,500,253,0,0,0,60,150,'undead_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.67),
(1685,1869,22046,'Varangka''s Dre Vanul','','dre_vanul','14.00','36.00',46,'male','L2Monster','Fighter',40,485,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(1686,1870,22047,'Guardian of the Ghost Town','','monster_eye_05te','21.00','43.00',44,'male','L2Monster','Mystic',40,449,11.000,648,2.100,40,43,30,21,20,10,2688,184,322,253,176,187,278,500,253,0,0,0,23,23,'',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(1687,1871,22048,'Dark Spider','','giant_spider_04te','26.00','25.50',42,'male','L2Monster','Fighter',40,415,11.000,589,2.100,40,43,30,21,20,10,2625,175,342,196,152,175,278,500,253,0,0,0,30,174,'',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.24),
(1688,1872,22049,'Varangka''s Succubus','','succubus_05te','10.00','36.00',49,'male','L2Monster','Fighter',40,542,11.000,799,2.100,40,43,30,21,20,10,3025,223,529,245,247,219,278,0,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(1689,1873,22050,'Probe Golem Prodigy IV','','golem_microscout','12.00','43.50',46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(1690,1874,22051,'Spelunking Spider','','giant_spider_05te','26.00','25.50',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,88,0,0,55,174,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(1691,1875,22052,'Menacing Jackhammer Golem','','golem_prop','23.00','32.80',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,88,0,0,55,174,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(1692,1876,22053,'Horrifying Cannon Golem I','','golem_cannon_catapult','23.50','34.70',48,'male','L2Monster','Fighter',40,2091,16.500,768,2.100,40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,291,0,0,45,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1693,1877,22054,'Horrifying Cannon Golem IV','','golem_cannon_catapult','23.50','34.70',48,'male','L2Monster','Fighter',40,2091,16.500,768,2.100,40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,291,0,0,45,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1694,1878,22055,'Cruel Vice Golem','','golem_repair','23.00','32.80',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1695,1879,22056,'Probe Golem Champion I','','golem_microscout','12.00','43.50',49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(1696,1880,22057,'Spelunking Ant','','ant_soldier','35.00','17.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3030,228,560,253,264,226,278,0,253,291,0,0,45,120,'ant_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(1697,1881,22058,'Horrifying Excavator Golem III','','golem_carrier','23.00','32.80',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(1698,1882,22059,'Bloodthirsty Ginzu Golem VII','','golem_guardian_090p','16.00','37.20',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(1699,1883,22060,'Horrifying Cannon Golem','','golem_cannon_catapult_a','23.50','34.70',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1700,1884,22061,'Horrifying Cannon Golem III','','golem_microscout_a','12.00','43.50',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(1701,1885,22062,'Horrifying Jackhammer Golem','','golem_prop','23.00','32.80',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1702,1886,22063,'Ginzu Golem Prodigy X','','golem_guardian_090p','16.00','37.20',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1703,1887,22064,'Bloodthirsty Ginzu Golem II','','golem_guardian_a_090p','16.00','37.20',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1704,1888,22065,'Horrifying Ginzu Golem V','','golem_guardian','18.00','41.50',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4085,321,662,276,319,247,278,0,253,0,0,0,15,174,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1705,1889,22066,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1706,1890,22067,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1707,1891,22068,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1708,1892,22069,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1709,1893,22070,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1710,1894,22071,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1711,1895,22072,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1712,1896,22073,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1713,1897,22074,'Epic Cannon Golem','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1714,1898,22075,'Epic Cannon Golem Adjunct','','golem_microscout_a','12.00','43.50',52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4633,358,627,268,300,239,278,0,253,0,0,0,100,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(1715,1899,22076,'Deadly Ginzu Golem V','','golem_guardian','18.00','41.50',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'',300,1,'Local','',0,0,0,7,10,8,0,0,0,0.30),
(1716,1900,22077,'Horrifying Ginzu Golem VIII','','golem_guardian_a','18.00','41.50',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1717,1901,22078,'Deadly Ginzu Golem VIII','','golem_guardian_a','18.00','41.50',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(1718,1902,22079,'Lost Bandersnatch','','bandersnatch_c','18.00','25.00',53,'male','L2Monster','Fighter',40,620,6.500,923,2.400,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1719,1903,22080,'Massive Maze Bandersnatch','','bandersnatch','18.00','25.00',54,'male','L2Monster','Fighter',40,640,6.500,923,2.400,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1720,1904,22081,'Lost Watcher','','field_stalker','16.00','36.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4813,378,547,334,319,247,278,0,253,0,0,0,100,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(1721,1905,22082,'Elder Lost Watcher','','field_stalker_110p','15.00','30.00',54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3569,285,699,284,339,254,278,500,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(1722,1906,22083,'Baby Panthera','','saber_toothed_tiger_080p','29.00','22.70',55,'male','L2Monster','Fighter',40,660,6.500,923,2.400,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1723,1907,22084,'Panthera','','saber_toothed_tiger','28.00','0.00',56,'male','L2Monster','Fighter',40,681,6.500,923,2.400,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1724,1908,22085,'Lost Gargoyle','','gargoyle_02te','16.00','50.00',55,'female','L2Monster','Fighter',40,2643,3.250,987,2.400,40,43,30,21,20,10,3959,320,554,331,360,261,278,0,253,0,0,0,80,165,'',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.72),
(1725,1909,22086,'Lost Gargoyle Youngling','','gargoyle_02te_110p','17.50','56.00',56,'female','L2Monster','Fighter',40,2724,13.000,1019,2.400,40,43,30,21,20,10,3605,296,777,301,382,269,278,500,253,0,0,0,70,110,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(1726,1910,22087,'Pronghorn Spirit','','antelope','17.00','34.00',56,'female','L2Monster','Fighter',40,2724,13.000,1019,2.400,40,43,30,21,20,10,3605,296,777,301,382,269,278,500,253,0,0,0,70,110,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(1727,1911,22088,'Pronghorn','','antelope_110p','19.00','37.80',57,'female','L2Monster','Fighter',40,2806,3.250,1052,2.400,40,43,30,21,20,10,8452,702,743,289,405,276,278,500,253,0,0,0,80,174,'',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.20),
(1728,1912,22089,'Ice Tarantula','','giant_spider','26.00','25.50',57,'male','L2Monster','Fighter',40,2806,3.250,1052,2.400,40,43,30,21,20,10,8452,702,743,289,405,276,278,500,253,0,0,0,80,174,'',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.20),
(1729,1913,22090,'Frost Tarantula','','giant_spider_110p','32.00','28.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1730,1914,22091,'Lost Iron Golem','','iron_golem_120p','22.00','42.50',58,'male','L2Monster','Fighter',40,722,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1731,1915,22092,'Frost Iron Golem','','iron_golem_130p','25.00','46.40',59,'male','L2Monster','Fighter',40,742,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1732,1916,22093,'Lost Buffalo','','buffalo','22.00','31.00',60,'male','L2Monster','Fighter',40,3054,13.000,1150,2.400,40,43,30,21,20,10,4097,355,782,405,478,299,278,0,253,0,0,0,80,170,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1733,1917,22094,'Frost Buffalo','','buffalo_a_110p','24.00','34.70',61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4058,357,901,378,505,307,278,0,253,3937,0,0,15,180,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.58),
(1734,1918,22095,'Ursus Cub','','grizzly','21.00','40.00',61,'male','L2Monster','Fighter',40,1568,3.750,1184,2.700,40,43,30,21,20,10,2435,214,1091,313,505,307,278,0,253,131,0,0,60,174,'',300,1,'Local',NULL,0,0,0,7,50,1,9,0,0,0.30),
(1735,1919,22096,'Ursus','','grizzly_120p','20.00','48.80',62,'male','L2Monster','Fighter',40,1609,3.750,1217,2.700,40,43,30,21,20,10,2075,185,1142,321,532,315,278,0,253,0,0,0,70,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.41),
(1736,14920,22097,'Lost Yeti','','yeti','15.00','27.50',62,'male','L2Monster','Fighter',40,3219,22.500,1217,2.700,40,43,30,21,20,10,6224,554,1142,321,532,315,278,0,253,3937,0,0,15,180,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.58),
(1737,1921,22098,'Frost Yeti','','yeti_110p','20.00','29.80',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,5772,521,897,438,560,323,278,0,253,127,0,0,70,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(1738,1922,22099,'Freya''s Buffalo','','buffalo','22.00','31.00',57,'male','L2Monster','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1739,1923,22100,'Freya''s Gardener','','field_stalker','16.00','36.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1740,1924,22101,'Freya''s Servant','','gargoyle_02te','16.00','50.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1741,1925,22102,'Freya''s Servant','','gargoyle_02te','16.00','50.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1742,1926,22103,'Freya''s White Bear','','grizzly','21.00','40.00',57,'male','L2Monster','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(1743,1927,22104,'Freya''s Dog','','bandersnatch','18.00','25.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(1744,1928,22105,'Spiked Stakato','','blade_stakato_120p','18.00','43.20',72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10535,1070,1284,540,849,399,278,500,253,0,0,0,60,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1745,1929,22106,'Spiked Stakato Worker','','blade_stakato_worker_120p','22.00','48.30',73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,0,0,1770,415,885,407,278,500,253,148,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(1746,1930,22107,'Spiked Stakato Guard','','spike_stakato','16.00','22.80',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,8909,928,1831,423,921,416,278,500,253,147,0,0,50,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(1747,1931,22108,'Female Spiked Stakato','','spike_stakato_soldier','17.00','30.00',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(1748,1932,22109,'Male Spiked Stakato','','marsh_stakato_soldier_120p','18.00','31.00',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(1749,1933,22110,'Male Spiked Stakato','','marsh_stakato_soldier_tran','16.00','28.40',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(1750,1934,22111,'Spiked Stakato Sorcerer','','blade_stakato_queen_120p','24.00','43.60',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1751,1935,22112,'Cannibalistic Stakato Follower','','spike_stakato_worker','17.00','29.80',74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(1752,1936,22113,'Cannibalistic Stakato Leader','','cannibal_stakato_leader_120p','48.80','0.00',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1753,1937,22114,'Cannibalistic Stakato Leader','','cannibal_stakato_leader_tran','40.00','42.00',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(1754,1938,22115,'Spiked Stakato Soldier','','blade_stakato_120p','18.00','43.20',76,'male','L2Monster','Fighter',40,4297,4.250,1710,3.000,40,43,30,21,20,10,16021,1712,1614,534,994,433,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1755,1939,22116,'Spiked Stakato Drone','','blade_stakato_drone_120p','28.00','47.30',77,'male','L2Monster','Fighter',40,4364,34.000,1747,3.000,40,43,30,21,20,10,6431,696,1664,463,1031,442,278,500,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.56),
(1756,1940,22117,'Spiked Stakato Captain','','marsh_stakato_drone_120p','14.00','29.10',78,'male','L2Monster','Fighter',40,4428,4.250,1784,3.000,40,43,30,21,20,10,15583,1706,1715,555,1069,451,278,0,253,0,0,0,27,150,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.43),
(1757,1941,22118,'Spiked Stakato Nurse','','marsh_stakato_queen_120p','26.00','43.80',79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1758,1942,22119,'Spiked Stakato Nurse','','marsh_stakato_queen_tran','16.00','28.40',79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1759,1943,22120,'Spiked Stakato Baby','','spike_stakato_drone','16.00','29.00',79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(1760,1944,22121,'Spiked Stakato Shaman','','blade_stakato_queen_120p','24.00','43.60',80,'male','L2Monster','Mystic',40,4550,25.500,1859,3.000,40,43,30,21,20,10,10362,1163,1814,576,1144,468,278,0,253,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1761,1945,22122,'Monastic Pilgrim','','angel_080p','12.00','27.80',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(1762,1946,22123,'Monastic Crusader','','archangel_050p','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.54),
(1763,1947,22124,'Solina Brother','','solina_brother','9.00','23.40',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1764,1948,22125,'Solina Lay Brother','','solina_brother','9.00','23.40',82,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,142,0,0,27,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(1765,1949,22126,'Silent Seeker','','solina_father','11.00','25.40',82,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,142,0,0,27,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(1766,1950,22127,'Silent Brother','','solina_father','11.00','25.40',83,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(1767,1951,22128,'Monastery Guardian','','grail_protection','9.00','15.60',83,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(1768,1952,22129,'Warrior Monk','','monk_warrior','12.00','28.40',84,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,253,2500,0,0,34,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(1769,1953,22130,'Divine Advocate','','apostle_warrior','8.00','30.00',85,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,45,185,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.46),
(1770,1954,22131,'Pilgrim of Light','','apostle_mage','11.00','38.50',85,'male','L2Monster','Mystic',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,45,185,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.46),
(1771,1955,22132,'Judge of Light','','apostle_grail_a','13.00','47.00',86,'male','L2Monster','Fighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,6719,0,0,24,180,'',0,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51),
(1772,1956,22133,'Guardian of the Grail','','will_o_wisp','13.00','22.00',86,'male','L2Monster','Fighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,6719,0,0,24,180,'',0,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51),
(1773,1957,22134,'Guardian of the Holy Land','','solina_priest','14.00','34.50',87,'male','L2Monster','Fighter',40,4899,17.000,2088,3.000,40,43,30,21,20,10,13871,1750,2963,639,1470,519,200,0,182,6719,0,0,24,180,'',0,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51),
(1774,1958,22135,'Beholder of Light','','apostle_grail','13.00','47.00',87,'male','L2Monster','Fighter',40,4899,17.000,2088,3.000,40,43,30,21,20,10,13871,1750,2963,639,1470,519,200,0,182,6719,0,0,24,180,'',0,0,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51),
(1775,1959,22136,'Gatekeeper Zombie','','zombie_gateguard','17.00','30.50',83,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1776,1960,22137,'Penance Guard','','zombie_gateguard_brd','40.00','30.50',81,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1777,1961,22138,'Chapel Guard','','zombie_gateguard_brd','40.00','30.50',85,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(1778,1962,22139,'Old Aristocrat''s Soldier','','zombie_enlisted_man','17.00','22.30',81,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1779,1963,22140,'Zombie Worker','','zombie_laborer','11.00','24.60',80,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1780,1964,22141,'Forgotten Victim','','zombie_laborer','11.00','24.60',80,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1781,1965,22142,'Triol''s Layperson','','heretic_privates_a','7.70','28.40',81,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1782,1966,22143,'Triol''s Believer','','heretic_privates','7.70','28.40',82,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1783,1967,22144,'Resurrected Temple Knight','','zombie_enlisted_man','17.00','22.30',82,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1784,1968,22145,'Ritual Sacrifice','','self_blaster','9.00','25.80',81,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1785,1969,22146,'Triol''s Priest','','heretic_privates','7.70','28.40',84,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1786,1970,22147,'Ritual Offering','','zombie_enlisted_man','17.00','22.30',83,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1787,1971,22148,'Triol''s Believer','','heretic_privates','7.70','28.40',82,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1788,1972,22149,'Ritual Offering','','zombie_enlisted_man','17.00','22.30',82,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1789,1973,22150,'Triol''s Believer','','heretic_privates','7.70','28.40',83,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1790,1974,22151,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1791,1975,22152,'Temple Guard','','zombie_em_knight','17.00','22.30',84,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1792,1976,22153,'Temple Guard Captain','','zombie_em_knight','17.00','22.30',84,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1793,1977,22154,'Ritual Sacrifice','','self_blaster','9.00','25.80',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1794,1978,22155,'Triol''s High Priest','','heretic_priest_a','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1795,1979,22156,'Triol''s Priest','','heretic_privates','7.70','28.40',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1796,1980,22157,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1797,1981,22158,'Triol''s Believer','','heretic_privates_a','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1798,1982,22159,'Triol''s High Priest','','heretic_priest_a','7.70','28.40',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1799,1983,22160,'Triol''s Priest','','heretic_privates','7.70','28.40',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1800,1984,22161,'Ritual Sacrifice','','self_blaster','9.00','25.80',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1801,1985,22162,'Triol''s Believer','','heretic_privates_a','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1802,1986,22163,'Triol''s High Priest','','heretic_priest','8.00','19.60',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1803,1987,22164,'Triol''s Believer','','heretic_privates_a','7.70','28.40',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1804,1988,22165,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1805,1989,22166,'Triol''s Believer','','heretic_privates','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1806,1990,22167,'Triol''s High Priest','','heretic_priest_a','7.70','28.40',87,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1807,1991,22168,'Triol''s Priest','','heretic_privates','7.70','28.40',87,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1808,1992,22169,'Ritual Sacrifice','','self_blaster','9.00','25.80',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1809,1993,22170,'Triol''s Believer','','heretic_privates_a','7.70','28.40',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1810,1994,22171,'Triol''s High Priest','','heretic_priest','8.00','19.60',87,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1811,1995,22172,'Ritual Sacrifice','','self_blaster','9.00','25.80',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1812,1996,22173,'Triol''s Priest','','heretic_privates','7.70','28.40',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1813,1997,22174,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1814,1998,22175,'Andreas'' Captain of the Royal Guard','','zombie_em_knight','17.00','22.30',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1815,1999,22176,'Andreas'' Royal Guards','','zombie_em_knight','17.00','22.30',85,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1816,2011,22188,'Andreas'' Captain of the Royal Guard','','heretic_priest_120p','13.00','23.20',87,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1817,2012,22189,'Andreas'' Royal Guards','','heretic_privates_120p','13.00','34.00',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1818,2013,22190,'Ritual Sacrifice','','self_blaster','9.00','25.80',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1819,2014,22191,'Andreas'' Captain of the Royal Guard','','heretic_priest_120p','13.00','23.20',87,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1820,2015,22192,'Andreas'' Royal Guards','','heretic_privates_120p','13.00','34.00',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1821,2016,22193,'Andreas'' Royal Guards','','heretic_privates_120p','13.00','34.00',86,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1822,2017,22194,'Penance Guard','','zombie_gateguard_slp','40.00','22.00',81,'male','L2Monster','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(1823,0,22195,'Ritual Sacrifice','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1824,0,22196,'Velociraptor','','velociraptor','19.00',47.2,86,'male','L2Monster','Fighter',80,251060,13.43,2296,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1825,0,22197,'Velociraptor','','velociraptor','19.00',47.2,86,'male','L2Monster','Fighter',80,125530,13.43,2296,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1826,0,22198,'Velociraptor','','velociraptor','19.00',47.2,86,'male','L2Monster','Fighter',80,251060,13.43,2296,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1827,0,22199,'Pterosaur','','rhamphorhynchus','36.00',43.7,87,'male','L2Monster','Fighter',80,1014300,13.43,2339,3.09,40,43,30,21,20,10,11031,1401,2269,635,1413,531,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1828,0,22200,'Ornithomimus','','ornithomimus','15.00',37.2,84,'male','L2Monster','Fighter',80,123050,13.43,2211,3.09,40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1829,0,22201,'Ornithomimus','','ornithomimus','15.00',37.2,84,'male','L2Monster','Fighter',80,123050,13.43,2211,3.09,40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1830,0,22202,'Ornithomimus','','ornithomimus','15.00',37.2,84,'male','L2Monster','Fighter',80,123050,13.43,2211,3.09,40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1831,0,22203,'Deinonychus','','deinonychus','14.00',14.3,83,'male','L2Monster','Fighter',80,121840,13.43,2168,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1832,0,22204,'Deinonychus','','deinonychus','14.00',14.3,83,'male','L2Monster','Fighter',80,121840,13.43,2168,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1833,0,22205,'Deinonychus','','deinonychus','14.00',14.3,83,'male','L2Monster','Fighter',80,121840,13.43,2168,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1834,0,22208,'Pachycephalosaurus','','pachycephalosaurus','22.00',40,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1835,0,22209,'Pachycephalosaurus','','pachycephalosaurus','22.00',40,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1836,0,22210,'Pachycephalosaurus','','pachycephalosaurus','22.00',40,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1837,0,22211,'Wild Strider','','wild_giant_strider','32.00',44.2,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1838,0,22212,'Wild Strider','','wild_giant_strider','32.00',44.2,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1839,0,22213,'Wild Strider','','wild_giant_strider','32.00',44.2,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1840,0,22214,'Elroki','','Crokian_Officer','25.00',33,85,'male','L2Monster','Fighter',80,248570,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1841,0,22215,'Tyrannosaurus','','tyranosaurus','60.00',89.7,87,'male','L2Monster','Fighter',80,3064060,13.43,2339,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1842,0,22216,'Tyrannosaurus','','tyranosaurus','60.00',89.7,87,'male','L2Monster','Fighter',80,3064060,13.43,2339,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1843,0,22217,'Tyrannosaurus','','tyranosaurus','60.00',89.7,87,'male','L2Monster','Fighter',80,3064060,13.43,2339,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1844,0,22218,'Velociraptor','','velociraptor','19.00',47.2,86,'male','L2Monster','Fighter',80,125530,13.43,2296,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1845,0,22219,'Ornithomimus','','ornithomimus','15.00',37.2,84,'male','L2Monster','Fighter',80,123050,13.43,2211,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1846,0,22220,'Deinonychus','','deinonychus','14.00',14.3,83,'male','L2Monster','Fighter',80,121840,13.43,2168,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1847,0,22221,'Pachycephalosaurus','','pachycephalosaurus','22.00',40,84,'male','L2Monster','Fighter',80,123050,13.43,2211,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1848,0,22222,'Wild Strider','','wild_giant_strider','32.00',44.2,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1849,0,22223,'Velociraptor','','velociraptor','19.00',47.2,86,'male','L2Monster','Fighter',80,125530,13.43,2296,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1850,0,22224,'Ornithomimus','','ornithomimus','15.00',37.2,84,'male','L2Monster','Fighter',80,123050,13.43,2211,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1851,0,22225,'Deinonychus','','deinonychus','14.00',14.3,83,'male','L2Monster','Fighter',80,121840,13.43,2168,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1852,0,22226,'Pachycephalosaurus','','pachycephalosaurus','22.00',40,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,0,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1853,0,22227,'Wild Strider','','wild_giant_strider','25.00',33,85,'male','L2Monster','Fighter',80,124280,13.43,2253,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,0,88,188,'dino',500,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76),
(1854,10001,25001,'Greyclaw Kutus','Raid Boss','ol_mahum_champion_50_bi','21.00','43.50',23,'male','L2RaidBoss','Fighter',40,95986,49.420,545,4.500,60,57,73,76,70,80,714843,67170,61,857,6,348,278,0,1972,67,633,0,50,170,'',0,0,'Tigra','',0,20,382,7,30,4,20,0,-18,0.63),
(1855,10002,25002,'Guard of Kutus','Raid Fighter','ol_mahum','13.50','25.00',22,'male','L2Minion','Fighter',40,6613,18.950,257,4.500,40,43,30,41,20,10,0,0,74,411,9,167,278,0,253,7,0,0,50,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.46),
(1856,10003,25003,'Pawn of Kutus','Raid Fighter','ol_mahum','13.50','25.00',22,'male','L2Minion','Fighter',40,9870,18.950,257,4.500,40,43,30,41,20,10,0,0,111,411,22,167,278,0,253,123,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.46),
(1857,10004,25004,'Turek Mercenary Captain','Raid Boss','orc_champion_50_bi','15.00','35.00',30,'male','L2RaidBoss','Fighter',40,168366,130.310,763,5.400,60,57,73,76,70,80,1424160,129276,226,1127,70,458,278,0,1972,124,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.76),
(1858,10005,25005,'Turek Mercenary Archer','Raid Fighter','orc_archer','14.00','25.00',29,'male','L2Minion','Ranger',500,11414,50.200,365,4.500,40,43,30,41,20,10,0,0,604,542,111,220,249,0,227,271,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80),
(1859,10006,25006,'Turek Mercenary Warrior','Raid Fighter','orc_fighter','12.00','22.00',29,'male','L2Minion','Fighter',40,8518,50.200,365,4.500,40,43,30,41,20,10,0,0,203,542,62,220,278,0,253,2,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.46),
(1860,10007,25007,'Retreat Spider Cletu','Raid Boss','poison_spider','27.00','25.50',42,'male','L2RaidBoss','Mystic',40,331522,179.910,1062,5.400,60,57,73,76,70,80,2299956,251972,746,1728,324,701,278,0,1972,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.65),
(1861,10008,25008,'Cletu''s Retainer','Raid Fighter','giant_spider','26.00','26.50',41,'male','L2Minion','Mystic',40,33216,69.880,514,5.400,40,43,30,41,20,10,0,0,662,835,278,339,278,0,253,0,0,0,72,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26),
(1862,10009,25009,'Cletu''s Pawn','Raid Fighter','giant_spider','26.00','26.50',41,'male','L2Minion','Mystic',40,16608,69.880,514,5.400,40,43,30,41,20,10,0,0,662,835,278,339,278,0,253,0,0,0,72,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26),
(1863,10010,25010,'Furious Thieles','Raid Boss','ti_mi_tran','23.00','90.00',55,'male','L2RaidBoss','raidboss',40,624464,248.860,2039,7.200,60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,1972,0,0,0,12,50,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.61),
(1864,10011,25011,'Guard of Thieles','Raid Fighter','zenta_lizardman_scout','11.00','30.00',54,'male','L2Minion','Ranger',500,42806,97.460,987,7.200,40,43,30,41,20,10,0,0,6746,1252,2944,508,249,0,227,279,0,0,37,170,'',0,0,'Local','',0,0,0,7,30,4,20,1500,0,0.93),
(1865,10012,25012,'Follower of Thieles','Raid Fighter','dryad','9.00','20.00',54,'female','L2Minion','Fighter',40,9909,97.460,987,7.200,40,43,30,41,20,10,0,0,2277,1252,1656,508,278,0,253,0,0,0,40,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.37),
(1866,10013,25013,'Ghost of Peasant Leader','Raid Boss','skeleton_knight_50_bi','15.00','39.00',50,'male','L2RaidBoss','Fighter',40,507285,222.490,1722,7.200,60,57,73,76,70,80,2494222,346727,1510,2226,862,904,278,0,1972,145,0,0,40,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.17),
(1867,10014,25014,'Ghost of Peasant','Raid Fighter','skeleton','11.00','25.00',49,'male','L2Minion','Fighter',40,51380,86.860,830,6.300,40,43,30,41,20,10,0,0,2751,1079,3086,438,278,0,253,68,0,0,60,170,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.30),
(1868,10015,25015,'Ghost of Peasant','Raid Fighter','skeleton_archer','11.00','27.00',49,'male','L2Minion','Ranger',500,25690,86.860,830,6.300,40,43,30,41,20,10,0,0,1375,1079,771,438,278,0,253,14,0,0,40,170,'',0,1,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80),
(1869,10016,25016,'The 3rd Underwater Guardian','Raid Boss','susceptor_100_bi','40.00','73.00',60,'male','L2RaidBoss','raidboss',40,188376,295.120,2368,8.100,60,57,73,76,70,80,3346092,522780,3860,2951,3932,1198,278,0,1972,0,0,0,27,150,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.43),
(1870,10017,25017,'Escort of the 3rd Guardian','Raid Fighter','will_o_wisp','13.00','22.00',59,'male','L2Minion','Fighter',40,24399,115.940,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.10),
(1871,10018,25018,'Support of the 3rd Guardian','Raid Fighter','will_o_wisp','13.00','22.00',59,'male','L2Minion','Fighter',40,12199,115.940,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.10),
(1872,10019,25019,'Pan Dryad','Raid Boss','pan_100_bi','42.00','73.00',25,'male','L2RaidBoss','Fighter',40,206185,53.660,606,4.500,60,57,73,76,70,80,730469,69595,146,928,30,377,278,0,1972,291,0,0,45,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.58),
(1873,10020,25020,'Breka Warlock Pastu','Raid Boss','batur_orc_shaman_100_bi','22.00','35.00',34,'male','L2RaidBoss','Priest',40,156584,75.160,893,5.400,60,57,73,76,70,80,1174184,135023,280,1308,55,531,278,0,1972,8,0,0,50,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.30),
(1874,10021,25021,'Pastu''s Silhouette','Raid Fighter','silhouette','8.00','23.00',33,'female','L2Minion','Fighter',40,15774,29.040,430,5.400,40,43,30,41,20,10,0,0,258,630,51,256,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(1875,10022,25022,'Pastu''s Shadow','Raid Fighter','shadow','10.00','30.00',33,'male','L2Minion','Mystic',40,7887,29.040,430,5.400,40,43,30,41,20,10,0,0,258,630,51,256,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(1876,10023,25023,'Stakato Queen Zyrnna','Raid Boss','marsh_stakato_queen_100_bi','30.00','76.00',34,'female','L2RaidBoss','raidboss',40,208019,139.580,1415,6.300,60,57,73,76,70,80,1753455,156895,340,1308,110,531,278,0,1972,150,0,0,50,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.41),
(1877,10024,25024,'Jeruna''s Guard Captain','Raid Fighter','marsh_stakato_drone','9.00','24.00',33,'male','L2Minion','Fighter',40,20909,53.930,677,6.300,40,43,30,41,20,10,0,0,626,630,408,256,278,0,253,238,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.39),
(1878,10025,25025,'Jeruna''s Guard','Raid Fighter','marsh_stakato_soldier','10.00','25.00',33,'male','L2Minion','Fighter',40,10454,53.930,677,6.300,40,43,30,41,20,10,0,0,313,630,102,256,278,0,253,257,0,0,30,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.74),
(1879,10026,25026,'Katu Van Leader Atui','Raid Boss','ketra_orc_overload','12.00','24.00',49,'male','L2RaidBoss','raidboss',40,352421,116.920,1660,6.300,60,57,73,76,70,80,1655129,248433,1147,2160,383,877,278,0,1972,84,0,0,33,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.48),
(1880,10027,25027,'Katu Van Marksman','Raid Fighter','ketra_orc_archer','12.00','27.00',48,'male','L2Minion','Ranger',500,23911,45.620,799,6.300,40,43,30,41,20,10,0,0,3102,1047,613,425,249,0,227,279,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.91),
(1881,10028,25028,'Katu Van Raider','Raid Fighter','ketra_orc_warrior','12.00','24.00',48,'male','L2Minion','Fighter',40,17844,45.620,799,6.300,40,43,30,41,20,10,0,0,1047,1047,345,425,278,0,253,128,0,0,36,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.54),
(1882,10029,25029,'Atraiban','Raid Boss','field_stalker_200_bi','45.00','96.00',53,'male','L2RaidBoss','raidboss',40,156190,256.750,1911,7.200,60,57,73,76,70,80,3145490,461913,2344,2433,1974,988,278,0,1972,0,0,0,70,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.41),
(1883,10030,25030,'Atraiban''s Top Disciple','Raid Fighter','will_o_wisp','13.00','22.00',52,'male','L2Minion','Mystic',40,20135,100.430,923,7.200,40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.10),
(1884,10031,25031,'Atraiban''s Disciple','Raid Fighter','liviona','15.00','28.00',52,'male','L2Minion','Fighter',40,10067,100.430,923,7.200,40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34),
(1885,10032,25032,'Eva''s Guardian Millenu','Raid Boss','banshee_50_bi','13.50','38.00',65,'female','L2RaidBoss','Mystic',40,229722,348.000,2707,8.100,60,57,73,76,70,80,1820975,806823,5880,3349,7541,1360,278,0,1972,3939,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.56),
(1886,10033,25033,'Millenu Guard Shaman','Raid Fighter','heltor_silenos_shaman','13.00','32.00',64,'male','L2Minion','Priest',40,20074,138.400,1319,8.100,40,43,30,41,20,10,0,0,7473,1634,12940,663,278,0,253,5131,0,0,29,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.22),
(1887,10034,25034,'Mellenu Guard Warrior','Raid Fighter','skeleton_royal_guard','11.00','28.50',64,'male','L2Minion','Fighter',40,30142,138.400,1319,8.100,40,43,30,41,20,10,0,0,11210,1634,29118,663,278,0,253,946,945,0,80,170,'',0,1,'Local','',0,20,534,7,30,4,20,0,0,0.52),
(1888,10035,25035,'Shilen''s Messenger Cabrio','Raid Boss','vale_master_50_bi','18.00','63.00',70,'male','L2RaidBoss','raidboss',40,888658,355.000,3058,9.000,60,57,73,76,70,80,1915900,918808,19755,3764,8986,1528,278,0,1972,189,0,0,70,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.74),
(1889,10036,25036,'Cabrio Captor','Raid Fighter','skeleton_archer','11.00','27.00',69,'male','L2Minion','Ranger',500,62338,141.600,1493,8.100,40,43,30,41,20,10,0,0,6981,1840,15424,747,249,0,227,279,0,0,40,170,'',0,1,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80),
(1890,10037,25037,'Cabrio Blader','Raid Fighter','doll_blader','6.00','12.00',69,'male','L2Minion','Fighter',40,46520,141.600,1493,8.100,40,43,30,41,20,10,0,0,6668,1840,8676,747,278,0,253,5129,5129,0,22,170,'',0,0,'Tigra','',0,0,582,7,30,4,20,0,0,0.50),
(1891,10038,25038,'Tirak','Raid Boss','dre_vanul_100_bi','28.00','75.00',28,'male','L2RaidBoss','raidboss',40,116581,60.420,699,4.500,60,57,73,76,70,80,750326,74683,96,1044,10,424,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.35),
(1892,10039,25039,'Tirak''s Guard','Raid Fighter','spartoi','11.00','27.00',27,'male','L2Minion','Fighter',40,11861,23.250,334,4.500,40,43,30,41,20,10,0,0,175,502,38,204,278,0,253,68,0,0,60,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30),
(1893,10040,25040,'Tirak''s Knight','Raid Fighter','skeleton','11.00','25.00',27,'male','L2Minion','Fighter',40,5930,23.250,334,4.500,40,43,30,41,20,10,0,0,87,502,9,204,278,0,253,2,945,0,60,170,NULL,0,1,'Tigra',NULL,0,20,216,7,30,4,20,0,0,0.30),
(1894,10041,25041,'Remmel','Raid Boss','marsh_stakato_queen_100_bi','30.00','76.00',35,'female','L2RaidBoss','raidboss',40,165289,77.760,927,5.400,60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,1972,221,109,0,50,170,'',0,0,'Tigra','',0,20,546,7,30,4,20,0,-18,0.41),
(1895,10042,25042,'Remmel''s Archer','Raid Fighter','batur_orc_archer','11.00','21.50',34,'male','L2Minion','Ranger',500,11143,30.060,446,5.400,40,43,30,41,20,10,0,0,547,654,46,265,249,0,227,275,0,0,45,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.96),
(1896,10043,25043,'Remmel''s Guard','Raid Fighter','marsh_stakato','10.00','20.00',34,'male','L2Minion','Fighter',40,8316,30.060,446,5.400,40,43,30,41,20,10,0,0,184,654,26,265,278,0,253,127,0,0,21,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.74),
(1897,10044,25044,'Barion','Raid Boss','skeleton_knight_50_bi','15.00','39.00',47,'male','L2RaidBoss','Fighter',40,319791,111.160,1296,6.300,60,57,73,76,70,80,1624139,238098,956,2030,296,824,278,0,1972,70,0,0,40,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.17),
(1898,10045,25045,'Dark Mage''s of Barion','Raid Fighter','batur_orc_shaman','11.00','16.00',46,'male','L2Minion','Priest',40,32280,43.310,618,6.300,40,43,30,41,20,10,0,0,861,983,260,399,278,0,253,159,0,0,50,120,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30),
(1899,10046,25046,'Barion''s Grunt','Raid Fighter','spartoi','11.00','27.00',46,'male','L2Minion','Fighter',40,16140,43.310,618,6.300,40,43,30,41,20,10,0,0,861,983,260,399,278,0,253,129,0,0,60,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30),
(1900,10047,25047,'Karte','Raid Boss','death_knight_50_bi','18.00','45.00',49,'male','L2RaidBoss','Fighter',40,352421,116.920,1660,6.300,60,57,73,76,70,80,1412364,185123,769,2160,184,877,278,0,1972,131,0,0,27,170,'',0,0,'DRIVER','',0,0,0,7,30,4,20,0,-18,0.71),
(1901,10048,25048,'Karte''s Chief Knight','Raid Fighter','skeleton_knight','10.00','25.00',48,'male','L2Minion','Fighter',40,35688,45.620,799,6.300,40,43,30,41,20,10,0,0,1403,1047,664,425,278,0,253,71,0,0,40,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.17),
(1902,10049,25049,'Karte''s Royal Guard','Raid Fighter','spartoi','11.00','27.00',48,'male','L2Minion','Fighter',40,17844,45.620,799,6.300,40,43,30,41,20,10,0,0,701,1047,166,425,278,0,253,74,0,0,60,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30),
(1903,10050,25050,'Verfa','Raid Boss','death_blader_200_bi','45.00','141.00',51,'male','L2RaidBoss','Fighter',40,771340,105.150,2039,7.200,60,57,73,76,70,80,1381165,185853,1700,2294,879,931,278,0,1972,1472,0,0,100,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.45),
(1904,10051,25051,'Rahha','Raid Boss','bloody_queen_100_bi','28.00','85.00',65,'female','L2RaidBoss','Mystic',40,818959,282.910,2707,8.100,60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.50),
(1905,10052,25052,'Priestess of Rahha','Raid Fighter','medusa','10.00','25.00',64,'female','L2Minion','Priest',40,85286,112.570,1319,8.100,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,0,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.52),
(1906,10053,25053,'Fanatics of Rahha','Raid Fighter','harpy','10.00','42.00',64,'female','L2Minion','Fighter',40,42643,112.570,1319,8.100,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.65),
(1907,10054,25054,'Kernon','Raid Boss','kaim_vanul','24.00','40.00',75,'male','L2RaidBoss','raidboss',40,945900,357.000,3420,9.000,60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,0,0,0,37,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45),
(1908,10055,25055,'Taliadon','Raid Fighter','death_blader','15.00','45.00',74,'male','L2Minion','Fighter',40,99324,142.800,1673,9.000,40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,253,1472,0,0,100,170,'',0,1,'Magister','',0,0,0,7,30,4,20,0,0,0.45),
(1909,10056,25056,'Vemsk','Raid Fighter','death_knight','12.00','30.00',74,'male','L2Minion','Fighter',40,49662,142.800,1673,9.000,40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,253,142,0,0,27,170,'',0,1,'Magister','',0,0,0,7,30,4,20,0,0,0.71),
(1910,10057,25057,'Biconne of Blue Sky','Raid Boss','lienrik','12.00','50.00',45,'male','L2RaidBoss','raidboss',40,288415,105.420,2235,7.200,60,57,73,76,70,80,1358394,171282,538,1905,112,774,278,0,1972,0,0,0,100,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.46),
(1911,10058,25058,'Biconne''s Shooter','Raid Fighter','skeleton_archer','11.00','27.00',44,'male','L2Minion','Ranger',500,19455,41.020,1084,7.200,40,43,30,41,20,10,0,0,1444,922,176,374,249,0,227,279,0,0,40,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.80),
(1912,10059,25059,'Biconne''s Warrior','Raid Fighter','skeleton_knight','10.00','25.00',44,'male','L2Minion','Fighter',40,3879,41.020,1084,7.200,40,43,30,41,20,10,0,0,487,922,99,374,278,0,253,150,0,0,40,160,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.17),
(1913,10060,25060,'Unrequited Kael','Raid Boss','succubus_100_bi','20.00','75.00',24,'female','L2RaidBoss','Mystic',40,99367,44.150,575,4.500,60,57,73,76,70,80,606920,51383,57,892,5,362,278,0,1972,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(1914,10061,25061,'Kael''s Bead','Raid Fighter','will_o_wisp','13.00','22.00',23,'male','L2Minion','Mystic',40,6830,16.940,272,4.500,40,43,30,41,20,10,0,0,69,428,8,174,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.10),
(1915,10062,25062,'Kael''s Escort','Raid Fighter','harpy','10.00','42.00',23,'female','L2Minion','Fighter',40,10195,16.940,272,4.500,40,43,30,41,20,10,0,0,103,428,19,174,278,0,253,0,0,0,60,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.65),
(1916,10063,25063,'Chertuba of Great Soul','Raid Boss','ketra_orc_warrior_100_bi','24.00','51.00',35,'male','L2RaidBoss','Fighter',40,330579,77.760,927,5.400,60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,1972,78,0,0,36,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.54),
(1917,10064,25064,'Wizard of Storm Teruk','Raid Boss','zenta_lizardman_shaman_50_bi','19.00','55.00',40,'male','L2RaidBoss','Priest',40,218810,91.280,1120,6.300,60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,1972,90,0,0,43,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.63),
(1918,10065,25065,'Teruk''s Escort','Raid Fighter','zenta_lizardman','11.00','32.00',39,'male','L2Minion','Fighter',40,6444,35.410,531,5.400,40,43,30,41,20,10,0,0,530,780,157,317,278,0,253,123,0,0,37,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.28),
(1919,10066,25066,'Teruk''s Knight','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',39,'male','L2Minion','Fighter',40,10980,35.410,531,5.400,40,43,30,41,20,10,0,0,265,780,39,317,278,0,253,291,0,0,40,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1920,10067,25067,'Captain of Red Flag Shaka','Raid Boss','oel_mahum_warrior_50_bi','30.00','60.00',52,'male','L2RaidBoss','Fighter',40,554640,233.130,1598,6.300,60,57,73,76,70,80,2909180,424683,1951,2363,1304,959,278,0,1972,71,0,0,70,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.65),
(1921,10068,25068,'Shaka''s Shooter','Raid Fighter','ol_mahum_archer','14.00','25.00',51,'male','L2Minion','Ranger',500,37786,91.130,768,6.300,40,43,30,41,20,10,0,0,5307,1147,2104,465,249,0,227,277,0,0,50,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93),
(1922,10069,25069,'Shaka''s Follower','Raid Fighter','oel_mahum_champion','23.00','61.00',51,'male','L2Minion','Fighter',40,28199,91.130,768,6.300,40,43,30,41,20,10,0,0,1791,1147,1183,465,278,0,253,128,633,0,67,170,NULL,0,0,'Tigra',NULL,0,20,409,7,30,4,20,0,0,0.46),
(1923,10070,25070,'Enchanted Forest Watcher Ruell','Raid Boss','ti_mi_tran','23.00','90.00',55,'male','L2RaidBoss','raidboss',40,451391,134.000,2039,7.200,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,0,0,0,12,50,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.61),
(1924,10071,25071,'Ruell''s Wind','Raid Fighter','sylph','11.00','35.00',54,'female','L2Minion','Mystic',40,7107,52.480,987,7.200,40,43,30,41,20,10,0,0,1676,1252,705,508,278,0,253,0,0,0,60,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1925,10072,25072,'Ruell''s Unicorn','Raid Fighter','unicorn','14.00','30.00',54,'male','L2Minion','Mystic',40,46232,52.480,987,7.200,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,0,0,0,46,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.74),
(1926,10073,25073,'Bloody Priest Rudelto','Raid Boss','karik_100_bi','50.00','180.00',69,'male','L2RaidBoss','Priest',40,875948,354.000,2987,8.100,60,57,73,76,70,80,1894878,895518,6751,3680,8676,1494,278,0,1972,0,0,0,37,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.45),
(1927,10074,25074,'Rudelto''s Banshee','Raid Fighter','banshee','9.00','23.00',68,'female','L2Minion','Mystic',40,91632,141.200,1458,8.100,40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1928,10075,25075,'Rudelto''s Dre Vanul','Raid Fighter','dre_vanul','14.00','36.00',68,'male','L2Minion','Fighter',40,45816,141.200,1458,8.100,40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35),
(1929,10076,25076,'Princess Molrang','Raid Boss','poison_toad_100_bi','40.00','20.00',25,'male','L2RaidBoss','Fighter',40,103092,53.660,606,4.500,60,57,73,76,70,80,730469,69595,73,928,7,377,278,0,1972,0,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.35),
(1930,10077,25077,'Captain Dogun','Raid Fighter','grizzly','21.00','40.00',24,'male','L2Minion','Fighter',40,10554,20.600,287,4.500,40,43,30,41,20,10,0,0,132,446,27,181,278,0,253,0,0,0,40,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.34),
(1931,10078,25078,'Princess'' Guard','Raid Fighter','grizzly','21.00','40.00',24,'male','L2Minion','Fighter',40,5277,20.600,287,4.500,40,43,30,41,20,10,0,0,66,446,6,181,278,0,253,0,0,0,40,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34),
(1932,10079,25079,'Cat''s Eye Bandit','Raid Boss','ol_mahum_champion_50_bi','21.00','43.50',30,'male','L2RaidBoss','Fighter',40,168366,121.010,763,5.400,60,57,73,76,70,80,1329219,122342,206,1127,53,458,278,0,1972,216,0,0,50,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.63),
(1933,10080,25080,'Mercenary','Raid Fighter','orc_shaman','9.00','22.00',29,'male','L2Minion','Priest',40,17036,46.620,365,4.500,40,43,30,41,20,10,0,0,185,542,47,220,278,0,253,179,0,0,45,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.26),
(1934,10081,25081,'Cat''s Eye Bandit','Raid Fighter','ol_mahum','13.50','25.00',29,'male','L2Minion','Fighter',40,8518,46.620,365,4.500,40,43,30,41,20,10,0,0,185,542,47,220,278,0,253,218,0,0,50,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.46),
(1935,10082,25082,'Leader of Cat Gang','Raid Boss','cat_the_cat_50_bi','13.50','26.00',39,'male','L2RaidBoss','raidboss',40,206753,88.520,1062,5.400,60,57,73,76,70,80,1078255,134578,268,1561,39,634,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.61),
(1936,10083,25083,'Cat Gang','Raid Fighter','cutie_cat','8.00','15.00',38,'female','L2Minion','Fighter',40,13903,34.310,514,5.400,40,43,30,41,20,10,0,0,330,754,65,306,278,0,253,0,0,0,48,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.34),
(1937,10084,25084,'Cat Gang','Raid Fighter','cat_the_cat','9.00','16.00',38,'male','L2Minion','Fighter',40,20752,34.310,514,5.400,40,43,30,41,20,10,0,0,495,754,146,306,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.61),
(1938,10085,25085,'Timak Orc Chief Ranger','Raid Boss','ketra_orc_warrior_100_bi','24.00','51.00',44,'male','L2RaidBoss','Fighter',40,371721,190.450,1355,6.300,60,57,73,76,70,80,2352182,262175,893,1845,414,749,278,0,1972,157,0,0,36,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.54),
(1939,10086,25086,'Timak Orc Ranger','Raid Fighter','ketra_orc_archer','12.00','27.00',43,'male','L2Minion','Ranger',500,9259,74.070,648,6.300,40,43,30,41,20,10,0,0,2392,892,653,362,249,0,227,14,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.91),
(1940,10087,25087,'Timak Orc Ranger','Raid Fighter','ketra_orc','12.00','29.00',43,'male','L2Minion','Fighter',40,6951,74.070,648,6.300,40,43,30,41,20,10,0,0,807,892,367,362,278,0,253,68,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.46),
(1941,10088,25088,'Crazy Mechanic Golem','Raid Boss','mechanic_golem_200_bi','15.00','63.00',43,'male','L2RaidBoss','Mystic',40,702418,199.420,2039,7.200,60,57,73,76,70,80,2492637,273103,1794,1785,1948,725,278,0,1972,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.72),
(1942,10089,25089,'Soulless Wild Boar','Raid Boss','giant_wild_hog','25.00','27.00',59,'male','L2RaidBoss','raidboss',40,512194,144.920,2301,7.200,60,57,73,76,70,80,2072981,415763,2664,2875,1302,1167,278,0,1972,0,0,0,35,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.54),
(1943,10090,25090,'Soulless Wolf','Raid Fighter','dire_wolf','13.00','11.00',58,'male','L2Minion','Fighter',40,35416,56.900,1117,7.200,40,43,30,41,20,10,0,0,3291,1399,2123,568,278,0,253,0,0,0,24,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(1944,10091,25091,'Soulless Bear','Raid Fighter','crimson_bear','19.00','36.00',58,'male','L2Minion','Fighter',40,52860,56.900,1117,7.200,40,43,30,41,20,10,0,0,4936,1399,4777,568,278,0,253,0,0,0,37,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.45),
(1945,10092,25092,'Korim','Raid Boss','heltor_silenos_shaman_50_bi','19.50','51.00',70,'male','L2RaidBoss','Priest',40,888658,288.220,3058,9.000,60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,278,0,1972,201,0,0,29,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.22),
(1946,10093,25093,'Korim Chief Guard Kaywon','Raid Fighter','heltor_silenos_warrior','13.00','31.00',69,'male','L2Minion','Fighter',40,93041,114.980,1493,8.100,40,43,30,41,20,10,0,0,10724,1840,20400,747,278,0,253,162,0,0,36,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,0,0.39),
(1947,10094,25094,'Korim Guards','Raid Fighter','heltor_silenos','13.00','29.00',69,'male','L2Minion','Fighter',40,46520,114.980,1493,8.100,40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,253,86,0,0,34,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,0,0.46),
(1948,10095,25095,'Elf Renoa','Raid Boss','elf_ghost','7.00','21.00',29,'male','L2RaidBoss','Mystic',40,121941,62.760,731,4.500,60,57,73,76,70,80,755659,76955,104,1085,11,440,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.41),
(1949,10096,25096,'Renoa''s Elpy','Raid Fighter','elpy','13.00','13.00',28,'male','L2Minion','Fighter',40,8296,24.170,349,4.500,40,43,30,41,20,10,0,0,126,522,18,212,278,0,253,0,0,0,50,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.60),
(1950,10097,25097,'Renoa''s Hog','Raid Fighter','giant_wild_hog','25.00','27.00',28,'male','L2Minion','Fighter',40,12383,24.170,349,4.500,40,43,30,41,20,10,0,0,190,522,41,212,278,0,253,0,0,0,35,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(1951,10098,25098,'Sejarr''s Servitor','Raid Boss','dark_fencer_200_bi','30.00','43.00',35,'male','L2RaidBoss','raidboss',40,330579,77.760,927,5.400,60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,1972,0,0,0,25,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.20),
(1952,10099,25099,'Rotten Tree Repiro','Raid Boss','hanged_man_ripper','35.00','80.00',44,'male','L2RaidBoss','raidboss',40,273375,102.550,1355,6.300,60,57,73,76,70,80,1344111,167614,493,1845,99,749,278,0,1972,0,0,0,55,55,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(1953,10100,25100,'Spirit of Sea of Spores','Raid Fighter','pixy','5.00','25.00',43,'female','L2Minion','Fighter',40,27494,39.880,648,6.300,40,43,30,41,20,10,0,0,318,892,88,362,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.72),
(1954,10101,25101,'Fighter of Sea of Spores','Raid Fighter','troll','21.00','35.00',43,'male','L2Minion','Fighter',40,13747,39.880,648,6.300,40,43,30,41,20,10,0,0,318,892,88,362,278,0,253,0,0,0,55,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.61),
(1955,10102,25102,'Shacram','Raid Boss','minotaur_100_bi','42.00','94.00',45,'male','L2RaidBoss','Fighter',40,576831,105.420,1722,7.200,60,57,73,76,70,80,1591877,230991,1603,1905,927,774,278,0,1972,300,0,0,40,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.59),
(1956,10103,25103,'Sorcerer Isirr','Raid Boss','zenta_lizardman_matriarch_50_bi','30.00','63.00',55,'male','L2RaidBoss','Mystic',40,451391,134.000,2039,7.200,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,195,0,0,53,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.46),
(1957,10104,25104,'Isirr''s Guard','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',54,'male','L2Minion','Fighter',40,46232,52.480,987,7.200,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,221,0,0,40,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1958,10105,25105,'Isirr''s Guards','Raid Fighter','zenta_lizardman','11.00','32.00',54,'male','L2Minion','Fighter',40,23116,52.480,987,7.200,40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,253,16,0,0,37,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.28),
(1959,10106,25106,'Ghost of the Well Lidia','Raid Boss','bloody_queen_100_bi','28.00','85.00',63,'female','L2RaidBoss','Mystic',40,526218,150.650,2570,8.100,60,57,73,76,70,80,2414839,561233,3581,3188,2006,1294,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.50),
(1960,10107,25107,'Lidia''s Archer','Raid Fighter','skeleton_archer','11.00','27.00',62,'male','L2Minion','Ranger',500,36451,59.880,1251,8.100,40,43,30,41,20,10,0,0,9897,1554,3306,631,249,0,227,279,0,0,40,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.80),
(1961,10108,25108,'Lidia''s Fighter','Raid Fighter','death_blader','15.00','45.00',62,'male','L2Minion','Fighter',40,27202,59.880,1251,8.100,40,43,30,41,20,10,0,0,3340,1554,1859,631,278,0,253,1472,0,0,100,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.45),
(1962,10109,25109,'Antharas Priest Cloe','Raid Boss','succubus_100_bi','20.00','75.00',74,'female','L2RaidBoss','Priest',40,935092,357.000,3347,9.000,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,1972,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(1963,10110,25110,'Cloe''s Servitor','Raid Fighter','silhouette','8.00','23.00',73,'female','L2Minion','Fighter',40,65759,142.400,1637,9.000,40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(1964,10111,25111,'Cloe''s Servitor','Raid Fighter','shadow','10.00','30.00',73,'male','L2Minion','Mystic',40,98148,142.400,1637,9.000,40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(1965,10112,25112,'Agent of Beres,Meana','Raid Boss','medusa_100_bi','20.00','53.00',30,'female','L2RaidBoss','raidboss',40,127782,65.160,763,5.400,60,57,73,76,70,80,890100,105037,169,1127,26,458,278,0,1972,0,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.52),
(1966,10113,25113,'Meana''s Maid','Raid Fighter','succubus','10.00','36.00',29,'female','L2Minion','Mystic',40,8678,25.100,365,4.500,40,43,30,41,20,10,0,0,203,542,41,220,278,0,253,0,0,0,60,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.84),
(1967,10114,25114,'Meana''s Guard Doll','Raid Fighter','crimson_doll','15.00','38.00',29,'male','L2Minion','Fighter',40,12952,25.100,365,4.500,40,43,30,41,20,10,0,0,305,542,94,220,278,0,253,0,0,0,60,170,NULL,0,1,'Local',NULL,0,0,0,7,30,4,20,0,0,0.67),
(1968,10115,25115,'Icarus Sample 1','Raid Boss','mana_vampire_200_bi','33.00','51.00',40,'male','L2RaidBoss','Mystic',40,294846,169.520,1120,6.300,60,57,73,76,70,80,1910416,217891,520,1615,177,656,278,0,1972,0,0,0,90,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.39),
(1969,10116,25116,'Icarus Sample 2','Raid Fighter','skeleton_archer','11.00','27.00',39,'male','L2Minion','Ranger',500,19779,65.750,531,5.400,40,43,30,41,20,10,0,0,1417,780,290,317,249,0,227,273,0,0,40,170,'',0,1,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80),
(1970,10117,25117,'Icarus Sample 3','Raid Fighter','magical_weaver','11.00','20.00',39,'male','L2Minion','Mystic',40,5984,65.750,531,5.400,40,43,30,41,20,10,0,0,478,780,163,317,278,0,253,0,0,0,90,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(1971,10118,25118,'Guilotine,Warden of the Execution Grounds','Raid Boss','skeleton_pikeman_100_bi','20.00','58.00',35,'male','L2RaidBoss','Fighter',40,330579,77.760,1415,6.300,60,57,73,76,70,80,1193687,138419,601,1356,236,550,278,0,1972,96,0,0,50,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.21),
(1972,10119,25119,'Messenger of Fairy Queen Berun','Raid Boss','pan_100_bi','42.00','73.00',50,'male','L2RaidBoss','raidboss',40,507285,274.000,1722,7.200,60,57,73,76,70,80,1237500,455390,1918,2226,1530,904,278,0,1972,213,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.58),
(1973,10120,25120,'Berun''s Officer','Raid Fighter','pan','14.00','35.00',49,'male','L2Minion','Fighter',40,34424,106.800,830,6.300,40,43,30,41,20,10,0,0,2336,1079,2443,438,278,0,253,90,0,0,45,110,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.58),
(1974,10121,25121,'Berun''s Prattler','Raid Fighter','pixy','5.00','25.00',49,'female','L2Minion','Fighter',40,51380,106.800,830,6.300,40,43,30,41,20,10,0,0,3504,1079,5498,438,278,0,253,0,0,0,80,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72),
(1975,10122,25122,'Refugee Hopeful Leo','Raid Boss','oel_mahum_witch_doctor_50_bi','22.50','54.00',56,'male','L2RaidBoss','raidboss',40,467209,136.790,2235,7.200,60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,278,0,1972,201,0,0,70,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.26),
(1976,10123,25123,'Leo''s Servant','Raid Fighter','lesser_giant','21.00','44.00',55,'male','L2Minion','Fighter',40,47946,53.600,1084,7.200,40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,253,3937,0,0,15,180,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.58),
(1977,10124,25124,'Leo''s Steward','Raid Fighter','lesser_giant_mage','21.00','44.00',55,'male','L2Minion','Mystic',40,23973,53.600,1084,7.200,40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,253,3938,0,0,15,180,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1978,10125,25125,'Fierce Tiger King Angel','Raid Boss','saber_toothed_tiger_200_bi','72.00','87.00',65,'male','L2RaidBoss','raidboss',40,1637918,348.000,2707,8.100,60,57,73,76,70,80,1820975,806823,11761,3349,30166,1360,278,0,1972,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.45),
(1979,10126,25126,'Longhorn Golkonda','Raid Boss','minotaur_100_bi','42.00','94.00',79,'male','L2RaidBoss','Fighter',40,1974940,355.000,3718,9.000,60,57,73,76,70,80,2346616,1166150,20224,4530,59372,1839,278,0,1972,91,0,0,40,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.59),
(1980,10127,25127,'Langk Matriarch Rashkos','Raid Boss','virud_lizardman_matriarch_50_bi','19.00','57.00',24,'male','L2RaidBoss','raidboss',40,198734,51.510,763,5.400,60,57,73,76,70,80,723779,67853,134,892,27,362,278,0,1972,124,0,0,56,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.65),
(1981,10128,25128,'Vuku Grand Seer Gharmash','Raid Boss','batur_orc_shaman_100_bi','22.00','35.00',33,'male','L2RaidBoss','Priest',40,148507,72.600,860,5.400,60,57,73,76,70,80,984556,97626,174,1261,24,512,278,0,1972,195,0,0,50,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.30),
(1982,10129,25129,'Vuku Shaman','Raid Fighter','orc_shaman','9.00','22.00',32,'male','L2Minion','Priest',40,10036,28.030,414,5.400,40,43,30,41,20,10,0,0,213,607,39,246,278,0,253,7,0,0,45,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.26);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(1983,10130,25130,'Gharmash''s Pet Trimden','Raid Fighter','poison_spider','27.00','25.50',32,'male','L2Minion','Mystic',40,14980,28.030,414,5.400,40,43,30,41,20,10,0,0,320,607,89,246,278,0,253,0,0,0,60,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.65),
(1984,10131,25131,'Carnage Lord Gato','Raid Boss','oel_mahum_50_bi','30.00','57.00',50,'male','L2RaidBoss','Fighter',40,369009,119.800,1415,6.300,60,57,73,76,70,80,1670250,297042,1243,2226,429,904,278,0,1972,71,0,0,70,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.48),
(1985,10132,25132,'Gato''s Marksman','Raid Fighter','ol_mahum_archer','14.00','25.00',49,'male','L2Minion','Ranger',500,6112,46.770,677,6.300,40,43,30,41,20,10,0,0,3356,1079,682,438,249,0,227,273,0,0,50,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93),
(1986,10133,25133,'Gato''s Troop Leader','Raid Fighter','ol_mahum_champion','14.00','27.00',49,'male','L2Minion','Fighter',40,4588,46.770,677,6.300,40,43,30,41,20,10,0,0,1132,1079,383,438,278,0,253,69,0,0,50,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.63),
(1987,10134,25134,'Leto Chief Talkin','Raid Boss','zenta_lizardman_matriarch_50_bi','30.00','63.00',40,'male','L2RaidBoss','raidboss',40,218810,91.280,1722,7.200,60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,1972,221,0,0,53,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.46),
(1988,10135,25135,'Talkin''s Seer','Raid Fighter','virud_lizardman_shaman','10.00','29.00',39,'male','L2Minion','Priest',40,21961,35.410,830,6.300,40,43,30,41,20,10,0,0,393,780,80,317,278,0,253,7,0,0,43,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(1989,10136,25136,'Talkin''s Bodyguard','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',39,'male','L2Minion','Fighter',40,10980,35.410,830,6.300,40,43,30,41,20,10,0,0,393,780,80,317,278,0,253,16,0,0,40,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1990,10137,25137,'Beleth''s Seer Sephia','Raid Boss','bloody_queen_100_bi','28.00','85.00',55,'female','L2RaidBoss','Mystic',40,451391,134.000,2039,7.200,60,57,73,76,70,80,2001376,387789,2034,2576,903,1046,278,0,1972,0,0,0,80,170,NULL,0,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.50),
(1991,10138,25138,'Soul Drinker','Raid Fighter','mana_vampire','11.00','20.00',54,'male','L2Minion','Mystic',40,7107,52.480,987,7.200,40,43,30,41,20,10,0,0,2500,1252,1464,508,278,0,253,0,0,0,90,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(1992,10139,25139,'Sephia''s Salve','Raid Fighter','kaim_vanul','24.00','40.00',54,'male','L2Minion','Fighter',40,10671,52.480,987,7.200,40,43,30,41,20,10,0,0,3750,1252,3295,508,278,0,253,0,0,0,37,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.45),
(1993,10140,25140,'Hekaton Prime','Raid Boss','susceptor','20.00','35.00',65,'male','L2RaidBoss','raidboss',40,818959,282.910,2707,8.100,60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,1972,0,0,0,27,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.43),
(1994,10141,25141,'Hekaton Cottus','Raid Fighter','gamlin','11.00','32.00',64,'male','L2Minion','Fighter',40,85286,112.570,1319,8.100,40,43,30,41,20,10,0,0,8885,1634,16636,663,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.46),
(1995,10142,25142,'Hekaton Chires','Raid Fighter','lesser_giant','21.00','44.00',64,'male','L2Minion','Fighter',40,42643,112.570,1319,8.100,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,3937,0,0,15,180,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.58),
(1996,10143,25143,'Fire of Wrath Shuriel','Raid Boss','angel','13.50','36.50',78,'male','L2RaidBoss','Fighter',40,977229,355.000,3718,9.000,60,57,73,76,70,80,2287584,1166150,10051,4503,14666,1828,278,0,1972,2500,0,0,30,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52),
(1997,10144,25144,'Shuriel''s Oracle','Raid Fighter','oel_mahum_witch_doctor','15.00','34.00',78,'male','L2Minion','Fighter',40,103799,142.000,1859,9.000,40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,253,201,0,0,70,170,NULL,0,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,0.26),
(1998,10145,25145,'Shuriel''s Paladin','Raid Fighter','kel_mahum_champion','13.00','32.00',78,'male','L2Minion','Fighter',40,51899,142.000,1859,9.000,40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,253,147,0,0,50,170,NULL,0,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,0.56),
(1999,10146,25146,'Serpent Demon Bifrons','Raid Boss','serpent_slave_50_bi','25.00','72.00',21,'male','L2RaidBoss','raidboss',40,90169,38.900,485,4.500,60,57,73,76,70,80,578451,45688,42,789,3,320,278,0,1972,73,0,0,70,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.46),
(2000,10147,25147,'Assassin of Bifrons','Raid Fighter','virud_lizardman_scout','10.00','22.00',20,'male','L2Minion','Ranger',500,6241,14.890,227,4.500,40,43,30,41,20,10,0,0,90,378,3,153,249,0,227,2507,0,0,43,170,'',0,0,'Local','',0,0,0,7,30,4,20,1500,0,0.72),
(2001,10148,25148,'Butcher of Bifrons','Raid Fighter','virud_lizardman_warrior','12.00','30.00',20,'male','L2Minion','Fighter',40,4657,14.890,227,4.500,40,43,30,41,20,10,0,0,30,378,2,153,278,0,253,16,0,0,52,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.59),
(2002,10149,25149,'Zombie Lord Crowl','Raid Boss','zombie_100_bi','26.00','45.00',25,'male','L2RaidBoss','Fighter',40,103092,53.660,606,4.500,60,57,73,76,70,80,856025,92883,110,928,15,377,278,0,1972,0,0,0,15,15,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.43),
(2003,10150,25150,'Evil Spirit Archer','Raid Fighter','skeleton_archer','11.00','27.00',24,'male','L2Minion','Ranger',500,7071,20.600,287,4.500,40,43,30,41,20,10,0,0,296,446,25,181,249,0,227,14,0,0,40,170,'',0,1,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80),
(2004,10151,25151,'Evil Spirit Warrior','Raid Fighter','skeleton','11.00','25.00',24,'male','L2Minion','Fighter',40,5277,20.600,287,4.500,40,43,30,41,20,10,0,0,100,446,14,181,278,0,253,946,0,0,60,170,'',0,1,'Tigra','',0,0,0,7,30,4,20,0,0,0.30),
(2005,10152,25152,'Flame Lord Shadar','Raid Boss','dre_vanul_100_bi','28.00','75.00',35,'male','L2RaidBoss','Fighter',40,165289,77.760,927,5.400,60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.35),
(2006,10153,25153,'Claws of Shadar','Raid Fighter','imp','10.00','24.00',34,'male','L2Minion','Fighter',40,16632,30.060,446,5.400,40,43,30,41,20,10,0,0,554,654,220,265,278,0,253,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.34),
(2007,10154,25154,'Whip of Shadar','Raid Fighter','succubus','10.00','36.00',34,'female','L2Minion','Mystic',40,8316,30.060,446,5.400,40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.84),
(2008,10155,25155,'Shaman King Selu','Raid Boss','batur_orc_overlord_100_bi','24.00','52.00',40,'male','L2RaidBoss','Fighter',40,294846,182.560,1120,6.300,60,57,73,76,70,80,2046864,230791,570,1615,234,656,278,0,1972,79,0,0,80,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.28),
(2009,10156,25156,'Fanatic Shaman','Raid Fighter','batur_orc_shaman','11.00','16.00',39,'male','L2Minion','Priest',40,19779,70.810,531,5.400,40,43,30,41,20,10,0,0,699,780,383,317,278,0,253,123,19,0,50,170,'',0,0,'Tigra','',0,20,304,7,30,4,20,0,0,0.30),
(2010,10157,25157,'Fanatic Soldier','Raid Fighter','batur_orc_warrior','10.00','20.00',39,'male','L2Minion','Fighter',40,29521,70.810,531,5.400,40,43,30,41,20,10,0,0,1048,780,862,317,278,0,253,7,0,0,80,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.30),
(2011,10158,25158,'King Tarlk','Raid Boss','king_bugbear_200_bi','45.00','126.00',48,'male','L2RaidBoss','Fighter',40,920790,211.790,1722,7.200,60,57,73,76,70,80,2448691,283783,2574,2094,2776,850,278,0,1972,160,0,0,55,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.28),
(2012,10159,25159,'Paniel the Unicorn','Raid Boss','unicorn','14.00','30.00',54,'male','L2RaidBoss','raidboss',40,435256,131.200,1975,7.200,60,57,73,76,70,80,1983647,381736,1898,2504,823,1017,278,0,1972,0,0,0,46,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.74),
(2013,10160,25160,'Rapini the Unicorn','Raid Fighter','unicorn_boxer','11.00','18.00',53,'male','L2Minion','Mystic',40,44492,51.350,955,7.200,40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,253,0,0,0,27,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.71),
(2014,10161,25161,'Ririf the Unicorn','Raid Fighter','unicorn_mirage','13.00','17.50',53,'male','L2Minion','Mystic',40,22246,51.350,955,7.200,40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,253,0,0,0,27,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.69),
(2015,10162,25162,'Giant Marpanak','Raid Boss','lesser_giant_100_bi','42.00','91.00',60,'male','L2RaidBoss','raidboss',40,1461912,274.040,2368,8.100,60,57,73,76,70,80,3123036,491139,7025,2951,11841,1198,278,0,1972,3937,0,0,15,180,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.58),
(2016,10163,25163,'Roaring Skylancer','Raid Boss','drake','30.00','100.00',70,'male','L2RaidBoss','raidboss',40,888658,355.000,3058,9.000,60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,1972,0,0,0,70,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(2017,10166,25166,'Ikuntai','Raid Boss','skeleton_knight_50_bi','15.00','39.00',25,'male','L2RaidBoss','Fighter',40,134813,99.660,606,4.500,60,57,73,76,70,80,1278325,108133,133,928,31,377,278,0,1972,150,0,0,40,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.17),
(2018,10167,25167,'Ikuntai''s Servitor','Raid Fighter','silhouette','8.00','23.00',24,'female','L2Minion','Fighter',40,13786,38.270,287,4.500,40,43,30,41,20,10,0,0,121,446,28,181,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(2019,10168,25168,'Pawn of Ikuntai','Raid Fighter','skeleton_pikeman','10.00','28.00',24,'male','L2Minion','Fighter',40,6893,38.270,287,4.500,40,43,30,41,20,10,0,0,121,446,28,181,278,0,253,299,0,0,50,170,'',0,1,'Tigra','',0,0,0,7,30,4,20,0,0,0.21),
(2020,10169,25169,'Ragraman','Raid Boss','batur_orc_overlord_100_bi','24.00','52.00',30,'male','L2RaidBoss','Fighter',40,336732,121.010,763,5.400,60,57,73,76,70,80,1329219,122342,412,1127,212,458,278,0,1972,72,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.28),
(2021,10170,25170,'Lizardmen Leader Hellion','Raid Boss','zenta_lizardman_matriarch_50_bi','30.00','63.00',38,'male','L2RaidBoss','raidboss',40,195371,85.780,1028,5.400,60,57,73,76,70,80,1064286,131051,251,1508,36,612,278,0,1972,223,0,0,53,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.46),
(2022,10171,25171,'Hellion''s Archers','Raid Fighter','zenta_lizardman_scout','11.00','30.00',37,'male','L2Minion','Ranger',500,13142,33.230,497,5.400,40,43,30,41,20,10,0,0,686,728,60,295,249,0,227,278,0,0,37,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93),
(2023,10172,25172,'Hellion''s Guards','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',37,'male','L2Minion','Fighter',40,9807,33.230,497,5.400,40,43,30,41,20,10,0,0,231,728,34,295,278,0,253,291,0,0,40,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56),
(2024,10173,25173,'Tiger King Karuta','Raid Boss','saber_toothed_tiger_200_bi','72.00','87.00',45,'male','L2RaidBoss','raidboss',40,288415,105.420,1415,6.300,60,57,73,76,70,80,1591877,230991,801,1905,231,774,278,0,1972,0,0,0,60,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.45),
(2025,10174,25174,'Karuta''s Follower','Raid Fighter','heltor_silenos_chieftain','13.00','31.50',44,'male','L2Minion','Fighter',40,7758,41.020,677,6.300,40,43,30,41,20,10,0,0,725,922,205,374,278,0,253,127,0,0,27,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.39),
(2026,10175,25175,'Karuta''s Inferiors','Raid Fighter','crimson_bear','19.00','36.00',44,'male','L2Minion','Fighter',40,3879,41.020,677,6.300,40,43,30,41,20,10,0,0,725,922,205,374,278,0,253,0,0,0,37,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.45),
(2027,10176,25176,'Black Lily','Raid Boss','bloody_queen_100_bi','28.00','85.00',55,'female','L2RaidBoss','Mystic',40,451391,134.000,2039,7.200,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.50),
(2028,10177,25177,'Guardian Knight of Black Lily','Raid Fighter','death_knight','12.00','30.00',54,'male','L2Minion','Fighter',40,46232,52.480,987,7.200,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,75,0,0,27,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.71),
(2029,10178,25178,'Servitor of Black Lily','Raid Fighter','silhouette','8.00','23.00',54,'female','L2Minion','Fighter',40,23116,52.480,987,7.200,40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54),
(2030,10179,25179,'Guardian of the Statue of Giant Karum','Raid Boss','lesser_giant_50_bi','31.50','69.00',60,'male','L2RaidBoss','raidboss',40,526218,147.560,2368,8.100,60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,1972,3937,0,0,15,180,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.58),
(2031,10180,25180,'Karum''s Guard','Raid Fighter','lesser_giant_mage','21.00','44.00',59,'male','L2Minion','Mystic',40,36451,57.970,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,2314,583,278,0,253,3938,0,0,15,180,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.56),
(2032,10181,25181,'Karum''s Warrior','Raid Fighter','susceptor','20.00','35.00',59,'male','L2Minion','Fighter',40,54404,57.970,1150,7.200,40,43,30,41,20,10,0,0,5263,1437,5208,583,278,0,253,0,0,0,27,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.43),
(2033,10182,25182,'Demon Kurikups','Raid Boss','karik_100_bi','50.00','180.00',65,'male','L2RaidBoss','raidboss',40,100502,152.340,2707,8.100,60,57,73,76,70,80,2460640,581209,3838,3349,2140,1360,278,0,1972,0,0,0,37,200,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.45),
(2034,10183,25183,'Kurikups'' Wife','Raid Fighter','bloody_queen','14.00','40.00',64,'female','L2Minion','Mystic',40,13187,60.610,1319,8.100,40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50),
(2035,10184,25184,'Devil Blader of Chaos','Raid Fighter','death_blader','15.00','45.00',64,'male','L2Minion','Fighter',40,6593,60.610,1319,8.100,40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,253,1472,0,0,100,170,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.45),
(2036,10185,25185,'Tasaba Patriarch Hellena','Raid Boss','zenta_lizardman_matriarch','20.00','40.00',35,'male','L2RaidBoss','raidboss',40,165289,77.760,927,5.400,60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,1972,225,0,0,53,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.46),
(2037,10186,25186,'Hellena''s Marksman','Raid Fighter','zenta_lizardman_scout','11.00','30.00',34,'male','L2Minion','Ranger',500,11143,30.060,446,5.400,40,43,30,41,20,10,0,0,821,654,97,265,249,0,227,272,0,0,37,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93),
(2038,10187,25187,'Helena''s Soldier','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',34,'male','L2Minion','Fighter',40,8316,30.060,446,5.400,40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,16,0,0,40,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56),
(2039,10188,25188,'Apepi','Raid Boss','lienrik','12.00','50.00',30,'male','L2RaidBoss','raidboss',40,255564,65.160,763,5.400,60,57,73,76,70,80,759553,78807,227,1127,50,458,278,0,1972,0,0,0,100,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.46),
(2040,10189,25189,'Cronos''s Servitor Mumu','Raid Boss','cutie_cat','8.00','15.00',34,'female','L2RaidBoss','raidboss',40,39603,75.160,893,5.400,60,57,73,76,70,80,1001975,100648,187,1308,26,531,278,0,1972,0,0,0,48,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.34),
(2041,10190,25190,'Mumu''s Wizard','Raid Fighter','cutie_cat','8.00','15.00',33,'female','L2Minion','Mystic',40,3355,29.040,430,5.400,40,43,30,41,20,10,0,0,229,630,43,256,278,0,253,0,0,0,48,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34),
(2042,10191,25191,'Mumu''s Warrior','Raid Fighter','cat_the_cat','9.00','16.00',33,'male','L2Minion','Fighter',40,5037,29.040,430,5.400,40,43,30,41,20,10,0,0,344,630,97,256,278,0,253,0,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.61),
(2043,10192,25192,'Earth Protector Panathen','Raid Boss','farhite','16.00','31.00',43,'male','L2RaidBoss','raidboss',40,258849,99.710,1296,6.300,60,57,73,76,70,80,1557899,221896,673,1785,182,725,278,0,1972,183,0,0,15,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.74),
(2044,10193,25193,'Panathen''s Knight','Raid Fighter','nos','26.00','42.00',42,'male','L2Minion','Fighter',40,7218,38.750,618,6.300,40,43,30,41,20,10,0,0,1213,864,644,350,278,0,253,5130,0,0,18,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.78),
(2045,10194,25194,'Panathen''s Protectors','Raid Fighter','dailaon','20.00','28.00',42,'male','L2Minion','Fighter',500,13005,38.750,618,6.300,40,43,30,41,20,10,0,0,606,864,161,350,278,0,253,5127,0,0,18,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.91),
(2046,10198,25198,'Fafurion''s Herald Lokness','Raid Boss','devastator_200_bi','100.00','105.00',70,'male','L2RaidBoss','raidboss',40,1777317,355.000,2639,8.100,60,57,73,76,70,80,1915900,918808,13963,3764,35947,1528,278,0,1972,0,0,0,70,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.84),
(2047,10199,25199,'Water Dragon Seer Sheshark','Raid Boss','kaim_vanul','24.00','40.00',72,'male','L2RaidBoss','raidboss',40,912634,311.540,2707,8.100,60,57,73,76,70,80,4674309,805512,7164,3933,8915,1597,278,0,1972,181,0,0,43,200,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(2048,10200,25200,'Family of Sheshark','Raid Fighter','hunter_gargoyle','25.00','65.00',71,'male','L2Minion','Fighter',40,64111,124.420,1319,8.100,40,43,30,41,20,10,0,0,9147,1924,15345,781,278,0,253,0,0,0,100,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.46),
(2049,10201,25201,'Guard of Sheshark','Raid Fighter','serpent_slave','17.00','46.00',71,'male','L2Minion','Fighter',40,95688,124.420,1319,8.100,40,43,30,41,20,10,0,0,13720,1924,34528,781,278,0,253,6370,0,0,52,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.59),
(2050,10202,25202,'Krokian Padisha Sobekk','Raid Boss','ant_soldier_200_bi','75.00','54.00',74,'male','L2RaidBoss','Fighter',40,935092,357.000,2777,8.100,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,1972,5130,0,0,18,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.78),
(2051,10203,25203,'Parhit Padisha Sobekk','Raid Fighter','aracne','15.00','26.00',73,'male','L2Minion','Fighter',40,98148,142.400,1353,8.100,40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,253,5131,0,0,15,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.74),
(2052,10204,25204,'Krokian Padisha Sobekk','Raid Fighter','vampire_bat','10.00','33.50',73,'male','L2Minion','Mystic',40,49074,142.400,1353,8.100,40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,253,5128,0,0,18,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.78),
(2053,10205,25205,'Ocean Flame Ashakiel','Raid Boss','saber_toothed_tiger_200_bi','72.00','87.00',76,'male','L2RaidBoss','raidboss',40,956490,311.810,3274,9.000,60,57,73,76,70,80,4888056,961047,8153,4273,10359,1735,278,0,1972,98,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.76),
(2054,10206,25206,'Ashakia''s Blade','Raid Fighter','dark_fencer_200_bi','30.00','43.00',75,'female','L2Minion','Fighter',40,100472,124.790,1601,9.000,40,43,30,41,20,10,0,0,15569,2094,39730,850,278,0,253,6717,0,0,50,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2055,10207,25207,'Ashakiel''s Rod','Raid Fighter','unicorn','14.00','30.00',75,'male','L2Minion','Mystic',40,50236,124.790,1601,9.000,40,43,30,41,20,10,0,0,7784,2094,9932,850,278,0,253,6718,0,0,50,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2056,10208,25208,'Water Couatle Ateka','Raid Boss','lienrik','12.00','50.00',40,'male','L2RaidBoss','raidboss',40,218810,91.280,1722,7.200,60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,1972,0,0,0,100,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.46),
(2057,10209,25209,'Ateka''s Shaman','Raid Fighter','lienrik','12.00','50.00',39,'male','L2Minion','Priest',40,14713,35.410,830,6.300,40,43,30,41,20,10,0,0,524,780,143,317,278,0,253,0,0,0,100,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2058,10210,25210,'Ateka''s Grunt','Raid Fighter','lienrik','12.00','50.00',39,'male','L2Minion','Fighter',40,21961,35.410,830,6.300,40,43,30,41,20,10,0,0,786,780,323,317,278,0,253,0,0,0,100,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2059,10211,25211,'Sebek','Raid Boss','nos','26.00','42.00',36,'male','L2RaidBoss','raidboss',40,174646,80.400,1975,7.200,60,57,73,76,70,80,1212311,142855,326,1405,65,570,278,0,1972,5130,0,0,18,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.78),
(2060,10212,25212,'Sebek''s Priest','Raid Fighter','zenta_lizardman_scout','11.00','30.00',35,'male','L2Minion','Priest',500,11763,31.100,955,7.200,40,43,30,41,20,10,0,0,879,678,105,275,249,0,227,279,0,0,37,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93),
(2061,10213,25213,'Sebek''s Fanatic','Raid Fighter','dailaon','20.00','28.00',35,'male','L2Minion','Fighter',500,8778,31.100,955,7.200,40,43,30,41,20,10,0,0,296,678,59,275,278,0,253,5127,0,0,18,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.91),
(2062,10214,25214,'Fafurion''s Page Sika','Raid Boss','water_giant','13.00','44.00',40,'male','L2RaidBoss','raidboss',80,218810,91.280,2368,8.100,60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,1972,5132,0,0,35,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2063,10215,25215,'Sika''s Wizard','Raid Fighter','undine','12.00','27.00',39,'female','L2Minion','Mystic',40,14713,35.410,1150,7.200,40,43,30,41,20,10,0,0,353,780,69,317,278,0,253,0,0,0,60,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35),
(2064,10216,25216,'Sika''s Fighter','Raid Fighter','undine','12.00','27.00',39,'female','L2Minion','Mystic',40,21961,35.410,1150,7.200,40,43,30,41,20,10,0,0,530,780,157,317,278,0,253,0,0,0,60,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35),
(2065,10217,25217,'Cursed Clara','Raid Boss','medusa','10.00','25.00',50,'female','L2RaidBoss','raidboss',40,369009,119.800,1722,7.200,60,57,73,76,70,80,1425270,224177,833,2226,206,904,278,0,1972,0,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.52),
(2066,10218,25218,'Clara''s Marksman','Raid Fighter','virud_lizardman_scout','10.00','22.00',49,'male','L2Minion','Ranger',500,6112,46.770,830,6.300,40,43,30,41,20,10,0,0,2250,1079,328,438,249,0,227,2507,0,0,43,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.72),
(2067,10219,25219,'Clara''s Pawn','Raid Fighter','virud_lizardman_warrior','12.00','30.00',49,'male','L2Minion','Fighter',40,4588,46.770,830,6.300,40,43,30,41,20,10,0,0,759,1079,184,438,278,0,253,94,0,0,52,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.59),
(2068,10220,25220,'Death Lord Hallate','Raid Boss','death_lord','21.00','40.00',73,'male','L2RaidBoss','Fighter',40,924022,356.000,3274,9.000,60,57,73,76,70,80,2190219,1002134,8449,4017,12049,1631,278,0,1972,78,0,0,40,170,'',0,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50),
(2069,10221,25221,'Death Mage Krician','Raid Fighter','death_blader','15.00','45.00',72,'male','L2Minion','Fighter',40,64948,142.400,1601,9.000,40,43,30,41,20,10,0,0,10780,1966,20691,798,278,0,253,1472,0,0,100,170,'',0,1,'Magister','',0,0,0,7,30,4,20,0,0,0.45),
(2070,10222,25222,'Death Fighter Harik','Raid Fighter','death_knight','12.00','30.00',72,'male','L2Minion','Fighter',40,96938,142.400,1601,9.000,40,43,30,41,20,10,0,0,16170,1966,46558,798,278,0,253,75,0,0,27,170,'',0,1,'Magister','',0,0,0,7,30,4,20,0,0,0.71),
(2071,10223,25223,'Soul Collector Acheron','Raid Boss','vale_master_50_bi','18.00','63.00',35,'male','L2RaidBoss','raidboss',40,165289,77.760,1237,6.300,60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,1972,192,0,0,70,160,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.74),
(2072,10224,25224,'Soul Slasher','Raid Fighter','dark_horror','20.00','35.00',34,'male','L2Minion','Fighter',40,11143,30.060,589,6.300,40,43,30,41,20,10,0,0,246,654,46,265,278,0,253,0,0,0,100,140,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.37),
(2073,10225,25225,'Soul Strainer','Raid Fighter','hungry_spirit','13.00','40.00',34,'male','L2Minion','Fighter',40,16632,30.060,531,5.400,40,43,30,41,20,10,0,0,369,654,104,265,278,0,253,0,0,0,15,155,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.45),
(2074,10226,25226,'Roaring Lord Kastor','Raid Boss','oel_mahum_witch_doctor_50_bi','22.50','54.00',62,'male','L2RaidBoss','Fighter',40,768537,299.380,2502,8.100,60,57,73,76,70,80,3828086,679088,4510,3108,4959,1262,278,0,1972,186,0,0,70,180,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.26),
(2075,10227,25227,'Kastor''s Seer','Raid Fighter','oel_mahum_witch_doctor','15.00','34.00',61,'male','L2Minion','Fighter',40,79678,118.930,1217,8.100,40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,253,9,0,0,70,170,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26),
(2076,10228,25228,'Kastor''s Prefect','Raid Fighter','oel_mahum_warrior','20.00','38.00',61,'male','L2Minion','Fighter',40,39839,118.930,1217,8.100,40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,253,79,0,0,70,190,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.65),
(2077,10229,25229,'Storm Winged Naga','Raid Boss','wyrm_50_bi','58.00','108.00',75,'male','L2RaidBoss','Fighter',40,1891801,357.000,3420,9.000,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,0,0,0,70,200,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.19),
(2078,10230,25230,'Timak Seer Ragoth','Raid Boss','batur_orc_shaman_50_bi','16.00','25.00',57,'male','L2RaidBoss','Priest',40,482650,139.530,2169,7.200,60,57,73,76,70,80,2036961,401639,2325,2723,1079,1106,278,0,1972,201,0,0,50,160,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.30),
(2079,10231,25231,'Ragoth''s Guard','Raid Fighter','batur_orc_warrior','10.00','20.00',56,'male','L2Minion','Fighter',40,49626,54.710,1052,7.200,40,43,30,41,20,10,0,0,4299,1324,3954,537,278,0,253,74,657,0,80,175,NULL,0,0,'Tigra',NULL,0,20,456,7,30,4,20,0,0,0.30),
(2080,10232,25232,'Ragoth''s Herald','Raid Fighter','batur_orc','9.00','21.50',56,'male','L2Minion','Fighter',40,24813,54.710,1052,7.200,40,43,30,41,20,10,0,0,2149,1324,988,537,278,0,253,74,0,0,80,165,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2081,10233,25233,'Spirit of Andras,the Betrayer','Raid Boss','headless_knight_50_bi','30.00','46.50',69,'male','L2RaidBoss','Fighter',40,1256671,154.790,3643,9.000,60,57,73,76,70,80,2558623,621496,8956,3680,10177,1494,278,0,1972,2500,0,0,70,190,'',0,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52),
(2082,10234,25234,'Ancient Weird Drake','Raid Boss','drake_50_bi','45.00','150.00',65,'male','L2RaidBoss','raidboss',40,1052436,152.340,2707,8.100,60,57,73,76,70,80,2460640,581209,7676,3349,8563,1360,278,0,1972,0,0,0,70,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(2083,10235,25235,'Vanor Chief Kandra','Raid Boss','heltor_silenos_50_bi','19.00','43.50',72,'male','L2RaidBoss','raidboss',40,912634,356.000,3202,9.000,60,57,73,76,70,80,2161728,977072,8186,3933,11639,1597,278,0,1972,135,0,0,34,180,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.46),
(2084,10236,25236,'Kandra''s Healer','Raid Fighter','heltor_silenos_shaman','13.00','32.00',71,'male','L2Minion','Priest',40,95688,142.000,1565,9.000,40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,253,200,0,0,29,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.22),
(2085,10237,25237,'Kandra''s Guard','Raid Fighter','heltor_silenos_warrior','13.00','31.00',71,'male','L2Minion','Fighter',40,47844,142.000,1565,9.000,40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,253,228,0,0,36,190,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.39),
(2086,10238,25238,'Abyss Brukunt','Raid Boss','drake_50_bi','45.00','150.00',67,'male','L2RaidBoss','raidboss',40,512194,153.720,2846,8.100,60,57,73,76,70,80,2508399,600107,4130,3513,2312,1427,278,0,1972,0,0,0,70,185,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(2087,10239,25239,'Monstrous Beast of Abyss Brukunt','Raid Fighter','ketra_orc_shaman','10.00','23.00',66,'male','L2Minion','Priest',40,52860,61.230,1388,8.100,40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,253,195,0,0,10,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.34),
(2088,10240,25240,'Wild Beast of Abyss Brukunt','Raid Fighter','saber_toothed_tiger','34.00','28.00',66,'male','L2Minion','Fighter',40,26430,61.230,1388,8.100,40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,253,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.45),
(2089,10241,25241,'Harit Hero Tamash','Raid Boss','zenta_lizardman_warrior_50_bi','18.00','53.00',55,'male','L2RaidBoss','Fighter',40,624464,248.860,2639,8.100,60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,1972,298,0,0,40,175,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.56),
(2090,10242,25242,'Tamash''s Advisor','Raid Fighter','zenta_lizardman_shaman','13.00','35.00',54,'male','L2Minion','Priest',40,13199,97.460,1285,8.100,40,43,30,41,20,10,0,0,3036,1252,2944,508,278,0,253,193,0,0,43,155,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.63),
(2091,10243,25243,'Tamash''s Servant','Raid Fighter','zenta_lizardman','11.00','32.00',54,'male','L2Minion','Fighter',40,19818,97.460,1285,8.100,40,43,30,41,20,10,0,0,4554,1252,6625,508,278,0,253,234,0,0,37,170,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.28),
(2092,10244,25244,'Last Lesser Giant Olkuth','Raid Boss','lesser_giant_50_bi','31.50','69.00',75,'male','L2RaidBoss','raidboss',40,1891801,311.980,3420,9.000,60,57,73,76,70,80,4832156,847950,15764,4188,39730,1701,278,0,1972,78,0,0,15,140,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.58),
(2093,10245,25245,'Last Lesser Giant Glaki','Raid Boss','lesser_giant_mage_50_bi','30.00','66.00',78,'male','L2RaidBoss','Mystic',40,977229,288.700,3643,9.000,60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,278,0,1972,179,0,0,15,95,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.56),
(2094,10246,25246,'Glaki''s Henchman','Raid Fighter','lesser_giant','21.00','44.00',77,'male','L2Minion','Fighter',40,102704,115.680,1784,9.000,40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,253,169,0,0,15,150,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.58),
(2095,10247,25247,'Glaki''s Servant','Raid Fighter','lesser_giant','21.00','44.00',77,'male','L2Minion','Fighter',40,51352,115.680,1784,9.000,40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,253,166,0,0,15,140,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.58),
(2096,10248,25248,'Doom Blade Tanatos','Raid Boss','death_blader_bi','22.00','67.00',72,'male','L2RaidBoss','Fighter',40,1825269,289.290,3274,9.000,60,57,73,76,70,80,4362668,764172,13026,3933,26791,1597,278,0,1972,1472,0,0,100,180,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.45),
(2097,10249,25249,'Palatanos of Horrific Power','Raid Boss','hanged_man_ripper_50_bi','52.00','121.00',75,'male','L2RaidBoss','raidboss',40,945900,311.980,3420,9.000,60,57,73,76,70,80,4832156,847950,7882,4188,9932,1701,278,0,1972,0,0,0,55,165,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(2098,10250,25250,'Man-Eating Plant of Palatanos','Raid Fighter','magical_weaver','11.00','20.00',74,'male','L2Minion','Mystic',40,66547,124.800,1673,9.000,40,43,30,41,20,10,0,0,10072,2051,17077,833,278,0,253,0,0,0,90,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2099,10251,25251,'Sapling of Palatanos','Raid Fighter','skeleton_knight','10.00','25.00',74,'male','L2Minion','Fighter',40,99324,124.800,1673,9.000,40,43,30,41,20,10,0,0,15109,2051,38427,833,278,0,253,145,629,0,40,175,'',0,1,'Local','',0,20,629,7,30,4,20,0,0,0.17),
(2100,10252,25252,'Palibati Queen Themis','Raid Boss','cave_maiden_50_bi','37.00','98.00',70,'female','L2RaidBoss','raidboss',40,888658,310.390,3058,9.000,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,1972,234,0,0,70,160,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.43),
(2101,10253,25253,'Handmaiden of Themis','Raid Fighter','succubus','10.00','36.00',69,'female','L2Minion','Mystic',40,62338,123.830,1493,8.100,40,43,30,41,20,10,0,0,7862,1840,12062,747,278,0,253,0,0,0,60,150,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.84),
(2102,10254,25254,'Themis''s Sentinel','Raid Fighter','death_blader','15.00','45.00',69,'male','L2Minion','Fighter',40,93041,123.830,1493,8.100,40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,253,1472,0,0,100,170,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.45),
(2103,10255,25255,'Gargoyle Lord Tiphon','Raid Boss','hunter_gargoyle_50_bi','37.00','98.00',65,'male','L2RaidBoss','Fighter',40,1637918,282.910,2707,8.100,60,57,73,76,70,80,3674504,679343,9313,3349,17189,1360,278,0,1972,0,0,0,100,180,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.37),
(2104,10256,25256,'Taik High Prefect Arak','Raid Boss','ketra_orc_warrior_50_bi','18.00','37.00',60,'male','L2RaidBoss','Fighter',40,526218,147.560,2368,8.100,60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,1972,71,0,0,36,175,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.54),
(2105,10257,25257,'Arak''s Archer','Raid Fighter','ketra_orc_archer','12.00','27.00',59,'male','L2Minion','Ranger',500,36451,57.970,1150,7.200,40,43,30,41,20,10,0,0,7797,1437,2314,583,249,0,227,283,0,0,45,160,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.91),
(2106,10258,25258,'Arak''s Footman','Raid Fighter','ketra_orc','12.00','29.00',59,'male','L2Minion','Fighter',40,27202,57.970,1150,7.200,40,43,30,41,20,10,0,0,2632,1437,1302,583,278,0,253,127,0,0,45,175,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2107,10259,25259,'Zaken''s Butcher Krantz','Raid Boss','ogre_50_bi','30.00','66.00',55,'male','L2RaidBoss','raidboss',40,1248928,248.860,2039,7.200,60,57,73,76,70,80,2988757,448385,4942,2576,7268,1046,278,0,1972,297,0,0,22,160,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.82),
(2108,10260,25260,'Iron Giant Totem','Raid Boss','iron_golem_bi','27.00','52.00',45,'male','L2RaidBoss','Mystic',40,392985,195.770,1722,7.200,60,57,73,76,70,80,2377188,267898,974,1905,466,774,278,0,1972,0,0,0,20,50,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.41),
(2109,10261,25261,'Totem Guard Archer','Raid Fighter','batur_orc_archer','11.00','21.50',44,'male','L2Minion','Ranger',500,26454,76.180,830,6.300,40,43,30,41,20,10,0,0,2613,922,736,374,249,0,227,282,0,0,45,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.96),
(2110,10262,25262,'Totem Guard','Raid Fighter','batur_orc','9.00','21.50',44,'male','L2Minion','Fighter',40,19741,76.180,830,6.300,40,43,30,41,20,10,0,0,882,922,414,374,278,0,253,215,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.46),
(2111,10263,25263,'Kernon''s Faithful Servant Kelone','Raid Boss','cave_maiden_50_bi','37.00','98.00',67,'female','L2RaidBoss','Mystic',40,848789,285.490,2846,8.100,60,57,73,76,70,80,3745918,701317,5015,3513,4648,1427,278,0,1972,225,0,0,70,165,NULL,0,0,'Tigra',NULL,0,0,0,7,30,4,20,0,-18,0.43),
(2112,10264,25264,'Kelone''s Assassin','Raid Fighter','skeleton_royal_guard','11.00','28.50',66,'male','L2Minion','Fighter',40,59369,113.710,1388,8.100,40,43,30,41,20,10,0,0,6346,1715,7898,696,278,0,253,229,0,0,80,190,NULL,0,1,'Local',NULL,0,0,0,7,30,4,20,0,0,0.52),
(2113,10265,25265,'Kelone''s Secret Knight','Raid Fighter','drake','30.00','100.00',66,'male','L2Minion','Mystic',40,88610,113.710,1388,8.100,40,43,30,41,20,10,0,0,9520,1715,17773,696,278,0,253,0,0,0,70,180,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.84),
(2114,10266,25266,'Bloody Empress Decarbia','Raid Boss','bloody_queen_50_bi','21.00','64.00',75,'female','L2RaidBoss','Mystic',40,945900,357.000,3420,9.000,60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.50),
(2115,10267,25267,'Decarbia''s Royal Guard','Raid Fighter','death_knight','12.00','30.00',74,'male','L2Minion','Fighter',40,49662,142.800,1673,9.000,40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,253,5286,0,0,27,200,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.71),
(2116,10268,25268,'Decarbia''s Escort','Raid Fighter','skeleton_royal_guard','11.00','28.50',74,'male','L2Minion','Fighter',40,99324,142.800,1673,9.000,40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,253,234,0,0,80,210,NULL,0,1,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.52),
(2117,10269,25269,'Beast Lord Behemoth','Raid Boss','troll_50_bi','30.00','52.50',70,'male','L2RaidBoss','Fighter',40,888658,310.390,3058,9.000,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,1972,0,0,0,55,180,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.61),
(2118,10270,25270,'Behemoth Javeliner','Raid Fighter','virud_lizardman_scout','10.00','22.00',69,'male','L2Minion','Ranger',500,62338,123.830,1493,8.100,40,43,30,41,20,10,0,0,17470,1840,12062,747,249,0,227,2507,0,0,43,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.72),
(2119,10271,25271,'Behemoth Flare','Raid Fighter','will_o_wisp','13.00','22.00',69,'male','L2Minion','Mystic',40,46520,123.830,1493,8.100,40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,253,0,0,0,80,165,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.10),
(2120,10272,25272,'Partisan Leader Talakin','Raid Boss','ol_mahum_champion_50_bi','21.00','43.50',28,'male','L2RaidBoss','Fighter',40,233163,60.420,1415,6.300,60,57,73,76,70,80,879287,99579,286,1044,86,424,278,0,1972,77,0,0,50,190,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.63),
(2121,10273,25273,'Carnamakos','Raid Boss','iron_golem_bi','27.00','52.00',56,'male','L2RaidBoss','Mystic',40,507285,273.570,2104,7.200,60,57,73,76,70,80,3230613,486967,2902,2649,2636,1075,278,0,1972,0,0,0,20,50,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.41),
(2122,10274,25274,'Carnabarun','Raid Fighter','magical_weaver','11.00','20.00',55,'male','L2Minion','Mystic',40,34424,107.200,1019,7.200,40,43,30,41,20,10,0,0,3572,1288,4283,523,278,0,253,0,0,0,90,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2123,10275,25275,'Carnassiud','Raid Fighter','field_stalker','15.00','30.00',55,'male','L2Minion','Fighter',40,51380,107.200,1019,7.200,40,43,30,41,20,10,0,0,5359,1288,9639,523,278,0,253,0,0,0,70,170,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,0,0.41),
(2124,10276,25276,'Death Lord Ipos','Raid Boss','death_lord_50_bi','31.00','61.50',75,'male','L2RaidBoss','Fighter',40,1891801,357.000,3420,9.000,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,78,0,0,40,190,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.50),
(2125,10277,25277,'Lilith''s Witch Marilion','Raid Boss','bloody_queen_50_bi','21.00','64.00',50,'female','L2RaidBoss','Mystic',40,507285,239.600,1722,7.200,60,57,73,76,70,80,2672375,365590,1658,2226,1143,904,278,0,1972,0,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.50),
(2126,10278,25278,'Dead Soul of Stigma','Raid Fighter','mana_vampire','11.00','20.00',49,'male','L2Minion','Mystic',40,51380,93.540,830,6.300,40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,253,0,0,0,90,180,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2127,10279,25279,'Evil Spirit of Stigma','Raid Fighter','magical_weaver','11.00','20.00',49,'male','L2Minion','Mystic',40,25690,93.540,830,6.300,40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,253,0,0,0,90,180,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2128,10280,25280,'Pagan Watcher Cerberon','Raid Boss','kel_mahum_champion_50_bi','19.00','48.00',55,'male','L2RaidBoss','Fighter',40,1248928,268.010,2039,7.200,60,57,73,76,70,80,3202235,477279,5426,2576,9639,1046,278,0,1972,75,0,0,50,210,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.56),
(2129,10281,25281,'Anakim''s Nemesis Zakaron','Raid Boss','karik_50_bi','37.00','136.50',70,'male','L2RaidBoss','raidboss',40,1777317,310.390,3058,9.000,60,57,73,76,70,80,4135551,777993,12444,3764,28565,1528,278,0,1972,0,0,0,37,215,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2130,10282,25282,'Death Lord Shax','Raid Boss','death_lord_50_bi','31.00','61.50',75,'male','L2RaidBoss','Fighter',40,1891801,357.000,3420,9.000,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,2500,0,0,40,210,'',0,0,'Tigra','',0,0,0,7,30,4,20,0,-18,0.50),
(2131,10283,25283,'Lilith','Raid Boss','lilith','42.50','55.00',80,'female','L2RaidBoss','raidboss',40,1639146,354.000,3793,9.000,60,57,73,76,70,80,2374400,1196456,10404,4615,15367,1874,278,0,1972,0,0,0,45,200,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.50),
(2132,10284,25284,'Lilith''s Agent','Raid Fighter','lilim_wizard','9.00','34.00',79,'female','L2Minion','Mystic',40,115440,142.000,1859,9.000,40,43,30,41,20,10,0,0,13316,2265,26386,919,278,0,253,0,0,0,50,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50),
(2133,10285,25285,'Lilith''s Escort','Raid Fighter','lilim_knight','12.00','50.00',79,'male','L2Minion','Fighter',40,172299,142.000,1859,9.000,40,43,30,41,20,10,0,0,19974,2265,59372,919,278,0,253,5800,5799,0,56,220,NULL,0,0,'Local',NULL,0,20,674,7,30,4,20,0,0,0.46),
(2134,10286,25286,'Anakim','Raid Boss','anakim','15.50','29.00',80,'female','L2RaidBoss','raidboss',40,1639146,354.000,3793,9.000,60,57,73,76,70,80,2374400,1196456,10404,4615,15367,1874,278,0,1972,0,0,0,45,200,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.56),
(2135,10287,25287,'Anakim''s Guardian','Raid Fighter','nephilim_priest','23.00','40.50',79,'male','L2Minion','Priest',40,172299,142.000,1859,9.000,40,43,30,41,20,10,0,0,9987,2265,14843,919,278,0,253,0,0,0,50,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2136,10288,25288,'Anakim''s Royal Guard','Raid Fighter','nephilim_lord','10.00','41.50',79,'male','L2Minion','Fighter',40,86149,142.000,1859,9.000,40,43,30,41,20,10,0,0,9987,2265,14843,919,278,0,253,0,0,0,65,220,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.63),
(2137,10289,25289,'Anakim''s Executor','','nephilim_slayer','12.00','36.00',79,'male','L2Monster','Fighter',40,86149,142.000,1859,9.000,40,43,30,41,20,10,0,0,9987,2265,14843,919,278,0,253,0,0,0,65,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.63),
(2138,10290,25290,'Daimon the White-Eyed','Raid Boss','hundred_eye','21.00','55.00',78,'male','L2RaidBoss','raidboss',40,977229,355.000,3718,9.000,60,57,73,76,70,80,2318004,1136977,9824,4444,14332,1805,409,0,2901,0,0,0,30,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.54),
(2139,10291,25291,'Family of Daimon','Raid Fighter','field_stalker','15.00','30.00',77,'male','L2Monster','Fighter',40,22382,142.400,1859,9.000,40,43,30,41,20,10,0,0,12565,2179,24607,885,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(2140,10292,25292,'Family of Daimon','Raid Fighter','parasitic_eye','25.00','63.00',77,'male','L2Monster','Mystic',40,33607,142.400,1859,9.000,40,43,30,41,20,10,0,0,9424,2179,13842,885,278,0,253,0,0,0,30,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2141,10293,25293,'Hestia,Guardian Deity of the Hot Springs','Raid Boss','pixy_bi','10.00','54.00',78,'female','L2RaidBoss','raidboss',40,977229,288.700,3718,9.000,60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,409,0,2901,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.72),
(2142,10294,25294,'Fighter of Hestia','Raid Fighter','yeti','15.00','27.50',77,'male','L2Monster','Fighter',40,102704,115.680,1859,9.000,40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,253,0,0,0,16,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.48),
(2143,10295,25295,'Follower of Hestia','Raid Fighter','yeti','15.00','27.50',77,'male','L2Monster','Fighter',40,51352,115.680,1859,9.000,40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,253,0,0,0,16,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.48),
(2144,10296,25296,'Icicle Emperor Bumbalump','Raid Boss','yeti_20_bi','18.00','32.00',74,'male','L2RaidBoss','raidboss',40,935092,357.000,3718,9.000,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,409,0,2901,0,0,0,16,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(2145,10297,25297,'Icicle Giant','Raid Fighter','stone_golem','20.00','31.00',73,'male','L2Monster','Mystic',40,65759,142.400,1859,9.000,40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,253,0,0,0,23,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2146,10298,25298,'Icicle Giant','Raid Fighter','stone_golem','20.00','31.00',73,'male','L2Monster','Mystic',40,98148,142.400,1859,9.000,40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,253,0,0,0,23,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2147,10299,25299,'Ketra''s Hero Hekaton','Raid Boss','ketra_orc_chieftain_20_bi','17.00','46.20',80,'male','L2RaidBoss','raidboss',40,714778,154.670,3718,9.000,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,2901,6719,0,0,24,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.51),
(2148,10300,25300,'Scout of Hekaton','Raid Fighter','ketra_orc_archer','12.00','27.00',79,'male','L2Monster','Ranger',500,50349,62.040,1859,9.000,40,43,30,41,20,10,0,0,19811,2265,7884,919,278,0,253,288,0,0,45,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,0,0.91),
(2149,10301,25301,'Servant of Hekaton','Raid Fighter','ketra_orc','12.00','29.00',79,'male','L2Monster','Fighter',40,37574,62.040,1859,9.000,40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,253,79,0,0,45,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.46),
(2150,10302,25302,'Ketra''s Commander Tayr','Raid Boss','ketra_orc_warlord_20_bi','14.00','36.00',84,'male','L2RaidBoss','Fighter',40,743801,152.110,3718,9.000,60,57,73,76,70,80,3379556,898478,7856,4952,5408,2011,409,0,2901,80,0,0,27,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.48),
(2151,10303,25303,'Tayr''s Aide','Raid Fighter','ketra_orc_shaman','10.00','23.00',83,'male','L2Monster','Priest',40,52409,61.150,1859,9.000,40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,253,213,0,0,10,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34),
(2152,10304,25304,'Tayr''s Guard','Raid Fighter','ketra_orc','12.00','29.00',83,'male','L2Monster','Fighter',40,78223,61.150,1859,9.000,40,43,30,41,20,10,0,0,15123,2434,20916,988,278,0,253,79,6919,0,45,190,NULL,0,0,'Local',NULL,0,20,707,7,30,4,20,0,0,0.46),
(2153,10305,25305,'Ketra''s Chief Brakki','Raid Boss','ketra_warbeast','20.00','33.50',87,'male','L2RaidBoss','raidboss',40,1532678,149.340,3718,9.000,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,2901,0,0,0,26,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.50),
(2154,10306,25306,'Soul of Fire Nastron','Raid Boss','ifrit','10.00','42.00',87,'male','L2RaidBoss','raidboss',40,534922,149.340,3718,9.000,60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,2901,0,0,0,38,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(2155,10307,25307,'Family of Nastron','Raid Fighter','mana_vampire','11.00','20.00',86,'male','L2Monster','Mystic',40,56256,60.140,1859,9.000,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2156,10308,25308,'Family of Nastron','Raid Fighter','mana_vampire','11.00','20.00',86,'male','L2Monster','Mystic',40,28128,60.140,1859,9.000,40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2157,10309,25309,'Varka''s Hero Shadith','Raid Boss','barka_silenos_shaman_20_bi','17.00','47.50',80,'male','L2RaidBoss','Priest',40,714778,154.670,3718,9.000,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,2901,6716,0,0,36,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.54),
(2158,10310,25310,'Shadith''s Royal Guard Captain','Raid Fighter','barka_silenos_warrior','16.00','41.00',79,'male','L2Monster','Fighter',40,75148,62.040,1859,9.000,40,43,30,41,20,10,0,0,13374,2265,17740,919,278,0,253,142,6918,0,34,190,NULL,0,0,'Local',NULL,0,20,674,7,30,4,20,0,0,0.48),
(2159,10311,25311,'Shadith''s Sentinel','Raid Fighter','barka_silenos_hunter','16.00','38.00',79,'male','L2Monster','Ranger',40,37574,62.040,1859,9.000,40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,253,2504,0,0,44,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2160,10312,25312,'Varka''s Commander Mos','Raid Boss','barka_silenos_chieftain_20_bi','22.00','51.00',84,'male','L2RaidBoss','Fighter',40,743801,152.110,3718,9.000,60,57,73,76,70,80,3379556,898478,7856,4952,5408,2011,409,0,2901,2500,0,0,25,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.48),
(2161,10313,25313,'Mos'' Aide','Raid Fighter','barka_silenos_priest','9.00','41.50',83,'male','L2Monster','Priest',40,78223,61.150,1859,9.000,40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,253,6716,0,0,36,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.47),
(2162,10314,25314,'Mos'' Guard','Raid Fighter','barka_silenos_hunter','16.00','38.00',83,'male','L2Monster','Fighter',40,39111,61.150,1859,9.000,40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,253,142,0,0,44,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2163,10315,25315,'Varka''s Chief Horus','Raid Boss','barka_silenos_chieftain_20_bi','22.00','51.00',87,'male','L2RaidBoss','raidboss',40,1532678,149.340,3718,9.000,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,2901,2500,0,0,25,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.48),
(2164,10316,25316,'Soul of Water Ashutar','Raid Boss','undine','12.00','27.00',87,'female','L2RaidBoss','Mystic',40,534922,149.340,3718,9.000,60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,2901,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.35),
(2165,10317,25317,'Family of Ashutar','Raid Fighter','magical_weaver','11.00','20.00',86,'male','L2Monster','Mystic',40,56256,60.140,1859,9.000,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2166,10318,25318,'Family of Ashutar','Raid Fighter','magical_weaver','11.00','20.00',86,'male','L2Monster','Mystic',40,28128,60.140,1859,9.000,40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2167,10319,25319,'Ember','Raid Boss','inferno_drake_100_bi','48.00','73.00',85,'male','L2RaidBoss','raidboss',40,1048567,346.000,3718,9.000,60,57,73,76,70,80,2535975,1356048,11906,5036,18324,2045,409,0,2901,0,0,0,57,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(2168,10320,25320,'Sentinel of Ember','Raid Fighter','lava_golem','22.00','45.00',84,'male','L2Monster','Fighter',40,73883,139.200,1859,9.000,40,43,30,41,20,10,0,0,15276,2476,31447,1005,278,0,253,0,0,0,13,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.47),
(2169,10321,25321,'Messenger of Ember','Raid Fighter','ifrit','10.00','42.00',84,'male','L2Monster','Mystic',40,110274,139.200,1859,9.000,40,43,30,41,20,10,0,0,11457,2476,17689,1005,278,0,253,0,0,0,38,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.48),
(2170,10322,25322,'Demon''s Agent Falston','Raid Boss','vampire_warrior','9.00','31.50',66,'male','L2RaidBoss','Fighter',40,834231,350.000,3718,9.000,60,57,73,76,70,80,1838232,828036,6092,3431,7808,1393,409,0,2901,6723,0,0,43,190,NULL,0,0,'DRIVER',NULL,0,0,0,7,30,4,20,0,-18,0.60),
(2171,10323,25323,'Falston''s Disciple','Raid Fighter','vampire_wizard','5.50','28.00',65,'female','L2Monster','Mystic',40,58282,139.200,1859,9.000,40,43,30,41,20,10,0,0,7744,1674,13406,680,278,0,253,99,0,0,46,190,NULL,0,0,'DRIVER',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2172,10324,25324,'Servant of Falston','Raid Fighter','black_magician','8.00','30.00',65,'male','L2Monster','Mystic',40,86988,139.200,1859,9.000,40,43,30,41,20,10,0,0,11616,1674,30166,680,278,0,253,178,0,0,19,190,'',0,0,'DRIVER','',0,0,0,7,30,4,20,0,0,0.48),
(2173,10325,25325,'Flame of Splendor Barakiel','Raid Boss','apostle_warrior','8.00','30.00',70,'female','L2RaidBoss','Fighter',40,888658,310.390,3718,9.000,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,409,0,2901,6717,0,0,50,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.46),
(2174,10326,25326,'Barakiel''s Disciple','Raid Fighter','apostle_mage','11.00','38.50',69,'male','L2Monster','Mystic',40,93041,123.830,1859,9.000,40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,253,6718,0,0,50,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2175,10327,25327,'Barakiel''s Acolyte','Raid Fighter','apostle_mage','11.00','38.50',69,'male','L2Monster','Mystic',40,46520,123.830,1859,9.000,40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,253,6718,0,0,50,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2176,10328,25328,'Eilhalder von Hellmann','Raid Boss','vampire_lord','7.50','25.80',71,'male','L2RaidBoss','Fighter',40,900867,355.000,3718,9.000,60,57,73,76,70,80,2142425,952990,7927,3848,11244,1562,409,0,2901,0,0,0,15,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.56),
(2177,10329,25329,'Violet','Raid Fighter','vampire_witch','6.00','21.50',70,'female','L2Monster','Mystic',40,63242,142.000,1859,9.000,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2178,10330,25330,'Kurstin','Raid Fighter','vampire_witch','6.00','21.50',70,'female','L2Monster','Mystic',40,63242,142.000,1859,9.000,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2179,10331,25331,'Mina','Raid Fighter','vampire_witch','6.00','21.50',70,'female','L2Monster','Mystic',40,63242,142.000,1859,9.000,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2180,10332,25332,'Dorian','Raid Fighter','vampire_soldier','8.00','23.50',70,'male','L2Monster','Fighter',40,94391,142.000,1859,9.000,40,43,30,41,20,10,0,0,13791,1882,35947,764,278,0,253,234,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.45),
(2181,10333,25333,'Anakazel','Invaders'' Leader','dre_vanul_bi_one','21.00','54.00',28,'male','L2Monster','Fighter',40,193763,51.790,3718,9.000,60,57,73,76,70,80,629182,56542,163,1044,32,424,409,0,2901,0,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.35),
(2182,10334,25334,'Anakazel','Invaders'' Leader','dre_vanul_bi_one','21.00','54.00',38,'male','L2Monster','Fighter',40,306698,73.530,3718,9.000,60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,2901,0,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.35),
(2183,10335,25335,'Anakazel','Invaders'' Leader','kaim_vanul_20_bi','28.00','48.00',48,'male','L2Monster','Fighter',40,494363,97.750,3718,9.000,60,57,73,76,70,80,1173349,137957,1205,2094,514,850,409,0,2901,0,0,0,37,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2184,10336,25336,'Anakazel','Invaders'' Leader','kaim_vanul_20_bi','28.00','48.00',58,'male','L2Monster','Fighter',40,705074,121.930,3718,9.000,60,57,73,76,70,80,1470377,229005,2848,2798,1790,1136,409,0,2901,0,0,0,37,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2185,10337,25337,'Anakazel','Invaders'' Leader','karik','25.00','90.00',68,'male','L2Monster','Fighter',40,865808,132.250,3718,9.000,60,57,73,76,70,80,1812663,349493,4854,3596,3563,1460,409,0,2901,0,0,0,37,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2186,10338,25338,'Anakazel','Invaders'' Leader','karik','25.00','90.00',78,'male','L2Monster','Fighter',40,977523,133.250,3718,9.000,60,57,73,76,70,80,2238492,462266,7410,4444,6271,1805,409,0,2901,0,0,0,37,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2187,10339,25339,'Shadow of Halisha','Ruler of Sepulcher','halisha_a','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,96646,129.650,3718,9.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,-18,0.48),
(2188,10340,25340,'Knight of Shadow','','vale_master','12.00','40.00',80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.74),
(2189,10341,25341,'Knight of Shadow','','eligor','21.00','35.00',80,'male','L2Minion','Fighter',40,6414,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,35,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.48),
(2190,10342,25342,'Shadow of Halisha','Ruler of Sepulcher','halisha_b','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,96646,129.650,3718,9.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,-18,0.48),
(2191,10343,25343,'Knight of Shadow','','vale_master','12.00','40.00',80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.74),
(2192,10344,25344,'Knight of Shadow','','fiend_archer','17.00','55.00',80,'male','L2Minion','Ranger',500,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,12691,2419,3381,982,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,0,0.76),
(2193,10345,25345,'Knight of shadow','','lilim_wizard','9.00','34.00',80,'female','L2Minion','Fighter',40,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2194,10346,25346,'Shadow of Halisha','Ruler of Sepulcher','halisha_c','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,96646,129.650,3718,9.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,-18,0.48),
(2195,10347,25347,'Knight of Shadow','','lilim_wizard','9.00','34.00',80,'female','L2Minion','Fighter',40,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2196,10348,25348,'Knight of Shadow','','death_lord','21.00','40.00',80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,8567,2419,7608,982,278,0,253,78,0,0,40,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2197,10349,25349,'Shadow of Halisha','Ruler of Sepulcher','halisha_d','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,96646,129.650,3718,9.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,-18,0.48),
(2198,10350,25350,'Knight of Shadow','','lilim_wizard','9.00','34.00',80,'female','L2Minion','Fighter',40,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2199,10351,25351,'Knight of Shadow','','vale_master','12.00','40.00',80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.74),
(2200,10352,25352,'Giant Wasteland Basilisk','Raid Boss','lesser_basilisk','12.00','22.00',30,'male','L2RaidBoss','raidboss',40,127782,55.850,3718,9.000,60,57,73,76,70,80,636918,59660,96,1127,9,458,409,0,2901,0,0,0,35,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.39),
(2201,10353,25353,'Giant Wasteland Basilisk','Raid Fighter','lesser_basilisk_sm','12.00','22.00',29,'male','L2Monster','Fighter',40,12952,21.520,1859,9.000,40,43,30,41,20,10,0,0,174,542,35,220,278,0,253,0,0,0,35,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2202,10354,25354,'Gargoyle Lord Sirocco','Raid Boss','gargoyle_bi','16.00','65.00',35,'male','L2RaidBoss','Fighter',40,165289,77.760,3718,9.000,60,57,73,76,70,80,1193687,138419,300,1356,59,550,409,0,2901,0,0,0,140,190,'',0,0,'stiff_fix_outofdate_from_306','1145636093',0,0,0,7,30,4,20,0,-18,0.37),
(2203,10355,25355,'Sirocco''s Gargoyle','Raid Fighter','gargoyle','16.00','50.00',34,'male','L2Monster','Fighter',40,8316,30.060,1859,9.000,40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,0,0,0,140,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.37),
(2204,10356,25356,'Sirocco''s Guards','Raid Fighter','gargoyle','16.00','50.00',34,'male','L2Monster','Fighter',40,16632,30.060,1859,9.000,40,43,30,41,20,10,0,0,554,654,220,265,278,0,253,0,0,0,140,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.37),
(2205,10357,25357,'Sukar Wererat Chief','Raid Boss','wererat','14.00','25.00',21,'male','L2RaidBoss','Fighter',40,90169,38.900,3718,9.000,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,2901,216,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_414','1145636093',0,0,0,7,30,4,20,0,-18,0.61),
(2206,10358,25358,'Sukar Wererat Guard','Raid Fighter','wererat_sm','14.00','18.70',20,'male','L2Monster','Fighter',40,9314,14.890,1859,9.000,40,43,30,41,20,10,0,0,60,378,8,153,278,0,253,216,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.61),
(2207,10359,25359,'Sukar Wererat Priest','Raid Fighter','wererat_sm','14.00','18.70',20,'male','L2Monster','Priest',40,9314,14.890,1859,9.000,40,43,30,41,20,10,0,0,30,378,2,153,278,0,253,179,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.61),
(2208,10360,25360,'Tiger Hornet','Raid Boss','giant_bee_bi','8.00','32.00',26,'male','L2RaidBoss','raidboss',40,107186,47.890,3718,9.000,60,57,73,76,70,80,621174,53601,67,966,6,392,409,0,2901,0,0,0,90,190,'',0,0,'stiff_fix_outofdate_from_493','1145636094',0,0,0,7,30,4,20,0,-18,0.50),
(2209,10361,25361,'Yellow Hornet','Raid Fighter','giant_bee','8.00','24.50',25,'male','L2Monster','Fighter',40,10950,18.400,1859,9.000,40,43,30,41,20,10,0,0,122,464,23,188,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2210,10362,25362,'Tracker Leader Sharuk','Raid Boss','virud_lizardman_warrior','12.00','30.00',23,'male','L2RaidBoss','Fighter',40,95986,42.360,3718,9.000,60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,2901,291,0,0,52,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.59),
(2211,10363,25363,'Sharuk''s Tracker','Raid Fighter','virud_lizardman','10.00','23.00',22,'male','L2Monster','Fighter',40,4935,16.240,1859,9.000,40,43,30,41,20,10,0,0,47,411,4,167,278,0,253,2,0,0,43,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2212,10364,25364,'Sharuk''s Marksman','Raid Fighter','virud_lizardman_scout','10.00','22.00',22,'male','L2Monster','Ranger',500,6613,16.240,1859,9.000,40,43,30,41,20,10,0,0,140,411,7,167,278,0,253,2507,0,0,43,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,1500,0,0.72),
(2213,10365,25365,'Patriarch Kuroboros','Raid Boss','virud_lizardman_warrior_bi','12.00','34.50',26,'male','L2RaidBoss','Fighter',40,214372,47.890,3718,9.000,60,57,73,76,70,80,621174,53601,135,966,25,392,409,0,2901,93,0,0,52,190,'',0,0,'stiff_fix_outofdate_from_332','1145636093',0,0,0,7,30,4,20,0,-18,0.59),
(2214,10366,25366,'Kuroboros'' Priest','Raid Boss','virud_lizardman_matriarch','13.00','37.00',23,'male','L2RaidBoss','Priest',40,95986,42.360,3718,9.000,60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,2901,2,0,0,56,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.65),
(2215,10367,25367,'Kuroboros'' Follower','Raid Fighter','virud_lizardman','10.00','23.00',22,'male','L2Monster','Fighter',40,9870,16.240,1859,9.000,40,43,30,41,20,10,0,0,94,411,17,167,278,0,253,1,102,0,43,190,NULL,0,0,'Local',NULL,0,20,185,7,30,4,20,0,0,0.48),
(2216,10368,25368,'Kuroboros'' Discipline','Raid Fighter','virud_lizardman_shaman','10.00','29.00',22,'male','L2Monster','Priest',40,9870,16.240,1859,9.000,40,43,30,41,20,10,0,0,47,411,4,167,278,0,253,179,0,0,43,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48),
(2217,10369,25369,'Soul Scavenger','Raid Boss','dark_horror_bi','20.00','42.00',25,'male','L2RaidBoss','Fighter',40,103092,46.000,3718,9.000,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,2901,0,0,0,100,190,'',0,0,'stiff_fix_outofdate_from_409','1145636093',0,0,0,7,30,4,20,0,-18,0.37),
(2218,10370,25370,'Corpse Scavenger','Raid Fighter','skeleton_bi','11.00','31.00',24,'male','L2Monster','Fighter',40,10554,17.660,1859,9.000,40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,946,0,0,60,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.30),
(2219,10371,25371,'Anima Scavenger','Raid Fighter','spartoi','11.00','27.00',24,'male','L2Monster','Fighter',40,5277,17.660,1859,9.000,40,43,30,41,20,10,0,0,56,446,5,181,278,0,253,946,0,0,60,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.30),
(2220,10372,25372,'Discarded Guardian','Raid Boss','stone_golem_bi','20.00','40.30',20,'male','L2RaidBoss','Mystic',40,175392,37.230,3718,9.000,60,57,73,76,70,80,436632,37265,61,757,8,307,409,0,2901,0,0,0,23,190,'',0,0,'stiff_fix_outofdate_from_384','1145636093',0,0,0,7,30,4,20,0,-18,0.41),
(2221,10373,25373,'Malex Herald of Dagoniel ','Raid Boss','dre_vanul_bi_one','14.00','43.20',21,'male','L2RaidBoss','raidboss',40,90169,38.900,3718,9.000,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,2901,0,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_344','1145636093',0,0,0,7,30,4,20,0,-18,0.35),
(2222,10374,25374,'Abyss Flyer','Raid Fighter','vampire_bat','10.00','33.50',20,'male','L2Monster','Mystic',40,9314,14.890,1859,9.000,40,43,30,41,20,10,0,0,60,378,8,153,278,0,253,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2223,10375,25375,'Zombie Lord Farakelsus','Raid Boss','zombie_bi','13.00','27.50',20,'male','L2RaidBoss','Fighter',40,87696,37.230,3718,9.000,60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,2901,0,0,0,15,190,'',0,0,'stiff_fix_outofdate_from_459','1145636093',0,0,0,7,30,4,20,0,-18,0.43),
(2224,10376,25376,'Warrior Zombie of Farakelsus','Raid Fighter','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,15,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.43),
(2225,10377,25377,'Priest Zombie of Farakelsus','Raid Fighter','zombie','13.00','21.00',19,'male','L2Monster','Priest',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,27,363,1,147,278,0,253,0,0,0,15,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.43),
(2226,10378,25378,'Madness Beast','Raid Boss','onyx_beast_bi','14.00','18.70',20,'male','L2RaidBoss','Fighter',40,87696,37.230,3718,9.000,60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,2901,0,0,0,30,190,'',0,0,'stiff_fix_outofdate_from_366','1145636093',0,0,0,7,30,4,20,0,-18,0.24),
(2227,10379,25379,'Dementia Beast','Raid Fighter','onyx_beast','14.00','14.50',19,'male','L2Monster','Fighter',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,30,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.24),
(2228,10380,25380,'Kaysha Herald of Icarus','Raid Boss','succubus_bi','10.00','43.20',21,'female','L2RaidBoss','Mystic',40,90169,38.900,3718,9.000,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,2901,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(2229,10381,25381,'Nightmare Flyer','Raid Fighter','vampire_bat_bi','10.00','42.00',19,'male','L2Monster','Mystic',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2230,10382,25382,'Hostile Flyer','Raid Fighter','vampire_bat','10.00','33.50',19,'male','L2Monster','Mystic',40,4540,14.240,1859,9.000,40,43,30,41,20,10,0,0,27,363,1,147,278,0,253,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.50),
(2231,10383,25383,'Revenant of Sir Calibus','Raid Boss','death_knight_bi','12.00','30.00',34,'male','L2RaidBoss','Fighter',40,156584,64.420,3718,9.000,60,57,73,76,70,80,840195,76283,158,1308,20,531,409,0,2901,75,0,0,27,190,'',0,0,'stiff_fix_outofdate_from_687','1145636094',0,0,0,7,30,4,20,0,-18,0.71),
(2232,10384,25384,'Servant of Calibus','Raid Fighter','spartoi','11.00','27.00',33,'male','L2Monster','Fighter',40,15774,24.890,1859,9.000,40,43,30,41,20,10,0,0,292,630,75,256,278,0,253,946,0,0,60,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.30),
(2233,10385,25385,'Evil Spirit Tempest','Raid Boss','dre_vanul_bi_one','21.00','54.00',36,'male','L2RaidBoss','raidboss',40,174646,68.910,3718,9.000,60,57,73,76,70,80,867472,80701,185,1405,24,570,409,0,2901,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.35),
(2234,10386,25386,'Ghost of the Execution Grounds','Raid Fighter','skeleton_bi','11.00','31.00',35,'male','L2Monster','Fighter',40,17556,26.660,1859,9.000,40,43,30,41,20,10,0,0,336,678,87,275,278,0,253,128,0,0,60,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.30),
(2235,10387,25387,'Malignant Spirit of the Execution Grounds','Raid Fighter','skeleton','11.00','25.00',35,'male','L2Monster','Fighter',40,8778,26.660,1859,9.000,40,43,30,41,20,10,0,0,168,678,21,275,278,0,253,946,0,0,60,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.30),
(2236,10388,25388,'Red Eye Captain Trakia','Raid Boss','oel_mahum_bi','30.00','55.00',35,'male','L2RaidBoss','Fighter',40,165289,66.650,3718,9.000,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,2901,70,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.48),
(2237,10389,25389,'Red Eye Archer ','Raid Fighter','ol_mahum_archer','14.00','25.00',34,'male','L2Monster','Ranger',500,11143,25.770,1859,9.000,40,43,30,41,20,10,0,0,464,654,36,265,278,0,253,279,0,0,50,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,0,0.93),
(2238,10390,25390,'Red Eye Guards','Raid Fighter','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,8316,25.770,1859,9.000,40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,128,0,0,50,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.63),
(2239,10391,25391,'Nurka''s Messenger','Raid Boss','ol_mahum_champion_bi','21.00','40.50',33,'male','L2RaidBoss','Fighter',40,297015,62.230,3718,9.000,60,57,73,76,70,80,825587,73993,295,1261,75,512,409,0,2901,127,0,0,50,190,NULL,0,0,'stiff_fix_outofdate_from_693','1145636094',0,0,0,7,30,4,20,0,-18,0.63),
(2240,10392,25392,'Captain of Queen''s Royal Guards','Raid Boss','marsh_stakato_queen','15.00','37.00',32,'female','L2RaidBoss','Fighter',40,141034,60.060,3718,9.000,60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,2901,129,0,0,130,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.41),
(2241,10393,25393,'Marsh Stakato Noble','Raid Fighter','marsh_stakato_drone','9.00','24.00',31,'male','L2Monster','Fighter',40,14247,23.170,1859,9.000,40,43,30,41,20,10,0,0,246,585,61,237,278,0,253,223,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2242,10394,25394,'Premo Prime','Raid Boss','twin_headed_giant','17.00','39.00',38,'male','L2RaidBoss','raidboss',40,390743,73.530,3718,9.000,60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,2901,88,0,0,45,190,'',0,0,'stiff_fix_outofdate_from_697','1145636094',0,0,0,7,30,4,20,0,-18,0.46),
(2243,10395,25395,'Archon Suscepter','Raid Boss','susceptor_prime','45.00','72.00',45,'male','L2RaidBoss','raidboss',40,288415,90.360,3718,9.000,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,2901,0,0,0,78,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.52),
(2244,10396,25396,'Kusion Suscepter','Raid Fighter','susceptor','20.00','35.00',44,'male','L2Monster','Fighter',40,6649,35.160,1859,9.000,40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,27,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.43),
(2245,10397,25397,'Gustos Suscepter','Raid Fighter','susceptor','20.00','35.00',44,'male','L2Monster','Fighter',40,29037,35.160,1859,9.000,40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,27,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.43),
(2246,10398,25398,'Eye of Beleth','Raid Boss','monster_eye','21.00','43.00',35,'male','L2RaidBoss','Mystic',40,165289,66.650,3718,9.000,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,2901,0,0,0,90,190,'',0,0,'stiff_fix_outofdate_from_701','1145636094',0,0,0,7,30,4,20,0,-18,0.30),
(2247,10399,25399,'Apprentice of Watchman','Raid Fighter','mana_vampire','11.00','20.00',34,'male','L2Monster','Mystic',40,11143,25.770,1859,9.000,40,43,30,41,20,10,0,0,209,654,36,265,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2248,10400,25400,'Page of Watchman','Raid Fighter','magical_weaver','11.00','20.00',34,'male','L2Monster','Mystic',40,16632,25.770,1859,9.000,40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2249,10401,25401,'Skyla','Raid Boss','zenta_lizardman_matriarch_bi','30.00','63.00',32,'male','L2RaidBoss','raidboss',40,141034,60.060,3718,9.000,60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,2901,215,0,0,53,190,'',0,0,'stiff_fix_outofdate_from_703','1145636094',0,0,0,7,30,4,20,0,-18,0.46),
(2250,10402,25402,'Retainer of Skyla','Raid Fighter','zenta_lizardman','11.00','32.00',31,'male','L2Monster','Fighter',40,14247,23.170,1859,9.000,40,43,30,41,20,10,0,0,246,585,61,237,278,0,253,221,0,0,37,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.28),
(2251,10403,25403,'Follower of Skyla','Raid Fighter','zenta_lizardman_shaman','13.00','35.00',31,'male','L2Monster','Priest',40,9545,23.170,1859,9.000,40,43,30,41,20,10,0,0,164,585,27,237,278,0,253,180,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.63),
(2252,10404,25404,'Corsair Captain Kylon','Raid Boss','pirates_zombie_captain','16.00','44.00',33,'male','L2RaidBoss','Fighter',40,148507,62.230,3718,9.000,60,57,73,76,70,80,825587,73993,147,1261,18,512,409,0,2901,231,0,0,14,190,'',0,0,'stiff_fix_outofdate_from_705','1145636094',0,0,0,7,30,4,20,0,-18,0.76),
(2253,10405,25405,'Kylon''s Pirate','Raid Fighter','skeleton_bi_one','16.00','40.00',32,'male','L2Monster','Fighter',40,14980,24.030,1859,9.000,40,43,30,41,20,10,0,0,271,607,69,246,278,0,253,946,945,0,60,190,NULL,0,1,'Local',NULL,0,20,251,7,30,4,20,0,0,0.30),
(2254,10406,25406,'Kylon''s Mate','Raid Fighter','skeleton_knight_50_bi','15.00','39.00',32,'male','L2Monster','Fighter',40,14980,24.030,1859,9.000,40,43,30,41,20,10,0,0,271,607,69,246,278,0,253,130,103,0,40,190,NULL,0,1,'Local',NULL,0,20,251,7,30,4,20,0,0,0.17),
(2255,10407,25407,'Lord Ishka','Raid Boss','death_blader_bi','22.00','67.00',60,'male','L2RaidBoss','Fighter',40,526218,126.480,3718,9.000,60,57,73,76,70,80,1496444,237315,1642,2951,547,1198,409,0,2901,1472,0,0,100,190,'',0,0,'stiff_fix_outofdate_from_707','1145636094',0,0,0,7,30,4,20,0,-18,0.45),
(2256,10408,25408,'Ishka''s Elite Officer','Raid Fighter','skeleton_royal_guard','11.00','28.50',59,'male','L2Monster','Fighter',40,54404,49.690,1859,9.000,40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,253,946,945,0,80,190,NULL,0,1,'Local',NULL,0,20,485,7,30,4,20,0,0,0.52),
(2257,10409,25409,'Ishka''s Elite Soldier','Raid Fighter','skeleton_knight_20_bi','12.00','30.50',59,'male','L2Monster','Fighter',40,54404,49.690,1859,9.000,40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,253,150,103,0,40,190,NULL,0,1,'Local',NULL,0,20,485,7,30,4,20,0,0,0.17),
(2258,10410,25410,'Road Scavenger Leader','Raid Boss','wererat_bi','21.00','38.00',40,'male','L2RaidBoss','Fighter',40,218810,91.280,3718,9.000,60,57,73,76,70,80,1279280,187517,427,1615,87,656,409,0,2901,88,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.61),
(2259,10411,25411,'Road Scavenger Henchman','Raid Fighter','kobold_bi','15.00','24.00',39,'male','L2Monster','Fighter',40,21961,35.410,1859,9.000,40,43,30,41,20,10,0,0,786,780,323,317,278,0,253,0,0,0,47,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.54),
(2260,10412,25412,'Necrosentinel Royal Guard','Raid Boss','skeleton_royal_guard','11.00','28.50',47,'male','L2RaidBoss','Fighter',40,319791,95.280,3718,9.000,60,57,73,76,70,80,1162159,134535,546,2030,111,824,409,0,2901,946,946,0,80,190,'',0,0,'Local','',0,0,746,7,30,4,20,0,-18,0.52),
(2261,10413,25413,'Necrosentinel Archer','Raid Fighter','skeleton_archer','11.00','27.00',46,'male','L2Monster','Ranger',500,21628,37.130,1859,9.000,40,43,30,41,20,10,0,0,1454,983,172,399,278,0,253,279,0,0,40,190,'',0,1,'Local','',0,0,0,7,30,4,20,1500,0,0.80),
(2262,10414,25414,'Necrosentinel Soldier','Raid Fighter','skeleton_knight','10.00','25.00',46,'male','L2Monster','Fighter',40,16140,37.130,1859,9.000,40,43,30,41,20,10,0,0,490,983,97,399,278,0,253,150,103,0,40,190,'',0,1,'Local','',0,20,364,7,30,4,20,0,0,0.17),
(2263,10415,25415,'Nakondas','Raid Boss','drake_bi','37.00','125.00',35,'male','L2RaidBoss','raidboss',40,218810,66.650,3718,9.000,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,2901,0,0,0,70,190,'',0,0,'stiff_fix_outofdate_from_713','1145636094',0,0,0,7,30,4,20,0,-18,0.84),
(2264,10416,25416,'Nakondas'' Slave ','Raid Fighter','wyrm','29.00','72.00',34,'male','L2Monster','Fighter',40,14713,25.770,1859,9.000,40,43,30,41,20,10,0,0,209,654,36,265,278,0,253,0,0,0,70,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.19),
(2265,10417,25417,'Nakondas'' Chain ','Raid Fighter','succubus','10.00','36.00',34,'female','L2Monster','Mystic',40,21961,25.770,1859,9.000,40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,0,0,0,60,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.84),
(2266,10418,25418,'Dread Avenger Kraven','Raid Boss','death_knight_bi','12.00','30.00',44,'male','L2RaidBoss','Fighter',40,273375,87.900,3718,9.000,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,2901,75,0,0,27,190,'',0,0,'stiff_fix_outofdate_from_715','1145636094',0,0,0,7,30,4,20,0,-18,0.71),
(2267,10419,25419,'Dread Panther','Raid Fighter','onyx_beast','14.00','14.50',43,'male','L2Monster','Fighter',40,27494,34.190,1859,9.000,40,43,30,41,20,10,0,0,756,892,272,362,278,0,253,0,0,0,30,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.24),
(2268,10420,25420,'Orfen''s Handmaiden','Raid Boss','riba','25.00','72.00',48,'female','L2RaidBoss','raidboss',40,335987,114.040,3718,9.000,60,57,73,76,70,80,1639757,244248,1060,2094,345,850,409,0,2901,0,0,0,60,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2269,10421,25421,'Trisalim Escort','Raid Fighter','poison_spider_bi','40.00','38.00',47,'male','L2Monster','Mystic',40,22758,44.460,1859,9.000,40,43,30,41,20,10,0,0,1259,1015,526,412,278,0,253,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.65),
(2270,10422,25422,'Page of Rotting Tree','Raid Fighter','hanged_man_ripper','35.00','80.00',47,'male','L2Monster','Fighter',40,33967,44.460,1859,9.000,40,43,30,41,20,10,0,0,945,1015,296,412,278,0,253,0,0,0,55,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.48),
(2271,10423,25423,'Fairy Queen Timiniel','Raid Boss','pixy_bi','10.00','54.00',56,'female','L2RaidBoss','raidboss',40,539706,136.790,3718,9.000,60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,409,0,2901,0,0,0,80,190,'timiniel_clan',300,0,'stiff_fix_outofdate_from_719','1145636094',0,0,0,7,30,4,20,0,-18,0.72),
(2272,10424,25424,'Timiniel''s Royal Guards','Raid Fighter','pixy','5.00','25.00',55,'female','L2Monster','Fighter',40,27947,53.600,1859,9.000,40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,253,0,0,0,80,190,'timiniel_clan',300,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72),
(2273,10425,25425,'Timiniel''s Royal Guard Captain','Raid Fighter','pixy','5.00','25.00',55,'female','L2Monster','Fighter',40,55894,53.600,1859,9.000,40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,253,0,0,0,80,190,'timiniel_clan',300,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72),
(2274,10426,25426,'Betrayer of Urutu Freki','Raid Boss','werewolf_bi','11.00','29.70',25,'male','L2RaidBoss','Fighter',40,103092,46.000,3718,9.000,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,2901,0,0,0,50,190,'',0,0,'stiff_fix_outofdate_from_721','1145636094',0,0,0,7,30,4,20,0,-18,0.43),
(2275,10427,25427,'Freki''s Vampire Bat','Raid Fighter','vampire_bat','10.00','33.50',24,'male','L2Monster','Mystic',40,10554,17.660,1859,9.000,40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,0,0,0,60,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50),
(2276,10428,25428,'Freki''s Wild Bear','Raid Fighter','grizzly','21.00','40.00',24,'male','L2Monster','Fighter',40,10554,17.660,1859,9.000,40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,0,0,0,40,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34),
(2277,10429,25429,'Mammon Collector Talos','Raid Boss','ashuras','13.00','37.50',25,'male','L2RaidBoss','raidboss',40,103092,46.000,3718,9.000,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,2901,0,0,0,41,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.50),
(2278,10430,25430,'Talos'' Cohort','Raid Fighter','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,9870,16.240,1859,9.000,40,43,30,41,20,10,0,0,94,411,17,167,278,0,253,0,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35),
(2279,10431,25431,'Flamestone Golem','Raid Boss','lava_golem','22.00','45.00',44,'male','L2RaidBoss','Fighter',40,273375,87.900,3718,9.000,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,2901,0,0,0,13,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.47),
(2280,10432,25432,'Elemental of Flame','Raid Fighter','mana_vampire','11.00','20.00',43,'male','L2Monster','Mystic',40,27494,34.190,1859,9.000,40,43,30,41,20,10,0,0,378,892,68,362,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2281,10433,25433,'Elemental of Spark','Raid Fighter','magical_weaver','11.00','20.00',43,'male','L2Monster','Mystic',40,13747,34.190,1859,9.000,40,43,30,41,20,10,0,0,378,892,68,362,278,0,253,0,0,0,90,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2282,10434,25434,'Bandit Leader Barda','Raid Boss','oel_mahum_warrior_50_bi','30.00','60.00',55,'male','L2RaidBoss','Fighter',40,451391,114.860,3718,9.000,60,57,73,76,70,80,1432099,216652,1156,2576,336,1046,409,0,2901,121,0,0,70,190,'',0,0,'stiff_fix_outofdate_from_866','1145636094',0,0,0,7,30,4,20,0,-18,0.65),
(2283,10435,25435,'Barda''s Bandit','Raid Fighter','oel_mahum','20.00','37.00',54,'male','L2Monster','Fighter',40,46232,44.980,1859,9.000,40,43,30,41,20,10,0,0,2132,1252,1228,508,278,0,253,145,0,0,70,190,NULL,0,0,'stiff_fix_outofdate_from_867','1145636094',0,0,0,7,30,4,20,0,0,0.48),
(2284,10436,25436,'Barda''s Shaman','Raid Fighter','oel_mahum_witch_doctor','15.00','34.00',54,'male','L2Monster','Priest',40,30975,44.980,1859,9.000,40,43,30,41,20,10,0,0,1421,1252,546,508,278,0,253,201,0,0,70,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26),
(2285,10437,25437,'Timak Orc Gosmos','Raid Boss','batur_orc_overlord_100_bi','24.00','52.00',45,'male','L2RaidBoss','Fighter',40,576831,90.360,3718,9.000,60,57,73,76,70,80,1139085,129941,912,1905,346,774,409,0,2901,145,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_868','1145636094',0,0,0,7,30,4,20,0,-18,0.28),
(2286,10438,25438,'Thief Kelbar','Raid Boss','wererat_100_bi','25.00','50.00',44,'male','L2RaidBoss','Fighter',40,273375,87.900,3718,9.000,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,2901,239,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_870','1145636095',0,0,0,7,30,4,20,0,-18,0.61),
(2287,10439,25439,'Kelbar''s Inferior','Raid Fighter','wererat_bi','21.00','38.00',43,'male','L2Monster','Fighter',40,27494,34.190,1859,9.000,40,43,30,41,20,10,0,0,756,892,272,362,278,0,253,130,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.61),
(2288,10440,25440,'Kelbar''s Wizard','Raid Fighter','wererat','14.00','25.00',43,'male','L2Monster','Fighter',40,18421,34.190,1859,9.000,40,43,30,41,20,10,0,0,504,892,121,362,278,0,253,99,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.61),
(2289,10441,25441,'Evil Spirit Cyrion','Raid Boss','drake_50_bi','45.00','150.00',45,'male','L2RaidBoss','raidboss',40,288415,90.360,3718,9.000,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,2901,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.84),
(2290,10442,25442,'Evil Creature of Forest','Raid Fighter','crimson_bear','19.00','36.00',44,'male','L2Monster','Fighter',40,14518,35.160,1859,9.000,40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,37,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.45),
(2291,10443,25443,'Anger of Forest','Raid Fighter','giant_wild_hog','25.00','27.00',44,'male','L2Monster','Fighter',40,29037,35.160,1859,9.000,40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,35,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.54),
(2292,10444,25444,'Enmity Ghost Ramdal','Raid Boss','dark_horror_100_bi','40.00','70.00',65,'male','L2RaidBoss','Fighter',40,588136,130.580,3718,9.000,60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,2901,0,0,0,100,190,'',0,0,'stiff_fix_outofdate_from_874','1145636095',0,0,0,7,30,4,20,0,-18,0.37),
(2293,10445,25445,'Enmity Ghosts','Raid Fighter','crimson_doll','15.00','38.00',64,'male','L2Monster','Fighter',40,30636,51.950,1859,9.000,40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,253,0,0,0,60,190,'',0,1,'stiff_fix_outofdate_from_875','1145636095',0,0,0,7,30,4,20,0,0,0.67),
(2294,10446,25446,'Shooter of Enmity','Raid Fighter','skeleton_archer','11.00','27.00',64,'male','L2Minion','Ranger',500,41052,51.950,1859,9.000,40,43,30,41,20,10,0,0,6153,1634,1367,663,278,0,253,279,0,0,40,190,'',0,1,'Magister','',0,0,0,7,30,4,20,1500,0,0.80),
(2295,10447,25447,'Immortal Savior Mardil','Raid Boss','banshee_50_bi','13.50','38.00',71,'female','L2RaidBoss','Mystic',40,645953,133.310,3718,9.000,60,57,73,76,70,80,2068252,367642,2947,3848,1195,1562,409,0,2901,3939,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_876','1145636095',0,0,0,7,30,4,20,0,-18,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(2296,10448,25448,'Immortal Savior ','Raid Fighter','binding','12.00','21.00',70,'male','L2Monster','Fighter',40,33847,53.210,1859,9.000,40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,253,0,0,0,10,190,'',0,1,'stiff_fix_outofdate_from_877','1145636095',0,0,0,7,30,4,20,0,0,0.54),
(2297,10449,25449,'Immortal Guide','Raid Fighter','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,67694,53.210,1859,9.000,40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,253,0,0,0,80,190,'',0,0,'Magister','',0,0,0,7,30,4,20,0,0,0.34),
(2298,10450,25450,'Cherub Galaxia','Raid Boss','archangel_50_bi','22.00','120.00',79,'male','L2RaidBoss','Fighter',40,987470,355.000,3718,9.000,60,57,73,76,70,80,2377821,1136977,9883,4471,14504,1816,409,0,2901,97,0,0,50,190,'',0,0,'stiff_fix_outofdate_from_878','1145636095',0,0,0,7,30,4,20,0,-18,0.76),
(2299,10451,25451,'Galaxia''s Guards','Raid Fighter','angel','13.50','36.50',78,'male','L2Minion','Fighter',40,69545,142.400,1859,9.000,40,43,30,41,20,10,0,0,12640,2192,24904,890,278,0,253,148,0,0,30,190,NULL,0,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,0.52),
(2300,10452,25452,'Messenger of Angel','Raid Fighter','angel','13.50','36.50',79,'male','L2Minion','Fighter',40,104887,142.400,1859,9.000,40,43,30,41,20,10,0,0,9537,2206,14177,895,278,0,253,148,0,0,30,190,'',0,0,'Magister','',0,0,0,7,30,4,20,0,0,0.52),
(2301,10453,25453,'Meanas Anor','Raid Boss','wyrm_50_bi','58.00','108.00',70,'male','L2RaidBoss','Fighter',40,888658,288.220,3718,9.000,60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,409,0,2901,0,0,0,70,190,'',0,0,'stiff_fix_outofdate_from_881','1145636095',0,0,0,7,30,4,20,0,-18,0.19),
(2302,10454,25454,'Wyvern of Marsh','Raid Fighter','wyrm','29.00','72.00',69,'male','L2Monster','Fighter',40,62338,114.980,1859,9.000,40,43,30,41,20,10,0,0,7149,1840,9066,747,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.19),
(2303,10455,25455,'Succubus of Marsh','Raid Fighter','succubus','10.00','36.00',69,'female','L2Monster','Mystic',40,93041,114.980,1859,9.000,40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,253,0,0,0,60,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.84),
(2304,10456,25456,'Mirror of Oblivion','Raid Boss','mirror_50_bi','12.00','22.00',49,'male','L2RaidBoss','Mystic',40,352421,100.220,3718,9.000,60,57,73,76,70,80,1184339,140317,652,2160,143,877,409,0,2901,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.39),
(2305,10457,25457,'Shards of Oblivion','Raid Fighter','human_ghost','8.00','22.00',48,'male','L2Monster','Mystic',40,3808,39.100,1859,9.000,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2306,10458,25458,'Shadow of Oblivion','Raid Fighter','elf_ghost','7.00','21.00',48,'male','L2Monster','Mystic',40,7617,39.100,1859,9.000,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2307,10459,25459,'Shards of Oblivion','Raid Fighter','dwarf_ghost','9.00','16.50',48,'male','L2Monster','Mystic',40,3808,39.100,1859,9.000,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,1,'Local','',0,0,0,7,30,4,20,0,0,0.39),
(2308,10460,25460,'Deadman Ereve','Raid Boss','death_blader_200_bi','45.00','141.00',51,'male','L2RaidBoss','Fighter',40,385670,105.150,3718,9.000,60,57,73,76,70,80,1381165,185853,850,2294,219,931,409,0,2901,194,0,0,100,190,'',0,0,'stiff_fix_outofdate_from_887','1145636095',0,0,0,7,30,4,20,0,-18,0.45),
(2309,10461,25461,'Ereve''s Knight','Raid Fighter','skeleton_knight','10.00','25.00',50,'male','L2Monster','Fighter',40,39195,41.080,1859,9.000,40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,253,70,0,0,40,190,NULL,0,1,'stiff_fix_outofdate_from_888','1145636095',0,0,0,7,30,4,20,0,0,0.17),
(2310,10462,25462,'Ereve''s Squire','Raid Fighter','skeleton_pikeman','10.00','28.00',50,'male','L2Monster','Fighter',40,39195,41.080,1859,9.000,40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,253,98,0,0,50,190,NULL,0,1,'Local',NULL,0,0,0,7,30,4,20,0,0,0.21),
(2311,10463,25463,'Harit Guardian Garangky','Raid Boss','saber_toothed_tiger','72.00','87.00',56,'male','L2RaidBoss','raidboss',40,467209,117.250,3718,9.000,60,57,73,76,70,80,1444796,221098,1237,2649,368,1075,409,0,2901,0,0,0,60,190,'',0,0,'stiff_fix_outofdate_from_890','1145636095',0,0,0,7,30,4,20,0,-18,0.45),
(2312,10464,25464,'Garangky Guard Captain','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',55,'male','L2Monster','Fighter',40,47946,45.940,1859,9.000,40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,253,303,0,0,40,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.56),
(2313,10465,25465,'Garangky Guard Shaman','Raid Fighter','zenta_lizardman_shaman','13.00','35.00',55,'male','L2Monster','Priest',40,47946,45.940,1859,9.000,40,43,30,41,20,10,0,0,1142,1288,336,523,278,0,253,206,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.63),
(2314,10466,25466,'Garangky Guard ','Raid Fighter','zenta_lizardman','11.00','32.00',55,'male','L2Monster','Fighter',40,47946,45.940,1859,9.000,40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,253,77,0,0,37,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.28),
(2315,10467,25467,'Gorgolos','Raid Boss','field_stalker_200_bi','45.00','96.00',64,'male','L2RaidBoss','raidboss',40,576851,129.880,3718,9.000,60,57,73,76,70,80,1744167,326947,2103,3268,769,1327,409,0,2901,0,0,0,70,190,'',0,0,'stiff_fix_outofdate_from_894','1145636095',0,0,0,7,30,4,20,0,-18,0.41),
(2316,10468,25468,'Cursed Life','Raid Fighter','field_stalker','15.00','30.00',63,'male','L2Monster','Fighter',40,30008,51.650,1859,9.000,40,43,30,41,20,10,0,0,2006,1594,744,647,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2317,10469,25469,'Cursed Soul','Raid Fighter','field_stalker','15.00','30.00',63,'male','L2Monster','Fighter',40,60016,51.650,1859,9.000,40,43,30,41,20,10,0,0,4012,1594,2979,647,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2318,10470,25470,'Last Titan Utenus','Raid Boss','lesser_giant_mage','21.00','44.00',66,'male','L2RaidBoss','Mystic',40,598898,131.200,3718,9.000,60,57,73,76,70,80,1777636,338244,2252,3431,821,1393,409,0,2901,3938,0,0,15,190,'',0,0,'stiff_fix_outofdate_from_896','1145636095',0,0,0,7,30,4,20,0,-18,0.56),
(2319,10471,25471,'Utenus''s Wizard','Raid Fighter','lesser_giant','21.00','44.00',65,'male','L2Monster','Mystic',40,41855,52.230,1859,9.000,40,43,30,41,20,10,0,0,2866,1674,1412,680,278,0,253,0,0,0,15,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.58),
(2320,10472,25472,'Utenus''s Guard','Raid Fighter','leogul','15.00','35.00',65,'male','L2Monster','Fighter',40,62470,52.230,1859,9.000,40,43,30,41,20,10,0,0,4299,1674,3178,680,278,0,253,0,0,0,80,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72),
(2321,10473,25473,'Grave Robber Kim','Raid Boss','batur_orc_warrior_100_bi','20.00','42.00',52,'male','L2RaidBoss','Fighter',40,402319,107.600,3718,9.000,60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,2901,160,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_898','1145636095',0,0,0,7,30,4,20,0,-18,0.30),
(2322,10474,25474,'Kim''s Gang','Raid Fighter','batur_orc','9.00','21.50',51,'male','L2Monster','Fighter',40,40965,42.060,1859,9.000,40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,253,89,0,0,80,190,NULL,0,0,'stiff_fix_outofdate_from_899','1145636095',0,0,0,7,30,4,20,0,0,0.46),
(2323,10475,25475,'Ghost Knight Kabed','Raid Boss','headless_knight_50_bi','30.00','46.50',55,'male','L2RaidBoss','Fighter',40,451391,114.860,3718,9.000,60,57,73,76,70,80,1393657,221098,1156,2576,336,1046,409,0,2901,145,0,0,70,190,'',0,0,'stiff_fix_outofdate_from_900','1145636095',0,0,0,7,30,4,20,0,-18,0.52),
(2324,10476,25476,'Kabed''s Soldier','Raid Fighter','skeleton_knight','10.00','25.00',54,'male','L2Monster','Fighter',40,23116,44.980,1859,9.000,40,43,30,41,20,10,0,0,1066,1252,307,508,278,0,253,125,0,0,40,190,NULL,0,1,'Local',NULL,0,0,0,7,30,4,20,0,0,0.17),
(2325,10477,25477,'Kabed''s Archer','Raid Fighter','skeleton_archer','11.00','27.00',54,'male','L2Monster','Ranger',500,30975,44.980,1859,9.000,40,43,30,41,20,10,0,0,3158,1252,546,508,278,0,253,279,0,0,40,190,NULL,0,1,'Local',NULL,0,0,0,7,30,4,20,1500,0,0.80),
(2326,10478,25478,'Shilen''s Priest Hisilrome','Raid Boss','cave_maiden','25.00','65.00',65,'female','L2RaidBoss','Priest',40,588136,130.580,3718,9.000,60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,2901,230,0,0,70,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.43),
(2327,10479,25479,'Hisilrome''s Servitor','Raid Fighter','serpent_slave','17.00','46.00',64,'male','L2Monster','Fighter',40,41052,51.950,1859,9.000,40,43,30,41,20,10,0,0,2769,1634,1367,663,278,0,253,68,0,0,70,190,NULL,0,0,'stiff_fix_outofdate_from_903','1145636095',0,0,0,7,30,4,20,0,0,0.46),
(2328,10480,25480,'Hisilrome''s Page','Raid Fighter','lienrik','12.00','50.00',64,'male','L2Monster','Fighter',40,61272,51.950,1859,9.000,40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,253,0,0,0,100,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46),
(2329,10481,25481,'Magus Kenishee','Raid Boss','banshee_50_bi','13.50','38.00',53,'female','L2RaidBoss','Mystic',40,66938,110.040,3718,9.000,60,57,73,76,70,80,1406722,209570,996,2433,274,988,409,0,2901,3939,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.56),
(2330,10482,25482,'Shadow of Kenishee','Raid Fighter','shadow','10.00','30.00',52,'male','L2Monster','Mystic',40,8629,43.040,1859,9.000,40,43,30,41,20,10,0,0,1806,1181,969,479,278,0,253,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.54),
(2331,10483,25483,'Phantom of Kenishee','Raid Fighter','silhouette','8.00','23.00',52,'female','L2Monster','Fighter',40,8629,43.040,1859,9.000,40,43,30,41,20,10,0,0,903,1181,242,479,278,0,253,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.54),
(2332,10484,25484,'Zaken''s Chief Mate Tillion','Raid Boss','skeleton_knight_50_bi','15.00','39.00',50,'male','L2RaidBoss','Fighter',40,61148,102.690,3718,9.000,60,57,73,76,70,80,1195137,169534,706,2226,159,904,409,0,2901,160,0,0,40,190,NULL,0,0,'stiff_fix_outofdate_from_906','1145636095',0,0,0,7,30,4,20,0,-18,0.17),
(2333,10485,25485,'Tillion''s Inferior','Raid Fighter','skeleton_bi','11.00','31.00',49,'male','L2Monster','Fighter',40,7866,40.090,1859,9.000,40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,253,131,0,0,60,190,NULL,0,1,'Local',NULL,0,0,0,7,30,4,20,0,0,0.30),
(2334,10486,25486,'Tillion''s Bat','Raid Fighter','vampire_bat','10.00','33.50',49,'male','L2Monster','Mystic',40,7866,40.090,1859,9.000,40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,253,0,0,0,60,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50),
(2335,10487,25487,'Water Spirit Lian','Raid Boss','pixy_bi','15.00','81.00',40,'female','L2RaidBoss','raidboss',40,218810,78.240,3718,9.000,60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,2901,0,0,0,80,190,'',0,0,'stiff_fix_outofdate_from_909','1145636095',0,0,0,7,30,4,20,0,-18,0.72),
(2336,10488,25488,'Spirit of Gildor','Raid Fighter','pixy','5.00','25.00',39,'female','L2Monster','Fighter',40,14713,30.350,1859,9.000,40,43,30,41,20,10,0,0,299,780,54,317,278,0,253,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.72),
(2337,10489,25489,'Guardian of Gildor','Raid Fighter','pixy','5.00','25.00',39,'female','L2Monster','Fighter',40,21961,30.350,1859,9.000,40,43,30,41,20,10,0,0,449,780,121,317,278,0,253,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.72),
(2338,10490,25490,'Gwindorr','Raid Boss','serpent_slave','17.00','46.00',40,'male','L2RaidBoss','raidboss',40,218810,78.240,3718,9.000,60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,2901,129,0,0,70,190,'',0,0,'stiff_fix_outofdate_from_911','1145636095',0,0,0,7,30,4,20,0,-18,0.46),
(2339,10491,25491,'Guard of Gwindorr','Raid Fighter','virud_lizardman_scout','10.00','22.00',39,'male','L2Monster','Ranger',500,3678,30.350,1859,9.000,40,43,30,41,20,10,0,0,665,780,54,317,278,0,253,2507,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,1500,0,0.72),
(2340,10492,25492,'Follower of Gwindorr','Raid Fighter','virud_lizardman','10.00','23.00',39,'male','L2Monster','Fighter',40,10980,30.350,1859,9.000,40,43,30,41,20,10,0,0,224,780,30,317,278,0,253,2,0,0,43,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.48),
(2341,10493,25493,'Eva''s Spirit Niniel','Raid Boss','cutie_cat','8.00','15.00',55,'female','L2RaidBoss','raidboss',40,451391,114.860,3718,9.000,60,57,73,76,70,80,1432097,216652,1156,2576,336,1046,409,0,2901,0,0,0,48,190,NULL,0,0,'stiff_fix_outofdate_from_913','1145636095',0,0,0,7,30,4,20,0,-18,0.34),
(2342,10494,25494,'Spirit of Niniel','Raid Fighter','pixy','5.00','25.00',54,'female','L2Monster','Fighter',40,6091,44.980,1859,9.000,40,43,30,41,20,10,0,0,2187,1252,1685,508,278,0,253,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.72),
(2343,10495,25495,'Spirit of Niniel','Raid Fighter','pixy','5.00','25.00',54,'female','L2Monster','Fighter',40,23116,44.980,1859,9.000,40,43,30,41,20,10,0,0,1094,1252,420,508,278,0,253,0,0,0,80,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.72),
(2344,10496,25496,'Fafurion''s Envoy Pingolpin','Raid Boss','riba','25.00','72.00',52,'female','L2RaidBoss','raidboss',40,402319,107.600,3718,9.000,60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,2901,0,0,0,60,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45),
(2345,10497,25497,'Fafurion''s Envoy   ','Raid Fighter','marsh_stakato_soldier','10.00','25.00',51,'male','L2Monster','Fighter',40,8373,42.060,1859,9.000,40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,253,76,0,0,30,190,NULL,0,0,'stiff_fix_outofdate_from_916','1145636095',0,0,0,7,30,4,20,0,0,0.74),
(2346,10498,25498,'Fafurion''s Henchman Istary','Raid Boss','farhite_50_bi','24.00','48.00',45,'male','L2RaidBoss','raidboss',40,51869,90.360,3718,9.000,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,2901,5131,0,0,15,190,NULL,0,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.74),
(2347,10499,25499,'Alligator of Istary','Raid Fighter','crocodile','28.00','11.50',44,'male','L2Monster','Fighter',40,6649,35.160,1859,9.000,40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2348,10500,25500,'Alligator of Istary','Raid Fighter','crocodile','28.00','11.50',44,'male','L2Monster','Fighter',40,14518,35.160,1859,9.000,40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,70,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.41),
(2349,0,25501,'Boss Akata','Raid Boss','e_collector_teacher_Mdwarf_mon_130p','11.00','23.60',30,'male','L2RaidBoss','raidboss',40,127782,55.850,3718,9.000,60,57,73,76,70,80,636918,59660,96,1127,9,458,409,0,2901,0,0,0,35,190,'',0,0,'Local','',0,0,0,7,30,4,20,0,-18,0.39),
(2350,0,25502,'Akata''s Thug','Raid Fighter','e_traderB_Fdwarf_mon_120p','8.00','22.00',30,'male','L2Minion','Fighter',40,9093,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2351,0,25503,'Akata''s Lackey','Raid Fighter','e_collector_teacher_Fdwarf_mon_120p','9.00','21.40',30,'male','L2Minion','Fighter',40,6786,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2352,0,25504,'Nellis'' Vengeful Spirit','Raid Boss','a_mageguild_teacher_Mhuman_mon_120p','10.00','28.10',39,'male','L2RaidBoss','raidboss',40,206753,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2353,0,25505,'Nellis'' Follower','Raid Fighter','dwarf_ghost','10.00','18.70',38,'male','L2Minion','Fighter',40,20752,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2354,0,25506,'Rayito the Looter','Raid Boss','ol_mahum_champion_05te_120p','16.00','33.20',37,'male','L2RaidBoss','raidboss',40,184670,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2355,0,25507,'Rayito''s Henchman','Raid Fighter','ol_mahum_05te_110p','14.50','28.00',0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2356,0,25508,'Rayito''s Henchman','Raid Fighter','northern_goblin_110p','6.00','16.60',0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2357,0,25509,'Dark Shaman Varangka ','Raid Boss','batur_orc_shaman_a_01te_120p','13.00','20.80',53,'male','L2RaidBoss','raidboss',40,418874,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2358,0,25510,'Varangka''s Descendant','Raid Fighter','batur_orc_overlord_01te_110p','13.00','26.90',52,'male','L2Minion','Fighter',40,42733,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2359,0,25511,'Varangka''s Page','Raid Fighter','batur_orc_shaman_a_01te_110p','12.00','18.80',52,'male','L2Minion','Fighter',40,21366,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2360,0,25512,'Gigantic Chaos Golem','Raid Boss','chaos_golem','31.00','51.80',52,'male','L2RaidBoss','raidboss',40,804638,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2361,0,25514,'Queen Shyeed','Raid Boss','cannibal_stakato_leader_tran_120p','45.00','50.80',80,'male','L2RaidBoss','raidboss',40,714778,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2362,0,25515,'Spiked Stakato  ','Raid Fighter','spike_stakato_110p','13.00','21.00',79,'male','L2Minion','Fighter',40,50349,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2363,0,25516,'Spiked Stakato  ','Raid Fighter','spike_stakato_worker_110p','13.00','22.20',79,'male','L2Minion','Fighter',40,75148,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2364,0,25517,'Master Anays','Raid Boss','solina_priest_120p','16.00','41.80',87,'male','L2RaidBoss','raidboss',40,1069643,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2365,0,25518,'Splendor Disciple','Raid Fighter','apostle_grail','13.00','47.00',86,'male','L2Minion','Fighter',40,56245,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2366,0,25519,'Splendor Worshiper','Raid Fighter','apostle_grail_a','13.00','47.00',86,'male','L2Minion','Fighter',40,75369,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2367,0,25523,'Plague Golem','Raid Boss','stone_golem_bi','20.00','40.30',73,'male','L2RaidBoss','raidboss',40,1848045,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2368,0,25524,'Flamestone Giant','Raid Boss','lava_golem','22.00','45.00',76,'male','L2RaidBoss','raidboss',40,956490,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2369,0,25525,'Flame Spirit','Raid Fighter','mana_vampire','11.00','20.00',75,'male','L2Minion','Fighter',40,100472,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2370,0,25526,'Charged Spirit','Raid Fighter','magical_weaver','11.00','20.00',75,'male','L2Minion','Fighter',40,50236,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2371,0,25527,'Uruka','Raid Boss',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2372,12001,29001,'Queen Ant','','queen_ant','45.00','53.00',40,'female','L2Boss','raidboss',40,229898,208.000,667,2.100,60,57,73,76,70,80,2179536,140740,329,1615,77,655,278,0,1972,0,0,0,80,230,'queen_ant_clan',1000,0,'Local','',0,0,0,300,30,7,40,0,-18,0.37),
(2373,12002,29002,'Queen Ant Larva','','ant_larva','12.00','8.00',29,'male','L2Monster','Fighter',40,935,3.500,349,1.500,40,43,30,21,20,10,0,1,126,140,53,110,282,0,257,0,0,0,40,60,'queen_ant_clan',4500,0,'Local','',0,0,0,7,30,7,40,0,0,0.35),
(2374,12003,29003,'Nurse Ant','','ant','26.00','15.00',35,'male','L2Minion','Priest',40,6320,108.000,446,1.800,40,43,30,41,20,10,0,1,947,678,889,275,278,0,253,0,0,0,40,130,'queen_ant_clan',700,0,'Local','',0,0,0,7,30,7,40,0,0,0.26),
(2375,12004,29004,'Guard Ant','','ant','26.00','15.00',37,'male','L2Monster','Fighter',40,6861,115.000,480,1.800,40,43,30,41,20,10,0,1,269,728,62,295,278,500,253,0,0,0,40,230,'queen_ant_clan',700,0,'Local','',0,0,0,7,30,7,40,0,0,0.26),
(2376,12005,29005,'Royal Guard Ant','','ant','26.00','15.00',39,'male','L2Monster','Fighter',40,11140,122.000,514,1.800,40,43,30,41,20,10,0,1,1827,780,2576,316,278,0,253,0,0,0,40,230,'queen_ant_clan',700,0,'Local','',0,0,0,7,30,7,40,0,0,0.26),
(2377,12052,29006,'Core','','core','140.00','75.00',50,'male','L2Boss','raidboss',40,162561,273.000,575,1.500,60,57,73,76,70,80,2041407,153786,535,2226,500,904,278,0,1972,0,0,0,50,110,'curma_core_clan',2500,0,'Local','',0,0,0,10,30,7,40,0,-18,0.60),
(2378,12054,29007,'Death Knight','','death_knight','12.00','30.00',50,'male','L2Monster','Fighter',40,21830,166.000,830,2.100,40,43,30,41,20,10,0,1,683,1113,195,452,278,1050,253,75,0,0,27,110,'curma_core_clan',2300,1,'Local','',0,0,0,7,30,7,40,0,0,0.71),
(2379,12055,29008,'Death Wraith','','death_blader','15.00','45.00',55,'male','L2Monster','Fighter',40,25298,185.000,987,2.400,40,43,30,41,20,10,0,1,812,1288,2170,522,278,950,253,1472,0,0,100,230,'curma_core_clan',700,1,'Local','',0,0,0,7,30,7,40,0,0,0.45),
(2380,12056,29009,'Dicor','','mandragora_b','12.00','25.50',47,'female','L2Monster','Fighter',40,19819,154.000,738,2.100,40,43,30,41,20,10,0,1,577,1015,162,412,278,650,253,0,0,0,80,120,'curma_core_clan',800,0,'Local','',0,0,0,7,30,7,40,0,0,0.13),
(2381,12057,29010,'Validus','','grave','15.00','29.00',46,'male','L2Monster','Fighter',40,19165,150.000,707,2.100,40,43,30,41,20,10,0,1,545,984,154,400,278,750,253,0,0,0,70,110,'curma_core_clan',1200,0,'Local','',0,0,0,7,30,7,40,0,0,0.30),
(2382,12058,29011,'Susceptor','','susceptor','20.00','35.00',49,'male','L2Monster','Fighter',40,21154,162.000,799,2.100,40,43,30,41,20,10,0,1,647,1080,184,438,278,850,253,0,0,0,27,150,'curma_core_clan',1500,0,'Local','',0,0,0,7,30,7,40,0,0,0.43),
(2383,12059,29012,'Perum','','iron_golem','18.00','34.00',48,'male','L2Monster','Mystic',40,20483,158.000,768,2.100,40,43,30,41,20,10,0,1,611,1048,173,425,278,750,253,0,0,0,20,20,'curma_core_clan',800,0,'Local','',0,0,0,7,30,7,40,0,0,0.41),
(2384,12060,29013,'Premo','','troll','21.00','35.00',45,'male','L2Monster','Fighter',40,18519,146.000,677,2.100,40,43,30,41,20,10,0,1,514,952,144,386,278,0,253,0,0,0,55,110,'curma_core_clan',1200,0,'Local','',0,0,0,7,30,7,40,0,0,0.61),
(2385,12169,29014,'Orfen','','orfen','35.00','143.00',50,'female','L2Boss','raidboss',40,622493,273.000,1660,2.100,60,57,73,76,70,80,2041407,153786,553,2226,124,904,278,500,1972,0,0,0,60,230,'orfen_clan',3000,0,'Tigra','',0,0,0,300,30,7,40,0,-18,0.71),
(2386,12170,29015,'Raikel','','raikel','37.00','64.00',48,'male','L2Monster','Fighter',40,10241,158.000,768,2.100,40,43,30,41,20,10,0,1,489,1048,109,425,278,0,253,0,0,0,60,230,'orfen_clan',2500,0,'Local','',0,0,0,7,30,7,40,0,0,0.54),
(2387,12171,29016,'Raikel Leos','','raikel','37.00','64.00',49,'male','L2Monster','Fighter',40,10576,162.000,799,2.100,40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,253,0,0,0,60,230,'orfen_clan',2700,0,'Local','',0,0,0,7,30,15,40,0,0,0.54),
(2388,12172,29017,'Riba','','riba','25.00','72.00',48,'female','L2Monster','Fighter',40,10241,158.000,768,2.100,40,43,30,41,20,10,0,1,489,1048,109,425,278,0,253,0,0,0,60,230,'orfen_clan',2700,0,'Local','',0,0,0,7,30,7,40,0,0,0.45),
(2389,12173,29018,'Riba Iren','','riba','25.00','72.00',49,'female','L2Monster','Fighter',40,21154,162.000,799,2.100,40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,253,0,0,0,60,230,'orfen_clan',2900,0,'Local','',0,0,0,7,30,7,40,0,0,0.45),
(2390,12211,29019,'Antharas','','antaras','300.00','300.00',79,'male','L2Boss','Fighter',40,19635000,1000.000,22197,99.000,60,57,73,76,70,80,262721136,29116376,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,0,'Local','',0,0,0,14,30,4,40,0,-18,0.60),
(2391,12372,29020,'Baium','','baium','65.00','174.00',75,'male','L2Boss','Fighter',40,3698520,281.000,3347,3.000,60,57,73,76,70,80,10253419,1081544,6559,6282,4378,4601,333,1000,2362,0,0,0,80,120,'',0,0,'Local','',0,0,0,13,30,4,40,0,-25,0.60),
(2392,12373,29021,'Archangel','','archangel','15.00','80.00',74,'male','L2Monster','Fighter',40,295325,158.000,3274,3.000,60,57,73,76,70,80,6571,343,1564,8326,5772,6100,333,0,2362,93,0,0,50,170,'',0,0,'Local','',0,0,0,7,30,4,40,0,-25,0.76),
(2393,12374,29022,'Zaken','','zaken','16.00','32.00',60,'male','L2Boss','Fighter',40,858518,336.000,1975,2.400,60,57,73,76,70,80,4879728,423589,7273,2951,19762,1197,333,1000,2362,0,0,0,42,170,'',0,1,'Local','',0,0,0,300,30,4,40,0,-18,0.59),
(2394,12376,29023,'Doll Blader','','doll_blader','6.00','12.00',58,'male','L2Monster','Fighter',40,2888,6.500,1065,2.400,40,43,30,21,20,25,0,0,779,383,428,359,278,150,253,5129,0,0,22,150,'',0,0,'Local','',0,0,0,7,30,4,40,0,0,0.50),
(2395,12377,29024,'Vale master','','vale_master','12.00','40.00',59,'male','L2Monster','Fighter',40,2970,6.500,1102,2.400,40,43,30,21,20,25,0,0,818,395,452,369,278,150,253,0,0,0,70,155,'',0,0,'Local','',0,0,0,7,30,4,40,0,0,0.74),
(2396,12535,29025,'Baium','','baium_npc','65.00','82.00',75,'male','L2Folk','npc',40,3698520,8.500,3347,3.000,60,57,73,76,70,80,0,0,3483,523,9402,850,409,0,2901,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,-18,0.60),
(2397,12544,29026,'Pirate Zombie Captain','','pirates_zombie_captain','17.00','28.00',60,'male','L2Monster','Fighter',40,3054,6.500,1029,2.400,40,43,30,21,20,25,0,0,750,405,477,379,317,150,289,232,0,0,14,140,'',0,1,'Local','',0,0,0,7,10,8,40,0,0,0.76),
(2398,12545,29027,'Pirate Zombie','','pirates_zombie','10.00','23.00',57,'male','L2Monster','Mystic',40,2806,6.500,747,2.100,40,43,30,21,20,25,0,0,649,373,404,349,317,150,289,225,0,0,11,140,'',0,1,'Local','',0,0,0,7,10,8,40,0,0,0.74),
(2399,12899,29028,'Valakas','','valakas','190.00','335.00',85,'male','L2Boss','Fighter',40,16660000,1200.000,22197,99.000,60,57,73,76,70,80,284286410,27215401,14375,7999,36620,1999,333,0,2362,0,0,0,120,300,'valakas_clan',300,0,'Local','',0,0,0,21,30,4,40,0,-18,0.60),
(2400,12900,29029,'Lavasaurus Elder','Family of Valakas','golem','13.00','75.00',83,'male','L2Monster','Mystic',500,4868,50.000,1972,4.000,40,43,30,21,20,10,0,0,4354,628,1258,510,249,500,227,0,0,0,1,1,'valakas_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.48),
(2401,13122,29030,'Fenril Hound Kerinne','Family of Valakas','bandersnatch_20_bi','21.00','30.00',81,'male','L2Monster','Fighter',40,256613,176.000,3793,10.000,60,57,73,76,70,80,2407887,1226568,10699,4700,10558,1908,409,0,2901,0,0,0,30,200,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,-18,0.49),
(2402,13123,29031,'Kerinne''s Ifrit','','ifrit','10.00','42.00',80,'male','L2Monster','Mystic',40,33984,35.200,1859,4.000,40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,253,0,0,0,38,170,'fire_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(2403,13124,29032,'Kerinne''s Golem','','lava_golem','22.00','45.00',80,'male','L2Monster','Fighter',40,4697,50.000,1859,4.000,40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,253,0,0,0,13,60,'fire_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.47),
(2404,13125,29033,'Fenril Hound Freki','Family of Valakas','bandersnatch_20_bi','21.00','30.00',82,'male','L2Monster','Fighter',40,257118,175.500,3869,10.000,60,57,73,76,70,80,2434088,1257012,10997,4784,10896,1943,409,0,2901,0,0,0,30,200,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,-18,0.49),
(2405,13126,29034,'Freki''s Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(2406,13127,29035,'Freki''s Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,13,60,'fire_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.47),
(2407,13128,29036,'Fenril Hound Uruz','Family of Valakas','bandersnatch_20_bi','21.00','30.00',83,'male','L2Monster','Fighter',40,514943,349.000,3945,10.000,60,57,73,76,70,80,2466262,1289662,22594,4869,11233,1977,409,0,2901,0,0,0,30,200,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,-18,0.49),
(2408,13129,29037,'Fenril Hound Kinaz','Family of Valakas','bandersnatch_20_bi','21.00','30.00',84,'male','L2Monster','Fighter',40,257674,174.000,4022,10.000,60,57,73,76,70,80,2504880,1322688,11600,4952,11569,2011,409,0,2901,0,0,0,30,200,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,-18,0.49),
(2409,13130,29038,'Kinaz''s Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(2410,13131,29039,'Kinaz''s Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,38,170,'fire_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(2411,13132,29040,'Wings of Flame,Ixion','Gatekeeper of Valakas','inferno_drake_20_bi','29.00','42.00',85,'male','L2Monster','Fighter',40,515450,346.000,4099,10.000,60,57,73,76,70,80,2535975,1356048,23813,5036,11902,2045,409,0,2901,0,0,0,57,200,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,-18,0.48),
(2412,13133,29041,'Inferno Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,21134,2350,28532,954,278,0,253,0,0,0,13,60,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.47),
(2413,13134,29042,'Inferno Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,13,60,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.47),
(2414,13135,29043,'Howling Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,38,170,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2415,13136,29044,'Howling Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2416,0,29045,'Frintezza','','frintessa','45.00','42.70',90,'female','L2Boss','Fighter',40,753984,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2417,0,29046,'Scarlet van Halisha','','follower_of_frintessa','45.00','90.70',85,'male','L2Boss','Fighter',40,1666000,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2418,0,29047,'Scarlet van Halisha','','follower_of_frintessa_tran','92.00','112.80',90,'male','L2Boss','Fighter',40,2380000,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2419,0,29048,'Evil Spirit','','Evilate','40.00','100.00',87,'male','L2Monster','Fighter',40,98750,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2420,0,29049,'Evil Spirit','','Evilate','40.00','100.00',87,'male','L2Monster','Fighter',40,98750,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2421,0,29050,'Breath of Halisha','','portrait_spirit','23.00','40.00',85,'male','L2Monster','Fighter',40,15798,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2422,0,29051,'Breath of Halisha','','portrait_spirit_winged','23.00','40.00',85,'male','L2Monster','Fighter',40,15798,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2423,0,29052,' ','',NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2424,0,29053,' ','',NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2425,0,29054,'Benom','Triol''s Leader','benom','20.00','56.00',75,'male','L2Monster','Fighter',40,1352750,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2426,0,29055,'Teleportation Cubic','','teleport_npc','40.00','80.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2427,0,29056,'Ice Fairy Sirra','Raid Boss','ice_fairy','16.00','35.60',60,'male','L2RaidBoss','Fighter',40,188376,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2428,0,29057,'Sirra''s Page','Raid Fighter','sylph_110p','12.00','39.70',59,'male','L2Minion','Fighter',40,12199,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2429,0,29058,'Sirra''s Beholder','Raid Fighter','field_stalker_20_bi','18.00','36.00',59,'male','L2Minion','Fighter',40,6099,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2430,0,29059,'','',NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2431,0,29060,'Captain of the Ice Queen''s Royal Guard','Raid Boss','gargoyle_02te_120p','19.00','61.00',59,'male','L2RaidBoss','Fighter',40,157517,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2432,0,29061,'Teleportation Cubic','','teleport_npc_frin','40.00','80.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2433,0,29062,'High Priestess van Halter','Raid Boss','heretic_priest_110p','9.00','21.30',87,'male','L2RaidBoss','Fighter',40,257369,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2434,0,29063,'Andreas'' Acolyte','Raid Fighter','heretic_privates','7.70','28.40',0,'male','L2Minion','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2435,0,29064,'Andreas'' Acolyte','Raid Fighter','heretic_privates_a','7.70','28.40',0,'male','L2Minion','Fighter',40,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2436,0,29065,'Sailren','Sealed Evil Power',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2437,0,29066,'Antharas','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2438,0,29067,'Antharas','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2439,0,29068,'Antharas','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2440,0,29069,'Behemoth Dragon','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2441,0,29070,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2442,0,29071,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2443,0,29072,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2444,0,29073,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2445,0,29074,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2446,0,29075,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2447,0,29076,'Dragon Bomber','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2448,0,29077,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2449,0,29078,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(2450,0,29079,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2451,0,29080,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2452,0,29081,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2453,0,29082,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2454,0,29083,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2455,0,29084,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2456,0,29085,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2457,0,29086,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2458,0,29087,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2459,0,29088,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2460,0,29089,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2461,0,29090,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2462,0,29091,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2463,0,29092,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2464,0,29093,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2465,0,29094,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2466,0,29095,'Gordon','Knight of Destruction',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2467,0,29096,'Lord of Splendor Anays','Raid Boss',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2468,0,29097,'Splendor Disciple','Raid Fighter',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2469,0,29098,'Splendor Worshiper','Raid Fighter',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(2470,0,18001,'Blood Queen','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4536,394,860,368,478,299,278,500,253,0,0,0,80,160,'cave_servant_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2471,12079,18002,'Blood Queen','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4536,394,860,368,478,299,278,500,253,0,0,0,80,160,'cave_servant_clan',400,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2472,12082,18003,'Bearded Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,4,39,3,32,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,8,0,0,0,0.37),
(2473,12174,18004,'Susceptor Prime','','susceptor_prime','45.00','72.00',49,'male','L2Monster','Fighter',50,2168,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,0,'Local','',0,0,0,7,30,4,20,0,0,0.52),
(2474,12410,18005,'Mimic','','mimic','8.50','8.50',52,'male','L2Monster','Fighter',40,2479,6.500,892,2.400,40,43,30,21,20,10,3244,251,588,304,300,239,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(2475,12614,18006,'Maruk Lord','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3825,7.500,1423,2.700,40,43,30,21,20,10,6057,586,1256,464,713,365,278,500,253,1472,0,0,100,170,'malruk_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(2476,12615,18007,'Limal Karinness','','bloody_queen','14.00','40.00',69,'female','L2Monster','Mystic',40,3784,7.500,1458,2.700,40,43,30,21,20,10,5951,582,1392,460,821,373,278,500,253,0,0,0,80,140,'malruk_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2477,12616,18008,'Karik','','karik','25.00','90.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,6370,632,1445,470,858,382,278,500,253,0,0,0,37,200,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(2478,12622,18009,'Offering of Branded Elder','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1754,102,178,163,82,132,278,1000,253,127,0,0,45,30,'mercenary_siege_clan',500,0,'Local','',0,0,0,3,30,4,4,0,0,0.46),
(2479,12623,18010,'Offering of the Branded','','orc','10.00','21.00',32,'male','L2FestivalMonster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1523,86,134,129,69,123,237,1000,216,218,0,0,45,30,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.48),
(2480,12624,18011,'Offering of Branded Archer','','orc_archer','14.00','25.00',28,'male','L2FestivalMonster','Ranger',500,859,3.500,334,1.500,40,43,30,21,20,10,1001,53,251,110,49,106,249,1000,227,14,0,0,45,60,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.80),
(2481,12625,18012,'Offering of Branded Warrior','','orc_champion','10.00','23.00',29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1026,55,122,135,53,110,278,1000,253,125,0,0,45,110,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.76),
(2482,12626,18013,'Offering of Branded Follower','','orc_fighter','12.00','22.00',29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1227,66,107,115,53,110,237,1000,216,316,0,0,45,150,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.26),
(2483,12627,18014,'Offering of Branded Berserker','','orc_champion_20_bi','12.00','27.60',37,'male','L2FestivalMonster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2276,140,222,182,104,147,278,1000,253,292,0,0,43,115,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.48),
(2484,12628,18015,'Offering of Branded Zealot','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,156,138,82,132,237,1000,216,158,0,0,45,155,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2485,12629,18016,'Offering of Branded Marksman','','orc_archer_20_bi','16.00','30.00',32,'male','L2FestivalMonster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,342,129,69,123,249,1000,227,273,0,0,45,130,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.80),
(2486,12630,18017,'Offering of Branded Disciple','','batur_orc','9.00','21.50',34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,178,163,82,132,278,1000,253,129,0,0,80,165,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.46),
(2487,12631,18018,'Offering of Branded Saint','','batur_orc_20_bi','10.00','25.30',39,'male','L2FestivalMonster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2171,138,255,195,121,158,278,1000,253,72,0,0,80,165,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.46),
(2488,12632,18019,'Apostate''s Offering Elder','','orc_champion_20_bi','12.00','27.60',45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3013,210,377,238,188,193,278,1000,253,72,0,0,45,30,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.76),
(2489,12633,18020,'Apostate''s Offering ','','orc_fighter','12.00','22.00',43,'male','L2FestivalMonster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2751,186,291,189,163,181,237,1000,216,223,0,0,45,30,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2490,12634,18021,'Apostate''s Offering Archer','','batur_orc_archer','11.00','21.50',39,'male','L2FestivalMonster','Ranger',500,1462,4.500,514,1.800,40,43,30,21,20,10,1879,119,566,165,121,158,249,1000,227,275,0,0,45,60,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2491,12635,18022,'Apostate''s Offering Warrior','','batur_orc_warrior','10.00','20.00',40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1920,124,273,201,131,164,278,1000,253,127,0,0,80,115,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30),
(2492,12636,18023,'Apostate''s Offering Follower','','batur_orc','9.00','21.50',40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2296,148,238,171,131,164,237,1000,216,316,0,0,50,155,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30),
(2493,12637,18024,'Apostate''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',48,'male','L2FestivalMonster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3832,280,453,261,231,212,278,1000,253,297,0,0,37,120,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2494,12638,18025,'Apostate''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,330,202,188,193,237,1000,216,172,0,0,80,160,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2495,12639,18026,'Apostate''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',43,'male','L2FestivalMonster','Ranger',500,1728,5.500,618,2.100,40,43,30,21,20,10,2285,154,739,189,163,181,249,1000,227,277,0,0,45,135,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2496,12640,18027,'Apostate''s Offering Disciple','','batur_orc_overlord','12.00','24.00',45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,377,238,188,193,278,1000,253,74,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2497,12641,18028,'Apostate''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',50,'male','L2FestivalMonster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3570,269,509,278,264,226,278,1000,253,133,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2498,12642,18029,'Witch''s Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4666,383,706,331,382,269,278,1000,253,133,0,0,80,30,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30),
(2499,12643,18030,'Witch''s Offering','','batur_orc','9.00','21.50',54,'male','L2FestivalMonster','Mystic',40,2562,6.500,955,2.400,40,43,30,21,20,10,4339,346,556,266,339,254,237,1000,216,226,0,0,80,30,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2500,12644,18031,'Witch''s Offering Archer','','batur_orc_archer','11.00','21.50',50,'male','L2FestivalMonster','Mystic',500,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,1132,236,264,226,249,1000,227,278,0,0,45,70,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2501,12645,18032,'Witch''s Offering Warrior','','batur_orc_warrior','10.00','20.00',51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3121,238,539,286,281,232,278,1000,253,72,0,0,80,120,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30),
(2502,12646,18033,'Witch''s Offering Follower','','batur_orc','9.00','21.50',51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3732,285,472,243,281,232,237,1000,216,316,0,0,50,160,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30),
(2503,12647,18034,'Witch''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',59,'male','L2FestivalMonster','Mystic',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5789,495,820,359,453,291,278,1000,253,301,0,0,52,125,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.59),
(2504,12648,18035,'Witch''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,618,281,382,269,237,1000,216,91,0,0,80,165,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2505,12649,18036,'Witch''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',54,'male','L2FestivalMonster','Mystic',500,2562,6.500,955,2.400,40,43,30,21,20,10,3604,287,1413,266,339,254,249,1000,227,282,0,0,45,140,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2506,12650,18037,'Witch''s Offering Disciple','','batur_orc_overlord','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,706,331,382,269,278,1000,253,135,0,0,80,175,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2507,12651,18038,'Witch''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',61,'male','L2FestivalMonster','Mystic',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5313,468,901,378,505,307,278,1000,253,79,0,0,80,175,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2508,12652,18039,'Dark Omen Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6679,636,1169,439,681,356,278,1000,253,79,0,0,80,30,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.30),
(2509,12653,18040,'Dark Omen Offering','','batur_orc','9.00','21.50',65,'male','L2FestivalMonster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6286,584,942,355,619,340,237,1000,216,234,0,0,80,30,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2510,12654,18041,'Dark Omen Offering Archer','','batur_orc_archer','11.00','21.50',61,'male','L2FestivalMonster','Ranger',500,3137,7.500,1184,2.700,40,43,30,21,20,10,4599,405,2004,321,505,307,249,1000,227,283,0,0,45,70,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.96),
(2511,12655,18042,'Dark Omen Offering Warrior','','batur_orc_warrior','10.00','20.00',62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,4612,411,944,388,532,315,278,1000,253,133,0,0,80,125,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.30),
(2512,12656,18043,'Dark Omen Offering Follower','','batur_orc','9.00','21.50',62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,5516,492,826,330,532,315,237,1000,216,316,0,0,50,165,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.30),
(2513,12657,18044,'Dark Omen Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',70,'male','L2FestivalMonster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8149,808,1314,470,780,382,278,1000,253,97,0,0,52,130,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.59),
(2514,12658,18045,'Dark Omen Offering Zealot','','batur_orc_20_bi','10.00','25.30',67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1023,373,681,356,237,1000,216,2503,0,0,80,170,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2515,12659,18046,'Dark Omen Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',65,'male','L2FestivalMonster','Ranger',500,3465,7.500,1319,2.700,40,43,30,21,20,10,5222,485,2393,355,619,340,249,1000,227,286,0,0,45,145,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.96),
(2516,12660,18047,'Dark Omen Offering Disciple','','batur_orc_overlord','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1169,439,681,356,278,1000,253,142,0,0,80,180,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.28),
(2517,12661,18048,'Dark Omen Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',72,'male','L2FestivalMonster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,7402,752,1413,491,849,399,278,1000,253,2500,0,0,80,180,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.28),
(2518,12662,18049,'Offering of Forbidden Path Elder','','batur_orc_overlord_20_bi','14.00','28.80',78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,9052,991,1715,555,1069,451,278,1000,253,2500,0,0,80,30,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.28),
(2519,12663,18050,'Offering of Forbidden Path','','batur_orc_warrior','10.00','20.00',76,'male','L2FestivalMonster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,8594,919,1412,454,994,433,237,1000,216,236,0,0,80,30,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.30),
(2520,12664,18051,'Offering of Forbidden Path Archer','','ketra_orc_archer','12.00','27.00',82,'male','L2FestivalMonster','Ranger',500,4663,8.500,1934,3.000,40,43,30,21,20,10,8310,955,4248,508,1220,485,249,1000,227,287,0,0,45,70,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.91),
(2521,12665,18052,'Offering of Forbidden Path Warrior','','ketra_orc_warrior','12.00','24.00',80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,7680,862,1814,576,1144,468,278,1000,253,79,0,0,36,130,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.54),
(2522,12666,18053,'Offering of Forbidden Path Follower','','ketra_orc','12.00','29.00',80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,1000,216,316,0,0,10,180,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.34),
(2523,12667,18054,'Offering of Forbidden Path Berserker','','ketra_orc_warrior_20_bi','14.00','28.80',81,'male','L2FestivalMonster','Fighter',40,4608,8.500,1896,3.000,40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,1000,253,305,0,0,40,135,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.56),
(2524,12668,18055,'Offering of Forbidden Path Zealot','','ketra_orc_20_bi','14.00','34.80',78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1500,472,1069,451,237,1000,216,175,0,0,45,195,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2525,12669,18056,'Offering of Forbidden Path Marksman','','ketra_orc_archer_20_bi','14.00','32.40',76,'male','L2FestivalMonster','Ranger',500,4297,8.500,1710,3.000,40,43,30,21,20,10,7139,763,3587,454,994,433,249,1000,227,289,0,0,45,150,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.91),
(2526,12670,18057,'Offering of Forbidden Path Disciple','','ketra_orc_overload','12.00','24.00',78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1715,555,1069,451,278,1000,253,151,0,0,33,195,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.48),
(2527,12671,18058,'Offering of Forbidden Path Saint','','ketra_orc_overload_20_bi','14.00','28.80',83,'male','L2FestivalMonster','Fighter',40,4716,8.500,1972,3.000,40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,1000,253,2500,0,0,33,195,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.48),
(2528,12672,18059,'Offering of Branded Elder','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1720,100,178,163,82,132,278,1000,253,127,0,0,45,30,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.46),
(2529,12673,18060,'Offering of the Branded','','orc','10.00','21.00',32,'male','L2FestivalMonster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1523,86,134,129,69,123,237,1000,216,218,0,0,45,30,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.48),
(2530,12674,18061,'Offering of Branded Archer','','orc_archer','14.00','25.00',28,'male','L2FestivalMonster','Ranger',500,859,3.500,334,1.500,40,43,30,21,20,10,1001,53,251,110,49,106,249,1000,227,14,0,0,45,60,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.80),
(2531,12675,18062,'Offering of Branded Warrior','','orc_champion','10.00','23.00',29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1026,55,122,135,53,110,278,1000,253,125,0,0,45,110,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.76),
(2532,12676,18063,'Offering of Branded Follower','','orc_fighter','12.00','22.00',29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1227,66,107,115,53,110,237,1000,216,316,0,0,45,150,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.26),
(2533,12677,18064,'Offering of Branded Berserker','','orc_champion_20_bi','12.00','27.60',37,'male','L2FestivalMonster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2276,140,222,182,104,147,278,1000,253,292,0,0,43,115,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.48),
(2534,12678,18065,'Offering of Branded Zealot','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,156,138,82,132,237,1000,216,158,0,0,45,155,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2535,12679,18066,'Offering of Branded Marksman','','orc_archer_20_bi','16.00','30.00',32,'male','L2FestivalMonster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,342,129,69,123,249,1000,227,273,0,0,45,130,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.80),
(2536,12680,18067,'Offering of Branded Disciple','','batur_orc','9.00','21.50',34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,178,163,82,132,278,1000,253,129,0,0,80,165,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.46),
(2537,12681,18068,'Offering of Branded Saint','','batur_orc_20_bi','10.00','25.30',39,'male','L2FestivalMonster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2171,138,255,195,121,158,278,1000,253,72,0,0,80,165,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.46),
(2538,12682,18069,'Apostate''s Offering Elder','','orc_champion_20_bi','12.00','27.60',45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3013,210,377,238,188,193,278,1000,253,72,0,0,45,30,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.76),
(2539,12683,18070,'Apostate''s Offering ','','orc_fighter','12.00','22.00',43,'male','L2FestivalMonster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2751,186,291,189,163,181,237,1000,216,223,0,0,45,30,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2540,12684,18071,'Apostate''s Offering Archer','','batur_orc_archer','11.00','21.50',39,'male','L2FestivalMonster','Ranger',500,1462,4.500,514,1.800,40,43,30,21,20,10,1879,119,566,165,121,158,249,1000,227,275,0,0,45,60,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2541,12685,18072,'Apostate''s Offering Warrior','','batur_orc_warrior','10.00','20.00',40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1920,124,273,201,131,164,278,1000,253,127,0,0,80,115,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30),
(2542,12686,18073,'Apostate''s Offering Follower','','batur_orc','9.00','21.50',40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2296,148,238,171,131,164,237,1000,216,316,0,0,50,155,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30),
(2543,12687,18074,'Apostate''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',48,'male','L2FestivalMonster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3832,280,453,261,231,212,278,1000,253,297,0,0,37,120,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2544,12688,18075,'Apostate''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,330,202,188,193,237,1000,216,172,0,0,80,160,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2545,12689,18076,'Apostate''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',43,'male','L2FestivalMonster','Ranger',500,1728,5.500,618,2.100,40,43,30,21,20,10,2285,154,739,189,163,181,249,1000,227,277,0,0,45,135,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2546,12690,18077,'Apostate''s Offering Disciple','','batur_orc_overlord','12.00','24.00',45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,377,238,188,193,278,1000,253,74,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2547,12691,18078,'Apostate''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',50,'male','L2FestivalMonster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3570,269,509,278,264,226,278,1000,253,133,0,0,80,170,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2548,12692,18079,'Witch''s Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4666,383,706,331,382,269,278,1000,253,133,0,0,80,30,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30),
(2549,12693,18080,'Witch''s Offering','','batur_orc','9.00','21.50',54,'male','L2FestivalMonster','Mystic',40,2562,6.500,955,2.400,40,43,30,21,20,10,4339,346,556,266,339,254,237,1000,216,226,0,0,80,30,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2550,12694,18081,'Witch''s Offering Archer','','batur_orc_archer','11.00','21.50',50,'male','L2FestivalMonster','Mystic',500,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,1132,236,264,226,249,1000,227,278,0,0,45,70,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2551,12695,18082,'Witch''s Offering Warrior','','batur_orc_warrior','10.00','20.00',51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3121,238,539,286,281,232,278,1000,253,72,0,0,80,120,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30),
(2552,12696,18083,'Witch''s Offering Follower','','batur_orc','9.00','21.50',51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3732,285,472,243,281,232,237,1000,216,316,0,0,50,160,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30),
(2553,12697,18084,'Witch''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',59,'male','L2FestivalMonster','Mystic',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5789,495,820,359,453,291,278,1000,253,301,0,0,52,125,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.59),
(2554,12698,18085,'Witch''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,618,281,382,269,237,1000,216,91,0,0,80,165,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46),
(2555,12699,18086,'Witch''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',54,'male','L2FestivalMonster','Mystic',500,2562,6.500,955,2.400,40,43,30,21,20,10,3604,287,1413,266,339,254,249,1000,227,282,0,0,45,140,NULL,0,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96),
(2556,12700,18087,'Witch''s Offering Disciple','','batur_orc_overlord','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,706,331,382,269,278,1000,253,135,0,0,80,175,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2557,12701,18088,'Witch''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',61,'male','L2FestivalMonster','Mystic',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5313,468,901,378,505,307,278,1000,253,79,0,0,80,175,NULL,0,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28),
(2558,12702,18089,'Dark Omen Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6679,636,1169,439,681,356,278,1000,253,79,0,0,80,30,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.30),
(2559,12703,18090,'Dark Omen Offering','','batur_orc','9.00','21.50',65,'male','L2FestivalMonster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6286,584,942,355,619,340,237,1000,216,234,0,0,80,30,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2560,12704,18091,'Dark Omen Offering Archer','','batur_orc_archer','11.00','21.50',61,'male','L2FestivalMonster','Ranger',500,3137,7.500,1184,2.700,40,43,30,21,20,10,4599,405,2004,321,505,307,249,1000,227,283,0,0,45,70,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.96),
(2561,12705,18092,'Dark Omen Offering Warrior','','batur_orc_warrior','10.00','20.00',62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,4612,411,944,388,532,315,278,1000,253,133,0,0,80,125,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.30),
(2562,12706,18093,'Dark Omen Offering Follower','','batur_orc','9.00','21.50',62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,5516,492,826,330,532,315,237,1000,216,316,0,0,50,165,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.30),
(2563,12707,18094,'Dark Omen Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',70,'male','L2FestivalMonster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8149,808,1314,470,780,382,278,1000,253,97,0,0,52,130,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.59),
(2564,12708,18095,'Dark Omen Offering Zealot','','batur_orc_20_bi','10.00','25.30',67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1023,373,681,356,237,1000,216,2503,0,0,80,170,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2565,12709,18096,'Dark Omen Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',65,'male','L2FestivalMonster','Ranger',500,3465,7.500,1319,2.700,40,43,30,21,20,10,5222,485,2393,355,619,340,249,1000,227,286,0,0,45,145,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.96),
(2566,12710,18097,'Dark Omen Offering Disciple','','batur_orc_overlord','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1169,439,681,356,278,1000,253,142,0,0,80,180,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.28),
(2567,12711,18098,'Dark Omen Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',72,'male','L2FestivalMonster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,7402,752,1413,491,849,399,278,1000,253,2500,0,0,80,180,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.28),
(2568,12712,18099,'Offering of Forbidden Path Elder','','batur_orc_overlord_20_bi','14.00','28.80',78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,9052,991,1715,555,1069,451,278,1000,253,2500,0,0,80,30,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.28),
(2569,12713,18100,'Offering of Forbidden Path','','batur_orc_warrior','10.00','20.00',76,'male','L2FestivalMonster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,8594,919,1412,454,994,433,237,1000,216,236,0,0,80,30,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.30),
(2570,12714,18101,'Offering of Forbidden Path Archer','','ketra_orc_archer','12.00','27.00',82,'male','L2FestivalMonster','Ranger',500,4663,8.500,1934,3.000,40,43,30,21,20,10,8310,955,4248,508,1220,485,249,1000,227,287,0,0,45,70,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.91),
(2571,12715,18102,'Offering of Forbidden Path Warrior','','ketra_orc_warrior','12.00','24.00',80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,7680,862,1814,576,1144,468,278,1000,253,79,0,0,36,130,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.54),
(2572,12716,18103,'Offering of Forbidden Path Follower','','ketra_orc','12.00','29.00',80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,1000,216,316,0,0,10,180,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.34),
(2573,12717,18104,'Offering of Forbidden Path Berserker','','ketra_orc_warrior_20_bi','14.00','28.80',81,'male','L2FestivalMonster','Fighter',40,4608,8.500,1896,3.000,40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,1000,253,305,0,0,40,135,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.56),
(2574,12718,18105,'Offering of Forbidden Path Zealot','','ketra_orc_20_bi','14.00','34.80',78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1500,472,1069,451,237,1000,216,175,0,0,45,195,'',0,0,'Local','',0,0,0,3,10,8,0,0,10,0.46),
(2575,12719,18106,'Offering of Forbidden Path Marksman','','ketra_orc_archer_20_bi','14.00','32.40',76,'male','L2FestivalMonster','Ranger',500,4297,8.500,1710,3.000,40,43,30,21,20,10,7139,763,3587,454,994,433,249,1000,227,289,0,0,45,150,'',0,0,'Local','',0,0,0,3,10,8,0,1500,10,0.91),
(2576,12720,18107,'Offering of Forbidden Path Disciple','','ketra_orc_overload','12.00','24.00',78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1715,555,1069,451,278,1000,253,151,0,0,33,195,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.48),
(2577,12721,18108,'Offering of Forbidden Path Saint','','ketra_orc_overload_20_bi','14.00','28.80',83,'male','L2FestivalMonster','Fighter',40,4716,8.500,1972,3.000,40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,1000,253,2500,0,0,33,195,'',0,0,'Local','',0,0,0,3,30,4,4,0,0,0.48),
(2578,12764,18109,'Treasures of the Festival','','coffer_a','12.00','9.50',30,'male','L2FestivalMonster','Fighter',0,999,3.500,365,1.500,40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2579,12765,18110,'Treasures of the Festival','','coffer_a','12.00','9.50',41,'male','L2FestivalMonster','Fighter',0,1488,5.500,560,2.100,40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2580,12766,18111,'Treasures of the Festival','','coffer_a','12.00','9.50',52,'male','L2FestivalMonster','Fighter',0,2058,6.500,892,2.400,40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2581,12767,18112,'Treasures of the Festival','','coffer_a','12.00','9.50',63,'male','L2FestivalMonster','Fighter',0,2640,7.500,1251,2.700,40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2582,12768,18113,'Treasures of the Festival','','coffer_a','12.00','9.50',72,'male','L2FestivalMonster','Fighter',0,3063,8.500,1565,3.000,40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2583,12769,18114,'Treasures of the Festival','','coffer_a','12.00','9.50',30,'male','L2FestivalMonster','Fighter',0,999,3.500,365,1.500,40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2584,12770,18115,'Treasures of the Festival','','coffer_a','12.00','9.50',41,'male','L2FestivalMonster','Fighter',0,1488,5.500,560,2.100,40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2585,12771,18116,'Treasures of the Festival','','coffer_a','12.00','9.50',52,'male','L2FestivalMonster','Fighter',0,2058,6.500,892,2.400,40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2586,12772,18117,'Treasures of the Festival','','coffer_a','12.00','9.50',63,'male','L2FestivalMonster','Fighter',0,2640,7.500,1251,2.700,40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2587,12773,18118,'Treasures of the Festival','','coffer_a','12.00','9.50',72,'male','L2FestivalMonster','Fighter',0,3063,8.500,1565,3.000,40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,80,195,'',0,0,'Local','',0,0,0,7,0,0,0,0,0,0.56),
(2588,12789,18119,'Corpse of Deadman','','zombie_corpse','13.00','21.00',63,'male','L2DeadMan','Mystic',40,3302,7.500,1251,2.700,40,43,30,21,20,10,0,0,987,398,560,323,278,0,253,0,0,0,15,0,'',0,1,'Local','',0,0,0,240,30,4,4,0,0,0.43),
(2589,12955,18120,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2590,12956,18121,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2591,12957,18122,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2592,12958,18123,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2593,12959,18124,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2594,12960,18125,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2595,12961,18126,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2596,12962,18127,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2597,12963,18128,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2598,12964,18129,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2599,12965,18130,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2600,12966,18131,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,1,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48),
(2601,12967,18132,'Imperial Healer','','tera_beetle','19.00','54.50',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9949,1129,1540,782,807,635,278,0,253,0,0,0,45,170,'tomb1_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(2602,12968,18133,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(2603,12969,18134,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(2604,12970,18135,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9149,1039,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(2605,12971,18136,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,1482,710,977,577,237,0,216,0,0,0,37,170,'tomb1_clan',600,0,'Local','',0,0,0,7,10,8,0,0,0,0.54),
(2606,12972,18137,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(2607,12973,18138,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9069,1029,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2608,12974,18139,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,8935,1014,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2609,12975,18140,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9065,1029,1694,710,977,577,278,0,253,0,0,0,45,180,'tomb1_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2610,12976,18141,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2611,12977,18142,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2612,12978,18143,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2613,12979,18144,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2614,12980,18145,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7399,840,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2615,12981,18146,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7568,859,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2616,12982,18147,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7046,800,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2617,12983,18148,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8203,931,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2618,12984,18149,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7247,823,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(2619,12985,18150,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2620,12986,18151,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2621,12987,18152,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2622,12988,18153,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2623,12989,18154,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2624,12990,18155,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2625,12991,18156,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2626,12992,18157,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Folk','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2627,12993,18158,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2628,12994,18159,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2629,12995,18160,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2630,12996,18161,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2631,12997,18162,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2632,12998,18163,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2633,12999,18164,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2634,13000,18165,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2635,13001,18166,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7005,795,2255,534,1731,433,278,0,253,142,0,0,27,110,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(2636,13002,18167,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,1694,710,977,577,278,0,253,142,0,0,27,110,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(2637,13003,18168,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7099,806,1863,587,1182,477,278,0,253,142,0,0,27,110,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(2638,13004,18169,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6872,780,1694,710,977,577,278,0,253,142,0,0,27,110,'tomb3_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(2639,13005,18170,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6879,781,2170,485,2095,394,237,0,216,0,0,0,80,160,'tomb3_clan',600,1,'Local','',0,0,0,7,10,8,0,0,0,0.56),
(2640,13006,18171,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7147,811,1347,782,807,635,237,0,216,0,0,0,80,160,'tomb3_clan',600,1,'Local','',0,0,0,7,10,8,0,0,0,0.56),
(2641,13007,18172,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,1630,587,1182,477,237,0,216,0,0,0,80,160,'tomb3_clan',600,1,'Local','',0,0,0,7,10,8,0,0,0,0.56),
(2642,13008,18173,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2643,13009,18174,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2644,13010,18175,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2645,13011,18176,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2646,13012,18177,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2647,13013,18178,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2648,13014,18179,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2649,13015,18180,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2650,13016,18181,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2651,13017,18182,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2652,13018,18183,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2653,13019,18184,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45),
(2654,13020,18185,'Evil Astrologer','','doll_blader','6.00','12.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9413,1069,1694,710,977,577,278,0,253,5129,5129,0,22,150,'tomb4_clan',600,0,'Local','',0,0,184,7,30,4,4,0,0,0.50),
(2655,13021,18186,'Evil Astrologer','','doll_blader','6.00','12.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9467,1075,1694,710,977,577,278,0,253,5129,5129,0,22,150,'tomb4_clan',600,0,'Local','',0,0,184,7,30,4,4,0,0,0.50),
(2656,13022,18187,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2657,13023,18188,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2658,13024,18189,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9149,1039,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2659,13025,18190,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2660,13026,18191,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2661,13027,18192,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9069,1029,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2662,13028,18193,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,8935,1014,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2663,13029,18194,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9065,1029,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2664,13030,18195,'Signet of Emperor','','ant_larva','12.00','8.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6946,788,3001,401,3068,325,278,0,253,0,0,0,40,60,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2665,13031,18196,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2666,13032,18197,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2667,13033,18198,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2668,13034,18199,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2669,13035,18200,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2670,13036,18201,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2671,13037,18202,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2672,13038,18203,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2673,13039,18204,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2674,13040,18205,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2675,13041,18206,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2676,13042,18207,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2677,13043,18208,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2678,13044,18209,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2679,13045,18210,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2680,13046,18211,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2681,13047,18212,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2682,13048,18213,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2683,13049,18214,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2684,13050,18215,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2685,13051,18216,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2686,13052,18217,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2687,13053,18218,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2688,13054,18219,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2689,13055,18220,'Shaman of Darkness','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9467,1075,2050,587,1431,477,278,0,253,3939,0,0,80,160,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2690,13056,18221,'Shaman of Darkness','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9721,1103,2050,587,1431,477,278,0,253,3939,0,0,80,160,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2691,13057,18222,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9210,1045,2480,485,2095,394,278,0,253,0,0,0,41,190,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2692,13058,18223,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,1863,587,1182,477,278,0,253,0,0,0,41,190,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2693,13059,18224,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9303,1056,2480,485,2095,394,278,0,253,0,0,0,41,190,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2694,13060,18225,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9210,1045,1863,587,1182,477,278,0,253,0,0,0,41,190,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2695,13061,18226,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,2480,485,2095,394,278,0,253,0,0,0,70,155,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(2696,13062,18227,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11706,1329,1863,587,1182,477,278,0,253,0,0,0,70,155,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(2697,13063,18228,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,8801,999,2480,485,2095,394,278,0,253,0,0,0,70,155,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(2698,13064,18229,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9065,1029,1863,587,1182,477,278,0,253,0,0,0,70,155,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(2699,13065,18230,'Signet of Emperor','','ant_larva','12.00','8.00',81,'male','L2Monster','Fighter',40,4608,25.500,1896,3.000,40,43,30,21,20,10,7495,851,3001,401,3068,325,278,0,253,0,0,0,40,60,'tomb5_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2700,13066,18231,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2701,13067,18232,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2702,13068,18233,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2703,13069,18234,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2704,13070,18235,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2705,13071,18236,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2706,13072,18237,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2707,13073,18238,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2708,13074,18239,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2709,13075,18240,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2710,13076,18241,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2711,13077,18242,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2712,13078,18243,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2713,13079,18244,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb1_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2714,13080,18245,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb1_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2715,13081,18246,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb1_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2716,13082,18247,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb2_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2717,13083,18248,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb2_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2718,13084,18249,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb2_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2719,13085,18250,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2720,13086,18251,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2721,13087,18252,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb3_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2722,13088,18253,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2723,13089,18254,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2724,13090,18255,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb4_clan',600,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2725,13091,18256,'Halisha''s Treasure Box','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,1,0.000,1,0.000,40,43,30,21,20,10,0,0,2,1,1,1,1,0,1,0,0,0,80,1,NULL,0,0,'Local',NULL,0,0,0,7,0,0,0,0,0,0.56),
(2726,0,18257,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2727,0,18258,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2728,0,18259,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2729,0,18260,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2730,0,18261,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2731,0,18262,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2732,0,18263,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2733,0,18264,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2734,0,18265,'Treasure Chest','','mimic','8.50','8.50',21,'male','L2Monster','Fighter',40,594,1.500,227,1.500,40,43,30,21,20,10,0,0,63,101,25,82,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2735,0,18266,'Treasure Chest','','mimic','8.50','8.50',24,'male','L2Monster','Fighter',40,710,1.500,272,1.500,40,43,30,21,20,10,0,0,81,115,34,93,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2736,0,18267,'Treasure Chest','','mimic','8.50','8.50',27,'male','L2Monster','Fighter',40,840,1.500,318,1.500,40,43,30,21,20,10,0,0,104,129,45,105,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2737,0,18268,'Treasure Chest','','mimic','8.50','8.50',30,'male','L2Monster','Fighter',40,985,1.500,365,1.500,40,43,30,21,20,10,0,0,132,145,58,118,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2738,0,18269,'Treasure Chest','','mimic','8.50','8.50',33,'male','L2Monster','Fighter',40,1145,1.800,413,1.800,40,43,30,21,20,10,0,0,166,162,75,132,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2739,0,18270,'Treasure Chest','','mimic','8.50','8.50',36,'male','L2Monster','Fighter',40,1320,1.800,463,1.800,40,43,30,21,20,10,0,0,206,181,96,147,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2740,0,18271,'Treasure Chest','','mimic','8.50','8.50',39,'male','L2Monster','Fighter',40,1510,1.800,514,1.800,40,43,30,21,20,10,0,0,255,201,121,163,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2741,0,18272,'Treasure Chest','','mimic','8.50','8.50',42,'male','L2Monster','Fighter',40,1713,2.100,589,2.100,40,43,30,21,20,10,0,0,311,222,152,181,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2742,0,18273,'Treasure Chest','','mimic','8.50','8.50',45,'male','L2Monster','Fighter',40,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,377,245,188,199,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2743,0,18274,'Treasure Chest','','mimic','8.50','8.50',48,'male','L2Monster','Fighter',40,2159,2.100,768,2.100,40,43,30,21,20,10,0,0,453,270,231,219,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2744,0,18275,'Treasure Chest','','mimic','8.50','8.50',51,'male','L2Monster','Fighter',40,2398,2.400,861,2.400,40,43,30,21,20,10,0,0,539,296,281,240,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2745,0,18276,'Treasure Chest','','mimic','8.50','8.50',54,'male','L2Monster','Fighter',40,2645,2.400,955,2.400,40,43,30,21,20,10,0,0,636,323,339,262,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2746,0,18277,'Treasure Chest','','mimic','8.50','8.50',57,'male','L2Monster','Fighter',40,2897,2.400,1052,2.400,40,43,30,21,20,10,0,0,743,351,405,285,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2747,0,18278,'Treasure Chest','','mimic','8.50','8.50',60,'male','L2Monster','Fighter',40,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,860,380,478,309,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2748,0,18279,'Treasure Chest','','mimic','8.50','8.50',63,'male','L2Monster','Fighter',40,3408,2.700,1251,2.700,40,43,30,21,20,10,0,0,987,411,560,334,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2749,0,18280,'Treasure Chest','','mimic','8.50','8.50',66,'male','L2Monster','Fighter',40,3661,2.700,1353,2.700,40,43,30,21,20,10,0,0,1123,442,649,359,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2750,0,18281,'Treasure Chest','','mimic','8.50','8.50',69,'male','L2Monster','Fighter',40,3906,2.700,1458,2.700,40,43,30,21,20,10,0,0,1265,474,746,385,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2751,0,18282,'Treasure Chest','','mimic','8.50','8.50',72,'male','L2Monster','Fighter',40,4142,3.000,1565,3.000,40,43,30,21,20,10,0,0,1413,507,849,412,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2752,0,18283,'Treasure Chest','','mimic','8.50','8.50',75,'male','L2Monster','Fighter',40,4365,3.000,1673,3.000,40,43,30,21,20,10,0,0,1563,540,957,438,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2753,0,18284,'Treasure Chest','','mimic','8.50','8.50',78,'male','L2Monster','Fighter',40,4571,3.000,1784,3.000,40,43,30,21,20,10,0,0,1715,573,1069,465,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2754,0,18285,'Treasure Chest','','mimic','8.50','8.50',81,'male','L2Monster','Fighter',40,4757,3.000,1896,3.000,40,43,30,21,20,10,0,0,1863,606,1182,492,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2755,0,18286,'Treasure Chest','','mimic','8.50','8.50',84,'male','L2Monster','Fighter',40,4920,3.000,2011,3.000,40,43,30,21,20,10,0,0,2006,639,1296,519,278,0,253,0,0,0,80,1,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2756,13213,18287,'Otherworldly Invader Food','','mimic','8.50','8.50',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,166,157,75,128,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2757,13214,18288,'Otherworldly Invader Food','','mimic','8.50','8.50',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2758,13215,18289,'Dimension Invader Food','','mimic','8.50','8.50',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,332,223,163,181,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2759,13216,18290,'Dimension Invader Food','','mimic','8.50','8.50',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2760,13217,18291,'Purgatory Invader Food','','mimic','8.50','8.50',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,0,0,602,304,319,247,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2761,13218,18292,'Purgatory Invader Food','','mimic','8.50','8.50',55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2762,13219,18293,'Forbidden Path Invader Food','','mimic','8.50','8.50',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,0,0,987,398,560,323,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2763,13220,18294,'Forbidden Path Invader Food','','mimic','8.50','8.50',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2764,13221,18295,'Dark Omen Invader Food','','mimic','8.50','8.50',73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,0,0,1463,502,885,407,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2765,13222,18296,'Dark Omen Invader Food','','mimic','8.50','8.50',75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2766,13223,18297,'Messenger Invader Food','','mimic','8.50','8.50',83,'male','L2Monster','Fighter',40,4716,8.500,1972,3.000,40,43,30,21,20,10,0,0,1959,608,1258,494,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2767,13224,18298,'Messenger Invader Food','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,80,165,'ssq_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2768,13225,18299,'Flame of the Branded','','big_boom','6.00','13.00',35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1631,96,192,169,89,137,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2769,13226,18300,'Offering of the Branded,Evoked Spirit','','orc','10.00','21.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1751,100,166,157,75,128,278,0,253,158,0,0,45,155,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2770,13227,18301,'Flame of Apostates','','big_boom','6.00','13.00',46,'male','L2Monster','Fighter',40,1943,16.500,707,2.100,40,43,30,21,20,10,2817,199,401,245,202,199,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2771,13228,18302,'Offering of Apostates,Evoked Spirit','','orc_fighter','12.00','22.00',44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3113,213,354,230,176,187,278,0,253,172,0,0,45,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2772,13229,18303,'Flame of the Witch','','big_boom','6.00','13.00',57,'male','L2Monster','Mystic',40,2806,19.500,1052,2.400,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2773,13230,18304,'Offering of the Witch,Evoked Spirit','','batur_orc','9.00','21.50',55,'male','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4864,393,670,322,360,261,278,0,253,91,0,0,80,165,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2774,13231,18305,'Flame of Dark Omen','','big_boom','6.00','13.00',68,'male','L2Monster','Fighter',40,3706,22.500,1423,2.700,40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2775,13232,18306,'Offering of Dark Omen,Evoked Spirit','','batur_orc','9.00','21.50',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,253,2503,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(2776,13233,18307,'Flame of Forbidden Path','','big_boom','6.00','13.00',79,'male','L2Monster','Fighter',40,4490,25.500,1821,3.000,40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2777,13234,18308,'Offering of /Forbidden Path,Evoked Spirit','','batur_orc_warrior','10.00','20.00',77,'male','L2Monster','Fighter',40,4364,8.500,1747,3.000,40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,253,175,0,0,80,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2778,13235,18309,'Flame of the Branded','','big_boom','6.00','13.00',35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1631,96,192,169,89,137,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2779,13236,18310,'Offering of the Branded,Evoked Spirit','','orc','10.00','21.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1751,100,166,157,75,128,278,0,253,158,0,0,45,155,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2780,13237,18311,'Flame of Apostates','','big_boom','6.00','13.00',46,'male','L2Monster','Fighter',40,1943,16.500,707,2.100,40,43,30,21,20,10,2817,199,401,245,202,199,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2781,13238,18312,'Offering of Apostates,Evoked Spirit','','orc_fighter','12.00','22.00',44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3113,213,354,230,176,187,278,0,253,172,0,0,45,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2782,13239,18313,'Flame of the Witch','','big_boom','6.00','13.00',57,'male','L2Monster','Mystic',40,2806,19.500,1052,2.400,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2783,13240,18314,'Offering of the Witch,Evoked Spirit','','batur_orc','9.00','21.50',55,'male','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4864,393,670,322,360,261,278,0,253,91,0,0,80,165,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2784,13241,18315,'Flame of Dark Omen','','big_boom','6.00','13.00',68,'male','L2Monster','Fighter',40,3706,22.500,1423,2.700,40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2785,13242,18316,'Offering of Dark Omen,Evoked Spirit','','batur_orc','9.00','21.50',66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,253,2503,0,0,80,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2786,13243,18317,'Flame of Forbidden Path','','big_boom','6.00','13.00',79,'male','L2Monster','Fighter',40,4490,25.500,1821,3.000,40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2787,13244,18318,'Offering of Forbidden Path,Evoked Spirit','','batur_orc_warrior','10.00','20.00',77,'male','L2Monster','Fighter',40,4364,8.500,1747,3.000,40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,253,175,0,0,80,175,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2788,13245,18319,'Caught Frog','','poison_toad','20.00','10.00',10,'male','L2PenaltyMonster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,421,14,22,52,8,49,278,0,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.35),
(2789,13246,18320,'Caught Undine','','undine','12.00','27.00',20,'female','L2PenaltyMonster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,843,37,57,80,23,76,278,0,253,0,0,0,60,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.35),
(2790,13247,18321,'Caught Rakul','','rakul','30.00','39.00',30,'male','L2PenaltyMonster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1550,85,132,119,58,114,278,0,253,156,0,0,60,130,'',0,1,'Local','',0,0,0,7,50,1,9,0,10,0.59),
(2791,13248,18322,'Caught Sea Giant','','water_giant','13.00','44.00',40,'male','L2PenaltyMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2755,178,273,171,131,164,278,0,253,131,0,0,35,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.45),
(2792,13249,18323,'Caught Sea Horse Soldier','','theeder','9.00','32.00',50,'male','L2PenaltyMonster','Fighter',80,2245,5.500,830,2.100,40,43,30,21,20,10,4305,324,509,236,264,226,237,0,216,291,0,0,80,150,'',0,0,'Local','',0,0,0,7,30,4,0,0,10,0.45),
(2793,13250,18324,'Caught Homunculus','','homunculus','12.00','32.50',60,'male','L2PenaltyMonster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,6200,538,860,313,478,299,278,0,253,0,0,0,30,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.50),
(2794,13251,18325,'Caught Flava','','flava','18.00','34.00',70,'male','L2PenaltyMonster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8438,837,1314,399,780,382,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.45),
(2795,13252,18326,'Caught Gigantic Eye','','hundred_eye','21.00','55.00',80,'male','L2PenaltyMonster','Mystic',40,4550,8.500,1859,3.000,40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,253,0,0,0,30,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.54),
(2796,0,18327,'Freya''s Servant','','gargoyle_02te','16.00','50.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',300,0,'Local','',0,0,0,7,10,8,0,0,0,0.46),
(2797,0,18328,'Hall Alarm Device','','grave_keeper_key','8.00','21.00',85,'etc','L2Folk','npc',40,158000,2.000,989,0.900,40,43,30,21,20,10,0,0,652,753,358,295,423,0,385,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,0,4,3,0,0,0.60),
(2798,0,18329,'Hall Keeper Captain','','death_lord','21.00','40.00',83,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'hall_keeper_clan',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(2799,0,18330,'Hall Keeper Wizard','','vale_master','12.00','40.00',80,'male','L2Monster','Mystic',40,4550,8.500,1859,3.000,40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,253,0,0,0,30,180,'hall_keeper_clan',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.54),
(2800,0,18331,'Hall Keeper Guard','','death_knight','12.00','30.00',82,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'hall_keeper_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(2801,0,18332,'Hall Keeper Patrol','','headless_knight','21.00','31.00',81,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'hall_keeper_clan',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.54),
(2802,0,18333,'Hall Keeper Suicidal Soldier','','self_blaster','9.00','25.80',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'hall_keeper_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(2803,0,18334,'Dark Choir Captain','','erinyes_cmd','21.00','50.00',85,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,23,190,'dark_choir_clan',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.54),
(2804,0,18335,'Dark Choir Prima Donna','','portrait_spirit','23.00','40.00',82,'male','L2Monster','Mystic',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(2805,0,18336,'Dark Choir Lancer','','death_blader','15.00','45.00',82,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(2806,0,18337,'Dark Choir Archer','','skeleton_archer_20_bi','13.00','32.50',82,'male','L2Monster','Ranger',500,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(2807,0,18338,'Dark Choir Witch Doctor','','portrait_spirit_winged','23.00','40.00',82,'male','L2Monster','Mystic',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.45),
(2808,0,18339,'Dark Choir Player','','skeleton','11.00','25.00',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'dark_choir_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(2809,0,18340,'Hall Keeper Suicidal Soldier','','self_blaster','9.00','25.80',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(2810,0,18341,'Hall Keeper Suicidal Soldier','','self_blaster','9.00','25.80',80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.61),
(2811,5198,18342,'Gremlin','','gremlin','10.00','15.00',1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(2812,0,18343,'Gatekeeper Zombie','','zombie_gateguard','17.00','30.50',83,'male','L2Folk','npc',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,150,182,0,0,0,20,165,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(2813,0,18344,'Ancient Egg','','dinosaur_nest','43.00','33.50',80,'etc','L2Monster','npc',0,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,30,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2814,0,18345,'Sprigant','','arachnoid','45.00','67.00',80,'male','L2Monster','Fighter',40,3862,19.500,1052,2.400,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2815,0,18346,'Sprigant','','arachnoid','45.00','67.00',80,'male','L2Monster','Fighter',40,3862,19.500,1052,2.400,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(2816,5001,27001,'Orc Sniper','','orc_archer','14.00','25.00',10,'male','L2Monster','Ranger',500,257,2.000,120,0.900,40,43,30,21,20,10,0,0,51,61,8,49,249,0,227,14,0,0,45,110,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(2817,5002,27002,'Orc Fighter','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,27,66,10,54,278,0,253,1,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2818,5003,27003,'Spirit Of Mirrors','Quest Monster','poison_toad','20.00','10.00',9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,0,0,20,58,7,47,278,0,253,0,0,0,50,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2819,5004,27004,'Spirit Of Mirrors','Quest Monster','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2820,5005,27005,'Spirit Of Mirrors','Quest Monster','werewolf','10.00','26.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2821,5006,27006,'Bhato Bloodspear','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2822,5007,27007,'Tanuki Skullcrusher','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2823,5008,27008,'Kraacul Blackskull','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2824,5009,27009,'Taarq Blackskull','','orc_archer','14.00','25.00',11,'male','L2Monster','Ranger',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.80),
(2825,5016,27016,'Nerkas','Quest Monster','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2826,5017,27017,'Plague Zombie','Quest Monster','zombie','13.00','21.00',14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,0,0,33,73,12,59,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2827,5018,27018,'Orc Warrior','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2828,5019,27019,'Orc Warrior Leader','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2829,5020,27020,'Varool Foulclaw','Quest Monster','wererat','14.00','25.00',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(2830,5021,27021,'Kirunak','Quest Monster','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,80,'kirunak_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2831,5022,27022,'Merkenis','Quest Monster','succubus','10.00','36.00',22,'female','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,60,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(2832,5024,27024,'Undead Priest','Quest Monster','zombie','13.00','21.00',17,'male','L2Monster','Priest',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2833,5029,27029,'Phantom Salamander','Quest Monster','salamander','16.00','6.80',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,500,253,0,0,0,64,96,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(2834,5030,27030,'Water Seer','Quest Monster','monster_eye','21.00','43.00',17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,500,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2835,5031,27031,'Ol Mahum Sentry','Quest Monster','ol_mahum','13.50','25.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2836,5032,27032,'Lizardman Warrior','Quest Monster','virud_lizardman_warrior','12.00','30.00',13,'male','L2Monster','Fighter',80,339,2.500,147,1.200,40,43,30,21,20,10,0,0,33,63,11,56,237,500,216,16,0,0,52,130,'',0,0,'Local','',0,0,0,7,30,4,0,0,0,0.59),
(2837,5033,27033,'Lizardman Scout','Quest Monster','virud_lizardman','10.00','23.00',12,'male','L2Monster','Ranger',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,30,60,10,54,278,500,253,1,0,0,43,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2838,5034,27034,'Lizardman','Quest Monster','virud_lizardman','10.00','23.00',11,'male','L2Monster','Fighter',80,292,2.500,129,1.200,40,43,30,21,20,10,0,0,27,58,9,52,237,500,216,291,0,0,43,130,'',0,0,'Local','',0,0,0,7,30,4,0,0,0,0.48),
(2839,5035,27035,'Tamil','Quest Monster','bugbear','17.00','35.00',19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,0,0,58,82,21,73,278,500,253,4,0,0,55,130,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.28),
(2840,5036,27036,'Calpico','Quest Monster','orc_fighter','12.00','22.00',13,'male','L2Monster','Fighter',40,339,2.500,147,1.200,40,43,30,21,20,10,0,0,33,63,11,56,278,0,253,2,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2841,5037,27037,'Calpico''s Goons','Quest Monster','orc','10.00','21.00',10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,0,0,25,55,8,49,278,0,253,1,0,0,45,110,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(2842,5038,27038,'Cat''s Eye Bandit','Quest Monster','ol_mahum','13.50','25.00',15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,0,0,32,76,14,62,317,0,289,218,0,0,50,110,NULL,0,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.46),
(2843,5041,27041,'Baranka''s Messenger','Quest Monster','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,25,73,10,54,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.46),
(2844,5042,27042,'Orc Escort','Quest Monster','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,25,73,10,54,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2845,5043,27043,'Varangka''s Tracker','Quest Monster','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,23,70,9,52,278,500,253,0,0,0,60,80,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.50),
(2846,5044,27044,'Kasha Bear Totem Spirit','Quest Monster','grizzly','21.00','40.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,40,91,17,67,278,500,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(2847,5045,27045,'Kuruka Ratman Leader','Quest Monster','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,0,0,44,95,19,70,278,500,253,1,0,0,80,120,'wererat_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(2848,5046,27046,'Sumi','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2849,5047,27047,'Wanuk','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2850,5048,27048,'Chewba','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2851,5049,27049,'Heitafu','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2852,5050,27050,'Picubo','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2853,5051,27051,'Bumbum','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2854,5052,27052,'Minsku','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2855,5053,27053,'Chuchu','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2856,5054,27054,'Umbar Orc','Quest Monster','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2857,5055,27055,'Zakan','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2858,5056,27056,'Durka Spirit','Quest Monster','magical_weaver','11.00','20.00',18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,0,0,48,87,19,70,278,500,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2859,5058,27058,'Honey Bear','Quest Monster','grizzly','21.00','40.00',17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(2860,5059,27059,'Uoph','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2861,5060,27060,'Kracha','Kaboo Chief','orc_archer','14.00','25.00',11,'male','L2Monster','Ranger',500,292,2.500,129,1.200,40,43,30,21,20,10,0,0,56,64,9,52,249,0,227,275,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(2862,5061,27061,'Batoh','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,86,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(2863,5062,27062,'Tanukia','Kaboo Chief','orc_fighter','12.00','22.00',8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,0,0,18,55,6,45,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2864,5063,27063,'Tanukia''s Warhound','Quest Monster','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.39),
(2865,5064,27064,'Turel','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2866,5065,27065,'Roko','Kaboo Chief','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,0,0,41,55,6,45,249,0,227,275,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(2867,5066,27066,'Roko''s Warhound','Quest Monster','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.39),
(2868,5067,27067,'Kamut','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,86,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,50,1,9,0,0,0.46),
(2869,5068,27068,'Murtika','Kaboo Chief','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,0,0,41,55,6,45,249,0,227,275,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.80),
(2870,5069,27069,'Murtika''s Warhound','Quest Monster','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.39),
(2871,5070,27070,'Tumran Orc Brigand','Quest Monster','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2872,5077,27077,'Unicorn Of Eva','Quest Monster','unicorn','14.00','30.00',30,'male','L2Monster','Mystic',40,954,3.500,365,1.500,40,43,30,21,20,10,0,0,145,128,58,114,278,0,253,0,0,0,46,150,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(2873,5078,27078,'Trimden Lord ','Quest Monster','poison_spider','27.00','25.50',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,60,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(2874,5079,27079,'Black Willow Lurker','Quest Monster','hanged_man_ripper','35.00','80.00',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,55,55,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2875,5080,27080,'Pashika Son Of Voltar','Quest Monster','batur_orc_warrior','10.00','20.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,500,253,2,0,0,80,120,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2876,5081,27081,'Vultus Son Of Voltar','Quest Monster','batur_orc_warrior','10.00','20.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,500,253,2,0,0,80,120,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2877,5082,27082,'Enku Orc Overlord','Quest Monster','batur_orc_warrior','10.00','20.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,182,143,75,128,278,500,253,2,0,0,80,120,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2878,5083,27083,'Makum Bugbear Thug','Quest Monster','bugbear','17.00','35.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,2,0,0,55,130,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2879,5086,27086,'Revenant of Tantos Chief','Quest Monster','batur_orc_overlord','12.00','24.00',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,231,214,121,158,278,0,253,66,0,0,80,140,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2880,5088,27088,'Harpy Matriarch','Quest Monster','harpy','10.00','42.00',34,'female','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,0,0,178,163,82,132,278,500,253,0,0,0,60,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(2881,5089,27089,'Road Collector','Quest Monster','wererat','14.00','25.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,500,253,12,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(2882,5090,27090,'Serpent Demon Kadesh','Quest Monster','serpent_slave','17.00','46.00',41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,0,0,291,208,141,169,278,0,253,73,0,0,70,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2883,5092,27092,'Neer Bodyguard','Quest Monster','neer_crawler','14.00','22.00',33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,182,143,75,128,278,500,253,0,0,0,50,90,'lizardman_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(2884,5093,27093,'Delu Chief Kalkis','Quest Monster','virud_lizardman_matriarch','13.00','37.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,0,253,12,0,0,56,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.65),
(2885,5094,27094,'Delu Lizardman Assassin','Quest Monster','virud_lizardman','10.00','23.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,227,159,96,142,278,500,253,2,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2886,5095,27095,'Singing Flower Phantasm','Quest Monster','mandragora_b','12.00','25.50',44,'female','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.13),
(2887,5096,27096,'Singing Flower Nightmare','Quest Monster','mandragora_b','12.00','25.50',44,'female','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.13),
(2888,5097,27097,'Singing Flower Darkling','Quest Monster','mandragora_b','12.00','25.50',44,'female','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.13),
(2889,5098,27098,'Ghost Fire','Quest Monster','will_o_wisp','13.00','22.00',42,'male','L2Monster','Mystic',40,1660,5.500,589,2.100,40,43,30,21,20,10,0,0,311,215,152,175,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.10),
(2890,5099,27099,'Nameless Revenant','Quest Monster','zombie','13.00','21.00',38,'male','L2Monster','Mystic',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,261,171,112,153,278,0,253,0,0,0,15,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2891,5100,27100,'Skeletal Mercenary','Quest Monster','skeleton_knight','10.00','25.00',39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,280,177,121,158,278,0,253,69,0,0,40,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(2892,5101,27101,'Drevanul Prince Zeruel','Quest Monster','dre_vanul','14.00','36.00',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,0,0,342,196,152,175,278,0,253,0,0,0,80,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2893,5102,27102,'Pako The Cat','Quest Monster','cat_the_cat','9.00','16.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(2894,5103,27103,'Unicorn Racer','Quest Monster','unicorn_boxer','11.00','18.00',38,'male','L2Monster','Mystic',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(2895,5104,27104,'Shadow Turen','Quest Monster','shadow','10.00','30.00',39,'male','L2Monster','Mystic',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(2896,5105,27105,'Mimi The Cat','Quest Monster','cutie_cat','8.00','15.00',39,'female','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(2897,5106,27106,'Unicorn Phantasm','Quest Monster','unicorn_mirage','13.00','17.50',40,'male','L2Monster','Mystic',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(2898,5107,27107,'Silhouette Tilfo','Quest Monster','silhouette','8.00','23.00',40,'female','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(2899,5108,27108,'Stenoa Gorgon Queen','Quest Monster','cave_maiden','25.00','65.00',37,'female','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,0,253,127,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2900,5109,27109,'Handmaiden Of Stenoa','Quest Monster','medusa','10.00','25.00',33,'female','L2Monster','Mystic',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,182,143,75,128,278,0,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2901,5110,27110,'Shyslassys','Quest Monster','medusa','10.00','25.00',36,'female','L2Monster','Mystic',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,0,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2902,5111,27111,'Cave Basilisk','Quest Monster','lesser_basilisk','34.00','25.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,0,0,120,155,58,114,278,0,253,0,0,0,35,54,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2903,5112,27112,'Gorr','Quest Monster','medusa','10.00','25.00',36,'female','L2Monster','Mystic',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,227,159,96,142,278,0,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2904,5113,27113,'Baraham','Quest Monster','medusa','10.00','25.00',36,'female','L2Monster','Mystic',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,227,159,96,142,278,0,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2905,5114,27114,'Succubus Queen','Quest Monster','succubus','10.00','36.00',34,'female','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,0,0,196,148,82,132,278,0,253,0,0,0,60,100,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(2906,5115,27115,'Claw Of Succubus','Quest Monster','succubus','10.00','36.00',28,'female','L2Monster','Mystic',40,859,3.500,334,1.500,40,43,30,21,20,10,0,0,124,118,49,106,278,0,253,0,0,0,60,100,'demonic_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(2907,5116,27116,'Lava Salamander','Quest Monster','salamander','16.00','6.80',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,174,186,89,137,278,0,253,0,0,0,64,96,'elemental3_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(2908,5117,27117,'Nahir','Quest Monster','dre_vanul','14.00','36.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,174,186,89,137,278,0,253,0,0,0,80,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2909,5118,27118,'Black Willow','Quest Monster','hanged_man_ripper','35.00','80.00',30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,0,0,145,128,58,114,278,0,253,0,0,0,55,55,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2910,5119,27119,'Spirit of Sir Herod','Quest Monster','skeleton_royal_guard','11.00','28.50',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,69,0,0,80,120,'skeleton_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2911,5120,27120,'Luell Of Zephyr Winds','Quest Monster','sylph','11.00','35.00',37,'female','L2Monster','Mystic',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,0,253,0,0,0,60,60,'elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2912,5121,27121,'Actea Of Verdant Wilds','Quest Monster','dryad','9.00','20.00',37,'female','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,0,253,0,0,0,40,110,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(2913,5122,27122,'Leto Lizardman Agent','Quest Monster','zenta_lizardman','11.00','32.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,1,0,0,37,140,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2914,5123,27123,'Leto Lizardman Leader','Quest Monster','zenta_lizardman_warrior','13.00','35.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,66,0,0,40,140,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2915,5124,27124,'Leto Lizardman Assassin','Quest Monster','zenta_lizardman','11.00','32.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,217,0,0,37,140,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2916,5125,27125,'Leto Lizardman Sniper','Quest Monster','zenta_lizardman_scout','11.00','30.00',36,'male','L2Monster','Ranger',500,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,417,193,96,142,249,0,227,14,0,0,37,150,'lizardman_clan',300,0,'Local','',0,0,0,7,10,8,0,1500,0,0.93),
(2917,5126,27126,'Leto Lizardman Wizard','Quest Monster','zenta_lizardman_shaman','13.00','35.00',39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,280,177,121,158,278,0,253,7,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(2918,5127,27127,'Leto Lizardman Lord','Quest Monster','zenta_lizardman_matriarch','20.00','40.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,69,0,0,53,140,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2919,5128,27128,'Aruraune','Quest Monster','mandragora_b','12.00','25.50',40,'female','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,278,500,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.13),
(2920,5129,27129,'Ol Mahum Inspector','Quest Monster','ol_mahum','13.50','25.00',38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,261,171,112,153,278,500,253,2,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2921,5130,27130,'Ol Mahum Betrayer','Quest Monster','ol_mahum','13.50','25.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,0,253,12,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2922,5131,27131,'Crimson Werewolf','Quest Monster','werewolf','10.00','26.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,500,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2923,5132,27132,'Krudel Lizardman','Quest Monster','virud_lizardman','10.00','23.00',36,'male','L2Monster','Fighter',80,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,237,500,216,291,0,0,43,130,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.48),
(2924,5133,27133,'Evil Eye Lord','Quest Monster','monster_eye','21.00','43.00',37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2925,5134,27134,'Tatoma','Quest Monster','king_bugbear','15.00','40.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,0,0,140,167,69,123,278,500,253,88,0,0,55,130,'orc_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2926,5135,27135,'Grima','Quest Monster','devastator','35.00','35.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,560,253,264,226,278,500,253,0,0,0,25,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2927,5136,27136,'Succubus Of Seduction','Quest Monster','succubus','10.00','36.00',40,'female','L2Monster','Mystic',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,60,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(2928,5137,27137,'Demon King','Quest Monster','dre_vanul','14.00','36.00',50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,500,253,0,0,0,80,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2929,5138,27138,'Great Demon King','Quest Monster','death_knight','12.00','30.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,946,335,478,299,278,500,253,127,0,0,27,110,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(2930,5139,27139,'Secret Keeper Tree','Quest Monster','ti_mi_tran','23.00','90.00',47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,0,0,388,279,216,206,278,0,253,0,0,0,12,12,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(2931,5140,27140,'Breka Overlord Haka','Quest Monster','batur_orc_overlord','12.00','24.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2932,5141,27141,'Breka Overlord Jaka','Quest Monster','batur_orc_overlord','12.00','24.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2933,5142,27142,'Breka Overlord Marka','Quest Monster','batur_orc_overlord','12.00','24.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2934,5143,27143,'Windsus Aleph','Quest Monster','giant_wild_hog','25.00','27.00',42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,0,0,342,196,152,175,278,500,253,0,0,0,35,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(2935,5144,27144,'Tarlk Raider Athu','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2936,5145,27145,'Tarlk Raider Lanka','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2937,5146,27146,'Tarlk Raider Triska','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2938,5147,27147,'Tarlk Raider Motura','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2939,5148,27148,'Tarlk Raider Kalath','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2940,5149,27149,'Gremlin Filcher','Quest Monster','gremlin','10.00','15.00',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,25,73,10,54,278,500,253,0,0,0,20,50,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(2941,5150,27150,'Black Legion Stormtrooper','Quest Monster','skeleton_royal_guard','11.00','28.50',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,217,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2942,5151,27151,'Delu Lizardman Headhunter','Quest Monster','virud_lizardman_scout','10.00','22.00',28,'male','L2Monster','Fighter',500,859,3.500,334,1.500,40,43,30,21,20,10,0,0,276,118,49,106,249,500,227,2507,0,0,43,130,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.72);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(2943,5152,27152,'Marsh Stakato Marquess','Quest Monster','marsh_stakato_queen','15.00','37.00',35,'female','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,211,154,89,137,278,500,253,0,0,0,130,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(2944,5153,27153,'Alexandro Sanches ','Dark Lord','imp','10.00','24.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,0,0,10,48,3,35,278,0,253,0,0,0,60,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(2945,5154,27154,'Bonaparterius','Abyss King','goblin','10.00','16.50',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,0,0,10,48,3,35,278,0,253,4,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.32),
(2946,5155,27155,'Ramsebalius','Evil Overlord','orc','10.00','21.00',3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,0,0,12,40,3,35,278,0,253,2,0,0,45,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(2947,5156,27156,'Leto Shaman Ketz','Quest Monster','zenta_lizardman_shaman','13.00','35.00',40,'male','L2Monster','Priest',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,159,0,0,43,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(2948,5157,27157,'Leto Chief Narak','Quest Monster','zenta_lizardman_matriarch','20.00','40.00',41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,0,0,265,229,141,169,278,500,253,221,0,0,53,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2949,5158,27158,'Timak Raider Kaikee','Quest Monster','batur_orc','9.00','21.50',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,66,0,0,80,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2950,5159,27159,'Timak Overlord Okun','Quest Monster','batur_orc_overlord','12.00','24.00',46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,0,0,442,223,202,199,278,500,253,127,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2951,5160,27160,'Gok Magok','Grandis Chief','twin_headed_giant','17.00','39.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,302,245,163,181,278,500,253,0,0,0,45,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2952,5161,27161,'Taik Overlord Kakran','Quest Monster','ketra_orc_warrior','12.00','24.00',45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,415,216,188,193,278,500,253,69,0,0,36,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(2953,5162,27162,'Hatar Chieftain Kubel','Quest Monster','medusa','10.00','25.00',52,'female','L2Monster','Mystic',40,2402,6.500,892,2.400,40,43,30,21,20,10,0,0,518,324,300,239,278,500,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(2954,5163,27163,'Vanor Elder Kerunos','Quest Monster','heltor_silenos_chieftain','13.00','31.50',51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,0,0,490,315,281,232,278,500,253,179,0,0,27,160,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2955,5164,27164,'Karul Chief Orooto','Quest Monster','bugbear','17.00','35.00',43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,88,0,0,55,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(2956,5165,27165,'Abyssal Jewel 1','Quest Monster','mirror','26.00','52.00',60,'male','L2Monster','Mystic',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2957,5166,27166,'Abyssal Jewel 2','Quest Monster','mirror','26.00','52.00',60,'male','L2Monster','Mystic',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2958,5167,27167,'Abyssal Jewel 3','Quest Monster','mirror','26.00','52.00',60,'male','L2Monster','Mystic',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2959,5168,27168,'Jewel Guardian Mara','Quest Monster','succubus','10.00','36.00',53,'female','L2Monster','Mystic',40,2481,6.500,923,2.400,40,43,30,21,20,10,0,0,662,276,319,247,278,500,253,0,0,0,60,100,'abyss_jewel_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(2960,5169,27169,'Jewel Guardian Musfel','Quest Monster','dre_vanul','14.00','36.00',53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,0,0,547,334,319,247,278,500,253,0,0,0,80,80,'abyss_jewel_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(2961,5170,27170,'Jewel Guardian Pyton','Quest Monster','serpent_slave','17.00','46.00',58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,0,0,710,384,428,284,278,500,253,223,0,0,70,110,'abyss_jewel_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(2962,5171,27171,'Sacrifice Of The Sacrificed','Quest Monster','magical_weaver','11.00','20.00',20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,63,86,23,76,278,0,253,0,0,0,90,90,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(2963,5172,27172,'Harit Lizardman Zealot','Quest Monster','zenta_lizardman_warrior','13.00','35.00',55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,737,292,360,261,278,500,253,16,0,0,40,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(2964,5173,27173,'Box Of Athrea 1','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2965,5174,27174,'Box Of Athrea 2','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2966,5175,27175,'Box Of Athrea 3','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2967,5176,27176,'Box Of Athrea 4','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2968,5177,27177,'Box Of Athrea 5','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2969,5178,27178,'Blitz Wyrm','Quest Monster','wyrm','29.00','72.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,946,335,478,299,278,500,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(2970,5179,27179,'Grave Keymaster','Quest Monster','gargoyle','16.00','50.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,979,460,619,340,278,0,253,0,0,0,140,140,'grave_guard_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(2971,5180,27180,'Imperial Slave','Quest Monster','binding','12.00','21.00',56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,642,364,382,269,278,500,253,0,0,0,10,140,'grave_keeper_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(2972,5181,27181,'Imperial Gravekeeper','Quest Monster','death_blader','15.00','45.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,1472,0,0,100,170,'grave_keeper_clan',300,1,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(2973,5182,27182,'Ark Guardian Elberoth','Quest Monster','archangel','15.00','80.00',60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,6370,0,0,50,200,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(2974,5183,27183,'Ark Guardian Shadowfang','Quest Monster','kel_mahum_archer','13.00','27.00',60,'male','L2Monster','Ranger',500,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,2313,259,478,299,249,0,227,288,0,0,50,160,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.91),
(2975,5184,27184,'Angel Killer','Quest Monster','death_lord','21.00','40.00',60,'male','L2Monster','Fighter',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,711,446,478,299,278,0,253,130,0,0,40,200,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(2976,5185,27185,'Fairy Tree of Wind','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,273,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,0,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(2977,5186,27186,'Fairy Tree of Star','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,554,389,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2978,5187,27187,'Fairy Tree of Twilight','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,737,292,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2979,5188,27188,'Fairy Tree of Abyss','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(2980,5189,27189,'Soul of Tree Guardian','Quest Monster','elf_ghost','7.00','21.00',50,'male','L2Monster','Mystic',40,2245,2.750,830,2.100,40,43,30,21,20,10,0,0,509,236,264,226,278,500,253,0,0,0,80,140,'q421_tree_clan',100,1,'Local','',0,0,0,7,30,4,4,0,10,0.41),
(2981,5190,27190,'Ol Mahum Support Troop','Quest Monster','ol_mahum_champion','14.00','27.00',26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,0,0,96,120,41,98,278,500,253,69,0,0,50,150,'orc_clan',200,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(2982,5191,27191,'Malcom','Quest Monster','grizzly','21.00','40.00',25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,0,0,103,116,37,94,237,500,216,0,0,0,40,159,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(2983,5192,27192,'Succubus Handmaiden','Quest Monster','succubus','10.00','36.00',18,'female','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,0,0,48,87,19,70,278,500,253,0,0,0,60,134,'',0,0,'stiff_fix_outofdate_from_1028','1145636095',0,0,0,7,30,4,4,0,0,0.84),
(2984,5193,27193,'Goblin Servant','Quest Monster','goblin','10.00','16.50',12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,27,56,10,54,278,500,253,0,0,0,40,120,'',0,0,'stiff_fix_outofdate_from_1029','1145636095',0,0,0,7,30,4,4,0,10,0.32),
(2985,5194,27194,'Julie the Ripper','Quest Monster','doll_blader','6.00','12.00',40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,0,0,289,141,131,164,317,500,289,5129,5129,0,22,174,'',0,0,'stiff_fix_outofdate_from_1030','1145636095',0,0,60,7,10,8,0,0,10,0.50),
(2986,5195,27195,'Male Ant','Quest Monster','noble_ant','20.00','48.00',32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,0,0,154,151,69,123,278,0,253,0,0,0,80,150,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(2987,5196,27196,'Bluebacked Alligator','Quest Monster','crocodile','28.00','11.50',40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,70,110,'croc_clan',200,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(2988,5197,27197,'Bejewelled Alligator','Quest Monster','crocodile','28.00','11.50',40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,70,110,'croc_clan',200,0,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(2989,5199,27199,'Crimson Werewolf','Quest Monster','werewolf','10.00','26.00',36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,50,120,'werewolf_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(2990,5200,27200,'Krudel Lizardman','Quest Monster','virud_lizardman','10.00','23.00',36,'male','L2Monster','Fighter',80,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,237,0,216,291,0,0,43,130,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.48),
(2991,0,27201,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2992,0,27202,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2993,0,27203,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2994,0,27204,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2995,0,27205,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2996,0,27206,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2997,0,27207,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2998,0,27208,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(2999,0,27209,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(3000,0,27210,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(3001,0,27211,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(3002,0,27212,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(3003,0,27213,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,0,'Local','',0,0,0,7,30,4,0,0,0,0.28),
(3004,5214,27214,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3005,5215,27215,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3006,5216,27216,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3007,5217,27217,'Soul of Well','Quest Monster','dark_horror','20.00','35.00',63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,0,0,987,338,560,323,278,150,253,0,0,0,100,180,'',0,1,'Local','',0,0,0,7,30,4,4,0,10,0.37),
(3008,5218,27218,'Triol''s Pawn','Quest Monster','dre_vanul','14.00','36.00',65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,150,253,0,0,0,80,180,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.35),
(3009,5219,27219,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3010,5220,27220,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3011,5221,27221,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3012,5222,27222,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3013,5223,27223,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3014,5224,27224,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3015,5225,27225,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3016,5226,27226,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3017,5227,27227,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3018,5228,27228,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3019,5229,27229,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3020,5230,27230,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3021,5231,27231,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3022,5232,27232,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3023,5233,27233,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3024,5234,27234,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3025,5235,27235,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3026,5236,27236,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3027,5237,27237,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3028,5238,27238,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3029,5239,27239,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3030,5240,27240,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3031,5241,27241,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3032,5242,27242,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3033,5243,27243,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3034,5244,27244,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3035,5245,27245,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3036,5246,27246,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3037,5247,27247,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3038,5248,27248,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3039,5249,27249,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3040,5250,27250,'Fallen Angel Allector','Quest Monster','karik','25.00','90.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(3041,5251,27251,'Fallen Angel Allector','Quest Monster','karik','25.00','90.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(3042,5252,27252,'Fallen Angel Allector','Quest Monster','karik','25.00','90.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(3043,5253,27253,'Hell Fire','Quest Monster','will_o_wisp','13.00','22.00',76,'male','L2Monster','Mystic',40,4297,4.250,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,170,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.10),
(3044,5254,27254,'Unknown Stopper','Quest Monster','fiend_archer','17.00','55.00',81,'male','L2Monster','Ranger',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(3045,5255,27255,'Unknown Stopper','Quest Monster','fiend_archer','17.00','55.00',81,'male','L2Monster','Ranger',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(3046,5256,27256,'Unknown Stopper','Quest Monster','fiend_archer','17.00','55.00',81,'male','L2Monster','Ranger',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,10,0.76),
(3047,5257,27257,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3048,5258,27258,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3049,5259,27259,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3050,5260,27260,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3051,5261,27261,'Bead of Sacred Flame','Quest Monster','will_o_wisp','13.00','22.00',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.10),
(3052,5262,27262,'Death Lord Hallate','Quest Monster','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(3053,5263,27263,'Death Lord Hallate','Quest Monster','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(3054,5264,27264,'Death Lord Hallate','Quest Monster','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(3055,5265,27265,'Lich King Icarus','Quest Monster','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,253,205,0,0,70,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.74),
(3056,5266,27266,'Fallen Angel Haures','Quest Monster','doll_master','20.00','42.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,1,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(3057,5267,27267,'Fallen Angel Haures','Quest Monster','doll_master','20.00','42.00',76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,1,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(3058,5268,27268,'Guard of Haures','Quest Monster','neer_crawler','14.00','22.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1412,454,994,433,317,0,289,0,0,0,50,180,'',0,1,'Local','',0,0,0,7,10,8,0,0,10,0.37),
(3059,5269,27269,'Fallen Angel Naverius','Quest Monster','banshee','9.00','23.00',76,'female','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(3060,5270,27270,'Fallen Angel Naverius','Quest Monster','banshee','9.00','23.00',76,'female','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.56),
(3061,5271,27271,'Chimera Golem','Quest Monster','lava_golem','22.00','45.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,13,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.47),
(3062,5272,27272,'Hallate''s Dancer Lillian','Quest Monster','banshee','9.00','23.00',76,'female','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,NULL,0,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.56),
(3063,5273,27273,'Assassin Pezel','Quest Monster','skeleton_royal_guard','11.00','28.50',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,289,242,0,0,80,180,'',0,1,'Local','',0,0,0,7,10,8,0,0,0,0.52),
(3064,5274,27274,'Fallen angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.48),
(3065,5275,27275,'Fallen angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.48),
(3066,5276,27276,'Fallen angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.48),
(3067,5277,27277,'Fallen angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,0,'Local','',0,0,0,7,10,8,0,1500,0,0.48),
(3068,5278,27278,'Shadow of Beleth','Quest Monster','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,205,0,0,70,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.74),
(3069,5279,27279,'Cursed Kesadein','Quest Monster','doll_master','20.00','42.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,289,0,0,0,80,180,'',0,1,'Local','',0,0,0,7,10,8,0,0,10,0.56),
(3070,5280,27280,'Fallen Angel Narcissus','Quest Monster','karik','25.00','90.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,37,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(3071,5281,27281,'Fallen Angel Metellus','Quest Monster','karik','25.00','90.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,37,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(3072,5282,27282,'Reverse Angel Odiel','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3073,5283,27283,'Grandpapa Askalius','Quest Monster','susceptor_prime','45.00','72.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,78,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.52),
(3074,5284,27284,'Flame Evil Spirit Azira','Quest Monster','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,38,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3075,5285,27285,'Lizard''s Totem Sharuhi','Quest Monster','serpent_slave','17.00','46.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,72,0,0,70,180,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.46),
(3076,5286,27286,'Fallen Knight Adhil','Quest Monster','a_guard_MHuman','8.00','24.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,79,107,0,50,180,'',0,1,'Local','',0,20,161,7,30,4,4,0,-6,0.60),
(3077,5287,27287,'Bound Elf Panacea','Quest Monster','a_guard_MElf','8.00','23.50',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,145,0,0,50,180,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3078,5288,27288,'Sword Player Biel','Quest Monster','a_patriarch_MElf','8.00','22.50',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,74,74,0,50,180,'',0,1,'Local','',0,0,167,7,30,4,4,0,0,0.60),
(3079,5289,27289,'Ancient Sword Master Iron','Quest Monster','lilim_knight_10_bi','13.00','55.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,5800,5799,0,56,180,'',0,0,'Local','',0,20,161,7,30,4,4,0,-6,0.46),
(3080,5290,27290,'White Wing Commander ','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3081,5291,27291,'White Wing Fighter','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3082,5292,27292,'Fallen Noble Orc Muhark','Quest Monster','ketra_orc_warrior','12.00','24.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,7834,0,0,36,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(3083,5293,27293,'Khavatari Uruz','Quest Monster','ketra_orc_warrior','12.00','24.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,36,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(3084,5294,27294,'Overlord Atrus','Quest Monster','ketra_orc_chieftain','11.00','38.50',76,'male','L2Monster','Fighter',40,4297,34.000,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,6719,0,0,24,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.51),
(3085,5295,27295,'Sharuhi Mouth Mudaha','Quest Monster','ketra_orc_chieftain','11.00','38.50',76,'male','L2Monster','Fighter',40,4297,34.000,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,6719,0,0,24,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,0,0.51),
(3086,5296,27296,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3087,5297,27297,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3088,5298,27298,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3089,5299,27299,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3090,5300,27300,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3091,5301,27301,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3092,5302,27302,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3093,5303,27303,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3094,5304,27304,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3095,5305,27305,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3096,5306,27306,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3097,5307,27307,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3098,5308,27308,'Assassin Frost','Quest Monster','vampire_soldier','8.00','23.50',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,289,229,0,0,60,180,'',0,0,'Local','',0,0,0,7,10,8,0,0,0,0.45),
(3099,5309,27309,'Minervia Van Hacken','Quest Monster','vampire_witch','6.00','21.50',81,'female','L2Monster','Mystic',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,289,229,0,0,64,180,'',0,0,'Local','',0,0,0,7,10,8,0,0,10,0.50),
(3100,5310,27310,'Kitanis Van Hacken','Quest Monster','vampire_lord','7.50','25.80',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,15,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(3101,5311,27311,'Judgment Hound Dog Kelvas','Quest Monster','eligor','21.00','35.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,35,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3102,5312,27312,'Mysterious Servitor','Quest Monster','shadeless','7.00','28.00',81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,253,0,0,0,48,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.61),
(3103,5313,27313,'Vision Guardian Shakiel','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3104,5314,27314,'Vision Guardian Shakiel','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3105,5315,27315,'Vision Guardian Shakiel','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.48),
(3106,5316,27316,'Fallen Chieftain Vegus','Quest Monster','ketra_orc_warrior','12.00','24.00',55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,273,360,261,278,0,253,161,0,0,36,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.54),
(3107,5317,27317,'Restrainer of Glory','Quest Monster','kel_mahum_champion','13.00','32.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,399,780,382,278,0,253,161,0,0,50,180,'',0,0,'Local','',0,0,0,7,50,1,9,0,10,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(3108,0,27318,'Wendy''s Guardian','Quest Monster','golem_guardian_090p','16.00','37.20',46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,0,'Local','',0,0,0,7,50,1,9,0,0,0.30),
(3109,0,27319,'Black Leopard','Quest Monster','onyx_beast','14.00','14.50',18,'male','L2Monster','Fighter',40,476,3.500,287,1.500,40,43,30,21,20,10,1012,51,88,98,37,94,278,400,253,0,0,0,30,145,'beast_clan',300,0,'Local','',0,0,0,7,30,4,4,0,10,0.24),
(3110,0,27320,'Timora Orc','Quest Monster','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,2.500,203,1.200,40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3111,0,27321,'Bruin Lizardman','Quest Monster','virud_lizardman','10.00','23.00',20,'male','L2Monster','Fighter',40,541,2.500,203,1.200,40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3112,0,27322,'Picot Araneid','Quest Monster','giant_spider_50_bi','39.00','38.00',27,'male','L2Monster','Mystic',40,813,1.750,318,1.500,40,43,30,21,20,10,1453,74,104,106,45,102,278,500,253,0,0,0,72,130,'lizardman_clan',300,0,'Local','',0,0,0,7,50,1,9,0,10,0.26),
(3113,7001,30001,'Lector','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3114,7002,30002,'Jackson','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3115,7003,30003,'Silvia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3116,7004,30004,'Katerina','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3117,7005,30005,'Wilford','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3118,7006,30006,'Roxxy','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3119,7008,30008,'Roien','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3120,7009,30009,'Newbie Helper','','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3121,7010,30010,'Auron','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3122,7014,30014,'Celma','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3123,7017,30017,'Gallint','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3124,7019,30019,'Newbie Helper','','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3125,7022,30022,'Zigaunt','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3126,7026,30026,'Bitz','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3127,7027,30027,'Gwinter','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3128,7028,30028,'Pintage','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3129,7029,30029,'Minia','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3130,7030,30030,'Vivyan','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3131,7031,30031,'Biotin','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3132,7032,30032,'Yohanes','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3133,7033,30033,'Baulro','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3134,7034,30034,'Iris','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3135,7035,30035,'Harrys','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3136,7036,30036,'Petron','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3137,7037,30037,'Levian','High Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3138,7039,30039,'Gilbert','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3139,7040,30040,'Leon','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3140,7041,30041,'Arnold','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3141,7042,30042,'Abellos','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3142,7043,30043,'Johnstone','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3143,7044,30044,'Chiperan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3144,7045,30045,'Kenyos','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3145,7046,30046,'Hanks','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3146,7047,30047,'Firon','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3147,7048,30048,'Darin','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3148,7049,30049,'Bonnie','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3149,7050,30050,'Elias','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3150,7051,30051,'Cristel','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3151,7054,30054,'Rant','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3152,7055,30055,'Rolfe','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3153,7057,30057,'Aldo','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3154,7058,30058,'Holvas','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3155,7059,30059,'Trisha','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3156,7060,30060,'Sabrin','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3157,7061,30061,'Casey','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3158,7062,30062,'Sonia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3159,7063,30063,'Lara','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3160,7064,30064,'Terry','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3161,7065,30065,'Arnelle','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3162,7066,30066,'Pabris','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3163,7067,30067,'Glyvka','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3164,7068,30068,'Shegfield','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3165,7069,30069,'Rollant','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3166,7070,30070,'Sylvain','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3167,7071,30071,'Lucas','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3168,7072,30072,'Metty','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3169,7073,30073,'Jacob','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3170,7074,30074,'Harlan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3171,7075,30075,'Xaber','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3172,7076,30076,'Liam','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3173,7078,30078,'Pano','Grocer','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3174,7079,30079,'Barder','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3175,7080,30080,'Clarissa','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3176,7081,30081,'Helvetia','Grocer','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3177,7082,30082,'Denkus','Grocer','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3178,7083,30083,'Pochi','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3179,7084,30084,'Graham','Weapons Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3180,7085,30085,'Stanford','Weapons Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3181,7086,30086,'Taurin','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3182,7087,30087,'Peta','Armor Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3183,7088,30088,'Radia','Armor Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3184,7090,30090,'Sandra','Jeweler','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3185,7091,30091,'Ellie','Jeweler','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3186,7092,30092,'Collob','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3187,7093,30093,'Groot','Magic Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3188,7094,30094,'Gentler','Magic Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3189,7095,30095,'Randolf','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3190,7097,30097,'Galladucci','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3191,7098,30098,'Alexandria','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3192,7103,30103,'Valkon','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3193,7104,30104,'Parman','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3194,7105,30105,'Genwitter','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3195,7106,30106,'Dufner','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3196,7107,30107,'Goldian','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3197,7108,30108,'Macken','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3198,7109,30109,'Hannavalt','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3199,7110,30110,'Iker','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3200,7111,30111,'Dieter','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3201,7112,30112,'Maurius','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3202,7113,30113,'Juris','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3203,7114,30114,'Roa','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3204,7115,30115,'Jurek','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3205,7116,30116,'Dustin','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3206,7117,30117,'Primos','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3207,7118,30118,'Pupina','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3208,7119,30119,'Isabellin','Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3209,7120,30120,'Maximilian','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3210,7121,30121,'Jeronin','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3211,7122,30122,'Bane','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3212,7123,30123,'Vesa','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3213,7124,30124,'Zerome','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3214,7125,30125,'Belton','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3215,7126,30126,'Rath','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3216,7128,30128,'Atanas','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3217,7129,30129,'Mitraell','Hierarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3218,7130,30130,'Undrias','Abyssal Celebrant','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3219,7131,30131,'Newbie Helper','','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3220,7132,30132,'Cecktinon','Abyssal Celebrant','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3221,7133,30133,'Kartia','Abyssal Celebrant','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3222,7134,30134,'Jasmine','Gatekeeper','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3223,7135,30135,'Iria','Trader','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3224,7136,30136,'Payne','Trader','a_trader_MDarkElf','8.00','22.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3225,7137,30137,'Vollodos','Trader','a_trader_MDarkElf','8.00','22.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3226,7138,30138,'Minaless','Trader','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3227,7139,30139,'Dorankus','Warehouse Keeper','a_trader_MDarkElf','8.00','22.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3228,7140,30140,'Erviante','Warehouse Keeper','a_trader_MDarkElf','8.00','22.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3229,7141,30141,'Talloth','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3230,7143,30143,'Trudy','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3231,7144,30144,'Harne','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3232,7145,30145,'Vlasty','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3233,7146,30146,'Mirabel','Gatekeeper','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3234,7147,30147,'Unoren','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3235,7148,30148,'Ariel','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3236,7149,30149,'Creamees','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3237,7150,30150,'Herbiel','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3238,7151,30151,'Chad','Warehouse Freightman','a_trader_MElf','8.00','25.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3239,7152,30152,'Julia','Warehouse Keeper','a_common_people_FElf','8.00','25.50',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3240,7153,30153,'Markius','Warehouse Keeper','a_trader_MElf','8.00','25.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3241,7154,30154,'Asterios','Hierarch','a_patriarch_MElf','8.00','22.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3242,7155,30155,'Ellenia','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3243,7156,30156,'Cobendell','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3244,7157,30157,'Greenis','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3245,7158,30158,'Esrandell','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3246,7162,30162,'Karin','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3247,7163,30163,'Rex','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3248,7164,30164,'Ian','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3249,7165,30165,'Ralford','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3250,7166,30166,'Wesley','Magic Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3251,7169,30169,'Marty','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3252,7170,30170,'Radic','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3253,7171,30171,'Galios','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3254,7174,30174,'Arkenias','Grand Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3255,7175,30175,'Fairen','Grand Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3256,7176,30176,'Valleria','Grand Magister','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3257,7177,30177,'Valentina','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3258,7178,30178,'Zenkin','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3259,7179,30179,'Raudia','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3260,7180,30180,'Sara','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3261,7181,30181,'Galibredo','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3262,7182,30182,'Cliff','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3263,7183,30183,'Hagger','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3264,7184,30184,'Rigol','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3265,7185,30185,'Taniac Blackbird','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3266,7186,30186,'Bhan','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3267,7187,30187,'Klaus Blackbird','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3268,7188,30188,'Vadin','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3269,7189,30189,'Rovia','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3270,7190,30190,'Phanovia','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3271,7191,30191,'Hollint','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3272,7192,30192,'Darya','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3273,7194,30194,'Gideon','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3274,7195,30195,'Brecson','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3275,7196,30196,'Mouen','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3276,7197,30197,'Hector','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3277,7198,30198,'Jerin','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3278,7199,30199,'Yates','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(3279,7200,30200,'Stan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3280,7201,30201,'Pinaps','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3281,7207,30207,'Arodin','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3282,7208,30208,'Damion','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3283,7209,30209,'Colleen','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3284,7210,30210,'Norman','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3285,7216,30216,'Wheeler','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3286,7217,30217,'Berros','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3287,7218,30218,'Kendell','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3288,7219,30219,'Veltress','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3289,7220,30220,'Starden','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3290,7221,30221,'Rayen','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3291,7222,30222,'Alshupes','','a_common_people_MElf','6.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3292,7223,30223,'Arujien','','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3293,7224,30224,'Rayla','Sentry Knight','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,79,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3294,7230,30230,'Edroc','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3295,7231,30231,'Garette','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3296,7232,30232,'Sorint','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3297,7233,30233,'Esmeralda','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3298,7253,30253,'Simplon','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3299,7254,30254,'Harmony','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3300,7255,30255,'Haprock','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3301,7256,30256,'Bella','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3302,7283,30283,'Altran','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3303,7284,30284,'Alberius','Sentinel Knight','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,150,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3304,7285,30285,'Gartrandell','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3305,7288,30288,'Rains','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3306,7289,30289,'Raymond','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3307,7290,30290,'Xenos','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3308,7291,30291,'Alex','Captain','a_guard_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,68,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3309,7293,30293,'Manuel','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3310,7294,30294,'Varan','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3311,7297,30297,'Tobias','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3312,7298,30298,'Pinter','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3313,7300,30300,'Pushkin','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3314,7301,30301,'Hally','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3315,7305,30305,'Vellior','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3316,7307,30307,'Karrod','Blacksmith','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3317,7311,30311,'Sir Collin Windawood','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3318,7312,30312,'Rockswell','Lighthouse Keeper','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3319,7313,30313,'Asha','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3320,7314,30314,'Nestle','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3321,7315,30315,'Poesia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3322,7316,30316,'Raut','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3323,7317,30317,'Kluto','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3324,7320,30320,'Richlin','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3325,7321,30321,'Sydnia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3326,7322,30322,'Ballin','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3327,7325,30325,'Audiberti','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3328,7326,30326,'Leona','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3329,7327,30327,'Sorius','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3330,7328,30328,'Reisa','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3331,7329,30329,'Virgil','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3332,7330,30330,'Sidra','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3333,7331,30331,'Thoma','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3334,7332,30332,'Bathis','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3335,7333,30333,'Praga','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3336,7334,30334,'Babenco','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3337,7335,30335,'Brynn','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3338,7336,30336,'Curtis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3339,7337,30337,'Moretti','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3340,7338,30338,'Melville','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3341,7342,30342,'Varsak','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3342,7344,30344,'Rohmer','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3343,7345,30345,'Ramoniell','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3344,7346,30346,'Kayleen','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3345,7347,30347,'Marion','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3346,7348,30348,'Nelsya','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3347,7349,30349,'Jenna','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3348,7350,30350,'Carlon','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3349,7351,30351,'Astaron','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3350,7352,30352,'Karina','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3351,7353,30353,'Jughead','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3352,7354,30354,'Jewel','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3353,7355,30355,'Roselyn','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3354,7356,30356,'Altima','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3355,7357,30357,'Kristin','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3356,7358,30358,'Thifiell','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3357,7359,30359,'Kaitar','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3358,7360,30360,'Harant','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3359,7361,30361,'Rizraell','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3360,7362,30362,'Andellia','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3361,7363,30363,'Aios','Blacksmith','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3362,7368,30368,'Lilith','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3363,7369,30369,'Baenedes','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3364,7370,30370,'Nerupa','','aracne','15.00','26.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(3365,7371,30371,'Thalia','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3366,7373,30373,'Ramos','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3367,7374,30374,'Rhodiell','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3368,7375,30375,'Adonius','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3369,7376,30376,'Nell','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3370,7377,30377,'Talbot','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3371,7378,30378,'Estella','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3372,7379,30379,'Bezique','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,280,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3373,7380,30380,'Plink','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3374,7381,30381,'Alvah','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3375,7382,30382,'Leikan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3376,7383,30383,'Scott','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3377,7384,30384,'Linus','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3378,7385,30385,'Weisz','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3379,7386,30386,'Luis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3380,7387,30387,'Clancy','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3381,7391,30391,'Parina','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3382,7400,30400,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3383,7401,30401,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3384,7402,30402,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3385,7403,30403,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3386,7404,30404,'Newbie Helper','','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3387,7405,30405,'Marius','','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3388,7406,30406,'Matheo','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3389,7407,30407,'Mesella','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3390,7408,30408,'Lionel','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3391,7409,30409,'Earth Snake','','lesser_basilisk','34.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,35,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(3392,7410,30410,'Wasteland Lizardman','','virud_lizardman','10.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,43,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3393,7411,30411,'Flame Salamander','','salamander','16.00','6.80',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,96,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(3394,7412,30412,'Wind Sylph','','sylph','11.00','35.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,60,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(3395,7413,30413,'Water Undine','','undine','12.00','27.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,60,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3396,7414,30414,'Rosella','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3397,7415,30415,'Charkeren','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3398,7416,30416,'Triskel','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3399,7417,30417,'Sir Klaus Vasper','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3400,7418,30418,'Annika','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3401,7419,30419,'Arkenia','Witch','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3402,7420,30420,'Tyra','','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3403,7421,30421,'Varika','Witch','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3404,7422,30422,'Kalinta','Abyssal Celebrant','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3405,7423,30423,'Northwind','','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3406,7424,30424,'Allana','','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3407,7425,30425,'Neti','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3408,7426,30426,'Prias','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3409,7427,30427,'Siff','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3410,7428,30428,'Perrin','','a_casino_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3411,7429,30429,'Tiramisa','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3412,7430,30430,'Trionell','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3413,7431,30431,'Eriel','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3414,7432,30432,'Irene','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3415,7433,30433,'Kathaway','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3416,7434,30434,'Samed','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3417,7435,30435,'Leopold','','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3418,7436,30436,'Sarien','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3419,7437,30437,'Rolento','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3420,7452,30452,'Kurt','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3421,7458,30458,'Poitan','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3422,7459,30459,'Wandius','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3423,7460,30460,'Cardien','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3424,7461,30461,'Mirien','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3425,7462,30462,'Tronix','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3426,7463,30463,'Ixia','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3427,7464,30464,'Clayton','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3428,7465,30465,'Herven','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3429,7466,30466,'Bright','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3430,7469,30469,'Jonas','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3431,7471,30471,'Rupio','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3432,7472,30472,'Rosheria','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3433,7473,30473,'Bandellos','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3434,7474,30474,'Angus','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3435,7475,30475,'Stapin','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3436,7476,30476,'Kaira','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3437,7477,30477,'Sir Ortho Lancer','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3438,7478,30478,'Reikin','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3439,7483,30483,'Mozella','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3440,7484,30484,'Ponti','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3441,7485,30485,'Capella','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3442,7486,30486,'Hanna','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3443,7487,30487,'Penelope','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3444,7497,30497,'Edmond','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3445,7498,30498,'Moke','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3446,7499,30499,'Tapoy','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3447,7500,30500,'Osborn','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3448,7501,30501,'Kasman','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3449,7502,30502,'Umos','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3450,7503,30503,'Rikadio','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3451,7504,30504,'Mendio','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3452,7505,30505,'Drikus','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(3453,7506,30506,'Buka','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3454,7507,30507,'Racoy','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3455,7508,30508,'Castor','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3456,7509,30509,'Dowki','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3457,7510,30510,'Somak','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3458,7511,30511,'Gesto','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3459,7512,30512,'Kusto','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3460,7513,30513,'Penatus','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3461,7514,30514,'Vokian','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3462,7515,30515,'Manakia','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3463,7516,30516,'Reep','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3464,7517,30517,'Shari','Trader','e_traderA_FDwarf','8.00','19.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3465,7518,30518,'Garita','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3466,7519,30519,'Mion','Trader','e_traderA_FDwarf','8.00','19.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3467,7520,30520,'Reed','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3468,7521,30521,'Murdoc','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3469,7522,30522,'Airy','Warehouse Keeper','e_traderA_FDwarf','8.00','19.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3470,7523,30523,'Gouph','Collector','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3471,7524,30524,'Pippi','Collector','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3472,7525,30525,'Bronk','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3473,7526,30526,'Brunon','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3474,7527,30527,'Silvera','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3475,7528,30528,'Laferon','Foreman','e_guard_MDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3476,7529,30529,'Maron','Miner','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3477,7530,30530,'Newbie Helper','','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3478,7531,30531,'Lockirin','Iron Gate''s','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3479,7532,30532,'Spiron','Golden Wheel''s','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3480,7533,30533,'Balanki','Silver Scale''s','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3481,7534,30534,'Keef','Bronze Key''s','e_collector_master_MDwarf','8.00','18.40',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3482,7535,30535,'Filaur','Gray Pillar Member','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3483,7536,30536,'Arin','Black Anvil''s','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3484,7537,30537,'Daichir','Priest of the Earth','e_clergyman_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3485,7538,30538,'Zimenf','Priest of the Earth','e_clergyman_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3486,7539,30539,'Chichirin','Priestess of the Earth','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3487,7540,30540,'Wirphy','Gatekeeper','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3488,7541,30541,'Paion','Protector','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,282,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3489,7542,30542,'Runant','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3490,7543,30543,'Ethan','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3491,7544,30544,'Cromwell','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3492,7545,30545,'Proton','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3493,7546,30546,'Dinkey','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3494,7547,30547,'Tardyon','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3495,7548,30548,'Nathan','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3496,7549,30549,'Ghouliff Droopstone','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3497,7550,30550,'Gauri Twinklerock','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3498,7551,30551,'Tink Wandergold','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3499,7552,30552,'Kiril Sparkystone','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3500,7553,30553,'Maryse Redbonnet','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3501,7554,30554,'Bolter','Miner','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3502,7555,30555,'Torocco','Carrier','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3503,7556,30556,'Toma','Master','e_collector_master_MDwarf','8.00','18.40',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3504,7557,30557,'Torai','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3505,7558,30558,'Jakal','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3506,7559,30559,'Kunai','Trader','e_trader_FOrc','8.00','24.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3507,7560,30560,'Uska','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3508,7561,30561,'Papuma','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3509,7562,30562,'Grookin','Warehouse Keeper','e_trader_MOrc','8.00','23.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3510,7563,30563,'Imantu','Warehouse Freightman','e_trader_MOrc','8.00','23.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3511,7564,30564,'Sumari','Blacksmith','e_trader_MOrc','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3512,7565,30565,'Kakai','Flame Lord','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3513,7566,30566,'Varkees','Atuba Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3514,7567,30567,'Tantus','Neruga Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3515,7568,30568,'Hatos','Urutu Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3516,7569,30569,'Brukurse','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3517,7570,30570,'Karukia','Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3518,7571,30571,'Tanapi','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3519,7572,30572,'Livina','Seer','e_clergyman_FOrc','6.50','28.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3520,7573,30573,'Vulkus','Flame Guardian','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3521,7575,30575,'Newbie Helper','','e_clergyman_FOrc','6.50','28.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3522,7576,30576,'Tamil','Gatekeeper','e_teleporter_FOrc','8.00','32.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3523,7577,30577,'Rukain','Praetorian','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,279,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3524,7578,30578,'Nakusin','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3525,7579,30579,'Tamai','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3526,7580,30580,'Parugon','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3527,7581,30581,'Orinak','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3528,7582,30582,'Tiku','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3529,7583,30583,'Petukai','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3530,7584,30584,'Vapook','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3531,7585,30585,'Tataru Zu Hestui','','e_common_people_MOrc','8.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3532,7586,30586,'Anai Zu Neruga','','e_trader_FOrc','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3533,7587,30587,'Gantaki Zu Urutu','','e_common_people_MOrc','8.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3534,7588,30588,'Takia Zu Duda-Mara','','e_trader_FOrc','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3535,7589,30589,'Kazkin Zu Gandi','','e_trader_MOrc','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3536,7590,30590,'Rosheek','Khavatari','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3537,7591,30591,'Toruku','Khavatari','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3538,7592,30592,'Hestui Totem Spirit','','grizzly','21.00','40.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(3539,7593,30593,'Duda-Mara Totem Spirit','','giant_spider','26.00','26.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,72,130,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(3540,7594,30594,'Ranspo','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3541,7595,30595,'Opix','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3542,7596,30596,'Harkel','Partisan Doorman','ol_mahum','13.50','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3543,7597,30597,'Piotur','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3544,7598,30598,'Newbie Guide','','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3545,7599,30599,'Newbie Guide','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3546,7600,30600,'Newbie Guide','','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3547,7601,30601,'Newbie Guide','','e_guard_MDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3548,7602,30602,'Newbie Guide','','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3549,7608,30608,'Maria','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3550,7609,30609,'Creta','Astrologer','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3551,7610,30610,'Cronos','Elder','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3552,7611,30611,'Triff','Drunkard','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3553,7612,30612,'Casian','Elder','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3554,7613,30613,'Alders Spirit','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(3555,7614,30614,'Metheus','Brother','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3556,7615,30615,'Voltar','Breka Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,173,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(3557,7616,30616,'Kepra','Enku Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,162,0,0,45,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.76),
(3558,7617,30617,'Burai','Turek Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,172,0,0,45,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(3559,7618,30618,'Harak','Leunt Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,172,0,0,45,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3560,7619,30619,'Driko','Vuku Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,183,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(3561,7620,30620,'Emily','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3562,7621,30621,'Nikola','Maestro','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3563,7622,30622,'Box Of Titan','','coffer_b','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3564,7623,30623,'Kaien','Duelist','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3565,7624,30624,'Ascalon','Veteran','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,16,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3566,7625,30625,'Mason','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3567,7626,30626,'Hamil','Sagittarius','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3568,7627,30627,'Tree','','human_tree','35.00','90.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3569,7628,30628,'Strong Wooden Chest','','box','18.00','14.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3570,7629,30629,'Rukal','Bard','a_common_people_MElf','6.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3571,7630,30630,'Orim','Shadow','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3572,7631,30631,'Roderik','Warden','a_guard_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3573,7632,30632,'Endrigo','Warden','a_guard_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3574,7633,30633,'Evert','Fisher','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3575,7634,30634,'Galatea','High Summoner','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3576,7635,30635,'Almors','Summoner','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3577,7636,30636,'Camoniell','Summoner','a_trader_FElf','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3578,7637,30637,'Belthus','Summoner','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3579,7638,30638,'Basilla','Summoner','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3580,7639,30639,'Celestiel','Summoner','a_patriarch_MElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3581,7640,30640,'Brynthea','Summoner','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3582,7641,30641,'Takuna','Duda-Mara Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3583,7642,30642,'Chianta','Gandi Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3584,7643,30643,'First Orc','','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3585,7644,30644,'Kash','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3586,7645,30645,'Martien','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3587,7646,30646,'Raldo','Champion','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3588,7647,30647,'Chest Of Shyslassys','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3589,7648,30648,'Santiago','Hermit','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3590,7649,30649,'Ancestor Martankus','','orc_head','110.00','103.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3591,7650,30650,'Gerald','Priest of the Earth','e_traderA_FDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3592,7651,30651,'Dorf','Wanderer','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3593,7652,30652,'Uruha','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3594,7653,30653,'Sir Aron Tanford','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3595,7654,30654,'Sir Kiel Nighthawk','','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3596,7655,30655,'Isael Silvershadow','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3597,7656,30656,'Spirit Of Sir Talianus','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(3598,7657,30657,'Seresin','Cardinal','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3599,7658,30658,'Gupu','Father','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3600,7659,30659,'Orphan Girl','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3601,7660,30660,'Windy Shaoring','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3602,7661,30661,'Mysterious Dark Elf','','a_casino_FDarkElf','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3603,7662,30662,'Piper Longbow','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3604,7663,30663,'Slein Shining Blade','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,69,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3605,7664,30664,'Kein Flying Knife','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,217,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3606,7665,30665,'Kristina','Saint','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3607,7666,30666,'Sla','Preacher','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3608,7667,30667,'Ramus','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3609,7668,30668,'Katari','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3610,7669,30669,'Kakan','','e_trader_FOrc','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3611,7670,30670,'Nyakuri','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3612,7671,30671,'Croto','Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3613,7672,30672,'Dubabah','Jailer','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3614,7673,30673,'Lorain','Researcher','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3615,7674,30674,'Daurin Hammercrush','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3616,7675,30675,'Corpse Of Kamur','','e_trader_Morc_death','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3617,7676,30676,'Croop','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3618,7677,30677,'Flutter','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3619,7678,30678,'Helton','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3620,7679,30679,'Roameria','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3621,7680,30680,'Egnos','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3622,7681,30681,'Karia','High Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3623,7682,30682,'Pekiron','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3624,7683,30683,'Daunt','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3625,7684,30684,'Viktor','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3626,7685,30685,'Baxt','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3627,7686,30686,'Silva','Warehouse Freightman','e_traderA_FDwarf','8.00','19.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(3628,7687,30687,'Vergara','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3629,7688,30688,'Duning','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3630,7689,30689,'Siria','Grand Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3631,7690,30690,'Luther','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3632,7691,30691,'Aren Athebalt','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3633,7692,30692,'Stedmiel','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3634,7693,30693,'Queenien','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3635,7694,30694,'Scraide','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3636,7695,30695,'Moses','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3637,7696,30696,'Page','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3638,7697,30697,'Videlrien','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3639,7698,30698,'Evelyn','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3640,7699,30699,'Medown','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3641,7700,30700,'Prestan','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3642,7701,30701,'Errickin','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3643,7702,30702,'Bernard','Guild President','a_casino_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3644,7703,30703,'Colin','Guild President','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3645,7704,30704,'Garvarentz','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3646,7705,30705,'Chakiris','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3647,7706,30706,'Lazenby','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3648,7707,30707,'Raigen','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3649,7708,30708,'Nasign','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3650,7709,30709,'Norton','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3651,7710,30710,'Weston','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3652,7711,30711,'Byron','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3653,7712,30712,'Makhis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3654,7713,30713,'Gardner','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3655,7714,30714,'Paros','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3656,7715,30715,'Marina','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3657,7716,30716,'Cecile','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3658,7717,30717,'Gauen','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3659,7718,30718,'Joan','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3660,7719,30719,'Mariell','Gatekeeper','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3661,7720,30720,'Kaiena','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3662,7721,30721,'Ladd','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3663,7722,30722,'Merian','Gatekeeper','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3664,7723,30723,'Roy','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3665,7724,30724,'Tavillian','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3666,7725,30725,'Yening','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3667,7726,30726,'Tebose','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3668,7727,30727,'Verona','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3669,7728,30728,'Leirynn','Militiaman','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,93,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3670,7729,30729,'Borys','Drunkard','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3671,7730,30730,'Jax','Bodyguard','a_guard_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,232,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3672,7731,30731,'Martin','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3673,7732,30732,'Ol Mahum Pilgrim','','ol_mahum','13.50','25.00',36,'male','L2Folk','npc',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,1,0,0,50,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3674,7733,30733,'Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3675,7734,30734,'Supply Box On Wharf','','box','18.00','14.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3676,7735,30735,'Sophya','Mercenary Captain','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3677,7736,30736,'Redfoot','Mercenary','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3678,7737,30737,'Morgan','Guildsman','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3679,7738,30738,'Matild','Alchemist','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3680,7739,30739,'Keltir','Royal Servant','fox','9.50','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,23,110,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(3681,7740,30740,'Toad','Royal Servant','poison_toad','20.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,100,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3682,7741,30741,'Rabbit','Royal Servant','rabbit','5.00','4.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,80,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3683,7742,30742,'Rupina','Fairy of Love','pixy','5.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(3684,7743,30743,'Wisdom Chest','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3685,7744,30744,'Grey','Guild Member','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3686,7745,30745,'Tor','Guild Member','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3687,7746,30746,'Cybellin','','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3688,7747,30747,'Mimyu','Fairy','pixy','5.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(3689,7748,30748,'Exarion','Drake','drake','30.00','100.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(3690,7749,30749,'Zwov','Drake','drake','30.00','100.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(3691,7750,30750,'Kalibran','Drake','drake','30.00','100.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.84),
(3692,7751,30751,'Suzet','Wyrm','wyrm','29.00','72.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(3693,7752,30752,'Shamhai','Wyrm','wyrm','29.00','72.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.19),
(3694,7753,30753,'Gabrielle','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3695,7754,30754,'Gilmore','Antharas Watchman','skeleton_knight','10.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,150,0,0,40,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(3696,7755,30755,'Theodric','Antharas Watchman','skeleton_knight','10.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,127,0,0,40,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(3697,7756,30756,'Sir Kristof Rodemai','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3698,7757,30757,'Statue Of Offering','','castle_kent_statue_jewel','25.00','98.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3699,7758,30758,'Athrea','Witch','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3700,7759,30759,'Kalis','Witch','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3701,7760,30760,'Sir Gustav Athebaldt','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3702,7761,30761,'Corpse Of Fritz','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3703,7762,30762,'Corpse Of Lutz','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3704,7763,30763,'Corpse Of Kurtz','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3705,7764,30764,'Balthazar','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3706,7765,30765,'Imperial Coffer','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3707,7766,30766,'Cleo','Witch','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3708,7767,30767,'Auctioneer','','a_maidB_FHuman','8.00','22.50',70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3709,7768,30768,'Auctioneer','','a_trader_FElf','8.00','24.00',70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3710,7769,30769,'Auctioneer','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3711,7770,30770,'Auctioneer','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3712,7771,30771,'Auctioneer','','e_trader_FOrc','8.00','24.00',70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3713,7772,30772,'Wilson','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3714,7773,30773,'Todd','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3715,7827,30827,'Lundy','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3716,7828,30828,'Waters','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3717,7829,30829,'Cooper','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3718,7830,30830,'Joey','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3719,7831,30831,'Nelson','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3720,7832,30832,'Hardin','','a_hardin_MHuman','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3721,7833,30833,'Kaspar','Magister','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3722,7834,30834,'Cema','Magic Trader','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3723,7835,30835,'Icarus','Lich King','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,212,0,0,70,15,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(3724,7836,30836,'Minerva','Gatekeeper','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3725,7837,30837,'Woodrow','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3726,7838,30838,'Woodley','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3727,7839,30839,'Holly','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3728,7840,30840,'Lorenzo','Trader','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3729,7841,30841,'Carson','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3730,7842,30842,'Alexis','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3731,7843,30843,'Romp','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3732,7844,30844,'Walderal','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3733,7845,30845,'Klump','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3734,7846,30846,'Wilbert','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3735,7847,30847,'Ferris','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3736,7848,30848,'Elisa','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3737,7849,30849,'Sedrick','Grand Master','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3738,7850,30850,'Aiken','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3739,7851,30851,'Kendra','Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3740,7852,30852,'Sinden','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3741,7853,30853,'Raien','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3742,7854,30854,'Drikiyan','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3743,7855,30855,'Desmond','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3744,7856,30856,'Winonin','Magister','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3745,7857,30857,'Orven','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3746,7858,30858,'Ross','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3747,7859,30859,'Vivyan','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3748,7860,30860,'Flownia','Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3749,7861,30861,'Leonard','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3750,7862,30862,'Oltlin','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3751,7863,30863,'Ghest','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3752,7864,30864,'Hanellin','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3753,7865,30865,'Ladanza','High Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3754,7866,30866,'Marestella','Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3755,7867,30867,'Reva','Seer','e_trader_MOrc','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3756,7868,30868,'Sir Eric Rodemai','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3757,7869,30869,'Lemper','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3758,7870,30870,'Kurtiz','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3759,7871,30871,'Bret','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3760,7872,30872,'Conroy','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3761,7873,30873,'Coleman','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3762,7874,30874,'Aldis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3763,7875,30875,'Carlton','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3764,7876,30876,'Eastan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3765,7877,30877,'Grayson','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3766,7878,30878,'Angelina','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3767,7879,30879,'Felton','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3768,7880,30880,'Viktor Van Dake','Border Outpost Captain','a_royal_guardA_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3769,7881,30881,'Sanders','Border Outpost Aide','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3770,7882,30882,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3771,7883,30883,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3772,7884,30884,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3773,7885,30885,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3774,7886,30886,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3775,7887,30887,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3776,7888,30888,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3777,7889,30889,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3778,7890,30890,'Espen','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3779,7891,30891,'Verona','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3780,7892,30892,'Enverun','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3781,7893,30893,'Payel','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3782,7894,30894,'Natools','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3783,7895,30895,'Kluck','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3784,7896,30896,'Mia','Warehouse Keeper','e_traderA_FDwarf','8.00','19.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3785,7897,30897,'Roman','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3786,7898,30898,'Morning','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3787,7899,30899,'Flauen','Gatekeeper','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3788,7900,30900,'Marcus','Grand Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3789,7901,30901,'Arti','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3790,7902,30902,'Karuna','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3791,7903,30903,'Traus','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3792,7904,30904,'Naiel','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3793,7905,30905,'Squillari','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3794,7906,30906,'Ranton','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3795,7907,30907,'Minevia','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3796,7908,30908,'Tanios','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3797,7909,30909,'Anabel','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3798,7910,30910,'Xairakin','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3799,7911,30911,'Brikus','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3800,7912,30912,'Xenovia','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(3801,7913,30913,'Tushku','High Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3802,7914,30914,'Sorbo','Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3803,7915,30915,'Takina','Seer','e_mageguild_teacher_FOrc','8.00','28.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3804,7916,30916,'Gosta','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3805,7917,30917,'Dupuis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3806,7918,30918,'Kent','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3807,7919,30919,'Rodic','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3808,7920,30920,'Kraisen','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3809,7921,30921,'Timos','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3810,7922,30922,'Cage','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3811,7923,30923,'Dunst','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3812,7924,30924,'Nedy','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3813,7925,30925,'Morelyn','High Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3814,7926,30926,'Restina','Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3815,7927,30927,'Alicia','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3816,7928,30928,'Fenster','Mercenary','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3817,7929,30929,'Patrin','Antique Dealer','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3818,7930,30930,'Rogent','Antique Appraiser','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3819,7931,30931,'Bentley','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3820,7932,30932,'Benica','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3821,7933,30933,'Braki','','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3822,7934,30934,'Marsha','Collector','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3823,7935,30935,'Trumpin','Collector','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3824,7936,30936,'Malcom1','Frog Prince','poison_toad','20.00','10.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3825,7937,30937,'Malcom2','Wild Boar Prince','giant_wild_hog','25.00','27.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,35,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(3826,7938,30938,'Malcom3','Orc Prince','ketra_orc','12.00','29.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,45,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.46),
(3827,7939,30939,'Malcom4','Prince of Darkness','skeleton_royal_guard','11.00','28.50',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(3828,7940,30940,'Malcom5','Gremlin Prince','gremlin','10.00','15.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,20,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(3829,7941,30941,'Malcom6','Prince of Wild Beast','saber_toothed_tiger','34.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(3830,7942,30942,'Malcom7','Monster Eye Prince','monster_eye','21.00','43.00',70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(3831,7943,30943,'Malcom8','Rabbit Prince','rabbit','5.00','4.50',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3832,7944,30944,'Malcom9','Human Prince','a_casino_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3833,7945,30945,'Malcom10','Prince','e_collector_master_MDwarf','8.00','18.40',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3834,7946,30946,'Lucianne Tanford','','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3835,7947,30947,'Rerikya','','e_trader_FOrc','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3836,7948,30948,'Meridien','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3837,7949,30949,'Keplon','Researcher','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3838,7950,30950,'Euclie','Researcher','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3839,7951,30951,'Pithgon','Researcher','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3840,7952,30952,'Dimensional Vortex 1','','broadcasting_tower','13.00','54.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3841,7953,30953,'Dimensional Vortex 2','','broadcasting_tower','13.00','54.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3842,7954,30954,'Dimensional Vortex 3','','broadcasting_tower','13.00','54.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3843,7955,30955,'Gillian''s Revenant','','zombie','13.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,15,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.43),
(3844,7956,30956,'Nanarin','Musician','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,325,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3845,7957,30957,'Swan','Bard','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3846,7958,30958,'Galion','','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3847,7959,30959,'Barbado','Musician','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5133,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3848,7960,30960,'Beer Chest','','box','18.00','14.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3849,7961,30961,'Cloth Chest','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3850,7962,30962,'Statue of Water','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3851,7963,30963,'Statue of Fire','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3852,7964,30964,'Statue of Wind','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3853,7965,30965,'Statue of Earth','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3854,7966,30966,'Statue of Darkness','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3855,7967,30967,'Statue of Light','','coffer_d','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3856,7968,30968,'Jennifer','Lady Orc','e_trader_FOrc','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3857,7969,30969,'Iason Heine','','a_chamberlain_MHuman','9.50','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3858,7970,30970,'Dorothy','Locksmith','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3859,7971,30971,'Orpheus','Mad Doctor','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3860,7972,30972,'Orpheus Resurrecter','','susceptor','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(3861,7973,30973,'Medium Jar','','pot','10.00','15.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3862,7974,30974,'Oliver','Resurrected Adventurer','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3863,7975,30975,'Clarine','Resurrected Adventurer','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3864,7976,30976,'Resurrected Town Maiden','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3865,7977,30977,'Holy Ark of Secrecy1','','coffer_a','12.00','9.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3866,7978,30978,'Holy Ark of Secrecy2','','coffer_b','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3867,7979,30979,'Holy Ark of Secrecy3','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3868,7980,30980,'Ark Guardian''s Corpse','','angel_death','25.00','36.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(3869,7981,30981,'Black Judge','','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3870,7982,30982,'Sleeping Ant Larva1','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3871,7983,30983,'Sleeping Ant Larva2','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3872,7984,30984,'Sleeping Ant Larva3','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3873,7985,30985,'Sleeping Ant Larva4','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3874,7986,30986,'Sleeping Ant Larva5','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3875,7987,30987,'Sleeping Ant Larva6','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3876,7988,30988,'Verce','Leathersmith','a_patriarch_MElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3877,7989,30989,'Chest of Bifrons','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3878,7990,30990,'Lottery Ticket Seller','','a_casino_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3879,7991,30991,'Lottery Ticket Seller','','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3880,7992,30992,'Lottery Ticket Seller','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3881,7993,30993,'Lottery Ticket Seller','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3882,7994,30994,'Lottery Ticket Seller','','e_trader_MOrc','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3883,7995,30995,'Race Manager','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3884,8001,31001,'Claudia Athebalt','','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3885,8002,31002,'Reorin','Maestro','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3886,8003,31003,'Here I Come','','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(3887,8004,31004,'Half Moon Love','','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(3888,8005,31005,'Everlasting','','mechanic_golem','5.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(3889,8006,31006,'Dark Side of the Moon','','silhouette','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(3890,8007,31007,'Wind Rider','','unicorn_boxer','11.00','18.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(3891,8008,31008,'Shooting Star','','unicorn_mirage','13.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(3892,8009,31009,'Cyclone Thunder','','dark_fencer','7.00','13.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,25,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(3893,8010,31010,'Hungry Baby','','hatchling','9.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.27),
(3894,8011,31011,'Salty Dog','','pet_wolf','13.00','11.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(3895,8012,31012,'Raging Revolution','','silver_cat','7.00','15.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(3896,8013,31013,'Valentine Blue','','blue_eye','11.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(3897,8014,31014,'Light My Fire','','big_boom','6.00','13.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3898,8015,31015,'Red Bullet','','fox','9.50','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,23,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(3899,8016,31016,'Shining Silver','','rabbit','5.00','4.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3900,8017,31017,'Over the top','','ant_larva','12.00','8.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(3901,8018,31018,'Royal Straight','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(3902,8019,31019,'All Seven','','wererat','14.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(3903,8020,31020,'Nasty Green','','dryad','9.00','20.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(3904,8021,31021,'Shortcut','','goblin','10.00','16.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.32),
(3905,8022,31022,'Typhoon Tiger','','giant_bee','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(3906,8023,31023,'Red Hot','','salamander','16.00','6.80',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.20),
(3907,8024,31024,'Galaxy Express','','onyx_beast','14.00','14.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.24),
(3908,8025,31025,'Best Condition','','manadragora','14.00','17.80',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(3909,8026,31026,'Albatross','','orc','10.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,45,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(3910,8027,31027,'Coffer of the Dead','','coffer_b','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3911,8028,31028,'Chest of Kernon','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3912,8029,31029,'Chest of Golkonda','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3913,8030,31030,'Chest of Hallate','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3914,8031,31031,'Broadcasting Tower','','broadcasting_tower','13.00','54.00',70,'etc','L2Observation','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3915,8032,31032,'Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3916,8033,31033,'Sentinel','','a_guard_MElf','8.00','23.50',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3917,8034,31034,'Sentry','','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3918,8035,31035,'Defender','','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3919,8036,31036,'Centurion','','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(3920,8042,31042,'Kantabilon','Melody Maestro','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3921,8043,31043,'Octavia','Melody Maestro','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3922,8044,31044,'Galman','Valley Trader','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3923,8045,31045,'Kitzka','Valley Trader','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3924,8046,31046,'Marsden','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3925,8047,31047,'Kell','Symbol Maker','a_mageguild_teacher_FHuman','8.00','23.50',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3926,8048,31048,'McDermott','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3927,8049,31049,'Pepper','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3928,8050,31050,'Thora','Symbol Maker','a_mageguild_teacher_FHuman','8.00','23.50',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3929,8051,31051,'Keach','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3930,8052,31052,'Heid','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3931,8053,31053,'Kidder','Symbol Maker','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3932,8067,31067,'Rood','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3933,8074,31074,'Corpse of Hutaku','','e_trader_Morc_death','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3934,8075,31075,'Sales Cat of Ivory Tower','','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(3935,8076,31076,'Newbie Guide','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3936,8077,31077,'Newbie Guide','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3937,8078,31078,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3938,8079,31079,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3939,8080,31080,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3940,8081,31081,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3941,8082,31082,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3942,8083,31083,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3943,8084,31084,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3944,8085,31085,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3945,8086,31086,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3946,8087,31087,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3947,8088,31088,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3948,8089,31089,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3949,8090,31090,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3950,8091,31091,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3951,8092,31092,'Black Marketeer of Mammon','','black_market_trader_MDwarf','8.00','18.00',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3952,8093,31093,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(3953,8094,31094,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(3954,8095,31095,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3955,8096,31096,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3956,8097,31097,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3957,8098,31098,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3958,8099,31099,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3959,8100,31100,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3960,8101,31101,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3961,8102,31102,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3962,8103,31103,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3963,8104,31104,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3964,8105,31105,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3965,8106,31106,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3966,8107,31107,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3967,8108,31108,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3968,8109,31109,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3969,8110,31110,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3970,8111,31111,'Gatekeeper Spirit','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3971,8112,31112,'Gatekeeper Spirit','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3972,8113,31113,'Merchant of Mammon','','black_market_trader_MDwarf_set','22.00','18.00',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3973,8114,31114,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3974,8115,31115,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3975,8116,31116,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(3976,8117,31117,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3977,8118,31118,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3978,8119,31119,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3979,8120,31120,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3980,8121,31121,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3981,8122,31122,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3982,8123,31123,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3983,8124,31124,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3984,8125,31125,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3985,8126,31126,'Blacksmith of Mammon','','e_smith_master_MDwarf','8.00','17.00',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3986,8127,31127,'Festival Guide','Level 31 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3987,8128,31128,'Festival Guide','Level 42 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3988,8129,31129,'Festival Guide','Level 53 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3989,8130,31130,'Festival Guide','Level 64 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3990,8131,31131,'Festival Guide','No Level Limit','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3991,8132,31132,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3992,8133,31133,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3993,8134,31134,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3994,8135,31135,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3995,8136,31136,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(3996,8137,31137,'Festival Guide','Level 31 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3997,8138,31138,'Festival Guide','Level 42 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3998,8139,31139,'Festival Guide','Level 53 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(3999,8140,31140,'Festival Guide','Level 64 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4000,8141,31141,'Festival Guide','No Level Limit','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4001,8142,31142,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4002,8143,31143,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3889,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4003,8144,31144,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4004,8145,31145,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4005,8146,31146,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4006,8147,31147,'Sobling','Head Researcher','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4007,8148,31148,'Pirate''s Chest','','coffer_c','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4008,8149,31149,'Alchemist''s Mixing Urn','','pot','10.00','15.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4009,8168,31168,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4010,8169,31169,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4011,8170,31170,'Crest of Dawn','','flag_ssq','0.01','0.01',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4012,8171,31171,'Crest of Dusk','','flag_ssq','0.01','0.01',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4013,8172,31172,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4014,8173,31173,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4015,8174,31174,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4016,8175,31175,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4017,8176,31176,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4018,8177,31177,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4019,8178,31178,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4020,8179,31179,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4021,8180,31180,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4022,8181,31181,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4023,8182,31182,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4024,8183,31183,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4025,8184,31184,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4026,8185,31185,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4027,8186,31186,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4028,8187,31187,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4029,8188,31188,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4030,8189,31189,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4031,8190,31190,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4032,8191,31191,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4033,8192,31192,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4034,8193,31193,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4035,8194,31194,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4036,8195,31195,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4037,8196,31196,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4038,8197,31197,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4039,8198,31198,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4040,8199,31199,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4041,8200,31200,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4042,8201,31201,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4043,8202,31202,'Maximus','','pet_wolf','13.00','11.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4044,8203,31203,'Moon Dancer','','pet_wolf','13.00','11.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4045,8204,31204,'Georgio','','pet_wolf','13.00','11.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4046,8205,31205,'Katz','','hatchling','9.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.27),
(4047,8206,31206,'Ten Ten','','hatchling','9.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.27),
(4048,8207,31207,'Sardinia','','hatchling','9.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.27),
(4049,8208,31208,'La Grange','','hatchling','9.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.27),
(4050,8209,31209,'Misty Rain','','pet_wolf','13.00','11.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4051,8210,31210,'Race Track Gatekeeper','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4052,8211,31211,'Race Track Guide','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4053,8212,31212,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4054,8213,31213,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4055,8214,31214,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4056,8215,31215,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4057,8216,31216,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4058,8217,31217,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4059,8218,31218,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4060,8219,31219,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4061,8220,31220,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4062,8221,31221,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4063,8222,31222,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4064,8223,31223,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4065,8224,31224,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4066,8225,31225,'Arena Manager','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4067,8226,31226,'Arena Director','','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4068,8227,31227,'Sprockets the Cat','Event Manager','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4069,8228,31228,'Roy the Cat','Event Manager','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4070,8229,31229,'Winnie the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4071,8230,31230,'Louie the Cat','Event Manager','silver_cat','7.00','15.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4072,8231,31231,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4073,8232,31232,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4074,8233,31233,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4075,8234,31234,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4076,8235,31235,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4077,8236,31236,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4078,8237,31237,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4079,8238,31238,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4080,8239,31239,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4081,8240,31240,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4082,8241,31241,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4083,8242,31242,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4084,8243,31243,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4085,8244,31244,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4086,8245,31245,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4087,8246,31246,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4088,8247,31247,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4089,8248,31248,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4090,8249,31249,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4091,8250,31250,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4092,8251,31251,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4093,8252,31252,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4094,8253,31253,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4095,8254,31254,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4096,8255,31255,'Sprockets the Cat','Event Manager','cat_the_cat','9.00','16.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4097,8256,31256,'Leon','Trader','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4098,8257,31257,'Veronica','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4099,8258,31258,'Helmut','Trader','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4100,8259,31259,'Janne','Trader','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4101,8260,31260,'Judith','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4102,8261,31261,'Renee','Trader','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4103,8262,31262,'Rupert','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4104,8263,31263,'Liesel','Trader','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4105,8264,31264,'Olsun','Symbol Maker','a_traderC_Mhuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4106,8265,31265,'Annette','Pet Manager','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4107,8266,31266,'Kaiser','','youth_tiger','16.00','17.20',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.45),
(4108,8267,31267,'Lietta','Warehouse Keeper','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4109,8268,31268,'Hakon','Warehouse Keeper','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4110,8269,31269,'Mona','Warehouse Chief','e_traderB_FDwarf','6.00','18.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4111,8270,31270,'Stefano','Warehouse Freightman','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4112,8271,31271,'Hilda','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,87,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4113,8272,31272,'Noel','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4114,8273,31273,'Borodin','Blueprint Seller','e_mine_teacher_MDwarf','8.00','18.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4115,8274,31274,'Fundin','Mineral Trader','a_smith_MDwarf','7.00','16.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4116,8275,31275,'Tatiana','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4117,8276,31276,'Bernhard','Grand Master','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4118,8277,31277,'Felix','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,125,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4119,8278,31278,'Bronwyn','Master','a_fighterguild_teacher_MElf','7.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4120,8279,31279,'Gregory','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4121,8280,31280,'Bastian','Priest','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4122,8281,31281,'Cerenas','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4123,8282,31282,'Justin','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4124,8283,31283,'Alminas','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4125,8284,31284,'Elena','Spellbook Seller','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4126,8285,31285,'Samael','Grand Master','a_patriarch_MDarkElf','6.00','23.80',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4127,8286,31286,'Drakon','Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,143,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4128,8287,31287,'Kamilen','Magister','a_casino_FDarkElf','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,204,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4129,8288,31288,'Aklan','High Prefect','e_patriarch_MOrc','8.00','26.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4130,8289,31289,'Lakan','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4131,8290,31290,'Skahi','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4132,8291,31291,'Terava','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4133,8292,31292,'Andrei','Captain','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4134,8293,31293,'Gunter','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4135,8294,31294,'Sven','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4136,8295,31295,'Henrik','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4137,8296,31296,'Cadmon','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4138,8297,31297,'Bayard','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4139,8298,31298,'Ulrich','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4140,8299,31299,'Eugen','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4141,8300,31300,'Drumond','Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4142,8301,31301,'Nils','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4143,8302,31302,'Vladimir','Trader','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4144,8303,31303,'Alisha','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4145,8304,31304,'Astrid','Trader','a_traderC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4146,8305,31305,'Candice','Trader','e_traderA_FDwarf','8.00','19.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4147,8306,31306,'Natasha','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4148,8307,31307,'Weber','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4149,8308,31308,'Achim','Symbol Maker','a_traderC_Mhuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(4150,8309,31309,'Woods','Pet Manager','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4151,8310,31310,'Rafael','','strider','23.00','31.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.25),
(4152,8311,31311,'Hugin','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4153,8312,31312,'Durin','Warehouse Keeper','a_traderA_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4154,8313,31313,'Lunin','Warehouse Keeper','e_traderB_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4155,8314,31314,'Donal','Warehouse Chief','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4156,8315,31315,'Daisy','Warehouse Freightman','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4157,8316,31316,'Vincenz','Blacksmith','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4158,8317,31317,'Lombert','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4159,8318,31318,'Greta','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4160,8319,31319,'Hans','Mineral Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4161,8320,31320,'Ilyana','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4162,8321,31321,'Siegmund','Grand Master','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4163,8322,31322,'Erian','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,125,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4164,8323,31323,'Beryl','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4165,8324,31324,'Andromeda','Grand Master','a_casino_FDarkElf','8.00','23.00',70,'female','L2WeddingManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,316,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4166,8325,31325,'Themis','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,227,627,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4167,8326,31326,'Lambac','High Prefect','e_patriarch_MOrc','8.00','26.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4168,8327,31327,'Tazki','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4169,8328,31328,'Innocentin','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4170,8329,31329,'Eliyah','Priest','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4171,8330,31330,'Wagner','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4172,8331,31331,'Valdis','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4173,8332,31332,'Amelia','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4174,8333,31333,'Rumiel','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4175,8334,31334,'Tifaren','Grand Magister','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4176,8335,31335,'Kayan','Magister','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,317,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4177,8336,31336,'Rahorakti','Grand Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4178,8337,31337,'Mekara','Seer','e_mageguild_teacher_FOrc','8.00','28.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4179,8338,31338,'Anton','Spellbook Seller','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4180,8339,31339,'Hakran','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4181,8340,31340,'Mathias','Captain','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4182,8341,31341,'Richtor','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4183,8342,31342,'Dimitri','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4184,8343,31343,'Bellard','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4185,8344,31344,'Schmidt','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4186,8345,31345,'Ian','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4187,8346,31346,'Sirius','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4188,8347,31347,'Burke','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4189,8348,31348,'Agripel','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4190,8349,31349,'Benedict','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4191,8350,31350,'Dominic','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4192,8351,31351,'Volker','Wharf Manager','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4193,8356,31356,'Remy','Porter','a_traderB_MHuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4194,8357,31357,'Leandro','Secretary','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4195,8358,31358,'Kasiel','Bard','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4196,8359,31359,'Jaradine','Mother Tree Guardian','a_patriarch_MElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4197,8360,31360,'Alhena','Tetrarch Agent','a_casino_FDarkElf','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,315,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4198,8361,31361,'Kreed','Tetrarch Executioner','a_trader_MDarkElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4199,8362,31362,'Tate','Carrier','a_traderA_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4200,8363,31363,'Rogin','Deliveryman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4201,8364,31364,'Rokar','Guardian of Flame','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,203,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4202,8365,31365,'Yakand','Guardian of Flame','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,203,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4203,8366,31366,'Feed Seller','','a_traderD_Mhuman','7.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4204,8367,31367,'Voice of Glory','','kel_mahum_witch_doctor','13.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.28),
(4205,8368,31368,'Mikellan','Monk of Silence','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4206,8369,31369,'Mennon','Monk of Silence','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4207,8370,31370,'Kadun Zu Ketra','Hierarch','ketra_orc_chieftain','11.00','38.50',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6719,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.51),
(4208,8371,31371,'Wahkan','Ketra''s Messenger','ketra_orc','12.00','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,45,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.46),
(4209,8372,31372,'Asefa','Soul Guide','ketra_orc_shaman','10.00','23.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,10,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4210,8373,31373,'Atan','Grocer','ketra_orc_warrior','12.00','24.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(4211,8374,31374,'Jaff','Warehouse Keeper','ketra_orc_warrior','12.00','24.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(4212,8375,31375,'Jumara','Trader','ketra_orc_warrior','12.00','24.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(4213,8376,31376,'Kurfa','Gatekeeper','ketra_orc_shaman','10.00','23.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,10,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4214,8377,31377,'Ashas Varka Durai','Hierarch','barka_silenos_chieftain','18.00','42.50',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,139,0,0,25,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4215,8378,31378,'Naran Ashanuk','Varka''s Messenger','barka_silenos_warrior','16.00','41.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,173,0,0,34,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4216,8379,31379,'Udan Mardui','Soul Guide','barka_silenos_shaman','14.00','39.50',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(4217,8380,31380,'Diyabu','Grocer','barka_silenos_hunter','16.00','38.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,44,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4218,8381,31381,'Hagos','Warehouse Keeper','barka_silenos_warrior','16.00','41.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,34,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4219,8382,31382,'Shikon','Trader','barka_silenos_hunter','16.00','38.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,44,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4220,8383,31383,'Teranu Mardui','Gatekeeper','barka_silenos_shaman','14.00','39.50',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(4221,8384,31384,'Gatekeeper of Fire Dragon','','skeleton_knight','10.00','25.00',70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(4222,8385,31385,'Heart of Volcano','','heart_of_warding','17.00','75.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4223,8386,31386,'Violet','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4224,8387,31387,'Kurstin','','a_traderB_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4225,8388,31388,'Mina','','a_traderB_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4226,8389,31389,'Dorian','','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,297,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4227,8390,31390,'Dummy - Boy A','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4228,8391,31391,'Dummy  - Boy B','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4229,8392,31392,'Dummy  - Boy C','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4230,8393,31393,'Dummy - Boy D','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4231,8394,31394,'Dummy - Boy E','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4232,8395,31395,'Dummy - Lady F','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4233,8396,31396,'Dummy - Lady G','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4234,8397,31397,'Dummy - Lady H','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4235,8398,31398,'Dummy - Lady I','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4236,8399,31399,'Dummy - Lady J','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4237,8400,31400,'Dummy - Sword Guard','Ch4 Test','a_guard_MHuman','8.00','24.00',80,'male','L2Folk','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4238,8401,31401,'Dummy - Bow Guard','Ch4 Test','a_guard_MHuman','8.00','24.00',80,'female','L2Folk','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,14,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4239,8404,31404,'Monster Race Guide','Town of Gludio','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4240,8405,31405,'Monster Race Guide','Town of Dion','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4241,8406,31406,'Monster Race Guide','Town of Giran','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4242,8407,31407,'Monster Race Guide','Heine','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4243,8408,31408,'Monster Race Guide','Town of Oren','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4244,8409,31409,'Monster Race Guide','Hunters Village','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4245,8410,31410,'Monster Race Guide','Town of Aden','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4246,8411,31411,'Monster Race Guide','Town of Goddard','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4247,8412,31412,'Monster Race Guide','Rune Township','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4248,8413,31413,'Antonio','Spellbook Seller','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4249,8414,31414,'Lynn','Spellbook Seller','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4250,8415,31415,'Triya','Spellbook Seller','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4251,8416,31416,'Aren','Spellbook Seller','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4252,8417,31417,'Berynel','Spellbook Seller','a_common_people_MElf','6.00','21.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4253,8418,31418,'Rouke','Spellbook Seller','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4254,8419,31419,'Lorel','Spellbook Seller','a_common_people_MElf','6.00','21.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4255,8420,31420,'Tomanel','Spellbook Seller','a_casino_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4256,8421,31421,'Ratriya','Spellbook Seller','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4257,8422,31422,'Migel','Spellbook Seller','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4258,8423,31423,'Romas','Spellbook Seller','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4259,8424,31424,'Shantra','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4260,8425,31425,'Koram','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4261,8426,31426,'Jaka','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4262,8427,31427,'Urgal','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4263,8428,31428,'Shafa','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4264,8429,31429,'Shitara','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4265,8430,31430,'Donai','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4266,8431,31431,'Karai','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4267,8432,31432,'Reeya','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4268,8433,31433,'Ronaldo','Blueprint Seller','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4269,8434,31434,'Shaling','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4270,8435,31435,'Daeger','Blueprint Seller','e_traderA_master_MDwarf','8.00','18.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4271,8436,31436,'Dani','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4272,8437,31437,'Luka','Blueprint Seller','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4273,8438,31438,'Lara','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4274,8439,31439,'Rogen','Mineral Trader','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4275,8440,31440,'Lanna','Mineral Trader','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4276,8441,31441,'Gordo','Mineral Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4277,8442,31442,'Kiki','Mineral Trader','e_traderB_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4278,8443,31443,'Raban','Mineral Trader','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4279,8444,31444,'Cona','Mineral Trader','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4280,8445,31445,'Shutner','Mineral Trader','e_traderB_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4281,8452,31452,'Ghost of Wigoth','','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4282,8453,31453,'Nameless Spirit','','a_king_MHuman','8.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4283,8454,31454,'Ghost of Wigoth','','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4284,8455,31455,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4285,8456,31456,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4286,8457,31457,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4287,8458,31458,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4288,8459,31459,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4289,8460,31460,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4290,8461,31461,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4291,8462,31462,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4292,8463,31463,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4293,8464,31464,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4294,8465,31465,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4295,8466,31466,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4296,8467,31467,'Key Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4297,8468,31468,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4298,8469,31469,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4299,8470,31470,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4300,8471,31471,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4301,8472,31472,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4302,8473,31473,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4303,8474,31474,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4304,8475,31475,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4305,8476,31476,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4306,8477,31477,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4307,8478,31478,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4308,8479,31479,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4309,8480,31480,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4310,8481,31481,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4311,8482,31482,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4312,8483,31483,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4313,8484,31484,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4314,8485,31485,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4315,8486,31486,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4316,8487,31487,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4317,8488,31488,'Rift Post Recruit','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4318,8489,31489,'Rift Post Private','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,304,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4319,8490,31490,'Rift Post Officer','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,111,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4320,8491,31491,'Rift Post Captain','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,660,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4321,8492,31492,'Rift Post Commander','','a_lord_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,655,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4322,8493,31493,'Rift Post Hero','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4323,8494,31494,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(4324,8495,31495,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4325,8496,31496,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4326,8497,31497,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4327,8498,31498,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4328,8499,31499,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4329,8500,31500,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4330,8501,31501,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4331,8502,31502,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4332,8503,31503,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4333,8504,31504,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4334,8505,31505,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4335,8506,31506,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4336,8507,31507,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4337,8508,31508,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4338,8509,31509,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4339,8510,31510,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4340,8511,31511,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4341,8512,31512,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4342,8513,31513,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4343,8514,31514,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4344,8515,31515,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4345,8516,31516,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4346,8517,31517,'Hierarch','','a_hardin_MHuman','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4347,8518,31518,'Mysterious Necromancer','','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4348,8519,31519,'Enfeux','','saints_coffin','20.00','60.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4349,8520,31520,'Leikar','Maid','a_maidA_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4350,8521,31521,'Jeremy','Chef','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4351,8522,31522,'Mysterious Wizard','','a_hardin_MHuman','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4352,8523,31523,'Tombstone','','old_tomb_stone','20.00','30.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4353,8524,31524,'Ghost of von Hellmann','','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4354,8525,31525,'Ghost of von Hellmann''s Page','','dark_horror','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.37),
(4355,8526,31526,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4356,8527,31527,'Well','','umul','33.00','37.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4357,8528,31528,'Ghost of Priest','','elf_ghost','7.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(4358,8529,31529,'Ghost of Adventurer','','human_ghost','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4359,8530,31530,'Box','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4360,8531,31531,'Tombstone','','old_tomb_stone','20.00','30.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4361,8532,31532,'Maid of Lidia','','vampire_witch','6.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(4362,8533,31533,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4363,8534,31534,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4364,8535,31535,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4365,8536,31536,'Coffin','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4366,8537,31537,'Tunatun','Beast Herder','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4367,8538,31538,'Ghost of Adventurer','','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4368,8539,31539,'Vulcan','Blacksmith of Flame','a_smith_MDwarf','7.00','16.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4369,8540,31540,'Klein','Watcher of Valakas','skeleton_royal_guard','11.00','28.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(4370,8541,31541,'Daimon''s Altar','','gianteye_altar','60.00','50.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4371,8542,31542,'Yeti''s Table','','yetis_dinner_table','25.00','15.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4372,8543,31543,'Pulin','','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4373,8544,31544,'Naff','','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4374,8545,31545,'Crocus','','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4375,8546,31546,'Kuber','','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4376,8547,31547,'Beolin','','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4377,8548,31548,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4378,8549,31549,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4379,8550,31550,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4380,8551,31551,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4381,8552,31552,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4382,8553,31553,'Pierce','Mercenary Captain','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4383,8554,31554,'Kahman','Mercenary','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4384,8555,31555,'Abercrombie','Mercenary Supplier','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4385,8556,31556,'Selina','Mercenary Medic','a_traderC_Fhuman','7.00','21.50',70,'female','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,659,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4386,8557,31557,'Mercenary Sentry','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,298,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4387,8558,31558,'Ketra''s Holy Altar','','orcish_totem','25.00','47.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4388,8559,31559,'Box of Asefa','','coffer_d','12.00','22.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4389,8560,31560,'Varka''s Holy Altar','','silenos_totem','28.00','55.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4390,8561,31561,'Udan Mardui''s Box','','coffer_b','12.00','9.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4391,8562,31562,'Klufe','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4392,8563,31563,'Perelin','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4393,8564,31564,'Mishini','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4394,8565,31565,'Ogord','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4395,8566,31566,'Ropfi','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4396,8567,31567,'Bleaker','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4397,8568,31568,'Pamfus','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4398,8569,31569,'Cyano','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4399,8570,31570,'Lanosco','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4400,8571,31571,'Hufs','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4401,8572,31572,'O''Fulle','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4402,8573,31573,'Monakan','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4403,8574,31574,'Willie','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4404,8575,31575,'Litulon','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4405,8576,31576,'Berix','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4406,8577,31577,'Linnaeus','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4407,8578,31578,'Hilgendorf','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4408,8579,31579,'Klaus','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4409,8580,31580,'Galadrid','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,132,110,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4410,8581,31581,'Anastia','Magister','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4411,8582,31582,'Mordred','Dark Knight','vampire_soldier','8.00','23.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,137,634,0,60,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.45),
(4412,8583,31583,'Feynn','Blacksmith','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,168,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4413,8584,31584,'Valentine','Brewer','e_traderB_MDwarf','8.00','17.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4414,8585,31585,'Sparky the Cat','Keats Servitor','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4415,8586,31586,'Sparky the Cat','Keats Servitor','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4416,8587,31587,'Gedrik','Gemcutter','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4417,8588,31588,'Agnes','Saint of Light','a_teleporter_FElf','8.50','23.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4418,8589,31589,'Duda-Mara Totem Spirit ','','giant_spider','26.00','26.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,72,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.26),
(4419,8590,31590,'Truth Scholar Devianne','','a_teleporter_FHuman','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,192,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4420,8591,31591,'Sunset Guide Luna','','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,633,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4421,8592,31592,'Telson','Chief Golem Crafter','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4422,8593,31593,'Dorothy','Golem of Telson','mechanic_golem','5.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(4423,8594,31594,'Mond','Chief Inspector','e_celebrant_MDwarf','8.00','19.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4424,8595,31595,'Leona Blackbird','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,110,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4425,8596,31596,'Tobald','Master','e_guard_MDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,187,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4426,8597,31597,'Tobald','Master','e_guard_MDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,187,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4427,8598,31598,'Medina Blackheart','','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,206,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4428,8599,31599,'Disgraced Knight Waldstein','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4429,8600,31600,'Pamela Aprodia','','a_casino_FDarkElf','8.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4430,8601,31601,'Pamela Aprodia','','a_guard_FDarkelf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4431,8602,31602,'Sharona Artemia','Bodyguard','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,232,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4432,8603,31603,'Black Cat','Hunter Guild Member','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,227,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4433,8604,31604,'Grimst','Information Broker','a_casino_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4434,8605,31605,'Kinsley','Head Summoner','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,212,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4435,8606,31606,'Alice de Catrina','Kinsley''s Servitor','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4436,8607,31607,'Sake Dun Zu Hestui','','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,298,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4437,8608,31608,'Belinda','Summoner','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4438,8609,31609,'Aurora the Unicorn','Belinda Servitor','unicorn_boxer','11.00','18.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(4439,8610,31610,'Shiken Gloomdrake','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,633,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4440,8611,31611,'Scryde Heartseeker','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4441,8612,31612,'Eternity Wanderer Staris','','a_trader_MElf','8.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,150,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4442,8613,31613,'Noctisse','Summoner','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,204,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4443,8614,31614,'Radyss','Head Summoner','a_patriarch_MElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4444,8615,31615,'Hermit','','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4445,8616,31616,'Hermit','','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,8,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4446,8617,31617,'Aria Firstmatter','','a_guard_FDarkelf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,236,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4447,8618,31618,'Moon Voice Irene','','a_common_people_FElf','8.00','25.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,109,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4448,8619,31619,'Erica Ken Weber','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,236,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4449,8620,31620,'Verdure Elder Elikia','','a_patriarch_MElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4450,8621,31621,'Abyss Saint Elcardia','','a_guard_FDarkelf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,206,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4451,8622,31622,'Keats','Cursed Summoner','poison_toad','20.00','10.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.35),
(4452,8623,31623,'Bavarin','Information Broker','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4453,8624,31624,'Donath','Master Chef','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4454,8625,31625,'Yeti','Donath Kitchen Help','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5129,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4455,8626,31626,'Duncan','Chef','a_smith_MDwarf','7.00','16.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5129,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4456,8627,31627,'Mist','Information Broker','e_bath_MDwarf','6.00','16.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4457,8628,31628,'Lilly','Mist''s Granddaughter','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4458,8629,31629,'Kaleidos the Unicorn','','blue_eye','11.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(4459,8630,31630,'Kaleidos the Unicorn','','blue_eye','11.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(4460,8631,31631,'Eric Ramsheart','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4461,8632,31632,'Mysterious Servitor','','shadeless','7.00','28.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4462,8633,31633,'Winter Hunter Kadyth','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4463,8634,31634,'Winter Hunter Kadyth','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4464,8635,31635,'Winter Hunter Kadyth','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4465,8636,31636,'Flame Successor Akkan','','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,305,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4466,8637,31637,'Khavatari Kashu','','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,267,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4467,8638,31638,'Starling Knight Kastien','','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,142,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4468,8639,31639,'Kain Van Halter','','a_traderA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2626,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4469,8640,31640,'Pilgrim of Darkness','','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,318,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4470,8641,31641,'Pilgrim of Darkness','','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,318,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4471,8642,31642,'Tarkai Zu Duda-Mara','','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,210,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4472,8643,31643,'Silver Feyshar','','a_patriarch_MElf','8.00','22.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,148,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4473,8644,31644,'Dawn Witness Franz','','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4474,8645,31645,'Hindemith Truevoice','','a_traderD_Mhuman','7.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,195,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4475,8646,31646,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4476,8647,31647,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4477,8648,31648,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4478,8649,31649,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4479,8650,31650,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4480,8651,31651,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4481,8652,31652,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4482,8653,31653,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4483,8654,31654,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4484,8655,31655,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4485,8656,31656,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4486,8657,31657,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4487,8658,31658,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4488,8659,31659,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4489,8660,31660,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4490,8661,31661,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4491,8662,31662,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4492,8663,31663,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4493,8664,31664,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4494,8665,31665,'Corpse of Dwarf','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4495,8666,31666,'Lumen','Spellbook Seller','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4496,8667,31667,'Raik','Amulet Seller','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4497,8668,31668,'Tangen','Blueprint Seller','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4498,8669,31669,'Onyx','Mineral Trader','e_mine_teacher_MDwarf','8.00','18.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(4499,8670,31670,'Burns','Spellbook Seller','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4500,8671,31671,'Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Folk','npc',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,120,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(4501,8672,31672,'Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Folk','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4502,8673,31673,'Patrol','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Folk','npc',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,120,'',0,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(4503,8674,31674,'Patrol','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Folk','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4504,8675,31675,'Viktor Van Deik','Border Outpost Captain','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4505,8676,31676,'Gregory Athebaldt','Border Outpost Captain','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4506,8677,31677,'Border Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Folk','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4507,8678,31678,'Border Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Folk','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4508,8679,31679,'Eustace Van Essen','Frontier Guard Captain','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4509,8680,31680,'Fleming Van Issen','Frontier Guard Captain','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4510,8681,31681,'Frontier Guard','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Folk','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4511,8682,31682,'Frontier Guard','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Folk','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4512,8683,31683,'Eye of Argos','','argos_eye','205.00','307.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4513,8684,31684,'Eye of Udan Mardui','','mana_vampire','11.00','20.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4514,8685,31685,'Asefa''s Eye','','magical_weaver','11.00','20.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(4515,8686,31686,'Gatekeeper of Fire Dragon','','skeleton_knight','10.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(4516,8687,31687,'Gatekeeper of Fire Dragon','','skeleton_knight','10.00','25.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.17),
(4517,8688,31688,'Grand Olympiad Manager','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2OlympiadManager','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4518,8689,31689,'Olympiad Finisher','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4519,8690,31690,'Monument of Heroes ','','heroes_obelisk_human','21.00','69.00',70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4520,8691,31691,'Training Dummy ','','training_doll','9.00','22.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4521,8692,31692,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4522,8693,31693,'Priest of Dusk','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4523,8694,31694,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4524,8695,31695,'Priest of Dusk','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4525,8696,31696,'Platis','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4526,8697,31697,'Eindarkner','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4527,8698,31698,'Arisha','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4528,8699,31699,'Stanislava','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4529,8700,31700,'Saint''s Follower','','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4530,8701,31701,'Saint''s Follower','','a_common_people_MElf','6.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4531,8702,31702,'Saint''s Follower','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4532,8703,31703,'Saint''s Follower','','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4533,8704,31704,'Saint''s Follower','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4534,8705,31705,'Daimon the White-Eyed','','hundred_eye','21.00','55.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(4535,8706,31706,'Miki the Cat','','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4536,8707,31707,'Ketra Van Grunt','','ketra_orc_chieftain','11.00','38.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6719,0,0,24,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.51),
(4537,8708,31708,'Ketra Van Shaman','','ketra_orc_shaman','10.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,92,0,0,10,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4538,8709,31709,'Ketra Van Captain','','ketra_orc_warlord','12.00','30.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,0,0,27,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4539,8710,31710,'Ketra Van Commander','','barka_silenos_chieftain','18.00','42.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2500,0,0,25,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4540,8711,31711,'Ketra Van Shaman','','barka_silenos_shaman','14.00','39.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.49),
(4541,8712,31712,'Varka Raider','','barka_silenos_warrior','16.00','41.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,142,0,0,34,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4542,8713,31713,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4543,8714,31714,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4544,8715,31715,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4545,8716,31716,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4546,8717,31717,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4547,8718,31718,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4548,8719,31719,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4549,8720,31720,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4550,8721,31721,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4551,8722,31722,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4552,8723,31723,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4553,8724,31724,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4554,8725,31725,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4555,8726,31726,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4556,8727,31727,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4557,8728,31728,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4558,8729,31729,'Adventurer Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4559,8730,31730,'Adventurer Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4560,8731,31731,'Adventurer Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4561,8732,31732,'Adventurer Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4562,8733,31733,'Adventurer Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4563,8734,31734,'Adventurer Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4564,8735,31735,'Adventurer Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4565,8736,31736,'Adventurer Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4566,8737,31737,'Adventurer Guildsman','','e_trader_FOrc','8.00','24.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4567,8738,31738,'Adventurer Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4568,8739,31739,'Talien','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4569,8740,31740,'Caradine','','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4570,8741,31741,'Ossian','','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4571,8742,31742,'Virgil','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4572,8743,31743,'Kassandra','','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4573,8744,31744,'Ogmar','','e_common_people_MOrc','8.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4574,8745,31745,'Lady of the Lake','','a_teleporter_FElf','8.50','23.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4575,8746,31746,'Fallen Unicorn','','death_unicorn','14.00','30.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,46,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(4576,8747,31747,'Pure White Unicorn','','unicorn','14.00','30.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,46,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.74),
(4577,8748,31748,'Cornerstone of Restraining','','grave_keeper','8.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4578,8750,31750,'Mysterious Woman','','a_teleporter_FElf','8.50','23.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4579,8751,31751,'Mysterious Dark Knight','','death_lord','21.00','40.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,78,0,0,40,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(4580,8752,31752,'Corpse of Angel','','angel_death','25.00','36.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4581,8755,31755,'Halaster','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4582,8756,31756,'Mr. Cat','Test Server Helper','cat_the_cat','9.00','16.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4583,8757,31757,'Miss Queen','Test Server Helper','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4584,8758,31758,'Rafi','','hatchling','9.00','10.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.27),
(4585,8759,31759,'Teleport Cube','','teleport_npc','40.00','80.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4586,8760,31760,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4587,8761,31761,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4588,8762,31762,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4589,8763,31763,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4590,8764,31764,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4591,8765,31765,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4592,8766,31766,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48),
(4593,8767,31767,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4594,8768,31768,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4595,8769,31769,'Monument of Heroes','','heroes_obelisk_elf','24.00','77.50',70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4596,8770,31770,'Monument of Heroes','','heroes_obelisk_darkelf','25.00','77.00',70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4597,8771,31771,'Monument of Heroes','','heroes_obelisk_orc','21.00','72.50',70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4598,8772,31772,'Monument of Heroes','','heroes_obelisk_dwarf','23.00','80.00',70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4599,8773,31773,'Sonin','Warehouse Keeper','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4600,0,31774,'Beryl the Cat','Event Manager','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(4601,0,31775,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4602,0,31776,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4603,0,31777,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4604,0,31778,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4605,0,31779,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4606,0,31780,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4607,0,31781,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4608,0,31782,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4609,0,31783,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4610,0,31784,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4611,0,31785,'Adventure Guildsman','','e_trader_FOrc','8.00','24.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4612,0,31786,'Adventure Guildsman','','e_trader_FOrc','8.00','24.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4613,0,31787,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4614,0,31788,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4615,0,31789,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4616,0,31790,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4617,0,31791,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4618,0,31792,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4619,0,31793,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4620,0,31794,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4621,0,31795,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4622,0,31796,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4623,0,31797,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4624,0,31798,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4625,0,31799,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4626,0,31800,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4627,0,31801,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4628,0,31802,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4629,0,31803,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4630,0,31804,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4631,0,31805,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4632,0,31806,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4633,0,31807,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4634,0,31808,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4635,0,31809,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4636,0,31810,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4637,0,31811,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4638,0,31812,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4639,0,31813,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4640,0,31814,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4641,0,31815,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4642,0,31816,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4643,0,31817,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4644,0,31818,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4645,0,31819,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4646,0,31820,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4647,0,31821,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4648,0,31822,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4649,0,31823,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4650,0,31824,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4651,0,31825,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4652,0,31826,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4653,0,31827,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4654,0,31828,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4655,0,31829,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4656,0,31830,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4657,0,31831,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4658,0,31832,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4659,0,31833,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4660,0,31834,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4661,0,31835,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4662,0,31836,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4663,0,31837,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4664,0,31838,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4665,0,31839,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(4666,0,31840,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,1,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60),
(4667,0,31841,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(4668,12053,31842,'Teleport Cube','','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,7,3,0,0,0.60),
(4669,12078,31843,'Teleport Cube','','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(4670,12083,31844,'Aracna','','aracne','15.00','26.00',50,'female','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,64,120,'all_elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(4671,12084,31845,'Bloody Pixy','','pixy','5.00','25.00',50,'female','L2Folk','npc',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,80,120,'all_elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(4672,12085,31846,'Satyros','','pan','14.00','35.00',50,'male','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,291,0,0,45,110,'all_elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(4673,12086,31847,'Pan','','pan','14.00','35.00',50,'male','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,291,0,0,45,110,'all_elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.58),
(4674,12087,31848,'Pixy','','pixy','5.00','25.00',50,'female','L2Folk','npc',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,80,120,'all_elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(4675,12088,31849,'Red Arachne','','aracne','15.00','26.00',50,'female','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,64,120,'all_elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.50),
(4676,12089,31850,'Blight Treant','','ti_mi_riran','23.00','90.00',50,'male','L2Folk','npc',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental2_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4677,12090,31851,'Treant','','ti_mi_tran','23.00','90.00',50,'male','L2Folk','npc',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4678,12091,31852,'Pixy Murika','','pixy','5.00','25.00',50,'female','L2Folk','npc',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,509,278,264,226,278,0,253,0,0,0,80,120,'all_elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.72),
(4679,12092,31853,'Treant Bremec','','ti_mi_tran','23.00','90.00',50,'male','L2Folk','npc',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(4680,12260,31854,'Event Manager','','a_traderB_MHuman','7.00','21.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4681,12261,31855,'Event Manager','','a_trader_FElf','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4682,12262,31856,'Event Manager','','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4683,12263,31857,'Event Manager','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4684,12264,31858,'Event Manager','','e_trader_FOrc','8.00','24.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4685,12324,31859,'Teleport Cube','','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(4686,0,31860,'Sprockets the Cat','Event Manager','e_trader_FOrc','8.00','18.00',70,'male','L2ClassMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4687,12563,31861,'Gatekeeper','','a_teleporter_FHuman','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(4688,12571,31862,'Angelic Vortex','','alive_castle_aden_controltower_jewel','7.00','35.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4689,12617,31863,'Santa Trainee','','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4690,12618,31864,'Santa Trainee','','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4691,12901,31865,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4692,12902,31866,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4693,12903,31867,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4694,12904,31868,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4695,12905,31869,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4696,12906,31870,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4697,12907,31871,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4698,12908,31872,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4699,12909,31873,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Folk','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4700,12910,31874,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4701,12911,31875,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4702,12912,31876,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4703,12913,31877,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4704,12914,31878,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4705,12915,31879,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4706,12916,31880,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4707,12917,31881,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4708,12918,31882,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Folk','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4709,12919,31883,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4710,12920,31884,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4711,12921,31885,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4712,12922,31886,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4713,12923,31887,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4714,12924,31888,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4715,12925,31889,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4716,12926,31890,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4717,12927,31891,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Folk','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4718,12928,31892,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4719,12929,31893,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4720,12930,31894,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4721,12931,31895,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4722,12932,31896,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4723,12933,31897,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4724,12934,31898,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4725,12935,31899,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4726,12936,31900,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Folk','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4727,12937,31901,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4728,12938,31902,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4729,12939,31903,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4730,12940,31904,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4731,12941,31905,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4732,12942,31906,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4733,12943,31907,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4734,12944,31908,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4735,12945,31909,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Folk','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4736,12946,31910,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4737,12947,31911,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4738,12948,31912,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4739,12949,31913,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4740,12950,31914,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4741,12951,31915,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4742,12952,31916,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4743,12953,31917,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4744,12954,31918,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Folk','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4745,13187,31919,'Ghost Chamberlain of Elmoreden','','a_tombkeeperA','7.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4746,13188,31920,'Ghost Chamberlain of Elmoreden','','a_tombkeeperA','7.00','23.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4747,13189,31921,'Conquerors'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4748,13190,31922,'Emperors'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4749,13191,31923,'Great Sages'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4750,13192,31924,'Judges'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4751,13193,31925,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4752,13194,31926,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4753,13195,31927,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4754,13196,31928,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4755,13197,31929,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4756,13198,31930,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4757,13199,31931,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4758,13200,31932,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4759,13201,31933,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4760,13202,31934,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4761,13203,31935,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4762,13204,31936,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4763,13205,31937,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4764,13206,31938,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4765,13207,31939,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4766,13208,31940,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4767,13209,31941,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4768,13210,31942,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4769,13211,31943,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4770,13212,31944,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4771,0,31945,'Auzendorff','Trader','e_traderB_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4772,0,31946,'Hombre','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4773,0,31947,'Owaki','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4774,0,31948,'Adrian','Trader','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4775,0,31949,'Rouge','Trader','a_traderC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4776,0,31950,'Mailland','Trader','e_traderB_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4777,0,31951,'Jose','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4778,0,31952,'Pele','Trader','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4779,0,31953,'Rankar','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4780,0,31954,'Saroyan','Pet Manager','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4781,0,31955,'Ruby','','baby_tiger','9.50','18.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4782,0,31956,'Rydel','Warehouse Keeper','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4783,0,31957,'Cherbal','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4784,0,31958,'Yasheni','Warehouse Chief','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4785,0,31959,'Axel','Warehouse Freightman','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4786,0,31960,'Byron','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4787,0,31961,'Newyear','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4788,0,31962,'Altair','Blueprint Seller','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4789,0,31963,'Hitchi','Mineral Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4790,0,31964,'Bilia','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4791,0,31965,'Hector','Grand Master','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4792,0,31966,'Karamon','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4793,0,31967,'Euline','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4794,0,31968,'Baryl','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4795,0,31969,'Evelyn','Priest','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4796,0,31970,'Sinis','Priest','a_mageguild_teacher_MElf','7.00','22.20',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4797,0,31971,'Otillo','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4798,0,31972,'Atraxia','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4799,0,31973,'Raheel','Spellbook Seller','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4800,0,31974,'Drizzit','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4801,0,31975,'Aerina','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4802,0,31976,'Talia','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4803,0,31977,'Shaka','High Prefect','e_patriarch_MOrc','8.00','26.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4804,0,31978,'Tazeer','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4805,0,31979,'Moira','Seer','e_clergyman_FOrc','6.50','28.00',70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4806,0,31980,'Rumba','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4807,0,31981,'Vishotsky','Captain','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4808,0,31982,'Glen','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4809,0,31983,'Friggar','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4810,0,31984,'Sherring','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4811,0,31985,'Kosmos','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4812,0,31986,'Erstack','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4813,0,31987,'Gotter','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4814,0,31988,'Singa','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','npc',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4815,0,31989,'Batidae','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,1,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60),
(4816,0,31990,'Siger','Blacksmith','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,168,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4817,0,31991,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4818,0,31992,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,1,'Tigra','',0,20,147,7,30,4,4,0,-6,0.60),
(4819,0,31993,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4820,0,31994,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4821,0,31995,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,50,120,'',0,1,'Tigra','',0,20,147,7,30,4,4,0,-6,0.60),
(4822,0,31996,'Javier','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4823,0,31997,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4824,0,31998,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(4825,0,31999,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4826,0,32000,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4827,0,32001,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4828,0,32002,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.37),
(4829,0,32003,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4830,0,32004,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4831,0,32005,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4832,0,32006,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4833,0,32007,'Galba','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4834,0,32008,'Gremory','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4835,0,32009,'Devorin','Nurse','e_common_people_FDwarf','7.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4836,0,32010,'Flauron','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4837,0,32011,'Imperial Tomb Guide','','a_tombkeeperA','7.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4838,0,32012,'Tantan','Retired Adventurer','a_old_people_Mhuman','9.00','17.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4839,0,32013,'Suki','Wild Maiden','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4840,0,32014,'Ivan ','Runaway Youth','a_traderD_Mhuman','7.00','21.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4841,0,32015,'Scout''s Corpse','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(4842,0,32016,'Torrant','Beacon Tower Manager','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4843,0,32017,'Karuda','','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4844,0,32018,'Misa','','a_maidB_FHuman','8.00','22.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4845,0,32019,'Suspicious Man','','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4846,0,32020,'Rafforty','','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4847,0,32021,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4848,0,32022,'Kierre','','ice_sculpture_b','12.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4849,0,32023,'Ice Shelf','','ice_shelf','35.00','14.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4850,0,32024,'Mulia','Clan Trader','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4851,0,32025,'Ilia','Clan Trader','e_smith_Fdwarf','8.00','17.50',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4852,0,32026,'Hestui Guard','','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4853,0,32027,'Holy Brazier','','grail_brazier_b','30.00','31.00',78,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4854,0,32028,'Holy Grail','','holy_grail','6.20','7.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4855,0,32029,'Freya''s Steward','','a_common_people_MElf','6.00','21.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4856,0,32030,'Garden Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4857,0,32031,'Ice Fairy Sculpture','','ice_sculpture_b','12.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4858,0,32032,'Strange Machine','','strange_mechanical_instrument','16.00','15.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4859,0,32033,'Doctor Chaos','','doctor_chaos','9.00','15.60',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4860,0,32034,'Temple Gatekeeper','','heretical_sanctuary_gatekeeper_a','80.00','181.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4861,0,32035,'Temple Gatekeeper','','heretical_sanctuary_openner_a','28.00','70.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4862,0,32036,'Temple Gatekeeper','','heretical_sanctuary_gatekeeper_b','80.00','203.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4863,0,32037,'Temple Gatekeeper','','heretical_sanctuary_openner_b','28.00','70.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4864,0,32038,'Ritual Offering','','a_traderA_Mhuman_deco','8.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4865,0,32039,'Triol''s Mirror','','heretical_devil_mirror','28.00','70.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4866,0,32040,'Triol''s Mirror','','heretical_devil_mirror','28.00','70.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4867,0,32041,'Yumi','Collector','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4868,0,32042,'Weathermaster','','pavel_weather_controller','14.50','18.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4869,0,32043,'Weathermaster','','pavel_weather_controller','14.50','18.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4870,0,32044,'Weathermaster','','Evilate_weather','16.00','18.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4871,0,32045,'Doctor Chaos'' Secret Bookshelf','','Evilate_doc_chaos','25.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4872,0,32046,'Suspicious-Looking Pile of Stones','','susceptor_env','20.00','35.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4873,0,32047,'Wendy','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4874,0,32048,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4875,0,32049,'Rooney','Blacksmith of Wind','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4876,0,32050,'Parts Box','','box','18.00','14.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4877,0,32051,'Altar Gatekeeper','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4878,0,32052,'Obi','Railroad Worker','e_mine_teacher_MDwarf','8.00','18.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4879,0,32053,'Abey','Railroad Worker','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4880,0,32054,'Ghost of a Railroad Engineer','','dwarf_ghost','10.00','18.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4881,0,32055,'Ghost of an Ancient Railroad Engineer','','dwarf_ghost','10.00','18.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4882,0,32056,'Aren','Khavatari','e_mageguild_teacher_FOrc','8.00','28.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4883,0,32057,'Totem Spirit of Gandi','','onyx_beast','14.00','14.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4884,0,32058,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4885,0,32059,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4886,0,32060,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4887,0,32061,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4888,0,32062,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4889,0,32063,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4890,0,32064,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4891,0,32065,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4892,0,32066,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4893,0,32067,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4894,0,32068,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4895,0,32069,'Gutenhagen','Collector','e_guard_MDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4896,0,32070,'Adolph','','a_child_people_Mhuman','5.00','12.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4897,0,32071,'Linda','','a_child_people_Fhuman','5.00','12.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4898,0,32072,'Edwin','','a_old_people_Mhuman','9.00','17.30',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4899,0,32073,'Old Female Drifter','','a_old_people_Fhuman','9.00','17.30',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4900,0,32074,'Gludio Territory Manager','Guild President','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4901,0,32075,'Sandy the Cat','Tournament Helper','queen_of_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4902,0,32076,'Box','','box','18.00','14.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4903,0,32077,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4904,0,32078,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4905,0,32079,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.56),
(4906,0,32082,'Dion Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4907,0,32083,'Giran Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4908,0,32084,'Oren Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4909,0,32085,'Aden Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4910,0,32086,'Innadril Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4911,0,32087,'Schuttgart Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4912,0,32088,'Goddard Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4913,0,32089,'Rune Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Tigra','',0,0,0,7,30,4,4,0,0,0.60),
(4914,0,32090,'Dead Leopard''s Carcass','','onyx_beast_ns','14.00','14.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4915,0,32091,'Omega''s Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4916,0,32092,'Alder','Warehouse Chief','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4917,0,32093,'Bolin','Head Blacksmith','e_common_people_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4918,0,32094,'Schule','Grand Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4919,0,32095,'Marie','High Priest','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4920,0,32096,'Helminter','Grand Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4921,0,32097,'Finker','High Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4922,0,32098,'Celes','Grand Magister','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4923,0,32099,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4924,0,32100,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4925,0,32101,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4926,0,32102,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4927,0,32103,'Telling the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(4928,0,32104,'Vervato','','Crokian_Sorcerer',25,33,70,'male','L2Merchant','Mystic',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4929,0,32105,'Dinn','','a_traderC_Mhuman',8,23,70,'male','L2Merchant','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4930,0,32106,'Singsing','','a_wharfinger_MHuman',8,23,70,'male','L2Merchant','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4931,0,32107,'Teleport Cube','','teleport_npc',40,80,70,'male','L2Merchant','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4932,0,32108,'','','rhamphorhynchus_npc',1,30,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4933,0,32109,'Shilen''s Stone Statue','','primeval_raid_teleporter',24,72.5,70,'male','L2Merchant','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4934,0,32110,'','','clear_npc',0.1,0.1,70,'male','L2Folk','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4935,0,32111,'Orahochin','','Crokian_Sorcerer',25,33,70,'male','L2Merchant','Mystic',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4936,0,32112,'Gariachin','','Crokian_Sorcerer',25,33,70,'male','L2Merchant','Mystic',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4937,0,32113,'Marquez','','a_wharfinger_MHuman',8,23,70,'male','L2Merchant','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4938,0,32114,'Mushika','','Crokian_Elder',25,33,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4939,0,32115,'Asamah','','Crokian_Vice_Elder',45,41.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4940,0,32116,'Kirikachin','','Crokian_Vice_Elder',45,41.5,70,'male','L2Merchant','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4941,0,32117,'Karakawei','','Crokian_Sorcerer',25,33,70,'male','L2Folk','Mystic',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4942,0,32118,'Mantarasa Egg','','dinosaur_nest',43,33.5,70,'male','L2Folk','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,0,0,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4943,0,32119,'Ulu Kaimu','','Evilate_doc_chaos',25,33.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4944,0,32120,'Balu Kaimu','','Evilate_doc_chaos',25,33.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4945,0,32121,'Chuta Kaimu','','Evilate_doc_chaos',25,33.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4946,0,32122,'Warrior''s Grave','','Evilate_weather',16,18.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4947,0,32123,'Valakas','','valakas_f',190,335,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,0,0,0,0,0,0,0,0,0),
(4948,0,32124,'Great Soul','','Soul_Collector_Npc',14,25,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4949,0,32125,'Great Soul','','Soul_Collector_Npc',14,25,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4950,0,32126,'Priest Guard','','e_elmore_guard_Mhuman',8,23.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4951,0,32127,'Priest Guard','','e_elmore_guard_Mhuman',8,23.5,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4952,0,32128,'Guardian Wizard of the Cloth','','a_traderB_FHuman',8,25,70,'male','L2Folk','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4953,0,32129,'','','valakas_f_dummy',8,10,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4954,0,32130,'Looney the Cat','Event Manager','king_of_cat',8,16.01,70,'male','L2Folk','Fighter',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(4955,0,32131,'Magic Laboratory Worker','Event Manager','e_smith_Fdwarf',8,17.5,70,'male','L2Folk','npc',40,3862,11.85,1493,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),(4956,12301,35010,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Fighter',40,2317,6.500,3830,2.400,40,43,30,21,20,10,0,0,1683,687,546,233,416,0,379,128,628,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,20,0,7,30,4,4,0,0,0.60),
(4957,12302,35011,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Fighter',80,2317,6.500,3830,2.400,40,43,30,21,20,10,0,0,1798,787,546,233,357,0,325,93,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,30,4,0,0,0,0.60),
(4958,12303,35012,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Ranger',1100,2245,6.500,3830,2.400,40,43,30,21,20,10,0,0,1889,544,546,233,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,10,8,0,1500,10,0.60),
(4959,12304,35013,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'female','L2SiegeGuard','Mystic',800,2245,6.500,4245,5.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60),
(4960,12305,35014,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Mystic',800,2245,6.500,4245,5.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,179,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60),
(4961,12306,35015,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Fighter',40,2245,8.500,3830,6.500,40,43,30,21,20,10,0,0,1683,687,546,233,416,0,379,128,628,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,20,0,7,30,4,4,0,0,0.60),
(4962,12307,35016,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Fighter',80,2317,8.500,3830,6.500,40,43,30,21,20,10,0,0,1798,787,546,233,357,0,325,93,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,30,4,0,0,0,0.60),
(4963,12308,35017,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Ranger',1100,2245,8.500,3830,6.500,40,43,30,21,20,10,0,0,1889,544,546,233,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,10,8,0,1500,10,0.60),
(4964,12309,35018,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'female','L2SiegeGuard','Mystic',800,2245,8.500,4245,7.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60),
(4965,12310,35019,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'male','L2SiegeGuard','Mystic',800,2245,8.500,4245,7.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,179,0,0,50,195,'mercenary_siege_clan',1200,0,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60),
(4966,12722,35020,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,1763,485,1610,394,416,0,379,150,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4967,12723,35021,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',80,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2058,485,1610,394,357,0,325,97,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4968,12724,35022,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Ranger',1100,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2292,412,1610,394,322,0,293,288,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4969,12725,35023,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'female','L2SiegeGuard','Mystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4970,12726,35024,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Mystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,196,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4971,12727,35025,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,1763,485,1610,394,416,0,379,150,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4972,12728,35026,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',80,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2058,485,1610,394,357,0,325,97,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4973,12729,35027,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Ranger',1100,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2292,412,1610,394,322,0,293,288,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4974,12730,35028,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'female','L2SiegeGuard','Mystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4975,12731,35029,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Mystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,196,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4976,12732,35030,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1154,380,988,309,416,0,379,132,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4977,12733,35031,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',80,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1347,380,988,309,357,0,325,301,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4978,12734,35032,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Ranger',1100,3818,2.400,1150,2.400,40,43,30,21,20,10,0,0,1501,323,988,309,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4979,12735,35033,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'female','L2SiegeGuard','Mystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4980,12736,35034,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Mystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4981,12737,35035,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1154,380,988,309,416,0,379,132,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4982,12738,35036,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',80,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1347,380,988,309,357,0,325,301,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4983,12739,35037,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Ranger',1100,3054,2.400,1150,2.400,40,43,30,21,20,10,0,0,1501,323,988,309,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4984,12740,35038,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'female','L2SiegeGuard','Mystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4985,12741,35039,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Mystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4986,12742,35040,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Fighter',40,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,899,332,744,270,416,0,379,66,20,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,20,0,7,30,4,4,0,0,0.60),
(4987,12743,35041,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Fighter',80,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1050,332,744,270,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4988,12744,35042,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Ranger',1100,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1169,282,744,270,322,0,293,274,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4989,12745,35043,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'female','L2SiegeGuard','Mystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,7,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4990,12746,35044,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Mystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,154,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4991,12747,35045,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Fighter',40,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,899,332,744,270,416,0,379,66,20,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,20,0,7,30,4,4,0,0,0.60),
(4992,12748,35046,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Fighter',80,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1050,332,744,270,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4993,12749,35047,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Ranger',1100,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1169,282,744,270,322,0,293,274,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4994,12750,35048,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'female','L2SiegeGuard','Mystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,7,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4995,12751,35049,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'male','L2SiegeGuard','Mystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,154,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(4996,12752,35050,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Fighter',40,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,506,245,390,199,416,0,379,66,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(4997,12753,35051,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Fighter',80,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,591,245,390,199,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(4998,12754,35052,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Ranger',1100,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,658,209,390,199,322,0,293,14,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(4999,12755,35053,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'female','L2SiegeGuard','Mystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,6,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(5000,12756,35054,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Mystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,99,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(5001,12757,35055,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Fighter',40,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,506,245,390,199,416,0,379,66,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5002,12758,35056,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Fighter',80,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,591,245,390,199,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5003,12759,35057,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Ranger',1100,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,658,209,390,199,322,0,293,14,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,10,0.60),
(5004,12760,35058,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'female','L2SiegeGuard','Mystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,6,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(5005,12761,35059,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'male','L2SiegeGuard','Mystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,99,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,10,0.60),
(5006,12762,35060,'Nephilim Mercenary','','a_guard_MHuman','8.00','24.00',75,'male','L2SiegeGuard','Fighter',40,189460,178.300,855,2.300,84,71,73,76,70,80,0,0,5261,1047,3228,425,526,0,3727,0,0,0,65,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,5,0,-4,0.63);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(5007,12763,35061,'Nephilim Mercenary','','a_royal_guardA_MHuman','8.00','24.00',72,'male','L2SiegeGuard','Mystic',40,185726,178.000,800,2.300,84,71,73,76,70,80,0,0,4792,983,2909,399,613,0,4347,7,0,0,50,195,'mercenary_siege_clan',1200,1,'Local','',0,0,0,7,30,4,5,0,-4,0.48),
(5008,12024,35062,'Headquarters','','flag_a','15.00','58.00',1,'etc','L2Folk','npc',40,158000,2.000,989,0.900,40,43,30,21,20,10,0,0,652,753,358,295,423,0,385,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,0,4,3,0,0,0.60),
(5009,0,35063,'Gludio Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5010,0,35064,'Baron Lewin Waldner','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','Fighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,0,0,4308,418,619,340,278,0,253,79,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5011,12010,35065,'Cronenberg','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','Fighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5012,12011,35066,'Royal Knight','Gludio','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5013,12012,35067,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5014,12013,35068,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5015,12014,35069,'Court Guard','Gludio','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5016,12015,35070,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5017,12016,35071,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5018,12017,35072,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5019,12018,35073,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5020,12019,35074,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5021,12020,35075,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5022,12021,35076,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5023,12022,35077,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5024,12023,35078,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5025,12025,35079,'Royal Knight','Gludio','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5026,12026,35080,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5027,12027,35081,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5028,12028,35082,'Court Guard','Gludio','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5029,12029,35083,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5030,12030,35084,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5031,12031,35085,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5032,12032,35086,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5033,12033,35087,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5034,12034,35088,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5035,12035,35089,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5036,12036,35090,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5037,12037,35091,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5038,12838,35092,'Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5039,12839,35093,'Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5040,12840,35094,'Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5041,12841,35095,'Mass Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5042,12842,35096,'Outer Doorman','Gludio','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5043,12843,35097,'Inner Doorman','Gludio','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5044,0,35098,'Blacksmith','Gludio','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5045,0,35099,'Warehouse Keeper','Gludio','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5046,12252,35100,'Sayres','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5047,0,35101,'Grad','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5048,12316,35102,'Greenspan','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5049,0,35103,'Manor Manager','Gludio','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5050,12253,35104,'Tyron','Sir','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,74,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5051,12123,35105,'Dion Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5052,12093,35106,'Duke Byron Ashton','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','Fighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5053,12094,35107,'Ivano','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','Fighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5054,12095,35108,'Royal Knight','Dion','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'dion_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5055,12096,35109,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5056,12097,35110,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5057,12098,35111,'Court Guard','Dion','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5058,12099,35112,'Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5059,12100,35113,'Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5060,12101,35114,'Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5061,12102,35115,'Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5062,12103,35116,'Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5063,12104,35117,'Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5064,12105,35118,'Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5065,12106,35119,'Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5066,12107,35120,'Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5067,12108,35121,'Royal Knight','Dion','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'dion_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5068,12109,35122,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5069,12110,35123,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5070,12111,35124,'Court Guard','Dion','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5071,12112,35125,'Court Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5072,12113,35126,'Court Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5073,12114,35127,'Court Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5074,12115,35128,'Court Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5075,12116,35129,'Court Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5076,12117,35130,'Court Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5077,12118,35131,'Court Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5078,12119,35132,'Court Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5079,12120,35133,'Court Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5080,12155,35134,'Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5081,12156,35135,'Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5082,12157,35136,'Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5083,12158,35137,'Mass Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5084,12159,35138,'Outer Doorman','Dion','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5085,12160,35139,'Inner Doorman','Dion','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5086,0,35140,'Blacksmith','Dion','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5087,0,35141,'Warehouse Keeper','Dion','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5088,12121,35142,'Crosby','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5089,0,35143,'Hodler','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5090,12317,35144,'Mercenary Manager Sanford','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5091,0,35145,'Manor Manager','Dion','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5092,12122,35146,'Gibbson','Herald','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5093,12154,35147,'Giran Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5094,12124,35148,'Baron Carmon Esthus','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','Fighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,0,0,4308,418,619,340,278,0,253,79,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5095,12125,35149,'Ulric','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','Fighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,0,0,3777,388,532,315,278,0,253,142,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5096,12126,35150,'Royal Knight','Giran','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'giran_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5097,12127,35151,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5098,12128,35152,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5099,12129,35153,'Court Guard','Giran','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5100,12130,35154,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5101,12131,35155,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5102,12132,35156,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5103,12133,35157,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5104,12134,35158,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5105,12135,35159,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5106,12136,35160,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5107,12137,35161,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5108,12138,35162,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5109,12139,35163,'Royal Knight','Giran','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'giran_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5110,12140,35164,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5111,12141,35165,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5112,12142,35166,'Court Guard','Giran','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5113,12143,35167,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5114,12144,35168,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5115,12145,35169,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5116,12146,35170,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5117,12147,35171,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5118,12148,35172,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5119,12149,35173,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5120,12150,35174,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5121,12151,35175,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5122,12162,35176,'Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5123,12163,35177,'Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5124,12164,35178,'Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5125,12165,35179,'Mass Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5126,12166,35180,'Outer Doorman','Giran','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5127,12167,35181,'Inner Doorman','Giran','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5128,0,35182,'Blacksmith','Giran','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5129,0,35183,'Warehouse Keeper','Giran','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5130,12152,35184,'Saul','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5131,0,35185,'Bryce','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5132,12319,35186,'Arvid','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5133,0,35187,'Manor Manager','Giran','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5134,12153,35188,'Holmes','Sir','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5135,12242,35189,'Oren Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5136,0,35190,'Balthus Van Dyke','Duke','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','Fighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5137,12213,35191,'Quant','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','Fighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,0,0,3777,388,532,315,278,0,253,142,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5138,12214,35192,'Royal Knight','Oren','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5139,12215,35193,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5140,12216,35194,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5141,12217,35195,'Court Guard','Oren','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5142,12218,35196,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5143,12219,35197,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5144,12220,35198,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5145,12221,35199,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5146,12222,35200,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5147,12223,35201,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5148,12224,35202,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5149,12225,35203,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5150,12226,35204,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5151,12227,35205,'Royal Knight','Oren','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5152,12228,35206,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5153,12229,35207,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5154,12230,35208,'Court Guard','Oren','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5155,12231,35209,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5156,12232,35210,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5157,12233,35211,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5158,12234,35212,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5159,12235,35213,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5160,12236,35214,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5161,12237,35215,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5162,12238,35216,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5163,12239,35217,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5164,12243,35218,'Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5165,12244,35219,'Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5166,12245,35220,'Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5167,12246,35221,'Mass Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5168,12247,35222,'Outer Doorman','Oren','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(5169,12248,35223,'Inner Doorman','Oren','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5170,0,35224,'Blacksmith','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5171,0,35225,'Warehouse Keeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5172,12240,35226,'Brasseur','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5173,0,35227,'Finrod','Wyvern Manager','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,0,0,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5174,12318,35228,'Morrison','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5175,0,35229,'Manor Manager','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,3862,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5176,0,35230,'Manor Manager','Oren','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,3862,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5177,0,35231,'Manor Manager','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,3862,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,93,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5178,12241,35232,'Sherwood','Messenger','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5179,12291,35233,'Aden Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,721,2.500,213,1.200,40,43,30,21,20,10,0,0,57,189,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5180,12254,35234,'Amadeo Cadmus','King','a_lord_MHuman','8.00','23.00',75,'male','L2SiegeGuard','Fighter',40,84582,8.500,6694,3.000,40,43,30,21,20,10,562,1,9383,523,957,425,278,0,253,80,0,0,50,120,'oren_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5181,12265,35235,'Royal Knight','Aden','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,38622,7.500,5975,2.700,40,43,30,21,20,10,0,0,3943,470,780,382,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5182,12266,35236,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Mystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,0,0,3652,449,713,365,278,0,253,7,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5183,12267,35237,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Mystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,0,0,3652,449,713,365,278,0,253,92,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5184,12268,35238,'Court Guard','Aden','a_royal_guardB_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Fighter',80,37063,7.500,5693,2.700,40,43,30,21,20,10,0,0,3652,449,713,365,237,0,216,1376,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5185,12269,35239,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,237,0,216,300,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5186,12270,35240,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,278,0,253,132,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5187,12271,35241,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Ranger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5188,12272,35242,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5189,12273,35243,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5190,12274,35244,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Ranger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5191,12275,35245,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5192,12276,35246,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5193,12277,35247,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Ranger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5194,12278,35248,'Royal Knight','Aden','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,38622,7.500,5975,2.700,40,43,30,21,20,10,490,1,3943,470,780,382,278,0,253,142,633,0,50,120,'aden_siege_clan',1200,1,'Local','',0,20,147,7,30,4,4,0,-6,0.60),
(5195,12279,35249,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Mystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,253,326,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5196,12280,35250,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'female','L2SiegeGuard','Mystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,253,325,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5197,12281,35251,'Court Guard','Aden','a_royal_guardB_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Fighter',80,37063,7.500,5693,2.700,40,43,30,21,20,10,462,1,3652,449,713,365,237,0,216,300,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5198,12282,35252,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5199,12283,35253,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5200,12284,35254,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Ranger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,7486,428,649,348,249,0,227,285,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5201,12285,35255,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5202,12286,35256,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5203,12287,35257,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Ranger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5204,12288,35258,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5205,12289,35259,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5206,12290,35260,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Ranger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5207,12292,35261,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5208,12293,35262,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5209,12294,35263,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5210,12295,35264,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5211,12296,35265,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5212,12297,35266,'Mass Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5213,12298,35267,'Outer Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5214,12299,35268,'Inner Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5215,12322,35269,'Hall Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5216,12323,35270,'Inner Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5217,12830,35271,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5218,0,35272,'Blacksmith','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5219,0,35273,'Warehouse Keeper','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5220,12255,35274,'Logan','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5221,0,35275,'Kruger','Wyvern Manager','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Fighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5222,12320,35276,'Eldon','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5223,0,35277,'Manor Manager','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Ranger',1100,3862,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5224,12259,35278,'Messenger Ruford','Messenger','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,135,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5225,12602,35279,'Innadril Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5226,12572,35280,'Baron Lionel Hunter','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','Fighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5227,12573,35281,'Schaht','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','Fighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5228,12574,35282,'Royal Knight','Innadril','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5229,12575,35283,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5230,12576,35284,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5231,12577,35285,'Court Guard','Innadril','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5232,12578,35286,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5233,12579,35287,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5234,12580,35288,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5235,12581,35289,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5236,12582,35290,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5237,12583,35291,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5238,12584,35292,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5239,12585,35293,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5240,12586,35294,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5241,12587,35295,'Royal Knight','Innadril','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5242,12588,35296,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5243,12589,35297,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5244,12590,35298,'Court Guard','Innadril','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5245,12591,35299,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5246,12592,35300,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5247,12593,35301,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5248,12594,35302,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5249,12595,35303,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5250,12596,35304,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5251,12597,35305,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5252,12598,35306,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5253,12599,35307,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5254,0,35308,'Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5255,0,35309,'Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5256,0,35310,'Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5257,0,35311,'Mass Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5258,0,35312,'Outer Doorman','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5259,0,35313,'Inner Doorman','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5260,0,35314,'Blacksmith','Innadril','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5261,0,35315,'Warehouse Keeper','Innadril','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5262,12600,35316,'Neurath','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5263,0,35317,'Tate','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5264,12613,35318,'Solinus','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5265,0,35319,'Manor Manager','Innadril','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5266,12601,35320,'Raybell','Sir','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5267,12831,35322,'Altar of Fire','','godad_holything','24.00','65.00',20,'etc','L2Artefact','Fighter',40,558,1.200,213,1.200,40,43,30,21,20,10,0,0,57,97,23,79,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5268,12832,35323,'Altar of Water','','godad_holything','24.00','65.00',20,'etc','L2Artefact','Fighter',40,558,1.200,213,1.200,40,43,30,21,20,10,0,0,57,97,23,79,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5269,0,35324,'Heinz','Royal Guard Captain','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5270,12794,35325,'Duke Mora Ken Abygail','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','Fighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5271,12795,35326,'Royal Knight','Goddard','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'godad_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5272,12796,35327,'Court Sorcerer','Goddard','a_patriarch_MElf','8.00','22.50',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5273,12797,35328,'Court Sorcerer','Goddard','a_mageguild_master_FHuman','8.00','23.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5274,12798,35329,'Guard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,1376,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5275,12799,35330,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5276,12800,35331,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5277,12801,35332,'Bodyguard','Goddard','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5278,12802,35333,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5279,12803,35334,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5280,12804,35335,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5281,12805,35336,'Bodyguard','Goddard','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5282,12806,35337,'Bodyguard','Goddard','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5283,12807,35338,'Bodyguard','Goddard','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,280,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5284,12808,35339,'Royal Knight','Goddard','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'godad_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5285,12809,35340,'Court Sorcerer','Goddard','a_patriarch_MElf','8.00','22.50',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5286,12810,35341,'Court Sorcerer','Goddard','a_mageguild_master_FHuman','8.00','23.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5287,12811,35342,'Guard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,1376,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5288,12812,35343,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5289,12813,35344,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5290,12814,35345,'Bodyguard','Goddard','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5291,12815,35346,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5292,12816,35347,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5293,12817,35348,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5294,12818,35349,'Bodyguard','Goddard','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5295,12819,35350,'Bodyguard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','Fighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,76,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5296,12820,35351,'Bodyguard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','Ranger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,280,0,0,50,120,'godad_siege_clan',1200,1,'Local','',0,0,0,7,10,8,0,1500,0,0.60),
(5297,12821,35352,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5298,12822,35353,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5299,12823,35354,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5300,12824,35355,'Mass Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5301,12825,35356,'Outer Doorman','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5302,12826,35357,'Inner Doorman','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5303,12827,35358,'Inner Doorman','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5304,12828,35359,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5305,12829,35360,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5306,0,35361,'Blacksmith','Goddard','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5307,0,35362,'Warehouse Keeper','Goddard','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5308,12791,35363,'Alfred','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5309,0,35364,'Hadley','Wyvern Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5310,12790,35365,'Rowell','Manager of Mercenary','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5311,0,35366,'Manor Manager','Goddard','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5312,12792,35367,'Daven','Messenger','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5313,12038,35368,'Bloody Lord Nurka','','oel_mahum','20.00','37.00',55,'male','L2Monster','Fighter',40,1264000,40.000,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,282,0,257,72,0,0,70,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5314,12039,35369,'Partisan Healer','','batur_orc_shaman','11.00','16.00',40,'male','L2Monster','Priest',40,1527,4.500,531,5.000,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,7,0,0,50,120,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.30),
(5315,12040,35370,'Partisan Court Guard','','ol_mahum_champion','14.00','27.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,69,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.63),
(5316,12041,35371,'Partisan Court Guard','','ol_mahum_archer','14.00','25.00',40,'male','L2Monster','Ranger',1100,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,333,201,131,164,254,0,231,14,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,1500,0,0.93),
(5317,12042,35372,'Partisan Soldier','','ol_mahum','13.50','25.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,2,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.46),
(5318,12043,35373,'Partisan Sorcerer','','batur_orc_shaman','11.00','16.00',35,'male','L2Monster','Mystic',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,7,0,0,50,120,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.30),
(5319,12044,35374,'Partisan Archer','','ol_mahum_archer','14.00','25.00',35,'male','L2Monster','Ranger',1100,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,427,169,89,137,254,0,231,14,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,1500,0,0.93),
(5320,12045,35375,'Bloody Lord Nurka','','oel_mahum','20.00','37.00',55,'male','L2Monster','Fighter',40,1264000,60.000,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,282,0,257,72,0,0,70,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5321,12046,35376,'Partisan Healer','','batur_orc_shaman','11.00','16.00',40,'male','L2Monster','Priest',40,1527,4.500,531,5.000,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,7,0,0,50,120,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.30),
(5322,12047,35377,'Partisan Court Guard','','ol_mahum_champion','14.00','27.00',40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,69,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.63),
(5323,12048,35378,'Partisan Court Guard','','ol_mahum_archer','14.00','25.00',40,'male','L2Monster','Ranger',1100,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,333,201,131,164,254,0,231,14,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,1500,0,0.93),
(5324,12049,35379,'Partisan Soldier','','ol_mahum','13.50','25.00',35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,2,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.46),
(5325,12050,35380,'Partisan Sorcerer','','batur_orc_shaman','11.00','16.00',35,'male','L2Monster','Mystic',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,7,0,0,50,120,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,0,0,0.30),
(5326,12051,35381,'Partisan Archer','','ol_mahum_archer','14.00','25.00',35,'male','L2Monster','Ranger',1100,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,235,169,89,137,254,0,231,14,0,0,50,110,'partisan_clan',300,0,'Local','',0,0,0,7,30,4,3,1500,0,0.93),
(5327,12845,35382,'Brakel','Partisan Herald','ol_mahum_champion','14.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(5328,12844,35383,'Tamutak','Ol Mahum Steward','ol_mahum_champion','14.00','27.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.63),
(5329,12851,35384,'Black','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5330,0,35385,'Renny','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,4.500,414,1.800,40,43,30,21,20,10,0,0,171,162,75,128,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(5331,12853,35386,'Boyer','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5332,0,35387,'Baback','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,4.500,514,1.800,40,43,30,21,20,10,0,0,263,201,121,158,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5333,12854,35388,'Tim','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5334,0,35389,'Loring','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,5.500,618,2.100,40,43,30,21,20,10,0,0,343,230,163,181,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5335,12852,35390,'Dillon','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5336,0,35391,'Latif','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,5.500,738,2.100,40,43,30,21,20,10,0,0,440,262,216,206,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5337,12848,35392,'Bremmer','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5338,0,35393,'Faolan','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,6.500,892,2.400,40,43,30,21,20,10,0,0,588,304,300,239,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5339,12849,35394,'Kalis','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5340,0,35395,'Kogan','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,3.500,242,1.500,40,43,30,21,20,10,0,0,71,106,28,83,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5341,12850,35396,'Winker','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5342,0,35397,'Merton','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,3.500,318,1.500,40,43,30,21,20,10,0,0,107,129,45,102,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5343,12846,35398,'Ruben','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5344,0,35399,'Luce','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,4.500,381,1.800,40,43,30,21,20,10,0,0,147,151,64,118,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5345,12847,35400,'Horner','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5346,0,35401,'Amiel','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,4.500,414,1.800,40,43,30,21,20,10,0,0,171,162,75,128,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5347,0,35402,'Borna','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,4.500,446,1.800,40,43,30,21,20,10,0,0,198,175,89,137,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5348,12862,35403,'Ron','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5349,0,35404,'Jamal','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,5.500,589,2.100,40,43,30,21,20,10,0,0,321,222,152,175,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5350,12863,35405,'Flynn','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5351,0,35406,'Jabilo','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,5.500,677,2.100,40,43,30,21,20,10,0,0,389,245,188,193,278,0,253,0,0,0,80,156,'',0,0,'Local','',0,0,0,7,10,4,4,0,0,0.56),
(5352,12861,35407,'Seth','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5353,12532,35408,'Dietrich','','headless_knight','21.00','31.00',67,'male','L2Monster','Fighter',40,16388,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,1,'Local','',0,0,0,1,30,4,40,0,-18,0.52),
(5354,12533,35409,'Mikhail','','headless_knight','21.00','31.00',67,'male','L2Monster','Fighter',40,16388,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,1,'Local','',0,0,0,1,30,4,40,0,-18,0.52),
(5355,12534,35410,'Gustav','','headless_knight','21.00','31.00',70,'male','L2Monster','Fighter',40,8092000,7.500,2987,2.700,60,57,73,76,70,80,0,0,3987,469,1732,381,333,0,2362,0,0,0,70,180,'',0,1,'Local','',0,0,0,1,30,4,40,0,-18,0.52),
(5356,12565,35411,'Doom Servant','','hungry_spirit','13.00','40.00',65,'male','L2Monster','Fighter',40,9571,7.500,1150,2.700,40,43,30,21,20,10,0,0,2151,417,617,338,278,150,253,0,0,0,15,120,'gustav_clan',1000,1,'Local','',0,0,0,7,50,1,40,0,0,0.45),
(5357,12566,35412,'Doom Guard','','hungry_spirit','13.00','40.00',66,'male','L2Monster','Fighter',50,10639,7.500,1184,2.700,40,43,30,21,20,10,0,0,2243,427,649,347,278,0,253,0,0,0,15,120,'gustav_clan',1000,1,'Local','',0,0,0,7,50,1,40,0,0,0.45),
(5358,12567,35413,'Doom Archer','','skeleton_archer','11.00','27.00',67,'male','L2Monster','Ranger',1100,10879,7.500,1217,2.700,40,43,30,21,20,10,0,0,5191,438,680,356,249,0,227,286,0,0,40,140,'gustav_clan',700,1,'Local','',0,0,0,7,10,8,40,1500,0,0.80),
(5359,12568,35414,'Doom Trooper','','skeleton_pikeman','10.00','28.00',68,'male','L2Monster','Fighter',80,11118,7.500,1251,2.700,40,43,30,21,20,10,0,0,2839,449,713,364,238,0,217,301,0,0,50,155,'gustav_clan',1000,1,'Local','',0,0,0,7,30,4,40,0,0,0.21),
(5360,12569,35415,'Doom Warrior','','skeleton_knight','10.00','25.00',69,'male','L2Monster','Fighter',40,11353,7.500,1285,2.700,40,43,30,21,20,10,0,0,2529,459,745,373,317,150,289,71,0,0,40,160,'gustav_clan',1000,1,'Local','',0,0,0,7,10,8,40,0,0,0.17),
(5361,12570,35416,'Doom Knight','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,11586,7.500,1319,2.700,40,43,30,21,20,10,0,0,2297,469,779,381,278,150,253,1472,0,0,100,170,'gustav_clan',1000,1,'Local','',0,0,0,7,30,4,40,0,0,0.45),
(5362,0,35417,'Doorman of Hell','','dwarf_ghost','10.00','18.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5363,0,35418,'Doorman of Hell','','dwarf_ghost','10.00','18.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5364,0,35419,'Hephaeston','Wyvern Manager','human_ghost','8.00','22.00',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5365,12888,35420,'Loken','Messenger','human_ghost','8.00','22.00',70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,80,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.39),
(5366,12887,35421,'Biggerstaff','Steward','elf_ghost','7.00','21.00',70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.41),
(5367,12551,35422,'Flag of Winner','','azit_a','100.00','72.00',56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5368,12552,35423,'Red Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5369,12553,35424,'Yellow Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5370,12554,35425,'Green Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5371,12555,35426,'Blue Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5372,12556,35427,'Purple Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5373,12539,35428,'Oel Mahum Berserker','','oel_mahum_warrior','20.00','38.00',60,'male','L2Monster','Fighter',40,125202,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,1476,5200,598,333,0,2362,0,0,0,70,140,'',0,0,'Local','',0,0,0,7,30,4,40,0,-18,0.65),
(5374,12540,35429,'Oel Mahum Scout','','oel_mahum_warrior','20.00','38.00',60,'male','L2Monster','Fighter',40,56341,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,1476,5200,598,333,0,2362,0,0,0,70,140,'',0,0,'Local','',0,0,0,7,30,4,40,0,-18,0.65),
(5375,12541,35430,'Oel Mahum Leader','','oel_mahum_witch_doctor','15.00','34.00',60,'male','L2Monster','Fighter',40,62601,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,2953,5200,299,333,0,2362,0,0,0,70,140,'',0,0,'Local','',0,0,0,7,30,4,40,0,-18,0.26),
(5376,12542,35431,'Oel Mahum Cleric','','oel_mahum_witch_doctor','15.00','34.00',60,'male','L2Monster','Priest',40,62601,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,738,5200,1197,333,0,2362,0,0,0,70,140,'',0,0,'Local','',0,0,0,7,30,4,40,0,-18,0.26),
(5377,12543,35432,'Oel Mahum Thief','','oel_mahum_40_sm','12.00','19.00',60,'male','L2Monster','Fighter',40,50080,156.800,3420,10.000,60,57,73,76,70,80,0,0,544,1181,5200,538,333,0,2362,0,0,0,70,140,'',0,0,'Local','',0,0,0,7,30,4,40,0,-18,0.48),
(5378,12557,35433,'Inner Doorman','','oel_mahum','20.00','37.00',70,'male','L2Folk','npc',40,5149,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5379,12558,35434,'Inner Doorman','','oel_mahum','20.00','37.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5380,12559,35435,'Outer Doorman','','oel_mahum','20.00','37.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5381,12560,35436,'Outer Doorman','','oel_mahum','20.00','37.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5382,12561,35437,'Messenger','','oel_mahum','20.00','37.00',56,'male','L2Folk','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,70,120,'dion_siege_clan',600,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5383,12562,35438,'Chamberlain','','oel_mahum','20.00','37.00',56,'male','L2ClanHallManager','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,2530,0,0,0,70,120,'dion_siege_clan',600,0,'Local','',0,0,0,7,30,4,3,0,0,0.48),
(5384,12889,35439,'Carey','Clan Hall Manager','a_maidB_FHuman','8.00','22.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5385,0,35440,'Daniel','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5386,12890,35441,'Dianne','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5387,0,35442,'Jacques','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5388,12891,35443,'Crissy','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5389,0,35444,'Joff','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5390,12892,35445,'Albert','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5391,0,35446,'Niels','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5392,12893,35447,'Korgen','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5393,0,35448,'Rudy','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5394,12894,35449,'DiMaggio','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5395,0,35450,'Gellar','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5396,12835,35451,'Emma','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5397,0,35452,'Theobolt','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5398,12833,35453,'Adrienne','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5399,0,35454,'Rosconne','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5400,12834,35455,'Bianca','Clan Hall Manager','a_maidB_FHuman','8.00','22.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5401,0,35456,'Stewart','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5402,12836,35457,'Gladys','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5403,0,35458,'Theron','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5404,12837,35459,'Regina','Clan Hall Manager','a_maidB_FHuman','8.00','22.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5405,0,35460,'Trey','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5406,12898,35461,'Aida','Clan Hall Manager','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5407,0,35462,'Kalmer','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5408,12897,35463,'Helga','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5409,0,35464,'Volfrem','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5410,12896,35465,'Millicent','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5411,0,35466,'Gerard','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5412,12895,35467,'Branhillde','Clan Hall Manager','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5413,0,35468,'Lambert','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5414,0,35469,'Gods'' Altar','','rune_holything','46.00','72.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5415,0,35470,'Astair van Halter','King','a_lord_MHuman','8.00','23.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5416,0,35471,'Royal Knight','Rune','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'rune_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5417,0,35472,'Court Sorcerer','Rune','a_patriarch_MElf','8.00','23.00',68,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5418,0,35473,'Court Sorcerer','Rune','a_mageguild_master_FHuman','8.00','23.00',68,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5419,0,35474,'Court Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5420,0,35475,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5421,0,35476,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5422,0,35477,'Guard','Rune','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5423,0,35478,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5424,0,35479,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5425,0,35480,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5426,0,35481,'Guard','Rune','e_guard_MOrc','8.00','27.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5427,0,35482,'Guard','Rune','e_guard_MOrc','8.00','27.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5428,0,35483,'Guard','Rune','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5429,0,35484,'Royal Knight','Rune','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'rune_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5430,0,35485,'Court Sorcerer','Rune','a_patriarch_MElf','8.00','23.00',68,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5431,0,35486,'Court Sorcerer','Rune','a_mageguild_master_FHuman','8.00','23.00',68,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5432,0,35487,'Court Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',68,'male','L2SiegeGuard','Fighter',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5433,0,35488,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5434,0,35489,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5435,0,35490,'Guard','Rune','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5436,0,35491,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5437,0,35492,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5438,0,35493,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5439,0,35494,'Guard','Rune','e_guard_MOrc','8.00','27.00',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5440,0,35495,'Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5441,0,35496,'Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',66,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5442,0,35497,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5443,0,35498,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5444,0,35499,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5445,0,35500,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5446,0,35501,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5447,0,35502,'Group Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5448,0,35503,'Outer Doorman','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5449,0,35504,'Inner Doorman','Rune','e_elmore_guard_Mhuman','8.00','23.50',0,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5450,0,35505,'Inner Doorman','Rune','e_elmore_guard_Mhuman','8.00','23.50',0,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5451,0,35506,'Dungeon Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5452,0,35507,'Blacksmith','Rune','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5453,0,35508,'Warehouse Keeper','Rune','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5454,0,35509,'Frederick','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5455,0,35510,'Titus','Wyvern Manager','a_fighterguild_teacher_MHuman','8.00','17.00',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5456,0,35511,'Gompus','Mercenary Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5457,0,35512,'Manor Manager','Rune','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5458,0,35513,'Sherman','Messenger','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,135,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5459,0,35514,'Altar of Wind','','godad_holything','65.00','0.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5460,0,35515,'Altar of Earth','','godad_holything','65.00','0.00',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5461,0,35516,'Verus','Royal Guard Captain','big_boom','6.00','13.00',60,'male','L2Pet','npc',40,51515,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(5462,0,35517,'Swain Ken Orwen','Count','a_lord_MHuman','8.00','23.00',65,'male','L2Folk','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,750,0,0.60),
(5463,0,35518,'Royal Knight','Schuttgart','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','Fighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,20,123,7,30,4,4,0,-6,0.60),
(5464,0,35519,'Court Sorcerer','Schuttgart','a_patriarch_MElf','8.00','22.50',58,'male','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5465,0,35520,'Court Sorcerer','Schuttgart','a_mageguild_master_FHuman','8.00','23.00',58,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,50,1,9,0,0,0.60),
(5466,0,35521,'Court Guard','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',58,'male','L2SiegeGuard','Fighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5467,0,35522,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5468,0,35523,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5469,0,35524,'Guard','Schuttgart','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5470,0,35525,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5471,0,35526,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5472,0,35527,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5473,0,35528,'Guard','Schuttgart','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5474,0,35529,'Guard','Schuttgart','silver_cat','7.00','15.00',42,'male','L2Pet','npc',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5475,0,35530,'Guard','Schuttgart','blue_eye','11.00','16.00',42,'male','L2Pet','npc',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5476,0,35531,'Royal Knight','Schuttgart','shadeless','7.00','28.00',42,'male','L2Pet','npc',40,24436,5.500,679,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5477,0,35532,'Court Sorcerer','Schuttgart','headless_knight','21.00','31.00',67,'male','L2Monster','Fighter',40,23114,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,1,'Local','',0,0,0,1,30,4,40,0,-18,0.52),
(5478,0,35533,'Court Sorcerer','Schuttgart','headless_knight','21.00','31.00',67,'male','L2Monster','Fighter',40,23114,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,1,'Local','',0,0,0,1,30,4,40,0,-18,0.52),
(5479,0,35534,'Court Guard','Schuttgart','headless_knight','21.00','31.00',70,'male','L2Monster','Fighter',40,8092000,7.500,2987,2.700,60,57,73,76,70,80,0,0,3987,469,1732,381,333,0,2362,0,0,0,70,180,'',0,1,'Local','',0,0,0,1,30,4,40,0,-18,0.52),
(5480,0,35535,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5481,0,35536,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5482,0,35537,'Guard','Schuttgart','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5483,0,35538,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5484,0,35539,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5485,0,35540,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5486,0,35541,'Guard','Schuttgart','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5487,0,35542,'Guard','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5488,0,35543,'Guard','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','Fighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,1,'Local','',0,0,0,7,30,4,0,0,0,0.60),
(5489,0,35544,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'schuttgart_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5490,0,35545,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'schuttgart_siege_clan',600,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5491,0,35546,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,5817,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,750,0,0.60),
(5492,0,35547,'Group Gatekeeper','Schuttgart','a_guard_MElf','8.00','23.50',70,'male','L2Folk','npc',40,2724,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,1,'Local','',35547,0,0,7,30,4,4,750,0,0.60),
(5493,0,35548,'Outer Doorman','Schuttgart','a_guard_FDarkelf','8.00','25.00',70,'female','L2Folk','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,750,0,0.60),
(5494,0,35549,'Inner Doorman','Schuttgart','e_guard_MDwarf','8.00','19.00',70,'male','L2Folk','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,750,0,0.60),
(5495,0,35550,'Inner Doorman','Schuttgart','e_guard_MOrc','8.00','27.00',70,'male','L2Folk','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,1,'Local','',0,0,0,7,30,4,4,750,0,0.60),
(5496,0,35551,'Doorman  ','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(5497,0,35552,'Doorman  ','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5498,0,35553,'Blacksmith','Schuttgart','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5499,0,35554,'Warehouse Keeper','Schuttgart','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5500,0,35555,'August','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5501,0,35556,'Gallic','Wyvern Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5502,0,35557,'Kendrew','Mercenary Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5503,0,35558,'Manor Manager','Schuttgart','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5504,0,35559,'Daguerre','Messenger','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5505,12606,35560,'Mass Gatekeeper','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5506,0,35561,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5507,0,35562,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5508,0,35563,'Mass Gatekeeper','','a_teleporter_FHuman','8.00','25.00',56,'female','L2SiegeGuard','Fighter',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'',600,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5509,0,35564,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5510,0,35565,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5511,0,35566,'Ronald','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5512,0,35567,'Emil','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5513,0,35568,'Wayne','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5514,0,35569,'Daniel','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5515,0,35570,'Patty','Clan Hall Manager','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5516,0,35571,'Dale','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5517,0,35572,'Jimmy','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5518,0,35573,'Shawn','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5519,0,35574,'Michael','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5520,0,35575,'Ryan','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5521,0,35576,'Jack','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5522,0,35577,'Harry','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5523,0,35578,'Karuto','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5524,0,35579,'Egon','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5525,0,35580,'Carol','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5526,0,35581,'Osho','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5527,0,35582,'Stanley','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5528,0,35583,'Walter','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5529,0,35584,'Billy','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5530,0,35585,'Alice','Clan Hall Gatekeeper','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5531,0,35586,'Serena','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5532,0,35587,'Neria','Clan Hall Gatekeeper','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5533,0,35588,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5534,0,35589,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5535,0,35590,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5536,0,35591,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5537,0,35592,'Enraged Yeti','','yeti','15.00','27.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5538,0,35593,'Treasure Chest','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5539,0,35594,'Treasure Chest','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5540,0,35595,'Treasure Chest','','mimic','8.50','8.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5541,0,35596,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5542,0,35597,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5543,0,35598,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5544,0,35599,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5545,0,35600,'Manager','','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5546,0,35601,'Doorman','','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5547,0,35602,'Doorman','','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5548,0,35603,'Coordinator','','yeti','15.00','27.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5549,0,35604,'Messenger','','yeti_cute','5.00','10.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5550,0,35605,'Angout','Steward','yeti','15.00','27.50',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5551,0,35606,'Victor''s Flag','','azit_contest_pile_winner','63.50','97.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5552,0,35607,'Red Flag','','azit_contest_pile_a','52.00','195.50',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5553,0,35608,'Yellow Flag','','azit_contest_pile_b','51.80','108.25',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5554,0,35609,'Green Flag','','azit_contest_pile_c','51.80','108.25',70,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5555,0,35610,'Blue Flag','','azit_contest_pile_d','51.80','108.25',56,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5556,0,35611,'Purple Flag','','azit_contest_pile_e','51.80','108.25',56,'etc','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5557,0,35612,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5558,0,35613,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5559,0,35614,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5560,0,35615,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5561,0,35616,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5562,0,35617,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5563,0,35618,'Frenzied Cougar','','saber_toothed_tiger','28.00','0.00',60,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5564,0,35619,'Frenzied Buffalo','','buffalo','22.00','31.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5565,0,35620,'Frenzied Kookaburra','','rough_ostrich','10.00','33.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5566,0,35621,'Frenzied Buffalo Baby','','baby_buffalo','12.00','15.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5567,0,35622,'Frenzied Baby Cougar','','baby_tiger','11.00','15.70',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5568,12608,35623,'Inner Doorman','','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5569,0,35624,'Inner Doorman','','kel_mahum_champion','13.00','32.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5570,12607,35625,'Outer Doorman','','a_guard_MHuman','8.00','24.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5571,0,35626,'Outer Doorman','','kel_mahum_champion','13.00','32.00',70,'male','L2Doormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5572,0,35627,'Messenger','','kel_mahum_champion','13.00','32.00',56,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5573,0,35628,'Quigby','Farm Manager','kel_mahum_champion','13.00','32.00',56,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(5574,0,35629,'Lidia von Hellmann','','lidia_von_helmann','10.00','25.40',73,'female','L2Folk','npc',40,1869456,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5575,0,35630,'Alfred von Hellmann','','vampire_warrior','9.00','31.50',72,'male','L2Folk','npc',40,11353,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5576,0,35631,'Giselle von Hellmann','','vampire_wizard','5.50','28.80',71,'male','L2Folk','npc',40,11118,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5577,0,35632,'Vampire Adept','','vampire_witch','6.00','21.50',70,'male','L2Folk','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5578,0,35633,'Vampire Soldier','','vampire_soldier','8.00','23.50',70,'male','L2Folk','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5579,0,35634,'Vampire Caster','','vampire_witch','6.00','21.50',70,'male','L2Folk','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5580,0,35635,'Vampire Magister','','vampire_wizard','5.50','28.80',71,'male','L2Folk','npc',40,11118,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5581,0,35636,'Vampire Warlord','','vampire_warrior','9.00','31.50',72,'male','L2Folk','npc',40,11353,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5582,0,35637,'Vampire Leader','','vampire_lord','7.50','25.80',73,'male','L2Folk','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5583,0,35638,'Valens','Wyvern Manager','vampire_soldier','8.00','23.50',70,'male','L2WyvernManager','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5584,0,35639,'Jacquard','Messenger','vampire_soldier','8.00','23.50',70,'male','L2SiegeNpc','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5585,0,35640,'Bandello','Steward','vampire_soldier','8.00','23.50',70,'male','L2Folk','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5586,0,35641,'Fortress Guard','','vampire_soldier','8.00','23.50',70,'male','L2Folk','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5587,0,35642,'Fortress Guard','','vampire_soldier','8.00','23.50',70,'male','L2Folk','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5588,0,35643,'Gate  ','','farm_hedge','184.00','24.00',70,'male','L2Folk','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5589,0,35644,'Manor Manager','Schuttgart','a_traderA_MDwarf','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5590,0,35645,'Manor Manager','Schuttgart','e_trader_MOrc','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5591,0,35646,'Vampire Caster','','vampire_witch','6.00','21.50',70,'male','L2Folk','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5592,0,35647,'Vampire Leader','','vampire_lord','7.50','25.80',73,'male','L2Folk','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(5593,0,35648,'Court Magician','Gludio',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5594,0,35649,'Court Magician','Dion',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5595,0,35650,'Court Magician','Giran',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5596,0,35651,'Court Magician','Oren',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5597,0,35652,'Court Magician','Aden',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5598,0,35653,'Court Magician','Innadril',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5599,0,35654,'Court Magician','Goddard',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5600,0,35655,'Court Magician','Rune',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5601,0,35656,'Court Magician','Schuttgart',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(5602,12192,14001,'Reanimated Man','','skeleton','11.00','25.00',46,'male','L2Pet','npc',40,2914,5.500,816,2.100,40,43,30,21,20,25,0,0,482,245,202,230,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5603,12193,14002,'Reanimated Man','','skeleton','11.00','25.00',54,'male','L2Pet','npc',40,3843,6.500,1102,2.400,40,43,30,21,20,25,0,0,763,313,339,293,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5604,12465,14003,'Reanimated Man','','skeleton','11.00','25.00',62,'male','L2Pet','npc',40,4829,7.500,1404,2.700,40,43,30,21,20,25,0,0,1133,388,532,363,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5605,12466,14004,'Reanimated Man','','skeleton','11.00','25.00',66,'male','L2Pet','npc',40,5319,7.500,1561,2.700,40,43,30,21,20,25,0,0,1347,428,649,401,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5606,12467,14005,'Reanimated Man','','skeleton','11.00','25.00',70,'male','L2Pet','npc',40,5793,7.500,1722,2.700,40,43,30,21,20,25,0,0,1577,470,780,440,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5607,12468,14006,'Reanimated Man','','skeleton','11.00','25.00',74,'male','L2Pet','npc',40,6238,8.500,1888,3.000,40,43,30,21,20,25,0,0,1816,512,921,480,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5608,12469,14007,'Reanimated Man','','skeleton','11.00','25.00',76,'male','L2Pet','npc',40,6446,8.500,1972,3.000,40,43,30,21,20,25,0,0,1937,534,994,500,278,0,253,0,0,0,60,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.30),
(5609,13613,14008,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5610,13614,14009,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5611,13615,14010,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5612,13616,14011,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5613,13617,14012,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5614,13618,14013,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5615,13619,14014,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5616,13620,14015,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5617,13621,14016,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5618,13622,14017,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5619,13623,14018,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5620,13624,14019,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5621,13625,14020,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5622,13626,14021,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5623,13627,14022,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5624,13628,14023,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5625,13629,14024,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5626,13630,14025,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5627,13631,14026,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5628,13632,14027,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5629,13633,14028,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5630,13634,14029,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5631,13635,14030,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5632,13636,14031,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5633,13637,14032,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5634,13638,14033,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5635,13639,14034,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5636,13640,14035,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5637,13641,14036,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5638,13642,14037,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,253,0,0,0,60,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.30),
(5639,12194,14038,'Corrupted Man','','zombie','13.00','21.00',42,'male','L2Pet','npc',40,2490,5.500,1019,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,15,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(5640,12195,14039,'Corrupted Man','','zombie','13.00','21.00',50,'male','L2Pet','npc',40,3367,5.500,1435,2.100,40,43,30,21,20,25,0,0,611,278,264,260,278,0,253,0,0,0,15,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(5641,12196,14040,'Corrupted Man','','zombie','13.00','21.00',58,'male','L2Pet','npc',40,4333,6.500,1876,2.400,40,43,30,21,20,25,0,0,937,349,428,327,278,0,253,0,0,0,15,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(5642,12470,14041,'Corrupted Man','','zombie','13.00','21.00',64,'male','L2Pet','npc',40,5076,7.500,2223,2.700,40,43,30,21,20,25,0,0,1238,408,589,382,278,0,253,0,0,0,15,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(5643,12471,14042,'Corrupted Man','','zombie','13.00','21.00',68,'male','L2Pet','npc',40,5559,7.500,2462,2.700,40,43,30,21,20,25,0,0,1460,449,713,421,278,0,253,0,0,0,15,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(5644,12472,14043,'Corrupted Man','','zombie','13.00','21.00',72,'male','L2Pet','npc',40,6020,8.500,2707,3.000,40,43,30,21,20,25,0,0,1695,491,849,460,278,0,253,0,0,0,15,140,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.43),
(5645,13643,14044,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5646,13644,14045,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5647,13645,14046,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5648,13646,14047,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5649,13647,14048,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5650,13648,14049,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5651,13649,14050,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5652,13650,14051,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5653,13651,14052,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5654,13652,14053,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5655,13653,14054,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5656,13654,14055,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5657,13655,14056,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5658,13656,14057,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5659,13657,14058,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5660,13658,14059,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5661,13659,14060,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5662,13660,14061,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5663,13661,14062,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5664,13662,14063,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5665,13663,14064,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5666,13664,14065,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5667,13665,14066,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5668,13666,14067,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5669,13667,14068,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5670,13668,14069,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5671,13669,14070,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5672,13670,14071,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5673,13671,14072,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(5674,13672,14073,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,6642,8.500,3086,3.000,40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,253,0,0,0,15,140,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.43),
(5675,13179,14074,'Cursed Man','','doll_master','20.00','42.00',58,'male','L2Pet','npc',80,3467,7.800,1251,2.400,40,43,30,21,20,25,0,0,1015,349,428,327,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5676,13180,14075,'Cursed Man','','doll_master','20.00','42.00',62,'male','L2Pet','npc',80,3863,9.000,1404,2.700,40,43,30,21,20,25,0,0,1227,388,532,363,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5677,13181,14076,'Cursed Man','','doll_master','20.00','42.00',66,'male','L2Pet','npc',80,4255,9.000,1561,2.700,40,43,30,21,20,25,0,0,1459,428,649,401,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5678,13182,14077,'Cursed Man','','doll_master','20.00','42.00',70,'male','L2Pet','npc',80,4634,9.000,1722,2.700,40,43,30,21,20,25,0,0,1708,470,780,440,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5679,13183,14078,'Cursed Man','','doll_master','20.00','42.00',72,'male','L2Pet','npc',80,4816,10.200,1804,3.000,40,43,30,21,20,25,0,0,1837,491,849,460,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5680,13184,14079,'Cursed Man','','doll_master','20.00','42.00',74,'male','L2Pet','npc',80,4990,10.200,1888,3.000,40,43,30,21,20,25,0,0,1967,512,921,480,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5681,13185,14080,'Cursed Man','','doll_master','20.00','42.00',76,'male','L2Pet','npc',80,5157,10.200,1972,3.000,40,43,30,21,20,25,0,0,2098,534,994,500,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5682,13673,14081,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2229,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5683,13674,14082,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2245,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5684,13675,14083,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2261,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5685,13676,14084,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2277,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5686,13677,14085,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2293,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5687,13678,14086,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2309,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5688,13679,14087,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2325,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5689,13680,14088,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2341,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5690,13681,14089,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2357,555,1069,520,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5691,13682,14090,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2388,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5692,13683,14091,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2404,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5693,13684,14092,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2420,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5694,13685,14093,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2436,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5695,13686,14094,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2452,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5696,13687,14095,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2468,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5697,13688,14096,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2484,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5698,13689,14097,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2500,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5699,13690,14098,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2517,558,1082,523,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5700,13691,14099,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2548,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5701,13692,14100,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2564,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5702,13693,14101,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2580,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5703,13694,14102,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2596,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5704,13695,14103,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2613,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5705,13696,14104,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2629,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5706,13697,14105,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2645,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5707,13698,14106,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2661,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5708,13699,14107,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2678,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5709,13700,14108,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2694,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5710,13701,14109,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2710,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5711,13702,14110,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5314,10.200,2057,3.000,40,43,30,21,20,25,0,0,2726,562,1095,526,278,0,253,0,0,0,80,160,'',0,1,'Local','',0,0,0,7,30,8,4,0,0,0.56),
(5712,12006,14111,'Kat the Cat','','cat_the_cat','9.00','16.00',22,'male','L2Pet','npc',40,978,3.500,279,1.500,40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5713,12007,14112,'Kat the Cat','','cat_the_cat','9.00','16.00',32,'male','L2Pet','npc',40,1689,4.500,458,1.800,40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5714,12008,14113,'Kat the Cat','','cat_the_cat','9.00','16.00',42,'male','L2Pet','npc',40,2656,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5715,12175,14114,'Kat the Cat','','cat_the_cat','9.00','16.00',50,'male','L2Pet','npc',40,3592,5.500,957,2.100,40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5716,12176,14115,'Kat the Cat','','cat_the_cat','9.00','16.00',58,'male','L2Pet','npc',40,4622,6.500,1251,2.400,40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5717,12344,14116,'Kat the Cat','','cat_the_cat','9.00','16.00',27,'male','L2Pet','npc',40,1302,3.500,367,1.500,40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5718,12345,14117,'Kat the Cat','','cat_the_cat','9.00','16.00',37,'male','L2Pet','npc',40,2142,4.500,553,1.800,40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5719,12346,14118,'Kat the Cat','','cat_the_cat','9.00','16.00',46,'male','L2Pet','npc',40,3108,5.500,816,2.100,40,43,30,21,20,25,0,0,401,245,202,230,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5720,12347,14119,'Kat the Cat','','cat_the_cat','9.00','16.00',54,'male','L2Pet','npc',40,4099,6.500,1102,2.400,40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5721,12411,14120,'Kat the Cat','','cat_the_cat','9.00','16.00',60,'male','L2Pet','npc',40,4887,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5722,12412,14121,'Kat the Cat','','cat_the_cat','9.00','16.00',62,'male','L2Pet','npc',40,5151,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5723,12413,14122,'Kat the Cat','','cat_the_cat','9.00','16.00',64,'male','L2Pet','npc',40,5414,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5724,12414,14123,'Kat the Cat','','cat_the_cat','9.00','16.00',66,'male','L2Pet','npc',40,5674,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5725,12415,14124,'Kat the Cat','','cat_the_cat','9.00','16.00',68,'male','L2Pet','npc',40,5930,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5726,12416,14125,'Kat the Cat','','cat_the_cat','9.00','16.00',70,'male','L2Pet','npc',40,6179,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5727,12417,14126,'Kat the Cat','','cat_the_cat','9.00','16.00',72,'male','L2Pet','npc',40,6421,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5728,12418,14127,'Kat the Cat','','cat_the_cat','9.00','16.00',74,'male','L2Pet','npc',40,6654,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5729,12419,14128,'Kat the Cat','','cat_the_cat','9.00','16.00',76,'male','L2Pet','npc',40,6876,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,80,120,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(5730,13253,14129,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5731,13254,14130,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5732,13255,14131,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5733,13256,14132,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5734,13257,14133,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5735,13258,14134,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5736,13259,14135,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5737,13260,14136,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5738,13261,14137,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5739,13262,14138,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5740,13263,14139,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5741,13264,14140,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5742,13265,14141,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5743,13266,14142,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5744,13267,14143,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5745,13268,14144,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5746,13269,14145,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5747,13270,14146,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5748,13271,14147,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5749,13272,14148,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5750,13273,14149,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5751,13274,14150,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5752,13275,14151,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5753,13276,14152,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5754,13277,14153,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5755,13278,14154,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5756,13279,14155,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5757,13280,14156,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5758,13281,14157,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5759,13282,14158,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,80,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(5760,12061,14159,'Mew the Cat','','cutie_cat','8.00','15.00',27,'female','L2Pet','npc',40,1302,3.500,367,1.500,40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5761,12062,14160,'Mew the Cat','','cutie_cat','8.00','15.00',37,'female','L2Pet','npc',40,2142,4.500,553,1.800,40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5762,12063,14161,'Mew the Cat','','cutie_cat','8.00','15.00',47,'female','L2Pet','npc',40,3227,5.500,851,2.100,40,43,30,21,20,25,0,0,427,253,216,237,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5763,12177,14162,'Mew the Cat','','cutie_cat','8.00','15.00',54,'female','L2Pet','npc',40,4099,6.500,1102,2.400,40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5764,12348,14163,'Mew the Cat','','cutie_cat','8.00','15.00',22,'female','L2Pet','npc',40,978,3.500,279,1.500,40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5765,12349,14164,'Mew the Cat','','cutie_cat','8.00','15.00',32,'female','L2Pet','npc',40,1689,4.500,458,1.800,40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5766,12350,14165,'Mew the Cat','','cutie_cat','8.00','15.00',42,'female','L2Pet','npc',40,2656,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5767,12351,14166,'Mew the Cat','','cutie_cat','8.00','15.00',50,'female','L2Pet','npc',40,3592,5.500,957,2.100,40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5768,12352,14167,'Mew the Cat','','cutie_cat','8.00','15.00',58,'female','L2Pet','npc',40,4622,6.500,1251,2.400,40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5769,12420,14168,'Mew the Cat','','cutie_cat','8.00','15.00',60,'female','L2Pet','npc',40,4887,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5770,12421,14169,'Mew the Cat','','cutie_cat','8.00','15.00',62,'female','L2Pet','npc',40,5151,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5771,12422,14170,'Mew the Cat','','cutie_cat','8.00','15.00',64,'female','L2Pet','npc',40,5414,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5772,12423,14171,'Mew the Cat','','cutie_cat','8.00','15.00',66,'female','L2Pet','npc',40,5674,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5773,12424,14172,'Mew the Cat','','cutie_cat','8.00','15.00',68,'female','L2Pet','npc',40,5930,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5774,12425,14173,'Mew the Cat','','cutie_cat','8.00','15.00',70,'female','L2Pet','npc',40,6179,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5775,12426,14174,'Mew the Cat','','cutie_cat','8.00','15.00',72,'female','L2Pet','npc',40,6421,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5776,12427,14175,'Mew the Cat','','cutie_cat','8.00','15.00',74,'female','L2Pet','npc',40,6654,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5777,12428,14176,'Mew the Cat','','cutie_cat','8.00','15.00',76,'female','L2Pet','npc',40,6876,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5778,13283,14177,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5779,13284,14178,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5780,13285,14179,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5781,13286,14180,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5782,13287,14181,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5783,13288,14182,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5784,13289,14183,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5785,13290,14184,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5786,13291,14185,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5787,13292,14186,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5788,13293,14187,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5789,13294,14188,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5790,13295,14189,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5791,13296,14190,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5792,13297,14191,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5793,13298,14192,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5794,13299,14193,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5795,13300,14194,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5796,13301,14195,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5797,13302,14196,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5798,13303,14197,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5799,13304,14198,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5800,13305,14199,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5801,13306,14200,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5802,13307,14201,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5803,13308,14202,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5804,13309,14203,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5805,13310,14204,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5806,13311,14205,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5807,13312,14206,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5808,12477,14207,'Kai the Cat','','silver_cat','7.00','15.00',42,'male','L2Pet','npc',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,342,215,152,202,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5809,12478,14208,'Kai the Cat','','silver_cat','7.00','15.00',46,'male','L2Pet','npc',40,2331,5.500,816,2.100,40,43,30,21,20,25,0,0,442,245,202,230,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5810,12479,14209,'Kai the Cat','','silver_cat','7.00','15.00',50,'male','L2Pet','npc',40,2694,5.500,957,2.100,40,43,30,21,20,25,0,0,560,278,264,260,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5811,12480,14210,'Kai the Cat','','silver_cat','7.00','15.00',54,'male','L2Pet','npc',40,3074,6.500,1102,2.400,40,43,30,21,20,25,0,0,699,313,339,293,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5812,12481,14211,'Kai the Cat','','silver_cat','7.00','15.00',58,'male','L2Pet','npc',40,3467,6.500,1251,2.400,40,43,30,21,20,25,0,0,859,349,428,327,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5813,12482,14212,'Kai the Cat','','silver_cat','7.00','15.00',60,'male','L2Pet','npc',40,3665,6.500,1327,2.400,40,43,30,21,20,25,0,0,946,368,478,345,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5814,12483,14213,'Kai the Cat','','silver_cat','7.00','15.00',62,'male','L2Pet','npc',40,3863,7.500,1404,2.700,40,43,30,21,20,25,0,0,1038,388,532,363,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5815,12484,14214,'Kai the Cat','','silver_cat','7.00','15.00',64,'male','L2Pet','npc',40,4060,7.500,1482,2.700,40,43,30,21,20,25,0,0,1135,408,589,382,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5816,12485,14215,'Kai the Cat','','silver_cat','7.00','15.00',66,'male','L2Pet','npc',40,4255,7.500,1561,2.700,40,43,30,21,20,25,0,0,1235,428,649,401,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5817,12486,14216,'Kai the Cat','','silver_cat','7.00','15.00',68,'male','L2Pet','npc',40,4447,7.500,1641,2.700,40,43,30,21,20,25,0,0,1339,449,713,421,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5818,12487,14217,'Kai the Cat','','silver_cat','7.00','15.00',70,'male','L2Pet','npc',40,4634,7.500,1722,2.700,40,43,30,21,20,25,0,0,1445,470,780,440,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5819,12488,14218,'Kai the Cat','','silver_cat','7.00','15.00',72,'male','L2Pet','npc',40,4816,8.500,1804,3.000,40,43,30,21,20,25,0,0,1554,491,849,460,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5820,12489,14219,'Kai the Cat','','silver_cat','7.00','15.00',74,'male','L2Pet','npc',40,4990,8.500,1888,3.000,40,43,30,21,20,25,0,0,1664,512,921,480,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5821,12536,14220,'Kai the Cat','','silver_cat','7.00','15.00',76,'male','L2Pet','npc',40,5157,8.500,1972,3.000,40,43,30,21,20,25,0,0,1775,534,994,500,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.34),
(5822,13313,14221,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5823,13314,14222,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5824,13315,14223,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5825,13316,14224,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5826,13317,14225,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5827,13318,14226,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5828,13319,14227,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5829,13320,14228,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5830,13321,14229,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5831,13322,14230,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5832,13323,14231,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5833,13324,14232,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5834,13325,14233,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5835,13326,14234,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5836,13327,14235,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5837,13328,14236,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5838,13329,14237,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5839,13330,14238,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5840,13331,14239,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5841,13332,14240,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5842,13333,14241,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5843,13334,14242,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5844,13335,14243,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5845,13336,14244,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5846,13337,14245,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5847,13338,14246,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5848,13339,14247,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5849,13340,14248,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5850,13341,14249,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5851,13342,14250,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.34),
(5852,13137,14251,'Feline Queen','','queen_of_cat','8.00','15.00',58,'female','L2Pet','npc',40,2889,6.500,1251,2.400,40,43,30,21,20,25,0,0,313,349,428,327,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5853,13138,14252,'Feline Queen','','queen_of_cat','8.00','15.00',60,'female','L2Pet','npc',40,3054,6.500,1327,2.400,40,43,30,21,20,25,0,0,340,368,478,345,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5854,13139,14253,'Feline Queen','','queen_of_cat','8.00','15.00',62,'female','L2Pet','npc',40,3219,7.500,1404,2.700,40,43,30,21,20,25,0,0,368,388,532,363,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5855,13140,14254,'Feline Queen','','queen_of_cat','8.00','15.00',64,'female','L2Pet','npc',40,3384,7.500,1482,2.700,40,43,30,21,20,25,0,0,397,408,589,382,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5856,13141,14255,'Feline Queen','','queen_of_cat','8.00','15.00',66,'female','L2Pet','npc',40,3546,7.500,1561,2.700,40,43,30,21,20,25,0,0,427,428,649,401,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(5857,13142,14256,'Feline Queen','','queen_of_cat','8.00','15.00',68,'female','L2Pet','npc',40,3706,7.500,1641,2.700,40,43,30,21,20,25,0,0,457,449,713,421,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5858,13143,14257,'Feline Queen','','queen_of_cat','8.00','15.00',70,'female','L2Pet','npc',40,3862,7.500,1722,2.700,40,43,30,21,20,25,0,0,487,470,780,440,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5859,13144,14258,'Feline Queen','','queen_of_cat','8.00','15.00',72,'female','L2Pet','npc',40,4013,8.500,1804,3.000,40,43,30,21,20,25,0,0,517,491,849,460,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5860,13145,14259,'Feline Queen','','queen_of_cat','8.00','15.00',74,'female','L2Pet','npc',40,4158,8.500,1888,3.000,40,43,30,21,20,25,0,0,547,512,921,480,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5861,13146,14260,'Feline Queen','','queen_of_cat','8.00','15.00',76,'female','L2Pet','npc',40,4297,8.500,1972,3.000,40,43,30,21,20,25,0,0,577,534,994,500,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5862,13343,14265,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5863,13344,14266,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5864,13345,14267,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5865,13346,14268,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5866,13347,14269,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5867,13348,14270,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5868,13349,14271,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5869,13350,14272,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5870,13351,14273,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5871,13352,14274,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5872,13353,14275,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5873,13354,14276,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5874,13355,14277,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5875,13356,14278,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5876,13357,14279,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5877,13358,14280,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5878,13359,14281,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5879,13360,14282,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5880,13361,14283,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5881,13362,14284,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5882,13363,14285,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5883,13364,14286,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5884,13365,14287,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5885,13366,14288,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5886,13367,14289,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5887,13368,14290,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5888,13369,14291,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5889,13370,14292,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5890,13371,14293,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5891,13372,14294,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.48),
(5892,12064,14295,'Boxer the Unicorn ','','unicorn_boxer','11.00','18.00',22,'male','L2Pet','npc',40,978,3.500,279,1.500,40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5893,12065,14296,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',32,'male','L2Pet','npc',40,1689,4.500,458,1.800,40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5894,12066,14297,'Boxer the Unicorn ','','unicorn_boxer','11.00','18.00',42,'male','L2Pet','npc',40,2656,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5895,12178,14298,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',50,'male','L2Pet','npc',40,3592,5.500,957,2.100,40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5896,12179,14299,'Boxer the Unicorn ','','unicorn_boxer','11.00','18.00',58,'male','L2Pet','npc',40,4622,6.500,1251,2.400,40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5897,12353,14300,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',27,'male','L2Pet','npc',40,1302,3.500,367,1.500,40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5898,12354,14301,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',37,'male','L2Pet','npc',40,2142,4.500,553,1.800,40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5899,12355,14302,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',46,'male','L2Pet','npc',40,3108,5.500,816,2.100,40,43,30,21,20,25,0,0,401,245,202,230,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5900,12356,14303,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',54,'male','L2Pet','npc',40,4099,6.500,1102,2.400,40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5901,12438,14304,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',60,'male','L2Pet','npc',40,4887,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5902,12439,14305,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',62,'male','L2Pet','npc',40,5151,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5903,12440,14306,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',64,'male','L2Pet','npc',40,5414,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5904,12441,14307,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',66,'male','L2Pet','npc',40,5674,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5905,12442,14308,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',68,'male','L2Pet','npc',40,5930,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5906,12443,14309,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',70,'male','L2Pet','npc',40,6179,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5907,12444,14310,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',72,'male','L2Pet','npc',40,6421,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5908,12445,14311,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',74,'male','L2Pet','npc',40,6654,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5909,12446,14312,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',76,'male','L2Pet','npc',40,6876,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.71),
(5910,13373,14313,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5911,13374,14314,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5912,13375,14315,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5913,13376,14316,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5914,13377,14317,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5915,13378,14318,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5916,13379,14319,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5917,13380,14320,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5918,13381,14321,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5919,13382,14322,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5920,13383,14323,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5921,13384,14324,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5922,13385,14325,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5923,13386,14326,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5924,13387,14327,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5925,13388,14328,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5926,13389,14329,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5927,13390,14330,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5928,13391,14331,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5929,13392,14332,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5930,13393,14333,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5931,13394,14334,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5932,13395,14335,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5933,13396,14336,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5934,13397,14337,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5935,13398,14338,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5936,13399,14339,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5937,13400,14340,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5938,13401,14341,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5939,13402,14342,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(5940,12067,14343,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',27,'male','L2Pet','npc',40,1302,3.500,367,1.500,40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5941,12068,14344,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',37,'male','L2Pet','npc',40,2142,4.500,553,1.800,40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5942,12069,14345,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',47,'male','L2Pet','npc',40,3227,5.500,851,2.100,40,43,30,21,20,25,0,0,427,253,216,237,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5943,12180,14346,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',54,'male','L2Pet','npc',40,4099,6.500,1102,2.400,40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5944,12357,14347,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',22,'male','L2Pet','npc',40,978,3.500,279,1.500,40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5945,12358,14348,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',32,'male','L2Pet','npc',40,1689,4.500,458,1.800,40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5946,12359,14349,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',42,'male','L2Pet','npc',40,2656,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5947,12360,14350,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',50,'male','L2Pet','npc',40,3592,5.500,957,2.100,40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5948,12361,14351,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',58,'male','L2Pet','npc',40,4622,6.500,1251,2.400,40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5949,12429,14352,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',60,'male','L2Pet','npc',40,4887,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5950,12430,14353,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',62,'male','L2Pet','npc',40,5151,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5951,12431,14354,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',64,'male','L2Pet','npc',40,5414,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5952,12432,14355,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',66,'male','L2Pet','npc',40,5674,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5953,12433,14356,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',68,'male','L2Pet','npc',40,5930,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5954,12434,14357,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',70,'male','L2Pet','npc',40,6179,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5955,12435,14358,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',72,'male','L2Pet','npc',40,6421,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5956,12436,14359,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',74,'male','L2Pet','npc',40,6654,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5957,12437,14360,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',76,'male','L2Pet','npc',40,6876,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,27,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(5958,13403,14361,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5959,13404,14362,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5960,13405,14363,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5961,13406,14364,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5962,13407,14365,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5963,13408,14366,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5964,13409,14367,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5965,13410,14368,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5966,13411,14369,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5967,13412,14370,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5968,13413,14371,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5969,13414,14372,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5970,13415,14373,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5971,13416,14374,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5972,13417,14375,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5973,13418,14376,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5974,13419,14377,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5975,13420,14378,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5976,13421,14379,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5977,13422,14380,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5978,13423,14381,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5979,13424,14382,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5980,13425,14383,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5981,13426,14384,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5982,13427,14385,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5983,13428,14386,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5984,13429,14387,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5985,13430,14388,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5986,13431,14389,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5987,13432,14390,'Mirage the Unicorn ','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(5988,12490,14391,'Merrow the Unicorn','','blue_eye','11.00','16.00',42,'male','L2Pet','npc',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,342,215,152,202,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5989,12491,14392,'Merrow the Unicorn','','blue_eye','11.00','16.00',46,'male','L2Pet','npc',40,2331,5.500,816,2.100,40,43,30,21,20,25,0,0,442,245,202,230,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5990,12492,14393,'Merrow the Unicorn','','blue_eye','11.00','16.00',50,'male','L2Pet','npc',40,2694,5.500,957,2.100,40,43,30,21,20,25,0,0,560,278,264,260,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5991,12493,14394,'Merrow the Unicorn','','blue_eye','11.00','16.00',54,'male','L2Pet','npc',40,3074,6.500,1102,2.400,40,43,30,21,20,25,0,0,699,313,339,293,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5992,12494,14395,'Merrow the Unicorn','','blue_eye','11.00','16.00',58,'male','L2Pet','npc',40,3467,6.500,1251,2.400,40,43,30,21,20,25,0,0,859,349,428,327,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5993,12495,14396,'Merrow the Unicorn','','blue_eye','11.00','16.00',60,'male','L2Pet','npc',40,3665,6.500,1327,2.400,40,43,30,21,20,25,0,0,946,368,478,345,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5994,12496,14397,'Merrow the Unicorn','','blue_eye','11.00','16.00',62,'male','L2Pet','npc',40,3863,7.500,1404,2.700,40,43,30,21,20,25,0,0,1038,388,532,363,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5995,12497,14398,'Merrow the Unicorn','','blue_eye','11.00','16.00',64,'male','L2Pet','npc',40,4060,7.500,1482,2.700,40,43,30,21,20,25,0,0,1135,408,589,382,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5996,12498,14399,'Merrow the Unicorn','','blue_eye','11.00','16.00',66,'male','L2Pet','npc',40,4255,7.500,1561,2.700,40,43,30,21,20,25,0,0,1235,428,649,401,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5997,12499,14400,'Merrow the Unicorn','','blue_eye','11.00','16.00',68,'male','L2Pet','npc',40,4447,7.500,1641,2.700,40,43,30,21,20,25,0,0,1339,449,713,421,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5998,12500,14401,'Merrow the Unicorn','','blue_eye','11.00','16.00',70,'male','L2Pet','npc',40,4634,7.500,1722,2.700,40,43,30,21,20,25,0,0,1445,470,780,440,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(5999,12501,14402,'Merrow the Unicorn','','blue_eye','11.00','16.00',72,'male','L2Pet','npc',40,4816,8.500,1804,3.000,40,43,30,21,20,25,0,0,1554,491,849,460,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(6000,12502,14403,'Merrow the Unicorn','','blue_eye','11.00','16.00',74,'male','L2Pet','npc',40,4990,8.500,1888,3.000,40,43,30,21,20,25,0,0,1664,512,921,480,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,10,0.71),
(6001,12537,14404,'Merrow the Unicorn','','blue_eye','11.00','16.00',76,'male','L2Pet','npc',40,5157,8.500,1972,3.000,40,43,30,21,20,25,0,0,1775,534,994,500,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6002,13433,14405,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6003,13434,14406,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6004,13435,14407,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6005,13436,14408,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6006,13437,14409,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6007,13438,14410,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6008,13439,14411,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6009,13440,14412,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6010,13441,14413,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6011,13442,14414,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6012,13443,14415,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6013,13444,14416,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6014,13445,14417,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6015,13446,14418,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6016,13447,14419,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6017,13448,14420,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6018,13449,14421,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6019,13450,14422,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6020,13451,14423,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6021,13452,14424,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6022,13453,14425,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6023,13454,14426,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6024,13455,14427,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6025,13456,14428,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6026,13457,14429,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6027,13458,14430,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6028,13459,14431,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6029,13460,14432,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6030,13461,14433,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6031,13462,14434,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,10,0.71),
(6032,13151,14435,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',58,'male','L2Pet','npc',40,2889,6.500,1251,2.400,40,43,30,21,20,25,0,0,313,349,428,327,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6033,13152,14436,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',60,'male','L2Pet','npc',40,3054,6.500,1327,2.400,40,43,30,21,20,25,0,0,340,368,478,345,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6034,13153,14437,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',62,'male','L2Pet','npc',40,3219,7.500,1404,2.700,40,43,30,21,20,25,0,0,368,388,532,363,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(6035,13154,14438,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',64,'male','L2Pet','npc',40,3384,7.500,1482,2.700,40,43,30,21,20,25,0,0,397,408,589,382,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6036,13155,14439,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',66,'male','L2Pet','npc',40,3546,7.500,1561,2.700,40,43,30,21,20,25,0,0,427,428,649,401,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6037,13156,14440,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',68,'male','L2Pet','npc',40,3706,7.500,1641,2.700,40,43,30,21,20,25,0,0,457,449,713,421,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6038,13157,14441,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',70,'male','L2Pet','npc',40,3862,7.500,1722,2.700,40,43,30,21,20,25,0,0,487,470,780,440,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6039,13158,14442,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',72,'male','L2Pet','npc',40,4013,8.500,1804,3.000,40,43,30,21,20,25,0,0,517,491,849,460,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6040,13159,14443,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',74,'male','L2Pet','npc',40,4158,8.500,1888,3.000,40,43,30,21,20,25,0,0,547,512,921,480,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6041,13160,14444,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',76,'male','L2Pet','npc',40,4297,8.500,1972,3.000,40,43,30,21,20,25,0,0,577,534,994,500,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.71),
(6042,13463,14449,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6043,13464,14450,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6044,13465,14451,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6045,13466,14452,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6046,13467,14453,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6047,13468,14454,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6048,13469,14455,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6049,13470,14456,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6050,13471,14457,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6051,13472,14458,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6052,13473,14459,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6053,13474,14460,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6054,13475,14461,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6055,13476,14462,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6056,13477,14463,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6057,13478,14464,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6058,13479,14465,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6059,13480,14466,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6060,13481,14467,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6061,13482,14468,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6062,13483,14469,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6063,13484,14470,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6064,13485,14471,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6065,13486,14472,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6066,13487,14473,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6067,13488,14474,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6068,13489,14475,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6069,13490,14476,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6070,13491,14477,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6071,13492,14478,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,8.500,2057,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.71),
(6072,12070,14479,'Shadow','','shadow','10.00','30.00',22,'male','L2Pet','npc',40,978,3.500,279,1.500,40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6073,12071,14480,'Shadow','','shadow','10.00','30.00',32,'male','L2Pet','npc',40,1689,4.500,458,1.800,40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6074,12072,14481,'Shadow','','shadow','10.00','30.00',42,'male','L2Pet','npc',40,2656,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6075,12181,14482,'Shadow','','shadow','10.00','30.00',50,'male','L2Pet','npc',40,3592,5.500,957,2.100,40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6076,12182,14483,'Shadow','','shadow','10.00','30.00',58,'male','L2Pet','npc',40,4622,6.500,1251,2.400,40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6077,12362,14484,'Shadow','','shadow','10.00','30.00',27,'male','L2Pet','npc',40,1302,3.500,367,1.500,40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6078,12363,14485,'Shadow','','shadow','10.00','30.00',37,'male','L2Pet','npc',40,2142,4.500,553,1.800,40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6079,12364,14486,'Shadow','','shadow','10.00','30.00',46,'male','L2Pet','npc',40,3108,5.500,816,2.100,40,43,30,21,20,25,0,0,401,245,202,230,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6080,12365,14487,'Shadow','','shadow','10.00','30.00',54,'male','L2Pet','npc',40,4099,6.500,1102,2.400,40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6081,12447,14488,'Shadow','','shadow','10.00','30.00',60,'male','L2Pet','npc',40,4887,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6082,12448,14489,'Shadow','','shadow','10.00','30.00',62,'male','L2Pet','npc',40,5151,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6083,12449,14490,'Shadow','','shadow','10.00','30.00',64,'male','L2Pet','npc',40,5414,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6084,12450,14491,'Shadow','','shadow','10.00','30.00',66,'male','L2Pet','npc',40,5674,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6085,12451,14492,'Shadow','','shadow','10.00','30.00',68,'male','L2Pet','npc',40,5930,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6086,12452,14493,'Shadow','','shadow','10.00','30.00',70,'male','L2Pet','npc',40,6179,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6087,12453,14494,'Shadow','','shadow','10.00','30.00',72,'male','L2Pet','npc',40,6421,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6088,12454,14495,'Shadow','','shadow','10.00','30.00',74,'male','L2Pet','npc',40,6654,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6089,12455,14496,'Shadow','','shadow','10.00','30.00',76,'male','L2Pet','npc',40,6876,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6090,13493,14497,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6091,13494,14498,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6092,13495,14499,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6093,13496,14500,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6094,13497,14501,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6095,13498,14502,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6096,13499,14503,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6097,13500,14504,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6098,13501,14505,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6099,13502,14506,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6100,13503,14507,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6101,13504,14508,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6102,13505,14509,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6103,13506,14510,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6104,13507,14511,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6105,13508,14512,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6106,13509,14513,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6107,13510,14514,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6108,13511,14515,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6109,13512,14516,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6110,13513,14517,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6111,13514,14518,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6112,13515,14519,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6113,13516,14520,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6114,13517,14521,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6115,13518,14522,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6116,13519,14523,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6117,13520,14524,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6118,13521,14525,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6119,13522,14526,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6120,12073,14527,'Silhouette','','silhouette','8.00','23.00',27,'female','L2Pet','npc',40,1302,3.500,367,1.500,40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6121,12074,14528,'Silhouette','','silhouette','8.00','23.00',37,'female','L2Pet','npc',40,2142,4.500,553,1.800,40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6122,12075,14529,'Silhouette','','silhouette','8.00','23.00',47,'female','L2Pet','npc',40,3227,5.500,851,2.100,40,43,30,21,20,25,0,0,427,253,216,237,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6123,12183,14530,'Silhouette','','silhouette','8.00','23.00',54,'female','L2Pet','npc',40,4099,6.500,1102,2.400,40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6124,12366,14531,'Silhouette','','silhouette','8.00','23.00',22,'female','L2Pet','npc',40,978,3.500,279,1.500,40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6125,12367,14532,'Silhouette','','silhouette','8.00','23.00',32,'female','L2Pet','npc',40,1689,4.500,458,1.800,40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6126,12368,14533,'Silhouette','','silhouette','8.00','23.00',42,'female','L2Pet','npc',40,2656,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6127,12369,14534,'Silhouette','','silhouette','8.00','23.00',50,'female','L2Pet','npc',40,3592,5.500,957,2.100,40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6128,12370,14535,'Silhouette','','silhouette','8.00','23.00',58,'female','L2Pet','npc',40,4622,6.500,1251,2.400,40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6129,12456,14536,'Silhouette','','silhouette','8.00','23.00',60,'female','L2Pet','npc',40,4887,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6130,12457,14537,'Silhouette','','silhouette','8.00','23.00',62,'female','L2Pet','npc',40,5151,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6131,12458,14538,'Silhouette','','silhouette','8.00','23.00',64,'female','L2Pet','npc',40,5414,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6132,12459,14539,'Silhouette','','silhouette','8.00','23.00',66,'female','L2Pet','npc',40,5674,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6133,12460,14540,'Silhouette','','silhouette','8.00','23.00',68,'female','L2Pet','npc',40,5930,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6134,12461,14541,'Silhouette','','silhouette','8.00','23.00',70,'female','L2Pet','npc',40,6179,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6135,12462,14542,'Silhouette','','silhouette','8.00','23.00',72,'female','L2Pet','npc',40,6421,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6136,12463,14543,'Silhouette','','silhouette','8.00','23.00',74,'female','L2Pet','npc',40,6654,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6137,12464,14544,'Silhouette','','silhouette','8.00','23.00',76,'female','L2Pet','npc',40,6876,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,80,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.54),
(6138,13523,14545,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6139,13524,14546,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6140,13525,14547,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6141,13526,14548,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6142,13527,14549,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6143,13528,14550,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6144,13529,14551,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6145,13530,14552,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6146,13531,14553,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6147,13532,14554,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6148,13533,14555,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6149,13534,14556,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6150,13535,14557,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6151,13536,14558,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6152,13537,14559,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6153,13538,14560,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6154,13539,14561,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6155,13540,14562,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6156,13541,14563,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6157,13542,14564,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6158,13543,14565,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6159,13544,14566,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6160,13545,14567,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6161,13546,14568,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6162,13547,14569,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6163,13548,14570,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6164,13549,14571,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6165,13550,14572,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6166,13551,14573,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6167,13552,14574,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,8.500,2057,3.000,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,80,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.54),
(6168,12503,14575,'Soulless','','shadeless','7.00','28.00',42,'male','L2Pet','npc',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,342,215,152,202,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6169,12504,14576,'Soulless','','shadeless','7.00','28.00',46,'male','L2Pet','npc',40,2331,5.500,816,2.100,40,43,30,21,20,25,0,0,442,245,202,230,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6170,12505,14577,'Soulless','','shadeless','7.00','28.00',50,'male','L2Pet','npc',40,2694,5.500,957,2.100,40,43,30,21,20,25,0,0,560,278,264,260,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6171,12506,14578,'Soulless','','shadeless','7.00','28.00',54,'male','L2Pet','npc',40,3074,6.500,1102,2.400,40,43,30,21,20,25,0,0,699,313,339,293,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6172,12507,14579,'Soulless','','shadeless','7.00','28.00',58,'male','L2Pet','npc',40,3467,6.500,1251,2.400,40,43,30,21,20,25,0,0,859,349,428,327,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6173,12508,14580,'Soulless','','shadeless','7.00','28.00',60,'male','L2Pet','npc',40,3665,6.500,1327,2.400,40,43,30,21,20,25,0,0,946,368,478,345,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6174,12509,14581,'Soulless','','shadeless','7.00','28.00',62,'male','L2Pet','npc',40,3863,7.500,1404,2.700,40,43,30,21,20,25,0,0,1038,388,532,363,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6175,12510,14582,'Soulless','','shadeless','7.00','28.00',64,'male','L2Pet','npc',40,4060,7.500,1482,2.700,40,43,30,21,20,25,0,0,1135,408,589,382,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6176,12511,14583,'Soulless','','shadeless','7.00','28.00',66,'male','L2Pet','npc',40,4255,7.500,1561,2.700,40,43,30,21,20,25,0,0,1235,428,649,401,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6177,12512,14584,'Soulless','','shadeless','7.00','28.00',68,'male','L2Pet','npc',40,4447,7.500,1641,2.700,40,43,30,21,20,25,0,0,1339,449,713,421,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6178,12513,14585,'Soulless','','shadeless','7.00','28.00',70,'male','L2Pet','npc',40,4634,7.500,1722,2.700,40,43,30,21,20,25,0,0,1445,470,780,440,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6179,12514,14586,'Soulless','','shadeless','7.00','28.00',72,'male','L2Pet','npc',40,4816,8.500,1804,3.000,40,43,30,21,20,25,0,0,1554,491,849,460,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6180,12515,14587,'Soulless','','shadeless','7.00','28.00',74,'male','L2Pet','npc',40,4990,8.500,1888,3.000,40,43,30,21,20,25,0,0,1664,512,921,480,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6181,12538,14588,'Soulless','','shadeless','7.00','28.00',76,'male','L2Pet','npc',40,5157,8.500,1972,3.000,40,43,30,21,20,25,0,0,1775,534,994,500,278,0,253,0,0,0,48,190,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.61),
(6182,13553,14589,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6183,13554,14590,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6184,13555,14591,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6185,13556,14592,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6186,13557,14593,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6187,13558,14594,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6188,13559,14595,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6189,13560,14596,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6190,13561,14597,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6191,13562,14598,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6192,13563,14599,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6193,13564,14600,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6194,13565,14601,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6195,13566,14602,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6196,13567,14603,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6197,13568,14604,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6198,13569,14605,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6199,13570,14606,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6200,13571,14607,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6201,13572,14608,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6202,13573,14609,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6203,13574,14610,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6204,13575,14611,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6205,13576,14612,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6206,13577,14613,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6207,13578,14614,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6208,13579,14615,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6209,13580,14616,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6210,13581,14617,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6211,13582,14618,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,8.500,2057,3.000,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,253,0,0,0,48,190,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.61),
(6212,13165,14619,'Nightshade','','knight_of_shadow','10.00','35.50',58,'male','L2Pet','npc',40,5778,5.500,1251,2.400,40,43,30,21,20,25,0,0,313,349,428,327,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6213,13166,14620,'Nightshade','','knight_of_shadow','10.00','35.50',60,'male','L2Pet','npc',40,6109,5.500,1327,2.400,40,43,30,21,20,25,0,0,340,368,478,345,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6214,13167,14621,'Nightshade','','knight_of_shadow','10.00','35.50',62,'male','L2Pet','npc',40,6439,5.500,1404,2.700,40,43,30,21,20,25,0,0,368,388,532,363,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6215,13168,14622,'Nightshade','','knight_of_shadow','10.00','35.50',64,'male','L2Pet','npc',40,6768,6.500,1482,2.700,40,43,30,21,20,25,0,0,397,408,589,382,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6216,13169,14623,'Nightshade','','knight_of_shadow','10.00','35.50',66,'male','L2Pet','npc',40,7093,6.500,1561,2.700,40,43,30,21,20,25,0,0,427,428,649,401,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6217,13170,14624,'Nightshade','','knight_of_shadow','10.00','35.50',68,'male','L2Pet','npc',40,7412,6.500,1641,2.700,40,43,30,21,20,25,0,0,457,449,713,421,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6218,13171,14625,'Nightshade','','knight_of_shadow','10.00','35.50',70,'male','L2Pet','npc',40,7724,7.500,1722,2.700,40,43,30,21,20,25,0,0,487,470,780,440,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(6219,13172,14626,'Nightshade','','knight_of_shadow','10.00','35.50',72,'male','L2Pet','npc',40,8026,7.500,1804,3.000,40,43,30,21,20,25,0,0,517,491,849,460,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6220,13173,14627,'Nightshade','','knight_of_shadow','10.00','35.50',74,'male','L2Pet','npc',40,8317,7.500,1888,3.000,40,43,30,21,20,25,0,0,547,512,921,480,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6221,13174,14628,'Nightshade','','knight_of_shadow','10.00','35.50',76,'male','L2Pet','npc',40,8595,7.500,1972,3.000,40,43,30,21,20,25,0,0,577,534,994,500,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6222,13583,14633,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6223,13584,14634,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6224,13585,14635,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6225,13586,14636,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6226,13587,14637,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6227,13588,14638,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6228,13589,14639,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6229,13590,14640,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6230,13591,14641,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,8.500,2143,3.000,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6231,13592,14642,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6232,13593,14643,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6233,13594,14644,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6234,13595,14645,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6235,13596,14646,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6236,13597,14647,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6237,13598,14648,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6238,13599,14649,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6239,13600,14650,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,8.500,2143,3.000,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6240,13601,14651,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6241,13602,14652,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6242,13603,14653,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6243,13604,14654,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6244,13605,14655,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6245,13606,14656,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6246,13607,14657,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6247,13608,14658,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6248,13609,14659,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6249,13610,14660,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6250,13611,14661,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6251,13612,14662,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,8.500,2143,3.000,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.59),
(6252,12187,14663,'Mechanic Golem','','mechanic_golem','5.00','19.00',30,'male','L2Pet','npc',40,1049,3.500,421,1.500,40,43,30,21,20,25,0,0,132,140,58,132,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6253,12188,14664,'Mechanic Golem','','mechanic_golem','5.00','19.00',38,'male','L2Pet','npc',40,1540,4.500,573,1.800,40,43,30,21,20,25,0,0,238,188,112,176,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6254,12189,14665,'Mechanic Golem','','mechanic_golem','5.00','19.00',45,'male','L2Pet','npc',40,2057,5.500,781,2.100,40,43,30,21,20,25,0,0,377,238,188,223,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6255,12190,14666,'Mechanic Golem','','mechanic_golem','5.00','19.00',51,'male','L2Pet','npc',40,2555,6.500,993,2.400,40,43,30,21,20,25,0,0,539,286,281,268,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6256,12191,14667,'Mechanic Golem','','mechanic_golem','5.00','19.00',57,'male','L2Pet','npc',40,3087,6.500,1213,2.400,40,43,30,21,20,25,0,0,743,340,405,318,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6257,12522,14668,'Mechanic Golem','','mechanic_golem','5.00','19.00',62,'male','L2Pet','npc',40,3541,7.500,1404,2.700,40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6258,12523,14669,'Mechanic Golem','','mechanic_golem','5.00','19.00',66,'male','L2Pet','npc',40,3901,7.500,1561,2.700,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6259,12524,14670,'Mechanic Golem','','mechanic_golem','5.00','19.00',70,'male','L2Pet','npc',40,4248,7.500,1722,2.700,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,30,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.72),
(6260,12525,14671,'Mechanic Golem','','mechanic_golem','5.00','19.00',74,'male','L2Pet','npc',40,4574,8.500,1888,3.000,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,30,150,'',0,0,'Saboteur (Orphus.com)','',0,0,0,7,30,4,4,0,0,0.72),
(6261,13703,14672,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6262,13704,14673,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6263,13705,14674,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6264,13706,14675,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6265,13707,14676,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6266,13708,14677,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6267,13709,14678,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6268,13710,14679,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6269,13711,14680,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6270,13712,14681,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6271,13713,14682,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6272,13714,14683,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6273,13715,14684,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6274,13716,14685,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6275,13717,14686,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6276,13718,14687,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6277,13719,14688,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6278,13720,14689,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6279,13721,14690,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6280,13722,14691,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6281,13723,14692,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6282,13724,14693,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6283,13725,14694,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6284,13726,14695,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6285,13727,14696,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6286,13728,14697,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6287,13729,14698,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6288,13730,14699,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6289,13731,14700,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6290,13732,14701,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,253,0,0,0,30,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.72),
(6291,12517,14702,'Big Boom','','big_boom','6.00','13.00',60,'male','L2Pet','npc',40,3054,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(6292,12518,14703,'Big Boom','','big_boom','6.00','13.00',64,'male','L2Pet','npc',40,3384,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(6293,12519,14704,'Big Boom','','big_boom','6.00','13.00',68,'male','L2Pet','npc',40,3706,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(6294,12520,14705,'Big Boom','','big_boom','6.00','13.00',72,'male','L2Pet','npc',40,4013,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(6295,12521,14706,'Big Boom','','big_boom','6.00','13.00',76,'male','L2Pet','npc',40,4297,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,48,140,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.60),
(6296,13733,14707,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6297,13734,14708,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6298,13735,14709,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6299,13736,14710,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6300,13737,14711,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6301,13738,14712,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6302,13739,14713,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6303,13740,14714,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6304,13741,14715,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6305,13742,14716,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6306,13743,14717,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6307,13744,14718,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6308,13745,14719,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6309,13746,14720,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6310,13747,14721,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6311,13748,14722,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6312,13749,14723,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6313,13750,14724,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6314,13751,14725,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6315,13752,14726,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6316,13753,14727,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6317,13754,14728,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6318,13755,14729,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6319,13756,14730,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6320,13757,14731,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6321,13758,14732,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6322,13759,14733,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6323,13760,14734,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6324,13761,14735,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6325,13762,14736,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,8.500,2143,3.000,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6326,12251,14737,'Siege Golem','','siege_golem','60.00','140.00',55,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,2592,1205,360,1242,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6327,13763,14738,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3036,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6328,13764,14739,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3066,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6329,13765,14740,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3096,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6330,13766,14741,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3126,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6331,13767,14742,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3156,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6332,13768,14743,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3186,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6333,13769,14744,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3216,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6334,13770,14745,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3246,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6335,13771,14746,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3276,1397,484,1440,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6336,13772,14747,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3326,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6337,13773,14748,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3356,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6338,13774,14749,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3386,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6339,13775,14750,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3417,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6340,13776,14751,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3447,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6341,13777,14752,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3477,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6342,13778,14753,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3507,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6343,13779,14754,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3538,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6344,13780,14755,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3568,1406,490,1449,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6345,13781,14756,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3619,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6346,13782,14757,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3650,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6347,13783,14758,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3680,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6348,13784,14759,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3711,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6349,13785,14760,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3741,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6350,13786,14761,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3772,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6351,13787,14762,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3802,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6352,13788,14763,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3832,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6353,13789,14764,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3863,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6354,13790,14765,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3893,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6355,13791,14766,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3924,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6356,13792,14767,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,6.500,1138,2.400,40,43,30,21,20,25,0,0,3954,1414,496,1457,165,0,150,0,0,0,40,40,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.69),
(6357,12375,14768,'Wild Hog Cannon','','range_golem','93.00','90.00',60,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,888,709,478,730,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6358,13793,14769,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1012,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6359,13794,14770,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1022,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6360,13795,14771,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1032,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6361,13796,14772,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1042,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6362,13797,14773,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1052,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6363,13798,14774,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1062,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6364,13799,14775,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1072,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6365,13800,14776,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1082,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6366,13801,14777,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1092,794,601,818,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6367,13802,14778,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1108,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6368,13803,14779,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1118,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6369,13804,14780,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1128,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6370,13805,14781,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1139,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6371,13806,14782,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1149,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6372,13807,14783,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1159,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6373,13808,14784,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1169,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6374,13809,14785,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1179,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6375,13810,14786,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1189,799,608,823,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6376,13811,14787,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1206,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6377,13812,14788,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1216,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6378,13813,14789,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1226,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6379,13814,14790,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1237,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6380,13815,14791,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1247,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6381,13816,14792,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1257,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6382,13817,14793,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1267,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6383,13818,14794,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1277,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6384,13819,14795,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1287,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6385,13820,14796,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1297,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6386,13821,14797,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1308,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6387,13822,14798,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,6.500,1327,2.400,40,43,30,21,20,25,0,0,1318,804,615,828,278,0,253,0,0,0,10,10,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6388,12184,14799,'Dark Panther','','dark_fencer','7.00','13.00',42,'male','L2Pet','npc',40,1826,5.500,679,2.100,40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6389,12185,14800,'Dark Panther','','dark_fencer','7.00','13.00',51,'male','L2Pet','npc',40,2555,6.500,993,2.400,40,43,30,21,20,25,0,0,539,286,281,268,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6390,12186,14801,'Dark Panther','','dark_fencer','7.00','13.00',60,'male','L2Pet','npc',40,3359,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6391,12473,14802,'Dark Panther','','dark_fencer','7.00','13.00',64,'male','L2Pet','npc',40,3722,7.500,1482,2.700,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6392,12474,14803,'Dark Panther','','dark_fencer','7.00','13.00',68,'male','L2Pet','npc',40,4076,7.500,1641,2.700,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6393,12475,14804,'Dark Panther','','dark_fencer','7.00','13.00',72,'male','L2Pet','npc',40,4414,8.500,1804,3.000,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6394,12476,14805,'Dark Panther','','dark_fencer','7.00','13.00',76,'male','L2Pet','npc',40,4727,8.500,1972,3.000,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,25,150,'',0,0,'Magister','',0,0,0,7,30,4,4,0,0,0.20),
(6395,13823,14806,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6396,13824,14807,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6397,13825,14808,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6398,13826,14809,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6399,13827,14810,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20);
INSERT INTO `npc` (`ordinal`,`c4id`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`) VALUES
(6400,13828,14811,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6401,13829,14812,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6402,13830,14813,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6403,13831,14814,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6404,13832,14815,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6405,13833,14816,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6406,13834,14817,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6407,13835,14818,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6408,13836,14819,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6409,13837,14820,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6410,13838,14821,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6411,13839,14822,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6412,13840,14823,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6413,13841,14824,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6414,13842,14825,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6415,13843,14826,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6416,13844,14827,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6417,13845,14828,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6418,13846,14829,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6419,13847,14830,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6420,13848,14831,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6421,13849,14832,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6422,13850,14833,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6423,13851,14834,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6424,13852,14835,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,8.500,2143,3.000,40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,253,0,0,0,25,150,'',0,0,'Local','',0,0,0,7,50,4,4,0,0,0.20),
(6425,0,14836,'Feline King','','king_of_cat',6,16.01, 80,'male','L2Pet','npc',40,5461,13.43,2143,3.09,40,43,30,21,20,25,0,0,2606,795,1662,840,278,0,333,0,0,0,52,198,NULL,NULL,0,'Local',NULL,0, NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(6426,0,14837,'Magnus the Unicorn','','unicorn_magnus',13.5,17,80,'male','L2Pet','npc',40,5461,13.43,2143,3.09,40,43,30,21,20,25,0,0,2369,795,3510,840,278,0,333,0,0,0,52,198,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(6427,0,14838,'Spectral Lord','','spectral_knight',12.5,33.5,80,'male','L2Pet','npc',40,4550,13.43,2143,3.09,40,43,30,21,20,25,0,0,1994,576,1671,538,278,0,333,0,0,0,52,198,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0),
(6428,0,14839,'Swoop Cannon','','toad_cannon','45.00','47.50',68,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6429,0,14840,'Swoop Cannon','','toad_cannon','45.00','47.50',69,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6430,0,14841,'Swoop Cannon','','toad_cannon','45.00','47.50',70,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6431,0,14842,'Swoop Cannon','','toad_cannon','45.00','47.50',71,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6432,0,14843,'Swoop Cannon','','toad_cannon','45.00','47.50',72,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6433,0,14844,'Swoop Cannon','','toad_cannon','45.00','47.50',73,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6434,0,14845,'Swoop Cannon','','toad_cannon','45.00','47.50',74,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6435,0,14846,'Swoop Cannon','','toad_cannon','45.00','47.50',75,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6436,0,14847,'Swoop Cannon','','toad_cannon','45.00','47.50',76,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6437,0,14848,'Swoop Cannon','','toad_cannon','45.00','47.50',77,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6438,0,14849,'Swoop Cannon','','toad_cannon','45.00','47.50',78,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6439,0,14850,'Swoop Cannon','','toad_cannon','45.00','47.50',79,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6440,0,14851,'Swoop Cannon','','toad_cannon','45.00','47.50',80,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6441,0,14852,'Swoop Cannon','','toad_cannon','45.00','47.50',81,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6442,0,14853,'Swoop Cannon','','toad_cannon','45.00','47.50',82,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6443,0,14854,'Swoop Cannon','','toad_cannon','45.00','47.50',83,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6444,0,14855,'Swoop Cannon','','toad_cannon','45.00','47.50',84,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6445,0,14856,'Swoop Cannon','','toad_cannon','45.00','47.50',85,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6446,0,14857,'Swoop Cannon','','toad_cannon','45.00','47.50',86,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6447,0,14858,'Swoop Cannon','','toad_cannon','45.00','47.50',87,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6448,0,14859,'Swoop Cannon','','toad_cannon','45.00','47.50',88,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6449,0,14860,'Swoop Cannon','','toad_cannon','45.00','47.50',89,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6450,0,14861,'Swoop Cannon','','toad_cannon','45.00','47.50',90,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6451,0,14862,'Swoop Cannon','','toad_cannon','45.00','47.50',91,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6452,0,14863,'Swoop Cannon','','toad_cannon','45.00','47.50',92,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6453,0,14864,'Swoop Cannon','','toad_cannon','45.00','47.50',93,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6454,0,14865,'Swoop Cannon','','toad_cannon','45.00','47.50',94,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6455,0,14866,'Swoop Cannon','','toad_cannon','45.00','47.50',95,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6456,0,14867,'Swoop Cannon','','toad_cannon','45.00','47.50',96,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6457,0,14868,'Swoop Cannon','','toad_cannon','45.00','47.50',97,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6458,0,14869,'Swoop Cannon','','toad_cannon','45.00','47.50',98,'male','L2Pet','npc',40,79000,6.500,1138,2.400,40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,1,'Magister','',0,0,0,7,30,4,4,0,0,0.69),
(6459,12785,16013,'Trained Buffalo','','buffalo','22.00','31.00',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,0,0,1169,439,681,356,278,0,253,0,0,0,20,170,'pet_clan',400,0,'Local','',0,0,0,15,30,4,4,0,0,0.46),
(6460,12786,16014,'Trained Buffalo','','buffalo','22.00','31.00',67,'male','L2Monster','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,0,0,1169,439,681,356,278,0,253,0,0,0,20,170,'pet_clan',400,0,'Local','',0,0,0,15,30,4,4,0,0,0.46),
(6461,12787,16015,'Trained Cougar','','saber_toothed_tiger','12.00','22.00',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,0,0,1265,460,746,373,278,0,253,0,0,0,60,175,'pet_clan',400,0,'Local','',0,0,0,15,30,4,4,0,0,0.45),
(6462,12788,16016,'Trained Cougar','','saber_toothed_tiger','12.00','22.00',69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,0,0,1265,460,746,373,278,0,253,0,0,0,60,175,'pet_clan',400,0,'Local','',0,0,0,15,30,4,4,0,0,0.45),
(6463,12783,16017,'Trained Kookaburra','','pet_ostrich','10.00','33.00',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,23,190,'pet_clan',400,0,'Local','',0,0,0,15,30,4,4,0,0,0.50),
(6464,12784,16018,'Trained Kookaburra','','pet_ostrich','10.00','33.00',65,'male','L2Monster','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,23,190,'pet_clan',400,0,'Local','',0,0,0,15,30,4,4,0,0,0.50),
(6465,0,16019,'Tiny Baby Buffalo','','baby_buffalo','12.00','15.00',0,'male','L2Monster','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6466,0,16020,'Tame Tiny Baby Buffalo','','baby_buffalo','12.00','15.00',0,'male','L2Monster','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6467,0,16021,'Tiny Baby Cougar','','baby_tiger','11.00','15.70',0,'male','L2Monster','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6468,0,16022,'Tame Tiny Baby Cougar','','baby_tiger','11.00','15.70',0,'male','L2Monster','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6469,0,16023,'Tiny Baby Kookaburra','','baby_ostrich','7.00','15.00',0,'male','L2Monster','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6470,0,16024,'Tame Tiny Baby Kookaburra','','baby_ostrich','7.00','15.00',0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6471,12077,12077,'Wolf','','pet_wolf','13.00','11.50',15,'male','L2Pet','npc',40,195,2.500,164,1.200,40,43,30,21,20,25,0,0,9,19,3,17,282,0,257,0,0,0,24,125,'',0,0,'Local','',0,0,0,1200,7,4,4,0,0,0.39),
(6472,12311,12311,'Hatchling of the Wind','','hatchling','9.00','10.00',35,'male','L2Pet','npc',40,610,4.500,433,1.800,40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,0,'Local','',0,0,0,1200,7,4,4,0,0,0.27),
(6473,12312,12312,'Hatchling of the Stars','','hatchling','9.00','10.00',35,'male','L2Pet','npc',40,610,4.500,433,1.800,40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,0,'Local','',0,0,0,1200,7,4,4,0,0,0.27),
(6474,12313,12313,'Hatchling of Twilight','','hatchling','9.00','10.00',35,'male','L2Pet','npc',40,610,4.500,433,1.800,40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,0,'Local','',0,0,0,1200,7,4,4,0,0,0.27),
(6475,12526,12526,'Wind Strider','','strider','23.00','31.00',55,'male','L2Pet','npc',40,2728,6.500,1138,2.400,40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.25),
(6476,12527,12527,'Star Strider','','strider','23.00','31.00',55,'male','L2Pet','npc',40,2728,6.500,1138,2.400,40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.25),
(6477,12528,12528,'Twilight Strider','','strider','23.00','31.00',55,'male','L2Pet','npc',40,2728,6.500,1138,2.400,40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.25),
(6478,12564,12564,'Sin Eater','','imp','10.00','24.00',15,'male','L2Pet','npc',40,195,2.500,164,1.200,40,1,30,21,20,25,0,0,9,19,3,17,282,0,257,0,0,0,60,125,'',0,0,'Local','',0,0,0,1200,7,4,4,0,0,0.34),
(6479,12621,12621,'Wyvern','','wyvern','60.00','80.00',70,'male','L2Monster','Fighter',40,3862,7.500,1722,2.700,40,43,30,21,20,25,0,0,1335,470,780,440,282,0,257,0,0,0,80,170,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.60),
(6480,12780,12780,'Baby Buffalo','','baby_buffalo','12.00','15.00',25,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6481,12781,12781,'Baby Kookaburra','','baby_ostrich','7.00','15.00',25,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,13,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.50),
(6482,12782,12782,'Baby Cougar','','baby_tiger','11.00','15.70',25,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,0,'Local','',0,0,0,1200,30,4,4,0,0,0.48),
(6483,0,12774,'Young Squash','','drop_gourd_50_sm','10.00','10.50',1,'etc','L2Monster','Fighter',40,158,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6484,0,12775,'High Quality Squash','','drop_gourd','20.00','21.00',1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6485,0,12776,'Low Quality Squash','','drop_gourd_25_sm','15.00','16.00',1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6486,0,12777,'Large Young Squash','','drop_gourd','20.00','21.00',1,'etc','L2Monster','Fighter',40,158,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6487,0,12778,'High Quality Large Squash','','drop_gourd_50_bi','30.00','31.50',1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6488,0,12779,'Low Quality Large Squash','','drop_gourd_25_bi','25.00','26.50',1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6489,12250,13001,'Heart of Warding','','heart_of_warding','17.00','75.00',70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(6490,12314,13002,'Life Control Tower','','alive_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2ControlTower','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,40,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(6491,12315,13003,'Life Control Tower','','dead_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2ControlTower','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,40,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(6492,12342,13004,'Flame Control Tower','','alive_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2ControlTower','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,40,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(6493,12343,13005,'Flame Control Tower','','dead_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2ControlTower','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,40,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,1,'Local','',0,0,0,7,30,4,3,0,0,0.60),
(6494,12619,13006,'Christmas Tree','','x_mas_tree','0.00','0.00',70,'male','L2XmassTree','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(6495,12620,13007,'Special Christmas Tree','','x_mas_tree_50_bi','0.00','0.00',70,'male','L2XmassTree','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,0,'Local','',0,0,0,7,30,4,4,0,0,0.52),
(6496,0,13014,' ','',NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6497,0,13015,'','',NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6498,0,13016,'King Squash','','drop_gourd','20.00','21.00',1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6499,0,13017,'Emperor Squash','','drop_gourd_50_bi','30.00','31.50',1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,1,'Local','',0,0,0,7,30,4,4,0,0,0.60),
(6500,0,13018,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6501,0,13019,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6502,0,13020,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6503,0,13021,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6504,0,13022,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6505,0,13023,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6506,0,13024,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6507,0,13025,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6508,0,13026,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6509,0,13027,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6510,0,13028,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6511,0,13029,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6512,0,13030,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6513,0,13031,'Huge Pig','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6514,0,13032,'Huge Pig','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6515,0,13033,'Huge Pig','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6516,0,13034,'Super Huge Pig','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00),
(6517,0,13035,'Golden Pig','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.000,NULL,0.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00);
